// tcl wrapper for vtkPlot3D object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPlot3D.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>
int vtkContextItemCppCommand(vtkContextItem *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkPlot3DCppCommand(vtkPlot3D *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkPlot3DCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkPlot3DCppCommand(static_cast<vtkPlot3D *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkPlot3D_TclCreate(Tcl_Interp *interp)
{
  (void)interp;
  return 0;
}

int VTKTCL_EXPORT vtkPlot3DCppCommand(vtkPlot3D *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkPlot3D",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkContextItemCppCommand(static_cast<vtkContextItem *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkContextItem"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkPlot3D  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPlot3D");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkPlot3D  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPlot3D");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetPen",argv[1]))&&(argc == 3))
  {
    vtkPen  *temp0;
    error = 0;

    temp0 = (vtkPen *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPen"),interp,error));
    if (!error)
  {
    op->SetPen(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPen",argv[1]))&&(argc == 2))
  {
    vtkPen  *temp20;
    temp20 = (op)->GetPen();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPen");
    return TCL_OK;
  }
  if ((!strcmp("SetSelectionPen",argv[1]))&&(argc == 3))
  {
    vtkPen  *temp0;
    error = 0;

    temp0 = (vtkPen *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPen"),interp,error));
    if (!error)
  {
    op->SetSelectionPen(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSelectionPen",argv[1]))&&(argc == 2))
  {
    vtkPen  *temp20;
    temp20 = (op)->GetSelectionPen();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPen");
    return TCL_OK;
  }
  if ((!strcmp("SetInputData",argv[1]))&&(argc == 3))
  {
    vtkTable  *temp0;
    error = 0;

    temp0 = (vtkTable *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTable"),interp,error));
    if (!error)
  {
    op->SetInputData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetInputData",argv[1]))&&(argc == 6))
  {
    vtkTable  *temp0;
    vtkIdType   temp1;
    vtkIdType   temp2;
    vtkIdType   temp3;
    error = 0;

    temp0 = (vtkTable *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTable"),interp,error));
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (Tcl_GetInt(interp,argv[5],&tempi) != TCL_OK) error = 1;
    temp3 = tempi;
    if (!error)
  {
    op->SetInputData(temp0,temp1,temp2,temp3);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetColors",argv[1]))&&(argc == 3))
  {
    vtkDataArray  *temp0;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
  {
    op->SetColors(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetChart",argv[1]))&&(argc == 2))
  {
    vtkChartXYZ  *temp20;
    temp20 = (op)->GetChart();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkChartXYZ");
    return TCL_OK;
  }
  if ((!strcmp("SetChart",argv[1]))&&(argc == 3))
  {
    vtkChartXYZ  *temp0;
    error = 0;

    temp0 = (vtkChartXYZ *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkChartXYZ"),interp,error));
    if (!error)
  {
    op->SetChart(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetXAxisLabel",argv[1]))&&(argc == 2))
  {
    std::string   temp20;
    temp20 = (op)->GetXAxisLabel();
    Tcl_SetResult(interp, const_cast<char *>(temp20.c_str()), TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetYAxisLabel",argv[1]))&&(argc == 2))
  {
    std::string   temp20;
    temp20 = (op)->GetYAxisLabel();
    Tcl_SetResult(interp, const_cast<char *>(temp20.c_str()), TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetZAxisLabel",argv[1]))&&(argc == 2))
  {
    std::string   temp20;
    temp20 = (op)->GetZAxisLabel();
    Tcl_SetResult(interp, const_cast<char *>(temp20.c_str()), TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetSelection",argv[1]))&&(argc == 3))
  {
    vtkIdTypeArray  *temp0;
    error = 0;

    temp0 = (vtkIdTypeArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkIdTypeArray"),interp,error));
    if (!error)
  {
    op->SetSelection(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSelection",argv[1]))&&(argc == 2))
  {
    vtkIdTypeArray  *temp20;
    temp20 = (op)->GetSelection();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkIdTypeArray");
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkPlot3DCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkContextItemCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkPlot3D:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetPen\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPen\n",NULL);
    Tcl_AppendResult(interp,"  SetSelectionPen\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSelectionPen\n",NULL);
    Tcl_AppendResult(interp,"  SetInputData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetInputData\t with 4 args\n",NULL);
    Tcl_AppendResult(interp,"  SetColors\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetChart\n",NULL);
    Tcl_AppendResult(interp,"  SetChart\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetXAxisLabel\n",NULL);
    Tcl_AppendResult(interp,"  GetYAxisLabel\n",NULL);
    Tcl_AppendResult(interp,"  GetZAxisLabel\n",NULL);
    Tcl_AppendResult(interp,"  SetSelection\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSelection\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkContextItemCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetPen" );
    Tcl_DStringAppendElement ( &dString, "GetPen" );
    Tcl_DStringAppendElement ( &dString, "SetSelectionPen" );
    Tcl_DStringAppendElement ( &dString, "GetSelectionPen" );
    Tcl_DStringAppendElement ( &dString, "SetInputData" );
    Tcl_DStringAppendElement ( &dString, "SetInputData" );
    Tcl_DStringAppendElement ( &dString, "SetColors" );
    Tcl_DStringAppendElement ( &dString, "GetChart" );
    Tcl_DStringAppendElement ( &dString, "SetChart" );
    Tcl_DStringAppendElement ( &dString, "GetXAxisLabel" );
    Tcl_DStringAppendElement ( &dString, "GetYAxisLabel" );
    Tcl_DStringAppendElement ( &dString, "GetZAxisLabel" );
    Tcl_DStringAppendElement ( &dString, "SetSelection" );
    Tcl_DStringAppendElement ( &dString, "GetSelection" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkContextItemCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPen */
    if ( strcmp ( argv[2], "SetPen" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPen" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPen" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPen */
    Tcl_DStringAppendElement ( &dString, " Set/get the vtkPen object that controls how this plot draws (out)lines.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPen(vtkPen *pen);" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for SetPen */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPen */
    if ( strcmp ( argv[2], "GetPen" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPen" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPen */
    Tcl_DStringAppendElement ( &dString, " Set/get the vtkPen object that controls how this plot draws (out)lines.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPen *GetPen();" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for GetPen */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSelectionPen */
    if ( strcmp ( argv[2], "SetSelectionPen" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSelectionPen" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPen" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSelectionPen */
    Tcl_DStringAppendElement ( &dString, " Set/get the vtkPen object that controls how this plot draws (out)lines.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSelectionPen(vtkPen *pen);" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for SetSelectionPen */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSelectionPen */
    if ( strcmp ( argv[2], "GetSelectionPen" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelectionPen" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelectionPen */
    Tcl_DStringAppendElement ( &dString, " Set/get the vtkPen object that controls how this plot draws (out)lines.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPen *GetSelectionPen();" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for GetSelectionPen */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetInputData */
    if ( strcmp ( argv[2], "SetInputData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetInputData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTable" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetInputData */
    Tcl_DStringAppendElement ( &dString, " Set the input to the plot.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetInputData(vtkTable *input);" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for SetInputData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetInputData */
    if ( strcmp ( argv[2], "SetInputData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetInputData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTable" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetInputData */
    Tcl_DStringAppendElement ( &dString, " Set the input to the plot.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetInputData(vtkTable *input, vtkIdType xColumn, vtkIdType yColumn, vtkIdType zColumn);" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for SetInputData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetColors */
    if ( strcmp ( argv[2], "SetColors" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetColors" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetColors */
    Tcl_DStringAppendElement ( &dString, " Set the color of each point in the plot.  The input is a single component\n scalar array.  The values of this array will be passed through a lookup\n table to generate the color for each data point in the plot.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetColors(vtkDataArray *colorArr);" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for SetColors */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetChart */
    if ( strcmp ( argv[2], "GetChart" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetChart" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetChart */
    Tcl_DStringAppendElement ( &dString, " Get/set the chart for this plot.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkChartXYZ *GetChart();" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for GetChart */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetChart */
    if ( strcmp ( argv[2], "SetChart" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetChart" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkChartXYZ" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetChart */
    Tcl_DStringAppendElement ( &dString, " Get/set the chart for this plot.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetChart(vtkChartXYZ *chart);" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for SetChart */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetXAxisLabel */
    if ( strcmp ( argv[2], "GetXAxisLabel" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetXAxisLabel" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetXAxisLabel */
    Tcl_DStringAppendElement ( &dString, " Get the label for the X axis.\n" );
    Tcl_DStringAppendElement ( &dString, "std::string GetXAxisLabel();" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for GetXAxisLabel */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetYAxisLabel */
    if ( strcmp ( argv[2], "GetYAxisLabel" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetYAxisLabel" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetYAxisLabel */
    Tcl_DStringAppendElement ( &dString, " Get the label for the Y axis.\n" );
    Tcl_DStringAppendElement ( &dString, "std::string GetYAxisLabel();" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for GetYAxisLabel */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetZAxisLabel */
    if ( strcmp ( argv[2], "GetZAxisLabel" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetZAxisLabel" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetZAxisLabel */
    Tcl_DStringAppendElement ( &dString, " Get the label for the Z axis.\n" );
    Tcl_DStringAppendElement ( &dString, "std::string GetZAxisLabel();" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for GetZAxisLabel */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSelection */
    if ( strcmp ( argv[2], "SetSelection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSelection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkIdTypeArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSelection */
    Tcl_DStringAppendElement ( &dString, " Set/get the selection array for the plot.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetSelection(vtkIdTypeArray *id);" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for SetSelection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSelection */
    if ( strcmp ( argv[2], "GetSelection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelection */
    Tcl_DStringAppendElement ( &dString, " Set/get the selection array for the plot.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkIdTypeArray *GetSelection();" );
    Tcl_DStringAppendElement ( &dString, "vtkPlot3D" );
    /* Closing for GetSelection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkContextItemCppCommand(static_cast<vtkContextItem *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
