// tcl wrapper for vtkMath object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMath.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkMathNewCommand()
{
  vtkMath *temp = vtkMath::New();
  return static_cast<ClientData>(temp);
}

int vtkObjectCppCommand(vtkObject *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkMathCppCommand(vtkMath *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkMathCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkMathCppCommand(static_cast<vtkMath *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkMath_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkMath"),vtkMathNewCommand,vtkMathCommand);
  return 0;
}

int VTKTCL_EXPORT vtkMathCppCommand(vtkMath *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkMath",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkObject"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkMath  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMath");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkMath  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMath");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkMath  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMath");
    return TCL_OK;
  }
  }
  if ((!strcmp("Pi",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->Pi();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("RadiansFromDegrees",argv[1]))&&(argc == 3))
  {
    float    temp0;
    float    temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->RadiansFromDegrees(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("RadiansFromDegrees",argv[1]))&&(argc == 3))
  {
    double   temp0;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->RadiansFromDegrees(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("DegreesFromRadians",argv[1]))&&(argc == 3))
  {
    float    temp0;
    float    temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->DegreesFromRadians(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("DegreesFromRadians",argv[1]))&&(argc == 3))
  {
    double   temp0;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->DegreesFromRadians(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Round",argv[1]))&&(argc == 3))
  {
    float    temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->Round(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Round",argv[1]))&&(argc == 3))
  {
    double   temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->Round(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Floor",argv[1]))&&(argc == 3))
  {
    double   temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->Floor(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Ceil",argv[1]))&&(argc == 3))
  {
    double   temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->Ceil(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("CeilLog2",argv[1]))&&(argc == 3))
  {
    unsigned long long   temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned long long>(tempi);
    if (!error)
  {
    temp20 = (op)->CeilLog2(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("IsPowerOfTwo",argv[1]))&&(argc == 3))
  {
    unsigned long long   temp0;
    bool   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned long long>(tempi);
    if (!error)
  {
    temp20 = (op)->IsPowerOfTwo(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NearestPowerOfTwo",argv[1]))&&(argc == 3))
  {
    int      temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    temp20 = (op)->NearestPowerOfTwo(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Factorial",argv[1]))&&(argc == 3))
  {
    int      temp0;
    long long   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    temp20 = (op)->Factorial(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%lli",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Binomial",argv[1]))&&(argc == 4))
  {
    int      temp0;
    int      temp1;
    long long   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
  {
    temp20 = (op)->Binomial(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%lli",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("RandomSeed",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->RandomSeed(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSeed",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSeed();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("Random",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->Random();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("Random",argv[1]))&&(argc == 4))
  {
    double   temp0;
    double   temp1;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    temp20 = (op)->Random(temp0,temp1);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Gaussian",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->Gaussian();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("Gaussian",argv[1]))&&(argc == 4))
  {
    double   temp0;
    double   temp1;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    temp20 = (op)->Gaussian(temp0,temp1);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Norm",argv[1]))&&(argc == 5))
  {
    float  temp0[3];
    float    temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->Norm(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Norm",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->Norm(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Normalize",argv[1]))&&(argc == 5))
  {
    float  temp0[3];
    float    temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->Normalize(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Normalize",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->Normalize(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GaussianAmplitude",argv[1]))&&(argc == 4))
  {
    double   temp0;
    double   temp1;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    temp20 = (op)->GaussianAmplitude(temp0,temp1);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GaussianAmplitude",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    temp20 = (op)->GaussianAmplitude(temp0,temp1,temp2);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GaussianWeight",argv[1]))&&(argc == 4))
  {
    double   temp0;
    double   temp1;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    temp20 = (op)->GaussianWeight(temp0,temp1);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GaussianWeight",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    temp20 = (op)->GaussianWeight(temp0,temp1,temp2);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Norm2D",argv[1]))&&(argc == 4))
  {
    float  temp0[2];
    float    temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    temp20 = (op)->Norm2D(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Norm2D",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    temp20 = (op)->Norm2D(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Normalize2D",argv[1]))&&(argc == 4))
  {
    float  temp0[2];
    float    temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    temp20 = (op)->Normalize2D(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Normalize2D",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    temp20 = (op)->Normalize2D(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Determinant2x2",argv[1]))&&(argc == 6))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double   temp3;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp3 = tempd;
    if (!error)
  {
    temp20 = (op)->Determinant2x2(temp0,temp1,temp2,temp3);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Determinant3x3",argv[1]))&&(argc == 11))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double   temp3;
    double   temp4;
    double   temp5;
    double   temp6;
    double   temp7;
    double   temp8;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp3 = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp4 = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp5 = tempd;
    if (Tcl_GetDouble(interp,argv[8],&tempd) != TCL_OK) error = 1;
    temp6 = tempd;
    if (Tcl_GetDouble(interp,argv[9],&tempd) != TCL_OK) error = 1;
    temp7 = tempd;
    if (Tcl_GetDouble(interp,argv[10],&tempd) != TCL_OK) error = 1;
    temp8 = tempd;
    if (!error)
  {
    temp20 = (op)->Determinant3x3(temp0,temp1,temp2,temp3,temp4,temp5,temp6,temp7,temp8);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("RGBToHSV",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->RGBToHSV(temp0);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("RGBToHSV",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    temp20 = (op)->RGBToHSV(temp0,temp1,temp2);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("HSVToRGB",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->HSVToRGB(temp0);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("HSVToRGB",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    temp20 = (op)->HSVToRGB(temp0,temp1,temp2);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("LabToXYZ",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->LabToXYZ(temp0);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("XYZToLab",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->XYZToLab(temp0);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("XYZToRGB",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->XYZToRGB(temp0);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("RGBToXYZ",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->RGBToXYZ(temp0);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("RGBToLab",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->RGBToLab(temp0);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("LabToRGB",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->LabToRGB(temp0);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("UninitializeBounds",argv[1]))&&(argc == 8))
  {
    double temp0[6];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (!error)
  {
    op->UninitializeBounds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("AreBoundsInitialized",argv[1]))&&(argc == 8))
  {
    double temp0[6];
    int      temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (!error)
  {
    temp20 = (op)->AreBoundsInitialized(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetScalarTypeFittingRange",argv[1]))&&(argc == 6))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double   temp3;
    int      temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp3 = tempd;
    if (!error)
  {
    temp20 = (op)->GetScalarTypeFittingRange(temp0,temp1,temp2,temp3);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Inf",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->Inf();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("NegInf",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->NegInf();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("Nan",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->Nan();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("IsInf",argv[1]))&&(argc == 3))
  {
    double   temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->IsInf(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("IsNan",argv[1]))&&(argc == 3))
  {
    double   temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->IsNan(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("IsFinite",argv[1]))&&(argc == 3))
  {
    double   temp0;
    bool   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->IsFinite(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkMathCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkMath:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Pi\n",NULL);
    Tcl_AppendResult(interp,"  RadiansFromDegrees\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RadiansFromDegrees\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  DegreesFromRadians\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  DegreesFromRadians\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Round\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Round\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Floor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Ceil\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  CeilLog2\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  IsPowerOfTwo\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NearestPowerOfTwo\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Factorial\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Binomial\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  RandomSeed\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSeed\n",NULL);
    Tcl_AppendResult(interp,"  Random\n",NULL);
    Tcl_AppendResult(interp,"  Random\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  Gaussian\n",NULL);
    Tcl_AppendResult(interp,"  Gaussian\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  Norm\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  Norm\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  Normalize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  Normalize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GaussianAmplitude\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GaussianAmplitude\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GaussianWeight\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GaussianWeight\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  Norm2D\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  Norm2D\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  Normalize2D\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  Normalize2D\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  Determinant2x2\t with 4 args\n",NULL);
    Tcl_AppendResult(interp,"  Determinant3x3\t with 9 args\n",NULL);
    Tcl_AppendResult(interp,"  RGBToHSV\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  RGBToHSV\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  HSVToRGB\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  HSVToRGB\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  LabToXYZ\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  XYZToLab\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  XYZToRGB\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  RGBToXYZ\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  RGBToLab\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  LabToRGB\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  UninitializeBounds\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  AreBoundsInitialized\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  GetScalarTypeFittingRange\t with 4 args\n",NULL);
    Tcl_AppendResult(interp,"  Inf\n",NULL);
    Tcl_AppendResult(interp,"  NegInf\n",NULL);
    Tcl_AppendResult(interp,"  Nan\n",NULL);
    Tcl_AppendResult(interp,"  IsInf\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  IsNan\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  IsFinite\t with 1 arg\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "Pi" );
    Tcl_DStringAppendElement ( &dString, "RadiansFromDegrees" );
    Tcl_DStringAppendElement ( &dString, "RadiansFromDegrees" );
    Tcl_DStringAppendElement ( &dString, "DegreesFromRadians" );
    Tcl_DStringAppendElement ( &dString, "DegreesFromRadians" );
    Tcl_DStringAppendElement ( &dString, "Round" );
    Tcl_DStringAppendElement ( &dString, "Round" );
    Tcl_DStringAppendElement ( &dString, "Floor" );
    Tcl_DStringAppendElement ( &dString, "Ceil" );
    Tcl_DStringAppendElement ( &dString, "CeilLog2" );
    Tcl_DStringAppendElement ( &dString, "IsPowerOfTwo" );
    Tcl_DStringAppendElement ( &dString, "NearestPowerOfTwo" );
    Tcl_DStringAppendElement ( &dString, "Factorial" );
    Tcl_DStringAppendElement ( &dString, "Binomial" );
    Tcl_DStringAppendElement ( &dString, "RandomSeed" );
    Tcl_DStringAppendElement ( &dString, "GetSeed" );
    Tcl_DStringAppendElement ( &dString, "Random" );
    Tcl_DStringAppendElement ( &dString, "Random" );
    Tcl_DStringAppendElement ( &dString, "Gaussian" );
    Tcl_DStringAppendElement ( &dString, "Gaussian" );
    Tcl_DStringAppendElement ( &dString, "Norm" );
    Tcl_DStringAppendElement ( &dString, "Norm" );
    Tcl_DStringAppendElement ( &dString, "Normalize" );
    Tcl_DStringAppendElement ( &dString, "Normalize" );
    Tcl_DStringAppendElement ( &dString, "GaussianAmplitude" );
    Tcl_DStringAppendElement ( &dString, "GaussianAmplitude" );
    Tcl_DStringAppendElement ( &dString, "GaussianWeight" );
    Tcl_DStringAppendElement ( &dString, "GaussianWeight" );
    Tcl_DStringAppendElement ( &dString, "Norm2D" );
    Tcl_DStringAppendElement ( &dString, "Norm2D" );
    Tcl_DStringAppendElement ( &dString, "Normalize2D" );
    Tcl_DStringAppendElement ( &dString, "Normalize2D" );
    Tcl_DStringAppendElement ( &dString, "Determinant2x2" );
    Tcl_DStringAppendElement ( &dString, "Determinant3x3" );
    Tcl_DStringAppendElement ( &dString, "RGBToHSV" );
    Tcl_DStringAppendElement ( &dString, "RGBToHSV" );
    Tcl_DStringAppendElement ( &dString, "HSVToRGB" );
    Tcl_DStringAppendElement ( &dString, "HSVToRGB" );
    Tcl_DStringAppendElement ( &dString, "LabToXYZ" );
    Tcl_DStringAppendElement ( &dString, "XYZToLab" );
    Tcl_DStringAppendElement ( &dString, "XYZToRGB" );
    Tcl_DStringAppendElement ( &dString, "RGBToXYZ" );
    Tcl_DStringAppendElement ( &dString, "RGBToLab" );
    Tcl_DStringAppendElement ( &dString, "LabToRGB" );
    Tcl_DStringAppendElement ( &dString, "UninitializeBounds" );
    Tcl_DStringAppendElement ( &dString, "AreBoundsInitialized" );
    Tcl_DStringAppendElement ( &dString, "GetScalarTypeFittingRange" );
    Tcl_DStringAppendElement ( &dString, "Inf" );
    Tcl_DStringAppendElement ( &dString, "NegInf" );
    Tcl_DStringAppendElement ( &dString, "Nan" );
    Tcl_DStringAppendElement ( &dString, "IsInf" );
    Tcl_DStringAppendElement ( &dString, "IsNan" );
    Tcl_DStringAppendElement ( &dString, "IsFinite" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkObjectCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkMath *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkMath *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkMath *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Pi */
    if ( strcmp ( argv[2], "Pi" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Pi" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Pi */
    Tcl_DStringAppendElement ( &dString, " A mathematical constant. This version is atan(1.0) * 4.0\n" );
    Tcl_DStringAppendElement ( &dString, "static double Pi();" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Pi */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RadiansFromDegrees */
    if ( strcmp ( argv[2], "RadiansFromDegrees" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RadiansFromDegrees" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RadiansFromDegrees */
    Tcl_DStringAppendElement ( &dString, " Convert degrees into radians\n" );
    Tcl_DStringAppendElement ( &dString, "static float RadiansFromDegrees(float degrees);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for RadiansFromDegrees */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RadiansFromDegrees */
    if ( strcmp ( argv[2], "RadiansFromDegrees" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RadiansFromDegrees" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RadiansFromDegrees */
    Tcl_DStringAppendElement ( &dString, " Convert degrees into radians\n" );
    Tcl_DStringAppendElement ( &dString, "static double RadiansFromDegrees(double degrees);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for RadiansFromDegrees */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DegreesFromRadians */
    if ( strcmp ( argv[2], "DegreesFromRadians" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DegreesFromRadians" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DegreesFromRadians */
    Tcl_DStringAppendElement ( &dString, " Convert radians into degrees\n" );
    Tcl_DStringAppendElement ( &dString, "static float DegreesFromRadians(float radians);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for DegreesFromRadians */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DegreesFromRadians */
    if ( strcmp ( argv[2], "DegreesFromRadians" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DegreesFromRadians" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DegreesFromRadians */
    Tcl_DStringAppendElement ( &dString, " Convert radians into degrees\n" );
    Tcl_DStringAppendElement ( &dString, "static double DegreesFromRadians(double radians);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for DegreesFromRadians */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Round */
    if ( strcmp ( argv[2], "Round" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Round" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Round */
    Tcl_DStringAppendElement ( &dString, " Rounds a float to the nearest integer.\n" );
    Tcl_DStringAppendElement ( &dString, "static int Round(float f);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Round */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Round */
    if ( strcmp ( argv[2], "Round" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Round" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Round */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static int Round(double f);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Round */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Floor */
    if ( strcmp ( argv[2], "Floor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Floor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Floor */
    Tcl_DStringAppendElement ( &dString, " Rounds a double to the nearest integer not greater than itself.\n This is faster than floor() but provides undefined output on\n overflow.\n" );
    Tcl_DStringAppendElement ( &dString, "static int Floor(double x);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Floor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Ceil */
    if ( strcmp ( argv[2], "Ceil" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Ceil" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Ceil */
    Tcl_DStringAppendElement ( &dString, " Rounds a double to the nearest integer not less than itself.\n This is faster than ceil() but provides undefined output on\n overflow.\n" );
    Tcl_DStringAppendElement ( &dString, "static int Ceil(double x);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Ceil */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: CeilLog2 */
    if ( strcmp ( argv[2], "CeilLog2" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CeilLog2" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CeilLog2 */
    Tcl_DStringAppendElement ( &dString, " Gives the exponent of the lowest power of two not less than x.\n Or in mathspeak, return the smallest \"i\" for which 2^i >= x.\n If x is zero, then the return value will be zero.\n" );
    Tcl_DStringAppendElement ( &dString, "static int CeilLog2(vtkTypeUInt64 x);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for CeilLog2 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsPowerOfTwo */
    if ( strcmp ( argv[2], "IsPowerOfTwo" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsPowerOfTwo" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsPowerOfTwo */
    Tcl_DStringAppendElement ( &dString, " Returns true if integer is a power of two.\n" );
    Tcl_DStringAppendElement ( &dString, "static bool IsPowerOfTwo(vtkTypeUInt64 x);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for IsPowerOfTwo */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NearestPowerOfTwo */
    if ( strcmp ( argv[2], "NearestPowerOfTwo" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NearestPowerOfTwo" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NearestPowerOfTwo */
    Tcl_DStringAppendElement ( &dString, " Compute the nearest power of two that is not less than x.\n The return value is 1 if x is less than or equal to zero,\n and is VTK_INT_MIN if result is too large to fit in an int.\n" );
    Tcl_DStringAppendElement ( &dString, "static int NearestPowerOfTwo(int x);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for NearestPowerOfTwo */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Factorial */
    if ( strcmp ( argv[2], "Factorial" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Factorial" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Factorial */
    Tcl_DStringAppendElement ( &dString, " Compute N factorial, N! = N*(N-1) * (N-2)...*3*2*1.\n 0! is taken to be 1.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkTypeInt64 Factorial(int N);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Factorial */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Binomial */
    if ( strcmp ( argv[2], "Binomial" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Binomial" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Binomial */
    Tcl_DStringAppendElement ( &dString, " The number of combinations of n objects from a pool of m objects (m>n).\n This is commonly known as \"m choose n\" and sometimes denoted \\f$_mC_n\\f$\n or \\f$\\left(\\begin{array}{c}m \\\\ n\\end{array}\\right)\\f$.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkTypeInt64 Binomial(int m, int n);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Binomial */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RandomSeed */
    if ( strcmp ( argv[2], "RandomSeed" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RandomSeed" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RandomSeed */
    Tcl_DStringAppendElement ( &dString, " Initialize seed value. NOTE: Random() has the bad property that\n the first random number returned after RandomSeed() is called\n is proportional to the seed value! To help solve this, call\n RandomSeed() a few times inside seed. This doesn't ruin the\n repeatability of Random().\n\n * DON'T USE Random(), RandomSeed(), GetSeed(), Gaussian()\n * THIS IS STATIC SO THIS IS PRONE TO ERRORS (SPECIALLY FOR REGRESSION TESTS)\n * THIS IS HERE FOR BACKWARD COMPATIBILITY ONLY.\n * In ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "static void RandomSeed(int s);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for RandomSeed */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSeed */
    if ( strcmp ( argv[2], "GetSeed" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSeed" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSeed */
    Tcl_DStringAppendElement ( &dString, " Return the current seed used by the random number generator.\n\n * DON'T USE Random(), RandomSeed(), GetSeed(), Gaussian()\n * THIS IS STATIC SO THIS IS PRONE TO ERRORS (SPECIALLY FOR REGRESSION TESTS)\n * THIS IS HERE FOR BACKWARD COMPATIBILITY ONLY.\n * Instead, for a sequence of random numbers with a uniform distribution\n * create a vtkMinimalStandardRandomSequence object.\n * For a sequence of random numbers with a gaussian/normal distribution\n * create a vtkBoxMuelle ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "static int GetSeed();" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for GetSeed */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Random */
    if ( strcmp ( argv[2], "Random" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Random" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Random */
    Tcl_DStringAppendElement ( &dString, " Generate pseudo-random numbers distributed according to the uniform\n distribution between 0.0 and 1.0.\n This is used to provide portability across different systems.\n\n * DON'T USE Random(), RandomSeed(), GetSeed(), Gaussian()\n * THIS IS STATIC SO THIS IS PRONE TO ERRORS (SPECIALLY FOR REGRESSION TESTS)\n * THIS IS HERE FOR BACKWARD COMPATIBILITY ONLY.\n * Instead, for a sequence of random numbers with a uniform distribution\n * create a vtkMinimalStandardRandomSequence ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "static double Random();" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Random */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Random */
    if ( strcmp ( argv[2], "Random" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Random" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Random */
    Tcl_DStringAppendElement ( &dString, " Generate  pseudo-random numbers distributed according to the uniform\n distribution between \\a min and \\a max.\n\n * DON'T USE Random(), RandomSeed(), GetSeed(), Gaussian()\n * THIS IS STATIC SO THIS IS PRONE TO ERRORS (SPECIALLY FOR REGRESSION TESTS)\n * THIS IS HERE FOR BACKWARD COMPATIBILITY ONLY.\n * Instead, for a sequence of random numbers with a uniform distribution\n * create a vtkMinimalStandardRandomSequence object.\n * For a sequence of random numbers with a ga ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "static double Random(double min, double max);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Random */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Gaussian */
    if ( strcmp ( argv[2], "Gaussian" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Gaussian" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Gaussian */
    Tcl_DStringAppendElement ( &dString, " Generate pseudo-random numbers distributed according to the standard\n normal distribution.\n\n * DON'T USE Random(), RandomSeed(), GetSeed(), Gaussian()\n * THIS IS STATIC SO THIS IS PRONE TO ERRORS (SPECIALLY FOR REGRESSION TESTS)\n * THIS IS HERE FOR BACKWARD COMPATIBILITY ONLY.\n * Instead, for a sequence of random numbers with a uniform distribution\n * create a vtkMinimalStandardRandomSequence object.\n * For a sequence of random numbers with a gaussian/normal distrib ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "static double Gaussian();" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Gaussian */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Gaussian */
    if ( strcmp ( argv[2], "Gaussian" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Gaussian" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Gaussian */
    Tcl_DStringAppendElement ( &dString, " Generate  pseudo-random numbers distributed according to the Gaussian\n distribution with mean \\a mean and standard deviation \\a std.\n\n * DON'T USE Random(), RandomSeed(), GetSeed(), Gaussian()\n * THIS IS STATIC SO THIS IS PRONE TO ERRORS (SPECIALLY FOR REGRESSION TESTS)\n * THIS IS HERE FOR BACKWARD COMPATIBILITY ONLY.\n * Instead, for a sequence of random numbers with a uniform distribution\n * create a vtkMinimalStandardRandomSequence object.\n * For a sequence of r ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "static double Gaussian(double mean, double std);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Gaussian */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Norm */
    if ( strcmp ( argv[2], "Norm" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Norm" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Norm */
    Tcl_DStringAppendElement ( &dString, " Compute the norm of 3-vector.\n" );
    Tcl_DStringAppendElement ( &dString, "static float Norm(const float v\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Norm */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Norm */
    if ( strcmp ( argv[2], "Norm" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Norm" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Norm */
    Tcl_DStringAppendElement ( &dString, " Compute the norm of 3-vector (double-precision version).\n" );
    Tcl_DStringAppendElement ( &dString, "static double Norm(const double v\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Norm */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Normalize */
    if ( strcmp ( argv[2], "Normalize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Normalize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Normalize */
    Tcl_DStringAppendElement ( &dString, " Normalize (in place) a 3-vector. Returns norm of vector.\n" );
    Tcl_DStringAppendElement ( &dString, "static float Normalize(float v\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Normalize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Normalize */
    if ( strcmp ( argv[2], "Normalize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Normalize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Normalize */
    Tcl_DStringAppendElement ( &dString, " Normalize (in place) a 3-vector. Returns norm of vector\n (double-precision version).\n" );
    Tcl_DStringAppendElement ( &dString, "static double Normalize(double v\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Normalize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GaussianAmplitude */
    if ( strcmp ( argv[2], "GaussianAmplitude" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GaussianAmplitude" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GaussianAmplitude */
    Tcl_DStringAppendElement ( &dString, " Compute the amplitude of a Gaussian function with mean=0 and specified variance.\n That is, 1./(sqrt(2 Pi * variance)) * exp(-distanceFromMean^2/(2.*variance)).\n" );
    Tcl_DStringAppendElement ( &dString, "static double GaussianAmplitude(const double variance, const double distanceFromMean);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for GaussianAmplitude */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GaussianAmplitude */
    if ( strcmp ( argv[2], "GaussianAmplitude" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GaussianAmplitude" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GaussianAmplitude */
    Tcl_DStringAppendElement ( &dString, " Compute the amplitude of a Gaussian function with specified mean and variance.\n That is, 1./(sqrt(2 Pi * variance)) * exp(-(position - mean)^2/(2.*variance)).\n" );
    Tcl_DStringAppendElement ( &dString, "static double GaussianAmplitude(const double mean, const double variance, const double position);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for GaussianAmplitude */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GaussianWeight */
    if ( strcmp ( argv[2], "GaussianWeight" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GaussianWeight" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GaussianWeight */
    Tcl_DStringAppendElement ( &dString, " Compute the amplitude of an unnormalized Gaussian function with mean=0 and specified variance.\n That is, exp(-distanceFromMean^2/(2.*variance)). When distanceFromMean = 0, this function\n returns 1.\n" );
    Tcl_DStringAppendElement ( &dString, "static double GaussianWeight(const double variance, const double distanceFromMean);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for GaussianWeight */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GaussianWeight */
    if ( strcmp ( argv[2], "GaussianWeight" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GaussianWeight" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GaussianWeight */
    Tcl_DStringAppendElement ( &dString, " Compute the amplitude of an unnormalized Gaussian function with specified mean and variance.\n That is, exp(-(position - mean)^2/(2.*variance)). When the distance from 'position' to 'mean'\n is 0, this function returns 1.\n" );
    Tcl_DStringAppendElement ( &dString, "static double GaussianWeight(const double mean, const double variance, const double position);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for GaussianWeight */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Norm2D */
    if ( strcmp ( argv[2], "Norm2D" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Norm2D" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Norm2D */
    Tcl_DStringAppendElement ( &dString, " Compute the norm of a 2-vector.\n" );
    Tcl_DStringAppendElement ( &dString, "static float Norm2D(const float x\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Norm2D */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Norm2D */
    if ( strcmp ( argv[2], "Norm2D" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Norm2D" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Norm2D */
    Tcl_DStringAppendElement ( &dString, " Compute the norm of a 2-vector.\n (double-precision version).\n" );
    Tcl_DStringAppendElement ( &dString, "static double Norm2D(const double x\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Norm2D */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Normalize2D */
    if ( strcmp ( argv[2], "Normalize2D" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Normalize2D" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Normalize2D */
    Tcl_DStringAppendElement ( &dString, " Normalize (in place) a 2-vector. Returns norm of vector.\n" );
    Tcl_DStringAppendElement ( &dString, "static float Normalize2D(float v\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Normalize2D */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Normalize2D */
    if ( strcmp ( argv[2], "Normalize2D" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Normalize2D" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Normalize2D */
    Tcl_DStringAppendElement ( &dString, " Normalize (in place) a 2-vector. Returns norm of vector.\n (double-precision version).\n" );
    Tcl_DStringAppendElement ( &dString, "static double Normalize2D(double v\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Normalize2D */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Determinant2x2 */
    if ( strcmp ( argv[2], "Determinant2x2" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Determinant2x2" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Determinant2x2 */
    Tcl_DStringAppendElement ( &dString, " Calculate the determinant of a 2x2 matrix: | a b | | c d |\n" );
    Tcl_DStringAppendElement ( &dString, "static double Determinant2x2(double a, double b, double c, double d);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Determinant2x2 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Determinant3x3 */
    if ( strcmp ( argv[2], "Determinant3x3" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Determinant3x3" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Determinant3x3 */
    Tcl_DStringAppendElement ( &dString, " Calculate the determinant of a 3x3 matrix in the form:\n | a1,  b1,  c1 |\n | a2,  b2,  c2 |\n | a3,  b3,  c3 |\n" );
    Tcl_DStringAppendElement ( &dString, "static double Determinant3x3(double a1, double a2, double a3, double b1, double b2, double b3, double c1, double c2, double c3);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Determinant3x3 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RGBToHSV */
    if ( strcmp ( argv[2], "RGBToHSV" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RGBToHSV" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RGBToHSV */
    Tcl_DStringAppendElement ( &dString, " Convert color in RGB format (Red, Green, Blue) to HSV format\n (Hue, Saturation, Value). The input color is not modified.\n The input RGB must be float values in the range \\[0,1\\].\n The output ranges are hue \\[0, 1\\], saturation \\[0, 1\\], and\n value \\[0, 1\\].\n" );
    Tcl_DStringAppendElement ( &dString, "static double *RGBToHSV(const double rgb\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for RGBToHSV */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RGBToHSV */
    if ( strcmp ( argv[2], "RGBToHSV" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RGBToHSV" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RGBToHSV */
    Tcl_DStringAppendElement ( &dString, " Convert color in RGB format (Red, Green, Blue) to HSV format\n (Hue, Saturation, Value). The input color is not modified.\n The input RGB must be float values in the range \\[0,1\\].\n The output ranges are hue \\[0, 1\\], saturation \\[0, 1\\], and\n value \\[0, 1\\].\n" );
    Tcl_DStringAppendElement ( &dString, "static double *RGBToHSV(double r, double g, double b);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for RGBToHSV */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: HSVToRGB */
    if ( strcmp ( argv[2], "HSVToRGB" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HSVToRGB" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HSVToRGB */
    Tcl_DStringAppendElement ( &dString, " Convert color in HSV format (Hue, Saturation, Value) to RGB\n format (Red, Green, Blue). The input color is not modified.\n The input 'hsv' must be float values in the range \\[0,1\\].\n The elements of each component of the output 'rgb' are in\n the range \\[0, 1\\].\n" );
    Tcl_DStringAppendElement ( &dString, "static double *HSVToRGB(const double hsv\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for HSVToRGB */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: HSVToRGB */
    if ( strcmp ( argv[2], "HSVToRGB" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HSVToRGB" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HSVToRGB */
    Tcl_DStringAppendElement ( &dString, " Convert color in HSV format (Hue, Saturation, Value) to RGB\n format (Red, Green, Blue). The input color is not modified.\n The input 'hsv' must be float values in the range \\[0,1\\].\n The elements of each component of the output 'rgb' are in\n the range \\[0, 1\\].\n" );
    Tcl_DStringAppendElement ( &dString, "static double *HSVToRGB(double h, double s, double v);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for HSVToRGB */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: LabToXYZ */
    if ( strcmp ( argv[2], "LabToXYZ" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "LabToXYZ" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for LabToXYZ */
    Tcl_DStringAppendElement ( &dString, " Convert color from the CIE-L*ab system to CIE XYZ.\n" );
    Tcl_DStringAppendElement ( &dString, "static double *LabToXYZ(const double lab\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for LabToXYZ */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: XYZToLab */
    if ( strcmp ( argv[2], "XYZToLab" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "XYZToLab" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for XYZToLab */
    Tcl_DStringAppendElement ( &dString, " Convert Color from the CIE XYZ system to CIE-L*ab.\n" );
    Tcl_DStringAppendElement ( &dString, "static double *XYZToLab(const double xyz\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for XYZToLab */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: XYZToRGB */
    if ( strcmp ( argv[2], "XYZToRGB" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "XYZToRGB" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for XYZToRGB */
    Tcl_DStringAppendElement ( &dString, " Convert color from the CIE XYZ system to RGB.\n" );
    Tcl_DStringAppendElement ( &dString, "static double *XYZToRGB(const double xyz\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for XYZToRGB */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RGBToXYZ */
    if ( strcmp ( argv[2], "RGBToXYZ" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RGBToXYZ" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RGBToXYZ */
    Tcl_DStringAppendElement ( &dString, " Convert color from the RGB system to CIE XYZ.\n" );
    Tcl_DStringAppendElement ( &dString, "static double *RGBToXYZ(const double rgb\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for RGBToXYZ */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RGBToLab */
    if ( strcmp ( argv[2], "RGBToLab" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RGBToLab" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RGBToLab */
    Tcl_DStringAppendElement ( &dString, " Convert color from the RGB system to CIE-L*ab.\n The input RGB must be values in the range \\[0,1\\].\n The output ranges of 'L' is \\[0, 100\\]. The output\n range of 'a' and 'b' are approximately \\[-110, 110\\].\n" );
    Tcl_DStringAppendElement ( &dString, "static double *RGBToLab(const double rgb\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for RGBToLab */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: LabToRGB */
    if ( strcmp ( argv[2], "LabToRGB" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "LabToRGB" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for LabToRGB */
    Tcl_DStringAppendElement ( &dString, " Convert color from the CIE-L*ab system to RGB.\n" );
    Tcl_DStringAppendElement ( &dString, "static double *LabToRGB(const double lab\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for LabToRGB */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: UninitializeBounds */
    if ( strcmp ( argv[2], "UninitializeBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UninitializeBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UninitializeBounds */
    Tcl_DStringAppendElement ( &dString, " Set the bounds to an uninitialized state\n" );
    Tcl_DStringAppendElement ( &dString, "static void UninitializeBounds(double bounds\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for UninitializeBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AreBoundsInitialized */
    if ( strcmp ( argv[2], "AreBoundsInitialized" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AreBoundsInitialized" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AreBoundsInitialized */
    Tcl_DStringAppendElement ( &dString, " Are the bounds initialized?\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkTypeBool AreBoundsInitialized(double bounds\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for AreBoundsInitialized */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScalarTypeFittingRange */
    if ( strcmp ( argv[2], "GetScalarTypeFittingRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScalarTypeFittingRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScalarTypeFittingRange */
    Tcl_DStringAppendElement ( &dString, " Return the scalar type that is most likely to have enough precision\n to store a given range of data once it has been scaled and shifted\n (i.e. \\[range_min * scale + shift, range_max * scale + shift\\].\n If any one of the parameters is not an integer number (decimal part != 0),\n the search will default to float types only (float or double)\n Return -1 on error or no scalar type found.\n" );
    Tcl_DStringAppendElement ( &dString, "static int GetScalarTypeFittingRange(double range_min, double range_max, double scale=1.0, double shift=0.0);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for GetScalarTypeFittingRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Inf */
    if ( strcmp ( argv[2], "Inf" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Inf" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Inf */
    Tcl_DStringAppendElement ( &dString, " Special IEEE-754 number used to represent positive infinity.\n" );
    Tcl_DStringAppendElement ( &dString, "static double Inf();" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Inf */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NegInf */
    if ( strcmp ( argv[2], "NegInf" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NegInf" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NegInf */
    Tcl_DStringAppendElement ( &dString, " Special IEEE-754 number used to represent negative infinity.\n" );
    Tcl_DStringAppendElement ( &dString, "static double NegInf();" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for NegInf */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Nan */
    if ( strcmp ( argv[2], "Nan" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Nan" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Nan */
    Tcl_DStringAppendElement ( &dString, " Special IEEE-754 number used to represent Not-A-Number (Nan).\n" );
    Tcl_DStringAppendElement ( &dString, "static double Nan();" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for Nan */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsInf */
    if ( strcmp ( argv[2], "IsInf" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsInf" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsInf */
    Tcl_DStringAppendElement ( &dString, " Test if a number is equal to the special floating point value infinity.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkTypeBool IsInf(double x);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for IsInf */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsNan */
    if ( strcmp ( argv[2], "IsNan" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsNan" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsNan */
    Tcl_DStringAppendElement ( &dString, " Test if a number is equal to the special floating point value Not-A-Number (Nan).\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkTypeBool IsNan(double x);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for IsNan */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsFinite */
    if ( strcmp ( argv[2], "IsFinite" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsFinite" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsFinite */
    Tcl_DStringAppendElement ( &dString, " Test if a number has finite value i.e. it is normal, subnormal or zero, but not infinite or Nan.\n" );
    Tcl_DStringAppendElement ( &dString, "static bool IsFinite(double x);" );
    Tcl_DStringAppendElement ( &dString, "vtkMath" );
    /* Closing for IsFinite */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
