// tcl wrapper for vtkScalarsToColors object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkScalarsToColors.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkScalarsToColorsNewCommand()
{
  vtkScalarsToColors *temp = vtkScalarsToColors::New();
  return static_cast<ClientData>(temp);
}

int vtkObjectCppCommand(vtkObject *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkScalarsToColorsCppCommand(vtkScalarsToColors *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkScalarsToColorsCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkScalarsToColorsCppCommand(static_cast<vtkScalarsToColors *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkScalarsToColors_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkScalarsToColors"),vtkScalarsToColorsNewCommand,vtkScalarsToColorsCommand);
  return 0;
}

int VTKTCL_EXPORT vtkScalarsToColorsCppCommand(vtkScalarsToColors *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkScalarsToColors",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkObject"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkScalarsToColors  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkScalarsToColors");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkScalarsToColors  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkScalarsToColors");
    return TCL_OK;
  }
  }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkScalarsToColors  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkScalarsToColors");
    return TCL_OK;
  }
  if ((!strcmp("IsOpaque",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->IsOpaque();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("Build",argv[1]))&&(argc == 2))
  {
    op->Build();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetRange",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetRange();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetRange",argv[1]))&&(argc == 4))
  {
    double   temp0;
    double   temp1;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    op->SetRange(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetRange",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->SetRange(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetColor",argv[1]))&&(argc == 3))
  {
    double   temp0;
    double  *temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->GetColor(temp0);
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("GetOpacity",argv[1]))&&(argc == 3))
  {
    double   temp0;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->GetOpacity(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLuminance",argv[1]))&&(argc == 3))
  {
    double   temp0;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->GetLuminance(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetAlpha",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetAlpha(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAlpha",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetAlpha();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("MapScalars",argv[1]))&&(argc == 5))
  {
    vtkDataArray  *temp0;
    int      temp1;
    int      temp2;
    vtkUnsignedCharArray  *temp20;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (!error)
  {
    temp20 = (op)->MapScalars(temp0,temp1,temp2);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkUnsignedCharArray");
    return TCL_OK;
  }
  }
  if ((!strcmp("MapScalars",argv[1]))&&(argc == 5))
  {
    vtkAbstractArray  *temp0;
    int      temp1;
    int      temp2;
    vtkUnsignedCharArray  *temp20;
    error = 0;

    temp0 = (vtkAbstractArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractArray"),interp,error));
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (!error)
  {
    temp20 = (op)->MapScalars(temp0,temp1,temp2);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkUnsignedCharArray");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetVectorMode",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetVectorMode(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetVectorMode",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetVectorMode();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetVectorModeToMagnitude",argv[1]))&&(argc == 2))
  {
    op->SetVectorModeToMagnitude();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetVectorModeToComponent",argv[1]))&&(argc == 2))
  {
    op->SetVectorModeToComponent();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetVectorModeToRGBColors",argv[1]))&&(argc == 2))
  {
    op->SetVectorModeToRGBColors();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetVectorComponent",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetVectorComponent(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetVectorComponent",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetVectorComponent();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetVectorSize",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetVectorSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetVectorSize",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetVectorSize();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("DeepCopy",argv[1]))&&(argc == 3))
  {
    vtkScalarsToColors  *temp0;
    error = 0;

    temp0 = (vtkScalarsToColors *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkScalarsToColors"),interp,error));
    if (!error)
  {
    op->DeepCopy(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("UsingLogScale",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->UsingLogScale();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfAvailableColors",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetNumberOfAvailableColors();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetAnnotations",argv[1]))&&(argc == 4))
  {
    vtkAbstractArray  *temp0;
    vtkStringArray  *temp1;
    error = 0;

    temp0 = (vtkAbstractArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractArray"),interp,error));
    temp1 = (vtkStringArray *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkStringArray"),interp,error));
    if (!error)
  {
    op->SetAnnotations(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAnnotatedValues",argv[1]))&&(argc == 2))
  {
    vtkAbstractArray  *temp20;
    temp20 = (op)->GetAnnotatedValues();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAbstractArray");
    return TCL_OK;
  }
  if ((!strcmp("GetAnnotations",argv[1]))&&(argc == 2))
  {
    vtkStringArray  *temp20;
    temp20 = (op)->GetAnnotations();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkStringArray");
    return TCL_OK;
  }
  if ((!strcmp("SetAnnotation",argv[1]))&&(argc == 4))
  {
    vtkStdString   temp0;
    vtkStdString   temp1;
    vtkIdType   temp20;
    error = 0;

    temp0 = argv[2];
    temp1 = argv[3];
    if (!error)
  {
    temp20 = (op)->SetAnnotation(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfAnnotatedValues",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetNumberOfAnnotatedValues();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetAnnotation",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    vtkStdString   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    temp20 = (op)->GetAnnotation(temp0);
    Tcl_SetResult(interp, const_cast<char *>(temp20.c_str()), TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("ResetAnnotations",argv[1]))&&(argc == 2))
  {
    op->ResetAnnotations();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetIndexedLookup",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetIndexedLookup(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetIndexedLookup",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetIndexedLookup();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("IndexedLookupOn",argv[1]))&&(argc == 2))
  {
    op->IndexedLookupOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("IndexedLookupOff",argv[1]))&&(argc == 2))
  {
    op->IndexedLookupOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkScalarsToColorsCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkScalarsToColors:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  IsOpaque\n",NULL);
    Tcl_AppendResult(interp,"  Build\n",NULL);
    Tcl_AppendResult(interp,"  GetRange\n",NULL);
    Tcl_AppendResult(interp,"  SetRange\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetRange\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetColor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOpacity\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLuminance\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetAlpha\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAlpha\n",NULL);
    Tcl_AppendResult(interp,"  MapScalars\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  MapScalars\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetVectorMode\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetVectorMode\n",NULL);
    Tcl_AppendResult(interp,"  SetVectorModeToMagnitude\n",NULL);
    Tcl_AppendResult(interp,"  SetVectorModeToComponent\n",NULL);
    Tcl_AppendResult(interp,"  SetVectorModeToRGBColors\n",NULL);
    Tcl_AppendResult(interp,"  SetVectorComponent\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetVectorComponent\n",NULL);
    Tcl_AppendResult(interp,"  SetVectorSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetVectorSize\n",NULL);
    Tcl_AppendResult(interp,"  DeepCopy\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  UsingLogScale\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfAvailableColors\n",NULL);
    Tcl_AppendResult(interp,"  SetAnnotations\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetAnnotatedValues\n",NULL);
    Tcl_AppendResult(interp,"  GetAnnotations\n",NULL);
    Tcl_AppendResult(interp,"  SetAnnotation\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfAnnotatedValues\n",NULL);
    Tcl_AppendResult(interp,"  GetAnnotation\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  ResetAnnotations\n",NULL);
    Tcl_AppendResult(interp,"  SetIndexedLookup\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetIndexedLookup\n",NULL);
    Tcl_AppendResult(interp,"  IndexedLookupOn\n",NULL);
    Tcl_AppendResult(interp,"  IndexedLookupOff\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "IsOpaque" );
    Tcl_DStringAppendElement ( &dString, "Build" );
    Tcl_DStringAppendElement ( &dString, "GetRange" );
    Tcl_DStringAppendElement ( &dString, "SetRange" );
    Tcl_DStringAppendElement ( &dString, "SetRange" );
    Tcl_DStringAppendElement ( &dString, "GetColor" );
    Tcl_DStringAppendElement ( &dString, "GetOpacity" );
    Tcl_DStringAppendElement ( &dString, "GetLuminance" );
    Tcl_DStringAppendElement ( &dString, "SetAlpha" );
    Tcl_DStringAppendElement ( &dString, "GetAlpha" );
    Tcl_DStringAppendElement ( &dString, "MapScalars" );
    Tcl_DStringAppendElement ( &dString, "MapScalars" );
    Tcl_DStringAppendElement ( &dString, "SetVectorMode" );
    Tcl_DStringAppendElement ( &dString, "GetVectorMode" );
    Tcl_DStringAppendElement ( &dString, "SetVectorModeToMagnitude" );
    Tcl_DStringAppendElement ( &dString, "SetVectorModeToComponent" );
    Tcl_DStringAppendElement ( &dString, "SetVectorModeToRGBColors" );
    Tcl_DStringAppendElement ( &dString, "SetVectorComponent" );
    Tcl_DStringAppendElement ( &dString, "GetVectorComponent" );
    Tcl_DStringAppendElement ( &dString, "SetVectorSize" );
    Tcl_DStringAppendElement ( &dString, "GetVectorSize" );
    Tcl_DStringAppendElement ( &dString, "DeepCopy" );
    Tcl_DStringAppendElement ( &dString, "UsingLogScale" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfAvailableColors" );
    Tcl_DStringAppendElement ( &dString, "SetAnnotations" );
    Tcl_DStringAppendElement ( &dString, "GetAnnotatedValues" );
    Tcl_DStringAppendElement ( &dString, "GetAnnotations" );
    Tcl_DStringAppendElement ( &dString, "SetAnnotation" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfAnnotatedValues" );
    Tcl_DStringAppendElement ( &dString, "GetAnnotation" );
    Tcl_DStringAppendElement ( &dString, "ResetAnnotations" );
    Tcl_DStringAppendElement ( &dString, "SetIndexedLookup" );
    Tcl_DStringAppendElement ( &dString, "GetIndexedLookup" );
    Tcl_DStringAppendElement ( &dString, "IndexedLookupOn" );
    Tcl_DStringAppendElement ( &dString, "IndexedLookupOff" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkObjectCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkScalarsToColors *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsOpaque */
    if ( strcmp ( argv[2], "IsOpaque" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsOpaque" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsOpaque */
    Tcl_DStringAppendElement ( &dString, " Return true if all of the values defining the mapping have an opacity\n equal to 1. Default implementation return true.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int IsOpaque();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for IsOpaque */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Build */
    if ( strcmp ( argv[2], "Build" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Build" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Build */
    Tcl_DStringAppendElement ( &dString, " Perform any processing required (if any) before processing\n scalars. Default implementation does nothing.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void Build();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for Build */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRange */
    if ( strcmp ( argv[2], "GetRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRange */
    Tcl_DStringAppendElement ( &dString, " Sets/Gets the range of scalars that will be mapped.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual double *GetRange();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRange */
    if ( strcmp ( argv[2], "SetRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRange */
    Tcl_DStringAppendElement ( &dString, " Sets/Gets the range of scalars that will be mapped.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetRange(double min, double max);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRange */
    if ( strcmp ( argv[2], "SetRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRange */
    Tcl_DStringAppendElement ( &dString, " Sets/Gets the range of scalars that will be mapped.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRange(double rng\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetColor */
    if ( strcmp ( argv[2], "GetColor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetColor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetColor */
    Tcl_DStringAppendElement ( &dString, " Map one value through the lookup table and return the color as\n an RGB array of doubles between 0 and 1.\n" );
    Tcl_DStringAppendElement ( &dString, "double *GetColor(double v);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetColor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetOpacity */
    if ( strcmp ( argv[2], "GetOpacity" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOpacity" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOpacity */
    Tcl_DStringAppendElement ( &dString, " Map one value through the lookup table and return the alpha value\n (the opacity) as a double between 0 and 1. This implementation\n always returns 1.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual double GetOpacity(double v);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetOpacity */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLuminance */
    if ( strcmp ( argv[2], "GetLuminance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLuminance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLuminance */
    Tcl_DStringAppendElement ( &dString, " Map one value through the lookup table and return the luminance\n 0.3*red + 0.59*green + 0.11*blue as a double between 0 and 1.\n Returns the luminance value for the specified scalar value.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetLuminance(double x);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetLuminance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAlpha */
    if ( strcmp ( argv[2], "SetAlpha" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAlpha" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAlpha */
    Tcl_DStringAppendElement ( &dString, " Specify an additional opacity (alpha) value to blend with. Values\n != 1 modify the resulting color consistent with the requested\n form of the output. This is typically used by an actor in order to\n blend its opacity. Value is clamped between 0 and 1.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetAlpha(double alpha);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetAlpha */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAlpha */
    if ( strcmp ( argv[2], "GetAlpha" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAlpha" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAlpha */
    Tcl_DStringAppendElement ( &dString, " Specify an additional opacity (alpha) value to blend with. Values\n != 1 modify the resulting color consistent with the requested\n form of the output. This is typically used by an actor in order to\n blend its opacity. Value is clamped between 0 and 1.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetAlpha();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetAlpha */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: MapScalars */
    if ( strcmp ( argv[2], "MapScalars" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "MapScalars" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for MapScalars */
    Tcl_DStringAppendElement ( &dString, " Internal methods that map a data array into a 4-component,\n unsigned char RGBA array. The color mode determines the behavior\n of mapping. If VTK_COLOR_MODE_DEFAULT is set, then unsigned char\n data arrays are treated as colors (and converted to RGBA if\n necessary); If VTK_COLOR_MODE_DIRECT_SCALARS is set, then all arrays\n are treated as colors (integer types are clamped in the range 0-255,\n floating point arrays are clamped in the range 0.0-1.0. Note 'char' does\n not  ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkUnsignedCharArray *MapScalars(vtkDataArray *scalars, int colorMode, int component);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for MapScalars */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: MapScalars */
    if ( strcmp ( argv[2], "MapScalars" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "MapScalars" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractArray" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for MapScalars */
    Tcl_DStringAppendElement ( &dString, " Internal methods that map a data array into a 4-component,\n unsigned char RGBA array. The color mode determines the behavior\n of mapping. If VTK_COLOR_MODE_DEFAULT is set, then unsigned char\n data arrays are treated as colors (and converted to RGBA if\n necessary); If VTK_COLOR_MODE_DIRECT_SCALARS is set, then all arrays\n are treated as colors (integer types are clamped in the range 0-255,\n floating point arrays are clamped in the range 0.0-1.0. Note 'char' does\n not  ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkUnsignedCharArray *MapScalars(vtkAbstractArray *scalars, int colorMode, int component);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for MapScalars */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetVectorMode */
    if ( strcmp ( argv[2], "SetVectorMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetVectorMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetVectorMode */
    Tcl_DStringAppendElement ( &dString, " Change mode that maps vectors by magnitude vs. component.\n If the mode is \"RGBColors\", then the vectors components are\n scaled to the range and passed directly as the colors.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetVectorMode(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetVectorMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetVectorMode */
    if ( strcmp ( argv[2], "GetVectorMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVectorMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVectorMode */
    Tcl_DStringAppendElement ( &dString, " Change mode that maps vectors by magnitude vs. component.\n If the mode is \"RGBColors\", then the vectors components are\n scaled to the range and passed directly as the colors.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetVectorMode();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetVectorMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetVectorModeToMagnitude */
    if ( strcmp ( argv[2], "SetVectorModeToMagnitude" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetVectorModeToMagnitude" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetVectorModeToMagnitude */
    Tcl_DStringAppendElement ( &dString, " Change mode that maps vectors by magnitude vs. component.\n If the mode is \"RGBColors\", then the vectors components are\n scaled to the range and passed directly as the colors.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetVectorModeToMagnitude();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetVectorModeToMagnitude */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetVectorModeToComponent */
    if ( strcmp ( argv[2], "SetVectorModeToComponent" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetVectorModeToComponent" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetVectorModeToComponent */
    Tcl_DStringAppendElement ( &dString, " Change mode that maps vectors by magnitude vs. component.\n If the mode is \"RGBColors\", then the vectors components are\n scaled to the range and passed directly as the colors.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetVectorModeToComponent();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetVectorModeToComponent */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetVectorModeToRGBColors */
    if ( strcmp ( argv[2], "SetVectorModeToRGBColors" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetVectorModeToRGBColors" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetVectorModeToRGBColors */
    Tcl_DStringAppendElement ( &dString, " Change mode that maps vectors by magnitude vs. component.\n If the mode is \"RGBColors\", then the vectors components are\n scaled to the range and passed directly as the colors.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetVectorModeToRGBColors();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetVectorModeToRGBColors */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetVectorComponent */
    if ( strcmp ( argv[2], "SetVectorComponent" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetVectorComponent" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetVectorComponent */
    Tcl_DStringAppendElement ( &dString, " If the mapper does not select which component of a vector\n to map to colors, you can specify it here.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetVectorComponent(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetVectorComponent */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetVectorComponent */
    if ( strcmp ( argv[2], "GetVectorComponent" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVectorComponent" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVectorComponent */
    Tcl_DStringAppendElement ( &dString, " If the mapper does not select which component of a vector\n to map to colors, you can specify it here.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetVectorComponent();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetVectorComponent */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetVectorSize */
    if ( strcmp ( argv[2], "SetVectorSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetVectorSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetVectorSize */
    Tcl_DStringAppendElement ( &dString, " When mapping vectors, consider only the number of components selected\n by VectorSize to be part of the vector, and ignore any other\n components.  Set to -1 to map all components.  If this is not set\n to -1, then you can use SetVectorComponent to set which scalar\n component will be the first component in the vector to be mapped.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetVectorSize(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetVectorSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetVectorSize */
    if ( strcmp ( argv[2], "GetVectorSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVectorSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVectorSize */
    Tcl_DStringAppendElement ( &dString, " When mapping vectors, consider only the number of components selected\n by VectorSize to be part of the vector, and ignore any other\n components.  Set to -1 to map all components.  If this is not set\n to -1, then you can use SetVectorComponent to set which scalar\n component will be the first component in the vector to be mapped.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetVectorSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetVectorSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DeepCopy */
    if ( strcmp ( argv[2], "DeepCopy" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DeepCopy" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DeepCopy */
    Tcl_DStringAppendElement ( &dString, " Copy the contents from another object.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void DeepCopy(vtkScalarsToColors *o);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for DeepCopy */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: UsingLogScale */
    if ( strcmp ( argv[2], "UsingLogScale" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UsingLogScale" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UsingLogScale */
    Tcl_DStringAppendElement ( &dString, " This should return 1 is the subclass is using log scale for mapping scalars\n to colors. Default implementation always returns 0.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int UsingLogScale();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for UsingLogScale */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfAvailableColors */
    if ( strcmp ( argv[2], "GetNumberOfAvailableColors" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfAvailableColors" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfAvailableColors */
    Tcl_DStringAppendElement ( &dString, " Get the number of available colors for mapping to.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkIdType GetNumberOfAvailableColors();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetNumberOfAvailableColors */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAnnotations */
    if ( strcmp ( argv[2], "SetAnnotations" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAnnotations" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractArray" );
    Tcl_DStringAppendElement ( &dString, "vtkStringArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAnnotations */
    Tcl_DStringAppendElement ( &dString, " Set a list of discrete values, either\n as a categorical set of values (when IndexedLookup is true) or\n as a set of annotations to add to a scalar array (when IndexedLookup is false).\n The two arrays must both either be NULL or of the same length or\n the call will be ignored.\n\n * Note that these arrays are deep copied rather than being used directly\n * in order to support the use case where edits are made. If the\n * \\a values and \\a annotations arrays were held by  ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetAnnotations(vtkAbstractArray *values, vtkStringArray *annotations);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetAnnotations */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAnnotatedValues */
    if ( strcmp ( argv[2], "GetAnnotatedValues" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAnnotatedValues" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAnnotatedValues */
    Tcl_DStringAppendElement ( &dString, " Set a list of discrete values, either\n as a categorical set of values (when IndexedLookup is true) or\n as a set of annotations to add to a scalar array (when IndexedLookup is false).\n The two arrays must both either be NULL or of the same length or\n the call will be ignored.\n\n * Note that these arrays are deep copied rather than being used directly\n * in order to support the use case where edits are made. If the\n * \\a values and \\a annotations arrays were held by  ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractArray *GetAnnotatedValues();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetAnnotatedValues */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAnnotations */
    if ( strcmp ( argv[2], "GetAnnotations" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAnnotations" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAnnotations */
    Tcl_DStringAppendElement ( &dString, " Set a list of discrete values, either\n as a categorical set of values (when IndexedLookup is true) or\n as a set of annotations to add to a scalar array (when IndexedLookup is false).\n The two arrays must both either be NULL or of the same length or\n the call will be ignored.\n\n * Note that these arrays are deep copied rather than being used directly\n * in order to support the use case where edits are made. If the\n * \\a values and \\a annotations arrays were held by  ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "vtkStringArray *GetAnnotations();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetAnnotations */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAnnotation */
    if ( strcmp ( argv[2], "SetAnnotation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAnnotation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAnnotation */
    Tcl_DStringAppendElement ( &dString, " This variant of \\a SetAnnotation accepts the value as a string so\n ParaView can treat annotations as string vector arrays.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkIdType SetAnnotation(vtkStdString value, vtkStdString annotation);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetAnnotation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfAnnotatedValues */
    if ( strcmp ( argv[2], "GetNumberOfAnnotatedValues" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfAnnotatedValues" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfAnnotatedValues */
    Tcl_DStringAppendElement ( &dString, " Return the annotated value at a particular index in the list of annotations.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetNumberOfAnnotatedValues();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetNumberOfAnnotatedValues */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAnnotation */
    if ( strcmp ( argv[2], "GetAnnotation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAnnotation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAnnotation */
    Tcl_DStringAppendElement ( &dString, " Return the annotation at a particular index in the list of annotations.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkStdString GetAnnotation(vtkIdType idx);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetAnnotation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ResetAnnotations */
    if ( strcmp ( argv[2], "ResetAnnotations" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ResetAnnotations" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ResetAnnotations */
    Tcl_DStringAppendElement ( &dString, " Remove all existing values and their annotations.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void ResetAnnotations();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for ResetAnnotations */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetIndexedLookup */
    if ( strcmp ( argv[2], "SetIndexedLookup" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIndexedLookup" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIndexedLookup */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the lookup table is for categorical or ordinal data.\n The default is ordinal data; values not present in the lookup table\n will be assigned an interpolated color.\n\n * When categorical data is present, only values in the lookup table will be\n * considered valid; all other values will be assigned \\a NanColor.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetIndexedLookup(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for SetIndexedLookup */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetIndexedLookup */
    if ( strcmp ( argv[2], "GetIndexedLookup" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetIndexedLookup" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetIndexedLookup */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the lookup table is for categorical or ordinal data.\n The default is ordinal data; values not present in the lookup table\n will be assigned an interpolated color.\n\n * When categorical data is present, only values in the lookup table will be\n * considered valid; all other values will be assigned \\a NanColor.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetIndexedLookup();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for GetIndexedLookup */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IndexedLookupOn */
    if ( strcmp ( argv[2], "IndexedLookupOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IndexedLookupOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IndexedLookupOn */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the lookup table is for categorical or ordinal data.\n The default is ordinal data; values not present in the lookup table\n will be assigned an interpolated color.\n\n * When categorical data is present, only values in the lookup table will be\n * considered valid; all other values will be assigned \\a NanColor.\n" );
    Tcl_DStringAppendElement ( &dString, "void IndexedLookupOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for IndexedLookupOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IndexedLookupOff */
    if ( strcmp ( argv[2], "IndexedLookupOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IndexedLookupOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IndexedLookupOff */
    Tcl_DStringAppendElement ( &dString, " Set/get whether the lookup table is for categorical or ordinal data.\n The default is ordinal data; values not present in the lookup table\n will be assigned an interpolated color.\n\n * When categorical data is present, only values in the lookup table will be\n * considered valid; all other values will be assigned \\a NanColor.\n" );
    Tcl_DStringAppendElement ( &dString, "void IndexedLookupOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkScalarsToColors" );
    /* Closing for IndexedLookupOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
