// tcl wrapper for vtkHyperTreeGrid object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkHyperTreeGrid.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkHyperTreeGridNewCommand()
{
  vtkHyperTreeGrid *temp = vtkHyperTreeGrid::New();
  return static_cast<ClientData>(temp);
}

int vtkDataSetCppCommand(vtkDataSet *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkHyperTreeGridCppCommand(vtkHyperTreeGrid *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkHyperTreeGridCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkHyperTreeGridCppCommand(static_cast<vtkHyperTreeGrid *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkHyperTreeGrid_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkHyperTreeGrid"),vtkHyperTreeGridNewCommand,vtkHyperTreeGridCommand);
  return 0;
}

int VTKTCL_EXPORT vtkHyperTreeGridCppCommand(vtkHyperTreeGrid *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkHyperTreeGrid",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkDataSetCppCommand(static_cast<vtkDataSet *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkDataSet"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkHyperTreeGrid  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHyperTreeGrid");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkHyperTreeGrid  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHyperTreeGrid");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkHyperTreeGrid  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHyperTreeGrid");
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDataObjectType",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDataObjectType();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("CopyStructure",argv[1]))&&(argc == 3))
  {
    vtkDataSet  *temp0;
    error = 0;

    temp0 = (vtkDataSet *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataSet"),interp,error));
    if (!error)
  {
    op->CopyStructure(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetGridSize",argv[1]))&&(argc == 5))
  {
    unsigned int      temp0;
    unsigned int      temp1;
    unsigned int      temp2;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = static_cast<unsigned int>(tempi);
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = static_cast<unsigned int>(tempi);
    if (!error)
  {
    op->SetGridSize(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetGridSize",argv[1]))&&(argc == 2))
  {
    unsigned int     *temp20;
    temp20 = (op)->GetGridSize();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      sprintf(tempResult,"%u %u %u ",temp20[0],temp20[1],temp20[2]);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetGridExtent",argv[1]))&&(argc == 8))
  {
    int    temp0[6];
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0[0] = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp0[1] = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp0[2] = tempi;
    if (Tcl_GetInt(interp,argv[5],&tempi) != TCL_OK) error = 1;
    temp0[3] = tempi;
    if (Tcl_GetInt(interp,argv[6],&tempi) != TCL_OK) error = 1;
    temp0[4] = tempi;
    if (Tcl_GetInt(interp,argv[7],&tempi) != TCL_OK) error = 1;
    temp0[5] = tempi;
    if (!error)
  {
    op->SetGridExtent(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetGridExtent",argv[1]))&&(argc == 8))
  {
    int      temp0;
    int      temp1;
    int      temp2;
    int      temp3;
    int      temp4;
    int      temp5;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (Tcl_GetInt(interp,argv[5],&tempi) != TCL_OK) error = 1;
    temp3 = tempi;
    if (Tcl_GetInt(interp,argv[6],&tempi) != TCL_OK) error = 1;
    temp4 = tempi;
    if (Tcl_GetInt(interp,argv[7],&tempi) != TCL_OK) error = 1;
    temp5 = tempi;
    if (!error)
  {
    op->SetGridExtent(temp0,temp1,temp2,temp3,temp4,temp5);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetTransposedRootIndexing",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetTransposedRootIndexing(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTransposedRootIndexing",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetTransposedRootIndexing();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetIndexingModeToKJI",argv[1]))&&(argc == 2))
  {
    op->SetIndexingModeToKJI();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetIndexingModeToIJK",argv[1]))&&(argc == 2))
  {
    op->SetIndexingModeToIJK();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetBranchFactor",argv[1]))&&(argc == 3))
  {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
  {
    op->SetBranchFactor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetBranchFactor",argv[1]))&&(argc == 2))
  {
    unsigned int      temp20;
    temp20 = (op)->GetBranchFactor();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDimension",argv[1]))&&(argc == 3))
  {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
  {
    op->SetDimension(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDimension",argv[1]))&&(argc == 2))
  {
    unsigned int      temp20;
    temp20 = (op)->GetDimension();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfCells",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetNumberOfCells();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfPoints",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetNumberOfPoints();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfLeaves",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetNumberOfLeaves();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfLevels",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    vtkIdType   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    temp20 = (op)->GetNumberOfLevels(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfTrees",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetNumberOfTrees();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetXCoordinates",argv[1]))&&(argc == 3))
  {
    vtkDataArray  *temp0;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
  {
    op->SetXCoordinates(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetXCoordinates",argv[1]))&&(argc == 2))
  {
    vtkDataArray  *temp20;
    temp20 = (op)->GetXCoordinates();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataArray");
    return TCL_OK;
  }
  if ((!strcmp("SetYCoordinates",argv[1]))&&(argc == 3))
  {
    vtkDataArray  *temp0;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
  {
    op->SetYCoordinates(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetYCoordinates",argv[1]))&&(argc == 2))
  {
    vtkDataArray  *temp20;
    temp20 = (op)->GetYCoordinates();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataArray");
    return TCL_OK;
  }
  if ((!strcmp("SetZCoordinates",argv[1]))&&(argc == 3))
  {
    vtkDataArray  *temp0;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
  {
    op->SetZCoordinates(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetZCoordinates",argv[1]))&&(argc == 2))
  {
    vtkDataArray  *temp20;
    temp20 = (op)->GetZCoordinates();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataArray");
    return TCL_OK;
  }
  if ((!strcmp("SetMaterialMask",argv[1]))&&(argc == 3))
  {
    vtkBitArray  *temp0;
    error = 0;

    temp0 = (vtkBitArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkBitArray"),interp,error));
    if (!error)
  {
    op->SetMaterialMask(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMaterialMask",argv[1]))&&(argc == 2))
  {
    vtkBitArray  *temp20;
    temp20 = (op)->GetMaterialMask();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkBitArray");
    return TCL_OK;
  }
  if ((!strcmp("SetMaterialMaskIndex",argv[1]))&&(argc == 3))
  {
    vtkIdTypeArray  *temp0;
    error = 0;

    temp0 = (vtkIdTypeArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkIdTypeArray"),interp,error));
    if (!error)
  {
    op->SetMaterialMaskIndex(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMaterialMaskIndex",argv[1]))&&(argc == 2))
  {
    vtkIdTypeArray  *temp20;
    temp20 = (op)->GetMaterialMaskIndex();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkIdTypeArray");
    return TCL_OK;
  }
  if ((!strcmp("GenerateTrees",argv[1]))&&(argc == 2))
  {
    op->GenerateTrees();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("NewCursor",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    vtkHyperTreeCursor  *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    temp20 = (op)->NewCursor(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHyperTreeCursor");
    return TCL_OK;
  }
  }
  if ((!strcmp("SubdivideLeaf",argv[1]))&&(argc == 4))
  {
    vtkHyperTreeCursor  *temp0;
    vtkIdType   temp1;
    error = 0;

    temp0 = (vtkHyperTreeCursor *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkHyperTreeCursor"),interp,error));
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
  {
    op->SubdivideLeaf(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCell",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    vtkCell  *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    temp20 = (op)->GetCell(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkCell");
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCell",argv[1]))&&(argc == 4))
  {
    vtkIdType   temp0;
    vtkGenericCell  *temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkGenericCell *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkGenericCell"),interp,error));
    if (!error)
  {
    op->GetCell(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCellType",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    int      temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    temp20 = (op)->GetCellType(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCellPoints",argv[1]))&&(argc == 4))
  {
    vtkIdType   temp0;
    vtkIdList  *temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkIdList *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkIdList"),interp,error));
    if (!error)
  {
    op->GetCellPoints(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPointCells",argv[1]))&&(argc == 4))
  {
    vtkIdType   temp0;
    vtkIdList  *temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkIdList *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkIdList"),interp,error));
    if (!error)
  {
    op->GetPointCells(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCellNeighbors",argv[1]))&&(argc == 5))
  {
    vtkIdType   temp0;
    vtkIdList  *temp1;
    vtkIdList  *temp2;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkIdList *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkIdList"),interp,error));
    temp2 = (vtkIdList *)(vtkTclGetPointerFromObject(argv[4],const_cast<char *>("vtkIdList"),interp,error));
    if (!error)
  {
    op->GetCellNeighbors(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("FindPoint",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    vtkIdType   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    temp20 = (op)->FindPoint(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("Initialize",argv[1]))&&(argc == 2))
  {
    op->Initialize();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetMaxCellSize",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetMaxCellSize();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("ShallowCopy",argv[1]))&&(argc == 3))
  {
    vtkDataObject  *temp0;
    error = 0;

    temp0 = (vtkDataObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataObject"),interp,error));
    if (!error)
  {
    op->ShallowCopy(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("DeepCopy",argv[1]))&&(argc == 3))
  {
    vtkDataObject  *temp0;
    error = 0;

    temp0 = (vtkDataObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataObject"),interp,error));
    if (!error)
  {
    op->DeepCopy(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetExtentType",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetExtentType();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetActualMemorySize",argv[1]))&&(argc == 2))
  {
    unsigned long     temp20;
    temp20 = (op)->GetActualMemorySize();
    char tempResult[1024];
    sprintf(tempResult,"%lu",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GenerateSuperCursorTraversalTable",argv[1]))&&(argc == 2))
  {
    op->GenerateSuperCursorTraversalTable();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfChildren",argv[1]))&&(argc == 2))
  {
    unsigned int      temp20;
    temp20 = (op)->GetNumberOfChildren();
    char tempResult[1024];
    sprintf(tempResult,"%u",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkHyperTreeGridCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkDataSetCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkHyperTreeGrid:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDataObjectType\n",NULL);
    Tcl_AppendResult(interp,"  CopyStructure\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetGridSize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetGridSize\n",NULL);
    Tcl_AppendResult(interp,"  SetGridExtent\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  SetGridExtent\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  SetTransposedRootIndexing\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTransposedRootIndexing\n",NULL);
    Tcl_AppendResult(interp,"  SetIndexingModeToKJI\n",NULL);
    Tcl_AppendResult(interp,"  SetIndexingModeToIJK\n",NULL);
    Tcl_AppendResult(interp,"  SetBranchFactor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetBranchFactor\n",NULL);
    Tcl_AppendResult(interp,"  SetDimension\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDimension\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfCells\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfPoints\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfLeaves\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfLevels\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfTrees\n",NULL);
    Tcl_AppendResult(interp,"  SetXCoordinates\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetXCoordinates\n",NULL);
    Tcl_AppendResult(interp,"  SetYCoordinates\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetYCoordinates\n",NULL);
    Tcl_AppendResult(interp,"  SetZCoordinates\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetZCoordinates\n",NULL);
    Tcl_AppendResult(interp,"  SetMaterialMask\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMaterialMask\n",NULL);
    Tcl_AppendResult(interp,"  SetMaterialMaskIndex\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMaterialMaskIndex\n",NULL);
    Tcl_AppendResult(interp,"  GenerateTrees\n",NULL);
    Tcl_AppendResult(interp,"  NewCursor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SubdivideLeaf\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetCell\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCell\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetCellType\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCellPoints\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetPointCells\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetCellNeighbors\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  FindPoint\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  Initialize\n",NULL);
    Tcl_AppendResult(interp,"  GetMaxCellSize\n",NULL);
    Tcl_AppendResult(interp,"  ShallowCopy\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  DeepCopy\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetExtentType\n",NULL);
    Tcl_AppendResult(interp,"  GetActualMemorySize\n",NULL);
    Tcl_AppendResult(interp,"  GenerateSuperCursorTraversalTable\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfChildren\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkDataSetCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "GetDataObjectType" );
    Tcl_DStringAppendElement ( &dString, "CopyStructure" );
    Tcl_DStringAppendElement ( &dString, "SetGridSize" );
    Tcl_DStringAppendElement ( &dString, "GetGridSize" );
    Tcl_DStringAppendElement ( &dString, "SetGridExtent" );
    Tcl_DStringAppendElement ( &dString, "SetGridExtent" );
    Tcl_DStringAppendElement ( &dString, "SetTransposedRootIndexing" );
    Tcl_DStringAppendElement ( &dString, "GetTransposedRootIndexing" );
    Tcl_DStringAppendElement ( &dString, "SetIndexingModeToKJI" );
    Tcl_DStringAppendElement ( &dString, "SetIndexingModeToIJK" );
    Tcl_DStringAppendElement ( &dString, "SetBranchFactor" );
    Tcl_DStringAppendElement ( &dString, "GetBranchFactor" );
    Tcl_DStringAppendElement ( &dString, "SetDimension" );
    Tcl_DStringAppendElement ( &dString, "GetDimension" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfCells" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPoints" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfLeaves" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfLevels" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfTrees" );
    Tcl_DStringAppendElement ( &dString, "SetXCoordinates" );
    Tcl_DStringAppendElement ( &dString, "GetXCoordinates" );
    Tcl_DStringAppendElement ( &dString, "SetYCoordinates" );
    Tcl_DStringAppendElement ( &dString, "GetYCoordinates" );
    Tcl_DStringAppendElement ( &dString, "SetZCoordinates" );
    Tcl_DStringAppendElement ( &dString, "GetZCoordinates" );
    Tcl_DStringAppendElement ( &dString, "SetMaterialMask" );
    Tcl_DStringAppendElement ( &dString, "GetMaterialMask" );
    Tcl_DStringAppendElement ( &dString, "SetMaterialMaskIndex" );
    Tcl_DStringAppendElement ( &dString, "GetMaterialMaskIndex" );
    Tcl_DStringAppendElement ( &dString, "GenerateTrees" );
    Tcl_DStringAppendElement ( &dString, "NewCursor" );
    Tcl_DStringAppendElement ( &dString, "SubdivideLeaf" );
    Tcl_DStringAppendElement ( &dString, "GetCell" );
    Tcl_DStringAppendElement ( &dString, "GetCell" );
    Tcl_DStringAppendElement ( &dString, "GetCellType" );
    Tcl_DStringAppendElement ( &dString, "GetCellPoints" );
    Tcl_DStringAppendElement ( &dString, "GetPointCells" );
    Tcl_DStringAppendElement ( &dString, "GetCellNeighbors" );
    Tcl_DStringAppendElement ( &dString, "FindPoint" );
    Tcl_DStringAppendElement ( &dString, "Initialize" );
    Tcl_DStringAppendElement ( &dString, "GetMaxCellSize" );
    Tcl_DStringAppendElement ( &dString, "ShallowCopy" );
    Tcl_DStringAppendElement ( &dString, "DeepCopy" );
    Tcl_DStringAppendElement ( &dString, "GetExtentType" );
    Tcl_DStringAppendElement ( &dString, "GetActualMemorySize" );
    Tcl_DStringAppendElement ( &dString, "GenerateSuperCursorTraversalTable" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfChildren" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkDataSetCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkHyperTreeGrid *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDataObjectType */
    if ( strcmp ( argv[2], "GetDataObjectType" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDataObjectType" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDataObjectType */
    Tcl_DStringAppendElement ( &dString, " Return what type of dataset this is.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDataObjectType();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetDataObjectType */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: CopyStructure */
    if ( strcmp ( argv[2], "CopyStructure" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CopyStructure" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataSet" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CopyStructure */
    Tcl_DStringAppendElement ( &dString, " Copy the internal geometric and topological structure of a\n vtkHyperTreeGrid object.\n" );
    Tcl_DStringAppendElement ( &dString, "void CopyStructure(vtkDataSet *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for CopyStructure */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetGridSize */
    if ( strcmp ( argv[2], "SetGridSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGridSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGridSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get sizes of this rectilinear grid dataset\n" );
    Tcl_DStringAppendElement ( &dString, "void SetGridSize(unsigned int i, unsigned int j, unsigned int k);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetGridSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetGridSize */
    if ( strcmp ( argv[2], "GetGridSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetGridSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetGridSize */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "unsigned int *GetGridSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetGridSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetGridExtent */
    if ( strcmp ( argv[2], "SetGridExtent" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGridExtent" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGridExtent */
    Tcl_DStringAppendElement ( &dString, " Set/Get extent of this rectilinear grid dataset\n" );
    Tcl_DStringAppendElement ( &dString, "void SetGridExtent(int extent\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetGridExtent */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetGridExtent */
    if ( strcmp ( argv[2], "SetGridExtent" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGridExtent" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGridExtent */
    Tcl_DStringAppendElement ( &dString, " Set/Get extent of this rectilinear grid dataset\n" );
    Tcl_DStringAppendElement ( &dString, "void SetGridExtent(int iMin, int iMax, int jMin, int jMax, int kMin, int kMax);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetGridExtent */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTransposedRootIndexing */
    if ( strcmp ( argv[2], "SetTransposedRootIndexing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTransposedRootIndexing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTransposedRootIndexing */
    Tcl_DStringAppendElement ( &dString, " Specify whether indexing mode of grid root cells must be transposed to\n x-axis first, z-axis last, instead of the default z-axis first, k-axis last\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTransposedRootIndexing(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetTransposedRootIndexing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTransposedRootIndexing */
    if ( strcmp ( argv[2], "GetTransposedRootIndexing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTransposedRootIndexing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTransposedRootIndexing */
    Tcl_DStringAppendElement ( &dString, " Specify whether indexing mode of grid root cells must be transposed to\n x-axis first, z-axis last, instead of the default z-axis first, k-axis last\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetTransposedRootIndexing();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetTransposedRootIndexing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetIndexingModeToKJI */
    if ( strcmp ( argv[2], "SetIndexingModeToKJI" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIndexingModeToKJI" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIndexingModeToKJI */
    Tcl_DStringAppendElement ( &dString, " Specify whether indexing mode of grid root cells must be transposed to\n x-axis first, z-axis last, instead of the default z-axis first, k-axis last\n" );
    Tcl_DStringAppendElement ( &dString, "void SetIndexingModeToKJI();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetIndexingModeToKJI */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetIndexingModeToIJK */
    if ( strcmp ( argv[2], "SetIndexingModeToIJK" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIndexingModeToIJK" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIndexingModeToIJK */
    Tcl_DStringAppendElement ( &dString, " Specify whether indexing mode of grid root cells must be transposed to\n x-axis first, z-axis last, instead of the default z-axis first, k-axis last\n" );
    Tcl_DStringAppendElement ( &dString, "void SetIndexingModeToIJK();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetIndexingModeToIJK */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetBranchFactor */
    if ( strcmp ( argv[2], "SetBranchFactor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetBranchFactor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetBranchFactor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the subdivision factor in the grid refinement scheme\n NB: Can only be 2 or 3\n" );
    Tcl_DStringAppendElement ( &dString, "void SetBranchFactor(unsigned int);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetBranchFactor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetBranchFactor */
    if ( strcmp ( argv[2], "GetBranchFactor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBranchFactor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBranchFactor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the subdivision factor in the grid refinement scheme\n NB: Can only be 2 or 3\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetBranchFactor();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetBranchFactor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDimension */
    if ( strcmp ( argv[2], "SetDimension" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDimension" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDimension */
    Tcl_DStringAppendElement ( &dString, " Set/Get the dimensionality of the grid\n NB: Can only be 1, 2 or 3\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDimension(unsigned int);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetDimension */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDimension */
    if ( strcmp ( argv[2], "GetDimension" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDimension" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDimension */
    Tcl_DStringAppendElement ( &dString, " Set/Get the dimensionality of the grid\n NB: Can only be 1, 2 or 3\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetDimension();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetDimension */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfCells */
    if ( strcmp ( argv[2], "GetNumberOfCells" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfCells" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfCells */
    Tcl_DStringAppendElement ( &dString, " Return the number of cells in the dual grid.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetNumberOfCells();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetNumberOfCells */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfPoints */
    if ( strcmp ( argv[2], "GetNumberOfPoints" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPoints" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfPoints */
    Tcl_DStringAppendElement ( &dString, " Return the number of points in the dual grid.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetNumberOfPoints();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetNumberOfPoints */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfLeaves */
    if ( strcmp ( argv[2], "GetNumberOfLeaves" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfLeaves" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfLeaves */
    Tcl_DStringAppendElement ( &dString, " Get the number of leaves in the primal tree grid.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetNumberOfLeaves();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetNumberOfLeaves */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfLevels */
    if ( strcmp ( argv[2], "GetNumberOfLevels" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfLevels" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfLevels */
    Tcl_DStringAppendElement ( &dString, " Return the number of levels in an individual (primal) tree\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetNumberOfLevels(vtkIdType);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetNumberOfLevels */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfTrees */
    if ( strcmp ( argv[2], "GetNumberOfTrees" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfTrees" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfTrees */
    Tcl_DStringAppendElement ( &dString, " Return the number of trees in the level 0 grid.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetNumberOfTrees();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetNumberOfTrees */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetXCoordinates */
    if ( strcmp ( argv[2], "SetXCoordinates" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetXCoordinates" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetXCoordinates */
    Tcl_DStringAppendElement ( &dString, " Specify the grid coordinates in the x-direction.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetXCoordinates(vtkDataArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetXCoordinates */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetXCoordinates */
    if ( strcmp ( argv[2], "GetXCoordinates" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetXCoordinates" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetXCoordinates */
    Tcl_DStringAppendElement ( &dString, " Specify the grid coordinates in the x-direction.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray *GetXCoordinates();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetXCoordinates */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetYCoordinates */
    if ( strcmp ( argv[2], "SetYCoordinates" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetYCoordinates" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetYCoordinates */
    Tcl_DStringAppendElement ( &dString, " Specify the grid coordinates in the y-direction.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetYCoordinates(vtkDataArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetYCoordinates */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetYCoordinates */
    if ( strcmp ( argv[2], "GetYCoordinates" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetYCoordinates" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetYCoordinates */
    Tcl_DStringAppendElement ( &dString, " Specify the grid coordinates in the y-direction.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray *GetYCoordinates();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetYCoordinates */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetZCoordinates */
    if ( strcmp ( argv[2], "SetZCoordinates" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetZCoordinates" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetZCoordinates */
    Tcl_DStringAppendElement ( &dString, " Specify the grid coordinates in the z-direction.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetZCoordinates(vtkDataArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetZCoordinates */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetZCoordinates */
    if ( strcmp ( argv[2], "GetZCoordinates" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetZCoordinates" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetZCoordinates */
    Tcl_DStringAppendElement ( &dString, " Specify the grid coordinates in the z-direction.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray *GetZCoordinates();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetZCoordinates */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMaterialMask */
    if ( strcmp ( argv[2], "SetMaterialMask" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMaterialMask" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkBitArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMaterialMask */
    Tcl_DStringAppendElement ( &dString, " Specify the blanking mask of primal leaf cells\n" );
    Tcl_DStringAppendElement ( &dString, "void SetMaterialMask(vtkBitArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetMaterialMask */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMaterialMask */
    if ( strcmp ( argv[2], "GetMaterialMask" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaterialMask" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaterialMask */
    Tcl_DStringAppendElement ( &dString, " Specify the blanking mask of primal leaf cells\n" );
    Tcl_DStringAppendElement ( &dString, "vtkBitArray *GetMaterialMask();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetMaterialMask */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMaterialMaskIndex */
    if ( strcmp ( argv[2], "SetMaterialMaskIndex" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMaterialMaskIndex" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkIdTypeArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMaterialMaskIndex */
    Tcl_DStringAppendElement ( &dString, " Specify the visibility mask of primal leaf cells\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetMaterialMaskIndex(vtkIdTypeArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SetMaterialMaskIndex */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMaterialMaskIndex */
    if ( strcmp ( argv[2], "GetMaterialMaskIndex" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaterialMaskIndex" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaterialMaskIndex */
    Tcl_DStringAppendElement ( &dString, " Specify the visibility mask of primal leaf cells\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdTypeArray *GetMaterialMaskIndex();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetMaterialMaskIndex */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GenerateTrees */
    if ( strcmp ( argv[2], "GenerateTrees" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GenerateTrees" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GenerateTrees */
    Tcl_DStringAppendElement ( &dString, " This method must be called once the tree settings change\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void GenerateTrees();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GenerateTrees */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewCursor */
    if ( strcmp ( argv[2], "NewCursor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewCursor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewCursor */
    Tcl_DStringAppendElement ( &dString, " Create a new cursor: an object that can traverse\n the cells of an individual hyper tree.\n \\post result_exists: result!=0\n" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeCursor *NewCursor(vtkIdType);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for NewCursor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SubdivideLeaf */
    if ( strcmp ( argv[2], "SubdivideLeaf" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SubdivideLeaf" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeCursor" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SubdivideLeaf */
    Tcl_DStringAppendElement ( &dString, " Subdivide node pointed by cursor, only if its a leaf.\n At the end, cursor points on the node that used to be leaf.\n \\pre leaf_exists: leaf!=0\n \\pre is_a_leaf: leaf->CurrentIsLeaf()\n" );
    Tcl_DStringAppendElement ( &dString, "void SubdivideLeaf(vtkHyperTreeCursor *, vtkIdType);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for SubdivideLeaf */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCell */
    if ( strcmp ( argv[2], "GetCell" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCell" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCell */
    Tcl_DStringAppendElement ( &dString, " This method should be avoided in favor of cell/point iterators.\n Random access to cells requires that connectivity arrays are created explicitly.\n Get cell with cellId such that: 0 <= cellId < NumberOfCells.\n THIS METHOD IS NOT THREAD SAFE.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkCell *GetCell(vtkIdType);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetCell */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCell */
    if ( strcmp ( argv[2], "GetCell" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCell" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkGenericCell" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCell */
    Tcl_DStringAppendElement ( &dString, " This method should be avoided in favor of cell/point iterators.\n Random access to cells requires that connectivity arrays are created explicitly.\n Get cell with cellId such that: 0 <= cellId < NumberOfCells.\n This is a thread-safe alternative to the previous GetCell()\n method.\n THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND\n THE DATASET IS NOT MODIFIED\n" );
    Tcl_DStringAppendElement ( &dString, "void GetCell(vtkIdType, vtkGenericCell *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetCell */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCellType */
    if ( strcmp ( argv[2], "GetCellType" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCellType" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCellType */
    Tcl_DStringAppendElement ( &dString, " All cell types are 2: quadrilaters,3d: hexahedrons.  They may be degenerate though.\n Get type of cell with cellId such that: 0 <= cellId < NumberOfCells.\n THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND\n THE DATASET IS NOT MODIFIED\n" );
    Tcl_DStringAppendElement ( &dString, "int GetCellType(vtkIdType);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetCellType */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCellPoints */
    if ( strcmp ( argv[2], "GetCellPoints" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCellPoints" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkIdList" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCellPoints */
    Tcl_DStringAppendElement ( &dString, " This method should be avoided in favor of cell/point iterators.\n Random access to cells requires that connectivity arrays are created explicitly.\n Topological inquiry to get points defining cell.\n THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND\n THE DATASET IS NOT MODIFIED\n" );
    Tcl_DStringAppendElement ( &dString, "void GetCellPoints(vtkIdType, vtkIdList *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetCellPoints */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPointCells */
    if ( strcmp ( argv[2], "GetPointCells" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPointCells" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkIdList" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPointCells */
    Tcl_DStringAppendElement ( &dString, " This method should be avoided in favor of cell/point iterators.\n Random access to cells requires that connectivity arrays are created explicitly.\n Topological inquiry to get cells using point.\n THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND\n THE DATASET IS NOT MODIFIED\n" );
    Tcl_DStringAppendElement ( &dString, "void GetPointCells(vtkIdType, vtkIdList *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetPointCells */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCellNeighbors */
    if ( strcmp ( argv[2], "GetCellNeighbors" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCellNeighbors" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkIdList" );
    Tcl_DStringAppendElement ( &dString, "vtkIdList" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCellNeighbors */
    Tcl_DStringAppendElement ( &dString, " This method should be avoided in favor of cell/point iterators.\n Random access to cells requires that connectivity arrays are created explicitly.\n Topological inquiry to get all cells using list of points exclusive of\n cell specified (e.g., cellId). Note that the list consists of only\n cells that use ALL the points provided.\n This is exactly the same as GetCellNeighbors in unstructured grid.\n THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND\n THE DA ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void GetCellNeighbors(vtkIdType, vtkIdList *, vtkIdList *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetCellNeighbors */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: FindPoint */
    if ( strcmp ( argv[2], "FindPoint" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "FindPoint" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for FindPoint */
    Tcl_DStringAppendElement ( &dString, " Find cell to which this point belongs, or at least closest one,\n even if the point is outside the grid.\n Since dual points are leaves, use the structure of the Tree instead\n of a point locator.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType FindPoint(double x\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for FindPoint */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Initialize */
    if ( strcmp ( argv[2], "Initialize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Initialize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Initialize */
    Tcl_DStringAppendElement ( &dString, " Restore data object to initial state,\n THIS METHOD IS NOT THREAD SAFE.\n" );
    Tcl_DStringAppendElement ( &dString, "void Initialize();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for Initialize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMaxCellSize */
    if ( strcmp ( argv[2], "GetMaxCellSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaxCellSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaxCellSize */
    Tcl_DStringAppendElement ( &dString, " Convenience method returns largest cell size in dataset. This is generally\n used to allocate memory for supporting data structures.\n This is the number of points of a cell.\n THIS METHOD IS THREAD SAFE\n" );
    Tcl_DStringAppendElement ( &dString, "int GetMaxCellSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetMaxCellSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ShallowCopy */
    if ( strcmp ( argv[2], "ShallowCopy" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ShallowCopy" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ShallowCopy */
    Tcl_DStringAppendElement ( &dString, " Shallow and Deep copy.\n" );
    Tcl_DStringAppendElement ( &dString, "void ShallowCopy(vtkDataObject *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for ShallowCopy */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DeepCopy */
    if ( strcmp ( argv[2], "DeepCopy" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DeepCopy" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DeepCopy */
    Tcl_DStringAppendElement ( &dString, " Shallow and Deep copy.\n" );
    Tcl_DStringAppendElement ( &dString, "void DeepCopy(vtkDataObject *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for DeepCopy */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExtentType */
    if ( strcmp ( argv[2], "GetExtentType" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExtentType" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExtentType */
    Tcl_DStringAppendElement ( &dString, " Structured extent. The extent type is a 3D extent\n" );
    Tcl_DStringAppendElement ( &dString, "int GetExtentType();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetExtentType */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetActualMemorySize */
    if ( strcmp ( argv[2], "GetActualMemorySize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetActualMemorySize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetActualMemorySize */
    Tcl_DStringAppendElement ( &dString, " Return the actual size of the data in kibibytes (1024 bytes). This number\n is valid only after the pipeline has updated. The memory size\n returned is guaranteed to be greater than or equal to the\n memory required to represent the data (e.g., extra space in\n arrays, etc. are not included in the return value). THIS METHOD\n IS THREAD SAFE.\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned long GetActualMemorySize();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetActualMemorySize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GenerateSuperCursorTraversalTable */
    if ( strcmp ( argv[2], "GenerateSuperCursorTraversalTable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GenerateSuperCursorTraversalTable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GenerateSuperCursorTraversalTable */
    Tcl_DStringAppendElement ( &dString, " Generate the table before calling InitializeSuperCursorChild.\n" );
    Tcl_DStringAppendElement ( &dString, "void GenerateSuperCursorTraversalTable();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GenerateSuperCursorTraversalTable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfChildren */
    if ( strcmp ( argv[2], "GetNumberOfChildren" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfChildren" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfChildren */
    Tcl_DStringAppendElement ( &dString, " The number of children each node can have.\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned int GetNumberOfChildren();" );
    Tcl_DStringAppendElement ( &dString, "vtkHyperTreeGrid" );
    /* Closing for GetNumberOfChildren */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkDataSetCppCommand(static_cast<vtkDataSet *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
