// tcl wrapper for vtkUnstructuredGridBase object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkUnstructuredGridBase.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>
int vtkPointSetCppCommand(vtkPointSet *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkUnstructuredGridBaseCppCommand(vtkUnstructuredGridBase *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkUnstructuredGridBaseCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkUnstructuredGridBaseCppCommand(static_cast<vtkUnstructuredGridBase *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkUnstructuredGridBase_TclCreate(Tcl_Interp *interp)
{
  (void)interp;
  return 0;
}

int VTKTCL_EXPORT vtkUnstructuredGridBaseCppCommand(vtkUnstructuredGridBase *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkUnstructuredGridBase",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkPointSetCppCommand(static_cast<vtkPointSet *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkPointSet"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("IsTypeOf",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsTypeOf(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObjectBase  *temp0;
    vtkUnstructuredGridBase  *temp20;
    error = 0;

    temp0 = (vtkObjectBase *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObjectBase"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkUnstructuredGridBase");
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkUnstructuredGridBase  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkUnstructuredGridBase");
    return TCL_OK;
  }
  if ((!strcmp("GetDataObjectType",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDataObjectType();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("Allocate",argv[1]))&&(argc == 4))
  {
    vtkIdType   temp0;
    int      temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
  {
    op->Allocate(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("DeepCopy",argv[1]))&&(argc == 3))
  {
    vtkDataObject  *temp0;
    error = 0;

    temp0 = (vtkDataObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataObject"),interp,error));
    if (!error)
  {
    op->DeepCopy(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("InsertNextCell",argv[1]))&&(argc == 4))
  {
    int      temp0;
    vtkIdList  *temp1;
    vtkIdType   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkIdList *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkIdList"),interp,error));
    if (!error)
  {
    temp20 = (op)->InsertNextCell(temp0,temp1);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetIdsOfCellsOfType",argv[1]))&&(argc == 4))
  {
    int      temp0;
    vtkIdTypeArray  *temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    temp1 = (vtkIdTypeArray *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkIdTypeArray"),interp,error));
    if (!error)
  {
    op->GetIdsOfCellsOfType(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("IsHomogeneous",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->IsHomogeneous();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetData",argv[1]))&&(argc == 3))
  {
    vtkInformation  *temp0;
    vtkUnstructuredGridBase  *temp20;
    error = 0;

    temp0 = (vtkInformation *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkInformation"),interp,error));
    if (!error)
  {
    temp20 = (op)->GetData(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkUnstructuredGridBase");
    return TCL_OK;
  }
  }
  if ((!strcmp("GetData",argv[1]))&&(argc == 4))
  {
    vtkInformationVector  *temp0;
    int      temp1;
    vtkUnstructuredGridBase  *temp20;
    error = 0;

    temp0 = (vtkInformationVector *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkInformationVector"),interp,error));
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
  {
    temp20 = (op)->GetData(temp0,temp1);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkUnstructuredGridBase");
    return TCL_OK;
  }
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkUnstructuredGridBaseCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkPointSetCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkUnstructuredGridBase:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsTypeOf\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  GetDataObjectType\n",NULL);
    Tcl_AppendResult(interp,"  Allocate\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  DeepCopy\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  InsertNextCell\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetIdsOfCellsOfType\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  IsHomogeneous\n",NULL);
    Tcl_AppendResult(interp,"  GetData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetData\t with 2 args\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkPointSetCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "IsTypeOf" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "GetDataObjectType" );
    Tcl_DStringAppendElement ( &dString, "Allocate" );
    Tcl_DStringAppendElement ( &dString, "DeepCopy" );
    Tcl_DStringAppendElement ( &dString, "InsertNextCell" );
    Tcl_DStringAppendElement ( &dString, "GetIdsOfCellsOfType" );
    Tcl_DStringAppendElement ( &dString, "IsHomogeneous" );
    Tcl_DStringAppendElement ( &dString, "GetData" );
    Tcl_DStringAppendElement ( &dString, "GetData" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkPointSetCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: IsTypeOf */
    if ( strcmp ( argv[2], "IsTypeOf" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsTypeOf" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsTypeOf */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkTypeBool IsTypeOf(const char *type);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for IsTypeOf */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkTypeBool IsA(const char *type);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObjectBase" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkUnstructuredGridBase *SafeDownCast(vtkObjectBase *o);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase *NewInstance() const;" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDataObjectType */
    if ( strcmp ( argv[2], "GetDataObjectType" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDataObjectType" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDataObjectType */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int GetDataObjectType();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for GetDataObjectType */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Allocate */
    if ( strcmp ( argv[2], "Allocate" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Allocate" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Allocate */
    Tcl_DStringAppendElement ( &dString, " Allocate memory for the number of cells indicated. extSize is not used.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void Allocate(vtkIdType numCells=1000, int extSize=1000) = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for Allocate */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DeepCopy */
    if ( strcmp ( argv[2], "DeepCopy" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DeepCopy" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DeepCopy */
    Tcl_DStringAppendElement ( &dString, " Shallow and Deep copy.\n" );
    Tcl_DStringAppendElement ( &dString, "void DeepCopy(vtkDataObject *src);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for DeepCopy */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: InsertNextCell */
    if ( strcmp ( argv[2], "InsertNextCell" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "InsertNextCell" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkIdList" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for InsertNextCell */
    Tcl_DStringAppendElement ( &dString, " Insert/create cell in object by a list of point ids defining\n cell topology. Most cells require just a type which implicitly defines\n a set of points and their ordering. For non-polyhedron cell type, ptIds\n is the list of global Ids of unique cell points. For polyhedron cell,\n a special ptIds input format is required:\n (numCellFaces, numFace0Pts, id1, id2, id3, numFace1Pts,id1, id2, id3, ...)\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkIdType InsertNextCell(int type, vtkIdList *ptIds) = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for InsertNextCell */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetIdsOfCellsOfType */
    if ( strcmp ( argv[2], "GetIdsOfCellsOfType" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetIdsOfCellsOfType" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "vtkIdTypeArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetIdsOfCellsOfType */
    Tcl_DStringAppendElement ( &dString, " Fill vtkIdTypeArray container with list of cell Ids.  This\n method traverses all cells and, for a particular cell type,\n inserts the cell Id into the container.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void GetIdsOfCellsOfType(int type, vtkIdTypeArray *array) = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for GetIdsOfCellsOfType */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsHomogeneous */
    if ( strcmp ( argv[2], "IsHomogeneous" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsHomogeneous" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsHomogeneous */
    Tcl_DStringAppendElement ( &dString, " Traverse cells and determine if cells are all of the same type.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int IsHomogeneous() = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for IsHomogeneous */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetData */
    if ( strcmp ( argv[2], "GetData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkInformation" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetData */
    Tcl_DStringAppendElement ( &dString, " Retrieve an instance of this class from an information object.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkUnstructuredGridBase *GetData(vtkInformation *info);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for GetData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetData */
    if ( strcmp ( argv[2], "GetData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkInformationVector" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetData */
    Tcl_DStringAppendElement ( &dString, " Retrieve an instance of this class from an information object.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkUnstructuredGridBase *GetData(vtkInformationVector *v, int i=0);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridBase" );
    /* Closing for GetData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkPointSetCppCommand(static_cast<vtkPointSet *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
