// tcl wrapper for vtkThreadedImageAlgorithm object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkThreadedImageAlgorithm.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>
int vtkImageAlgorithmCppCommand(vtkImageAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkThreadedImageAlgorithmCppCommand(vtkThreadedImageAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkThreadedImageAlgorithmCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkThreadedImageAlgorithmCppCommand(static_cast<vtkThreadedImageAlgorithm *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkThreadedImageAlgorithm_TclCreate(Tcl_Interp *interp)
{
  (void)interp;
  return 0;
}

int VTKTCL_EXPORT vtkThreadedImageAlgorithmCppCommand(vtkThreadedImageAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkThreadedImageAlgorithm",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkImageAlgorithmCppCommand(static_cast<vtkImageAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkImageAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkThreadedImageAlgorithm  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkThreadedImageAlgorithm");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkThreadedImageAlgorithm  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkThreadedImageAlgorithm");
    return TCL_OK;
  }
  }
  if ((!strcmp("GetEnableSMP",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetEnableSMP();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetEnableSMP",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetEnableSMP(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetGlobalDefaultEnableSMP",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetGlobalDefaultEnableSMP(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetGlobalDefaultEnableSMP",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetGlobalDefaultEnableSMP();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetMinimumPieceSize",argv[1]))&&(argc == 5))
  {
    int      temp0;
    int      temp1;
    int      temp2;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (!error)
  {
    op->SetMinimumPieceSize(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetMinimumPieceSize",argv[1]))&&(argc == 5))
  {
    int    temp0[3];
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0[0] = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp0[1] = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp0[2] = tempi;
    if (!error)
  {
    op->SetMinimumPieceSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMinimumPieceSize",argv[1]))&&(argc == 2))
  {
    int     *temp20;
    temp20 = (op)->GetMinimumPieceSize();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      sprintf(tempResult,"%i %i %i ",temp20[0],temp20[1],temp20[2]);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetDesiredBytesPerPiece",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetDesiredBytesPerPiece(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDesiredBytesPerPiece",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetDesiredBytesPerPiece();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetSplitMode",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetSplitMode(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSplitModeMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSplitModeMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSplitModeMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSplitModeMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetSplitModeToSlab",argv[1]))&&(argc == 2))
  {
    op->SetSplitModeToSlab();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetSplitModeToBeam",argv[1]))&&(argc == 2))
  {
    op->SetSplitModeToBeam();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetSplitModeToBlock",argv[1]))&&(argc == 2))
  {
    op->SetSplitModeToBlock();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetSplitMode",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSplitMode();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetNumberOfThreads",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNumberOfThreads(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfThreadsMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfThreadsMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfThreadsMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfThreadsMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfThreads",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfThreads();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkThreadedImageAlgorithmCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkImageAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkThreadedImageAlgorithm:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetEnableSMP\n",NULL);
    Tcl_AppendResult(interp,"  SetEnableSMP\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetGlobalDefaultEnableSMP\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetGlobalDefaultEnableSMP\n",NULL);
    Tcl_AppendResult(interp,"  SetMinimumPieceSize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetMinimumPieceSize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetMinimumPieceSize\n",NULL);
    Tcl_AppendResult(interp,"  SetDesiredBytesPerPiece\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDesiredBytesPerPiece\n",NULL);
    Tcl_AppendResult(interp,"  SetSplitMode\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSplitModeMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSplitModeMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  SetSplitModeToSlab\n",NULL);
    Tcl_AppendResult(interp,"  SetSplitModeToBeam\n",NULL);
    Tcl_AppendResult(interp,"  SetSplitModeToBlock\n",NULL);
    Tcl_AppendResult(interp,"  GetSplitMode\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfThreads\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfThreadsMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfThreadsMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfThreads\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkImageAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "GetEnableSMP" );
    Tcl_DStringAppendElement ( &dString, "SetEnableSMP" );
    Tcl_DStringAppendElement ( &dString, "SetGlobalDefaultEnableSMP" );
    Tcl_DStringAppendElement ( &dString, "GetGlobalDefaultEnableSMP" );
    Tcl_DStringAppendElement ( &dString, "SetMinimumPieceSize" );
    Tcl_DStringAppendElement ( &dString, "SetMinimumPieceSize" );
    Tcl_DStringAppendElement ( &dString, "GetMinimumPieceSize" );
    Tcl_DStringAppendElement ( &dString, "SetDesiredBytesPerPiece" );
    Tcl_DStringAppendElement ( &dString, "GetDesiredBytesPerPiece" );
    Tcl_DStringAppendElement ( &dString, "SetSplitMode" );
    Tcl_DStringAppendElement ( &dString, "GetSplitModeMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetSplitModeMaxValue" );
    Tcl_DStringAppendElement ( &dString, "SetSplitModeToSlab" );
    Tcl_DStringAppendElement ( &dString, "SetSplitModeToBeam" );
    Tcl_DStringAppendElement ( &dString, "SetSplitModeToBlock" );
    Tcl_DStringAppendElement ( &dString, "GetSplitMode" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfThreads" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfThreadsMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfThreadsMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfThreads" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkImageAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetEnableSMP */
    if ( strcmp ( argv[2], "GetEnableSMP" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetEnableSMP" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetEnableSMP */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable SMP for threading.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetEnableSMP();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetEnableSMP */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetEnableSMP */
    if ( strcmp ( argv[2], "SetEnableSMP" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetEnableSMP" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetEnableSMP */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable SMP for threading.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetEnableSMP(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SetEnableSMP */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetGlobalDefaultEnableSMP */
    if ( strcmp ( argv[2], "SetGlobalDefaultEnableSMP" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGlobalDefaultEnableSMP" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGlobalDefaultEnableSMP */
    Tcl_DStringAppendElement ( &dString, " Global Disable SMP for all derived Imaging filters.\n" );
    Tcl_DStringAppendElement ( &dString, "static void SetGlobalDefaultEnableSMP(bool enable);" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SetGlobalDefaultEnableSMP */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetGlobalDefaultEnableSMP */
    if ( strcmp ( argv[2], "GetGlobalDefaultEnableSMP" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetGlobalDefaultEnableSMP" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetGlobalDefaultEnableSMP */
    Tcl_DStringAppendElement ( &dString, " Global Disable SMP for all derived Imaging filters.\n" );
    Tcl_DStringAppendElement ( &dString, "static bool GetGlobalDefaultEnableSMP();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetGlobalDefaultEnableSMP */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMinimumPieceSize */
    if ( strcmp ( argv[2], "SetMinimumPieceSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMinimumPieceSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMinimumPieceSize */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetMinimumPieceSize(int, int, int);" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SetMinimumPieceSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMinimumPieceSize */
    if ( strcmp ( argv[2], "SetMinimumPieceSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMinimumPieceSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMinimumPieceSize */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetMinimumPieceSize(int a\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SetMinimumPieceSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMinimumPieceSize */
    if ( strcmp ( argv[2], "GetMinimumPieceSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMinimumPieceSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMinimumPieceSize */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int *GetMinimumPieceSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetMinimumPieceSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDesiredBytesPerPiece */
    if ( strcmp ( argv[2], "SetDesiredBytesPerPiece" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDesiredBytesPerPiece" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDesiredBytesPerPiece */
    Tcl_DStringAppendElement ( &dString, " The desired bytes per piece when volume is split for execution.\n When SMP is enabled, this is used to subdivide the volume into pieces.\n Smaller pieces allow for better dynamic load balancing, but increase\n the total overhead. The default is 65536 bytes.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDesiredBytesPerPiece(vtkIdType a);" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SetDesiredBytesPerPiece */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDesiredBytesPerPiece */
    if ( strcmp ( argv[2], "GetDesiredBytesPerPiece" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDesiredBytesPerPiece" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDesiredBytesPerPiece */
    Tcl_DStringAppendElement ( &dString, " The desired bytes per piece when volume is split for execution.\n When SMP is enabled, this is used to subdivide the volume into pieces.\n Smaller pieces allow for better dynamic load balancing, but increase\n the total overhead. The default is 65536 bytes.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetDesiredBytesPerPiece();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetDesiredBytesPerPiece */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSplitMode */
    if ( strcmp ( argv[2], "SetSplitMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSplitMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSplitMode */
    Tcl_DStringAppendElement ( &dString, " Set the method used to divide the volume into pieces.\n Slab mode splits the volume along the Z direction first,\n Beam mode splits evenly along the Z and Y directions, and\n Block mode splits evenly along all three directions.\n Most filters use Slab mode as the default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSplitMode(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SetSplitMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSplitModeMinValue */
    if ( strcmp ( argv[2], "GetSplitModeMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSplitModeMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSplitModeMinValue */
    Tcl_DStringAppendElement ( &dString, " Set the method used to divide the volume into pieces.\n Slab mode splits the volume along the Z direction first,\n Beam mode splits evenly along the Z and Y directions, and\n Block mode splits evenly along all three directions.\n Most filters use Slab mode as the default.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSplitModeMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetSplitModeMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSplitModeMaxValue */
    if ( strcmp ( argv[2], "GetSplitModeMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSplitModeMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSplitModeMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set the method used to divide the volume into pieces.\n Slab mode splits the volume along the Z direction first,\n Beam mode splits evenly along the Z and Y directions, and\n Block mode splits evenly along all three directions.\n Most filters use Slab mode as the default.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSplitModeMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetSplitModeMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSplitModeToSlab */
    if ( strcmp ( argv[2], "SetSplitModeToSlab" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSplitModeToSlab" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSplitModeToSlab */
    Tcl_DStringAppendElement ( &dString, " Set the method used to divide the volume into pieces.\n Slab mode splits the volume along the Z direction first,\n Beam mode splits evenly along the Z and Y directions, and\n Block mode splits evenly along all three directions.\n Most filters use Slab mode as the default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSplitModeToSlab();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SetSplitModeToSlab */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSplitModeToBeam */
    if ( strcmp ( argv[2], "SetSplitModeToBeam" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSplitModeToBeam" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSplitModeToBeam */
    Tcl_DStringAppendElement ( &dString, " Set the method used to divide the volume into pieces.\n Slab mode splits the volume along the Z direction first,\n Beam mode splits evenly along the Z and Y directions, and\n Block mode splits evenly along all three directions.\n Most filters use Slab mode as the default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSplitModeToBeam();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SetSplitModeToBeam */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSplitModeToBlock */
    if ( strcmp ( argv[2], "SetSplitModeToBlock" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSplitModeToBlock" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSplitModeToBlock */
    Tcl_DStringAppendElement ( &dString, " Set the method used to divide the volume into pieces.\n Slab mode splits the volume along the Z direction first,\n Beam mode splits evenly along the Z and Y directions, and\n Block mode splits evenly along all three directions.\n Most filters use Slab mode as the default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSplitModeToBlock();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SetSplitModeToBlock */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSplitMode */
    if ( strcmp ( argv[2], "GetSplitMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSplitMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSplitMode */
    Tcl_DStringAppendElement ( &dString, " Set the method used to divide the volume into pieces.\n Slab mode splits the volume along the Z direction first,\n Beam mode splits evenly along the Z and Y directions, and\n Block mode splits evenly along all three directions.\n Most filters use Slab mode as the default.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSplitMode();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetSplitMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfThreads */
    if ( strcmp ( argv[2], "SetNumberOfThreads" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfThreads" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfThreads */
    Tcl_DStringAppendElement ( &dString, " Get/Set the number of threads to create when rendering.\n This is ignored if EnableSMP is On.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNumberOfThreads(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for SetNumberOfThreads */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfThreadsMinValue */
    if ( strcmp ( argv[2], "GetNumberOfThreadsMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfThreadsMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfThreadsMinValue */
    Tcl_DStringAppendElement ( &dString, " Get/Set the number of threads to create when rendering.\n This is ignored if EnableSMP is On.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfThreadsMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetNumberOfThreadsMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfThreadsMaxValue */
    if ( strcmp ( argv[2], "GetNumberOfThreadsMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfThreadsMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfThreadsMaxValue */
    Tcl_DStringAppendElement ( &dString, " Get/Set the number of threads to create when rendering.\n This is ignored if EnableSMP is On.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfThreadsMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetNumberOfThreadsMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfThreads */
    if ( strcmp ( argv[2], "GetNumberOfThreads" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfThreads" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfThreads */
    Tcl_DStringAppendElement ( &dString, " Get/Set the number of threads to create when rendering.\n This is ignored if EnableSMP is On.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfThreads();" );
    Tcl_DStringAppendElement ( &dString, "vtkThreadedImageAlgorithm" );
    /* Closing for GetNumberOfThreads */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkImageAlgorithmCppCommand(static_cast<vtkImageAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
