// tcl wrapper for vtkPeriodicTable object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPeriodicTable.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkPeriodicTableNewCommand()
{
  vtkPeriodicTable *temp = vtkPeriodicTable::New();
  return static_cast<ClientData>(temp);
}

int vtkObjectCppCommand(vtkObject *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkPeriodicTableCppCommand(vtkPeriodicTable *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkPeriodicTableCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkPeriodicTableCppCommand(static_cast<vtkPeriodicTable *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkPeriodicTable_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkPeriodicTable"),vtkPeriodicTableNewCommand,vtkPeriodicTableCommand);
  return 0;
}

int VTKTCL_EXPORT vtkPeriodicTableCppCommand(vtkPeriodicTable *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkPeriodicTable",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkObject"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkPeriodicTable  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPeriodicTable");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkPeriodicTable  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPeriodicTable");
    return TCL_OK;
  }
  }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkPeriodicTable  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPeriodicTable");
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfElements",argv[1]))&&(argc == 2))
  {
    unsigned short    temp20;
    temp20 = (op)->GetNumberOfElements();
    char tempResult[1024];
    sprintf(tempResult,"%hu",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSymbol",argv[1]))&&(argc == 3))
  {
    unsigned short    temp0;
    const char    *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned short>(tempi);
    if (!error)
  {
    temp20 = (op)->GetSymbol(temp0);
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("GetElementName",argv[1]))&&(argc == 3))
  {
    unsigned short    temp0;
    const char    *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned short>(tempi);
    if (!error)
  {
    temp20 = (op)->GetElementName(temp0);
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAtomicNumber",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    unsigned short    temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->GetAtomicNumber(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%hu",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCovalentRadius",argv[1]))&&(argc == 3))
  {
    unsigned short    temp0;
    float    temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned short>(tempi);
    if (!error)
  {
    temp20 = (op)->GetCovalentRadius(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetVDWRadius",argv[1]))&&(argc == 3))
  {
    unsigned short    temp0;
    float    temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned short>(tempi);
    if (!error)
  {
    temp20 = (op)->GetVDWRadius(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDefaultLUT",argv[1]))&&(argc == 3))
  {
    vtkLookupTable  *temp0;
    error = 0;

    temp0 = (vtkLookupTable *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkLookupTable"),interp,error));
    if (!error)
  {
    op->GetDefaultLUT(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkPeriodicTableCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkPeriodicTable:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfElements\n",NULL);
    Tcl_AppendResult(interp,"  GetSymbol\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetElementName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAtomicNumber\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCovalentRadius\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetVDWRadius\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDefaultLUT\t with 1 arg\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfElements" );
    Tcl_DStringAppendElement ( &dString, "GetSymbol" );
    Tcl_DStringAppendElement ( &dString, "GetElementName" );
    Tcl_DStringAppendElement ( &dString, "GetAtomicNumber" );
    Tcl_DStringAppendElement ( &dString, "GetCovalentRadius" );
    Tcl_DStringAppendElement ( &dString, "GetVDWRadius" );
    Tcl_DStringAppendElement ( &dString, "GetDefaultLUT" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkObjectCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkPeriodicTable *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfElements */
    if ( strcmp ( argv[2], "GetNumberOfElements" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfElements" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfElements */
    Tcl_DStringAppendElement ( &dString, " Returns the number of elements in the periodic table.\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned short GetNumberOfElements();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for GetNumberOfElements */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSymbol */
    if ( strcmp ( argv[2], "GetSymbol" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSymbol" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSymbol */
    Tcl_DStringAppendElement ( &dString, " Given an atomic number, returns the symbol associated with the\n element\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetSymbol(const unsigned short atomicNum);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for GetSymbol */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetElementName */
    if ( strcmp ( argv[2], "GetElementName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetElementName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetElementName */
    Tcl_DStringAppendElement ( &dString, " Given an atomic number, returns the name of the element\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetElementName(const unsigned short atomicNum);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for GetElementName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAtomicNumber */
    if ( strcmp ( argv[2], "GetAtomicNumber" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAtomicNumber" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAtomicNumber */
    Tcl_DStringAppendElement ( &dString, " Given a case-insensitive string that contains the symbol or name\n of an element, return the corresponding atomic number.\n" );
    Tcl_DStringAppendElement ( &dString, "unsigned short GetAtomicNumber(const char *str);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for GetAtomicNumber */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCovalentRadius */
    if ( strcmp ( argv[2], "GetCovalentRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCovalentRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCovalentRadius */
    Tcl_DStringAppendElement ( &dString, " Given an atomic number, return the covalent radius of the atom\n" );
    Tcl_DStringAppendElement ( &dString, "float GetCovalentRadius(const unsigned short atomicNum);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for GetCovalentRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetVDWRadius */
    if ( strcmp ( argv[2], "GetVDWRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVDWRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVDWRadius */
    Tcl_DStringAppendElement ( &dString, " Given an atomic number, returns the van der Waals radius of the\n atom\n" );
    Tcl_DStringAppendElement ( &dString, "float GetVDWRadius(const unsigned short atomicNum);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for GetVDWRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDefaultLUT */
    if ( strcmp ( argv[2], "GetDefaultLUT" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDefaultLUT" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkLookupTable" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDefaultLUT */
    Tcl_DStringAppendElement ( &dString, " Fill the given vtkLookupTable to map atomic numbers to the\n familiar RGB tuples provided by the Blue Obelisk Data Repository\n" );
    Tcl_DStringAppendElement ( &dString, "void GetDefaultLUT(vtkLookupTable *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicTable" );
    /* Closing for GetDefaultLUT */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
