// tcl wrapper for vtkBinCellDataFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkBinCellDataFilter.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkBinCellDataFilterNewCommand()
{
  vtkBinCellDataFilter *temp = vtkBinCellDataFilter::New();
  return static_cast<ClientData>(temp);
}

int vtkDataSetAlgorithmCppCommand(vtkDataSetAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkBinCellDataFilterCppCommand(vtkBinCellDataFilter *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkBinCellDataFilterCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkBinCellDataFilterCppCommand(static_cast<vtkBinCellDataFilter *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkBinCellDataFilter_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkBinCellDataFilter"),vtkBinCellDataFilterNewCommand,vtkBinCellDataFilterCommand);
  return 0;
}

int VTKTCL_EXPORT vtkBinCellDataFilterCppCommand(vtkBinCellDataFilter *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkBinCellDataFilter",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkDataSetAlgorithmCppCommand(static_cast<vtkDataSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkDataSetAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkBinCellDataFilter  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkBinCellDataFilter");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkBinCellDataFilter  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkBinCellDataFilter");
    return TCL_OK;
  }
  }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkBinCellDataFilter  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkBinCellDataFilter");
    return TCL_OK;
  }
  if ((!strcmp("SetValue",argv[1]))&&(argc == 4))
  {
    int      temp0;
    double   temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    op->SetValue(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetValue",argv[1]))&&(argc == 3))
  {
    int      temp0;
    double   temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    temp20 = (op)->GetValue(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetNumberOfBins",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNumberOfBins(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfBins",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfBins();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GenerateValues",argv[1]))&&(argc == 5))
  {
    int      temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    op->GenerateValues(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSourceData",argv[1]))&&(argc == 3))
  {
    vtkDataObject  *temp0;
    error = 0;

    temp0 = (vtkDataObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataObject"),interp,error));
    if (!error)
  {
    op->SetSourceData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSource",argv[1]))&&(argc == 2))
  {
    vtkDataObject  *temp20;
    temp20 = (op)->GetSource();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataObject");
    return TCL_OK;
  }
  if ((!strcmp("SetSourceConnection",argv[1]))&&(argc == 3))
  {
    vtkAlgorithmOutput  *temp0;
    error = 0;

    temp0 = (vtkAlgorithmOutput *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAlgorithmOutput"),interp,error));
    if (!error)
  {
    op->SetSourceConnection(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSpatialMatch",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetSpatialMatch(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSpatialMatch",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSpatialMatch();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SpatialMatchOn",argv[1]))&&(argc == 2))
  {
    op->SpatialMatchOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SpatialMatchOff",argv[1]))&&(argc == 2))
  {
    op->SpatialMatchOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetStoreNumberOfNonzeroBins",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetStoreNumberOfNonzeroBins(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("StoreNumberOfNonzeroBinsOn",argv[1]))&&(argc == 2))
  {
    op->StoreNumberOfNonzeroBinsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("StoreNumberOfNonzeroBinsOff",argv[1]))&&(argc == 2))
  {
    op->StoreNumberOfNonzeroBinsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetStoreNumberOfNonzeroBins",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetStoreNumberOfNonzeroBins();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetNumberOfNonzeroBinsArrayName",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetNumberOfNonzeroBinsArrayName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfNonzeroBinsArrayName",argv[1]))&&(argc == 2))
  {
    char    *temp20;
    temp20 = (op)->GetNumberOfNonzeroBinsArrayName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetTolerance",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetTolerance(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTolerance",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetTolerance();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetComputeTolerance",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetComputeTolerance(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("ComputeToleranceOn",argv[1]))&&(argc == 2))
  {
    op->ComputeToleranceOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ComputeToleranceOff",argv[1]))&&(argc == 2))
  {
    op->ComputeToleranceOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetComputeTolerance",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetComputeTolerance();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetArrayComponent",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetArrayComponent(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetArrayComponent",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetArrayComponent();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetCellOverlapMethod",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetCellOverlapMethod(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCellOverlapMethodMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetCellOverlapMethodMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetCellOverlapMethodMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetCellOverlapMethodMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetCellOverlapMethod",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetCellOverlapMethod();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetCellLocator",argv[1]))&&(argc == 3))
  {
    vtkCellLocator  *temp0;
    error = 0;

    temp0 = (vtkCellLocator *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkCellLocator"),interp,error));
    if (!error)
  {
    op->SetCellLocator(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCellLocator",argv[1]))&&(argc == 2))
  {
    vtkCellLocator  *temp20;
    temp20 = (op)->GetCellLocator();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkCellLocator");
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkBinCellDataFilterCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkDataSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkBinCellDataFilter:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  SetValue\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetValue\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfBins\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfBins\n",NULL);
    Tcl_AppendResult(interp,"  GenerateValues\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetSourceData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSource\n",NULL);
    Tcl_AppendResult(interp,"  SetSourceConnection\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetSpatialMatch\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSpatialMatch\n",NULL);
    Tcl_AppendResult(interp,"  SpatialMatchOn\n",NULL);
    Tcl_AppendResult(interp,"  SpatialMatchOff\n",NULL);
    Tcl_AppendResult(interp,"  SetStoreNumberOfNonzeroBins\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  StoreNumberOfNonzeroBinsOn\n",NULL);
    Tcl_AppendResult(interp,"  StoreNumberOfNonzeroBinsOff\n",NULL);
    Tcl_AppendResult(interp,"  GetStoreNumberOfNonzeroBins\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfNonzeroBinsArrayName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfNonzeroBinsArrayName\n",NULL);
    Tcl_AppendResult(interp,"  SetTolerance\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTolerance\n",NULL);
    Tcl_AppendResult(interp,"  SetComputeTolerance\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  ComputeToleranceOn\n",NULL);
    Tcl_AppendResult(interp,"  ComputeToleranceOff\n",NULL);
    Tcl_AppendResult(interp,"  GetComputeTolerance\n",NULL);
    Tcl_AppendResult(interp,"  SetArrayComponent\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetArrayComponent\n",NULL);
    Tcl_AppendResult(interp,"  SetCellOverlapMethod\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCellOverlapMethodMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetCellOverlapMethodMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetCellOverlapMethod\n",NULL);
    Tcl_AppendResult(interp,"  SetCellLocator\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCellLocator\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkDataSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "SetValue" );
    Tcl_DStringAppendElement ( &dString, "GetValue" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfBins" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfBins" );
    Tcl_DStringAppendElement ( &dString, "GenerateValues" );
    Tcl_DStringAppendElement ( &dString, "SetSourceData" );
    Tcl_DStringAppendElement ( &dString, "GetSource" );
    Tcl_DStringAppendElement ( &dString, "SetSourceConnection" );
    Tcl_DStringAppendElement ( &dString, "SetSpatialMatch" );
    Tcl_DStringAppendElement ( &dString, "GetSpatialMatch" );
    Tcl_DStringAppendElement ( &dString, "SpatialMatchOn" );
    Tcl_DStringAppendElement ( &dString, "SpatialMatchOff" );
    Tcl_DStringAppendElement ( &dString, "SetStoreNumberOfNonzeroBins" );
    Tcl_DStringAppendElement ( &dString, "StoreNumberOfNonzeroBinsOn" );
    Tcl_DStringAppendElement ( &dString, "StoreNumberOfNonzeroBinsOff" );
    Tcl_DStringAppendElement ( &dString, "GetStoreNumberOfNonzeroBins" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfNonzeroBinsArrayName" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfNonzeroBinsArrayName" );
    Tcl_DStringAppendElement ( &dString, "SetTolerance" );
    Tcl_DStringAppendElement ( &dString, "GetTolerance" );
    Tcl_DStringAppendElement ( &dString, "SetComputeTolerance" );
    Tcl_DStringAppendElement ( &dString, "ComputeToleranceOn" );
    Tcl_DStringAppendElement ( &dString, "ComputeToleranceOff" );
    Tcl_DStringAppendElement ( &dString, "GetComputeTolerance" );
    Tcl_DStringAppendElement ( &dString, "SetArrayComponent" );
    Tcl_DStringAppendElement ( &dString, "GetArrayComponent" );
    Tcl_DStringAppendElement ( &dString, "SetCellOverlapMethod" );
    Tcl_DStringAppendElement ( &dString, "GetCellOverlapMethodMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetCellOverlapMethodMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetCellOverlapMethod" );
    Tcl_DStringAppendElement ( &dString, "SetCellLocator" );
    Tcl_DStringAppendElement ( &dString, "GetCellLocator" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkDataSetAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Construct object with initial range (VTK_DOUBLE_MIN, VTK_DOUBLE_MAX) and\n a single bin.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkBinCellDataFilter *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetValue */
    if ( strcmp ( argv[2], "SetValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetValue */
    Tcl_DStringAppendElement ( &dString, " Methods to set / get bin values.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetValue(int i, double value);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetValue */
    if ( strcmp ( argv[2], "GetValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetValue */
    Tcl_DStringAppendElement ( &dString, " Methods to set / get bin values.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetValue(int i);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfBins */
    if ( strcmp ( argv[2], "SetNumberOfBins" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfBins" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfBins */
    Tcl_DStringAppendElement ( &dString, " Methods to set / get bin values.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNumberOfBins(int numBins);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetNumberOfBins */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfBins */
    if ( strcmp ( argv[2], "GetNumberOfBins" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfBins" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfBins */
    Tcl_DStringAppendElement ( &dString, " Methods to set / get bin values.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfBins();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetNumberOfBins */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GenerateValues */
    if ( strcmp ( argv[2], "GenerateValues" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GenerateValues" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GenerateValues */
    Tcl_DStringAppendElement ( &dString, " Methods to set / get bin values.\n" );
    Tcl_DStringAppendElement ( &dString, "void GenerateValues(int numBins, double rangeStart, double rangeEnd);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GenerateValues */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSourceData */
    if ( strcmp ( argv[2], "SetSourceData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSourceData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSourceData */
    Tcl_DStringAppendElement ( &dString, " Specify the data set whose cells will be counted.\n The Input gives the geometry (the points and cells) for the output,\n while the Source is used to determine how many source cells lie within\n each input cell.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSourceData(vtkDataObject *source);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetSourceData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSource */
    if ( strcmp ( argv[2], "GetSource" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSource" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSource */
    Tcl_DStringAppendElement ( &dString, " Specify the data set whose cells will be counted.\n The Input gives the geometry (the points and cells) for the output,\n while the Source is used to determine how many source cells lie within\n each input cell.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataObject *GetSource();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetSource */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSourceConnection */
    if ( strcmp ( argv[2], "SetSourceConnection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSourceConnection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAlgorithmOutput" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSourceConnection */
    Tcl_DStringAppendElement ( &dString, " Specify the data set whose cells will be counted.\n The Input gives the geometry (the points and cells) for the output,\n while the Source is used to determine how many source cells lie within\n each input cell.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSourceConnection(vtkAlgorithmOutput *algOutput);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetSourceConnection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSpatialMatch */
    if ( strcmp ( argv[2], "SetSpatialMatch" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSpatialMatch" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSpatialMatch */
    Tcl_DStringAppendElement ( &dString, " This flag is used only when a piece is requested to update.  By default\n the flag is off.  Because no spatial correspondence between input pieces\n and source pieces is known, all of the source has to be requested no\n matter what piece of the output is requested.  When there is a spatial\n correspondence, the user/application can set this flag.  This hint allows\n the breakup of the probe operation to be much more efficient.  When piece\n m of n is requested for update by ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSpatialMatch(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetSpatialMatch */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSpatialMatch */
    if ( strcmp ( argv[2], "GetSpatialMatch" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSpatialMatch" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSpatialMatch */
    Tcl_DStringAppendElement ( &dString, " This flag is used only when a piece is requested to update.  By default\n the flag is off.  Because no spatial correspondence between input pieces\n and source pieces is known, all of the source has to be requested no\n matter what piece of the output is requested.  When there is a spatial\n correspondence, the user/application can set this flag.  This hint allows\n the breakup of the probe operation to be much more efficient.  When piece\n m of n is requested for update by ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSpatialMatch();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetSpatialMatch */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SpatialMatchOn */
    if ( strcmp ( argv[2], "SpatialMatchOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SpatialMatchOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SpatialMatchOn */
    Tcl_DStringAppendElement ( &dString, " This flag is used only when a piece is requested to update.  By default\n the flag is off.  Because no spatial correspondence between input pieces\n and source pieces is known, all of the source has to be requested no\n matter what piece of the output is requested.  When there is a spatial\n correspondence, the user/application can set this flag.  This hint allows\n the breakup of the probe operation to be much more efficient.  When piece\n m of n is requested for update by ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SpatialMatchOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SpatialMatchOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SpatialMatchOff */
    if ( strcmp ( argv[2], "SpatialMatchOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SpatialMatchOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SpatialMatchOff */
    Tcl_DStringAppendElement ( &dString, " This flag is used only when a piece is requested to update.  By default\n the flag is off.  Because no spatial correspondence between input pieces\n and source pieces is known, all of the source has to be requested no\n matter what piece of the output is requested.  When there is a spatial\n correspondence, the user/application can set this flag.  This hint allows\n the breakup of the probe operation to be much more efficient.  When piece\n m of n is requested for update by ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SpatialMatchOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SpatialMatchOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetStoreNumberOfNonzeroBins */
    if ( strcmp ( argv[2], "SetStoreNumberOfNonzeroBins" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetStoreNumberOfNonzeroBins" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetStoreNumberOfNonzeroBins */
    Tcl_DStringAppendElement ( &dString, " Set whether to store the number of nonzero bins for each cell.\n On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetStoreNumberOfNonzeroBins(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetStoreNumberOfNonzeroBins */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: StoreNumberOfNonzeroBinsOn */
    if ( strcmp ( argv[2], "StoreNumberOfNonzeroBinsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "StoreNumberOfNonzeroBinsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for StoreNumberOfNonzeroBinsOn */
    Tcl_DStringAppendElement ( &dString, " Set whether to store the number of nonzero bins for each cell.\n On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void StoreNumberOfNonzeroBinsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for StoreNumberOfNonzeroBinsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: StoreNumberOfNonzeroBinsOff */
    if ( strcmp ( argv[2], "StoreNumberOfNonzeroBinsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "StoreNumberOfNonzeroBinsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for StoreNumberOfNonzeroBinsOff */
    Tcl_DStringAppendElement ( &dString, " Set whether to store the number of nonzero bins for each cell.\n On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void StoreNumberOfNonzeroBinsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for StoreNumberOfNonzeroBinsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetStoreNumberOfNonzeroBins */
    if ( strcmp ( argv[2], "GetStoreNumberOfNonzeroBins" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetStoreNumberOfNonzeroBins" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetStoreNumberOfNonzeroBins */
    Tcl_DStringAppendElement ( &dString, " Set whether to store the number of nonzero bins for each cell.\n On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetStoreNumberOfNonzeroBins();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetStoreNumberOfNonzeroBins */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfNonzeroBinsArrayName */
    if ( strcmp ( argv[2], "SetNumberOfNonzeroBinsArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfNonzeroBinsArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfNonzeroBinsArrayName */
    Tcl_DStringAppendElement ( &dString, " Returns the name of the id array added to the output that holds the number\n of nonzero bins per cell.\n Set to \"NumberOfNonzeroBins\" by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNumberOfNonzeroBinsArrayName(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetNumberOfNonzeroBinsArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfNonzeroBinsArrayName */
    if ( strcmp ( argv[2], "GetNumberOfNonzeroBinsArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfNonzeroBinsArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfNonzeroBinsArrayName */
    Tcl_DStringAppendElement ( &dString, " Returns the name of the id array added to the output that holds the number\n of nonzero bins per cell.\n Set to \"NumberOfNonzeroBins\" by default.\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetNumberOfNonzeroBinsArrayName();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetNumberOfNonzeroBinsArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTolerance */
    if ( strcmp ( argv[2], "SetTolerance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTolerance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTolerance */
    Tcl_DStringAppendElement ( &dString, " Set the tolerance used to compute whether a cell centroid in the\n source is in a cell of the input.  This value is only used\n if ComputeTolerance is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTolerance(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetTolerance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTolerance */
    if ( strcmp ( argv[2], "GetTolerance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTolerance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTolerance */
    Tcl_DStringAppendElement ( &dString, " Set the tolerance used to compute whether a cell centroid in the\n source is in a cell of the input.  This value is only used\n if ComputeTolerance is off.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetTolerance();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetTolerance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetComputeTolerance */
    if ( strcmp ( argv[2], "SetComputeTolerance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetComputeTolerance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetComputeTolerance */
    Tcl_DStringAppendElement ( &dString, " Set whether to use the Tolerance field or precompute the tolerance.\n When on, the tolerance will be computed and the field value is ignored.\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetComputeTolerance(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetComputeTolerance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ComputeToleranceOn */
    if ( strcmp ( argv[2], "ComputeToleranceOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeToleranceOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeToleranceOn */
    Tcl_DStringAppendElement ( &dString, " Set whether to use the Tolerance field or precompute the tolerance.\n When on, the tolerance will be computed and the field value is ignored.\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void ComputeToleranceOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for ComputeToleranceOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ComputeToleranceOff */
    if ( strcmp ( argv[2], "ComputeToleranceOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeToleranceOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeToleranceOff */
    Tcl_DStringAppendElement ( &dString, " Set whether to use the Tolerance field or precompute the tolerance.\n When on, the tolerance will be computed and the field value is ignored.\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void ComputeToleranceOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for ComputeToleranceOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetComputeTolerance */
    if ( strcmp ( argv[2], "GetComputeTolerance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetComputeTolerance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetComputeTolerance */
    Tcl_DStringAppendElement ( &dString, " Set whether to use the Tolerance field or precompute the tolerance.\n When on, the tolerance will be computed and the field value is ignored.\n Off by default.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetComputeTolerance();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetComputeTolerance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetArrayComponent */
    if ( strcmp ( argv[2], "SetArrayComponent" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetArrayComponent" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetArrayComponent */
    Tcl_DStringAppendElement ( &dString, " Set/get which component of the scalar array to bin; defaults to 0.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetArrayComponent(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetArrayComponent */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetArrayComponent */
    if ( strcmp ( argv[2], "GetArrayComponent" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetArrayComponent" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetArrayComponent */
    Tcl_DStringAppendElement ( &dString, " Set/get which component of the scalar array to bin; defaults to 0.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetArrayComponent();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetArrayComponent */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetCellOverlapMethod */
    if ( strcmp ( argv[2], "SetCellOverlapMethod" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCellOverlapMethod" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCellOverlapMethod */
    Tcl_DStringAppendElement ( &dString, " Set whether cell overlap is determined by source cell centroid or by source\n cell points.\n Centroid by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetCellOverlapMethod(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetCellOverlapMethod */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCellOverlapMethodMinValue */
    if ( strcmp ( argv[2], "GetCellOverlapMethodMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCellOverlapMethodMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCellOverlapMethodMinValue */
    Tcl_DStringAppendElement ( &dString, " Set whether cell overlap is determined by source cell centroid or by source\n cell points.\n Centroid by default.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetCellOverlapMethodMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetCellOverlapMethodMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCellOverlapMethodMaxValue */
    if ( strcmp ( argv[2], "GetCellOverlapMethodMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCellOverlapMethodMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCellOverlapMethodMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set whether cell overlap is determined by source cell centroid or by source\n cell points.\n Centroid by default.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetCellOverlapMethodMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetCellOverlapMethodMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCellOverlapMethod */
    if ( strcmp ( argv[2], "GetCellOverlapMethod" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCellOverlapMethod" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCellOverlapMethod */
    Tcl_DStringAppendElement ( &dString, " Set whether cell overlap is determined by source cell centroid or by source\n cell points.\n Centroid by default.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetCellOverlapMethod();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetCellOverlapMethod */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetCellLocator */
    if ( strcmp ( argv[2], "SetCellLocator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCellLocator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkCellLocator" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCellLocator */
    Tcl_DStringAppendElement ( &dString, " Set/Get a spatial locator for speeding the search process. By\n default an instance of vtkCellLocator is used.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetCellLocator(vtkCellLocator *cellLocator);" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for SetCellLocator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCellLocator */
    if ( strcmp ( argv[2], "GetCellLocator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCellLocator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCellLocator */
    Tcl_DStringAppendElement ( &dString, " Set/Get a spatial locator for speeding the search process. By\n default an instance of vtkCellLocator is used.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkCellLocator *GetCellLocator();" );
    Tcl_DStringAppendElement ( &dString, "vtkBinCellDataFilter" );
    /* Closing for GetCellLocator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkDataSetAlgorithmCppCommand(static_cast<vtkDataSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
