// tcl wrapper for vtkUnstructuredGridQuadricDecimation object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkUnstructuredGridQuadricDecimation.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkUnstructuredGridQuadricDecimationNewCommand()
{
  vtkUnstructuredGridQuadricDecimation *temp = vtkUnstructuredGridQuadricDecimation::New();
  return static_cast<ClientData>(temp);
}

int vtkUnstructuredGridAlgorithmCppCommand(vtkUnstructuredGridAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkUnstructuredGridQuadricDecimationCppCommand(vtkUnstructuredGridQuadricDecimation *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkUnstructuredGridQuadricDecimationCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkUnstructuredGridQuadricDecimationCppCommand(static_cast<vtkUnstructuredGridQuadricDecimation *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkUnstructuredGridQuadricDecimation_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkUnstructuredGridQuadricDecimation"),vtkUnstructuredGridQuadricDecimationNewCommand,vtkUnstructuredGridQuadricDecimationCommand);
  return 0;
}

int VTKTCL_EXPORT vtkUnstructuredGridQuadricDecimationCppCommand(vtkUnstructuredGridQuadricDecimation *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkUnstructuredGridQuadricDecimation",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkUnstructuredGridAlgorithmCppCommand(static_cast<vtkUnstructuredGridAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkUnstructuredGridAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkUnstructuredGridQuadricDecimation  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkUnstructuredGridQuadricDecimation");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkUnstructuredGridQuadricDecimation  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkUnstructuredGridQuadricDecimation");
    return TCL_OK;
  }
  }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkUnstructuredGridQuadricDecimation  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkUnstructuredGridQuadricDecimation");
    return TCL_OK;
  }
  if ((!strcmp("SetTargetReduction",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetTargetReduction(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTargetReduction",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetTargetReduction();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetNumberOfTetsOutput",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNumberOfTetsOutput(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfTetsOutput",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfTetsOutput();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetNumberOfEdgesToDecimate",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNumberOfEdgesToDecimate(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfEdgesToDecimate",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfEdgesToDecimate();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetNumberOfCandidates",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNumberOfCandidates(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfCandidates",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfCandidates();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetAutoAddCandidates",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetAutoAddCandidates(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAutoAddCandidates",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetAutoAddCandidates();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetAutoAddCandidatesThreshold",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetAutoAddCandidatesThreshold(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAutoAddCandidatesThreshold",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetAutoAddCandidatesThreshold();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetBoundaryWeight",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetBoundaryWeight(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetBoundaryWeight",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetBoundaryWeight();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetScalarsName",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetScalarsName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetScalarsName",argv[1]))&&(argc == 2))
  {
    char    *temp20;
    temp20 = (op)->GetScalarsName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkUnstructuredGridQuadricDecimationCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkUnstructuredGridAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkUnstructuredGridQuadricDecimation:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  SetTargetReduction\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTargetReduction\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfTetsOutput\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfTetsOutput\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfEdgesToDecimate\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfEdgesToDecimate\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfCandidates\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfCandidates\n",NULL);
    Tcl_AppendResult(interp,"  SetAutoAddCandidates\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAutoAddCandidates\n",NULL);
    Tcl_AppendResult(interp,"  SetAutoAddCandidatesThreshold\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAutoAddCandidatesThreshold\n",NULL);
    Tcl_AppendResult(interp,"  SetBoundaryWeight\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetBoundaryWeight\n",NULL);
    Tcl_AppendResult(interp,"  SetScalarsName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetScalarsName\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkUnstructuredGridAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "SetTargetReduction" );
    Tcl_DStringAppendElement ( &dString, "GetTargetReduction" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfTetsOutput" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfTetsOutput" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfEdgesToDecimate" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfEdgesToDecimate" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfCandidates" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfCandidates" );
    Tcl_DStringAppendElement ( &dString, "SetAutoAddCandidates" );
    Tcl_DStringAppendElement ( &dString, "GetAutoAddCandidates" );
    Tcl_DStringAppendElement ( &dString, "SetAutoAddCandidatesThreshold" );
    Tcl_DStringAppendElement ( &dString, "GetAutoAddCandidatesThreshold" );
    Tcl_DStringAppendElement ( &dString, "SetBoundaryWeight" );
    Tcl_DStringAppendElement ( &dString, "GetBoundaryWeight" );
    Tcl_DStringAppendElement ( &dString, "SetScalarsName" );
    Tcl_DStringAppendElement ( &dString, "GetScalarsName" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkUnstructuredGridAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkUnstructuredGridQuadricDecimation *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTargetReduction */
    if ( strcmp ( argv[2], "SetTargetReduction" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTargetReduction" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTargetReduction */
    Tcl_DStringAppendElement ( &dString, " Set/Get the desired reduction (expressed as a fraction of the original\n number of tetrehedra)\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTargetReduction(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for SetTargetReduction */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTargetReduction */
    if ( strcmp ( argv[2], "GetTargetReduction" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTargetReduction" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTargetReduction */
    Tcl_DStringAppendElement ( &dString, " Set/Get the desired reduction (expressed as a fraction of the original\n number of tetrehedra)\n" );
    Tcl_DStringAppendElement ( &dString, "double GetTargetReduction();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for GetTargetReduction */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfTetsOutput */
    if ( strcmp ( argv[2], "SetNumberOfTetsOutput" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfTetsOutput" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfTetsOutput */
    Tcl_DStringAppendElement ( &dString, " Set/Get the desired number of tetrahedra to be outputed\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNumberOfTetsOutput(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for SetNumberOfTetsOutput */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfTetsOutput */
    if ( strcmp ( argv[2], "GetNumberOfTetsOutput" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfTetsOutput" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfTetsOutput */
    Tcl_DStringAppendElement ( &dString, " Set/Get the desired number of tetrahedra to be outputed\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfTetsOutput();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for GetNumberOfTetsOutput */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfEdgesToDecimate */
    if ( strcmp ( argv[2], "SetNumberOfEdgesToDecimate" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfEdgesToDecimate" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfEdgesToDecimate */
    Tcl_DStringAppendElement ( &dString, " Set/Get the desired number of edge to collapse\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNumberOfEdgesToDecimate(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for SetNumberOfEdgesToDecimate */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfEdgesToDecimate */
    if ( strcmp ( argv[2], "GetNumberOfEdgesToDecimate" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfEdgesToDecimate" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfEdgesToDecimate */
    Tcl_DStringAppendElement ( &dString, " Set/Get the desired number of edge to collapse\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfEdgesToDecimate();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for GetNumberOfEdgesToDecimate */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfCandidates */
    if ( strcmp ( argv[2], "SetNumberOfCandidates" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfCandidates" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfCandidates */
    Tcl_DStringAppendElement ( &dString, " Set/Get the number of candidates selected for each randomized set before\n performing an edge collapse. Increasing this number can help producing\n higher quality output but it will be slower. Default is 8.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNumberOfCandidates(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for SetNumberOfCandidates */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfCandidates */
    if ( strcmp ( argv[2], "GetNumberOfCandidates" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfCandidates" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfCandidates */
    Tcl_DStringAppendElement ( &dString, " Set/Get the number of candidates selected for each randomized set before\n performing an edge collapse. Increasing this number can help producing\n higher quality output but it will be slower. Default is 8.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfCandidates();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for GetNumberOfCandidates */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAutoAddCandidates */
    if ( strcmp ( argv[2], "SetAutoAddCandidates" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAutoAddCandidates" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAutoAddCandidates */
    Tcl_DStringAppendElement ( &dString, " Enable(1)/Disable(0) the feature of temporarily doubling the number of\n candidates for each randomized set if the quadric error was significantly\n increased over the last edge collapse, i.e. if the ratio between the error\n difference and the last error is over some threshold. Basically, we are\n trying to make up for cases when random selection returns so many 'bad'\n edges. By doing this we can achieve a higher quality output with much less\n time than just double the N ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAutoAddCandidates(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for SetAutoAddCandidates */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAutoAddCandidates */
    if ( strcmp ( argv[2], "GetAutoAddCandidates" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAutoAddCandidates" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAutoAddCandidates */
    Tcl_DStringAppendElement ( &dString, " Enable(1)/Disable(0) the feature of temporarily doubling the number of\n candidates for each randomized set if the quadric error was significantly\n increased over the last edge collapse, i.e. if the ratio between the error\n difference and the last error is over some threshold. Basically, we are\n trying to make up for cases when random selection returns so many 'bad'\n edges. By doing this we can achieve a higher quality output with much less\n time than just double the N ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "int GetAutoAddCandidates();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for GetAutoAddCandidates */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAutoAddCandidatesThreshold */
    if ( strcmp ( argv[2], "SetAutoAddCandidatesThreshold" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAutoAddCandidatesThreshold" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAutoAddCandidatesThreshold */
    Tcl_DStringAppendElement ( &dString, " Set/Get the threshold that decides when to double the set size.\n Default is 0.4.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAutoAddCandidatesThreshold(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for SetAutoAddCandidatesThreshold */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAutoAddCandidatesThreshold */
    if ( strcmp ( argv[2], "GetAutoAddCandidatesThreshold" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAutoAddCandidatesThreshold" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAutoAddCandidatesThreshold */
    Tcl_DStringAppendElement ( &dString, " Set/Get the threshold that decides when to double the set size.\n Default is 0.4.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetAutoAddCandidatesThreshold();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for GetAutoAddCandidatesThreshold */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetBoundaryWeight */
    if ( strcmp ( argv[2], "SetBoundaryWeight" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetBoundaryWeight" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetBoundaryWeight */
    Tcl_DStringAppendElement ( &dString, " Set/Get the weight of the boundary on the quadric metrics. The larger\n the number, the better the boundary is preserved.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetBoundaryWeight(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for SetBoundaryWeight */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetBoundaryWeight */
    if ( strcmp ( argv[2], "GetBoundaryWeight" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBoundaryWeight" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBoundaryWeight */
    Tcl_DStringAppendElement ( &dString, " Set/Get the weight of the boundary on the quadric metrics. The larger\n the number, the better the boundary is preserved.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetBoundaryWeight();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for GetBoundaryWeight */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetScalarsName */
    if ( strcmp ( argv[2], "SetScalarsName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetScalarsName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetScalarsName */
    Tcl_DStringAppendElement ( &dString, " Set/Get the scalar field name used for simplification\n" );
    Tcl_DStringAppendElement ( &dString, "void SetScalarsName(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for SetScalarsName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScalarsName */
    if ( strcmp ( argv[2], "GetScalarsName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScalarsName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScalarsName */
    Tcl_DStringAppendElement ( &dString, " Set/Get the scalar field name used for simplification\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetScalarsName();" );
    Tcl_DStringAppendElement ( &dString, "vtkUnstructuredGridQuadricDecimation" );
    /* Closing for GetScalarsName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkUnstructuredGridAlgorithmCppCommand(static_cast<vtkUnstructuredGridAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
