#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkAbstractInterpolatedVelocityField_TclCreate(Tcl_Interp *interp);
int vtkAMRInterpolatedVelocityField_TclCreate(Tcl_Interp *interp);
int vtkCompositeInterpolatedVelocityField_TclCreate(Tcl_Interp *interp);
int vtkInterpolatedVelocityField_TclCreate(Tcl_Interp *interp);
int vtkStreamTracer_TclCreate(Tcl_Interp *interp);
int vtkModifiedBSPTree_TclCreate(Tcl_Interp *interp);
int vtkCellLocatorInterpolatedVelocityField_TclCreate(Tcl_Interp *interp);
int vtkTemporalStreamTracer_TclCreate(Tcl_Interp *interp);
int vtkParticleTracerBase_TclCreate(Tcl_Interp *interp);
int vtkParticleTracer_TclCreate(Tcl_Interp *interp);
int vtkStreaklineFilter_TclCreate(Tcl_Interp *interp);
int vtkParticlePathFilter_TclCreate(Tcl_Interp *interp);
int vtkTemporalInterpolatedVelocityField_TclCreate(Tcl_Interp *interp);
int vtkCachingInterpolatedVelocityField_TclCreate(Tcl_Interp *interp);
int vtkDashedStreamLine_TclCreate(Tcl_Interp *interp);
int vtkStreamLine_TclCreate(Tcl_Interp *interp);
int vtkStreamPoints_TclCreate(Tcl_Interp *interp);
int vtkStreamer_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkfiltersflowpathstcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkfiltersflowpathstcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkfiltersflowpathstcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkfiltersflowpathstcl_Init(interp);
}


int VTK_EXPORT Vtkfiltersflowpathstcl_Init(Tcl_Interp *interp)
{

  vtkAbstractInterpolatedVelocityField_TclCreate(interp);
  vtkAMRInterpolatedVelocityField_TclCreate(interp);
  vtkCompositeInterpolatedVelocityField_TclCreate(interp);
  vtkInterpolatedVelocityField_TclCreate(interp);
  vtkStreamTracer_TclCreate(interp);
  vtkModifiedBSPTree_TclCreate(interp);
  vtkCellLocatorInterpolatedVelocityField_TclCreate(interp);
  vtkTemporalStreamTracer_TclCreate(interp);
  vtkParticleTracerBase_TclCreate(interp);
  vtkParticleTracer_TclCreate(interp);
  vtkStreaklineFilter_TclCreate(interp);
  vtkParticlePathFilter_TclCreate(interp);
  vtkTemporalInterpolatedVelocityField_TclCreate(interp);
  vtkCachingInterpolatedVelocityField_TclCreate(interp);
  vtkDashedStreamLine_TclCreate(interp);
  vtkStreamLine_TclCreate(interp);
  vtkStreamPoints_TclCreate(interp);
  vtkStreamer_TclCreate(interp);
  char pkgName[]="vtkFiltersFlowPathsTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
