// tcl wrapper for vtkParticleTracerBase object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkParticleTracerBase.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>
int vtkPolyDataAlgorithmCppCommand(vtkPolyDataAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkParticleTracerBaseCppCommand(vtkParticleTracerBase *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkParticleTracerBaseCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkParticleTracerBaseCppCommand(static_cast<vtkParticleTracerBase *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkParticleTracerBase_TclCreate(Tcl_Interp *interp)
{
  (void)interp;
  return 0;
}

int VTKTCL_EXPORT vtkParticleTracerBaseCppCommand(vtkParticleTracerBase *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkParticleTracerBase",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkPolyDataAlgorithmCppCommand(static_cast<vtkPolyDataAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkPolyDataAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkParticleTracerBase  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkParticleTracerBase");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkParticleTracerBase  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkParticleTracerBase");
    return TCL_OK;
  }
  }
  if ((!strcmp("PrintParticleHistories",argv[1]))&&(argc == 2))
  {
    op->PrintParticleHistories();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetComputeVorticity",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetComputeVorticity();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetComputeVorticity",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetComputeVorticity(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTerminalSpeed",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetTerminalSpeed();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetTerminalSpeed",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetTerminalSpeed(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRotationScale",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRotationScale();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetRotationScale",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetRotationScale(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetIgnorePipelineTime",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetIgnorePipelineTime(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetIgnorePipelineTime",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetIgnorePipelineTime();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("IgnorePipelineTimeOn",argv[1]))&&(argc == 2))
  {
    op->IgnorePipelineTimeOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("IgnorePipelineTimeOff",argv[1]))&&(argc == 2))
  {
    op->IgnorePipelineTimeOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetForceReinjectionEveryNSteps",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetForceReinjectionEveryNSteps();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetForceReinjectionEveryNSteps",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetForceReinjectionEveryNSteps(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetTerminationTime",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetTerminationTime(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTerminationTime",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetTerminationTime();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetIntegrator",argv[1]))&&(argc == 3))
  {
    vtkInitialValueProblemSolver  *temp0;
    error = 0;

    temp0 = (vtkInitialValueProblemSolver *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkInitialValueProblemSolver"),interp,error));
    if (!error)
  {
    op->SetIntegrator(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetIntegrator",argv[1]))&&(argc == 2))
  {
    vtkInitialValueProblemSolver  *temp20;
    temp20 = (op)->GetIntegrator();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkInitialValueProblemSolver");
    return TCL_OK;
  }
  if ((!strcmp("SetIntegratorType",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetIntegratorType(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetIntegratorType",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetIntegratorType();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetStartTime",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetStartTime();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetStartTime",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetStartTime(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetStaticSeeds",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetStaticSeeds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetStaticSeeds",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetStaticSeeds();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetStaticMesh",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetStaticMesh(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetStaticMesh",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetStaticMesh();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetParticleWriter",argv[1]))&&(argc == 3))
  {
    vtkAbstractParticleWriter  *temp0;
    error = 0;

    temp0 = (vtkAbstractParticleWriter *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractParticleWriter"),interp,error));
    if (!error)
  {
    op->SetParticleWriter(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetParticleWriter",argv[1]))&&(argc == 2))
  {
    vtkAbstractParticleWriter  *temp20;
    temp20 = (op)->GetParticleWriter();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAbstractParticleWriter");
    return TCL_OK;
  }
  if ((!strcmp("SetParticleFileName",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetParticleFileName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetParticleFileName",argv[1]))&&(argc == 2))
  {
    char    *temp20;
    temp20 = (op)->GetParticleFileName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetEnableParticleWriting",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetEnableParticleWriting(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetEnableParticleWriting",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetEnableParticleWriting();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("EnableParticleWritingOn",argv[1]))&&(argc == 2))
  {
    op->EnableParticleWritingOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("EnableParticleWritingOff",argv[1]))&&(argc == 2))
  {
    op->EnableParticleWritingOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetDisableResetCache",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetDisableResetCache(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDisableResetCache",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDisableResetCache();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("DisableResetCacheOn",argv[1]))&&(argc == 2))
  {
    op->DisableResetCacheOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("DisableResetCacheOff",argv[1]))&&(argc == 2))
  {
    op->DisableResetCacheOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("AddSourceConnection",argv[1]))&&(argc == 3))
  {
    vtkAlgorithmOutput  *temp0;
    error = 0;

    temp0 = (vtkAlgorithmOutput *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAlgorithmOutput"),interp,error));
    if (!error)
  {
    op->AddSourceConnection(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("RemoveAllSources",argv[1]))&&(argc == 2))
  {
    op->RemoveAllSources();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkParticleTracerBaseCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkPolyDataAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkParticleTracerBase:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PrintParticleHistories\n",NULL);
    Tcl_AppendResult(interp,"  GetComputeVorticity\n",NULL);
    Tcl_AppendResult(interp,"  SetComputeVorticity\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTerminalSpeed\n",NULL);
    Tcl_AppendResult(interp,"  SetTerminalSpeed\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRotationScale\n",NULL);
    Tcl_AppendResult(interp,"  SetRotationScale\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetIgnorePipelineTime\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetIgnorePipelineTime\n",NULL);
    Tcl_AppendResult(interp,"  IgnorePipelineTimeOn\n",NULL);
    Tcl_AppendResult(interp,"  IgnorePipelineTimeOff\n",NULL);
    Tcl_AppendResult(interp,"  GetForceReinjectionEveryNSteps\n",NULL);
    Tcl_AppendResult(interp,"  SetForceReinjectionEveryNSteps\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetTerminationTime\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTerminationTime\n",NULL);
    Tcl_AppendResult(interp,"  SetIntegrator\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetIntegrator\n",NULL);
    Tcl_AppendResult(interp,"  SetIntegratorType\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetIntegratorType\n",NULL);
    Tcl_AppendResult(interp,"  GetStartTime\n",NULL);
    Tcl_AppendResult(interp,"  SetStartTime\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetStaticSeeds\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetStaticSeeds\n",NULL);
    Tcl_AppendResult(interp,"  SetStaticMesh\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetStaticMesh\n",NULL);
    Tcl_AppendResult(interp,"  SetParticleWriter\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetParticleWriter\n",NULL);
    Tcl_AppendResult(interp,"  SetParticleFileName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetParticleFileName\n",NULL);
    Tcl_AppendResult(interp,"  SetEnableParticleWriting\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetEnableParticleWriting\n",NULL);
    Tcl_AppendResult(interp,"  EnableParticleWritingOn\n",NULL);
    Tcl_AppendResult(interp,"  EnableParticleWritingOff\n",NULL);
    Tcl_AppendResult(interp,"  SetDisableResetCache\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDisableResetCache\n",NULL);
    Tcl_AppendResult(interp,"  DisableResetCacheOn\n",NULL);
    Tcl_AppendResult(interp,"  DisableResetCacheOff\n",NULL);
    Tcl_AppendResult(interp,"  AddSourceConnection\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RemoveAllSources\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkPolyDataAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "PrintParticleHistories" );
    Tcl_DStringAppendElement ( &dString, "GetComputeVorticity" );
    Tcl_DStringAppendElement ( &dString, "SetComputeVorticity" );
    Tcl_DStringAppendElement ( &dString, "GetTerminalSpeed" );
    Tcl_DStringAppendElement ( &dString, "SetTerminalSpeed" );
    Tcl_DStringAppendElement ( &dString, "GetRotationScale" );
    Tcl_DStringAppendElement ( &dString, "SetRotationScale" );
    Tcl_DStringAppendElement ( &dString, "SetIgnorePipelineTime" );
    Tcl_DStringAppendElement ( &dString, "GetIgnorePipelineTime" );
    Tcl_DStringAppendElement ( &dString, "IgnorePipelineTimeOn" );
    Tcl_DStringAppendElement ( &dString, "IgnorePipelineTimeOff" );
    Tcl_DStringAppendElement ( &dString, "GetForceReinjectionEveryNSteps" );
    Tcl_DStringAppendElement ( &dString, "SetForceReinjectionEveryNSteps" );
    Tcl_DStringAppendElement ( &dString, "SetTerminationTime" );
    Tcl_DStringAppendElement ( &dString, "GetTerminationTime" );
    Tcl_DStringAppendElement ( &dString, "SetIntegrator" );
    Tcl_DStringAppendElement ( &dString, "GetIntegrator" );
    Tcl_DStringAppendElement ( &dString, "SetIntegratorType" );
    Tcl_DStringAppendElement ( &dString, "GetIntegratorType" );
    Tcl_DStringAppendElement ( &dString, "GetStartTime" );
    Tcl_DStringAppendElement ( &dString, "SetStartTime" );
    Tcl_DStringAppendElement ( &dString, "SetStaticSeeds" );
    Tcl_DStringAppendElement ( &dString, "GetStaticSeeds" );
    Tcl_DStringAppendElement ( &dString, "SetStaticMesh" );
    Tcl_DStringAppendElement ( &dString, "GetStaticMesh" );
    Tcl_DStringAppendElement ( &dString, "SetParticleWriter" );
    Tcl_DStringAppendElement ( &dString, "GetParticleWriter" );
    Tcl_DStringAppendElement ( &dString, "SetParticleFileName" );
    Tcl_DStringAppendElement ( &dString, "GetParticleFileName" );
    Tcl_DStringAppendElement ( &dString, "SetEnableParticleWriting" );
    Tcl_DStringAppendElement ( &dString, "GetEnableParticleWriting" );
    Tcl_DStringAppendElement ( &dString, "EnableParticleWritingOn" );
    Tcl_DStringAppendElement ( &dString, "EnableParticleWritingOff" );
    Tcl_DStringAppendElement ( &dString, "SetDisableResetCache" );
    Tcl_DStringAppendElement ( &dString, "GetDisableResetCache" );
    Tcl_DStringAppendElement ( &dString, "DisableResetCacheOn" );
    Tcl_DStringAppendElement ( &dString, "DisableResetCacheOff" );
    Tcl_DStringAppendElement ( &dString, "AddSourceConnection" );
    Tcl_DStringAppendElement ( &dString, "RemoveAllSources" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkPolyDataAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PrintParticleHistories */
    if ( strcmp ( argv[2], "PrintParticleHistories" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PrintParticleHistories" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PrintParticleHistories */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void PrintParticleHistories();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for PrintParticleHistories */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetComputeVorticity */
    if ( strcmp ( argv[2], "GetComputeVorticity" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetComputeVorticity" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetComputeVorticity */
    Tcl_DStringAppendElement ( &dString, " Turn on/off vorticity computation at streamline points\n (necessary for generating proper stream-ribbons using the\n vtkRibbonFilter.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetComputeVorticity();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetComputeVorticity */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetComputeVorticity */
    if ( strcmp ( argv[2], "SetComputeVorticity" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetComputeVorticity" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetComputeVorticity */
    Tcl_DStringAppendElement ( &dString, " Turn on/off vorticity computation at streamline points\n (necessary for generating proper stream-ribbons using the\n vtkRibbonFilter.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetComputeVorticity(bool);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetComputeVorticity */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTerminalSpeed */
    if ( strcmp ( argv[2], "GetTerminalSpeed" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTerminalSpeed" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTerminalSpeed */
    Tcl_DStringAppendElement ( &dString, " Specify the terminal speed value, below which integration is terminated.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetTerminalSpeed();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetTerminalSpeed */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTerminalSpeed */
    if ( strcmp ( argv[2], "SetTerminalSpeed" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTerminalSpeed" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTerminalSpeed */
    Tcl_DStringAppendElement ( &dString, " Specify the terminal speed value, below which integration is terminated.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTerminalSpeed(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetTerminalSpeed */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRotationScale */
    if ( strcmp ( argv[2], "GetRotationScale" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRotationScale" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRotationScale */
    Tcl_DStringAppendElement ( &dString, " This can be used to scale the rate with which the streamribbons\n twist. The default is 1.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRotationScale();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetRotationScale */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRotationScale */
    if ( strcmp ( argv[2], "SetRotationScale" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRotationScale" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRotationScale */
    Tcl_DStringAppendElement ( &dString, " This can be used to scale the rate with which the streamribbons\n twist. The default is 1.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRotationScale(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetRotationScale */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetIgnorePipelineTime */
    if ( strcmp ( argv[2], "SetIgnorePipelineTime" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIgnorePipelineTime" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIgnorePipelineTime */
    Tcl_DStringAppendElement ( &dString, " To get around problems with the Paraview Animation controls\n we can just animate the time step and ignore the TIME_ requests\n" );
    Tcl_DStringAppendElement ( &dString, "void SetIgnorePipelineTime(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetIgnorePipelineTime */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetIgnorePipelineTime */
    if ( strcmp ( argv[2], "GetIgnorePipelineTime" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetIgnorePipelineTime" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetIgnorePipelineTime */
    Tcl_DStringAppendElement ( &dString, " To get around problems with the Paraview Animation controls\n we can just animate the time step and ignore the TIME_ requests\n" );
    Tcl_DStringAppendElement ( &dString, "int GetIgnorePipelineTime();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetIgnorePipelineTime */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IgnorePipelineTimeOn */
    if ( strcmp ( argv[2], "IgnorePipelineTimeOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IgnorePipelineTimeOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IgnorePipelineTimeOn */
    Tcl_DStringAppendElement ( &dString, " To get around problems with the Paraview Animation controls\n we can just animate the time step and ignore the TIME_ requests\n" );
    Tcl_DStringAppendElement ( &dString, "void IgnorePipelineTimeOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for IgnorePipelineTimeOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IgnorePipelineTimeOff */
    if ( strcmp ( argv[2], "IgnorePipelineTimeOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IgnorePipelineTimeOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IgnorePipelineTimeOff */
    Tcl_DStringAppendElement ( &dString, " To get around problems with the Paraview Animation controls\n we can just animate the time step and ignore the TIME_ requests\n" );
    Tcl_DStringAppendElement ( &dString, "void IgnorePipelineTimeOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for IgnorePipelineTimeOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetForceReinjectionEveryNSteps */
    if ( strcmp ( argv[2], "GetForceReinjectionEveryNSteps" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetForceReinjectionEveryNSteps" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetForceReinjectionEveryNSteps */
    Tcl_DStringAppendElement ( &dString, " When animating particles, it is nice to inject new ones every Nth step\n to produce a continuous flow. Setting ForceReinjectionEveryNSteps to a\n non zero value will cause the particle source to reinject particles\n every Nth step even if it is otherwise unchanged.\n Note that if the particle source is also animated, this flag will be\n redundant as the particles will be reinjected whenever the source changes\n anyway\n" );
    Tcl_DStringAppendElement ( &dString, "int GetForceReinjectionEveryNSteps();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetForceReinjectionEveryNSteps */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetForceReinjectionEveryNSteps */
    if ( strcmp ( argv[2], "SetForceReinjectionEveryNSteps" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetForceReinjectionEveryNSteps" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetForceReinjectionEveryNSteps */
    Tcl_DStringAppendElement ( &dString, " When animating particles, it is nice to inject new ones every Nth step\n to produce a continuous flow. Setting ForceReinjectionEveryNSteps to a\n non zero value will cause the particle source to reinject particles\n every Nth step even if it is otherwise unchanged.\n Note that if the particle source is also animated, this flag will be\n redundant as the particles will be reinjected whenever the source changes\n anyway\n" );
    Tcl_DStringAppendElement ( &dString, "void SetForceReinjectionEveryNSteps(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetForceReinjectionEveryNSteps */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTerminationTime */
    if ( strcmp ( argv[2], "SetTerminationTime" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTerminationTime" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTerminationTime */
    Tcl_DStringAppendElement ( &dString, " Setting TerminationTime to a positive value will cause particles\n to terminate when the time is reached. Use a vlue of zero to\n diable termination. The units of time should be consistent with the\n primary time variable.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTerminationTime(double t);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetTerminationTime */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTerminationTime */
    if ( strcmp ( argv[2], "GetTerminationTime" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTerminationTime" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTerminationTime */
    Tcl_DStringAppendElement ( &dString, " Setting TerminationTime to a positive value will cause particles\n to terminate when the time is reached. Use a vlue of zero to\n diable termination. The units of time should be consistent with the\n primary time variable.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetTerminationTime();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetTerminationTime */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetIntegrator */
    if ( strcmp ( argv[2], "SetIntegrator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIntegrator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkInitialValueProblemSolver" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIntegrator */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetIntegrator(vtkInitialValueProblemSolver *);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetIntegrator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetIntegrator */
    if ( strcmp ( argv[2], "GetIntegrator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetIntegrator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetIntegrator */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkInitialValueProblemSolver *GetIntegrator();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetIntegrator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetIntegratorType */
    if ( strcmp ( argv[2], "SetIntegratorType" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIntegratorType" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIntegratorType */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetIntegratorType(int type);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetIntegratorType */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetIntegratorType */
    if ( strcmp ( argv[2], "GetIntegratorType" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetIntegratorType" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetIntegratorType */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int GetIntegratorType();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetIntegratorType */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetStartTime */
    if ( strcmp ( argv[2], "GetStartTime" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetStartTime" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetStartTime */
    Tcl_DStringAppendElement ( &dString, " Set the time value for particle tracing to begin. The units of time should\n be consistent with the primary time variable.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetStartTime();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetStartTime */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetStartTime */
    if ( strcmp ( argv[2], "SetStartTime" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetStartTime" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetStartTime */
    Tcl_DStringAppendElement ( &dString, " Set the time value for particle tracing to begin. The units of time should\n be consistent with the primary time variable.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetStartTime(double t);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetStartTime */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetStaticSeeds */
    if ( strcmp ( argv[2], "SetStaticSeeds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetStaticSeeds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetStaticSeeds */
    Tcl_DStringAppendElement ( &dString, " if StaticSeeds is set and the mesh is static,\n then every time particles are injected we can re-use the same\n injection information. We classify particles according to\n processor just once before start.\n If StaticSeeds is set and a moving seed source is specified\n the motion will be ignored and results will not be as expected.\n The default is that StaticSeeds is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetStaticSeeds(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetStaticSeeds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetStaticSeeds */
    if ( strcmp ( argv[2], "GetStaticSeeds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetStaticSeeds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetStaticSeeds */
    Tcl_DStringAppendElement ( &dString, " if StaticSeeds is set and the mesh is static,\n then every time particles are injected we can re-use the same\n injection information. We classify particles according to\n processor just once before start.\n If StaticSeeds is set and a moving seed source is specified\n the motion will be ignored and results will not be as expected.\n The default is that StaticSeeds is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetStaticSeeds();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetStaticSeeds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetStaticMesh */
    if ( strcmp ( argv[2], "SetStaticMesh" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetStaticMesh" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetStaticMesh */
    Tcl_DStringAppendElement ( &dString, " if StaticMesh is set, many optimizations for cell caching\n can be assumed. if StaticMesh is not set, the algorithm\n will attempt to find out if optimizations can be used, but\n setting it to true will force all optimizations.\n Do not Set StaticMesh to true if a dynamic mesh is being used\n as this will invalidate all results.\n The default is that StaticMesh is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetStaticMesh(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetStaticMesh */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetStaticMesh */
    if ( strcmp ( argv[2], "GetStaticMesh" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetStaticMesh" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetStaticMesh */
    Tcl_DStringAppendElement ( &dString, " if StaticMesh is set, many optimizations for cell caching\n can be assumed. if StaticMesh is not set, the algorithm\n will attempt to find out if optimizations can be used, but\n setting it to true will force all optimizations.\n Do not Set StaticMesh to true if a dynamic mesh is being used\n as this will invalidate all results.\n The default is that StaticMesh is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetStaticMesh();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetStaticMesh */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetParticleWriter */
    if ( strcmp ( argv[2], "SetParticleWriter" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetParticleWriter" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractParticleWriter" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetParticleWriter */
    Tcl_DStringAppendElement ( &dString, " Set/Get the Writer associated with this Particle Tracer\n Ideally a parallel IO capable vtkH5PartWriter should be used\n which will collect particles from all parallel processes\n and write them to a single HDF5 file.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetParticleWriter(vtkAbstractParticleWriter *pw);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetParticleWriter */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetParticleWriter */
    if ( strcmp ( argv[2], "GetParticleWriter" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetParticleWriter" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetParticleWriter */
    Tcl_DStringAppendElement ( &dString, " Set/Get the Writer associated with this Particle Tracer\n Ideally a parallel IO capable vtkH5PartWriter should be used\n which will collect particles from all parallel processes\n and write them to a single HDF5 file.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractParticleWriter *GetParticleWriter();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetParticleWriter */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetParticleFileName */
    if ( strcmp ( argv[2], "SetParticleFileName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetParticleFileName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetParticleFileName */
    Tcl_DStringAppendElement ( &dString, " Set/Get the filename to be used with the particle writer when\n dumping particles to disk\n" );
    Tcl_DStringAppendElement ( &dString, "void SetParticleFileName(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetParticleFileName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetParticleFileName */
    if ( strcmp ( argv[2], "GetParticleFileName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetParticleFileName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetParticleFileName */
    Tcl_DStringAppendElement ( &dString, " Set/Get the filename to be used with the particle writer when\n dumping particles to disk\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetParticleFileName();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetParticleFileName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetEnableParticleWriting */
    if ( strcmp ( argv[2], "SetEnableParticleWriting" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetEnableParticleWriting" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetEnableParticleWriting */
    Tcl_DStringAppendElement ( &dString, " Set/Get the filename to be used with the particle writer when\n dumping particles to disk\n" );
    Tcl_DStringAppendElement ( &dString, "void SetEnableParticleWriting(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetEnableParticleWriting */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetEnableParticleWriting */
    if ( strcmp ( argv[2], "GetEnableParticleWriting" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetEnableParticleWriting" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetEnableParticleWriting */
    Tcl_DStringAppendElement ( &dString, " Set/Get the filename to be used with the particle writer when\n dumping particles to disk\n" );
    Tcl_DStringAppendElement ( &dString, "int GetEnableParticleWriting();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetEnableParticleWriting */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: EnableParticleWritingOn */
    if ( strcmp ( argv[2], "EnableParticleWritingOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "EnableParticleWritingOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for EnableParticleWritingOn */
    Tcl_DStringAppendElement ( &dString, " Set/Get the filename to be used with the particle writer when\n dumping particles to disk\n" );
    Tcl_DStringAppendElement ( &dString, "void EnableParticleWritingOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for EnableParticleWritingOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: EnableParticleWritingOff */
    if ( strcmp ( argv[2], "EnableParticleWritingOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "EnableParticleWritingOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for EnableParticleWritingOff */
    Tcl_DStringAppendElement ( &dString, " Set/Get the filename to be used with the particle writer when\n dumping particles to disk\n" );
    Tcl_DStringAppendElement ( &dString, "void EnableParticleWritingOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for EnableParticleWritingOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDisableResetCache */
    if ( strcmp ( argv[2], "SetDisableResetCache" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDisableResetCache" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDisableResetCache */
    Tcl_DStringAppendElement ( &dString, " Set/Get the flag to disable cache\n This is off by default and turned on in special circumstances\n such as in a coprocessing workflow\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDisableResetCache(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for SetDisableResetCache */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDisableResetCache */
    if ( strcmp ( argv[2], "GetDisableResetCache" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDisableResetCache" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDisableResetCache */
    Tcl_DStringAppendElement ( &dString, " Set/Get the flag to disable cache\n This is off by default and turned on in special circumstances\n such as in a coprocessing workflow\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDisableResetCache();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for GetDisableResetCache */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DisableResetCacheOn */
    if ( strcmp ( argv[2], "DisableResetCacheOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DisableResetCacheOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DisableResetCacheOn */
    Tcl_DStringAppendElement ( &dString, " Set/Get the flag to disable cache\n This is off by default and turned on in special circumstances\n such as in a coprocessing workflow\n" );
    Tcl_DStringAppendElement ( &dString, "void DisableResetCacheOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for DisableResetCacheOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DisableResetCacheOff */
    if ( strcmp ( argv[2], "DisableResetCacheOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DisableResetCacheOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DisableResetCacheOff */
    Tcl_DStringAppendElement ( &dString, " Set/Get the flag to disable cache\n This is off by default and turned on in special circumstances\n such as in a coprocessing workflow\n" );
    Tcl_DStringAppendElement ( &dString, "void DisableResetCacheOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for DisableResetCacheOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AddSourceConnection */
    if ( strcmp ( argv[2], "AddSourceConnection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AddSourceConnection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAlgorithmOutput" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AddSourceConnection */
    Tcl_DStringAppendElement ( &dString, " Provide support for multiple seed sources\n" );
    Tcl_DStringAppendElement ( &dString, "void AddSourceConnection(vtkAlgorithmOutput *input);" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for AddSourceConnection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RemoveAllSources */
    if ( strcmp ( argv[2], "RemoveAllSources" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveAllSources" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveAllSources */
    Tcl_DStringAppendElement ( &dString, " Provide support for multiple seed sources\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveAllSources();" );
    Tcl_DStringAppendElement ( &dString, "vtkParticleTracerBase" );
    /* Closing for RemoveAllSources */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkPolyDataAlgorithmCppCommand(static_cast<vtkPolyDataAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
