// tcl wrapper for vtkDeformPointSet object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkDeformPointSet.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkDeformPointSetNewCommand()
{
  vtkDeformPointSet *temp = vtkDeformPointSet::New();
  return static_cast<ClientData>(temp);
}

int vtkPointSetAlgorithmCppCommand(vtkPointSetAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkDeformPointSetCppCommand(vtkDeformPointSet *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkDeformPointSetCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkDeformPointSetCppCommand(static_cast<vtkDeformPointSet *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkDeformPointSet_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkDeformPointSet"),vtkDeformPointSetNewCommand,vtkDeformPointSetCommand);
  return 0;
}

int VTKTCL_EXPORT vtkDeformPointSetCppCommand(vtkDeformPointSet *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkDeformPointSet",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkPointSetAlgorithmCppCommand(static_cast<vtkPointSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkPointSetAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkDeformPointSet  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDeformPointSet");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkDeformPointSet  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDeformPointSet");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkDeformPointSet  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDeformPointSet");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetControlMeshData",argv[1]))&&(argc == 3))
  {
    vtkPolyData  *temp0;
    error = 0;

    temp0 = (vtkPolyData *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPolyData"),interp,error));
    if (!error)
  {
    op->SetControlMeshData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetControlMeshData",argv[1]))&&(argc == 2))
  {
    vtkPolyData  *temp20;
    temp20 = (op)->GetControlMeshData();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPolyData");
    return TCL_OK;
  }
  if ((!strcmp("SetControlMeshConnection",argv[1]))&&(argc == 3))
  {
    vtkAlgorithmOutput  *temp0;
    error = 0;

    temp0 = (vtkAlgorithmOutput *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAlgorithmOutput"),interp,error));
    if (!error)
  {
    op->SetControlMeshConnection(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetInitializeWeights",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetInitializeWeights(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetInitializeWeights",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetInitializeWeights();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("InitializeWeightsOn",argv[1]))&&(argc == 2))
  {
    op->InitializeWeightsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("InitializeWeightsOff",argv[1]))&&(argc == 2))
  {
    op->InitializeWeightsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkDeformPointSetCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkPointSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkDeformPointSet:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetControlMeshData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetControlMeshData\n",NULL);
    Tcl_AppendResult(interp,"  SetControlMeshConnection\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetInitializeWeights\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetInitializeWeights\n",NULL);
    Tcl_AppendResult(interp,"  InitializeWeightsOn\n",NULL);
    Tcl_AppendResult(interp,"  InitializeWeightsOff\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkPointSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetControlMeshData" );
    Tcl_DStringAppendElement ( &dString, "GetControlMeshData" );
    Tcl_DStringAppendElement ( &dString, "SetControlMeshConnection" );
    Tcl_DStringAppendElement ( &dString, "SetInitializeWeights" );
    Tcl_DStringAppendElement ( &dString, "GetInitializeWeights" );
    Tcl_DStringAppendElement ( &dString, "InitializeWeightsOn" );
    Tcl_DStringAppendElement ( &dString, "InitializeWeightsOff" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkPointSetAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiable (i.e., concrete) class.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkDeformPointSet *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiable (i.e., concrete) class.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiable (i.e., concrete) class.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiable (i.e., concrete) class.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiable (i.e., concrete) class.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetControlMeshData */
    if ( strcmp ( argv[2], "SetControlMeshData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetControlMeshData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPolyData" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetControlMeshData */
    Tcl_DStringAppendElement ( &dString, " Specify the control mesh to deform the input vtkPointSet. The control\n mesh must be a closed, non-self-intersecting, manifold mesh.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetControlMeshData(vtkPolyData *controlMesh);" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for SetControlMeshData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetControlMeshData */
    if ( strcmp ( argv[2], "GetControlMeshData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetControlMeshData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetControlMeshData */
    Tcl_DStringAppendElement ( &dString, " Specify the control mesh to deform the input vtkPointSet. The control\n mesh must be a closed, non-self-intersecting, manifold mesh.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPolyData *GetControlMeshData();" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for GetControlMeshData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetControlMeshConnection */
    if ( strcmp ( argv[2], "SetControlMeshConnection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetControlMeshConnection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAlgorithmOutput" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetControlMeshConnection */
    Tcl_DStringAppendElement ( &dString, " Specify the point locations used to probe input. Any geometry\n can be used. New style. Equivalent to SetInputConnection(1, algOutput).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetControlMeshConnection(vtkAlgorithmOutput *algOutput);" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for SetControlMeshConnection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetInitializeWeights */
    if ( strcmp ( argv[2], "SetInitializeWeights" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetInitializeWeights" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetInitializeWeights */
    Tcl_DStringAppendElement ( &dString, " Specify whether to regenerate interpolation weights or not. Initially\n the filter will reexecute no matter what this flag is set to (initial\n weights must be computed). Also, this flag is ignored if the number of\n input points/cells or the number of control mesh points/cells changes\n between executions. Thus flag is used to force reexecution and\n recomputation of weights.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetInitializeWeights(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for SetInitializeWeights */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetInitializeWeights */
    if ( strcmp ( argv[2], "GetInitializeWeights" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetInitializeWeights" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetInitializeWeights */
    Tcl_DStringAppendElement ( &dString, " Specify whether to regenerate interpolation weights or not. Initially\n the filter will reexecute no matter what this flag is set to (initial\n weights must be computed). Also, this flag is ignored if the number of\n input points/cells or the number of control mesh points/cells changes\n between executions. Thus flag is used to force reexecution and\n recomputation of weights.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetInitializeWeights();" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for GetInitializeWeights */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: InitializeWeightsOn */
    if ( strcmp ( argv[2], "InitializeWeightsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "InitializeWeightsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for InitializeWeightsOn */
    Tcl_DStringAppendElement ( &dString, " Specify whether to regenerate interpolation weights or not. Initially\n the filter will reexecute no matter what this flag is set to (initial\n weights must be computed). Also, this flag is ignored if the number of\n input points/cells or the number of control mesh points/cells changes\n between executions. Thus flag is used to force reexecution and\n recomputation of weights.\n" );
    Tcl_DStringAppendElement ( &dString, "void InitializeWeightsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for InitializeWeightsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: InitializeWeightsOff */
    if ( strcmp ( argv[2], "InitializeWeightsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "InitializeWeightsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for InitializeWeightsOff */
    Tcl_DStringAppendElement ( &dString, " Specify whether to regenerate interpolation weights or not. Initially\n the filter will reexecute no matter what this flag is set to (initial\n weights must be computed). Also, this flag is ignored if the number of\n input points/cells or the number of control mesh points/cells changes\n between executions. Thus flag is used to force reexecution and\n recomputation of weights.\n" );
    Tcl_DStringAppendElement ( &dString, "void InitializeWeightsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkDeformPointSet" );
    /* Closing for InitializeWeightsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkPointSetAlgorithmCppCommand(static_cast<vtkPointSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
