#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkCompositeDataGeometryFilter_TclCreate(Tcl_Interp *interp);
int vtkGeometryFilter_TclCreate(Tcl_Interp *interp);
int vtkHierarchicalDataSetGeometryFilter_TclCreate(Tcl_Interp *interp);
int vtkImageDataGeometryFilter_TclCreate(Tcl_Interp *interp);
int vtkImageDataToUniformGrid_TclCreate(Tcl_Interp *interp);
int vtkLinearToQuadraticCellsFilter_TclCreate(Tcl_Interp *interp);
int vtkProjectSphereFilter_TclCreate(Tcl_Interp *interp);
int vtkRectilinearGridGeometryFilter_TclCreate(Tcl_Interp *interp);
int vtkStructuredGridGeometryFilter_TclCreate(Tcl_Interp *interp);
int vtkStructuredPointsGeometryFilter_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridGeometryFilter_TclCreate(Tcl_Interp *interp);
int vtkDataSetSurfaceFilter_TclCreate(Tcl_Interp *interp);
int vtkDataSetRegionSurfaceFilter_TclCreate(Tcl_Interp *interp);
int vtkAbstractGridConnectivity_TclCreate(Tcl_Interp *interp);
int vtkDataSetGhostGenerator_TclCreate(Tcl_Interp *interp);
int vtkRectilinearGridPartitioner_TclCreate(Tcl_Interp *interp);
int vtkStructuredAMRGridConnectivity_TclCreate(Tcl_Interp *interp);
int vtkStructuredGridConnectivity_TclCreate(Tcl_Interp *interp);
int vtkStructuredGridGhostDataGenerator_TclCreate(Tcl_Interp *interp);
int vtkStructuredGridPartitioner_TclCreate(Tcl_Interp *interp);
int vtkUniformGridGhostDataGenerator_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkfiltersgeometrytcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkfiltersgeometrytcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkfiltersgeometrytcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkfiltersgeometrytcl_Init(interp);
}


int VTK_EXPORT Vtkfiltersgeometrytcl_Init(Tcl_Interp *interp)
{

  vtkCompositeDataGeometryFilter_TclCreate(interp);
  vtkGeometryFilter_TclCreate(interp);
  vtkHierarchicalDataSetGeometryFilter_TclCreate(interp);
  vtkImageDataGeometryFilter_TclCreate(interp);
  vtkImageDataToUniformGrid_TclCreate(interp);
  vtkLinearToQuadraticCellsFilter_TclCreate(interp);
  vtkProjectSphereFilter_TclCreate(interp);
  vtkRectilinearGridGeometryFilter_TclCreate(interp);
  vtkStructuredGridGeometryFilter_TclCreate(interp);
  vtkStructuredPointsGeometryFilter_TclCreate(interp);
  vtkUnstructuredGridGeometryFilter_TclCreate(interp);
  vtkDataSetSurfaceFilter_TclCreate(interp);
  vtkDataSetRegionSurfaceFilter_TclCreate(interp);
  vtkAbstractGridConnectivity_TclCreate(interp);
  vtkDataSetGhostGenerator_TclCreate(interp);
  vtkRectilinearGridPartitioner_TclCreate(interp);
  vtkStructuredAMRGridConnectivity_TclCreate(interp);
  vtkStructuredGridConnectivity_TclCreate(interp);
  vtkStructuredGridGhostDataGenerator_TclCreate(interp);
  vtkStructuredGridPartitioner_TclCreate(interp);
  vtkUniformGridGhostDataGenerator_TclCreate(interp);
  char pkgName[]="vtkFiltersGeometryTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
