#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkAdaptiveSubdivisionFilter_TclCreate(Tcl_Interp *interp);
int vtkBandedPolyDataContourFilter_TclCreate(Tcl_Interp *interp);
int vtkButterflySubdivisionFilter_TclCreate(Tcl_Interp *interp);
int vtkDijkstraGraphGeodesicPath_TclCreate(Tcl_Interp *interp);
int vtkDijkstraImageGeodesicPath_TclCreate(Tcl_Interp *interp);
int vtkFillHolesFilter_TclCreate(Tcl_Interp *interp);
int vtkGeodesicPath_TclCreate(Tcl_Interp *interp);
int vtkGraphGeodesicPath_TclCreate(Tcl_Interp *interp);
int vtkLinearExtrusionFilter_TclCreate(Tcl_Interp *interp);
int vtkLinearSubdivisionFilter_TclCreate(Tcl_Interp *interp);
int vtkLoopSubdivisionFilter_TclCreate(Tcl_Interp *interp);
int vtkPolyDataPointSampler_TclCreate(Tcl_Interp *interp);
int vtkProjectedTexture_TclCreate(Tcl_Interp *interp);
int vtkQuadRotationalExtrusionFilter_TclCreate(Tcl_Interp *interp);
int vtkRibbonFilter_TclCreate(Tcl_Interp *interp);
int vtkRotationalExtrusionFilter_TclCreate(Tcl_Interp *interp);
int vtkRuledSurfaceFilter_TclCreate(Tcl_Interp *interp);
int vtkSelectEnclosedPoints_TclCreate(Tcl_Interp *interp);
int vtkSelectPolyData_TclCreate(Tcl_Interp *interp);
int vtkSpherePuzzleArrows_TclCreate(Tcl_Interp *interp);
int vtkSpherePuzzle_TclCreate(Tcl_Interp *interp);
int vtkSubdivideTetra_TclCreate(Tcl_Interp *interp);
int vtkOutlineFilter_TclCreate(Tcl_Interp *interp);
int vtkSectorSource_TclCreate(Tcl_Interp *interp);
int vtkVolumeOfRevolutionFilter_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkfiltersmodelingtcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkfiltersmodelingtcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkfiltersmodelingtcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkfiltersmodelingtcl_Init(interp);
}


int VTK_EXPORT Vtkfiltersmodelingtcl_Init(Tcl_Interp *interp)
{

  vtkAdaptiveSubdivisionFilter_TclCreate(interp);
  vtkBandedPolyDataContourFilter_TclCreate(interp);
  vtkButterflySubdivisionFilter_TclCreate(interp);
  vtkDijkstraGraphGeodesicPath_TclCreate(interp);
  vtkDijkstraImageGeodesicPath_TclCreate(interp);
  vtkFillHolesFilter_TclCreate(interp);
  vtkGeodesicPath_TclCreate(interp);
  vtkGraphGeodesicPath_TclCreate(interp);
  vtkLinearExtrusionFilter_TclCreate(interp);
  vtkLinearSubdivisionFilter_TclCreate(interp);
  vtkLoopSubdivisionFilter_TclCreate(interp);
  vtkPolyDataPointSampler_TclCreate(interp);
  vtkProjectedTexture_TclCreate(interp);
  vtkQuadRotationalExtrusionFilter_TclCreate(interp);
  vtkRibbonFilter_TclCreate(interp);
  vtkRotationalExtrusionFilter_TclCreate(interp);
  vtkRuledSurfaceFilter_TclCreate(interp);
  vtkSelectEnclosedPoints_TclCreate(interp);
  vtkSelectPolyData_TclCreate(interp);
  vtkSpherePuzzleArrows_TclCreate(interp);
  vtkSpherePuzzle_TclCreate(interp);
  vtkSubdivideTetra_TclCreate(interp);
  vtkOutlineFilter_TclCreate(interp);
  vtkSectorSource_TclCreate(interp);
  vtkVolumeOfRevolutionFilter_TclCreate(interp);
  char pkgName[]="vtkFiltersModelingTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
