// tcl wrapper for vtkExtractCTHPart object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkExtractCTHPart.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkExtractCTHPartNewCommand()
{
  vtkExtractCTHPart *temp = vtkExtractCTHPart::New();
  return static_cast<ClientData>(temp);
}

int vtkMultiBlockDataSetAlgorithmCppCommand(vtkMultiBlockDataSetAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkExtractCTHPartCppCommand(vtkExtractCTHPart *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkExtractCTHPartCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkExtractCTHPartCppCommand(static_cast<vtkExtractCTHPart *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkExtractCTHPart_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkExtractCTHPart"),vtkExtractCTHPartNewCommand,vtkExtractCTHPartCommand);
  return 0;
}

int VTKTCL_EXPORT vtkExtractCTHPartCppCommand(vtkExtractCTHPart *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkExtractCTHPart",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkMultiBlockDataSetAlgorithmCppCommand(static_cast<vtkMultiBlockDataSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkMultiBlockDataSetAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkExtractCTHPart  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkExtractCTHPart");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkExtractCTHPart  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkExtractCTHPart");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkExtractCTHPart  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkExtractCTHPart");
    return TCL_OK;
  }
  }
  if ((!strcmp("AddVolumeArrayName",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->AddVolumeArrayName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("RemoveVolumeArrayNames",argv[1]))&&(argc == 2))
  {
    op->RemoveVolumeArrayNames();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfVolumeArrayNames",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfVolumeArrayNames();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetVolumeArrayName",argv[1]))&&(argc == 3))
  {
    int      temp0;
    const char    *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    temp20 = (op)->GetVolumeArrayName(temp0);
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("SetController",argv[1]))&&(argc == 3))
  {
    vtkMultiProcessController  *temp0;
    error = 0;

    temp0 = (vtkMultiProcessController *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkMultiProcessController"),interp,error));
    if (!error)
  {
    op->SetController(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetController",argv[1]))&&(argc == 2))
  {
    vtkMultiProcessController  *temp20;
    temp20 = (op)->GetController();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMultiProcessController");
    return TCL_OK;
  }
  if ((!strcmp("SetCapping",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetCapping(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCapping",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetCapping();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("CappingOn",argv[1]))&&(argc == 2))
  {
    op->CappingOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("CappingOff",argv[1]))&&(argc == 2))
  {
    op->CappingOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetGenerateTriangles",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetGenerateTriangles(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetGenerateTriangles",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetGenerateTriangles();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GenerateTrianglesOn",argv[1]))&&(argc == 2))
  {
    op->GenerateTrianglesOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GenerateTrianglesOff",argv[1]))&&(argc == 2))
  {
    op->GenerateTrianglesOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetRemoveGhostCells",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetRemoveGhostCells(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRemoveGhostCells",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetRemoveGhostCells();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("RemoveGhostCellsOn",argv[1]))&&(argc == 2))
  {
    op->RemoveGhostCellsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("RemoveGhostCellsOff",argv[1]))&&(argc == 2))
  {
    op->RemoveGhostCellsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetClipPlane",argv[1]))&&(argc == 3))
  {
    vtkPlane  *temp0;
    error = 0;

    temp0 = (vtkPlane *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPlane"),interp,error));
    if (!error)
  {
    op->SetClipPlane(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetClipPlane",argv[1]))&&(argc == 2))
  {
    vtkPlane  *temp20;
    temp20 = (op)->GetClipPlane();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPlane");
    return TCL_OK;
  }
  if ((!strcmp("GetMTime",argv[1]))&&(argc == 2))
  {
    unsigned long long   temp20;
    temp20 = (op)->GetMTime();
    char tempResult[1024];
    sprintf(tempResult,"%llu",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetVolumeFractionSurfaceValue",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetVolumeFractionSurfaceValue(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetVolumeFractionSurfaceValueMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetVolumeFractionSurfaceValueMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetVolumeFractionSurfaceValueMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetVolumeFractionSurfaceValueMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetVolumeFractionSurfaceValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetVolumeFractionSurfaceValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkExtractCTHPartCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkMultiBlockDataSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkExtractCTHPart:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  AddVolumeArrayName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RemoveVolumeArrayNames\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfVolumeArrayNames\n",NULL);
    Tcl_AppendResult(interp,"  GetVolumeArrayName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetController\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetController\n",NULL);
    Tcl_AppendResult(interp,"  SetCapping\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCapping\n",NULL);
    Tcl_AppendResult(interp,"  CappingOn\n",NULL);
    Tcl_AppendResult(interp,"  CappingOff\n",NULL);
    Tcl_AppendResult(interp,"  SetGenerateTriangles\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetGenerateTriangles\n",NULL);
    Tcl_AppendResult(interp,"  GenerateTrianglesOn\n",NULL);
    Tcl_AppendResult(interp,"  GenerateTrianglesOff\n",NULL);
    Tcl_AppendResult(interp,"  SetRemoveGhostCells\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRemoveGhostCells\n",NULL);
    Tcl_AppendResult(interp,"  RemoveGhostCellsOn\n",NULL);
    Tcl_AppendResult(interp,"  RemoveGhostCellsOff\n",NULL);
    Tcl_AppendResult(interp,"  SetClipPlane\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetClipPlane\n",NULL);
    Tcl_AppendResult(interp,"  GetMTime\n",NULL);
    Tcl_AppendResult(interp,"  SetVolumeFractionSurfaceValue\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetVolumeFractionSurfaceValueMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetVolumeFractionSurfaceValueMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetVolumeFractionSurfaceValue\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkMultiBlockDataSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "AddVolumeArrayName" );
    Tcl_DStringAppendElement ( &dString, "RemoveVolumeArrayNames" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfVolumeArrayNames" );
    Tcl_DStringAppendElement ( &dString, "GetVolumeArrayName" );
    Tcl_DStringAppendElement ( &dString, "SetController" );
    Tcl_DStringAppendElement ( &dString, "GetController" );
    Tcl_DStringAppendElement ( &dString, "SetCapping" );
    Tcl_DStringAppendElement ( &dString, "GetCapping" );
    Tcl_DStringAppendElement ( &dString, "CappingOn" );
    Tcl_DStringAppendElement ( &dString, "CappingOff" );
    Tcl_DStringAppendElement ( &dString, "SetGenerateTriangles" );
    Tcl_DStringAppendElement ( &dString, "GetGenerateTriangles" );
    Tcl_DStringAppendElement ( &dString, "GenerateTrianglesOn" );
    Tcl_DStringAppendElement ( &dString, "GenerateTrianglesOff" );
    Tcl_DStringAppendElement ( &dString, "SetRemoveGhostCells" );
    Tcl_DStringAppendElement ( &dString, "GetRemoveGhostCells" );
    Tcl_DStringAppendElement ( &dString, "RemoveGhostCellsOn" );
    Tcl_DStringAppendElement ( &dString, "RemoveGhostCellsOff" );
    Tcl_DStringAppendElement ( &dString, "SetClipPlane" );
    Tcl_DStringAppendElement ( &dString, "GetClipPlane" );
    Tcl_DStringAppendElement ( &dString, "GetMTime" );
    Tcl_DStringAppendElement ( &dString, "SetVolumeFractionSurfaceValue" );
    Tcl_DStringAppendElement ( &dString, "GetVolumeFractionSurfaceValueMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetVolumeFractionSurfaceValueMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetVolumeFractionSurfaceValue" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkMultiBlockDataSetAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkExtractCTHPart *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AddVolumeArrayName */
    if ( strcmp ( argv[2], "AddVolumeArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AddVolumeArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AddVolumeArrayName */
    Tcl_DStringAppendElement ( &dString, " Select cell-data arrays (volume-fraction arrays) to contour with.\n" );
    Tcl_DStringAppendElement ( &dString, "void AddVolumeArrayName(const char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for AddVolumeArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RemoveVolumeArrayNames */
    if ( strcmp ( argv[2], "RemoveVolumeArrayNames" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveVolumeArrayNames" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveVolumeArrayNames */
    Tcl_DStringAppendElement ( &dString, " Select cell-data arrays (volume-fraction arrays) to contour with.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveVolumeArrayNames();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for RemoveVolumeArrayNames */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfVolumeArrayNames */
    if ( strcmp ( argv[2], "GetNumberOfVolumeArrayNames" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfVolumeArrayNames" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfVolumeArrayNames */
    Tcl_DStringAppendElement ( &dString, " Select cell-data arrays (volume-fraction arrays) to contour with.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfVolumeArrayNames();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetNumberOfVolumeArrayNames */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetVolumeArrayName */
    if ( strcmp ( argv[2], "GetVolumeArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVolumeArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVolumeArrayName */
    Tcl_DStringAppendElement ( &dString, " Select cell-data arrays (volume-fraction arrays) to contour with.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetVolumeArrayName(int idx);" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetVolumeArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetController */
    if ( strcmp ( argv[2], "SetController" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetController" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkMultiProcessController" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetController */
    Tcl_DStringAppendElement ( &dString, " Get/Set the parallel controller. By default, the value returned by\n vtkMultiBlockDataSetAlgorithm::GetGlobalController() when the object is\n instantiated is used.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetController(vtkMultiProcessController *controller);" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for SetController */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetController */
    if ( strcmp ( argv[2], "GetController" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetController" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetController */
    Tcl_DStringAppendElement ( &dString, " Get/Set the parallel controller. By default, the value returned by\n vtkMultiBlockDataSetAlgorithm::GetGlobalController() when the object is\n instantiated is used.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkMultiProcessController *GetController();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetController */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetCapping */
    if ( strcmp ( argv[2], "SetCapping" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCapping" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCapping */
    Tcl_DStringAppendElement ( &dString, " On by default, enables logic to cap the material volume.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetCapping(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for SetCapping */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCapping */
    if ( strcmp ( argv[2], "GetCapping" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCapping" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCapping */
    Tcl_DStringAppendElement ( &dString, " On by default, enables logic to cap the material volume.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetCapping();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetCapping */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: CappingOn */
    if ( strcmp ( argv[2], "CappingOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CappingOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CappingOn */
    Tcl_DStringAppendElement ( &dString, " On by default, enables logic to cap the material volume.\n" );
    Tcl_DStringAppendElement ( &dString, "void CappingOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for CappingOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: CappingOff */
    if ( strcmp ( argv[2], "CappingOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CappingOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CappingOff */
    Tcl_DStringAppendElement ( &dString, " On by default, enables logic to cap the material volume.\n" );
    Tcl_DStringAppendElement ( &dString, "void CappingOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for CappingOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetGenerateTriangles */
    if ( strcmp ( argv[2], "SetGenerateTriangles" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGenerateTriangles" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGenerateTriangles */
    Tcl_DStringAppendElement ( &dString, " Triangulate results. When set to false, the internal cut and contour filters\n are told not to triangulate results if possible. true by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetGenerateTriangles(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for SetGenerateTriangles */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetGenerateTriangles */
    if ( strcmp ( argv[2], "GetGenerateTriangles" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetGenerateTriangles" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetGenerateTriangles */
    Tcl_DStringAppendElement ( &dString, " Triangulate results. When set to false, the internal cut and contour filters\n are told not to triangulate results if possible. true by default.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetGenerateTriangles();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetGenerateTriangles */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GenerateTrianglesOn */
    if ( strcmp ( argv[2], "GenerateTrianglesOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GenerateTrianglesOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GenerateTrianglesOn */
    Tcl_DStringAppendElement ( &dString, " Triangulate results. When set to false, the internal cut and contour filters\n are told not to triangulate results if possible. true by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void GenerateTrianglesOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GenerateTrianglesOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GenerateTrianglesOff */
    if ( strcmp ( argv[2], "GenerateTrianglesOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GenerateTrianglesOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GenerateTrianglesOff */
    Tcl_DStringAppendElement ( &dString, " Triangulate results. When set to false, the internal cut and contour filters\n are told not to triangulate results if possible. true by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void GenerateTrianglesOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GenerateTrianglesOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRemoveGhostCells */
    if ( strcmp ( argv[2], "SetRemoveGhostCells" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRemoveGhostCells" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRemoveGhostCells */
    Tcl_DStringAppendElement ( &dString, " When set to false, the output surfaces will not hide contours extracted from\n ghost cells. This results in overlapping contours but overcomes holes.\n Default is set to true.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRemoveGhostCells(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for SetRemoveGhostCells */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRemoveGhostCells */
    if ( strcmp ( argv[2], "GetRemoveGhostCells" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRemoveGhostCells" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRemoveGhostCells */
    Tcl_DStringAppendElement ( &dString, " When set to false, the output surfaces will not hide contours extracted from\n ghost cells. This results in overlapping contours but overcomes holes.\n Default is set to true.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetRemoveGhostCells();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetRemoveGhostCells */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RemoveGhostCellsOn */
    if ( strcmp ( argv[2], "RemoveGhostCellsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveGhostCellsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveGhostCellsOn */
    Tcl_DStringAppendElement ( &dString, " When set to false, the output surfaces will not hide contours extracted from\n ghost cells. This results in overlapping contours but overcomes holes.\n Default is set to true.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveGhostCellsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for RemoveGhostCellsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RemoveGhostCellsOff */
    if ( strcmp ( argv[2], "RemoveGhostCellsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveGhostCellsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveGhostCellsOff */
    Tcl_DStringAppendElement ( &dString, " When set to false, the output surfaces will not hide contours extracted from\n ghost cells. This results in overlapping contours but overcomes holes.\n Default is set to true.\n" );
    Tcl_DStringAppendElement ( &dString, "void RemoveGhostCellsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for RemoveGhostCellsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetClipPlane */
    if ( strcmp ( argv[2], "SetClipPlane" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetClipPlane" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPlane" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetClipPlane */
    Tcl_DStringAppendElement ( &dString, " Set, get or manipulate the implicit clipping plane.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetClipPlane(vtkPlane *clipPlane);" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for SetClipPlane */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClipPlane */
    if ( strcmp ( argv[2], "GetClipPlane" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClipPlane" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClipPlane */
    Tcl_DStringAppendElement ( &dString, " Set, get or manipulate the implicit clipping plane.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPlane *GetClipPlane();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetClipPlane */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMTime */
    if ( strcmp ( argv[2], "GetMTime" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMTime" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMTime */
    Tcl_DStringAppendElement ( &dString, " Look at clip plane to compute MTime.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkMTimeType GetMTime();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetMTime */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetVolumeFractionSurfaceValue */
    if ( strcmp ( argv[2], "SetVolumeFractionSurfaceValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetVolumeFractionSurfaceValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetVolumeFractionSurfaceValue */
    Tcl_DStringAppendElement ( &dString, " Set and get the volume fraction surface value. This value should be\n between 0 and 1\n" );
    Tcl_DStringAppendElement ( &dString, "void SetVolumeFractionSurfaceValue(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for SetVolumeFractionSurfaceValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetVolumeFractionSurfaceValueMinValue */
    if ( strcmp ( argv[2], "GetVolumeFractionSurfaceValueMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVolumeFractionSurfaceValueMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVolumeFractionSurfaceValueMinValue */
    Tcl_DStringAppendElement ( &dString, " Set and get the volume fraction surface value. This value should be\n between 0 and 1\n" );
    Tcl_DStringAppendElement ( &dString, "double GetVolumeFractionSurfaceValueMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetVolumeFractionSurfaceValueMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetVolumeFractionSurfaceValueMaxValue */
    if ( strcmp ( argv[2], "GetVolumeFractionSurfaceValueMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVolumeFractionSurfaceValueMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVolumeFractionSurfaceValueMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set and get the volume fraction surface value. This value should be\n between 0 and 1\n" );
    Tcl_DStringAppendElement ( &dString, "double GetVolumeFractionSurfaceValueMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetVolumeFractionSurfaceValueMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetVolumeFractionSurfaceValue */
    if ( strcmp ( argv[2], "GetVolumeFractionSurfaceValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetVolumeFractionSurfaceValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetVolumeFractionSurfaceValue */
    Tcl_DStringAppendElement ( &dString, " Set and get the volume fraction surface value. This value should be\n between 0 and 1\n" );
    Tcl_DStringAppendElement ( &dString, "double GetVolumeFractionSurfaceValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkExtractCTHPart" );
    /* Closing for GetVolumeFractionSurfaceValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkMultiBlockDataSetAlgorithmCppCommand(static_cast<vtkMultiBlockDataSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
