// tcl wrapper for vtkPeriodicFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPeriodicFilter.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>
int vtkMultiBlockDataSetAlgorithmCppCommand(vtkMultiBlockDataSetAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkPeriodicFilterCppCommand(vtkPeriodicFilter *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkPeriodicFilterCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkPeriodicFilterCppCommand(static_cast<vtkPeriodicFilter *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkPeriodicFilter_TclCreate(Tcl_Interp *interp)
{
  (void)interp;
  return 0;
}

int VTKTCL_EXPORT vtkPeriodicFilterCppCommand(vtkPeriodicFilter *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkPeriodicFilter",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkMultiBlockDataSetAlgorithmCppCommand(static_cast<vtkMultiBlockDataSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkMultiBlockDataSetAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkPeriodicFilter  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPeriodicFilter");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkPeriodicFilter  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPeriodicFilter");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetIterationMode",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetIterationMode(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetIterationModeMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetIterationModeMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetIterationModeMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetIterationModeMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetIterationMode",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetIterationMode();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetIterationModeToDirectNb",argv[1]))&&(argc == 2))
  {
    op->SetIterationModeToDirectNb();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetIterationModeToMax",argv[1]))&&(argc == 2))
  {
    op->SetIterationModeToMax();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetNumberOfPeriods",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNumberOfPeriods(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfPeriods",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfPeriods();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("AddIndex",argv[1]))&&(argc == 3))
  {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
  {
    op->AddIndex(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("RemoveIndex",argv[1]))&&(argc == 3))
  {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
  {
    op->RemoveIndex(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("RemoveAllIndices",argv[1]))&&(argc == 2))
  {
    op->RemoveAllIndices();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkPeriodicFilterCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkMultiBlockDataSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkPeriodicFilter:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetIterationMode\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetIterationModeMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetIterationModeMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetIterationMode\n",NULL);
    Tcl_AppendResult(interp,"  SetIterationModeToDirectNb\n",NULL);
    Tcl_AppendResult(interp,"  SetIterationModeToMax\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfPeriods\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfPeriods\n",NULL);
    Tcl_AppendResult(interp,"  AddIndex\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RemoveIndex\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RemoveAllIndices\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkMultiBlockDataSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetIterationMode" );
    Tcl_DStringAppendElement ( &dString, "GetIterationModeMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetIterationModeMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetIterationMode" );
    Tcl_DStringAppendElement ( &dString, "SetIterationModeToDirectNb" );
    Tcl_DStringAppendElement ( &dString, "SetIterationModeToMax" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfPeriods" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPeriods" );
    Tcl_DStringAppendElement ( &dString, "AddIndex" );
    Tcl_DStringAppendElement ( &dString, "RemoveIndex" );
    Tcl_DStringAppendElement ( &dString, "RemoveAllIndices" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkMultiBlockDataSetAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetIterationMode */
    if ( strcmp ( argv[2], "SetIterationMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIterationMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIterationMode */
    Tcl_DStringAppendElement ( &dString, " Set/Get Iteration mode.\n VTK_ITERATION_MODE_DIRECT_NB to specify the number of periods,\n VTK_ITERATION_MODE_MAX to generate a full period (default).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetIterationMode(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for SetIterationMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetIterationModeMinValue */
    if ( strcmp ( argv[2], "GetIterationModeMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetIterationModeMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetIterationModeMinValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get Iteration mode.\n VTK_ITERATION_MODE_DIRECT_NB to specify the number of periods,\n VTK_ITERATION_MODE_MAX to generate a full period (default).\n" );
    Tcl_DStringAppendElement ( &dString, "int GetIterationModeMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for GetIterationModeMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetIterationModeMaxValue */
    if ( strcmp ( argv[2], "GetIterationModeMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetIterationModeMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetIterationModeMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get Iteration mode.\n VTK_ITERATION_MODE_DIRECT_NB to specify the number of periods,\n VTK_ITERATION_MODE_MAX to generate a full period (default).\n" );
    Tcl_DStringAppendElement ( &dString, "int GetIterationModeMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for GetIterationModeMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetIterationMode */
    if ( strcmp ( argv[2], "GetIterationMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetIterationMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetIterationMode */
    Tcl_DStringAppendElement ( &dString, " Set/Get Iteration mode.\n VTK_ITERATION_MODE_DIRECT_NB to specify the number of periods,\n VTK_ITERATION_MODE_MAX to generate a full period (default).\n" );
    Tcl_DStringAppendElement ( &dString, "int GetIterationMode();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for GetIterationMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetIterationModeToDirectNb */
    if ( strcmp ( argv[2], "SetIterationModeToDirectNb" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIterationModeToDirectNb" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIterationModeToDirectNb */
    Tcl_DStringAppendElement ( &dString, " Set/Get Iteration mode.\n VTK_ITERATION_MODE_DIRECT_NB to specify the number of periods,\n VTK_ITERATION_MODE_MAX to generate a full period (default).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetIterationModeToDirectNb();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for SetIterationModeToDirectNb */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetIterationModeToMax */
    if ( strcmp ( argv[2], "SetIterationModeToMax" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetIterationModeToMax" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetIterationModeToMax */
    Tcl_DStringAppendElement ( &dString, " Set/Get Iteration mode.\n VTK_ITERATION_MODE_DIRECT_NB to specify the number of periods,\n VTK_ITERATION_MODE_MAX to generate a full period (default).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetIterationModeToMax();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for SetIterationModeToMax */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfPeriods */
    if ( strcmp ( argv[2], "SetNumberOfPeriods" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfPeriods" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfPeriods */
    Tcl_DStringAppendElement ( &dString, " Set/Get Number of periods.\n Used only with ITERATION_MODE_DIRECT_NB.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNumberOfPeriods(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for SetNumberOfPeriods */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfPeriods */
    if ( strcmp ( argv[2], "GetNumberOfPeriods" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPeriods" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfPeriods */
    Tcl_DStringAppendElement ( &dString, " Set/Get Number of periods.\n Used only with ITERATION_MODE_DIRECT_NB.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfPeriods();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for GetNumberOfPeriods */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AddIndex */
    if ( strcmp ( argv[2], "AddIndex" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AddIndex" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AddIndex */
    Tcl_DStringAppendElement ( &dString, " Select the periodic pieces indices.\n Each node in the multi - block tree is identified by an \\c index. The index can\n be obtained by performing a preorder traversal of the tree (including empty\n nodes). eg. A(B (D, E), C(F, G)).\n Inorder traversal yields: A, B, D, E, C, F, G\n Index of A is 0, while index of C is 4.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void AddIndex(unsigned int index);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for AddIndex */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RemoveIndex */
    if ( strcmp ( argv[2], "RemoveIndex" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveIndex" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveIndex */
    Tcl_DStringAppendElement ( &dString, " Remove an index from selected indices tress\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void RemoveIndex(unsigned int index);" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for RemoveIndex */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RemoveAllIndices */
    if ( strcmp ( argv[2], "RemoveAllIndices" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RemoveAllIndices" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RemoveAllIndices */
    Tcl_DStringAppendElement ( &dString, " Clear selected indices tree\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void RemoveAllIndices();" );
    Tcl_DStringAppendElement ( &dString, "vtkPeriodicFilter" );
    /* Closing for RemoveAllIndices */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkMultiBlockDataSetAlgorithmCppCommand(static_cast<vtkMultiBlockDataSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
