// tcl wrapper for vtkEllipsoidalGaussianKernel object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkEllipsoidalGaussianKernel.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkEllipsoidalGaussianKernelNewCommand()
{
  vtkEllipsoidalGaussianKernel *temp = vtkEllipsoidalGaussianKernel::New();
  return static_cast<ClientData>(temp);
}

int vtkGeneralizedKernelCppCommand(vtkGeneralizedKernel *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkEllipsoidalGaussianKernelCppCommand(vtkEllipsoidalGaussianKernel *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkEllipsoidalGaussianKernelCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkEllipsoidalGaussianKernelCppCommand(static_cast<vtkEllipsoidalGaussianKernel *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkEllipsoidalGaussianKernel_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkEllipsoidalGaussianKernel"),vtkEllipsoidalGaussianKernelNewCommand,vtkEllipsoidalGaussianKernelCommand);
  return 0;
}

int VTKTCL_EXPORT vtkEllipsoidalGaussianKernelCppCommand(vtkEllipsoidalGaussianKernel *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkEllipsoidalGaussianKernel",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkGeneralizedKernelCppCommand(static_cast<vtkGeneralizedKernel *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkGeneralizedKernel"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkEllipsoidalGaussianKernel  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkEllipsoidalGaussianKernel");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkEllipsoidalGaussianKernel  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkEllipsoidalGaussianKernel");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkEllipsoidalGaussianKernel  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkEllipsoidalGaussianKernel");
    return TCL_OK;
  }
  }
  if ((!strcmp("Initialize",argv[1]))&&(argc == 5))
  {
    vtkAbstractPointLocator  *temp0;
    vtkDataSet  *temp1;
    vtkPointData  *temp2;
    error = 0;

    temp0 = (vtkAbstractPointLocator *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPointLocator"),interp,error));
    temp1 = (vtkDataSet *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkDataSet"),interp,error));
    temp2 = (vtkPointData *)(vtkTclGetPointerFromObject(argv[4],const_cast<char *>("vtkPointData"),interp,error));
    if (!error)
  {
    op->Initialize(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetUseNormals",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetUseNormals(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetUseNormals",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetUseNormals();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("UseNormalsOn",argv[1]))&&(argc == 2))
  {
    op->UseNormalsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("UseNormalsOff",argv[1]))&&(argc == 2))
  {
    op->UseNormalsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetNormalsArrayName",argv[1]))&&(argc == 3))
  {
    vtkStdString   temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetNormalsArrayName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNormalsArrayName",argv[1]))&&(argc == 2))
  {
    vtkStdString   temp20;
    temp20 = (op)->GetNormalsArrayName();
    Tcl_SetResult(interp, const_cast<char *>(temp20.c_str()), TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetUseScalars",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetUseScalars(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetUseScalars",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetUseScalars();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("UseScalarsOn",argv[1]))&&(argc == 2))
  {
    op->UseScalarsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("UseScalarsOff",argv[1]))&&(argc == 2))
  {
    op->UseScalarsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetScalarsArrayName",argv[1]))&&(argc == 3))
  {
    vtkStdString   temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetScalarsArrayName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetScalarsArrayName",argv[1]))&&(argc == 2))
  {
    vtkStdString   temp20;
    temp20 = (op)->GetScalarsArrayName();
    Tcl_SetResult(interp, const_cast<char *>(temp20.c_str()), TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetScaleFactor",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetScaleFactor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetScaleFactorMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetScaleFactorMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetScaleFactorMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetScaleFactorMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetScaleFactor",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetScaleFactor();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetSharpness",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetSharpness(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSharpnessMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSharpnessMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSharpnessMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSharpnessMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSharpness",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSharpness();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetEccentricity",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetEccentricity(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetEccentricityMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetEccentricityMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetEccentricityMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetEccentricityMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetEccentricity",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetEccentricity();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkEllipsoidalGaussianKernelCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkGeneralizedKernelCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkEllipsoidalGaussianKernel:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Initialize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetUseNormals\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetUseNormals\n",NULL);
    Tcl_AppendResult(interp,"  UseNormalsOn\n",NULL);
    Tcl_AppendResult(interp,"  UseNormalsOff\n",NULL);
    Tcl_AppendResult(interp,"  SetNormalsArrayName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNormalsArrayName\n",NULL);
    Tcl_AppendResult(interp,"  SetUseScalars\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetUseScalars\n",NULL);
    Tcl_AppendResult(interp,"  UseScalarsOn\n",NULL);
    Tcl_AppendResult(interp,"  UseScalarsOff\n",NULL);
    Tcl_AppendResult(interp,"  SetScalarsArrayName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetScalarsArrayName\n",NULL);
    Tcl_AppendResult(interp,"  SetScaleFactor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetScaleFactorMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetScaleFactorMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetScaleFactor\n",NULL);
    Tcl_AppendResult(interp,"  SetSharpness\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSharpnessMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSharpnessMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSharpness\n",NULL);
    Tcl_AppendResult(interp,"  SetEccentricity\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetEccentricityMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetEccentricityMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetEccentricity\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkGeneralizedKernelCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "Initialize" );
    Tcl_DStringAppendElement ( &dString, "SetUseNormals" );
    Tcl_DStringAppendElement ( &dString, "GetUseNormals" );
    Tcl_DStringAppendElement ( &dString, "UseNormalsOn" );
    Tcl_DStringAppendElement ( &dString, "UseNormalsOff" );
    Tcl_DStringAppendElement ( &dString, "SetNormalsArrayName" );
    Tcl_DStringAppendElement ( &dString, "GetNormalsArrayName" );
    Tcl_DStringAppendElement ( &dString, "SetUseScalars" );
    Tcl_DStringAppendElement ( &dString, "GetUseScalars" );
    Tcl_DStringAppendElement ( &dString, "UseScalarsOn" );
    Tcl_DStringAppendElement ( &dString, "UseScalarsOff" );
    Tcl_DStringAppendElement ( &dString, "SetScalarsArrayName" );
    Tcl_DStringAppendElement ( &dString, "GetScalarsArrayName" );
    Tcl_DStringAppendElement ( &dString, "SetScaleFactor" );
    Tcl_DStringAppendElement ( &dString, "GetScaleFactorMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetScaleFactorMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetScaleFactor" );
    Tcl_DStringAppendElement ( &dString, "SetSharpness" );
    Tcl_DStringAppendElement ( &dString, "GetSharpnessMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetSharpnessMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetSharpness" );
    Tcl_DStringAppendElement ( &dString, "SetEccentricity" );
    Tcl_DStringAppendElement ( &dString, "GetEccentricityMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetEccentricityMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetEccentricity" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkGeneralizedKernelCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiation, obtaining type information, and printing.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkEllipsoidalGaussianKernel *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiation, obtaining type information, and printing.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiation, obtaining type information, and printing.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiation, obtaining type information, and printing.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiation, obtaining type information, and printing.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Initialize */
    if ( strcmp ( argv[2], "Initialize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Initialize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPointLocator" );
    Tcl_DStringAppendElement ( &dString, "vtkDataSet" );
    Tcl_DStringAppendElement ( &dString, "vtkPointData" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Initialize */
    Tcl_DStringAppendElement ( &dString, " Initialize the kernel. Overload the superclass to set up scalars and\n vectors.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void Initialize(vtkAbstractPointLocator *loc, vtkDataSet *ds, vtkPointData *pd);" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for Initialize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetUseNormals */
    if ( strcmp ( argv[2], "SetUseNormals" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUseNormals" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUseNormals */
    Tcl_DStringAppendElement ( &dString, " Specify whether vector values should be used to affect the shape\n of the Gaussian distribution. By default this is on.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetUseNormals(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for SetUseNormals */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetUseNormals */
    if ( strcmp ( argv[2], "GetUseNormals" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetUseNormals" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetUseNormals */
    Tcl_DStringAppendElement ( &dString, " Specify whether vector values should be used to affect the shape\n of the Gaussian distribution. By default this is on.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetUseNormals();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetUseNormals */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: UseNormalsOn */
    if ( strcmp ( argv[2], "UseNormalsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseNormalsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseNormalsOn */
    Tcl_DStringAppendElement ( &dString, " Specify whether vector values should be used to affect the shape\n of the Gaussian distribution. By default this is on.\n" );
    Tcl_DStringAppendElement ( &dString, "void UseNormalsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for UseNormalsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: UseNormalsOff */
    if ( strcmp ( argv[2], "UseNormalsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseNormalsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseNormalsOff */
    Tcl_DStringAppendElement ( &dString, " Specify whether vector values should be used to affect the shape\n of the Gaussian distribution. By default this is on.\n" );
    Tcl_DStringAppendElement ( &dString, "void UseNormalsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for UseNormalsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNormalsArrayName */
    if ( strcmp ( argv[2], "SetNormalsArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNormalsArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNormalsArrayName */
    Tcl_DStringAppendElement ( &dString, " Specify the normals array name. Used to orient the ellipsoid. Note that\n by default the input normals are used (i.e. the input to\n vtkPointInterpolator). If no input normals are available, then the named\n NormalsArrayName is used.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNormalsArrayName(vtkStdString a);" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for SetNormalsArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNormalsArrayName */
    if ( strcmp ( argv[2], "GetNormalsArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNormalsArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNormalsArrayName */
    Tcl_DStringAppendElement ( &dString, " Specify the normals array name. Used to orient the ellipsoid. Note that\n by default the input normals are used (i.e. the input to\n vtkPointInterpolator). If no input normals are available, then the named\n NormalsArrayName is used.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkStdString GetNormalsArrayName();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetNormalsArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetUseScalars */
    if ( strcmp ( argv[2], "SetUseScalars" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUseScalars" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUseScalars */
    Tcl_DStringAppendElement ( &dString, " Specify whether scalar values should be used to scale the weights.\n By default this is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetUseScalars(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for SetUseScalars */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetUseScalars */
    if ( strcmp ( argv[2], "GetUseScalars" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetUseScalars" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetUseScalars */
    Tcl_DStringAppendElement ( &dString, " Specify whether scalar values should be used to scale the weights.\n By default this is off.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetUseScalars();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetUseScalars */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: UseScalarsOn */
    if ( strcmp ( argv[2], "UseScalarsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseScalarsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseScalarsOn */
    Tcl_DStringAppendElement ( &dString, " Specify whether scalar values should be used to scale the weights.\n By default this is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void UseScalarsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for UseScalarsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: UseScalarsOff */
    if ( strcmp ( argv[2], "UseScalarsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UseScalarsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UseScalarsOff */
    Tcl_DStringAppendElement ( &dString, " Specify whether scalar values should be used to scale the weights.\n By default this is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void UseScalarsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for UseScalarsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetScalarsArrayName */
    if ( strcmp ( argv[2], "SetScalarsArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetScalarsArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetScalarsArrayName */
    Tcl_DStringAppendElement ( &dString, " Specify the scalars array name. Used to scale the ellipsoid. Note that\n by default the input scalars are used (i.e. the input to\n vtkPointInterpolator). If no input scalars are available, then the named\n ScalarsArrayName is used.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetScalarsArrayName(vtkStdString a);" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for SetScalarsArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScalarsArrayName */
    if ( strcmp ( argv[2], "GetScalarsArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScalarsArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScalarsArrayName */
    Tcl_DStringAppendElement ( &dString, " Specify the scalars array name. Used to scale the ellipsoid. Note that\n by default the input scalars are used (i.e. the input to\n vtkPointInterpolator). If no input scalars are available, then the named\n ScalarsArrayName is used.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkStdString GetScalarsArrayName();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetScalarsArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetScaleFactor */
    if ( strcmp ( argv[2], "SetScaleFactor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetScaleFactor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetScaleFactor */
    Tcl_DStringAppendElement ( &dString, " Multiply the Gaussian splat distribution by this value. If UseScalars is\n on and a scalar aray is provided, then the scalar value will be\n multiplied by the ScaleFactor times the Gaussian function.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetScaleFactor(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for SetScaleFactor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScaleFactorMinValue */
    if ( strcmp ( argv[2], "GetScaleFactorMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScaleFactorMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScaleFactorMinValue */
    Tcl_DStringAppendElement ( &dString, " Multiply the Gaussian splat distribution by this value. If UseScalars is\n on and a scalar aray is provided, then the scalar value will be\n multiplied by the ScaleFactor times the Gaussian function.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetScaleFactorMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetScaleFactorMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScaleFactorMaxValue */
    if ( strcmp ( argv[2], "GetScaleFactorMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScaleFactorMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScaleFactorMaxValue */
    Tcl_DStringAppendElement ( &dString, " Multiply the Gaussian splat distribution by this value. If UseScalars is\n on and a scalar aray is provided, then the scalar value will be\n multiplied by the ScaleFactor times the Gaussian function.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetScaleFactorMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetScaleFactorMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScaleFactor */
    if ( strcmp ( argv[2], "GetScaleFactor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScaleFactor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScaleFactor */
    Tcl_DStringAppendElement ( &dString, " Multiply the Gaussian splat distribution by this value. If UseScalars is\n on and a scalar aray is provided, then the scalar value will be\n multiplied by the ScaleFactor times the Gaussian function.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetScaleFactor();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetScaleFactor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSharpness */
    if ( strcmp ( argv[2], "SetSharpness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSharpness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSharpness */
    Tcl_DStringAppendElement ( &dString, " Set / Get the sharpness (i.e., falloff) of the Gaussian. By default\n Sharpness=2. As the sharpness increases the effects of distant points\n are reduced.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSharpness(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for SetSharpness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSharpnessMinValue */
    if ( strcmp ( argv[2], "GetSharpnessMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSharpnessMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSharpnessMinValue */
    Tcl_DStringAppendElement ( &dString, " Set / Get the sharpness (i.e., falloff) of the Gaussian. By default\n Sharpness=2. As the sharpness increases the effects of distant points\n are reduced.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetSharpnessMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetSharpnessMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSharpnessMaxValue */
    if ( strcmp ( argv[2], "GetSharpnessMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSharpnessMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSharpnessMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set / Get the sharpness (i.e., falloff) of the Gaussian. By default\n Sharpness=2. As the sharpness increases the effects of distant points\n are reduced.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetSharpnessMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetSharpnessMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSharpness */
    if ( strcmp ( argv[2], "GetSharpness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSharpness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSharpness */
    Tcl_DStringAppendElement ( &dString, " Set / Get the sharpness (i.e., falloff) of the Gaussian. By default\n Sharpness=2. As the sharpness increases the effects of distant points\n are reduced.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetSharpness();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetSharpness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetEccentricity */
    if ( strcmp ( argv[2], "SetEccentricity" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetEccentricity" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetEccentricity */
    Tcl_DStringAppendElement ( &dString, " Set / Get the eccentricity of the ellipsoidal Gaussian. A value=1.0\n produces a spherical distribution. Values < 1 produce a needle like\n distribution (in the direction of the normal); values > 1 produce a\n pancake like distribution (orthogonal to the normal).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetEccentricity(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for SetEccentricity */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetEccentricityMinValue */
    if ( strcmp ( argv[2], "GetEccentricityMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetEccentricityMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetEccentricityMinValue */
    Tcl_DStringAppendElement ( &dString, " Set / Get the eccentricity of the ellipsoidal Gaussian. A value=1.0\n produces a spherical distribution. Values < 1 produce a needle like\n distribution (in the direction of the normal); values > 1 produce a\n pancake like distribution (orthogonal to the normal).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetEccentricityMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetEccentricityMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetEccentricityMaxValue */
    if ( strcmp ( argv[2], "GetEccentricityMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetEccentricityMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetEccentricityMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set / Get the eccentricity of the ellipsoidal Gaussian. A value=1.0\n produces a spherical distribution. Values < 1 produce a needle like\n distribution (in the direction of the normal); values > 1 produce a\n pancake like distribution (orthogonal to the normal).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetEccentricityMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetEccentricityMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetEccentricity */
    if ( strcmp ( argv[2], "GetEccentricity" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetEccentricity" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetEccentricity */
    Tcl_DStringAppendElement ( &dString, " Set / Get the eccentricity of the ellipsoidal Gaussian. A value=1.0\n produces a spherical distribution. Values < 1 produce a needle like\n distribution (in the direction of the normal); values > 1 produce a\n pancake like distribution (orthogonal to the normal).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetEccentricity();" );
    Tcl_DStringAppendElement ( &dString, "vtkEllipsoidalGaussianKernel" );
    /* Closing for GetEccentricity */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkGeneralizedKernelCppCommand(static_cast<vtkGeneralizedKernel *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
