#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkBoundedPointSource_TclCreate(Tcl_Interp *interp);
int vtkEllipsoidalGaussianKernel_TclCreate(Tcl_Interp *interp);
int vtkEuclideanClusterExtraction_TclCreate(Tcl_Interp *interp);
int vtkExtractHierarchicalBins_TclCreate(Tcl_Interp *interp);
int vtkExtractPointCloudPiece_TclCreate(Tcl_Interp *interp);
int vtkExtractPoints_TclCreate(Tcl_Interp *interp);
int vtkExtractSurface_TclCreate(Tcl_Interp *interp);
int vtkFitImplicitFunction_TclCreate(Tcl_Interp *interp);
int vtkGaussianKernel_TclCreate(Tcl_Interp *interp);
int vtkGeneralizedKernel_TclCreate(Tcl_Interp *interp);
int vtkHierarchicalBinningFilter_TclCreate(Tcl_Interp *interp);
int vtkInterpolationKernel_TclCreate(Tcl_Interp *interp);
int vtkLinearKernel_TclCreate(Tcl_Interp *interp);
int vtkPCACurvatureEstimation_TclCreate(Tcl_Interp *interp);
int vtkPCANormalEstimation_TclCreate(Tcl_Interp *interp);
int vtkPointDensityFilter_TclCreate(Tcl_Interp *interp);
int vtkPointCloudFilter_TclCreate(Tcl_Interp *interp);
int vtkPointInterpolator_TclCreate(Tcl_Interp *interp);
int vtkPointInterpolator2D_TclCreate(Tcl_Interp *interp);
int vtkProbabilisticVoronoiKernel_TclCreate(Tcl_Interp *interp);
int vtkRadiusOutlierRemoval_TclCreate(Tcl_Interp *interp);
int vtkSPHInterpolator_TclCreate(Tcl_Interp *interp);
int vtkSPHCubicKernel_TclCreate(Tcl_Interp *interp);
int vtkSPHKernel_TclCreate(Tcl_Interp *interp);
int vtkSPHQuarticKernel_TclCreate(Tcl_Interp *interp);
int vtkSPHQuinticKernel_TclCreate(Tcl_Interp *interp);
int vtkShepardKernel_TclCreate(Tcl_Interp *interp);
int vtkSignedDistance_TclCreate(Tcl_Interp *interp);
int vtkStatisticalOutlierRemoval_TclCreate(Tcl_Interp *interp);
int vtkVoxelGrid_TclCreate(Tcl_Interp *interp);
int vtkVoronoiKernel_TclCreate(Tcl_Interp *interp);
int vtkWendlandQuinticKernel_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkfilterspointstcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkfilterspointstcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkfilterspointstcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkfilterspointstcl_Init(interp);
}


int VTK_EXPORT Vtkfilterspointstcl_Init(Tcl_Interp *interp)
{

  vtkBoundedPointSource_TclCreate(interp);
  vtkEllipsoidalGaussianKernel_TclCreate(interp);
  vtkEuclideanClusterExtraction_TclCreate(interp);
  vtkExtractHierarchicalBins_TclCreate(interp);
  vtkExtractPointCloudPiece_TclCreate(interp);
  vtkExtractPoints_TclCreate(interp);
  vtkExtractSurface_TclCreate(interp);
  vtkFitImplicitFunction_TclCreate(interp);
  vtkGaussianKernel_TclCreate(interp);
  vtkGeneralizedKernel_TclCreate(interp);
  vtkHierarchicalBinningFilter_TclCreate(interp);
  vtkInterpolationKernel_TclCreate(interp);
  vtkLinearKernel_TclCreate(interp);
  vtkPCACurvatureEstimation_TclCreate(interp);
  vtkPCANormalEstimation_TclCreate(interp);
  vtkPointDensityFilter_TclCreate(interp);
  vtkPointCloudFilter_TclCreate(interp);
  vtkPointInterpolator_TclCreate(interp);
  vtkPointInterpolator2D_TclCreate(interp);
  vtkProbabilisticVoronoiKernel_TclCreate(interp);
  vtkRadiusOutlierRemoval_TclCreate(interp);
  vtkSPHInterpolator_TclCreate(interp);
  vtkSPHCubicKernel_TclCreate(interp);
  vtkSPHKernel_TclCreate(interp);
  vtkSPHQuarticKernel_TclCreate(interp);
  vtkSPHQuinticKernel_TclCreate(interp);
  vtkShepardKernel_TclCreate(interp);
  vtkSignedDistance_TclCreate(interp);
  vtkStatisticalOutlierRemoval_TclCreate(interp);
  vtkVoxelGrid_TclCreate(interp);
  vtkVoronoiKernel_TclCreate(interp);
  vtkWendlandQuinticKernel_TclCreate(interp);
  char pkgName[]="vtkFiltersPointsTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
