// tcl wrapper for vtkPCANormalEstimation object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPCANormalEstimation.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkPCANormalEstimationNewCommand()
{
  vtkPCANormalEstimation *temp = vtkPCANormalEstimation::New();
  return static_cast<ClientData>(temp);
}

int vtkPolyDataAlgorithmCppCommand(vtkPolyDataAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkPCANormalEstimationCppCommand(vtkPCANormalEstimation *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkPCANormalEstimationCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkPCANormalEstimationCppCommand(static_cast<vtkPCANormalEstimation *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkPCANormalEstimation_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkPCANormalEstimation"),vtkPCANormalEstimationNewCommand,vtkPCANormalEstimationCommand);
  return 0;
}

int VTKTCL_EXPORT vtkPCANormalEstimationCppCommand(vtkPCANormalEstimation *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkPCANormalEstimation",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkPolyDataAlgorithmCppCommand(static_cast<vtkPolyDataAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkPolyDataAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkPCANormalEstimation  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPCANormalEstimation");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkPCANormalEstimation  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPCANormalEstimation");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkPCANormalEstimation  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPCANormalEstimation");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSampleSize",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetSampleSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSampleSizeMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSampleSizeMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSampleSizeMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSampleSizeMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSampleSize",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSampleSize();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetNormalOrientation",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNormalOrientation(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNormalOrientation",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNormalOrientation();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetNormalOrientationToAsComputed",argv[1]))&&(argc == 2))
  {
    op->SetNormalOrientationToAsComputed();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetNormalOrientationToPoint",argv[1]))&&(argc == 2))
  {
    op->SetNormalOrientationToPoint();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetNormalOrientationToGraphTraversal",argv[1]))&&(argc == 2))
  {
    op->SetNormalOrientationToGraphTraversal();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetOrientationPoint",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    op->SetOrientationPoint(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetOrientationPoint",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    op->SetOrientationPoint(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetOrientationPoint",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetOrientationPoint();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetFlipNormals",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetFlipNormals(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetFlipNormals",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetFlipNormals();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("FlipNormalsOn",argv[1]))&&(argc == 2))
  {
    op->FlipNormalsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("FlipNormalsOff",argv[1]))&&(argc == 2))
  {
    op->FlipNormalsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetLocator",argv[1]))&&(argc == 3))
  {
    vtkAbstractPointLocator  *temp0;
    error = 0;

    temp0 = (vtkAbstractPointLocator *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPointLocator"),interp,error));
    if (!error)
  {
    op->SetLocator(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLocator",argv[1]))&&(argc == 2))
  {
    vtkAbstractPointLocator  *temp20;
    temp20 = (op)->GetLocator();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAbstractPointLocator");
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkPCANormalEstimationCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkPolyDataAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkPCANormalEstimation:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetSampleSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSampleSizeMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSampleSizeMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSampleSize\n",NULL);
    Tcl_AppendResult(interp,"  SetNormalOrientation\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNormalOrientation\n",NULL);
    Tcl_AppendResult(interp,"  SetNormalOrientationToAsComputed\n",NULL);
    Tcl_AppendResult(interp,"  SetNormalOrientationToPoint\n",NULL);
    Tcl_AppendResult(interp,"  SetNormalOrientationToGraphTraversal\n",NULL);
    Tcl_AppendResult(interp,"  SetOrientationPoint\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetOrientationPoint\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetOrientationPoint\n",NULL);
    Tcl_AppendResult(interp,"  SetFlipNormals\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetFlipNormals\n",NULL);
    Tcl_AppendResult(interp,"  FlipNormalsOn\n",NULL);
    Tcl_AppendResult(interp,"  FlipNormalsOff\n",NULL);
    Tcl_AppendResult(interp,"  SetLocator\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLocator\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkPolyDataAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetSampleSize" );
    Tcl_DStringAppendElement ( &dString, "GetSampleSizeMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetSampleSizeMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetSampleSize" );
    Tcl_DStringAppendElement ( &dString, "SetNormalOrientation" );
    Tcl_DStringAppendElement ( &dString, "GetNormalOrientation" );
    Tcl_DStringAppendElement ( &dString, "SetNormalOrientationToAsComputed" );
    Tcl_DStringAppendElement ( &dString, "SetNormalOrientationToPoint" );
    Tcl_DStringAppendElement ( &dString, "SetNormalOrientationToGraphTraversal" );
    Tcl_DStringAppendElement ( &dString, "SetOrientationPoint" );
    Tcl_DStringAppendElement ( &dString, "SetOrientationPoint" );
    Tcl_DStringAppendElement ( &dString, "GetOrientationPoint" );
    Tcl_DStringAppendElement ( &dString, "SetFlipNormals" );
    Tcl_DStringAppendElement ( &dString, "GetFlipNormals" );
    Tcl_DStringAppendElement ( &dString, "FlipNormalsOn" );
    Tcl_DStringAppendElement ( &dString, "FlipNormalsOff" );
    Tcl_DStringAppendElement ( &dString, "SetLocator" );
    Tcl_DStringAppendElement ( &dString, "GetLocator" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkPolyDataAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkPCANormalEstimation *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSampleSize */
    if ( strcmp ( argv[2], "SetSampleSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSampleSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSampleSize */
    Tcl_DStringAppendElement ( &dString, " For each sampled point, specify the number of the closest, surrounding\n points used to estimate the normal (the so called k-neighborhood). By\n default 25 points are used. Smaller numbers may speed performance at the\n cost of accuracy.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSampleSize(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for SetSampleSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSampleSizeMinValue */
    if ( strcmp ( argv[2], "GetSampleSizeMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSampleSizeMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSampleSizeMinValue */
    Tcl_DStringAppendElement ( &dString, " For each sampled point, specify the number of the closest, surrounding\n points used to estimate the normal (the so called k-neighborhood). By\n default 25 points are used. Smaller numbers may speed performance at the\n cost of accuracy.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSampleSizeMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for GetSampleSizeMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSampleSizeMaxValue */
    if ( strcmp ( argv[2], "GetSampleSizeMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSampleSizeMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSampleSizeMaxValue */
    Tcl_DStringAppendElement ( &dString, " For each sampled point, specify the number of the closest, surrounding\n points used to estimate the normal (the so called k-neighborhood). By\n default 25 points are used. Smaller numbers may speed performance at the\n cost of accuracy.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSampleSizeMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for GetSampleSizeMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSampleSize */
    if ( strcmp ( argv[2], "GetSampleSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSampleSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSampleSize */
    Tcl_DStringAppendElement ( &dString, " For each sampled point, specify the number of the closest, surrounding\n points used to estimate the normal (the so called k-neighborhood). By\n default 25 points are used. Smaller numbers may speed performance at the\n cost of accuracy.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSampleSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for GetSampleSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNormalOrientation */
    if ( strcmp ( argv[2], "SetNormalOrientation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNormalOrientation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNormalOrientation */
    Tcl_DStringAppendElement ( &dString, " Configure how the filter addresses consistency in normal\n oreientation. When initially computed using PCA, a point normal may\n point in the + or - direction, which may not be consistent with\n neighboring points. To address this, various strategies have been used\n to create consistent normals. The simplest approach is to do nothing\n (AsComputed). Another simple approach is to flip the normal based on its\n direction with respect to a specified point (i.e., point normals ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNormalOrientation(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for SetNormalOrientation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNormalOrientation */
    if ( strcmp ( argv[2], "GetNormalOrientation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNormalOrientation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNormalOrientation */
    Tcl_DStringAppendElement ( &dString, " Configure how the filter addresses consistency in normal\n oreientation. When initially computed using PCA, a point normal may\n point in the + or - direction, which may not be consistent with\n neighboring points. To address this, various strategies have been used\n to create consistent normals. The simplest approach is to do nothing\n (AsComputed). Another simple approach is to flip the normal based on its\n direction with respect to a specified point (i.e., point normals ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNormalOrientation();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for GetNormalOrientation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNormalOrientationToAsComputed */
    if ( strcmp ( argv[2], "SetNormalOrientationToAsComputed" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNormalOrientationToAsComputed" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNormalOrientationToAsComputed */
    Tcl_DStringAppendElement ( &dString, " Configure how the filter addresses consistency in normal\n oreientation. When initially computed using PCA, a point normal may\n point in the + or - direction, which may not be consistent with\n neighboring points. To address this, various strategies have been used\n to create consistent normals. The simplest approach is to do nothing\n (AsComputed). Another simple approach is to flip the normal based on its\n direction with respect to a specified point (i.e., point normals ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNormalOrientationToAsComputed();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for SetNormalOrientationToAsComputed */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNormalOrientationToPoint */
    if ( strcmp ( argv[2], "SetNormalOrientationToPoint" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNormalOrientationToPoint" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNormalOrientationToPoint */
    Tcl_DStringAppendElement ( &dString, " Configure how the filter addresses consistency in normal\n oreientation. When initially computed using PCA, a point normal may\n point in the + or - direction, which may not be consistent with\n neighboring points. To address this, various strategies have been used\n to create consistent normals. The simplest approach is to do nothing\n (AsComputed). Another simple approach is to flip the normal based on its\n direction with respect to a specified point (i.e., point normals ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNormalOrientationToPoint();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for SetNormalOrientationToPoint */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNormalOrientationToGraphTraversal */
    if ( strcmp ( argv[2], "SetNormalOrientationToGraphTraversal" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNormalOrientationToGraphTraversal" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNormalOrientationToGraphTraversal */
    Tcl_DStringAppendElement ( &dString, " Configure how the filter addresses consistency in normal\n oreientation. When initially computed using PCA, a point normal may\n point in the + or - direction, which may not be consistent with\n neighboring points. To address this, various strategies have been used\n to create consistent normals. The simplest approach is to do nothing\n (AsComputed). Another simple approach is to flip the normal based on its\n direction with respect to a specified point (i.e., point normals ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNormalOrientationToGraphTraversal();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for SetNormalOrientationToGraphTraversal */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetOrientationPoint */
    if ( strcmp ( argv[2], "SetOrientationPoint" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOrientationPoint" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOrientationPoint */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetOrientationPoint(double, double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for SetOrientationPoint */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetOrientationPoint */
    if ( strcmp ( argv[2], "SetOrientationPoint" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOrientationPoint" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOrientationPoint */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetOrientationPoint(double a\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for SetOrientationPoint */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetOrientationPoint */
    if ( strcmp ( argv[2], "GetOrientationPoint" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOrientationPoint" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOrientationPoint */
    Tcl_DStringAppendElement ( &dString, " If the normal orientation is to be consistent with a specified\n direction, then an orientation point should be set. The sign of the\n normals will be modified so that they point towards this point. By\n default, the specified orientation point is (0,0,0).\n" );
    Tcl_DStringAppendElement ( &dString, "double *GetOrientationPoint();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for GetOrientationPoint */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetFlipNormals */
    if ( strcmp ( argv[2], "SetFlipNormals" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetFlipNormals" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetFlipNormals */
    Tcl_DStringAppendElement ( &dString, " The normal orientation can be flipped by enabling this flag.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetFlipNormals(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for SetFlipNormals */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetFlipNormals */
    if ( strcmp ( argv[2], "GetFlipNormals" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetFlipNormals" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetFlipNormals */
    Tcl_DStringAppendElement ( &dString, " The normal orientation can be flipped by enabling this flag.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetFlipNormals();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for GetFlipNormals */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: FlipNormalsOn */
    if ( strcmp ( argv[2], "FlipNormalsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "FlipNormalsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for FlipNormalsOn */
    Tcl_DStringAppendElement ( &dString, " The normal orientation can be flipped by enabling this flag.\n" );
    Tcl_DStringAppendElement ( &dString, "void FlipNormalsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for FlipNormalsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: FlipNormalsOff */
    if ( strcmp ( argv[2], "FlipNormalsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "FlipNormalsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for FlipNormalsOff */
    Tcl_DStringAppendElement ( &dString, " The normal orientation can be flipped by enabling this flag.\n" );
    Tcl_DStringAppendElement ( &dString, "void FlipNormalsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for FlipNormalsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLocator */
    if ( strcmp ( argv[2], "SetLocator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLocator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPointLocator" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLocator */
    Tcl_DStringAppendElement ( &dString, " Specify a point locator. By default a vtkStaticPointLocator is\n used. The locator performs efficient searches to locate points\n around a sample point.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLocator(vtkAbstractPointLocator *locator);" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for SetLocator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLocator */
    if ( strcmp ( argv[2], "GetLocator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLocator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLocator */
    Tcl_DStringAppendElement ( &dString, " Specify a point locator. By default a vtkStaticPointLocator is\n used. The locator performs efficient searches to locate points\n around a sample point.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPointLocator *GetLocator();" );
    Tcl_DStringAppendElement ( &dString, "vtkPCANormalEstimation" );
    /* Closing for GetLocator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkPolyDataAlgorithmCppCommand(static_cast<vtkPolyDataAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
