// tcl wrapper for vtkPointDensityFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPointDensityFilter.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkPointDensityFilterNewCommand()
{
  vtkPointDensityFilter *temp = vtkPointDensityFilter::New();
  return static_cast<ClientData>(temp);
}

int vtkImageAlgorithmCppCommand(vtkImageAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkPointDensityFilterCppCommand(vtkPointDensityFilter *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkPointDensityFilterCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkPointDensityFilterCppCommand(static_cast<vtkPointDensityFilter *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkPointDensityFilter_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkPointDensityFilter"),vtkPointDensityFilterNewCommand,vtkPointDensityFilterCommand);
  return 0;
}

int VTKTCL_EXPORT vtkPointDensityFilterCppCommand(vtkPointDensityFilter *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkPointDensityFilter",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkImageAlgorithmCppCommand(static_cast<vtkImageAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkImageAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkPointDensityFilter  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPointDensityFilter");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkPointDensityFilter  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPointDensityFilter");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkPointDensityFilter  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPointDensityFilter");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSampleDimensions",argv[1]))&&(argc == 5))
  {
    int      temp0;
    int      temp1;
    int      temp2;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (!error)
  {
    op->SetSampleDimensions(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSampleDimensions",argv[1]))&&(argc == 5))
  {
    int    temp0[3];
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0[0] = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp0[1] = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp0[2] = tempi;
    if (!error)
  {
    op->SetSampleDimensions(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSampleDimensions",argv[1]))&&(argc == 2))
  {
    int     *temp20;
    temp20 = (op)->GetSampleDimensions();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      sprintf(tempResult,"%i %i %i ",temp20[0],temp20[1],temp20[2]);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetModelBounds",argv[1]))&&(argc == 8))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double   temp3;
    double   temp4;
    double   temp5;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp3 = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp4 = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp5 = tempd;
    if (!error)
  {
    op->SetModelBounds(temp0,temp1,temp2,temp3,temp4,temp5);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetModelBounds",argv[1]))&&(argc == 8))
  {
    double temp0[6];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (!error)
  {
    op->SetModelBounds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetModelBounds",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetModelBounds();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[3], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[4], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[5], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetAdjustDistance",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetAdjustDistance(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAdjustDistanceMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetAdjustDistanceMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetAdjustDistanceMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetAdjustDistanceMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetAdjustDistance",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetAdjustDistance();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDensityEstimate",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetDensityEstimate(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDensityEstimateMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDensityEstimateMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetDensityEstimateMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDensityEstimateMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetDensityEstimate",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDensityEstimate();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDensityEstimateToFixedRadius",argv[1]))&&(argc == 2))
  {
    op->SetDensityEstimateToFixedRadius();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetDensityEstimateToRelativeRadius",argv[1]))&&(argc == 2))
  {
    op->SetDensityEstimateToRelativeRadius();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetDensityEstimateAsString",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetDensityEstimateAsString();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetDensityForm",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetDensityForm(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDensityFormMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDensityFormMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetDensityFormMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDensityFormMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetDensityForm",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDensityForm();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDensityFormToVolumeNormalized",argv[1]))&&(argc == 2))
  {
    op->SetDensityFormToVolumeNormalized();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetDensityFormToNumberOfPoints",argv[1]))&&(argc == 2))
  {
    op->SetDensityFormToNumberOfPoints();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetDensityFormAsString",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetDensityFormAsString();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetRadius",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetRadius(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRadiusMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRadiusMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetRadiusMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRadiusMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetRadius",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRadius();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetRelativeRadius",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetRelativeRadius(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRelativeRadiusMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRelativeRadiusMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetRelativeRadiusMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRelativeRadiusMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetRelativeRadius",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRelativeRadius();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetScalarWeighting",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetScalarWeighting(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetScalarWeighting",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetScalarWeighting();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("ScalarWeightingOn",argv[1]))&&(argc == 2))
  {
    op->ScalarWeightingOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ScalarWeightingOff",argv[1]))&&(argc == 2))
  {
    op->ScalarWeightingOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetLocator",argv[1]))&&(argc == 3))
  {
    vtkAbstractPointLocator  *temp0;
    error = 0;

    temp0 = (vtkAbstractPointLocator *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPointLocator"),interp,error));
    if (!error)
  {
    op->SetLocator(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLocator",argv[1]))&&(argc == 2))
  {
    vtkAbstractPointLocator  *temp20;
    temp20 = (op)->GetLocator();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAbstractPointLocator");
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkPointDensityFilterCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkImageAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkPointDensityFilter:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetSampleDimensions\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetSampleDimensions\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetSampleDimensions\n",NULL);
    Tcl_AppendResult(interp,"  SetModelBounds\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  SetModelBounds\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  GetModelBounds\n",NULL);
    Tcl_AppendResult(interp,"  SetAdjustDistance\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAdjustDistanceMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetAdjustDistanceMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetAdjustDistance\n",NULL);
    Tcl_AppendResult(interp,"  SetDensityEstimate\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDensityEstimateMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetDensityEstimateMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetDensityEstimate\n",NULL);
    Tcl_AppendResult(interp,"  SetDensityEstimateToFixedRadius\n",NULL);
    Tcl_AppendResult(interp,"  SetDensityEstimateToRelativeRadius\n",NULL);
    Tcl_AppendResult(interp,"  GetDensityEstimateAsString\n",NULL);
    Tcl_AppendResult(interp,"  SetDensityForm\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDensityFormMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetDensityFormMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetDensityForm\n",NULL);
    Tcl_AppendResult(interp,"  SetDensityFormToVolumeNormalized\n",NULL);
    Tcl_AppendResult(interp,"  SetDensityFormToNumberOfPoints\n",NULL);
    Tcl_AppendResult(interp,"  GetDensityFormAsString\n",NULL);
    Tcl_AppendResult(interp,"  SetRadius\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRadiusMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetRadiusMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetRadius\n",NULL);
    Tcl_AppendResult(interp,"  SetRelativeRadius\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRelativeRadiusMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetRelativeRadiusMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetRelativeRadius\n",NULL);
    Tcl_AppendResult(interp,"  SetScalarWeighting\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetScalarWeighting\n",NULL);
    Tcl_AppendResult(interp,"  ScalarWeightingOn\n",NULL);
    Tcl_AppendResult(interp,"  ScalarWeightingOff\n",NULL);
    Tcl_AppendResult(interp,"  SetLocator\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLocator\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkImageAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetSampleDimensions" );
    Tcl_DStringAppendElement ( &dString, "SetSampleDimensions" );
    Tcl_DStringAppendElement ( &dString, "GetSampleDimensions" );
    Tcl_DStringAppendElement ( &dString, "SetModelBounds" );
    Tcl_DStringAppendElement ( &dString, "SetModelBounds" );
    Tcl_DStringAppendElement ( &dString, "GetModelBounds" );
    Tcl_DStringAppendElement ( &dString, "SetAdjustDistance" );
    Tcl_DStringAppendElement ( &dString, "GetAdjustDistanceMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetAdjustDistanceMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetAdjustDistance" );
    Tcl_DStringAppendElement ( &dString, "SetDensityEstimate" );
    Tcl_DStringAppendElement ( &dString, "GetDensityEstimateMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetDensityEstimateMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetDensityEstimate" );
    Tcl_DStringAppendElement ( &dString, "SetDensityEstimateToFixedRadius" );
    Tcl_DStringAppendElement ( &dString, "SetDensityEstimateToRelativeRadius" );
    Tcl_DStringAppendElement ( &dString, "GetDensityEstimateAsString" );
    Tcl_DStringAppendElement ( &dString, "SetDensityForm" );
    Tcl_DStringAppendElement ( &dString, "GetDensityFormMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetDensityFormMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetDensityForm" );
    Tcl_DStringAppendElement ( &dString, "SetDensityFormToVolumeNormalized" );
    Tcl_DStringAppendElement ( &dString, "SetDensityFormToNumberOfPoints" );
    Tcl_DStringAppendElement ( &dString, "GetDensityFormAsString" );
    Tcl_DStringAppendElement ( &dString, "SetRadius" );
    Tcl_DStringAppendElement ( &dString, "GetRadiusMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetRadiusMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetRadius" );
    Tcl_DStringAppendElement ( &dString, "SetRelativeRadius" );
    Tcl_DStringAppendElement ( &dString, "GetRelativeRadiusMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetRelativeRadiusMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetRelativeRadius" );
    Tcl_DStringAppendElement ( &dString, "SetScalarWeighting" );
    Tcl_DStringAppendElement ( &dString, "GetScalarWeighting" );
    Tcl_DStringAppendElement ( &dString, "ScalarWeightingOn" );
    Tcl_DStringAppendElement ( &dString, "ScalarWeightingOff" );
    Tcl_DStringAppendElement ( &dString, "SetLocator" );
    Tcl_DStringAppendElement ( &dString, "GetLocator" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkImageAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkPointDensityFilter *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSampleDimensions */
    if ( strcmp ( argv[2], "SetSampleDimensions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSampleDimensions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSampleDimensions */
    Tcl_DStringAppendElement ( &dString, " Set / get the dimensions of the sampling volume. Higher values generally\n produce better results but may be much slower. Note however that too\n high a resolution can generate excessive noise; too low and data can be\n excessively smoothed.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSampleDimensions(int i, int j, int k);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetSampleDimensions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSampleDimensions */
    if ( strcmp ( argv[2], "SetSampleDimensions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSampleDimensions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSampleDimensions */
    Tcl_DStringAppendElement ( &dString, " Set / get the dimensions of the sampling volume. Higher values generally\n produce better results but may be much slower. Note however that too\n high a resolution can generate excessive noise; too low and data can be\n excessively smoothed.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSampleDimensions(int dim\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetSampleDimensions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSampleDimensions */
    if ( strcmp ( argv[2], "GetSampleDimensions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSampleDimensions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSampleDimensions */
    Tcl_DStringAppendElement ( &dString, " Set / get the dimensions of the sampling volume. Higher values generally\n produce better results but may be much slower. Note however that too\n high a resolution can generate excessive noise; too low and data can be\n excessively smoothed.\n" );
    Tcl_DStringAppendElement ( &dString, "int *GetSampleDimensions();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetSampleDimensions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetModelBounds */
    if ( strcmp ( argv[2], "SetModelBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetModelBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetModelBounds */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetModelBounds(double, double, double, double, double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetModelBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetModelBounds */
    if ( strcmp ( argv[2], "SetModelBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetModelBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetModelBounds */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetModelBounds(double a\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetModelBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetModelBounds */
    if ( strcmp ( argv[2], "GetModelBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetModelBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetModelBounds */
    Tcl_DStringAppendElement ( &dString, " Set / get the (xmin,xmax, ymin,ymax, zmin,zmax) bounding box in which\n the sampling is performed. If any of the (min,max) bounds values are\n min >= max, then the bounds will be computed automatically from the input\n data. Otherwise, the user-specified bounds will be used.\n" );
    Tcl_DStringAppendElement ( &dString, "double *GetModelBounds();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetModelBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAdjustDistance */
    if ( strcmp ( argv[2], "SetAdjustDistance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAdjustDistance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAdjustDistance */
    Tcl_DStringAppendElement ( &dString, " Set / get the relative amount to pad the model bounds if automatic\n computation is performed. The padding is the fraction to scale\n the model bounds in each of the x-y-z directions. By default the\n padding is 0.10 (i.e., 10% larger in each direction).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAdjustDistance(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetAdjustDistance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAdjustDistanceMinValue */
    if ( strcmp ( argv[2], "GetAdjustDistanceMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAdjustDistanceMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAdjustDistanceMinValue */
    Tcl_DStringAppendElement ( &dString, " Set / get the relative amount to pad the model bounds if automatic\n computation is performed. The padding is the fraction to scale\n the model bounds in each of the x-y-z directions. By default the\n padding is 0.10 (i.e., 10% larger in each direction).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetAdjustDistanceMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetAdjustDistanceMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAdjustDistanceMaxValue */
    if ( strcmp ( argv[2], "GetAdjustDistanceMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAdjustDistanceMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAdjustDistanceMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set / get the relative amount to pad the model bounds if automatic\n computation is performed. The padding is the fraction to scale\n the model bounds in each of the x-y-z directions. By default the\n padding is 0.10 (i.e., 10% larger in each direction).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetAdjustDistanceMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetAdjustDistanceMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAdjustDistance */
    if ( strcmp ( argv[2], "GetAdjustDistance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAdjustDistance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAdjustDistance */
    Tcl_DStringAppendElement ( &dString, " Set / get the relative amount to pad the model bounds if automatic\n computation is performed. The padding is the fraction to scale\n the model bounds in each of the x-y-z directions. By default the\n padding is 0.10 (i.e., 10% larger in each direction).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetAdjustDistance();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetAdjustDistance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDensityEstimate */
    if ( strcmp ( argv[2], "SetDensityEstimate" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDensityEstimate" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDensityEstimate */
    Tcl_DStringAppendElement ( &dString, " Specify the method to estimate point density. The density can be\n calculated using a fixed sphere radius; or a sphere radius that is\n relative to voxel size.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDensityEstimate(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetDensityEstimate */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDensityEstimateMinValue */
    if ( strcmp ( argv[2], "GetDensityEstimateMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDensityEstimateMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDensityEstimateMinValue */
    Tcl_DStringAppendElement ( &dString, " Specify the method to estimate point density. The density can be\n calculated using a fixed sphere radius; or a sphere radius that is\n relative to voxel size.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDensityEstimateMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetDensityEstimateMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDensityEstimateMaxValue */
    if ( strcmp ( argv[2], "GetDensityEstimateMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDensityEstimateMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDensityEstimateMaxValue */
    Tcl_DStringAppendElement ( &dString, " Specify the method to estimate point density. The density can be\n calculated using a fixed sphere radius; or a sphere radius that is\n relative to voxel size.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDensityEstimateMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetDensityEstimateMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDensityEstimate */
    if ( strcmp ( argv[2], "GetDensityEstimate" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDensityEstimate" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDensityEstimate */
    Tcl_DStringAppendElement ( &dString, " Specify the method to estimate point density. The density can be\n calculated using a fixed sphere radius; or a sphere radius that is\n relative to voxel size.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDensityEstimate();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetDensityEstimate */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDensityEstimateToFixedRadius */
    if ( strcmp ( argv[2], "SetDensityEstimateToFixedRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDensityEstimateToFixedRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDensityEstimateToFixedRadius */
    Tcl_DStringAppendElement ( &dString, " Specify the method to estimate point density. The density can be\n calculated using a fixed sphere radius; or a sphere radius that is\n relative to voxel size.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDensityEstimateToFixedRadius();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetDensityEstimateToFixedRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDensityEstimateToRelativeRadius */
    if ( strcmp ( argv[2], "SetDensityEstimateToRelativeRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDensityEstimateToRelativeRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDensityEstimateToRelativeRadius */
    Tcl_DStringAppendElement ( &dString, " Specify the method to estimate point density. The density can be\n calculated using a fixed sphere radius; or a sphere radius that is\n relative to voxel size.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDensityEstimateToRelativeRadius();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetDensityEstimateToRelativeRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDensityEstimateAsString */
    if ( strcmp ( argv[2], "GetDensityEstimateAsString" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDensityEstimateAsString" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDensityEstimateAsString */
    Tcl_DStringAppendElement ( &dString, " Specify the method to estimate point density. The density can be\n calculated using a fixed sphere radius; or a sphere radius that is\n relative to voxel size.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetDensityEstimateAsString();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetDensityEstimateAsString */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDensityForm */
    if ( strcmp ( argv[2], "SetDensityForm" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDensityForm" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDensityForm */
    Tcl_DStringAppendElement ( &dString, " Specify the form by which the density is expressed. Either the density is\n expressed as (number of points/local sphere volume), or as simply the\n (number of points) within the local sphere.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDensityForm(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetDensityForm */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDensityFormMinValue */
    if ( strcmp ( argv[2], "GetDensityFormMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDensityFormMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDensityFormMinValue */
    Tcl_DStringAppendElement ( &dString, " Specify the form by which the density is expressed. Either the density is\n expressed as (number of points/local sphere volume), or as simply the\n (number of points) within the local sphere.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDensityFormMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetDensityFormMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDensityFormMaxValue */
    if ( strcmp ( argv[2], "GetDensityFormMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDensityFormMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDensityFormMaxValue */
    Tcl_DStringAppendElement ( &dString, " Specify the form by which the density is expressed. Either the density is\n expressed as (number of points/local sphere volume), or as simply the\n (number of points) within the local sphere.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDensityFormMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetDensityFormMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDensityForm */
    if ( strcmp ( argv[2], "GetDensityForm" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDensityForm" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDensityForm */
    Tcl_DStringAppendElement ( &dString, " Specify the form by which the density is expressed. Either the density is\n expressed as (number of points/local sphere volume), or as simply the\n (number of points) within the local sphere.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDensityForm();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetDensityForm */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDensityFormToVolumeNormalized */
    if ( strcmp ( argv[2], "SetDensityFormToVolumeNormalized" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDensityFormToVolumeNormalized" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDensityFormToVolumeNormalized */
    Tcl_DStringAppendElement ( &dString, " Specify the form by which the density is expressed. Either the density is\n expressed as (number of points/local sphere volume), or as simply the\n (number of points) within the local sphere.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDensityFormToVolumeNormalized();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetDensityFormToVolumeNormalized */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDensityFormToNumberOfPoints */
    if ( strcmp ( argv[2], "SetDensityFormToNumberOfPoints" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDensityFormToNumberOfPoints" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDensityFormToNumberOfPoints */
    Tcl_DStringAppendElement ( &dString, " Specify the form by which the density is expressed. Either the density is\n expressed as (number of points/local sphere volume), or as simply the\n (number of points) within the local sphere.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDensityFormToNumberOfPoints();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetDensityFormToNumberOfPoints */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDensityFormAsString */
    if ( strcmp ( argv[2], "GetDensityFormAsString" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDensityFormAsString" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDensityFormAsString */
    Tcl_DStringAppendElement ( &dString, " Specify the form by which the density is expressed. Either the density is\n expressed as (number of points/local sphere volume), or as simply the\n (number of points) within the local sphere.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetDensityFormAsString();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetDensityFormAsString */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRadius */
    if ( strcmp ( argv[2], "SetRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRadius */
    Tcl_DStringAppendElement ( &dString, " Set / get the radius variable defining the local sphere used to estimate\n the density function. The Radius is used when the density estimate is\n ^ set to a fixed radius (i.e., the radius doesn't change).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRadius(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadiusMinValue */
    if ( strcmp ( argv[2], "GetRadiusMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadiusMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadiusMinValue */
    Tcl_DStringAppendElement ( &dString, " Set / get the radius variable defining the local sphere used to estimate\n the density function. The Radius is used when the density estimate is\n ^ set to a fixed radius (i.e., the radius doesn't change).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRadiusMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetRadiusMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadiusMaxValue */
    if ( strcmp ( argv[2], "GetRadiusMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadiusMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadiusMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set / get the radius variable defining the local sphere used to estimate\n the density function. The Radius is used when the density estimate is\n ^ set to a fixed radius (i.e., the radius doesn't change).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRadiusMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetRadiusMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadius */
    if ( strcmp ( argv[2], "GetRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadius */
    Tcl_DStringAppendElement ( &dString, " Set / get the radius variable defining the local sphere used to estimate\n the density function. The Radius is used when the density estimate is\n ^ set to a fixed radius (i.e., the radius doesn't change).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRadius();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRelativeRadius */
    if ( strcmp ( argv[2], "SetRelativeRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRelativeRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRelativeRadius */
    Tcl_DStringAppendElement ( &dString, " Set / get the relative radius factor defining the local sphere used to\n estimate the density function. The relative sphere radius is equal to\n the diagonal length of a voxel times the radius factor. The RelativeRadius\n is used when the density estimate is set to relative radius (i.e.,\n relative to voxel size).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRelativeRadius(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetRelativeRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRelativeRadiusMinValue */
    if ( strcmp ( argv[2], "GetRelativeRadiusMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRelativeRadiusMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRelativeRadiusMinValue */
    Tcl_DStringAppendElement ( &dString, " Set / get the relative radius factor defining the local sphere used to\n estimate the density function. The relative sphere radius is equal to\n the diagonal length of a voxel times the radius factor. The RelativeRadius\n is used when the density estimate is set to relative radius (i.e.,\n relative to voxel size).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRelativeRadiusMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetRelativeRadiusMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRelativeRadiusMaxValue */
    if ( strcmp ( argv[2], "GetRelativeRadiusMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRelativeRadiusMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRelativeRadiusMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set / get the relative radius factor defining the local sphere used to\n estimate the density function. The relative sphere radius is equal to\n the diagonal length of a voxel times the radius factor. The RelativeRadius\n is used when the density estimate is set to relative radius (i.e.,\n relative to voxel size).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRelativeRadiusMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetRelativeRadiusMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRelativeRadius */
    if ( strcmp ( argv[2], "GetRelativeRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRelativeRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRelativeRadius */
    Tcl_DStringAppendElement ( &dString, " Set / get the relative radius factor defining the local sphere used to\n estimate the density function. The relative sphere radius is equal to\n the diagonal length of a voxel times the radius factor. The RelativeRadius\n is used when the density estimate is set to relative radius (i.e.,\n relative to voxel size).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRelativeRadius();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetRelativeRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetScalarWeighting */
    if ( strcmp ( argv[2], "SetScalarWeighting" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetScalarWeighting" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetScalarWeighting */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the weighting of point density by a scalar array. By default\n scalar weighting is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetScalarWeighting(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetScalarWeighting */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScalarWeighting */
    if ( strcmp ( argv[2], "GetScalarWeighting" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScalarWeighting" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScalarWeighting */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the weighting of point density by a scalar array. By default\n scalar weighting is off.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetScalarWeighting();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetScalarWeighting */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ScalarWeightingOn */
    if ( strcmp ( argv[2], "ScalarWeightingOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ScalarWeightingOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ScalarWeightingOn */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the weighting of point density by a scalar array. By default\n scalar weighting is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void ScalarWeightingOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for ScalarWeightingOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ScalarWeightingOff */
    if ( strcmp ( argv[2], "ScalarWeightingOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ScalarWeightingOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ScalarWeightingOff */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the weighting of point density by a scalar array. By default\n scalar weighting is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void ScalarWeightingOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for ScalarWeightingOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLocator */
    if ( strcmp ( argv[2], "SetLocator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLocator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPointLocator" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLocator */
    Tcl_DStringAppendElement ( &dString, " Specify a point locator. By default a vtkStaticPointLocator is\n used. The locator performs efficient searches to locate near a\n specified interpolation position.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLocator(vtkAbstractPointLocator *locator);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for SetLocator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLocator */
    if ( strcmp ( argv[2], "GetLocator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLocator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLocator */
    Tcl_DStringAppendElement ( &dString, " Specify a point locator. By default a vtkStaticPointLocator is\n used. The locator performs efficient searches to locate near a\n specified interpolation position.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPointLocator *GetLocator();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointDensityFilter" );
    /* Closing for GetLocator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkImageAlgorithmCppCommand(static_cast<vtkImageAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
