// tcl wrapper for vtkPointInterpolator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPointInterpolator.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkPointInterpolatorNewCommand()
{
  vtkPointInterpolator *temp = vtkPointInterpolator::New();
  return static_cast<ClientData>(temp);
}

int vtkDataSetAlgorithmCppCommand(vtkDataSetAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkPointInterpolatorCppCommand(vtkPointInterpolator *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkPointInterpolatorCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkPointInterpolatorCppCommand(static_cast<vtkPointInterpolator *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkPointInterpolator_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkPointInterpolator"),vtkPointInterpolatorNewCommand,vtkPointInterpolatorCommand);
  return 0;
}

int VTKTCL_EXPORT vtkPointInterpolatorCppCommand(vtkPointInterpolator *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkPointInterpolator",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkDataSetAlgorithmCppCommand(static_cast<vtkDataSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkDataSetAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkPointInterpolator  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPointInterpolator");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkPointInterpolator  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPointInterpolator");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkPointInterpolator  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPointInterpolator");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSourceData",argv[1]))&&(argc == 3))
  {
    vtkDataObject  *temp0;
    error = 0;

    temp0 = (vtkDataObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataObject"),interp,error));
    if (!error)
  {
    op->SetSourceData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSource",argv[1]))&&(argc == 2))
  {
    vtkDataObject  *temp20;
    temp20 = (op)->GetSource();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataObject");
    return TCL_OK;
  }
  if ((!strcmp("SetSourceConnection",argv[1]))&&(argc == 3))
  {
    vtkAlgorithmOutput  *temp0;
    error = 0;

    temp0 = (vtkAlgorithmOutput *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAlgorithmOutput"),interp,error));
    if (!error)
  {
    op->SetSourceConnection(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetLocator",argv[1]))&&(argc == 3))
  {
    vtkAbstractPointLocator  *temp0;
    error = 0;

    temp0 = (vtkAbstractPointLocator *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPointLocator"),interp,error));
    if (!error)
  {
    op->SetLocator(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLocator",argv[1]))&&(argc == 2))
  {
    vtkAbstractPointLocator  *temp20;
    temp20 = (op)->GetLocator();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAbstractPointLocator");
    return TCL_OK;
  }
  if ((!strcmp("SetKernel",argv[1]))&&(argc == 3))
  {
    vtkInterpolationKernel  *temp0;
    error = 0;

    temp0 = (vtkInterpolationKernel *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkInterpolationKernel"),interp,error));
    if (!error)
  {
    op->SetKernel(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetKernel",argv[1]))&&(argc == 2))
  {
    vtkInterpolationKernel  *temp20;
    temp20 = (op)->GetKernel();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkInterpolationKernel");
    return TCL_OK;
  }
  if ((!strcmp("SetNullPointsStrategy",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNullPointsStrategy(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNullPointsStrategy",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNullPointsStrategy();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetNullPointsStrategyToMaskPoints",argv[1]))&&(argc == 2))
  {
    op->SetNullPointsStrategyToMaskPoints();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetNullPointsStrategyToNullValue",argv[1]))&&(argc == 2))
  {
    op->SetNullPointsStrategyToNullValue();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetNullPointsStrategyToClosestPoint",argv[1]))&&(argc == 2))
  {
    op->SetNullPointsStrategyToClosestPoint();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetValidPointsMaskArrayName",argv[1]))&&(argc == 3))
  {
    vtkStdString   temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetValidPointsMaskArrayName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetValidPointsMaskArrayName",argv[1]))&&(argc == 2))
  {
    vtkStdString   temp20;
    temp20 = (op)->GetValidPointsMaskArrayName();
    Tcl_SetResult(interp, const_cast<char *>(temp20.c_str()), TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetNullValue",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetNullValue(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNullValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetNullValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("ClearExcludedArrays",argv[1]))&&(argc == 2))
  {
    op->ClearExcludedArrays();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfExcludedArrays",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfExcludedArrays();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetExcludedArray",argv[1]))&&(argc == 3))
  {
    int      temp0;
    const char    *temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    temp20 = (op)->GetExcludedArray(temp0);
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  }
  if ((!strcmp("SetPromoteOutputArrays",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetPromoteOutputArrays(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("PromoteOutputArraysOn",argv[1]))&&(argc == 2))
  {
    op->PromoteOutputArraysOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PromoteOutputArraysOff",argv[1]))&&(argc == 2))
  {
    op->PromoteOutputArraysOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetPromoteOutputArrays",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetPromoteOutputArrays();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPassPointArrays",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetPassPointArrays(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("PassPointArraysOn",argv[1]))&&(argc == 2))
  {
    op->PassPointArraysOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PassPointArraysOff",argv[1]))&&(argc == 2))
  {
    op->PassPointArraysOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetPassPointArrays",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetPassPointArrays();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPassCellArrays",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetPassCellArrays(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("PassCellArraysOn",argv[1]))&&(argc == 2))
  {
    op->PassCellArraysOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PassCellArraysOff",argv[1]))&&(argc == 2))
  {
    op->PassCellArraysOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetPassCellArrays",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetPassCellArrays();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPassFieldArrays",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetPassFieldArrays(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("PassFieldArraysOn",argv[1]))&&(argc == 2))
  {
    op->PassFieldArraysOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PassFieldArraysOff",argv[1]))&&(argc == 2))
  {
    op->PassFieldArraysOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetPassFieldArrays",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetPassFieldArrays();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetMTime",argv[1]))&&(argc == 2))
  {
    unsigned long long   temp20;
    temp20 = (op)->GetMTime();
    char tempResult[1024];
    sprintf(tempResult,"%llu",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkPointInterpolatorCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkDataSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkPointInterpolator:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetSourceData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSource\n",NULL);
    Tcl_AppendResult(interp,"  SetSourceConnection\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetLocator\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLocator\n",NULL);
    Tcl_AppendResult(interp,"  SetKernel\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetKernel\n",NULL);
    Tcl_AppendResult(interp,"  SetNullPointsStrategy\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNullPointsStrategy\n",NULL);
    Tcl_AppendResult(interp,"  SetNullPointsStrategyToMaskPoints\n",NULL);
    Tcl_AppendResult(interp,"  SetNullPointsStrategyToNullValue\n",NULL);
    Tcl_AppendResult(interp,"  SetNullPointsStrategyToClosestPoint\n",NULL);
    Tcl_AppendResult(interp,"  SetValidPointsMaskArrayName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetValidPointsMaskArrayName\n",NULL);
    Tcl_AppendResult(interp,"  SetNullValue\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNullValue\n",NULL);
    Tcl_AppendResult(interp,"  ClearExcludedArrays\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfExcludedArrays\n",NULL);
    Tcl_AppendResult(interp,"  GetExcludedArray\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetPromoteOutputArrays\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PromoteOutputArraysOn\n",NULL);
    Tcl_AppendResult(interp,"  PromoteOutputArraysOff\n",NULL);
    Tcl_AppendResult(interp,"  GetPromoteOutputArrays\n",NULL);
    Tcl_AppendResult(interp,"  SetPassPointArrays\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PassPointArraysOn\n",NULL);
    Tcl_AppendResult(interp,"  PassPointArraysOff\n",NULL);
    Tcl_AppendResult(interp,"  GetPassPointArrays\n",NULL);
    Tcl_AppendResult(interp,"  SetPassCellArrays\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PassCellArraysOn\n",NULL);
    Tcl_AppendResult(interp,"  PassCellArraysOff\n",NULL);
    Tcl_AppendResult(interp,"  GetPassCellArrays\n",NULL);
    Tcl_AppendResult(interp,"  SetPassFieldArrays\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PassFieldArraysOn\n",NULL);
    Tcl_AppendResult(interp,"  PassFieldArraysOff\n",NULL);
    Tcl_AppendResult(interp,"  GetPassFieldArrays\n",NULL);
    Tcl_AppendResult(interp,"  GetMTime\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkDataSetAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetSourceData" );
    Tcl_DStringAppendElement ( &dString, "GetSource" );
    Tcl_DStringAppendElement ( &dString, "SetSourceConnection" );
    Tcl_DStringAppendElement ( &dString, "SetLocator" );
    Tcl_DStringAppendElement ( &dString, "GetLocator" );
    Tcl_DStringAppendElement ( &dString, "SetKernel" );
    Tcl_DStringAppendElement ( &dString, "GetKernel" );
    Tcl_DStringAppendElement ( &dString, "SetNullPointsStrategy" );
    Tcl_DStringAppendElement ( &dString, "GetNullPointsStrategy" );
    Tcl_DStringAppendElement ( &dString, "SetNullPointsStrategyToMaskPoints" );
    Tcl_DStringAppendElement ( &dString, "SetNullPointsStrategyToNullValue" );
    Tcl_DStringAppendElement ( &dString, "SetNullPointsStrategyToClosestPoint" );
    Tcl_DStringAppendElement ( &dString, "SetValidPointsMaskArrayName" );
    Tcl_DStringAppendElement ( &dString, "GetValidPointsMaskArrayName" );
    Tcl_DStringAppendElement ( &dString, "SetNullValue" );
    Tcl_DStringAppendElement ( &dString, "GetNullValue" );
    Tcl_DStringAppendElement ( &dString, "ClearExcludedArrays" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfExcludedArrays" );
    Tcl_DStringAppendElement ( &dString, "GetExcludedArray" );
    Tcl_DStringAppendElement ( &dString, "SetPromoteOutputArrays" );
    Tcl_DStringAppendElement ( &dString, "PromoteOutputArraysOn" );
    Tcl_DStringAppendElement ( &dString, "PromoteOutputArraysOff" );
    Tcl_DStringAppendElement ( &dString, "GetPromoteOutputArrays" );
    Tcl_DStringAppendElement ( &dString, "SetPassPointArrays" );
    Tcl_DStringAppendElement ( &dString, "PassPointArraysOn" );
    Tcl_DStringAppendElement ( &dString, "PassPointArraysOff" );
    Tcl_DStringAppendElement ( &dString, "GetPassPointArrays" );
    Tcl_DStringAppendElement ( &dString, "SetPassCellArrays" );
    Tcl_DStringAppendElement ( &dString, "PassCellArraysOn" );
    Tcl_DStringAppendElement ( &dString, "PassCellArraysOff" );
    Tcl_DStringAppendElement ( &dString, "GetPassCellArrays" );
    Tcl_DStringAppendElement ( &dString, "SetPassFieldArrays" );
    Tcl_DStringAppendElement ( &dString, "PassFieldArraysOn" );
    Tcl_DStringAppendElement ( &dString, "PassFieldArraysOff" );
    Tcl_DStringAppendElement ( &dString, "GetPassFieldArrays" );
    Tcl_DStringAppendElement ( &dString, "GetMTime" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkDataSetAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkPointInterpolator *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSourceData */
    if ( strcmp ( argv[2], "SetSourceData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSourceData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSourceData */
    Tcl_DStringAppendElement ( &dString, " Specify the dataset Pc that will be probed by the input points P.  The\n Input P defines the dataset structure (the points and cells) for the\n output, while the Source Pc is probed (interpolated) to generate the\n scalars, vectors, etc. for the output points based on the point\n locations.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSourceData(vtkDataObject *source);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetSourceData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSource */
    if ( strcmp ( argv[2], "GetSource" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSource" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSource */
    Tcl_DStringAppendElement ( &dString, " Specify the dataset Pc that will be probed by the input points P.  The\n Input P defines the dataset structure (the points and cells) for the\n output, while the Source Pc is probed (interpolated) to generate the\n scalars, vectors, etc. for the output points based on the point\n locations.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataObject *GetSource();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetSource */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSourceConnection */
    if ( strcmp ( argv[2], "SetSourceConnection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSourceConnection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAlgorithmOutput" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSourceConnection */
    Tcl_DStringAppendElement ( &dString, " Specify the dataset Pc that will be probed by the input points P.  The\n Input P defines the structure (the points and cells) for the output,\n while the Source Pc is probed (interpolated) to generate the scalars,\n vectors, etc. for the output points based on the point locations.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSourceConnection(vtkAlgorithmOutput *algOutput);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetSourceConnection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLocator */
    if ( strcmp ( argv[2], "SetLocator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLocator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPointLocator" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLocator */
    Tcl_DStringAppendElement ( &dString, " Specify a point locator. By default a vtkStaticPointLocator is\n used. The locator performs efficient searches to locate near a\n specified interpolation position.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLocator(vtkAbstractPointLocator *locator);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetLocator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLocator */
    if ( strcmp ( argv[2], "GetLocator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLocator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLocator */
    Tcl_DStringAppendElement ( &dString, " Specify a point locator. By default a vtkStaticPointLocator is\n used. The locator performs efficient searches to locate near a\n specified interpolation position.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPointLocator *GetLocator();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetLocator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetKernel */
    if ( strcmp ( argv[2], "SetKernel" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetKernel" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkInterpolationKernel" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetKernel */
    Tcl_DStringAppendElement ( &dString, " Specify an interpolation kernel. By default a vtkLinearKernel is used\n (i.e., linear combination of closest points). The interpolation kernel\n changes the basis of the interpolation.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetKernel(vtkInterpolationKernel *kernel);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetKernel */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetKernel */
    if ( strcmp ( argv[2], "GetKernel" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetKernel" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetKernel */
    Tcl_DStringAppendElement ( &dString, " Specify an interpolation kernel. By default a vtkLinearKernel is used\n (i.e., linear combination of closest points). The interpolation kernel\n changes the basis of the interpolation.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkInterpolationKernel *GetKernel();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetKernel */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNullPointsStrategy */
    if ( strcmp ( argv[2], "SetNullPointsStrategy" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNullPointsStrategy" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNullPointsStrategy */
    Tcl_DStringAppendElement ( &dString, " Specify a strategy to use when encountering a \"null\" point during the\n interpolation process. Null points occur when the local neighborhood (of\n nearby points to interpolate from) is empty. If the strategy is set to\n MaskPoints, then an output array is created that marks points as being\n valid (=1) or null (invalid =0) (and the NullValue is set as well). If\n the strategy is set to NullValue (this is the default), then the output\n data value(s) are set to the NullPoi ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNullPointsStrategy(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetNullPointsStrategy */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNullPointsStrategy */
    if ( strcmp ( argv[2], "GetNullPointsStrategy" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNullPointsStrategy" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNullPointsStrategy */
    Tcl_DStringAppendElement ( &dString, " Specify a strategy to use when encountering a \"null\" point during the\n interpolation process. Null points occur when the local neighborhood (of\n nearby points to interpolate from) is empty. If the strategy is set to\n MaskPoints, then an output array is created that marks points as being\n valid (=1) or null (invalid =0) (and the NullValue is set as well). If\n the strategy is set to NullValue (this is the default), then the output\n data value(s) are set to the NullPoi ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNullPointsStrategy();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetNullPointsStrategy */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNullPointsStrategyToMaskPoints */
    if ( strcmp ( argv[2], "SetNullPointsStrategyToMaskPoints" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNullPointsStrategyToMaskPoints" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNullPointsStrategyToMaskPoints */
    Tcl_DStringAppendElement ( &dString, " Specify a strategy to use when encountering a \"null\" point during the\n interpolation process. Null points occur when the local neighborhood (of\n nearby points to interpolate from) is empty. If the strategy is set to\n MaskPoints, then an output array is created that marks points as being\n valid (=1) or null (invalid =0) (and the NullValue is set as well). If\n the strategy is set to NullValue (this is the default), then the output\n data value(s) are set to the NullPoi ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNullPointsStrategyToMaskPoints();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetNullPointsStrategyToMaskPoints */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNullPointsStrategyToNullValue */
    if ( strcmp ( argv[2], "SetNullPointsStrategyToNullValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNullPointsStrategyToNullValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNullPointsStrategyToNullValue */
    Tcl_DStringAppendElement ( &dString, " Specify a strategy to use when encountering a \"null\" point during the\n interpolation process. Null points occur when the local neighborhood (of\n nearby points to interpolate from) is empty. If the strategy is set to\n MaskPoints, then an output array is created that marks points as being\n valid (=1) or null (invalid =0) (and the NullValue is set as well). If\n the strategy is set to NullValue (this is the default), then the output\n data value(s) are set to the NullPoi ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNullPointsStrategyToNullValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetNullPointsStrategyToNullValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNullPointsStrategyToClosestPoint */
    if ( strcmp ( argv[2], "SetNullPointsStrategyToClosestPoint" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNullPointsStrategyToClosestPoint" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNullPointsStrategyToClosestPoint */
    Tcl_DStringAppendElement ( &dString, " Specify a strategy to use when encountering a \"null\" point during the\n interpolation process. Null points occur when the local neighborhood (of\n nearby points to interpolate from) is empty. If the strategy is set to\n MaskPoints, then an output array is created that marks points as being\n valid (=1) or null (invalid =0) (and the NullValue is set as well). If\n the strategy is set to NullValue (this is the default), then the output\n data value(s) are set to the NullPoi ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNullPointsStrategyToClosestPoint();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetNullPointsStrategyToClosestPoint */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetValidPointsMaskArrayName */
    if ( strcmp ( argv[2], "SetValidPointsMaskArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetValidPointsMaskArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetValidPointsMaskArrayName */
    Tcl_DStringAppendElement ( &dString, " If the NullPointsStrategy == MASK_POINTS, then an array is generated for\n each input point. This vtkCharArray is placed into the output of the filter,\n with a non-zero value for a valid point, and zero otherwise. The name of\n this masking array is specified here.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetValidPointsMaskArrayName(vtkStdString a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetValidPointsMaskArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetValidPointsMaskArrayName */
    if ( strcmp ( argv[2], "GetValidPointsMaskArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetValidPointsMaskArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetValidPointsMaskArrayName */
    Tcl_DStringAppendElement ( &dString, " If the NullPointsStrategy == MASK_POINTS, then an array is generated for\n each input point. This vtkCharArray is placed into the output of the filter,\n with a non-zero value for a valid point, and zero otherwise. The name of\n this masking array is specified here.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkStdString GetValidPointsMaskArrayName();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetValidPointsMaskArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNullValue */
    if ( strcmp ( argv[2], "SetNullValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNullValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNullValue */
    Tcl_DStringAppendElement ( &dString, " Specify the null point value. When a null point is encountered then all\n components of each null tuple are set to this value. By default the\n null value is set to zero.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNullValue(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetNullValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNullValue */
    if ( strcmp ( argv[2], "GetNullValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNullValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNullValue */
    Tcl_DStringAppendElement ( &dString, " Specify the null point value. When a null point is encountered then all\n components of each null tuple are set to this value. By default the\n null value is set to zero.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetNullValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetNullValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ClearExcludedArrays */
    if ( strcmp ( argv[2], "ClearExcludedArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ClearExcludedArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ClearExcludedArrays */
    Tcl_DStringAppendElement ( &dString, " Clears the contents of excluded array list.\n" );
    Tcl_DStringAppendElement ( &dString, "void ClearExcludedArrays();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for ClearExcludedArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfExcludedArrays */
    if ( strcmp ( argv[2], "GetNumberOfExcludedArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfExcludedArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfExcludedArrays */
    Tcl_DStringAppendElement ( &dString, " Return the number of excluded arrays.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfExcludedArrays();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetNumberOfExcludedArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExcludedArray */
    if ( strcmp ( argv[2], "GetExcludedArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExcludedArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExcludedArray */
    Tcl_DStringAppendElement ( &dString, " Return the name of the ith excluded array.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetExcludedArray(int i);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetExcludedArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPromoteOutputArrays */
    if ( strcmp ( argv[2], "SetPromoteOutputArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPromoteOutputArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPromoteOutputArrays */
    Tcl_DStringAppendElement ( &dString, " If enabled, then input arrays that are non-real types (i.e., not float\n or double) are promoted to float type on output. This is because the\n interpolation process may not be well behaved when integral types are\n combined using interpolation weights.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPromoteOutputArrays(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetPromoteOutputArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PromoteOutputArraysOn */
    if ( strcmp ( argv[2], "PromoteOutputArraysOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PromoteOutputArraysOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PromoteOutputArraysOn */
    Tcl_DStringAppendElement ( &dString, " If enabled, then input arrays that are non-real types (i.e., not float\n or double) are promoted to float type on output. This is because the\n interpolation process may not be well behaved when integral types are\n combined using interpolation weights.\n" );
    Tcl_DStringAppendElement ( &dString, "void PromoteOutputArraysOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for PromoteOutputArraysOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PromoteOutputArraysOff */
    if ( strcmp ( argv[2], "PromoteOutputArraysOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PromoteOutputArraysOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PromoteOutputArraysOff */
    Tcl_DStringAppendElement ( &dString, " If enabled, then input arrays that are non-real types (i.e., not float\n or double) are promoted to float type on output. This is because the\n interpolation process may not be well behaved when integral types are\n combined using interpolation weights.\n" );
    Tcl_DStringAppendElement ( &dString, "void PromoteOutputArraysOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for PromoteOutputArraysOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPromoteOutputArrays */
    if ( strcmp ( argv[2], "GetPromoteOutputArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPromoteOutputArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPromoteOutputArrays */
    Tcl_DStringAppendElement ( &dString, " If enabled, then input arrays that are non-real types (i.e., not float\n or double) are promoted to float type on output. This is because the\n interpolation process may not be well behaved when integral types are\n combined using interpolation weights.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetPromoteOutputArrays();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetPromoteOutputArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPassPointArrays */
    if ( strcmp ( argv[2], "SetPassPointArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPassPointArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPassPointArrays */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to shallow copy the input point data arrays to the\n output.  On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPassPointArrays(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetPassPointArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PassPointArraysOn */
    if ( strcmp ( argv[2], "PassPointArraysOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassPointArraysOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassPointArraysOn */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to shallow copy the input point data arrays to the\n output.  On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassPointArraysOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for PassPointArraysOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PassPointArraysOff */
    if ( strcmp ( argv[2], "PassPointArraysOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassPointArraysOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassPointArraysOff */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to shallow copy the input point data arrays to the\n output.  On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassPointArraysOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for PassPointArraysOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPassPointArrays */
    if ( strcmp ( argv[2], "GetPassPointArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPassPointArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPassPointArrays */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to shallow copy the input point data arrays to the\n output.  On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetPassPointArrays();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetPassPointArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPassCellArrays */
    if ( strcmp ( argv[2], "SetPassCellArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPassCellArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPassCellArrays */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to shallow copy the input cell data arrays to the\n output.  On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPassCellArrays(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetPassCellArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PassCellArraysOn */
    if ( strcmp ( argv[2], "PassCellArraysOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassCellArraysOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassCellArraysOn */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to shallow copy the input cell data arrays to the\n output.  On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassCellArraysOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for PassCellArraysOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PassCellArraysOff */
    if ( strcmp ( argv[2], "PassCellArraysOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassCellArraysOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassCellArraysOff */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to shallow copy the input cell data arrays to the\n output.  On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassCellArraysOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for PassCellArraysOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPassCellArrays */
    if ( strcmp ( argv[2], "GetPassCellArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPassCellArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPassCellArrays */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to shallow copy the input cell data arrays to the\n output.  On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetPassCellArrays();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetPassCellArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPassFieldArrays */
    if ( strcmp ( argv[2], "SetPassFieldArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPassFieldArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPassFieldArrays */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to pass the field-data arrays from the input to the\n output. On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPassFieldArrays(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for SetPassFieldArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PassFieldArraysOn */
    if ( strcmp ( argv[2], "PassFieldArraysOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassFieldArraysOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassFieldArraysOn */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to pass the field-data arrays from the input to the\n output. On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassFieldArraysOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for PassFieldArraysOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PassFieldArraysOff */
    if ( strcmp ( argv[2], "PassFieldArraysOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PassFieldArraysOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PassFieldArraysOff */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to pass the field-data arrays from the input to the\n output. On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "void PassFieldArraysOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for PassFieldArraysOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPassFieldArrays */
    if ( strcmp ( argv[2], "GetPassFieldArrays" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPassFieldArrays" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPassFieldArrays */
    Tcl_DStringAppendElement ( &dString, " Indicate whether to pass the field-data arrays from the input to the\n output. On by default.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetPassFieldArrays();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetPassFieldArrays */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMTime */
    if ( strcmp ( argv[2], "GetMTime" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMTime" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMTime */
    Tcl_DStringAppendElement ( &dString, " Get the MTime of this object also considering the locator and kernel.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkMTimeType GetMTime();" );
    Tcl_DStringAppendElement ( &dString, "vtkPointInterpolator" );
    /* Closing for GetMTime */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkDataSetAlgorithmCppCommand(static_cast<vtkDataSetAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
