// tcl wrapper for vtkSPHKernel object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkSPHKernel.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>
int vtkInterpolationKernelCppCommand(vtkInterpolationKernel *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkSPHKernelCppCommand(vtkSPHKernel *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkSPHKernelCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkSPHKernelCppCommand(static_cast<vtkSPHKernel *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkSPHKernel_TclCreate(Tcl_Interp *interp)
{
  (void)interp;
  return 0;
}

int VTKTCL_EXPORT vtkSPHKernelCppCommand(vtkSPHKernel *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkSPHKernel",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkInterpolationKernelCppCommand(static_cast<vtkInterpolationKernel *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkInterpolationKernel"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkSPHKernel  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkSPHKernel");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkSPHKernel  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkSPHKernel");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSpatialStep",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetSpatialStep(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSpatialStepMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSpatialStepMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSpatialStepMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSpatialStepMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSpatialStep",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSpatialStep();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDimension",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetDimension(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDimensionMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDimensionMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetDimensionMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDimensionMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetDimension",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDimension();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetCutoffFactor",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetCutoffFactor();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetCutoffArray",argv[1]))&&(argc == 3))
  {
    vtkDataArray  *temp0;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
  {
    op->SetCutoffArray(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCutoffArray",argv[1]))&&(argc == 2))
  {
    vtkDataArray  *temp20;
    temp20 = (op)->GetCutoffArray();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataArray");
    return TCL_OK;
  }
  if ((!strcmp("SetDensityArray",argv[1]))&&(argc == 3))
  {
    vtkDataArray  *temp0;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
  {
    op->SetDensityArray(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDensityArray",argv[1]))&&(argc == 2))
  {
    vtkDataArray  *temp20;
    temp20 = (op)->GetDensityArray();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataArray");
    return TCL_OK;
  }
  if ((!strcmp("SetMassArray",argv[1]))&&(argc == 3))
  {
    vtkDataArray  *temp0;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
  {
    op->SetMassArray(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMassArray",argv[1]))&&(argc == 2))
  {
    vtkDataArray  *temp20;
    temp20 = (op)->GetMassArray();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDataArray");
    return TCL_OK;
  }
  if ((!strcmp("Initialize",argv[1]))&&(argc == 5))
  {
    vtkAbstractPointLocator  *temp0;
    vtkDataSet  *temp1;
    vtkPointData  *temp2;
    error = 0;

    temp0 = (vtkAbstractPointLocator *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPointLocator"),interp,error));
    temp1 = (vtkDataSet *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkDataSet"),interp,error));
    temp2 = (vtkPointData *)(vtkTclGetPointerFromObject(argv[4],const_cast<char *>("vtkPointData"),interp,error));
    if (!error)
  {
    op->Initialize(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("ComputeFunctionWeight",argv[1]))&&(argc == 3))
  {
    double   temp0;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->ComputeFunctionWeight(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("ComputeDerivWeight",argv[1]))&&(argc == 3))
  {
    double   temp0;
    double   temp20;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    temp20 = (op)->ComputeDerivWeight(temp0);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNormFactor",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetNormFactor();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkSPHKernelCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkInterpolationKernelCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkSPHKernel:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetSpatialStep\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSpatialStepMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSpatialStepMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSpatialStep\n",NULL);
    Tcl_AppendResult(interp,"  SetDimension\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDimensionMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetDimensionMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetDimension\n",NULL);
    Tcl_AppendResult(interp,"  GetCutoffFactor\n",NULL);
    Tcl_AppendResult(interp,"  SetCutoffArray\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCutoffArray\n",NULL);
    Tcl_AppendResult(interp,"  SetDensityArray\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDensityArray\n",NULL);
    Tcl_AppendResult(interp,"  SetMassArray\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMassArray\n",NULL);
    Tcl_AppendResult(interp,"  Initialize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  ComputeFunctionWeight\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  ComputeDerivWeight\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNormFactor\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkInterpolationKernelCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetSpatialStep" );
    Tcl_DStringAppendElement ( &dString, "GetSpatialStepMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetSpatialStepMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetSpatialStep" );
    Tcl_DStringAppendElement ( &dString, "SetDimension" );
    Tcl_DStringAppendElement ( &dString, "GetDimensionMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetDimensionMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetDimension" );
    Tcl_DStringAppendElement ( &dString, "GetCutoffFactor" );
    Tcl_DStringAppendElement ( &dString, "SetCutoffArray" );
    Tcl_DStringAppendElement ( &dString, "GetCutoffArray" );
    Tcl_DStringAppendElement ( &dString, "SetDensityArray" );
    Tcl_DStringAppendElement ( &dString, "GetDensityArray" );
    Tcl_DStringAppendElement ( &dString, "SetMassArray" );
    Tcl_DStringAppendElement ( &dString, "GetMassArray" );
    Tcl_DStringAppendElement ( &dString, "Initialize" );
    Tcl_DStringAppendElement ( &dString, "ComputeFunctionWeight" );
    Tcl_DStringAppendElement ( &dString, "ComputeDerivWeight" );
    Tcl_DStringAppendElement ( &dString, "GetNormFactor" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkInterpolationKernelCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiation, obtaining type information, and printing.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiation, obtaining type information, and printing.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiation, obtaining type information, and printing.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiation, obtaining type information, and printing.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSpatialStep */
    if ( strcmp ( argv[2], "SetSpatialStep" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSpatialStep" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSpatialStep */
    Tcl_DStringAppendElement ( &dString, " The user defined intial particle spatial step. This is also referred to as\n the smoothing length.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSpatialStep(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for SetSpatialStep */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSpatialStepMinValue */
    if ( strcmp ( argv[2], "GetSpatialStepMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSpatialStepMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSpatialStepMinValue */
    Tcl_DStringAppendElement ( &dString, " The user defined intial particle spatial step. This is also referred to as\n the smoothing length.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetSpatialStepMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetSpatialStepMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSpatialStepMaxValue */
    if ( strcmp ( argv[2], "GetSpatialStepMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSpatialStepMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSpatialStepMaxValue */
    Tcl_DStringAppendElement ( &dString, " The user defined intial particle spatial step. This is also referred to as\n the smoothing length.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetSpatialStepMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetSpatialStepMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSpatialStep */
    if ( strcmp ( argv[2], "GetSpatialStep" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSpatialStep" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSpatialStep */
    Tcl_DStringAppendElement ( &dString, " The user defined intial particle spatial step. This is also referred to as\n the smoothing length.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetSpatialStep();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetSpatialStep */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDimension */
    if ( strcmp ( argv[2], "SetDimension" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDimension" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDimension */
    Tcl_DStringAppendElement ( &dString, " The domain dimension, default to 3.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDimension(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for SetDimension */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDimensionMinValue */
    if ( strcmp ( argv[2], "GetDimensionMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDimensionMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDimensionMinValue */
    Tcl_DStringAppendElement ( &dString, " The domain dimension, default to 3.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDimensionMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetDimensionMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDimensionMaxValue */
    if ( strcmp ( argv[2], "GetDimensionMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDimensionMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDimensionMaxValue */
    Tcl_DStringAppendElement ( &dString, " The domain dimension, default to 3.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDimensionMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetDimensionMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDimension */
    if ( strcmp ( argv[2], "GetDimension" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDimension" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDimension */
    Tcl_DStringAppendElement ( &dString, " The domain dimension, default to 3.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDimension();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetDimension */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCutoffFactor */
    if ( strcmp ( argv[2], "GetCutoffFactor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCutoffFactor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCutoffFactor */
    Tcl_DStringAppendElement ( &dString, " Return the cutoff factor. This is hard wired into the kernel (e.g., the\n vtkSPHQuinticKernel has a cutoff factor = 3.0).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetCutoffFactor();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetCutoffFactor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetCutoffArray */
    if ( strcmp ( argv[2], "SetCutoffArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCutoffArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCutoffArray */
    Tcl_DStringAppendElement ( &dString, " Specify the (optional) array defining a cutoff distance. If provided this\n distance is used to find the interpolating points within the local\n neighborbood. Otherwise the cutoff distance is defined as the cutoff\n factor times the spatial step size.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetCutoffArray(vtkDataArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for SetCutoffArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCutoffArray */
    if ( strcmp ( argv[2], "GetCutoffArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCutoffArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCutoffArray */
    Tcl_DStringAppendElement ( &dString, " Specify the (optional) array defining a cutoff distance. If provided this\n distance is used to find the interpolating points within the local\n neighborbood. Otherwise the cutoff distance is defined as the cutoff\n factor times the spatial step size.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray *GetCutoffArray();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetCutoffArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDensityArray */
    if ( strcmp ( argv[2], "SetDensityArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDensityArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDensityArray */
    Tcl_DStringAppendElement ( &dString, " Specify the (optional) density array. Used with the mass array to\n compute local particle volumes.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetDensityArray(vtkDataArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for SetDensityArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDensityArray */
    if ( strcmp ( argv[2], "GetDensityArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDensityArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDensityArray */
    Tcl_DStringAppendElement ( &dString, " Specify the (optional) density array. Used with the mass array to\n compute local particle volumes.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray *GetDensityArray();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetDensityArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMassArray */
    if ( strcmp ( argv[2], "SetMassArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMassArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMassArray */
    Tcl_DStringAppendElement ( &dString, " Specify the (optional) mass array. Used with the density array to\n compute local particle volumes.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetMassArray(vtkDataArray *);" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for SetMassArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMassArray */
    if ( strcmp ( argv[2], "GetMassArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMassArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMassArray */
    Tcl_DStringAppendElement ( &dString, " Specify the (optional) mass array. Used with the density array to\n compute local particle volumes.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray *GetMassArray();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetMassArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Initialize */
    if ( strcmp ( argv[2], "Initialize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Initialize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPointLocator" );
    Tcl_DStringAppendElement ( &dString, "vtkDataSet" );
    Tcl_DStringAppendElement ( &dString, "vtkPointData" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Initialize */
    Tcl_DStringAppendElement ( &dString, " Produce the computational parameters for the kernel. Invoke this method\n after setting initial values like SpatialStep.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void Initialize(vtkAbstractPointLocator *loc, vtkDataSet *ds, vtkPointData *pd);" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for Initialize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ComputeFunctionWeight */
    if ( strcmp ( argv[2], "ComputeFunctionWeight" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeFunctionWeight" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeFunctionWeight */
    Tcl_DStringAppendElement ( &dString, " Compute weighting factor given a normalized distance from a sample point.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual double ComputeFunctionWeight(const double d) = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for ComputeFunctionWeight */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ComputeDerivWeight */
    if ( strcmp ( argv[2], "ComputeDerivWeight" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeDerivWeight" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeDerivWeight */
    Tcl_DStringAppendElement ( &dString, " Compute weighting factor for derivative quantities given a normalized\n distance from a sample point.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual double ComputeDerivWeight(const double d) = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for ComputeDerivWeight */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNormFactor */
    if ( strcmp ( argv[2], "GetNormFactor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNormFactor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNormFactor */
    Tcl_DStringAppendElement ( &dString, " Return the SPH normalization factor. This also includes the contribution\n of 1/h^d, where h is the smoothing length (i.e., spatial step) and d is\n the dimension of the kernel. The returned value is only valid after the\n kernel is initialized.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetNormFactor();" );
    Tcl_DStringAppendElement ( &dString, "vtkSPHKernel" );
    /* Closing for GetNormFactor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkInterpolationKernelCppCommand(static_cast<vtkInterpolationKernel *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
