// tcl wrapper for vtkStatisticalOutlierRemoval object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkStatisticalOutlierRemoval.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkStatisticalOutlierRemovalNewCommand()
{
  vtkStatisticalOutlierRemoval *temp = vtkStatisticalOutlierRemoval::New();
  return static_cast<ClientData>(temp);
}

int vtkPointCloudFilterCppCommand(vtkPointCloudFilter *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkStatisticalOutlierRemovalCppCommand(vtkStatisticalOutlierRemoval *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkStatisticalOutlierRemovalCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkStatisticalOutlierRemovalCppCommand(static_cast<vtkStatisticalOutlierRemoval *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkStatisticalOutlierRemoval_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkStatisticalOutlierRemoval"),vtkStatisticalOutlierRemovalNewCommand,vtkStatisticalOutlierRemovalCommand);
  return 0;
}

int VTKTCL_EXPORT vtkStatisticalOutlierRemovalCppCommand(vtkStatisticalOutlierRemoval *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkStatisticalOutlierRemoval",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkPointCloudFilterCppCommand(static_cast<vtkPointCloudFilter *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkPointCloudFilter"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkStatisticalOutlierRemoval  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkStatisticalOutlierRemoval");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkStatisticalOutlierRemoval  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkStatisticalOutlierRemoval");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkStatisticalOutlierRemoval  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkStatisticalOutlierRemoval");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSampleSize",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetSampleSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSampleSizeMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSampleSizeMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSampleSizeMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSampleSizeMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSampleSize",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetSampleSize();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetStandardDeviationFactor",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetStandardDeviationFactor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetStandardDeviationFactorMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetStandardDeviationFactorMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetStandardDeviationFactorMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetStandardDeviationFactorMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetStandardDeviationFactor",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetStandardDeviationFactor();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetLocator",argv[1]))&&(argc == 3))
  {
    vtkAbstractPointLocator  *temp0;
    error = 0;

    temp0 = (vtkAbstractPointLocator *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAbstractPointLocator"),interp,error));
    if (!error)
  {
    op->SetLocator(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLocator",argv[1]))&&(argc == 2))
  {
    vtkAbstractPointLocator  *temp20;
    temp20 = (op)->GetLocator();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAbstractPointLocator");
    return TCL_OK;
  }
  if ((!strcmp("SetComputedMean",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetComputedMean(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetComputedMeanMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetComputedMeanMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetComputedMeanMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetComputedMeanMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetComputedMean",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetComputedMean();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetComputedStandardDeviation",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetComputedStandardDeviation(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetComputedStandardDeviationMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetComputedStandardDeviationMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetComputedStandardDeviationMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetComputedStandardDeviationMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetComputedStandardDeviation",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetComputedStandardDeviation();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkStatisticalOutlierRemovalCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkPointCloudFilterCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkStatisticalOutlierRemoval:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetSampleSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSampleSizeMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSampleSizeMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSampleSize\n",NULL);
    Tcl_AppendResult(interp,"  SetStandardDeviationFactor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetStandardDeviationFactorMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetStandardDeviationFactorMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetStandardDeviationFactor\n",NULL);
    Tcl_AppendResult(interp,"  SetLocator\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLocator\n",NULL);
    Tcl_AppendResult(interp,"  SetComputedMean\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetComputedMeanMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetComputedMeanMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetComputedMean\n",NULL);
    Tcl_AppendResult(interp,"  SetComputedStandardDeviation\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetComputedStandardDeviationMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetComputedStandardDeviationMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetComputedStandardDeviation\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkPointCloudFilterCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetSampleSize" );
    Tcl_DStringAppendElement ( &dString, "GetSampleSizeMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetSampleSizeMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetSampleSize" );
    Tcl_DStringAppendElement ( &dString, "SetStandardDeviationFactor" );
    Tcl_DStringAppendElement ( &dString, "GetStandardDeviationFactorMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetStandardDeviationFactorMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetStandardDeviationFactor" );
    Tcl_DStringAppendElement ( &dString, "SetLocator" );
    Tcl_DStringAppendElement ( &dString, "GetLocator" );
    Tcl_DStringAppendElement ( &dString, "SetComputedMean" );
    Tcl_DStringAppendElement ( &dString, "GetComputedMeanMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetComputedMeanMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetComputedMean" );
    Tcl_DStringAppendElement ( &dString, "SetComputedStandardDeviation" );
    Tcl_DStringAppendElement ( &dString, "GetComputedStandardDeviationMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetComputedStandardDeviationMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetComputedStandardDeviation" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkPointCloudFilterCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkStatisticalOutlierRemoval *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSampleSize */
    if ( strcmp ( argv[2], "SetSampleSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSampleSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSampleSize */
    Tcl_DStringAppendElement ( &dString, " For each point sampled, specify the number of the closest, surrounding\n points used to compute statistics. By default 25 points are used. Smaller\n numbers may speed performance.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSampleSize(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for SetSampleSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSampleSizeMinValue */
    if ( strcmp ( argv[2], "GetSampleSizeMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSampleSizeMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSampleSizeMinValue */
    Tcl_DStringAppendElement ( &dString, " For each point sampled, specify the number of the closest, surrounding\n points used to compute statistics. By default 25 points are used. Smaller\n numbers may speed performance.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSampleSizeMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetSampleSizeMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSampleSizeMaxValue */
    if ( strcmp ( argv[2], "GetSampleSizeMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSampleSizeMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSampleSizeMaxValue */
    Tcl_DStringAppendElement ( &dString, " For each point sampled, specify the number of the closest, surrounding\n points used to compute statistics. By default 25 points are used. Smaller\n numbers may speed performance.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSampleSizeMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetSampleSizeMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSampleSize */
    if ( strcmp ( argv[2], "GetSampleSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSampleSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSampleSize */
    Tcl_DStringAppendElement ( &dString, " For each point sampled, specify the number of the closest, surrounding\n points used to compute statistics. By default 25 points are used. Smaller\n numbers may speed performance.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetSampleSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetSampleSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetStandardDeviationFactor */
    if ( strcmp ( argv[2], "SetStandardDeviationFactor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetStandardDeviationFactor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetStandardDeviationFactor */
    Tcl_DStringAppendElement ( &dString, " The filter uses this specified standard deviation factor to extract\n points. By default, points within 1.0 standard deviations (i.e., a\n StandardDeviationFactor=1.0) of the mean distance to neighboring\n points are retained.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetStandardDeviationFactor(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for SetStandardDeviationFactor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetStandardDeviationFactorMinValue */
    if ( strcmp ( argv[2], "GetStandardDeviationFactorMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetStandardDeviationFactorMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetStandardDeviationFactorMinValue */
    Tcl_DStringAppendElement ( &dString, " The filter uses this specified standard deviation factor to extract\n points. By default, points within 1.0 standard deviations (i.e., a\n StandardDeviationFactor=1.0) of the mean distance to neighboring\n points are retained.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetStandardDeviationFactorMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetStandardDeviationFactorMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetStandardDeviationFactorMaxValue */
    if ( strcmp ( argv[2], "GetStandardDeviationFactorMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetStandardDeviationFactorMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetStandardDeviationFactorMaxValue */
    Tcl_DStringAppendElement ( &dString, " The filter uses this specified standard deviation factor to extract\n points. By default, points within 1.0 standard deviations (i.e., a\n StandardDeviationFactor=1.0) of the mean distance to neighboring\n points are retained.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetStandardDeviationFactorMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetStandardDeviationFactorMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetStandardDeviationFactor */
    if ( strcmp ( argv[2], "GetStandardDeviationFactor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetStandardDeviationFactor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetStandardDeviationFactor */
    Tcl_DStringAppendElement ( &dString, " The filter uses this specified standard deviation factor to extract\n points. By default, points within 1.0 standard deviations (i.e., a\n StandardDeviationFactor=1.0) of the mean distance to neighboring\n points are retained.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetStandardDeviationFactor();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetStandardDeviationFactor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLocator */
    if ( strcmp ( argv[2], "SetLocator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLocator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPointLocator" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLocator */
    Tcl_DStringAppendElement ( &dString, " Specify a point locator. By default a vtkStaticPointLocator is\n used. The locator performs efficient searches to locate points\n surroinding a sample point.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLocator(vtkAbstractPointLocator *locator);" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for SetLocator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLocator */
    if ( strcmp ( argv[2], "GetLocator" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLocator" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLocator */
    Tcl_DStringAppendElement ( &dString, " Specify a point locator. By default a vtkStaticPointLocator is\n used. The locator performs efficient searches to locate points\n surroinding a sample point.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractPointLocator *GetLocator();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetLocator */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetComputedMean */
    if ( strcmp ( argv[2], "SetComputedMean" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetComputedMean" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetComputedMean */
    Tcl_DStringAppendElement ( &dString, " After execution, return the value of the computed mean. Before execution\n the value returned is invalid.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetComputedMean(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for SetComputedMean */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetComputedMeanMinValue */
    if ( strcmp ( argv[2], "GetComputedMeanMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetComputedMeanMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetComputedMeanMinValue */
    Tcl_DStringAppendElement ( &dString, " After execution, return the value of the computed mean. Before execution\n the value returned is invalid.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetComputedMeanMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetComputedMeanMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetComputedMeanMaxValue */
    if ( strcmp ( argv[2], "GetComputedMeanMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetComputedMeanMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetComputedMeanMaxValue */
    Tcl_DStringAppendElement ( &dString, " After execution, return the value of the computed mean. Before execution\n the value returned is invalid.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetComputedMeanMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetComputedMeanMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetComputedMean */
    if ( strcmp ( argv[2], "GetComputedMean" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetComputedMean" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetComputedMean */
    Tcl_DStringAppendElement ( &dString, " After execution, return the value of the computed mean. Before execution\n the value returned is invalid.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetComputedMean();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetComputedMean */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetComputedStandardDeviation */
    if ( strcmp ( argv[2], "SetComputedStandardDeviation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetComputedStandardDeviation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetComputedStandardDeviation */
    Tcl_DStringAppendElement ( &dString, " After execution, return the value of the computed sigma (standard\n deviation). Before execution the value returned is invalid.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetComputedStandardDeviation(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for SetComputedStandardDeviation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetComputedStandardDeviationMinValue */
    if ( strcmp ( argv[2], "GetComputedStandardDeviationMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetComputedStandardDeviationMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetComputedStandardDeviationMinValue */
    Tcl_DStringAppendElement ( &dString, " After execution, return the value of the computed sigma (standard\n deviation). Before execution the value returned is invalid.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetComputedStandardDeviationMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetComputedStandardDeviationMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetComputedStandardDeviationMaxValue */
    if ( strcmp ( argv[2], "GetComputedStandardDeviationMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetComputedStandardDeviationMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetComputedStandardDeviationMaxValue */
    Tcl_DStringAppendElement ( &dString, " After execution, return the value of the computed sigma (standard\n deviation). Before execution the value returned is invalid.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetComputedStandardDeviationMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetComputedStandardDeviationMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetComputedStandardDeviation */
    if ( strcmp ( argv[2], "GetComputedStandardDeviation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetComputedStandardDeviation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetComputedStandardDeviation */
    Tcl_DStringAppendElement ( &dString, " After execution, return the value of the computed sigma (standard\n deviation). Before execution the value returned is invalid.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetComputedStandardDeviation();" );
    Tcl_DStringAppendElement ( &dString, "vtkStatisticalOutlierRemoval" );
    /* Closing for GetComputedStandardDeviation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkPointCloudFilterCppCommand(static_cast<vtkPointCloudFilter *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
