// tcl wrapper for vtkVoxelGrid object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkVoxelGrid.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkVoxelGridNewCommand()
{
  vtkVoxelGrid *temp = vtkVoxelGrid::New();
  return static_cast<ClientData>(temp);
}

int vtkPolyDataAlgorithmCppCommand(vtkPolyDataAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkVoxelGridCppCommand(vtkVoxelGrid *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkVoxelGridCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkVoxelGridCppCommand(static_cast<vtkVoxelGrid *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkVoxelGrid_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkVoxelGrid"),vtkVoxelGridNewCommand,vtkVoxelGridCommand);
  return 0;
}

int VTKTCL_EXPORT vtkVoxelGridCppCommand(vtkVoxelGrid *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkVoxelGrid",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkPolyDataAlgorithmCppCommand(static_cast<vtkPolyDataAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkPolyDataAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkVoxelGrid  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkVoxelGrid");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkVoxelGrid  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkVoxelGrid");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkVoxelGrid  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkVoxelGrid");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetConfigurationStyle",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetConfigurationStyle(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetConfigurationStyle",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetConfigurationStyle();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetConfigurationStyleToManual",argv[1]))&&(argc == 2))
  {
    op->SetConfigurationStyleToManual();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetConfigurationStyleToLeafSize",argv[1]))&&(argc == 2))
  {
    op->SetConfigurationStyleToLeafSize();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetConfigurationStyleToAutomatic",argv[1]))&&(argc == 2))
  {
    op->SetConfigurationStyleToAutomatic();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetDivisions",argv[1]))&&(argc == 5))
  {
    int      temp0;
    int      temp1;
    int      temp2;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (!error)
  {
    op->SetDivisions(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetDivisions",argv[1]))&&(argc == 5))
  {
    int    temp0[3];
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0[0] = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp0[1] = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp0[2] = tempi;
    if (!error)
  {
    op->SetDivisions(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDivisions",argv[1]))&&(argc == 2))
  {
    int     *temp20;
    temp20 = (op)->GetDivisions();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      sprintf(tempResult,"%i %i %i ",temp20[0],temp20[1],temp20[2]);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetLeafSize",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    op->SetLeafSize(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetLeafSize",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    op->SetLeafSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLeafSize",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetLeafSize();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetNumberOfPointsPerBin",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNumberOfPointsPerBin(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfPointsPerBinMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfPointsPerBinMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfPointsPerBinMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfPointsPerBinMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfPointsPerBin",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfPointsPerBin();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetKernel",argv[1]))&&(argc == 3))
  {
    vtkInterpolationKernel  *temp0;
    error = 0;

    temp0 = (vtkInterpolationKernel *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkInterpolationKernel"),interp,error));
    if (!error)
  {
    op->SetKernel(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetKernel",argv[1]))&&(argc == 2))
  {
    vtkInterpolationKernel  *temp20;
    temp20 = (op)->GetKernel();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkInterpolationKernel");
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkVoxelGridCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkPolyDataAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkVoxelGrid:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetConfigurationStyle\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetConfigurationStyle\n",NULL);
    Tcl_AppendResult(interp,"  SetConfigurationStyleToManual\n",NULL);
    Tcl_AppendResult(interp,"  SetConfigurationStyleToLeafSize\n",NULL);
    Tcl_AppendResult(interp,"  SetConfigurationStyleToAutomatic\n",NULL);
    Tcl_AppendResult(interp,"  SetDivisions\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetDivisions\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetDivisions\n",NULL);
    Tcl_AppendResult(interp,"  SetLeafSize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetLeafSize\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetLeafSize\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfPointsPerBin\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfPointsPerBinMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfPointsPerBinMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfPointsPerBin\n",NULL);
    Tcl_AppendResult(interp,"  SetKernel\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetKernel\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkPolyDataAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetConfigurationStyle" );
    Tcl_DStringAppendElement ( &dString, "GetConfigurationStyle" );
    Tcl_DStringAppendElement ( &dString, "SetConfigurationStyleToManual" );
    Tcl_DStringAppendElement ( &dString, "SetConfigurationStyleToLeafSize" );
    Tcl_DStringAppendElement ( &dString, "SetConfigurationStyleToAutomatic" );
    Tcl_DStringAppendElement ( &dString, "SetDivisions" );
    Tcl_DStringAppendElement ( &dString, "SetDivisions" );
    Tcl_DStringAppendElement ( &dString, "GetDivisions" );
    Tcl_DStringAppendElement ( &dString, "SetLeafSize" );
    Tcl_DStringAppendElement ( &dString, "SetLeafSize" );
    Tcl_DStringAppendElement ( &dString, "GetLeafSize" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfPointsPerBin" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPointsPerBinMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPointsPerBinMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPointsPerBin" );
    Tcl_DStringAppendElement ( &dString, "SetKernel" );
    Tcl_DStringAppendElement ( &dString, "GetKernel" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkPolyDataAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkVoxelGrid *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Standard methods for instantiating, obtaining type information, and\n printing information.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetConfigurationStyle */
    if ( strcmp ( argv[2], "SetConfigurationStyle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetConfigurationStyle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetConfigurationStyle */
    Tcl_DStringAppendElement ( &dString, " Configure how the filter is to operate. The user can choose to manually\n specify the binning volume (by setting its dimensions via MANUAL style); or\n specify a leaf bin size in the x-y-z directions (SPECIFY_LEAF_SIZE); or\n in AUTOMATIC style, use a rough average number of points in each bin\n guide the bin size and binning volume dimensions. By default, AUTOMATIC\n configuration style is used.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetConfigurationStyle(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SetConfigurationStyle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetConfigurationStyle */
    if ( strcmp ( argv[2], "GetConfigurationStyle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetConfigurationStyle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetConfigurationStyle */
    Tcl_DStringAppendElement ( &dString, " Configure how the filter is to operate. The user can choose to manually\n specify the binning volume (by setting its dimensions via MANUAL style); or\n specify a leaf bin size in the x-y-z directions (SPECIFY_LEAF_SIZE); or\n in AUTOMATIC style, use a rough average number of points in each bin\n guide the bin size and binning volume dimensions. By default, AUTOMATIC\n configuration style is used.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetConfigurationStyle();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for GetConfigurationStyle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetConfigurationStyleToManual */
    if ( strcmp ( argv[2], "SetConfigurationStyleToManual" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetConfigurationStyleToManual" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetConfigurationStyleToManual */
    Tcl_DStringAppendElement ( &dString, " Configure how the filter is to operate. The user can choose to manually\n specify the binning volume (by setting its dimensions via MANUAL style); or\n specify a leaf bin size in the x-y-z directions (SPECIFY_LEAF_SIZE); or\n in AUTOMATIC style, use a rough average number of points in each bin\n guide the bin size and binning volume dimensions. By default, AUTOMATIC\n configuration style is used.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetConfigurationStyleToManual();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SetConfigurationStyleToManual */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetConfigurationStyleToLeafSize */
    if ( strcmp ( argv[2], "SetConfigurationStyleToLeafSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetConfigurationStyleToLeafSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetConfigurationStyleToLeafSize */
    Tcl_DStringAppendElement ( &dString, " Configure how the filter is to operate. The user can choose to manually\n specify the binning volume (by setting its dimensions via MANUAL style); or\n specify a leaf bin size in the x-y-z directions (SPECIFY_LEAF_SIZE); or\n in AUTOMATIC style, use a rough average number of points in each bin\n guide the bin size and binning volume dimensions. By default, AUTOMATIC\n configuration style is used.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetConfigurationStyleToLeafSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SetConfigurationStyleToLeafSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetConfigurationStyleToAutomatic */
    if ( strcmp ( argv[2], "SetConfigurationStyleToAutomatic" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetConfigurationStyleToAutomatic" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetConfigurationStyleToAutomatic */
    Tcl_DStringAppendElement ( &dString, " Configure how the filter is to operate. The user can choose to manually\n specify the binning volume (by setting its dimensions via MANUAL style); or\n specify a leaf bin size in the x-y-z directions (SPECIFY_LEAF_SIZE); or\n in AUTOMATIC style, use a rough average number of points in each bin\n guide the bin size and binning volume dimensions. By default, AUTOMATIC\n configuration style is used.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetConfigurationStyleToAutomatic();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SetConfigurationStyleToAutomatic */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDivisions */
    if ( strcmp ( argv[2], "SetDivisions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDivisions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDivisions */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetDivisions(int, int, int);" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SetDivisions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDivisions */
    if ( strcmp ( argv[2], "SetDivisions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDivisions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDivisions */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetDivisions(int a\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SetDivisions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDivisions */
    if ( strcmp ( argv[2], "GetDivisions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDivisions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDivisions */
    Tcl_DStringAppendElement ( &dString, " Set the number of divisions in x-y-z directions (the binning volume\n dimensions). This data member is used when the configuration style is\n set to MANUAL.\n" );
    Tcl_DStringAppendElement ( &dString, "int *GetDivisions();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for GetDivisions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLeafSize */
    if ( strcmp ( argv[2], "SetLeafSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLeafSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLeafSize */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetLeafSize(double, double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SetLeafSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLeafSize */
    if ( strcmp ( argv[2], "SetLeafSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLeafSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLeafSize */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetLeafSize(double a\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SetLeafSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLeafSize */
    if ( strcmp ( argv[2], "GetLeafSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLeafSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLeafSize */
    Tcl_DStringAppendElement ( &dString, " Set the bin size in the x-y-z directions. This data member is\n used when the configuration style is set to SPECIFY_LEAF_SIZE. The class will\n use these x-y-z lengths, within the bounding box of the point cloud,\n to determine the binning dimensions.\n" );
    Tcl_DStringAppendElement ( &dString, "double *GetLeafSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for GetLeafSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfPointsPerBin */
    if ( strcmp ( argv[2], "SetNumberOfPointsPerBin" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfPointsPerBin" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfPointsPerBin */
    Tcl_DStringAppendElement ( &dString, " Specify the average number of points in each bin. Larger values\n result in higher rates of subsampling. This data member is used when the\n configuration style is set to AUTOMATIC. The class will automatically\n determine the binning dimensions in the x-y-z directions.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNumberOfPointsPerBin(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SetNumberOfPointsPerBin */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfPointsPerBinMinValue */
    if ( strcmp ( argv[2], "GetNumberOfPointsPerBinMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPointsPerBinMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfPointsPerBinMinValue */
    Tcl_DStringAppendElement ( &dString, " Specify the average number of points in each bin. Larger values\n result in higher rates of subsampling. This data member is used when the\n configuration style is set to AUTOMATIC. The class will automatically\n determine the binning dimensions in the x-y-z directions.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfPointsPerBinMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for GetNumberOfPointsPerBinMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfPointsPerBinMaxValue */
    if ( strcmp ( argv[2], "GetNumberOfPointsPerBinMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPointsPerBinMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfPointsPerBinMaxValue */
    Tcl_DStringAppendElement ( &dString, " Specify the average number of points in each bin. Larger values\n result in higher rates of subsampling. This data member is used when the\n configuration style is set to AUTOMATIC. The class will automatically\n determine the binning dimensions in the x-y-z directions.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfPointsPerBinMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for GetNumberOfPointsPerBinMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfPointsPerBin */
    if ( strcmp ( argv[2], "GetNumberOfPointsPerBin" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPointsPerBin" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfPointsPerBin */
    Tcl_DStringAppendElement ( &dString, " Specify the average number of points in each bin. Larger values\n result in higher rates of subsampling. This data member is used when the\n configuration style is set to AUTOMATIC. The class will automatically\n determine the binning dimensions in the x-y-z directions.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfPointsPerBin();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for GetNumberOfPointsPerBin */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetKernel */
    if ( strcmp ( argv[2], "SetKernel" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetKernel" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkInterpolationKernel" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetKernel */
    Tcl_DStringAppendElement ( &dString, " Specify an interpolation kernel to combine the point attributes. By\n default a vtkLinearKernel is used (i.e., average values). The\n interpolation kernel changes the basis of the interpolation.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetKernel(vtkInterpolationKernel *kernel);" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for SetKernel */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetKernel */
    if ( strcmp ( argv[2], "GetKernel" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetKernel" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetKernel */
    Tcl_DStringAppendElement ( &dString, " Specify an interpolation kernel to combine the point attributes. By\n default a vtkLinearKernel is used (i.e., average values). The\n interpolation kernel changes the basis of the interpolation.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkInterpolationKernel *GetKernel();" );
    Tcl_DStringAppendElement ( &dString, "vtkVoxelGrid" );
    /* Closing for GetKernel */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkPolyDataAlgorithmCppCommand(static_cast<vtkPolyDataAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
