#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkSMPContourGrid_TclCreate(Tcl_Interp *interp);
int vtkSMPContourGridManyPieces_TclCreate(Tcl_Interp *interp);
int vtkSMPMergePoints_TclCreate(Tcl_Interp *interp);
int vtkThreadedSynchronizedTemplates3D_TclCreate(Tcl_Interp *interp);
int vtkThreadedSynchronizedTemplatesCutter3D_TclCreate(Tcl_Interp *interp);
int vtkSMPTransform_TclCreate(Tcl_Interp *interp);
int vtkSMPWarpVector_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkfilterssmptcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkfilterssmptcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkfilterssmptcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkfilterssmptcl_Init(interp);
}


int VTK_EXPORT Vtkfilterssmptcl_Init(Tcl_Interp *interp)
{

  vtkSMPContourGrid_TclCreate(interp);
  vtkSMPContourGridManyPieces_TclCreate(interp);
  vtkSMPMergePoints_TclCreate(interp);
  vtkThreadedSynchronizedTemplates3D_TclCreate(interp);
  vtkThreadedSynchronizedTemplatesCutter3D_TclCreate(interp);
  vtkSMPTransform_TclCreate(interp);
  vtkSMPWarpVector_TclCreate(interp);
  char pkgName[]="vtkFiltersSMPTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
