// tcl wrapper for vtkHighestDensityRegionsStatistics object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkHighestDensityRegionsStatistics.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkHighestDensityRegionsStatisticsNewCommand()
{
  vtkHighestDensityRegionsStatistics *temp = vtkHighestDensityRegionsStatistics::New();
  return static_cast<ClientData>(temp);
}

int vtkStatisticsAlgorithmCppCommand(vtkStatisticsAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkHighestDensityRegionsStatisticsCppCommand(vtkHighestDensityRegionsStatistics *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkHighestDensityRegionsStatisticsCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkHighestDensityRegionsStatisticsCppCommand(static_cast<vtkHighestDensityRegionsStatistics *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkHighestDensityRegionsStatistics_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkHighestDensityRegionsStatistics"),vtkHighestDensityRegionsStatisticsNewCommand,vtkHighestDensityRegionsStatisticsCommand);
  return 0;
}

int VTKTCL_EXPORT vtkHighestDensityRegionsStatisticsCppCommand(vtkHighestDensityRegionsStatistics *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkHighestDensityRegionsStatistics",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkStatisticsAlgorithmCppCommand(static_cast<vtkStatisticsAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkStatisticsAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkHighestDensityRegionsStatistics  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHighestDensityRegionsStatistics");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkHighestDensityRegionsStatistics  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHighestDensityRegionsStatistics");
    return TCL_OK;
  }
  }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkHighestDensityRegionsStatistics  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHighestDensityRegionsStatistics");
    return TCL_OK;
  }
  if ((!strcmp("Aggregate",argv[1]))&&(argc == 4))
  {
    vtkDataObjectCollection  *temp0;
    vtkMultiBlockDataSet  *temp1;
    error = 0;

    temp0 = (vtkDataObjectCollection *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataObjectCollection"),interp,error));
    temp1 = (vtkMultiBlockDataSet *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkMultiBlockDataSet"),interp,error));
    if (!error)
  {
    op->Aggregate(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSigma",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetSigma(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSigmaMatrix",argv[1]))&&(argc == 6))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double   temp3;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp3 = tempd;
    if (!error)
  {
    op->SetSigmaMatrix(temp0,temp1,temp2,temp3);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("ComputeHDR",argv[1]))&&(argc == 4))
  {
    vtkDataArray  *temp0;
    vtkDataArray  *temp1;
    double   temp20;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    temp1 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
  {
    temp20 = (op)->ComputeHDR(temp0,temp1);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("ComputeHDR",argv[1]))&&(argc == 5))
  {
    vtkDataArray  *temp0;
    vtkDataArray  *temp1;
    vtkDataArray  *temp2;
    double   temp20;
    error = 0;

    temp0 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataArray"),interp,error));
    temp1 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkDataArray"),interp,error));
    temp2 = (vtkDataArray *)(vtkTclGetPointerFromObject(argv[4],const_cast<char *>("vtkDataArray"),interp,error));
    if (!error)
  {
    temp20 = (op)->ComputeHDR(temp0,temp1,temp2);
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkHighestDensityRegionsStatisticsCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkStatisticsAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkHighestDensityRegionsStatistics:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  Aggregate\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetSigma\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetSigmaMatrix\t with 4 args\n",NULL);
    Tcl_AppendResult(interp,"  ComputeHDR\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  ComputeHDR\t with 3 args\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkStatisticsAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "Aggregate" );
    Tcl_DStringAppendElement ( &dString, "SetSigma" );
    Tcl_DStringAppendElement ( &dString, "SetSigmaMatrix" );
    Tcl_DStringAppendElement ( &dString, "ComputeHDR" );
    Tcl_DStringAppendElement ( &dString, "ComputeHDR" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkStatisticsAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkHighestDensityRegionsStatistics *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Aggregate */
    if ( strcmp ( argv[2], "Aggregate" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Aggregate" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataObjectCollection" );
    Tcl_DStringAppendElement ( &dString, "vtkMultiBlockDataSet" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Aggregate */
    Tcl_DStringAppendElement ( &dString, " Given a collection of models, calculate aggregate model\n" );
    Tcl_DStringAppendElement ( &dString, "void Aggregate(vtkDataObjectCollection *, vtkMultiBlockDataSet *);" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics" );
    /* Closing for Aggregate */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSigma */
    if ( strcmp ( argv[2], "SetSigma" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSigma" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSigma */
    Tcl_DStringAppendElement ( &dString, " Set the width of the gaussian kernel.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSigma(double sigma);" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics" );
    /* Closing for SetSigma */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSigmaMatrix */
    if ( strcmp ( argv[2], "SetSigmaMatrix" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSigmaMatrix" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSigmaMatrix */
    Tcl_DStringAppendElement ( &dString, " Set the gaussian kernel matrix.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSigmaMatrix(double s11, double s12, double s21, double s22);" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics" );
    /* Closing for SetSigmaMatrix */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ComputeHDR */
    if ( strcmp ( argv[2], "ComputeHDR" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeHDR" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeHDR */
    Tcl_DStringAppendElement ( &dString, " Fill outDensity with density vector that is computed from\n inObservations values. This method uses a Gaussian kernel.\n For n observations and with X an observation point:\n f(X) = (1 / n) * Sum(KH(X -Xi)) for (i = 1 to n).\n Look ComputeSmoothGaussianKernel for KH kernel definition.\n" );
    Tcl_DStringAppendElement ( &dString, "double ComputeHDR(vtkDataArray *inObservations, vtkDataArray *outDensity);" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics" );
    /* Closing for ComputeHDR */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ComputeHDR */
    if ( strcmp ( argv[2], "ComputeHDR" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeHDR" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringAppendElement ( &dString, "vtkDataArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeHDR */
    Tcl_DStringAppendElement ( &dString, " Fill outDensity with density vector defined by inPOI and computed from\n the inObs values. This method uses a Gaussian kernel.\n For n observations and with X an observation point:\n f(X) = (1 / n) * Sum(KH(X -Xi)) for (i = 1 to n).\n Look ComputeSmoothGaussianKernel for KH kernel definition.\n" );
    Tcl_DStringAppendElement ( &dString, "double ComputeHDR(vtkDataArray *inObs, vtkDataArray *inPOI, vtkDataArray *outDensity);" );
    Tcl_DStringAppendElement ( &dString, "vtkHighestDensityRegionsStatistics" );
    /* Closing for ComputeHDR */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkStatisticsAlgorithmCppCommand(static_cast<vtkStatisticsAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
