// tcl wrapper for vtkNIFTIImageReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkNIFTIImageReader.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkNIFTIImageReaderNewCommand()
{
  vtkNIFTIImageReader *temp = vtkNIFTIImageReader::New();
  return static_cast<ClientData>(temp);
}

int vtkImageReader2CppCommand(vtkImageReader2 *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkNIFTIImageReaderCppCommand(vtkNIFTIImageReader *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkNIFTIImageReaderCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkNIFTIImageReaderCppCommand(static_cast<vtkNIFTIImageReader *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkNIFTIImageReader_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkNIFTIImageReader"),vtkNIFTIImageReaderNewCommand,vtkNIFTIImageReaderCommand);
  return 0;
}

int VTKTCL_EXPORT vtkNIFTIImageReaderCppCommand(vtkNIFTIImageReader *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkNIFTIImageReader",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkImageReader2CppCommand(static_cast<vtkImageReader2 *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkImageReader2"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkNIFTIImageReader  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkNIFTIImageReader");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkNIFTIImageReader  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkNIFTIImageReader");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkNIFTIImageReader  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkNIFTIImageReader");
    return TCL_OK;
  }
  }
  if ((!strcmp("GetFileExtensions",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetFileExtensions();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("GetDescriptiveName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetDescriptiveName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("CanReadFile",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->CanReadFile(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTimeAsVector",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetTimeAsVector();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetTimeAsVector",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetTimeAsVector(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("TimeAsVectorOn",argv[1]))&&(argc == 2))
  {
    op->TimeAsVectorOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("TimeAsVectorOff",argv[1]))&&(argc == 2))
  {
    op->TimeAsVectorOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetTimeDimension",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetTimeDimension();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetTimeSpacing",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetTimeSpacing();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetRescaleSlope",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRescaleSlope();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetRescaleIntercept",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRescaleIntercept();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetPlanarRGB",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetPlanarRGB();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPlanarRGB",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetPlanarRGB(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("PlanarRGBOn",argv[1]))&&(argc == 2))
  {
    op->PlanarRGBOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PlanarRGBOff",argv[1]))&&(argc == 2))
  {
    op->PlanarRGBOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetQFac",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetQFac();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetQFormMatrix",argv[1]))&&(argc == 2))
  {
    vtkMatrix4x4  *temp20;
    temp20 = (op)->GetQFormMatrix();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMatrix4x4");
    return TCL_OK;
  }
  if ((!strcmp("GetSFormMatrix",argv[1]))&&(argc == 2))
  {
    vtkMatrix4x4  *temp20;
    temp20 = (op)->GetSFormMatrix();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMatrix4x4");
    return TCL_OK;
  }
  if ((!strcmp("GetNIFTIHeader",argv[1]))&&(argc == 2))
  {
    vtkNIFTIImageHeader  *temp20;
    temp20 = (op)->GetNIFTIHeader();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkNIFTIImageHeader");
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkNIFTIImageReaderCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkImageReader2CppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkNIFTIImageReader:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetFileExtensions\n",NULL);
    Tcl_AppendResult(interp,"  GetDescriptiveName\n",NULL);
    Tcl_AppendResult(interp,"  CanReadFile\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTimeAsVector\n",NULL);
    Tcl_AppendResult(interp,"  SetTimeAsVector\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  TimeAsVectorOn\n",NULL);
    Tcl_AppendResult(interp,"  TimeAsVectorOff\n",NULL);
    Tcl_AppendResult(interp,"  GetTimeDimension\n",NULL);
    Tcl_AppendResult(interp,"  GetTimeSpacing\n",NULL);
    Tcl_AppendResult(interp,"  GetRescaleSlope\n",NULL);
    Tcl_AppendResult(interp,"  GetRescaleIntercept\n",NULL);
    Tcl_AppendResult(interp,"  GetPlanarRGB\n",NULL);
    Tcl_AppendResult(interp,"  SetPlanarRGB\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  PlanarRGBOn\n",NULL);
    Tcl_AppendResult(interp,"  PlanarRGBOff\n",NULL);
    Tcl_AppendResult(interp,"  GetQFac\n",NULL);
    Tcl_AppendResult(interp,"  GetQFormMatrix\n",NULL);
    Tcl_AppendResult(interp,"  GetSFormMatrix\n",NULL);
    Tcl_AppendResult(interp,"  GetNIFTIHeader\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkImageReader2CppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "GetFileExtensions" );
    Tcl_DStringAppendElement ( &dString, "GetDescriptiveName" );
    Tcl_DStringAppendElement ( &dString, "CanReadFile" );
    Tcl_DStringAppendElement ( &dString, "GetTimeAsVector" );
    Tcl_DStringAppendElement ( &dString, "SetTimeAsVector" );
    Tcl_DStringAppendElement ( &dString, "TimeAsVectorOn" );
    Tcl_DStringAppendElement ( &dString, "TimeAsVectorOff" );
    Tcl_DStringAppendElement ( &dString, "GetTimeDimension" );
    Tcl_DStringAppendElement ( &dString, "GetTimeSpacing" );
    Tcl_DStringAppendElement ( &dString, "GetRescaleSlope" );
    Tcl_DStringAppendElement ( &dString, "GetRescaleIntercept" );
    Tcl_DStringAppendElement ( &dString, "GetPlanarRGB" );
    Tcl_DStringAppendElement ( &dString, "SetPlanarRGB" );
    Tcl_DStringAppendElement ( &dString, "PlanarRGBOn" );
    Tcl_DStringAppendElement ( &dString, "PlanarRGBOff" );
    Tcl_DStringAppendElement ( &dString, "GetQFac" );
    Tcl_DStringAppendElement ( &dString, "GetQFormMatrix" );
    Tcl_DStringAppendElement ( &dString, "GetSFormMatrix" );
    Tcl_DStringAppendElement ( &dString, "GetNIFTIHeader" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkImageReader2CppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Static method for construction.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkNIFTIImageReader *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Static method for construction.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Static method for construction.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Static method for construction.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Static method for construction.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetFileExtensions */
    if ( strcmp ( argv[2], "GetFileExtensions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetFileExtensions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetFileExtensions */
    Tcl_DStringAppendElement ( &dString, " Valid extensions for this file type.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual const char *GetFileExtensions();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetFileExtensions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDescriptiveName */
    if ( strcmp ( argv[2], "GetDescriptiveName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDescriptiveName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDescriptiveName */
    Tcl_DStringAppendElement ( &dString, " Return a descriptive name that might be useful in a GUI.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual const char *GetDescriptiveName();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetDescriptiveName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: CanReadFile */
    if ( strcmp ( argv[2], "CanReadFile" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CanReadFile" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CanReadFile */
    Tcl_DStringAppendElement ( &dString, " Return true if this reader can read the given file.\n" );
    Tcl_DStringAppendElement ( &dString, "int CanReadFile(const char *filename);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for CanReadFile */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTimeAsVector */
    if ( strcmp ( argv[2], "GetTimeAsVector" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTimeAsVector" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTimeAsVector */
    Tcl_DStringAppendElement ( &dString, " Read the time dimension as scalar components (default: Off).\n If this is on, then each time point will be stored as a component in\n the image data.  If the file has both a time dimension and a vector\n dimension, then the number of components will be the product of these\n two dimensions, i.e. the components will store a sequence of vectors.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetTimeAsVector();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetTimeAsVector */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTimeAsVector */
    if ( strcmp ( argv[2], "SetTimeAsVector" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTimeAsVector" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTimeAsVector */
    Tcl_DStringAppendElement ( &dString, " Read the time dimension as scalar components (default: Off).\n If this is on, then each time point will be stored as a component in\n the image data.  If the file has both a time dimension and a vector\n dimension, then the number of components will be the product of these\n two dimensions, i.e. the components will store a sequence of vectors.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTimeAsVector(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for SetTimeAsVector */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: TimeAsVectorOn */
    if ( strcmp ( argv[2], "TimeAsVectorOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "TimeAsVectorOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for TimeAsVectorOn */
    Tcl_DStringAppendElement ( &dString, " Read the time dimension as scalar components (default: Off).\n If this is on, then each time point will be stored as a component in\n the image data.  If the file has both a time dimension and a vector\n dimension, then the number of components will be the product of these\n two dimensions, i.e. the components will store a sequence of vectors.\n" );
    Tcl_DStringAppendElement ( &dString, "void TimeAsVectorOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for TimeAsVectorOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: TimeAsVectorOff */
    if ( strcmp ( argv[2], "TimeAsVectorOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "TimeAsVectorOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for TimeAsVectorOff */
    Tcl_DStringAppendElement ( &dString, " Read the time dimension as scalar components (default: Off).\n If this is on, then each time point will be stored as a component in\n the image data.  If the file has both a time dimension and a vector\n dimension, then the number of components will be the product of these\n two dimensions, i.e. the components will store a sequence of vectors.\n" );
    Tcl_DStringAppendElement ( &dString, "void TimeAsVectorOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for TimeAsVectorOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTimeDimension */
    if ( strcmp ( argv[2], "GetTimeDimension" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTimeDimension" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTimeDimension */
    Tcl_DStringAppendElement ( &dString, " Get the time dimension that was stored in the NIFTI header.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetTimeDimension();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetTimeDimension */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTimeSpacing */
    if ( strcmp ( argv[2], "GetTimeSpacing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTimeSpacing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTimeSpacing */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double GetTimeSpacing();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetTimeSpacing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRescaleSlope */
    if ( strcmp ( argv[2], "GetRescaleSlope" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRescaleSlope" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRescaleSlope */
    Tcl_DStringAppendElement ( &dString, " Get the slope and intercept for rescaling the scalar values.\n These values allow calibration of the data to real values.\n Use the equation v = u*RescaleSlope + RescaleIntercept.\n This directly returns the values stored in the scl_slope and\n scl_inter fields in the NIFTI header.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRescaleSlope();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetRescaleSlope */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRescaleIntercept */
    if ( strcmp ( argv[2], "GetRescaleIntercept" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRescaleIntercept" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRescaleIntercept */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double GetRescaleIntercept();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetRescaleIntercept */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPlanarRGB */
    if ( strcmp ( argv[2], "GetPlanarRGB" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPlanarRGB" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPlanarRGB */
    Tcl_DStringAppendElement ( &dString, " Read planar RGB (separate R, G, and B planes), rather than packed RGB.\n The NIFTI format should always use packed RGB.  The Analyze format,\n however, was used to store both planar RGB and packed RGB depending\n on the software, without any indication in the header about which\n convention was being used.  Use this if you have a planar RGB file.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetPlanarRGB();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetPlanarRGB */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPlanarRGB */
    if ( strcmp ( argv[2], "SetPlanarRGB" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPlanarRGB" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPlanarRGB */
    Tcl_DStringAppendElement ( &dString, " Read planar RGB (separate R, G, and B planes), rather than packed RGB.\n The NIFTI format should always use packed RGB.  The Analyze format,\n however, was used to store both planar RGB and packed RGB depending\n on the software, without any indication in the header about which\n convention was being used.  Use this if you have a planar RGB file.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPlanarRGB(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for SetPlanarRGB */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PlanarRGBOn */
    if ( strcmp ( argv[2], "PlanarRGBOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PlanarRGBOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PlanarRGBOn */
    Tcl_DStringAppendElement ( &dString, " Read planar RGB (separate R, G, and B planes), rather than packed RGB.\n The NIFTI format should always use packed RGB.  The Analyze format,\n however, was used to store both planar RGB and packed RGB depending\n on the software, without any indication in the header about which\n convention was being used.  Use this if you have a planar RGB file.\n" );
    Tcl_DStringAppendElement ( &dString, "void PlanarRGBOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for PlanarRGBOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PlanarRGBOff */
    if ( strcmp ( argv[2], "PlanarRGBOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PlanarRGBOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PlanarRGBOff */
    Tcl_DStringAppendElement ( &dString, " Read planar RGB (separate R, G, and B planes), rather than packed RGB.\n The NIFTI format should always use packed RGB.  The Analyze format,\n however, was used to store both planar RGB and packed RGB depending\n on the software, without any indication in the header about which\n convention was being used.  Use this if you have a planar RGB file.\n" );
    Tcl_DStringAppendElement ( &dString, "void PlanarRGBOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for PlanarRGBOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetQFac */
    if ( strcmp ( argv[2], "GetQFac" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetQFac" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetQFac */
    Tcl_DStringAppendElement ( &dString, " QFac gives the slice order in the NIFTI file versus the VTK image.\n If QFac is -1, then the VTK slice index J is related to the NIFTI\n slice index j by the equation J = (num_slices - j - 1).  VTK requires\n the slices to be ordered so that the voxel indices (I,J,K) provide a\n right-handed coordinate system, whereas NIFTI does not.  Instead,\n NIFTI stores a factor called \"qfac\" in the header to signal when the\n (i,j,k) indices form a left-handed coordinate system.  QF ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "double GetQFac();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetQFac */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetQFormMatrix */
    if ( strcmp ( argv[2], "GetQFormMatrix" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetQFormMatrix" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetQFormMatrix */
    Tcl_DStringAppendElement ( &dString, " Get a matrix that gives the \"qform\" orientation and offset for the data.\n If no qform matrix was stored in the file, the return value is NULL.\n This matrix will transform VTK data coordinates into the NIFTI oriented\n data coordinates, where +X points right, +Y points anterior (toward the\n front), and +Z points superior (toward the head). The qform matrix will\n always have a positive determinant. The offset that is stored in the\n matrix gives the position of the firs ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "vtkMatrix4x4 *GetQFormMatrix();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetQFormMatrix */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSFormMatrix */
    if ( strcmp ( argv[2], "GetSFormMatrix" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSFormMatrix" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSFormMatrix */
    Tcl_DStringAppendElement ( &dString, " Get a matrix that gives the \"sform\" orientation and offset for the data.\n If no sform matrix was stored in the file, the return value is NULL.\n Like the qform matrix, this matrix will transform VTK data coordinates\n into a NIFTI coordinate system.  Unlike the qform matrix, the sform\n matrix can contain scaling information and can even (rarely) have\n a negative determinant, i.e. a flip.  This matrix is modified slightly\n as compared to the sform matrix stored in the  ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "vtkMatrix4x4 *GetSFormMatrix();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetSFormMatrix */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNIFTIHeader */
    if ( strcmp ( argv[2], "GetNIFTIHeader" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNIFTIHeader" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNIFTIHeader */
    Tcl_DStringAppendElement ( &dString, " Get the raw header information from the NIfTI file.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageHeader *GetNIFTIHeader();" );
    Tcl_DStringAppendElement ( &dString, "vtkNIFTIImageReader" );
    /* Closing for GetNIFTIHeader */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkImageReader2CppCommand(static_cast<vtkImageReader2 *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
