// tcl wrapper for vtkTecplotTableReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTecplotTableReader.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkTecplotTableReaderNewCommand()
{
  vtkTecplotTableReader *temp = vtkTecplotTableReader::New();
  return static_cast<ClientData>(temp);
}

int vtkTableAlgorithmCppCommand(vtkTableAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkTecplotTableReaderCppCommand(vtkTecplotTableReader *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkTecplotTableReaderCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkTecplotTableReaderCppCommand(static_cast<vtkTecplotTableReader *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkTecplotTableReader_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkTecplotTableReader"),vtkTecplotTableReaderNewCommand,vtkTecplotTableReaderCommand);
  return 0;
}

int VTKTCL_EXPORT vtkTecplotTableReaderCppCommand(vtkTecplotTableReader *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkTecplotTableReader",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkTableAlgorithmCppCommand(static_cast<vtkTableAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkTableAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkTecplotTableReader  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTecplotTableReader");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkTecplotTableReader  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTecplotTableReader");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkTecplotTableReader  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTecplotTableReader");
    return TCL_OK;
  }
  }
  if ((!strcmp("GetFileName",argv[1]))&&(argc == 2))
  {
    char    *temp20;
    temp20 = (op)->GetFileName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetFileName",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetFileName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMaxRecords",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetMaxRecords();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetMaxRecords",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetMaxRecords(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetHeaderLines",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetHeaderLines();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetHeaderLines",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetHeaderLines(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetColumnNamesOnLine",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetColumnNamesOnLine();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetColumnNamesOnLine",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetColumnNamesOnLine(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSkipColumnNames",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetSkipColumnNames();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetSkipColumnNames",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetSkipColumnNames(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetPedigreeIdArrayName",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetPedigreeIdArrayName(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPedigreeIdArrayName",argv[1]))&&(argc == 2))
  {
    char    *temp20;
    temp20 = (op)->GetPedigreeIdArrayName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetGeneratePedigreeIds",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetGeneratePedigreeIds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetGeneratePedigreeIds",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetGeneratePedigreeIds();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GeneratePedigreeIdsOn",argv[1]))&&(argc == 2))
  {
    op->GeneratePedigreeIdsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GeneratePedigreeIdsOff",argv[1]))&&(argc == 2))
  {
    op->GeneratePedigreeIdsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetOutputPedigreeIds",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetOutputPedigreeIds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetOutputPedigreeIds",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetOutputPedigreeIds();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("OutputPedigreeIdsOn",argv[1]))&&(argc == 2))
  {
    op->OutputPedigreeIdsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("OutputPedigreeIdsOff",argv[1]))&&(argc == 2))
  {
    op->OutputPedigreeIdsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetLastError",argv[1]))&&(argc == 2))
  {
    vtkStdString   temp20;
    temp20 = (op)->GetLastError();
    Tcl_SetResult(interp, const_cast<char *>(temp20.c_str()), TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkTecplotTableReaderCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkTableAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkTecplotTableReader:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetFileName\n",NULL);
    Tcl_AppendResult(interp,"  SetFileName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMaxRecords\n",NULL);
    Tcl_AppendResult(interp,"  SetMaxRecords\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetHeaderLines\n",NULL);
    Tcl_AppendResult(interp,"  SetHeaderLines\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetColumnNamesOnLine\n",NULL);
    Tcl_AppendResult(interp,"  SetColumnNamesOnLine\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSkipColumnNames\n",NULL);
    Tcl_AppendResult(interp,"  SetSkipColumnNames\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetPedigreeIdArrayName\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPedigreeIdArrayName\n",NULL);
    Tcl_AppendResult(interp,"  SetGeneratePedigreeIds\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetGeneratePedigreeIds\n",NULL);
    Tcl_AppendResult(interp,"  GeneratePedigreeIdsOn\n",NULL);
    Tcl_AppendResult(interp,"  GeneratePedigreeIdsOff\n",NULL);
    Tcl_AppendResult(interp,"  SetOutputPedigreeIds\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOutputPedigreeIds\n",NULL);
    Tcl_AppendResult(interp,"  OutputPedigreeIdsOn\n",NULL);
    Tcl_AppendResult(interp,"  OutputPedigreeIdsOff\n",NULL);
    Tcl_AppendResult(interp,"  GetLastError\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkTableAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "GetFileName" );
    Tcl_DStringAppendElement ( &dString, "SetFileName" );
    Tcl_DStringAppendElement ( &dString, "GetMaxRecords" );
    Tcl_DStringAppendElement ( &dString, "SetMaxRecords" );
    Tcl_DStringAppendElement ( &dString, "GetHeaderLines" );
    Tcl_DStringAppendElement ( &dString, "SetHeaderLines" );
    Tcl_DStringAppendElement ( &dString, "GetColumnNamesOnLine" );
    Tcl_DStringAppendElement ( &dString, "SetColumnNamesOnLine" );
    Tcl_DStringAppendElement ( &dString, "GetSkipColumnNames" );
    Tcl_DStringAppendElement ( &dString, "SetSkipColumnNames" );
    Tcl_DStringAppendElement ( &dString, "SetPedigreeIdArrayName" );
    Tcl_DStringAppendElement ( &dString, "GetPedigreeIdArrayName" );
    Tcl_DStringAppendElement ( &dString, "SetGeneratePedigreeIds" );
    Tcl_DStringAppendElement ( &dString, "GetGeneratePedigreeIds" );
    Tcl_DStringAppendElement ( &dString, "GeneratePedigreeIdsOn" );
    Tcl_DStringAppendElement ( &dString, "GeneratePedigreeIdsOff" );
    Tcl_DStringAppendElement ( &dString, "SetOutputPedigreeIds" );
    Tcl_DStringAppendElement ( &dString, "GetOutputPedigreeIds" );
    Tcl_DStringAppendElement ( &dString, "OutputPedigreeIdsOn" );
    Tcl_DStringAppendElement ( &dString, "OutputPedigreeIdsOff" );
    Tcl_DStringAppendElement ( &dString, "GetLastError" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkTableAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkTecplotTableReader *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetFileName */
    if ( strcmp ( argv[2], "GetFileName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetFileName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetFileName */
    Tcl_DStringAppendElement ( &dString, " Specifies the delimited text file to be loaded.\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetFileName();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GetFileName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetFileName */
    if ( strcmp ( argv[2], "SetFileName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetFileName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetFileName */
    Tcl_DStringAppendElement ( &dString, " Specifies the delimited text file to be loaded.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetFileName(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for SetFileName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMaxRecords */
    if ( strcmp ( argv[2], "GetMaxRecords" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaxRecords" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaxRecords */
    Tcl_DStringAppendElement ( &dString, " Specifies the maximum number of records to read from the file.  Limiting the\n number of records to read is useful for previewing the contents of a file.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetMaxRecords();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GetMaxRecords */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMaxRecords */
    if ( strcmp ( argv[2], "SetMaxRecords" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMaxRecords" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMaxRecords */
    Tcl_DStringAppendElement ( &dString, " Specifies the maximum number of records to read from the file.  Limiting the\n number of records to read is useful for previewing the contents of a file.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetMaxRecords(vtkIdType a);" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for SetMaxRecords */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetHeaderLines */
    if ( strcmp ( argv[2], "GetHeaderLines" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetHeaderLines" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetHeaderLines */
    Tcl_DStringAppendElement ( &dString, " Specifies the number of lines that form the header of the file. Default is 2.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetHeaderLines();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GetHeaderLines */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetHeaderLines */
    if ( strcmp ( argv[2], "SetHeaderLines" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetHeaderLines" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetHeaderLines */
    Tcl_DStringAppendElement ( &dString, " Specifies the number of lines that form the header of the file. Default is 2.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetHeaderLines(vtkIdType a);" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for SetHeaderLines */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetColumnNamesOnLine */
    if ( strcmp ( argv[2], "GetColumnNamesOnLine" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetColumnNamesOnLine" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetColumnNamesOnLine */
    Tcl_DStringAppendElement ( &dString, " Specifies the line number that holds the column names. Default is 1.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetColumnNamesOnLine();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GetColumnNamesOnLine */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetColumnNamesOnLine */
    if ( strcmp ( argv[2], "SetColumnNamesOnLine" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetColumnNamesOnLine" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetColumnNamesOnLine */
    Tcl_DStringAppendElement ( &dString, " Specifies the line number that holds the column names. Default is 1.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetColumnNamesOnLine(vtkIdType a);" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for SetColumnNamesOnLine */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSkipColumnNames */
    if ( strcmp ( argv[2], "GetSkipColumnNames" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSkipColumnNames" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSkipColumnNames */
    Tcl_DStringAppendElement ( &dString, " Specifies the number of fields to skip while reading the column names. Default is 1.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetSkipColumnNames();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GetSkipColumnNames */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSkipColumnNames */
    if ( strcmp ( argv[2], "SetSkipColumnNames" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSkipColumnNames" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSkipColumnNames */
    Tcl_DStringAppendElement ( &dString, " Specifies the number of fields to skip while reading the column names. Default is 1.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSkipColumnNames(vtkIdType a);" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for SetSkipColumnNames */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPedigreeIdArrayName */
    if ( strcmp ( argv[2], "SetPedigreeIdArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPedigreeIdArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPedigreeIdArrayName */
    Tcl_DStringAppendElement ( &dString, " The name of the array for generating or assigning pedigree ids\n (default \"id\").\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPedigreeIdArrayName(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for SetPedigreeIdArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPedigreeIdArrayName */
    if ( strcmp ( argv[2], "GetPedigreeIdArrayName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPedigreeIdArrayName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPedigreeIdArrayName */
    Tcl_DStringAppendElement ( &dString, " The name of the array for generating or assigning pedigree ids\n (default \"id\").\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetPedigreeIdArrayName();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GetPedigreeIdArrayName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetGeneratePedigreeIds */
    if ( strcmp ( argv[2], "SetGeneratePedigreeIds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGeneratePedigreeIds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGeneratePedigreeIds */
    Tcl_DStringAppendElement ( &dString, " If on (default), generates pedigree ids automatically.\n If off, assign one of the arrays to be the pedigree id.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetGeneratePedigreeIds(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for SetGeneratePedigreeIds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetGeneratePedigreeIds */
    if ( strcmp ( argv[2], "GetGeneratePedigreeIds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetGeneratePedigreeIds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetGeneratePedigreeIds */
    Tcl_DStringAppendElement ( &dString, " If on (default), generates pedigree ids automatically.\n If off, assign one of the arrays to be the pedigree id.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetGeneratePedigreeIds();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GetGeneratePedigreeIds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GeneratePedigreeIdsOn */
    if ( strcmp ( argv[2], "GeneratePedigreeIdsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GeneratePedigreeIdsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GeneratePedigreeIdsOn */
    Tcl_DStringAppendElement ( &dString, " If on (default), generates pedigree ids automatically.\n If off, assign one of the arrays to be the pedigree id.\n" );
    Tcl_DStringAppendElement ( &dString, "void GeneratePedigreeIdsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GeneratePedigreeIdsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GeneratePedigreeIdsOff */
    if ( strcmp ( argv[2], "GeneratePedigreeIdsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GeneratePedigreeIdsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GeneratePedigreeIdsOff */
    Tcl_DStringAppendElement ( &dString, " If on (default), generates pedigree ids automatically.\n If off, assign one of the arrays to be the pedigree id.\n" );
    Tcl_DStringAppendElement ( &dString, "void GeneratePedigreeIdsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GeneratePedigreeIdsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetOutputPedigreeIds */
    if ( strcmp ( argv[2], "SetOutputPedigreeIds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOutputPedigreeIds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOutputPedigreeIds */
    Tcl_DStringAppendElement ( &dString, " If on, assigns pedigree ids to output. Defaults to off.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetOutputPedigreeIds(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for SetOutputPedigreeIds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetOutputPedigreeIds */
    if ( strcmp ( argv[2], "GetOutputPedigreeIds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOutputPedigreeIds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOutputPedigreeIds */
    Tcl_DStringAppendElement ( &dString, " If on, assigns pedigree ids to output. Defaults to off.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetOutputPedigreeIds();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GetOutputPedigreeIds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: OutputPedigreeIdsOn */
    if ( strcmp ( argv[2], "OutputPedigreeIdsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "OutputPedigreeIdsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for OutputPedigreeIdsOn */
    Tcl_DStringAppendElement ( &dString, " If on, assigns pedigree ids to output. Defaults to off.\n" );
    Tcl_DStringAppendElement ( &dString, "void OutputPedigreeIdsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for OutputPedigreeIdsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: OutputPedigreeIdsOff */
    if ( strcmp ( argv[2], "OutputPedigreeIdsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "OutputPedigreeIdsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for OutputPedigreeIdsOff */
    Tcl_DStringAppendElement ( &dString, " If on, assigns pedigree ids to output. Defaults to off.\n" );
    Tcl_DStringAppendElement ( &dString, "void OutputPedigreeIdsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for OutputPedigreeIdsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLastError */
    if ( strcmp ( argv[2], "GetLastError" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLastError" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLastError */
    Tcl_DStringAppendElement ( &dString, " Returns a human-readable description of the most recent error, if any.\n Otherwise, returns an empty string.  Note that the result is only valid\n after calling Update().\n" );
    Tcl_DStringAppendElement ( &dString, "vtkStdString GetLastError();" );
    Tcl_DStringAppendElement ( &dString, "vtkTecplotTableReader" );
    /* Closing for GetLastError */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkTableAlgorithmCppCommand(static_cast<vtkTableAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
