// tcl wrapper for vtkImageConnectivityFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageConnectivityFilter.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkImageConnectivityFilterNewCommand()
{
  vtkImageConnectivityFilter *temp = vtkImageConnectivityFilter::New();
  return static_cast<ClientData>(temp);
}

int vtkImageAlgorithmCppCommand(vtkImageAlgorithm *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkImageConnectivityFilterCppCommand(vtkImageConnectivityFilter *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkImageConnectivityFilterCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkImageConnectivityFilterCppCommand(static_cast<vtkImageConnectivityFilter *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkImageConnectivityFilter_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkImageConnectivityFilter"),vtkImageConnectivityFilterNewCommand,vtkImageConnectivityFilterCommand);
  return 0;
}

int VTKTCL_EXPORT vtkImageConnectivityFilterCppCommand(vtkImageConnectivityFilter *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkImageConnectivityFilter",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkImageAlgorithmCppCommand(static_cast<vtkImageAlgorithm *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkImageAlgorithm"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkImageConnectivityFilter  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkImageConnectivityFilter");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkImageConnectivityFilter  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkImageConnectivityFilter");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkImageConnectivityFilter  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkImageConnectivityFilter");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSeedConnection",argv[1]))&&(argc == 3))
  {
    vtkAlgorithmOutput  *temp0;
    error = 0;

    temp0 = (vtkAlgorithmOutput *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAlgorithmOutput"),interp,error));
    if (!error)
  {
    op->SetSeedConnection(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSeedConnection",argv[1]))&&(argc == 2))
  {
    vtkAlgorithmOutput  *temp20;
    temp20 = (op)->GetSeedConnection();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAlgorithmOutput");
    return TCL_OK;
  }
  if ((!strcmp("SetSeedData",argv[1]))&&(argc == 3))
  {
    vtkDataSet  *temp0;
    error = 0;

    temp0 = (vtkDataSet *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDataSet"),interp,error));
    if (!error)
  {
    op->SetSeedData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetStencilConnection",argv[1]))&&(argc == 3))
  {
    vtkAlgorithmOutput  *temp0;
    error = 0;

    temp0 = (vtkAlgorithmOutput *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkAlgorithmOutput"),interp,error));
    if (!error)
  {
    op->SetStencilConnection(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetStencilConnection",argv[1]))&&(argc == 2))
  {
    vtkAlgorithmOutput  *temp20;
    temp20 = (op)->GetStencilConnection();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkAlgorithmOutput");
    return TCL_OK;
  }
  if ((!strcmp("SetStencilData",argv[1]))&&(argc == 3))
  {
    vtkImageStencilData  *temp0;
    error = 0;

    temp0 = (vtkImageStencilData *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkImageStencilData"),interp,error));
    if (!error)
  {
    op->SetStencilData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetLabelScalarTypeToUnsignedChar",argv[1]))&&(argc == 2))
  {
    op->SetLabelScalarTypeToUnsignedChar();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetLabelScalarTypeToShort",argv[1]))&&(argc == 2))
  {
    op->SetLabelScalarTypeToShort();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetLabelScalarTypeToUnsignedShort",argv[1]))&&(argc == 2))
  {
    op->SetLabelScalarTypeToUnsignedShort();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetLabelScalarTypeToInt",argv[1]))&&(argc == 2))
  {
    op->SetLabelScalarTypeToInt();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetLabelScalarTypeAsString",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetLabelScalarTypeAsString();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetLabelScalarType",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetLabelScalarType(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLabelScalarType",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetLabelScalarType();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetLabelModeToSeedScalar",argv[1]))&&(argc == 2))
  {
    op->SetLabelModeToSeedScalar();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetLabelModeToConstantValue",argv[1]))&&(argc == 2))
  {
    op->SetLabelModeToConstantValue();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetLabelModeToSizeRank",argv[1]))&&(argc == 2))
  {
    op->SetLabelModeToSizeRank();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetLabelModeAsString",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetLabelModeAsString();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetLabelMode",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetLabelMode(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLabelMode",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetLabelMode();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetExtractionModeToSeededRegions",argv[1]))&&(argc == 2))
  {
    op->SetExtractionModeToSeededRegions();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetExtractionModeToAllRegions",argv[1]))&&(argc == 2))
  {
    op->SetExtractionModeToAllRegions();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetExtractionModeToLargestRegion",argv[1]))&&(argc == 2))
  {
    op->SetExtractionModeToLargestRegion();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetExtractionModeAsString",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetExtractionModeAsString();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetExtractionMode",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetExtractionMode(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetExtractionMode",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetExtractionMode();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetLabelConstantValue",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetLabelConstantValue(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLabelConstantValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetLabelConstantValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNumberOfExtractedRegions",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetNumberOfExtractedRegions();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetExtractedRegionLabels",argv[1]))&&(argc == 2))
  {
    vtkIdTypeArray  *temp20;
    temp20 = (op)->GetExtractedRegionLabels();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkIdTypeArray");
    return TCL_OK;
  }
  if ((!strcmp("GetExtractedRegionSizes",argv[1]))&&(argc == 2))
  {
    vtkIdTypeArray  *temp20;
    temp20 = (op)->GetExtractedRegionSizes();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkIdTypeArray");
    return TCL_OK;
  }
  if ((!strcmp("GetExtractedRegionSeedIds",argv[1]))&&(argc == 2))
  {
    vtkIdTypeArray  *temp20;
    temp20 = (op)->GetExtractedRegionSeedIds();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkIdTypeArray");
    return TCL_OK;
  }
  if ((!strcmp("GetExtractedRegionExtents",argv[1]))&&(argc == 2))
  {
    vtkIntArray  *temp20;
    temp20 = (op)->GetExtractedRegionExtents();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkIntArray");
    return TCL_OK;
  }
  if ((!strcmp("SetGenerateRegionExtents",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetGenerateRegionExtents(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GenerateRegionExtentsOn",argv[1]))&&(argc == 2))
  {
    op->GenerateRegionExtentsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GenerateRegionExtentsOff",argv[1]))&&(argc == 2))
  {
    op->GenerateRegionExtentsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetGenerateRegionExtents",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetGenerateRegionExtents();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetSizeRange",argv[1]))&&(argc == 4))
  {
    vtkIdType   temp0;
    vtkIdType   temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (!error)
  {
    op->SetSizeRange(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetSizeRange",argv[1]))&&(argc == 4))
  {
    vtkIdType temp0[2];
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0[0] = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp0[1] = tempi;
    if (!error)
  {
    op->SetSizeRange(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSizeRange",argv[1]))&&(argc == 2))
  {
    vtkIdType  *temp20;
    temp20 = (op)->GetSizeRange();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      sprintf(tempResult,"%i %i ",temp20[0],temp20[1]);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetScalarRange",argv[1]))&&(argc == 4))
  {
    double   temp0;
    double   temp1;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    op->SetScalarRange(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetScalarRange",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->SetScalarRange(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetScalarRange",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetScalarRange();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetActiveComponent",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetActiveComponent(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetActiveComponent",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetActiveComponent();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkImageConnectivityFilterCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkImageAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkImageConnectivityFilter:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetSeedConnection\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSeedConnection\n",NULL);
    Tcl_AppendResult(interp,"  SetSeedData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetStencilConnection\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetStencilConnection\n",NULL);
    Tcl_AppendResult(interp,"  SetStencilData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelScalarTypeToUnsignedChar\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelScalarTypeToShort\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelScalarTypeToUnsignedShort\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelScalarTypeToInt\n",NULL);
    Tcl_AppendResult(interp,"  GetLabelScalarTypeAsString\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelScalarType\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLabelScalarType\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelModeToSeedScalar\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelModeToConstantValue\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelModeToSizeRank\n",NULL);
    Tcl_AppendResult(interp,"  GetLabelModeAsString\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelMode\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLabelMode\n",NULL);
    Tcl_AppendResult(interp,"  SetExtractionModeToSeededRegions\n",NULL);
    Tcl_AppendResult(interp,"  SetExtractionModeToAllRegions\n",NULL);
    Tcl_AppendResult(interp,"  SetExtractionModeToLargestRegion\n",NULL);
    Tcl_AppendResult(interp,"  GetExtractionModeAsString\n",NULL);
    Tcl_AppendResult(interp,"  SetExtractionMode\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetExtractionMode\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelConstantValue\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLabelConstantValue\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfExtractedRegions\n",NULL);
    Tcl_AppendResult(interp,"  GetExtractedRegionLabels\n",NULL);
    Tcl_AppendResult(interp,"  GetExtractedRegionSizes\n",NULL);
    Tcl_AppendResult(interp,"  GetExtractedRegionSeedIds\n",NULL);
    Tcl_AppendResult(interp,"  GetExtractedRegionExtents\n",NULL);
    Tcl_AppendResult(interp,"  SetGenerateRegionExtents\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GenerateRegionExtentsOn\n",NULL);
    Tcl_AppendResult(interp,"  GenerateRegionExtentsOff\n",NULL);
    Tcl_AppendResult(interp,"  GetGenerateRegionExtents\n",NULL);
    Tcl_AppendResult(interp,"  SetSizeRange\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetSizeRange\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetSizeRange\n",NULL);
    Tcl_AppendResult(interp,"  SetScalarRange\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetScalarRange\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetScalarRange\n",NULL);
    Tcl_AppendResult(interp,"  SetActiveComponent\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetActiveComponent\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkImageAlgorithmCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetSeedConnection" );
    Tcl_DStringAppendElement ( &dString, "GetSeedConnection" );
    Tcl_DStringAppendElement ( &dString, "SetSeedData" );
    Tcl_DStringAppendElement ( &dString, "SetStencilConnection" );
    Tcl_DStringAppendElement ( &dString, "GetStencilConnection" );
    Tcl_DStringAppendElement ( &dString, "SetStencilData" );
    Tcl_DStringAppendElement ( &dString, "SetLabelScalarTypeToUnsignedChar" );
    Tcl_DStringAppendElement ( &dString, "SetLabelScalarTypeToShort" );
    Tcl_DStringAppendElement ( &dString, "SetLabelScalarTypeToUnsignedShort" );
    Tcl_DStringAppendElement ( &dString, "SetLabelScalarTypeToInt" );
    Tcl_DStringAppendElement ( &dString, "GetLabelScalarTypeAsString" );
    Tcl_DStringAppendElement ( &dString, "SetLabelScalarType" );
    Tcl_DStringAppendElement ( &dString, "GetLabelScalarType" );
    Tcl_DStringAppendElement ( &dString, "SetLabelModeToSeedScalar" );
    Tcl_DStringAppendElement ( &dString, "SetLabelModeToConstantValue" );
    Tcl_DStringAppendElement ( &dString, "SetLabelModeToSizeRank" );
    Tcl_DStringAppendElement ( &dString, "GetLabelModeAsString" );
    Tcl_DStringAppendElement ( &dString, "SetLabelMode" );
    Tcl_DStringAppendElement ( &dString, "GetLabelMode" );
    Tcl_DStringAppendElement ( &dString, "SetExtractionModeToSeededRegions" );
    Tcl_DStringAppendElement ( &dString, "SetExtractionModeToAllRegions" );
    Tcl_DStringAppendElement ( &dString, "SetExtractionModeToLargestRegion" );
    Tcl_DStringAppendElement ( &dString, "GetExtractionModeAsString" );
    Tcl_DStringAppendElement ( &dString, "SetExtractionMode" );
    Tcl_DStringAppendElement ( &dString, "GetExtractionMode" );
    Tcl_DStringAppendElement ( &dString, "SetLabelConstantValue" );
    Tcl_DStringAppendElement ( &dString, "GetLabelConstantValue" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfExtractedRegions" );
    Tcl_DStringAppendElement ( &dString, "GetExtractedRegionLabels" );
    Tcl_DStringAppendElement ( &dString, "GetExtractedRegionSizes" );
    Tcl_DStringAppendElement ( &dString, "GetExtractedRegionSeedIds" );
    Tcl_DStringAppendElement ( &dString, "GetExtractedRegionExtents" );
    Tcl_DStringAppendElement ( &dString, "SetGenerateRegionExtents" );
    Tcl_DStringAppendElement ( &dString, "GenerateRegionExtentsOn" );
    Tcl_DStringAppendElement ( &dString, "GenerateRegionExtentsOff" );
    Tcl_DStringAppendElement ( &dString, "GetGenerateRegionExtents" );
    Tcl_DStringAppendElement ( &dString, "SetSizeRange" );
    Tcl_DStringAppendElement ( &dString, "SetSizeRange" );
    Tcl_DStringAppendElement ( &dString, "GetSizeRange" );
    Tcl_DStringAppendElement ( &dString, "SetScalarRange" );
    Tcl_DStringAppendElement ( &dString, "SetScalarRange" );
    Tcl_DStringAppendElement ( &dString, "GetScalarRange" );
    Tcl_DStringAppendElement ( &dString, "SetActiveComponent" );
    Tcl_DStringAppendElement ( &dString, "GetActiveComponent" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkImageAlgorithmCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkImageConnectivityFilter *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSeedConnection */
    if ( strcmp ( argv[2], "SetSeedConnection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSeedConnection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAlgorithmOutput" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSeedConnection */
    Tcl_DStringAppendElement ( &dString, " The input for seed locations (input port 1).\n Each point in the supplied data set will be used as a seed, unless\n the data set has scalars, in which case only the points with scalar\n values that are not equal to zero will be used as seeds.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSeedConnection(vtkAlgorithmOutput *port);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetSeedConnection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSeedConnection */
    if ( strcmp ( argv[2], "GetSeedConnection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSeedConnection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSeedConnection */
    Tcl_DStringAppendElement ( &dString, " The input for seed locations (input port 1).\n Each point in the supplied data set will be used as a seed, unless\n the data set has scalars, in which case only the points with scalar\n values that are not equal to zero will be used as seeds.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkAlgorithmOutput *GetSeedConnection();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetSeedConnection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSeedData */
    if ( strcmp ( argv[2], "SetSeedData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSeedData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDataSet" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSeedData */
    Tcl_DStringAppendElement ( &dString, " The input for seed locations (input port 1).\n Each point in the supplied data set will be used as a seed, unless\n the data set has scalars, in which case only the points with scalar\n values that are not equal to zero will be used as seeds.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSeedData(vtkDataSet *data);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetSeedData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetStencilConnection */
    if ( strcmp ( argv[2], "SetStencilConnection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetStencilConnection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkAlgorithmOutput" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetStencilConnection */
    Tcl_DStringAppendElement ( &dString, " The input for a stencil (input port 2).\n The output labels will be restricted to the region inside the stencil,\n as if no input voxels existed outside the stencil.  This allows you to\n apply this filter within an arbitrary region of interest.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetStencilConnection(vtkAlgorithmOutput *port);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetStencilConnection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetStencilConnection */
    if ( strcmp ( argv[2], "GetStencilConnection" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetStencilConnection" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetStencilConnection */
    Tcl_DStringAppendElement ( &dString, " The input for a stencil (input port 2).\n The output labels will be restricted to the region inside the stencil,\n as if no input voxels existed outside the stencil.  This allows you to\n apply this filter within an arbitrary region of interest.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkAlgorithmOutput *GetStencilConnection();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetStencilConnection */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetStencilData */
    if ( strcmp ( argv[2], "SetStencilData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetStencilData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkImageStencilData" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetStencilData */
    Tcl_DStringAppendElement ( &dString, " The input for a stencil (input port 2).\n The output labels will be restricted to the region inside the stencil,\n as if no input voxels existed outside the stencil.  This allows you to\n apply this filter within an arbitrary region of interest.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetStencilData(vtkImageStencilData *data);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetStencilData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelScalarTypeToUnsignedChar */
    if ( strcmp ( argv[2], "SetLabelScalarTypeToUnsignedChar" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelScalarTypeToUnsignedChar" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelScalarTypeToUnsignedChar */
    Tcl_DStringAppendElement ( &dString, " Set the scalar type for the output label image.\n This should be one of UnsignedChar, Short, UnsignedShort, or Int\n depending on how many labels are expected.  The default is UnsignedChar,\n which allows for 255 label values.  If the total number of regions is\n greater than the maximum label value N, then only the largest N regions\n will be kept and the rest will be discarded.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelScalarTypeToUnsignedChar();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetLabelScalarTypeToUnsignedChar */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelScalarTypeToShort */
    if ( strcmp ( argv[2], "SetLabelScalarTypeToShort" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelScalarTypeToShort" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelScalarTypeToShort */
    Tcl_DStringAppendElement ( &dString, " Set the scalar type for the output label image.\n This should be one of UnsignedChar, Short, UnsignedShort, or Int\n depending on how many labels are expected.  The default is UnsignedChar,\n which allows for 255 label values.  If the total number of regions is\n greater than the maximum label value N, then only the largest N regions\n will be kept and the rest will be discarded.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelScalarTypeToShort();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetLabelScalarTypeToShort */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelScalarTypeToUnsignedShort */
    if ( strcmp ( argv[2], "SetLabelScalarTypeToUnsignedShort" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelScalarTypeToUnsignedShort" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelScalarTypeToUnsignedShort */
    Tcl_DStringAppendElement ( &dString, " Set the scalar type for the output label image.\n This should be one of UnsignedChar, Short, UnsignedShort, or Int\n depending on how many labels are expected.  The default is UnsignedChar,\n which allows for 255 label values.  If the total number of regions is\n greater than the maximum label value N, then only the largest N regions\n will be kept and the rest will be discarded.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelScalarTypeToUnsignedShort();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetLabelScalarTypeToUnsignedShort */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelScalarTypeToInt */
    if ( strcmp ( argv[2], "SetLabelScalarTypeToInt" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelScalarTypeToInt" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelScalarTypeToInt */
    Tcl_DStringAppendElement ( &dString, " Set the scalar type for the output label image.\n This should be one of UnsignedChar, Short, UnsignedShort, or Int\n depending on how many labels are expected.  The default is UnsignedChar,\n which allows for 255 label values.  If the total number of regions is\n greater than the maximum label value N, then only the largest N regions\n will be kept and the rest will be discarded.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelScalarTypeToInt();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetLabelScalarTypeToInt */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLabelScalarTypeAsString */
    if ( strcmp ( argv[2], "GetLabelScalarTypeAsString" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLabelScalarTypeAsString" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLabelScalarTypeAsString */
    Tcl_DStringAppendElement ( &dString, " Set the scalar type for the output label image.\n This should be one of UnsignedChar, Short, UnsignedShort, or Int\n depending on how many labels are expected.  The default is UnsignedChar,\n which allows for 255 label values.  If the total number of regions is\n greater than the maximum label value N, then only the largest N regions\n will be kept and the rest will be discarded.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetLabelScalarTypeAsString();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetLabelScalarTypeAsString */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelScalarType */
    if ( strcmp ( argv[2], "SetLabelScalarType" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelScalarType" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelScalarType */
    Tcl_DStringAppendElement ( &dString, " Set the scalar type for the output label image.\n This should be one of UnsignedChar, Short, UnsignedShort, or Int\n depending on how many labels are expected.  The default is UnsignedChar,\n which allows for 255 label values.  If the total number of regions is\n greater than the maximum label value N, then only the largest N regions\n will be kept and the rest will be discarded.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelScalarType(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetLabelScalarType */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLabelScalarType */
    if ( strcmp ( argv[2], "GetLabelScalarType" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLabelScalarType" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLabelScalarType */
    Tcl_DStringAppendElement ( &dString, " Set the scalar type for the output label image.\n This should be one of UnsignedChar, Short, UnsignedShort, or Int\n depending on how many labels are expected.  The default is UnsignedChar,\n which allows for 255 label values.  If the total number of regions is\n greater than the maximum label value N, then only the largest N regions\n will be kept and the rest will be discarded.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetLabelScalarType();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetLabelScalarType */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelModeToSeedScalar */
    if ( strcmp ( argv[2], "SetLabelModeToSeedScalar" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelModeToSeedScalar" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelModeToSeedScalar */
    Tcl_DStringAppendElement ( &dString, " Set the mode for applying labels to the output.\n Labeling by SeedScalar uses the scalars from the seeds as labels, if\n present, or the regions will be labeled consecutively starting at 1,\n if the seeds have no scalars. Labeling by SizeRank means that the\n largest region is labeled 1 and other regions are labeled consecutively\n in order of decreasing size (if there is a tie, then the seed point ID\n is used as a tiebreaker).  Finally, Constant means that all regions\n w ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelModeToSeedScalar();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetLabelModeToSeedScalar */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelModeToConstantValue */
    if ( strcmp ( argv[2], "SetLabelModeToConstantValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelModeToConstantValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelModeToConstantValue */
    Tcl_DStringAppendElement ( &dString, " Set the mode for applying labels to the output.\n Labeling by SeedScalar uses the scalars from the seeds as labels, if\n present, or the regions will be labeled consecutively starting at 1,\n if the seeds have no scalars. Labeling by SizeRank means that the\n largest region is labeled 1 and other regions are labeled consecutively\n in order of decreasing size (if there is a tie, then the seed point ID\n is used as a tiebreaker).  Finally, Constant means that all regions\n w ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelModeToConstantValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetLabelModeToConstantValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelModeToSizeRank */
    if ( strcmp ( argv[2], "SetLabelModeToSizeRank" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelModeToSizeRank" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelModeToSizeRank */
    Tcl_DStringAppendElement ( &dString, " Set the mode for applying labels to the output.\n Labeling by SeedScalar uses the scalars from the seeds as labels, if\n present, or the regions will be labeled consecutively starting at 1,\n if the seeds have no scalars. Labeling by SizeRank means that the\n largest region is labeled 1 and other regions are labeled consecutively\n in order of decreasing size (if there is a tie, then the seed point ID\n is used as a tiebreaker).  Finally, Constant means that all regions\n w ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelModeToSizeRank();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetLabelModeToSizeRank */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLabelModeAsString */
    if ( strcmp ( argv[2], "GetLabelModeAsString" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLabelModeAsString" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLabelModeAsString */
    Tcl_DStringAppendElement ( &dString, " Set the mode for applying labels to the output.\n Labeling by SeedScalar uses the scalars from the seeds as labels, if\n present, or the regions will be labeled consecutively starting at 1,\n if the seeds have no scalars. Labeling by SizeRank means that the\n largest region is labeled 1 and other regions are labeled consecutively\n in order of decreasing size (if there is a tie, then the seed point ID\n is used as a tiebreaker).  Finally, Constant means that all regions\n w ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetLabelModeAsString();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetLabelModeAsString */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelMode */
    if ( strcmp ( argv[2], "SetLabelMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelMode */
    Tcl_DStringAppendElement ( &dString, " Set the mode for applying labels to the output.\n Labeling by SeedScalar uses the scalars from the seeds as labels, if\n present, or the regions will be labeled consecutively starting at 1,\n if the seeds have no scalars. Labeling by SizeRank means that the\n largest region is labeled 1 and other regions are labeled consecutively\n in order of decreasing size (if there is a tie, then the seed point ID\n is used as a tiebreaker).  Finally, Constant means that all regions\n w ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelMode(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetLabelMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLabelMode */
    if ( strcmp ( argv[2], "GetLabelMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLabelMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLabelMode */
    Tcl_DStringAppendElement ( &dString, " Set the mode for applying labels to the output.\n Labeling by SeedScalar uses the scalars from the seeds as labels, if\n present, or the regions will be labeled consecutively starting at 1,\n if the seeds have no scalars. Labeling by SizeRank means that the\n largest region is labeled 1 and other regions are labeled consecutively\n in order of decreasing size (if there is a tie, then the seed point ID\n is used as a tiebreaker).  Finally, Constant means that all regions\n w ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "int GetLabelMode();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetLabelMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetExtractionModeToSeededRegions */
    if ( strcmp ( argv[2], "SetExtractionModeToSeededRegions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetExtractionModeToSeededRegions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetExtractionModeToSeededRegions */
    Tcl_DStringAppendElement ( &dString, " Set which regions to output from this filter.\n This can be all the regions, just the seeded regions, or the largest\n region (which will the the largest seeded region, if there are seeds).\n The default is to output all the seeded regions, if there are seeds,\n or to output all the regions, if there are no seeds.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetExtractionModeToSeededRegions();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetExtractionModeToSeededRegions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetExtractionModeToAllRegions */
    if ( strcmp ( argv[2], "SetExtractionModeToAllRegions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetExtractionModeToAllRegions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetExtractionModeToAllRegions */
    Tcl_DStringAppendElement ( &dString, " Set which regions to output from this filter.\n This can be all the regions, just the seeded regions, or the largest\n region (which will the the largest seeded region, if there are seeds).\n The default is to output all the seeded regions, if there are seeds,\n or to output all the regions, if there are no seeds.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetExtractionModeToAllRegions();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetExtractionModeToAllRegions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetExtractionModeToLargestRegion */
    if ( strcmp ( argv[2], "SetExtractionModeToLargestRegion" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetExtractionModeToLargestRegion" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetExtractionModeToLargestRegion */
    Tcl_DStringAppendElement ( &dString, " Set which regions to output from this filter.\n This can be all the regions, just the seeded regions, or the largest\n region (which will the the largest seeded region, if there are seeds).\n The default is to output all the seeded regions, if there are seeds,\n or to output all the regions, if there are no seeds.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetExtractionModeToLargestRegion();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetExtractionModeToLargestRegion */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExtractionModeAsString */
    if ( strcmp ( argv[2], "GetExtractionModeAsString" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExtractionModeAsString" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExtractionModeAsString */
    Tcl_DStringAppendElement ( &dString, " Set which regions to output from this filter.\n This can be all the regions, just the seeded regions, or the largest\n region (which will the the largest seeded region, if there are seeds).\n The default is to output all the seeded regions, if there are seeds,\n or to output all the regions, if there are no seeds.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetExtractionModeAsString();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetExtractionModeAsString */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetExtractionMode */
    if ( strcmp ( argv[2], "SetExtractionMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetExtractionMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetExtractionMode */
    Tcl_DStringAppendElement ( &dString, " Set which regions to output from this filter.\n This can be all the regions, just the seeded regions, or the largest\n region (which will the the largest seeded region, if there are seeds).\n The default is to output all the seeded regions, if there are seeds,\n or to output all the regions, if there are no seeds.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetExtractionMode(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetExtractionMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExtractionMode */
    if ( strcmp ( argv[2], "GetExtractionMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExtractionMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExtractionMode */
    Tcl_DStringAppendElement ( &dString, " Set which regions to output from this filter.\n This can be all the regions, just the seeded regions, or the largest\n region (which will the the largest seeded region, if there are seeds).\n The default is to output all the seeded regions, if there are seeds,\n or to output all the regions, if there are no seeds.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetExtractionMode();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetExtractionMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelConstantValue */
    if ( strcmp ( argv[2], "SetLabelConstantValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelConstantValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelConstantValue */
    Tcl_DStringAppendElement ( &dString, " The label used when LabelMode is ConstantValue.\n The default value is 255.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelConstantValue(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetLabelConstantValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLabelConstantValue */
    if ( strcmp ( argv[2], "GetLabelConstantValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLabelConstantValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLabelConstantValue */
    Tcl_DStringAppendElement ( &dString, " The label used when LabelMode is ConstantValue.\n The default value is 255.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetLabelConstantValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetLabelConstantValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfExtractedRegions */
    if ( strcmp ( argv[2], "GetNumberOfExtractedRegions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfExtractedRegions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfExtractedRegions */
    Tcl_DStringAppendElement ( &dString, " Get the number of extracted regions.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetNumberOfExtractedRegions();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetNumberOfExtractedRegions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExtractedRegionLabels */
    if ( strcmp ( argv[2], "GetExtractedRegionLabels" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExtractedRegionLabels" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExtractedRegionLabels */
    Tcl_DStringAppendElement ( &dString, " Get the label used for each extracted region.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdTypeArray *GetExtractedRegionLabels();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetExtractedRegionLabels */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExtractedRegionSizes */
    if ( strcmp ( argv[2], "GetExtractedRegionSizes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExtractedRegionSizes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExtractedRegionSizes */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkIdTypeArray *GetExtractedRegionSizes();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetExtractedRegionSizes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExtractedRegionSeedIds */
    if ( strcmp ( argv[2], "GetExtractedRegionSeedIds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExtractedRegionSeedIds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExtractedRegionSeedIds */
    Tcl_DStringAppendElement ( &dString, " Get the PointId of the seed for each region.\n If no seed was used, the PointId will be -1.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdTypeArray *GetExtractedRegionSeedIds();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetExtractedRegionSeedIds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExtractedRegionExtents */
    if ( strcmp ( argv[2], "GetExtractedRegionExtents" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExtractedRegionExtents" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExtractedRegionExtents */
    Tcl_DStringAppendElement ( &dString, " Get the extent (a 6-tuples) for each output region.\n This is only valid if GenerateRegionExtentsOn() was called before\n the filter was executed.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIntArray *GetExtractedRegionExtents();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetExtractedRegionExtents */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetGenerateRegionExtents */
    if ( strcmp ( argv[2], "SetGenerateRegionExtents" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetGenerateRegionExtents" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetGenerateRegionExtents */
    Tcl_DStringAppendElement ( &dString, " Turn this on to request creation of the ExtractedRegionExtents array.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetGenerateRegionExtents(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetGenerateRegionExtents */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GenerateRegionExtentsOn */
    if ( strcmp ( argv[2], "GenerateRegionExtentsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GenerateRegionExtentsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GenerateRegionExtentsOn */
    Tcl_DStringAppendElement ( &dString, " Turn this on to request creation of the ExtractedRegionExtents array.\n" );
    Tcl_DStringAppendElement ( &dString, "void GenerateRegionExtentsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GenerateRegionExtentsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GenerateRegionExtentsOff */
    if ( strcmp ( argv[2], "GenerateRegionExtentsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GenerateRegionExtentsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GenerateRegionExtentsOff */
    Tcl_DStringAppendElement ( &dString, " Turn this on to request creation of the ExtractedRegionExtents array.\n" );
    Tcl_DStringAppendElement ( &dString, "void GenerateRegionExtentsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GenerateRegionExtentsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetGenerateRegionExtents */
    if ( strcmp ( argv[2], "GetGenerateRegionExtents" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetGenerateRegionExtents" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetGenerateRegionExtents */
    Tcl_DStringAppendElement ( &dString, " Turn this on to request creation of the ExtractedRegionExtents array.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetGenerateRegionExtents();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetGenerateRegionExtents */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSizeRange */
    if ( strcmp ( argv[2], "SetSizeRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSizeRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSizeRange */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetSizeRange(vtkIdType, vtkIdType);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetSizeRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSizeRange */
    if ( strcmp ( argv[2], "SetSizeRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSizeRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSizeRange */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetSizeRange(vtkIdType a\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetSizeRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSizeRange */
    if ( strcmp ( argv[2], "GetSizeRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSizeRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSizeRange */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType *GetSizeRange();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetSizeRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetScalarRange */
    if ( strcmp ( argv[2], "SetScalarRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetScalarRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetScalarRange */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetScalarRange(double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetScalarRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetScalarRange */
    if ( strcmp ( argv[2], "SetScalarRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetScalarRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetScalarRange */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetScalarRange(double a\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetScalarRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScalarRange */
    if ( strcmp ( argv[2], "GetScalarRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScalarRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScalarRange */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double *GetScalarRange();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetScalarRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetActiveComponent */
    if ( strcmp ( argv[2], "SetActiveComponent" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetActiveComponent" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetActiveComponent */
    Tcl_DStringAppendElement ( &dString, " For multi-component input images, select which component to use.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetActiveComponent(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for SetActiveComponent */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetActiveComponent */
    if ( strcmp ( argv[2], "GetActiveComponent" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetActiveComponent" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetActiveComponent */
    Tcl_DStringAppendElement ( &dString, " For multi-component input images, select which component to use.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetActiveComponent();" );
    Tcl_DStringAppendElement ( &dString, "vtkImageConnectivityFilter" );
    /* Closing for GetActiveComponent */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkImageAlgorithmCppCommand(static_cast<vtkImageAlgorithm *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
