#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkArcParallelEdgeStrategy_TclCreate(Tcl_Interp *interp);
int vtkAreaLayout_TclCreate(Tcl_Interp *interp);
int vtkAreaLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkAssignCoordinates_TclCreate(Tcl_Interp *interp);
int vtkAssignCoordinatesLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkAttributeClustering2DLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkBoxLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkCirclePackFrontChainLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkCirclePackLayout_TclCreate(Tcl_Interp *interp);
int vtkCirclePackLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkCirclePackToPolyData_TclCreate(Tcl_Interp *interp);
int vtkCircularLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkClustering2DLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkCommunity2DLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkConeLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkConstrained2DLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkCosmicTreeLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkEdgeLayout_TclCreate(Tcl_Interp *interp);
int vtkEdgeLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkFast2DLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkForceDirectedLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkGeoEdgeStrategy_TclCreate(Tcl_Interp *interp);
int vtkGeoMath_TclCreate(Tcl_Interp *interp);
int vtkGraphLayout_TclCreate(Tcl_Interp *interp);
int vtkGraphLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkIncrementalForceLayout_TclCreate(Tcl_Interp *interp);
int vtkPassThroughEdgeStrategy_TclCreate(Tcl_Interp *interp);
int vtkPassThroughLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkPerturbCoincidentVertices_TclCreate(Tcl_Interp *interp);
int vtkRandomLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkSimple2DLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkSimple3DCirclesStrategy_TclCreate(Tcl_Interp *interp);
int vtkSliceAndDiceLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkSpanTreeLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkSplineGraphEdges_TclCreate(Tcl_Interp *interp);
int vtkSquarifyLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkStackedTreeLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkTreeLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkTreeMapLayout_TclCreate(Tcl_Interp *interp);
int vtkTreeMapLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkTreeMapToPolyData_TclCreate(Tcl_Interp *interp);
int vtkTreeOrbitLayoutStrategy_TclCreate(Tcl_Interp *interp);
int vtkTreeRingToPolyData_TclCreate(Tcl_Interp *interp);
int vtkKCoreLayout_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkinfovislayouttcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkinfovislayouttcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkinfovislayouttcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkinfovislayouttcl_Init(interp);
}


int VTK_EXPORT Vtkinfovislayouttcl_Init(Tcl_Interp *interp)
{

  vtkArcParallelEdgeStrategy_TclCreate(interp);
  vtkAreaLayout_TclCreate(interp);
  vtkAreaLayoutStrategy_TclCreate(interp);
  vtkAssignCoordinates_TclCreate(interp);
  vtkAssignCoordinatesLayoutStrategy_TclCreate(interp);
  vtkAttributeClustering2DLayoutStrategy_TclCreate(interp);
  vtkBoxLayoutStrategy_TclCreate(interp);
  vtkCirclePackFrontChainLayoutStrategy_TclCreate(interp);
  vtkCirclePackLayout_TclCreate(interp);
  vtkCirclePackLayoutStrategy_TclCreate(interp);
  vtkCirclePackToPolyData_TclCreate(interp);
  vtkCircularLayoutStrategy_TclCreate(interp);
  vtkClustering2DLayoutStrategy_TclCreate(interp);
  vtkCommunity2DLayoutStrategy_TclCreate(interp);
  vtkConeLayoutStrategy_TclCreate(interp);
  vtkConstrained2DLayoutStrategy_TclCreate(interp);
  vtkCosmicTreeLayoutStrategy_TclCreate(interp);
  vtkEdgeLayout_TclCreate(interp);
  vtkEdgeLayoutStrategy_TclCreate(interp);
  vtkFast2DLayoutStrategy_TclCreate(interp);
  vtkForceDirectedLayoutStrategy_TclCreate(interp);
  vtkGeoEdgeStrategy_TclCreate(interp);
  vtkGeoMath_TclCreate(interp);
  vtkGraphLayout_TclCreate(interp);
  vtkGraphLayoutStrategy_TclCreate(interp);
  vtkIncrementalForceLayout_TclCreate(interp);
  vtkPassThroughEdgeStrategy_TclCreate(interp);
  vtkPassThroughLayoutStrategy_TclCreate(interp);
  vtkPerturbCoincidentVertices_TclCreate(interp);
  vtkRandomLayoutStrategy_TclCreate(interp);
  vtkSimple2DLayoutStrategy_TclCreate(interp);
  vtkSimple3DCirclesStrategy_TclCreate(interp);
  vtkSliceAndDiceLayoutStrategy_TclCreate(interp);
  vtkSpanTreeLayoutStrategy_TclCreate(interp);
  vtkSplineGraphEdges_TclCreate(interp);
  vtkSquarifyLayoutStrategy_TclCreate(interp);
  vtkStackedTreeLayoutStrategy_TclCreate(interp);
  vtkTreeLayoutStrategy_TclCreate(interp);
  vtkTreeMapLayout_TclCreate(interp);
  vtkTreeMapLayoutStrategy_TclCreate(interp);
  vtkTreeMapToPolyData_TclCreate(interp);
  vtkTreeOrbitLayoutStrategy_TclCreate(interp);
  vtkTreeRingToPolyData_TclCreate(interp);
  vtkKCoreLayout_TclCreate(interp);
  char pkgName[]="vtkInfovisLayoutTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
