#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkInteractorStyleDrawPolygon_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleFlight_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleImage_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleJoystickActor_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleJoystickCamera_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleMultiTouchCamera_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleRubberBand2D_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleRubberBand3D_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleRubberBandPick_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleRubberBandZoom_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleTerrain_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleTrackballActor_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleTrackballCamera_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleTrackball_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleUnicam_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleUser_TclCreate(Tcl_Interp *interp);
int vtkInteractorStyleSwitch_TclCreate(Tcl_Interp *interp);
int vtkParallelCoordinatesInteractorStyle_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkinteractionstyletcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkinteractionstyletcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkinteractionstyletcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkinteractionstyletcl_Init(interp);
}


int VTK_EXPORT Vtkinteractionstyletcl_Init(Tcl_Interp *interp)
{

  vtkInteractorStyleDrawPolygon_TclCreate(interp);
  vtkInteractorStyleFlight_TclCreate(interp);
  vtkInteractorStyleImage_TclCreate(interp);
  vtkInteractorStyleJoystickActor_TclCreate(interp);
  vtkInteractorStyleJoystickCamera_TclCreate(interp);
  vtkInteractorStyleMultiTouchCamera_TclCreate(interp);
  vtkInteractorStyleRubberBand2D_TclCreate(interp);
  vtkInteractorStyleRubberBand3D_TclCreate(interp);
  vtkInteractorStyleRubberBandPick_TclCreate(interp);
  vtkInteractorStyleRubberBandZoom_TclCreate(interp);
  vtkInteractorStyleTerrain_TclCreate(interp);
  vtkInteractorStyleTrackballActor_TclCreate(interp);
  vtkInteractorStyleTrackballCamera_TclCreate(interp);
  vtkInteractorStyleTrackball_TclCreate(interp);
  vtkInteractorStyleUnicam_TclCreate(interp);
  vtkInteractorStyleUser_TclCreate(interp);
  vtkInteractorStyleSwitch_TclCreate(interp);
  vtkParallelCoordinatesInteractorStyle_TclCreate(interp);
  char pkgName[]="vtkInteractionStyleTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
