// tcl wrapper for vtkCurveRepresentation object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkCurveRepresentation.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>
int vtkWidgetRepresentationCppCommand(vtkWidgetRepresentation *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkCurveRepresentationCppCommand(vtkCurveRepresentation *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkCurveRepresentationCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkCurveRepresentationCppCommand(static_cast<vtkCurveRepresentation *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkCurveRepresentation_TclCreate(Tcl_Interp *interp)
{
  (void)interp;
  return 0;
}

int VTKTCL_EXPORT vtkCurveRepresentationCppCommand(vtkCurveRepresentation *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkCurveRepresentation",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkWidgetRepresentationCppCommand(static_cast<vtkWidgetRepresentation *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkWidgetRepresentation"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkCurveRepresentation  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkCurveRepresentation");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkCurveRepresentation  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkCurveRepresentation");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetInteractionState",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetInteractionState(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetProjectToPlane",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetProjectToPlane(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetProjectToPlane",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetProjectToPlane();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("ProjectToPlaneOn",argv[1]))&&(argc == 2))
  {
    op->ProjectToPlaneOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ProjectToPlaneOff",argv[1]))&&(argc == 2))
  {
    op->ProjectToPlaneOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetPlaneSource",argv[1]))&&(argc == 3))
  {
    vtkPlaneSource  *temp0;
    error = 0;

    temp0 = (vtkPlaneSource *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPlaneSource"),interp,error));
    if (!error)
  {
    op->SetPlaneSource(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetProjectionNormal",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetProjectionNormal(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetProjectionNormalMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetProjectionNormalMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetProjectionNormalMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetProjectionNormalMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetProjectionNormal",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetProjectionNormal();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetProjectionNormalToXAxes",argv[1]))&&(argc == 2))
  {
    op->SetProjectionNormalToXAxes();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetProjectionNormalToYAxes",argv[1]))&&(argc == 2))
  {
    op->SetProjectionNormalToYAxes();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetProjectionNormalToZAxes",argv[1]))&&(argc == 2))
  {
    op->SetProjectionNormalToZAxes();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetProjectionNormalToOblique",argv[1]))&&(argc == 2))
  {
    op->SetProjectionNormalToOblique();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetProjectionPosition",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetProjectionPosition(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetProjectionPosition",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetProjectionPosition();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetPolyData",argv[1]))&&(argc == 3))
  {
    vtkPolyData  *temp0;
    error = 0;

    temp0 = (vtkPolyData *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPolyData"),interp,error));
    if (!error)
  {
    op->GetPolyData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetHandleProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetHandleProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetSelectedHandleProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetSelectedHandleProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetLineProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetLineProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetSelectedLineProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetSelectedLineProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetNumberOfHandles",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNumberOfHandles(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfHandles",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfHandles();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetHandlePosition",argv[1]))&&(argc == 6))
  {
    int      temp0;
    double   temp1;
    double   temp2;
    double   temp3;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp3 = tempd;
    if (!error)
  {
    op->SetHandlePosition(temp0,temp1,temp2,temp3);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetHandlePositions",argv[1]))&&(argc == 2))
  {
    vtkDoubleArray  *temp20;
    temp20 = (op)->GetHandlePositions();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDoubleArray");
    return TCL_OK;
  }
  if ((!strcmp("SetClosed",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetClosed(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetClosed",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetClosed();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("ClosedOn",argv[1]))&&(argc == 2))
  {
    op->ClosedOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ClosedOff",argv[1]))&&(argc == 2))
  {
    op->ClosedOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("IsClosed",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->IsClosed();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSummedLength",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSummedLength();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("InitializeHandles",argv[1]))&&(argc == 3))
  {
    vtkPoints  *temp0;
    error = 0;

    temp0 = (vtkPoints *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPoints"),interp,error));
    if (!error)
  {
    op->InitializeHandles(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("BuildRepresentation",argv[1]))&&(argc == 2))
  {
    op->BuildRepresentation();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ComputeInteractionState",argv[1]))&&(argc == 5))
  {
    int      temp0;
    int      temp1;
    int      temp2;
    int      temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (!error)
  {
    temp20 = (op)->ComputeInteractionState(temp0,temp1,temp2);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("StartWidgetInteraction",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->StartWidgetInteraction(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("WidgetInteraction",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->WidgetInteraction(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("EndWidgetInteraction",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->EndWidgetInteraction(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("ReleaseGraphicsResources",argv[1]))&&(argc == 3))
  {
    vtkWindow  *temp0;
    error = 0;

    temp0 = (vtkWindow *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkWindow"),interp,error));
    if (!error)
  {
    op->ReleaseGraphicsResources(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("RenderOpaqueGeometry",argv[1]))&&(argc == 3))
  {
    vtkViewport  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkViewport *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkViewport"),interp,error));
    if (!error)
  {
    temp20 = (op)->RenderOpaqueGeometry(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("RenderTranslucentPolygonalGeometry",argv[1]))&&(argc == 3))
  {
    vtkViewport  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkViewport *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkViewport"),interp,error));
    if (!error)
  {
    temp20 = (op)->RenderTranslucentPolygonalGeometry(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("RenderOverlay",argv[1]))&&(argc == 3))
  {
    vtkViewport  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkViewport *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkViewport"),interp,error));
    if (!error)
  {
    temp20 = (op)->RenderOverlay(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("HasTranslucentPolygonalGeometry",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->HasTranslucentPolygonalGeometry();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetLineColor",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    op->SetLineColor(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkCurveRepresentationCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkWidgetRepresentationCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkCurveRepresentation:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetInteractionState\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetProjectToPlane\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetProjectToPlane\n",NULL);
    Tcl_AppendResult(interp,"  ProjectToPlaneOn\n",NULL);
    Tcl_AppendResult(interp,"  ProjectToPlaneOff\n",NULL);
    Tcl_AppendResult(interp,"  SetPlaneSource\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetProjectionNormal\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetProjectionNormalMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetProjectionNormalMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetProjectionNormal\n",NULL);
    Tcl_AppendResult(interp,"  SetProjectionNormalToXAxes\n",NULL);
    Tcl_AppendResult(interp,"  SetProjectionNormalToYAxes\n",NULL);
    Tcl_AppendResult(interp,"  SetProjectionNormalToZAxes\n",NULL);
    Tcl_AppendResult(interp,"  SetProjectionNormalToOblique\n",NULL);
    Tcl_AppendResult(interp,"  SetProjectionPosition\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetProjectionPosition\n",NULL);
    Tcl_AppendResult(interp,"  GetPolyData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetHandleProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetSelectedHandleProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetLineProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetSelectedLineProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfHandles\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfHandles\n",NULL);
    Tcl_AppendResult(interp,"  SetHandlePosition\t with 4 args\n",NULL);
    Tcl_AppendResult(interp,"  GetHandlePositions\n",NULL);
    Tcl_AppendResult(interp,"  SetClosed\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetClosed\n",NULL);
    Tcl_AppendResult(interp,"  ClosedOn\n",NULL);
    Tcl_AppendResult(interp,"  ClosedOff\n",NULL);
    Tcl_AppendResult(interp,"  IsClosed\n",NULL);
    Tcl_AppendResult(interp,"  GetSummedLength\n",NULL);
    Tcl_AppendResult(interp,"  InitializeHandles\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  BuildRepresentation\n",NULL);
    Tcl_AppendResult(interp,"  ComputeInteractionState\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  StartWidgetInteraction\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  WidgetInteraction\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  EndWidgetInteraction\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  ReleaseGraphicsResources\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RenderOpaqueGeometry\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RenderTranslucentPolygonalGeometry\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RenderOverlay\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  HasTranslucentPolygonalGeometry\n",NULL);
    Tcl_AppendResult(interp,"  SetLineColor\t with 3 args\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkWidgetRepresentationCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetInteractionState" );
    Tcl_DStringAppendElement ( &dString, "SetProjectToPlane" );
    Tcl_DStringAppendElement ( &dString, "GetProjectToPlane" );
    Tcl_DStringAppendElement ( &dString, "ProjectToPlaneOn" );
    Tcl_DStringAppendElement ( &dString, "ProjectToPlaneOff" );
    Tcl_DStringAppendElement ( &dString, "SetPlaneSource" );
    Tcl_DStringAppendElement ( &dString, "SetProjectionNormal" );
    Tcl_DStringAppendElement ( &dString, "GetProjectionNormalMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetProjectionNormalMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetProjectionNormal" );
    Tcl_DStringAppendElement ( &dString, "SetProjectionNormalToXAxes" );
    Tcl_DStringAppendElement ( &dString, "SetProjectionNormalToYAxes" );
    Tcl_DStringAppendElement ( &dString, "SetProjectionNormalToZAxes" );
    Tcl_DStringAppendElement ( &dString, "SetProjectionNormalToOblique" );
    Tcl_DStringAppendElement ( &dString, "SetProjectionPosition" );
    Tcl_DStringAppendElement ( &dString, "GetProjectionPosition" );
    Tcl_DStringAppendElement ( &dString, "GetPolyData" );
    Tcl_DStringAppendElement ( &dString, "GetHandleProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSelectedHandleProperty" );
    Tcl_DStringAppendElement ( &dString, "GetLineProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSelectedLineProperty" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfHandles" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfHandles" );
    Tcl_DStringAppendElement ( &dString, "SetHandlePosition" );
    Tcl_DStringAppendElement ( &dString, "GetHandlePositions" );
    Tcl_DStringAppendElement ( &dString, "SetClosed" );
    Tcl_DStringAppendElement ( &dString, "GetClosed" );
    Tcl_DStringAppendElement ( &dString, "ClosedOn" );
    Tcl_DStringAppendElement ( &dString, "ClosedOff" );
    Tcl_DStringAppendElement ( &dString, "IsClosed" );
    Tcl_DStringAppendElement ( &dString, "GetSummedLength" );
    Tcl_DStringAppendElement ( &dString, "InitializeHandles" );
    Tcl_DStringAppendElement ( &dString, "BuildRepresentation" );
    Tcl_DStringAppendElement ( &dString, "ComputeInteractionState" );
    Tcl_DStringAppendElement ( &dString, "StartWidgetInteraction" );
    Tcl_DStringAppendElement ( &dString, "WidgetInteraction" );
    Tcl_DStringAppendElement ( &dString, "EndWidgetInteraction" );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    Tcl_DStringAppendElement ( &dString, "RenderOpaqueGeometry" );
    Tcl_DStringAppendElement ( &dString, "RenderTranslucentPolygonalGeometry" );
    Tcl_DStringAppendElement ( &dString, "RenderOverlay" );
    Tcl_DStringAppendElement ( &dString, "HasTranslucentPolygonalGeometry" );
    Tcl_DStringAppendElement ( &dString, "SetLineColor" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkWidgetRepresentationCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetInteractionState */
    if ( strcmp ( argv[2], "SetInteractionState" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetInteractionState" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetInteractionState */
    Tcl_DStringAppendElement ( &dString, " Set the interaction state\n" );
    Tcl_DStringAppendElement ( &dString, "void SetInteractionState(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetInteractionState */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetProjectToPlane */
    if ( strcmp ( argv[2], "SetProjectToPlane" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetProjectToPlane" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetProjectToPlane */
    Tcl_DStringAppendElement ( &dString, " Force the widget to be projected onto one of the orthogonal\n planes.  Remember that when the InteractionState changes, a\n ModifiedEvent is invoked.  This can be used to snap the curve to\n the plane if it is originally not aligned.  The normal in\n SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and\n 3 for arbitrary oblique planes when the widget is tied to a\n vtkPlaneSource.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetProjectToPlane(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetProjectToPlane */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetProjectToPlane */
    if ( strcmp ( argv[2], "GetProjectToPlane" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetProjectToPlane" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetProjectToPlane */
    Tcl_DStringAppendElement ( &dString, " Force the widget to be projected onto one of the orthogonal\n planes.  Remember that when the InteractionState changes, a\n ModifiedEvent is invoked.  This can be used to snap the curve to\n the plane if it is originally not aligned.  The normal in\n SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and\n 3 for arbitrary oblique planes when the widget is tied to a\n vtkPlaneSource.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetProjectToPlane();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetProjectToPlane */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ProjectToPlaneOn */
    if ( strcmp ( argv[2], "ProjectToPlaneOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ProjectToPlaneOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ProjectToPlaneOn */
    Tcl_DStringAppendElement ( &dString, " Force the widget to be projected onto one of the orthogonal\n planes.  Remember that when the InteractionState changes, a\n ModifiedEvent is invoked.  This can be used to snap the curve to\n the plane if it is originally not aligned.  The normal in\n SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and\n 3 for arbitrary oblique planes when the widget is tied to a\n vtkPlaneSource.\n" );
    Tcl_DStringAppendElement ( &dString, "void ProjectToPlaneOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for ProjectToPlaneOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ProjectToPlaneOff */
    if ( strcmp ( argv[2], "ProjectToPlaneOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ProjectToPlaneOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ProjectToPlaneOff */
    Tcl_DStringAppendElement ( &dString, " Force the widget to be projected onto one of the orthogonal\n planes.  Remember that when the InteractionState changes, a\n ModifiedEvent is invoked.  This can be used to snap the curve to\n the plane if it is originally not aligned.  The normal in\n SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and\n 3 for arbitrary oblique planes when the widget is tied to a\n vtkPlaneSource.\n" );
    Tcl_DStringAppendElement ( &dString, "void ProjectToPlaneOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for ProjectToPlaneOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPlaneSource */
    if ( strcmp ( argv[2], "SetPlaneSource" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPlaneSource" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPlaneSource" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPlaneSource */
    Tcl_DStringAppendElement ( &dString, " Set up a reference to a vtkPlaneSource that could be from another widget\n object, e.g. a vtkPolyDataSourceWidget.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPlaneSource(vtkPlaneSource *plane);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetPlaneSource */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetProjectionNormal */
    if ( strcmp ( argv[2], "SetProjectionNormal" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetProjectionNormal" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetProjectionNormal */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetProjectionNormal(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetProjectionNormal */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetProjectionNormalMinValue */
    if ( strcmp ( argv[2], "GetProjectionNormalMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetProjectionNormalMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetProjectionNormalMinValue */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int GetProjectionNormalMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetProjectionNormalMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetProjectionNormalMaxValue */
    if ( strcmp ( argv[2], "GetProjectionNormalMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetProjectionNormalMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetProjectionNormalMaxValue */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int GetProjectionNormalMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetProjectionNormalMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetProjectionNormal */
    if ( strcmp ( argv[2], "GetProjectionNormal" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetProjectionNormal" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetProjectionNormal */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int GetProjectionNormal();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetProjectionNormal */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetProjectionNormalToXAxes */
    if ( strcmp ( argv[2], "SetProjectionNormalToXAxes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetProjectionNormalToXAxes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetProjectionNormalToXAxes */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetProjectionNormalToXAxes();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetProjectionNormalToXAxes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetProjectionNormalToYAxes */
    if ( strcmp ( argv[2], "SetProjectionNormalToYAxes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetProjectionNormalToYAxes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetProjectionNormalToYAxes */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetProjectionNormalToYAxes();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetProjectionNormalToYAxes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetProjectionNormalToZAxes */
    if ( strcmp ( argv[2], "SetProjectionNormalToZAxes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetProjectionNormalToZAxes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetProjectionNormalToZAxes */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetProjectionNormalToZAxes();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetProjectionNormalToZAxes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetProjectionNormalToOblique */
    if ( strcmp ( argv[2], "SetProjectionNormalToOblique" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetProjectionNormalToOblique" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetProjectionNormalToOblique */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetProjectionNormalToOblique();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetProjectionNormalToOblique */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetProjectionPosition */
    if ( strcmp ( argv[2], "SetProjectionPosition" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetProjectionPosition" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetProjectionPosition */
    Tcl_DStringAppendElement ( &dString, " Set the position of poly line handles and points in terms of a plane's\n position. i.e., if ProjectionNormal is 0, all of the x-coordinate\n values of the points are set to position. Any value can be passed (and is\n ignored) to update the poly line points when Projection normal is set to 3\n for arbritrary plane orientations.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetProjectionPosition(double position);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetProjectionPosition */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetProjectionPosition */
    if ( strcmp ( argv[2], "GetProjectionPosition" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetProjectionPosition" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetProjectionPosition */
    Tcl_DStringAppendElement ( &dString, " Set the position of poly line handles and points in terms of a plane's\n position. i.e., if ProjectionNormal is 0, all of the x-coordinate\n values of the points are set to position. Any value can be passed (and is\n ignored) to update the poly line points when Projection normal is set to 3\n for arbritrary plane orientations.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetProjectionPosition();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetProjectionPosition */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolyData */
    if ( strcmp ( argv[2], "GetPolyData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolyData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPolyData" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolyData */
    Tcl_DStringAppendElement ( &dString, " Grab the polydata (including points) that defines the\n interpolating curve. Points are guaranteed to be up-to-date when\n either the InteractionEvent or EndInteraction events are\n invoked. The user provides the vtkPolyData and the points and\n polyline are added to it.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void GetPolyData(vtkPolyData *pd) = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetPolyData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetHandleProperty */
    if ( strcmp ( argv[2], "GetHandleProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetHandleProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetHandleProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the handle properties (the spheres are the handles). The\n properties of the handles when selected and unselected can be manipulated.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetHandleProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetHandleProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSelectedHandleProperty */
    if ( strcmp ( argv[2], "GetSelectedHandleProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelectedHandleProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelectedHandleProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the handle properties (the spheres are the handles). The\n properties of the handles when selected and unselected can be manipulated.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetSelectedHandleProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetSelectedHandleProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLineProperty */
    if ( strcmp ( argv[2], "GetLineProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLineProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLineProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the line properties. The properties of the line when selected\n and unselected can be manipulated.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetLineProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetLineProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSelectedLineProperty */
    if ( strcmp ( argv[2], "GetSelectedLineProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelectedLineProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelectedLineProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the line properties. The properties of the line when selected\n and unselected can be manipulated.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetSelectedLineProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetSelectedLineProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfHandles */
    if ( strcmp ( argv[2], "SetNumberOfHandles" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfHandles" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfHandles */
    Tcl_DStringAppendElement ( &dString, " Set/Get the number of handles for this widget.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetNumberOfHandles(int npts) = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetNumberOfHandles */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfHandles */
    if ( strcmp ( argv[2], "GetNumberOfHandles" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfHandles" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfHandles */
    Tcl_DStringAppendElement ( &dString, " Set/Get the number of handles for this widget.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfHandles();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetNumberOfHandles */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetHandlePosition */
    if ( strcmp ( argv[2], "SetHandlePosition" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetHandlePosition" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetHandlePosition */
    Tcl_DStringAppendElement ( &dString, " Set/Get the position of the handles. Call GetNumberOfHandles\n to determine the valid range of handle indices.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetHandlePosition(int handle, double x, double y, double z);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetHandlePosition */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetHandlePositions */
    if ( strcmp ( argv[2], "GetHandlePositions" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetHandlePositions" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetHandlePositions */
    Tcl_DStringAppendElement ( &dString, " Set/Get the position of the handles. Call GetNumberOfHandles\n to determine the valid range of handle indices.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkDoubleArray *GetHandlePositions() = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetHandlePositions */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetClosed */
    if ( strcmp ( argv[2], "SetClosed" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetClosed" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetClosed */
    Tcl_DStringAppendElement ( &dString, " Control whether the curve is open or closed. A closed forms a\n continuous loop: the first and last points are the same.  A\n minimum of 3 handles are required to form a closed loop.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetClosed(int closed);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetClosed */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClosed */
    if ( strcmp ( argv[2], "GetClosed" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClosed" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClosed */
    Tcl_DStringAppendElement ( &dString, " Control whether the curve is open or closed. A closed forms a\n continuous loop: the first and last points are the same.  A\n minimum of 3 handles are required to form a closed loop.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetClosed();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetClosed */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ClosedOn */
    if ( strcmp ( argv[2], "ClosedOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ClosedOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ClosedOn */
    Tcl_DStringAppendElement ( &dString, " Control whether the curve is open or closed. A closed forms a\n continuous loop: the first and last points are the same.  A\n minimum of 3 handles are required to form a closed loop.\n" );
    Tcl_DStringAppendElement ( &dString, "void ClosedOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for ClosedOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ClosedOff */
    if ( strcmp ( argv[2], "ClosedOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ClosedOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ClosedOff */
    Tcl_DStringAppendElement ( &dString, " Control whether the curve is open or closed. A closed forms a\n continuous loop: the first and last points are the same.  A\n minimum of 3 handles are required to form a closed loop.\n" );
    Tcl_DStringAppendElement ( &dString, "void ClosedOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for ClosedOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsClosed */
    if ( strcmp ( argv[2], "IsClosed" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsClosed" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsClosed */
    Tcl_DStringAppendElement ( &dString, " Convenience method to determine whether the curve is\n closed in a geometric sense.  The widget may be set \"closed\" but still\n be geometrically open (e.g., a straight line).\n" );
    Tcl_DStringAppendElement ( &dString, "int IsClosed();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for IsClosed */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSummedLength */
    if ( strcmp ( argv[2], "GetSummedLength" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSummedLength" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSummedLength */
    Tcl_DStringAppendElement ( &dString, " Get the approximate vs. the true arc length of the curve. Calculated as\n the summed lengths of the individual straight line segments. Use\n SetResolution to control the accuracy.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual double GetSummedLength() = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for GetSummedLength */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: InitializeHandles */
    if ( strcmp ( argv[2], "InitializeHandles" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "InitializeHandles" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPoints" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for InitializeHandles */
    Tcl_DStringAppendElement ( &dString, " Convenience method to allocate and set the handles from a\n vtkPoints instance.  If the first and last points are the same,\n the curve sets Closed to the on InteractionState and disregards\n the last point, otherwise Closed remains unchanged.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void InitializeHandles(vtkPoints *points) = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for InitializeHandles */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: BuildRepresentation */
    if ( strcmp ( argv[2], "BuildRepresentation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "BuildRepresentation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for BuildRepresentation */
    Tcl_DStringAppendElement ( &dString, " These are methods that satisfy vtkWidgetRepresentation's\n API. Note that a version of place widget is available where the\n center and handle position are specified.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void BuildRepresentation() = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for BuildRepresentation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ComputeInteractionState */
    if ( strcmp ( argv[2], "ComputeInteractionState" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeInteractionState" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeInteractionState */
    Tcl_DStringAppendElement ( &dString, " These are methods that satisfy vtkWidgetRepresentation's\n API. Note that a version of place widget is available where the\n center and handle position are specified.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int ComputeInteractionState(int X, int Y, int modify=0);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for ComputeInteractionState */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: StartWidgetInteraction */
    if ( strcmp ( argv[2], "StartWidgetInteraction" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "StartWidgetInteraction" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for StartWidgetInteraction */
    Tcl_DStringAppendElement ( &dString, " These are methods that satisfy vtkWidgetRepresentation's\n API. Note that a version of place widget is available where the\n center and handle position are specified.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void StartWidgetInteraction(double e\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for StartWidgetInteraction */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: WidgetInteraction */
    if ( strcmp ( argv[2], "WidgetInteraction" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "WidgetInteraction" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for WidgetInteraction */
    Tcl_DStringAppendElement ( &dString, " These are methods that satisfy vtkWidgetRepresentation's\n API. Note that a version of place widget is available where the\n center and handle position are specified.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void WidgetInteraction(double e\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for WidgetInteraction */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: EndWidgetInteraction */
    if ( strcmp ( argv[2], "EndWidgetInteraction" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "EndWidgetInteraction" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for EndWidgetInteraction */
    Tcl_DStringAppendElement ( &dString, " These are methods that satisfy vtkWidgetRepresentation's\n API. Note that a version of place widget is available where the\n center and handle position are specified.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void EndWidgetInteraction(double e\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for EndWidgetInteraction */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ReleaseGraphicsResources */
    if ( strcmp ( argv[2], "ReleaseGraphicsResources" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkWindow" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReleaseGraphicsResources */
    Tcl_DStringAppendElement ( &dString, " Methods supporting, and required by, the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void ReleaseGraphicsResources(vtkWindow *);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for ReleaseGraphicsResources */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RenderOpaqueGeometry */
    if ( strcmp ( argv[2], "RenderOpaqueGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RenderOpaqueGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkViewport" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RenderOpaqueGeometry */
    Tcl_DStringAppendElement ( &dString, " Methods supporting, and required by, the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int RenderOpaqueGeometry(vtkViewport *);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for RenderOpaqueGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RenderTranslucentPolygonalGeometry */
    if ( strcmp ( argv[2], "RenderTranslucentPolygonalGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RenderTranslucentPolygonalGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkViewport" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RenderTranslucentPolygonalGeometry */
    Tcl_DStringAppendElement ( &dString, " Methods supporting, and required by, the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int RenderTranslucentPolygonalGeometry(vtkViewport *);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for RenderTranslucentPolygonalGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RenderOverlay */
    if ( strcmp ( argv[2], "RenderOverlay" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RenderOverlay" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkViewport" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RenderOverlay */
    Tcl_DStringAppendElement ( &dString, " Methods supporting, and required by, the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int RenderOverlay(vtkViewport *);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for RenderOverlay */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: HasTranslucentPolygonalGeometry */
    if ( strcmp ( argv[2], "HasTranslucentPolygonalGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HasTranslucentPolygonalGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HasTranslucentPolygonalGeometry */
    Tcl_DStringAppendElement ( &dString, " Methods supporting, and required by, the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int HasTranslucentPolygonalGeometry();" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for HasTranslucentPolygonalGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLineColor */
    if ( strcmp ( argv[2], "SetLineColor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLineColor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLineColor */
    Tcl_DStringAppendElement ( &dString, " Convenience method to set the line color.\n Ideally one should use GetLineProperty()->SetColor().\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLineColor(double r, double g, double b);" );
    Tcl_DStringAppendElement ( &dString, "vtkCurveRepresentation" );
    /* Closing for SetLineColor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkWidgetRepresentationCppCommand(static_cast<vtkWidgetRepresentation *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
