// tcl wrapper for vtkFinitePlaneRepresentation object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkFinitePlaneRepresentation.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkFinitePlaneRepresentationNewCommand()
{
  vtkFinitePlaneRepresentation *temp = vtkFinitePlaneRepresentation::New();
  return static_cast<ClientData>(temp);
}

int vtkWidgetRepresentationCppCommand(vtkWidgetRepresentation *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkFinitePlaneRepresentationCppCommand(vtkFinitePlaneRepresentation *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkFinitePlaneRepresentationCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkFinitePlaneRepresentationCppCommand(static_cast<vtkFinitePlaneRepresentation *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkFinitePlaneRepresentation_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkFinitePlaneRepresentation"),vtkFinitePlaneRepresentationNewCommand,vtkFinitePlaneRepresentationCommand);
  return 0;
}

int VTKTCL_EXPORT vtkFinitePlaneRepresentationCppCommand(vtkFinitePlaneRepresentation *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkFinitePlaneRepresentation",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkWidgetRepresentationCppCommand(static_cast<vtkWidgetRepresentation *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkWidgetRepresentation"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkFinitePlaneRepresentation  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkFinitePlaneRepresentation");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkFinitePlaneRepresentation  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkFinitePlaneRepresentation");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkFinitePlaneRepresentation  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkFinitePlaneRepresentation");
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolyData",argv[1]))&&(argc == 3))
  {
    vtkPolyData  *temp0;
    error = 0;

    temp0 = (vtkPolyData *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPolyData"),interp,error));
    if (!error)
  {
    op->GetPolyData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetV1HandleProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetV1HandleProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetV2HandleProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetV2HandleProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetSelectedHandleProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetSelectedHandleProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetPlaneProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetPlaneProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetSelectedPlaneProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetSelectedPlaneProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetTubing",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetTubing(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTubing",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetTubing();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("TubingOn",argv[1]))&&(argc == 2))
  {
    op->TubingOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("TubingOff",argv[1]))&&(argc == 2))
  {
    op->TubingOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetDrawPlane",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetDrawPlane(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDrawPlane",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetDrawPlane();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("DrawPlaneOn",argv[1]))&&(argc == 2))
  {
    op->DrawPlaneOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("DrawPlaneOff",argv[1]))&&(argc == 2))
  {
    op->DrawPlaneOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetHandles",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetHandles(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("HandlesOn",argv[1]))&&(argc == 2))
  {
    op->HandlesOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("HandlesOff",argv[1]))&&(argc == 2))
  {
    op->HandlesOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PlaceWidget",argv[1]))&&(argc == 8))
  {
    double temp0[6];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (!error)
  {
    op->PlaceWidget(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("BuildRepresentation",argv[1]))&&(argc == 2))
  {
    op->BuildRepresentation();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ComputeInteractionState",argv[1]))&&(argc == 5))
  {
    int      temp0;
    int      temp1;
    int      temp2;
    int      temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (!error)
  {
    temp20 = (op)->ComputeInteractionState(temp0,temp1,temp2);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("StartWidgetInteraction",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->StartWidgetInteraction(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("WidgetInteraction",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->WidgetInteraction(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("ReleaseGraphicsResources",argv[1]))&&(argc == 3))
  {
    vtkWindow  *temp0;
    error = 0;

    temp0 = (vtkWindow *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkWindow"),interp,error));
    if (!error)
  {
    op->ReleaseGraphicsResources(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("RenderOpaqueGeometry",argv[1]))&&(argc == 3))
  {
    vtkViewport  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkViewport *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkViewport"),interp,error));
    if (!error)
  {
    temp20 = (op)->RenderOpaqueGeometry(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("RenderTranslucentPolygonalGeometry",argv[1]))&&(argc == 3))
  {
    vtkViewport  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkViewport *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkViewport"),interp,error));
    if (!error)
  {
    temp20 = (op)->RenderTranslucentPolygonalGeometry(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("HasTranslucentPolygonalGeometry",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->HasTranslucentPolygonalGeometry();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetInteractionState",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetInteractionState(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetInteractionStateMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetInteractionStateMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetInteractionStateMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetInteractionStateMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetOrigin",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    op->SetOrigin(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetOrigin",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    op->SetOrigin(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetOrigin",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetOrigin();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetNormal",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    op->SetNormal(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetNormal",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    op->SetNormal(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNormal",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetNormal();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetV1",argv[1]))&&(argc == 4))
  {
    double   temp0;
    double   temp1;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    op->SetV1(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetV1",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->SetV1(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetV1",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetV1();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetV2",argv[1]))&&(argc == 4))
  {
    double   temp0;
    double   temp1;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    op->SetV2(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetV2",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->SetV2(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetV2",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetV2();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetRepresentationState",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetRepresentationState(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRepresentationState",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetRepresentationState();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetNormalProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetNormalProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetSelectedNormalProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetSelectedNormalProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkFinitePlaneRepresentationCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkWidgetRepresentationCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkFinitePlaneRepresentation:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolyData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetV1HandleProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetV2HandleProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetSelectedHandleProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetPlaneProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetSelectedPlaneProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetTubing\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTubing\n",NULL);
    Tcl_AppendResult(interp,"  TubingOn\n",NULL);
    Tcl_AppendResult(interp,"  TubingOff\n",NULL);
    Tcl_AppendResult(interp,"  SetDrawPlane\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDrawPlane\n",NULL);
    Tcl_AppendResult(interp,"  DrawPlaneOn\n",NULL);
    Tcl_AppendResult(interp,"  DrawPlaneOff\n",NULL);
    Tcl_AppendResult(interp,"  SetHandles\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  HandlesOn\n",NULL);
    Tcl_AppendResult(interp,"  HandlesOff\n",NULL);
    Tcl_AppendResult(interp,"  PlaceWidget\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  BuildRepresentation\n",NULL);
    Tcl_AppendResult(interp,"  ComputeInteractionState\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  StartWidgetInteraction\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  WidgetInteraction\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  ReleaseGraphicsResources\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RenderOpaqueGeometry\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RenderTranslucentPolygonalGeometry\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  HasTranslucentPolygonalGeometry\n",NULL);
    Tcl_AppendResult(interp,"  SetInteractionState\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetInteractionStateMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetInteractionStateMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  SetOrigin\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetOrigin\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetOrigin\n",NULL);
    Tcl_AppendResult(interp,"  SetNormal\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetNormal\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetNormal\n",NULL);
    Tcl_AppendResult(interp,"  SetV1\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetV1\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetV1\n",NULL);
    Tcl_AppendResult(interp,"  SetV2\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetV2\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetV2\n",NULL);
    Tcl_AppendResult(interp,"  SetRepresentationState\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRepresentationState\n",NULL);
    Tcl_AppendResult(interp,"  GetNormalProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetSelectedNormalProperty\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkWidgetRepresentationCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "GetPolyData" );
    Tcl_DStringAppendElement ( &dString, "GetV1HandleProperty" );
    Tcl_DStringAppendElement ( &dString, "GetV2HandleProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSelectedHandleProperty" );
    Tcl_DStringAppendElement ( &dString, "GetPlaneProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSelectedPlaneProperty" );
    Tcl_DStringAppendElement ( &dString, "SetTubing" );
    Tcl_DStringAppendElement ( &dString, "GetTubing" );
    Tcl_DStringAppendElement ( &dString, "TubingOn" );
    Tcl_DStringAppendElement ( &dString, "TubingOff" );
    Tcl_DStringAppendElement ( &dString, "SetDrawPlane" );
    Tcl_DStringAppendElement ( &dString, "GetDrawPlane" );
    Tcl_DStringAppendElement ( &dString, "DrawPlaneOn" );
    Tcl_DStringAppendElement ( &dString, "DrawPlaneOff" );
    Tcl_DStringAppendElement ( &dString, "SetHandles" );
    Tcl_DStringAppendElement ( &dString, "HandlesOn" );
    Tcl_DStringAppendElement ( &dString, "HandlesOff" );
    Tcl_DStringAppendElement ( &dString, "PlaceWidget" );
    Tcl_DStringAppendElement ( &dString, "BuildRepresentation" );
    Tcl_DStringAppendElement ( &dString, "ComputeInteractionState" );
    Tcl_DStringAppendElement ( &dString, "StartWidgetInteraction" );
    Tcl_DStringAppendElement ( &dString, "WidgetInteraction" );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    Tcl_DStringAppendElement ( &dString, "RenderOpaqueGeometry" );
    Tcl_DStringAppendElement ( &dString, "RenderTranslucentPolygonalGeometry" );
    Tcl_DStringAppendElement ( &dString, "HasTranslucentPolygonalGeometry" );
    Tcl_DStringAppendElement ( &dString, "SetInteractionState" );
    Tcl_DStringAppendElement ( &dString, "GetInteractionStateMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetInteractionStateMaxValue" );
    Tcl_DStringAppendElement ( &dString, "SetOrigin" );
    Tcl_DStringAppendElement ( &dString, "SetOrigin" );
    Tcl_DStringAppendElement ( &dString, "GetOrigin" );
    Tcl_DStringAppendElement ( &dString, "SetNormal" );
    Tcl_DStringAppendElement ( &dString, "SetNormal" );
    Tcl_DStringAppendElement ( &dString, "GetNormal" );
    Tcl_DStringAppendElement ( &dString, "SetV1" );
    Tcl_DStringAppendElement ( &dString, "SetV1" );
    Tcl_DStringAppendElement ( &dString, "GetV1" );
    Tcl_DStringAppendElement ( &dString, "SetV2" );
    Tcl_DStringAppendElement ( &dString, "SetV2" );
    Tcl_DStringAppendElement ( &dString, "GetV2" );
    Tcl_DStringAppendElement ( &dString, "SetRepresentationState" );
    Tcl_DStringAppendElement ( &dString, "GetRepresentationState" );
    Tcl_DStringAppendElement ( &dString, "GetNormalProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSelectedNormalProperty" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkWidgetRepresentationCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Instantiate the class.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkFinitePlaneRepresentation *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Standard vtkObject methods\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Standard vtkObject methods\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Standard vtkObject methods\n" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Standard vtkObject methods\n" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolyData */
    if ( strcmp ( argv[2], "GetPolyData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolyData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPolyData" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolyData */
    Tcl_DStringAppendElement ( &dString, " Grab the polydata that defines the plane. The polydata contains a single\n polygon.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetPolyData(vtkPolyData *pd);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetPolyData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetV1HandleProperty */
    if ( strcmp ( argv[2], "GetV1HandleProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetV1HandleProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetV1HandleProperty */
    Tcl_DStringAppendElement ( &dString, " Get the handle properties (the little balls are the handles). The\n properties of the handles, when selected or normal, can be\n specified.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetV1HandleProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetV1HandleProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetV2HandleProperty */
    if ( strcmp ( argv[2], "GetV2HandleProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetV2HandleProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetV2HandleProperty */
    Tcl_DStringAppendElement ( &dString, " Get the handle properties (the little balls are the handles). The\n properties of the handles, when selected or normal, can be\n specified.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetV2HandleProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetV2HandleProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSelectedHandleProperty */
    if ( strcmp ( argv[2], "GetSelectedHandleProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelectedHandleProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelectedHandleProperty */
    Tcl_DStringAppendElement ( &dString, " Get the handle properties (the little balls are the handles). The\n properties of the handles, when selected or normal, can be\n specified.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetSelectedHandleProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetSelectedHandleProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPlaneProperty */
    if ( strcmp ( argv[2], "GetPlaneProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPlaneProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPlaneProperty */
    Tcl_DStringAppendElement ( &dString, " Get the plane properties. The\n properties of the plane when selected and normal can be\n set.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetPlaneProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetPlaneProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSelectedPlaneProperty */
    if ( strcmp ( argv[2], "GetSelectedPlaneProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelectedPlaneProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelectedPlaneProperty */
    Tcl_DStringAppendElement ( &dString, " Get the plane properties. The\n properties of the plane when selected and normal can be\n set.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetSelectedPlaneProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetSelectedPlaneProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTubing */
    if ( strcmp ( argv[2], "SetTubing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTubing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTubing */
    Tcl_DStringAppendElement ( &dString, " Turn on/off tubing of the wire outline of the plane. The tube thickens\n the line by wrapping with a vtkTubeFilter.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTubing(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetTubing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTubing */
    if ( strcmp ( argv[2], "GetTubing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTubing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTubing */
    Tcl_DStringAppendElement ( &dString, " Turn on/off tubing of the wire outline of the plane. The tube thickens\n the line by wrapping with a vtkTubeFilter.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetTubing();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetTubing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: TubingOn */
    if ( strcmp ( argv[2], "TubingOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "TubingOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for TubingOn */
    Tcl_DStringAppendElement ( &dString, " Turn on/off tubing of the wire outline of the plane. The tube thickens\n the line by wrapping with a vtkTubeFilter.\n" );
    Tcl_DStringAppendElement ( &dString, "void TubingOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for TubingOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: TubingOff */
    if ( strcmp ( argv[2], "TubingOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "TubingOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for TubingOff */
    Tcl_DStringAppendElement ( &dString, " Turn on/off tubing of the wire outline of the plane. The tube thickens\n the line by wrapping with a vtkTubeFilter.\n" );
    Tcl_DStringAppendElement ( &dString, "void TubingOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for TubingOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDrawPlane */
    if ( strcmp ( argv[2], "SetDrawPlane" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDrawPlane" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDrawPlane */
    Tcl_DStringAppendElement ( &dString, " Enable/disable the drawing of the plane. In some cases the plane\n interferes with the object that it is operating on (i.e., the\n plane interferes with the cut surface it produces producing\n z-buffer artifacts.)\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDrawPlane(bool plane);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetDrawPlane */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDrawPlane */
    if ( strcmp ( argv[2], "GetDrawPlane" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDrawPlane" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDrawPlane */
    Tcl_DStringAppendElement ( &dString, " Enable/disable the drawing of the plane. In some cases the plane\n interferes with the object that it is operating on (i.e., the\n plane interferes with the cut surface it produces producing\n z-buffer artifacts.)\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetDrawPlane();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetDrawPlane */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DrawPlaneOn */
    if ( strcmp ( argv[2], "DrawPlaneOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DrawPlaneOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DrawPlaneOn */
    Tcl_DStringAppendElement ( &dString, " Enable/disable the drawing of the plane. In some cases the plane\n interferes with the object that it is operating on (i.e., the\n plane interferes with the cut surface it produces producing\n z-buffer artifacts.)\n" );
    Tcl_DStringAppendElement ( &dString, "void DrawPlaneOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for DrawPlaneOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DrawPlaneOff */
    if ( strcmp ( argv[2], "DrawPlaneOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DrawPlaneOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DrawPlaneOff */
    Tcl_DStringAppendElement ( &dString, " Enable/disable the drawing of the plane. In some cases the plane\n interferes with the object that it is operating on (i.e., the\n plane interferes with the cut surface it produces producing\n z-buffer artifacts.)\n" );
    Tcl_DStringAppendElement ( &dString, "void DrawPlaneOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for DrawPlaneOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetHandles */
    if ( strcmp ( argv[2], "SetHandles" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetHandles" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetHandles */
    Tcl_DStringAppendElement ( &dString, " Switches handles (the spheres) on or off by manipulating the underlying\n actor visibility.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetHandles(bool handles);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetHandles */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: HandlesOn */
    if ( strcmp ( argv[2], "HandlesOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HandlesOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HandlesOn */
    Tcl_DStringAppendElement ( &dString, " Switches handles (the spheres) on or off by manipulating the underlying\n actor visibility.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void HandlesOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for HandlesOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: HandlesOff */
    if ( strcmp ( argv[2], "HandlesOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HandlesOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HandlesOff */
    Tcl_DStringAppendElement ( &dString, " Switches handles (the spheres) on or off by manipulating the underlying\n actor visibility.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void HandlesOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for HandlesOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PlaceWidget */
    if ( strcmp ( argv[2], "PlaceWidget" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PlaceWidget" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PlaceWidget */
    Tcl_DStringAppendElement ( &dString, " These are methods that satisfy vtkWidgetRepresentation's API.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void PlaceWidget(double bounds\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for PlaceWidget */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: BuildRepresentation */
    if ( strcmp ( argv[2], "BuildRepresentation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "BuildRepresentation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for BuildRepresentation */
    Tcl_DStringAppendElement ( &dString, " These are methods that satisfy vtkWidgetRepresentation's API.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void BuildRepresentation();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for BuildRepresentation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ComputeInteractionState */
    if ( strcmp ( argv[2], "ComputeInteractionState" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeInteractionState" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeInteractionState */
    Tcl_DStringAppendElement ( &dString, " These are methods that satisfy vtkWidgetRepresentation's API.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int ComputeInteractionState(int X, int Y, int modify=0);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for ComputeInteractionState */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: StartWidgetInteraction */
    if ( strcmp ( argv[2], "StartWidgetInteraction" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "StartWidgetInteraction" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for StartWidgetInteraction */
    Tcl_DStringAppendElement ( &dString, " These are methods that satisfy vtkWidgetRepresentation's API.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void StartWidgetInteraction(double e\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for StartWidgetInteraction */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: WidgetInteraction */
    if ( strcmp ( argv[2], "WidgetInteraction" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "WidgetInteraction" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for WidgetInteraction */
    Tcl_DStringAppendElement ( &dString, " These are methods that satisfy vtkWidgetRepresentation's API.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void WidgetInteraction(double e\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for WidgetInteraction */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ReleaseGraphicsResources */
    if ( strcmp ( argv[2], "ReleaseGraphicsResources" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkWindow" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReleaseGraphicsResources */
    Tcl_DStringAppendElement ( &dString, " Methods supporting, and required by, the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void ReleaseGraphicsResources(vtkWindow *);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for ReleaseGraphicsResources */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RenderOpaqueGeometry */
    if ( strcmp ( argv[2], "RenderOpaqueGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RenderOpaqueGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkViewport" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RenderOpaqueGeometry */
    Tcl_DStringAppendElement ( &dString, " Methods supporting, and required by, the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int RenderOpaqueGeometry(vtkViewport *);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for RenderOpaqueGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RenderTranslucentPolygonalGeometry */
    if ( strcmp ( argv[2], "RenderTranslucentPolygonalGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RenderTranslucentPolygonalGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkViewport" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RenderTranslucentPolygonalGeometry */
    Tcl_DStringAppendElement ( &dString, " Methods supporting, and required by, the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int RenderTranslucentPolygonalGeometry(vtkViewport *);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for RenderTranslucentPolygonalGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: HasTranslucentPolygonalGeometry */
    if ( strcmp ( argv[2], "HasTranslucentPolygonalGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HasTranslucentPolygonalGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HasTranslucentPolygonalGeometry */
    Tcl_DStringAppendElement ( &dString, " Methods supporting, and required by, the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int HasTranslucentPolygonalGeometry();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for HasTranslucentPolygonalGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetInteractionState */
    if ( strcmp ( argv[2], "SetInteractionState" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetInteractionState" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetInteractionState */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetInteractionState(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetInteractionState */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetInteractionStateMinValue */
    if ( strcmp ( argv[2], "GetInteractionStateMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetInteractionStateMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetInteractionStateMinValue */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int GetInteractionStateMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetInteractionStateMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetInteractionStateMaxValue */
    if ( strcmp ( argv[2], "GetInteractionStateMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetInteractionStateMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetInteractionStateMaxValue */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int GetInteractionStateMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetInteractionStateMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetOrigin */
    if ( strcmp ( argv[2], "SetOrigin" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOrigin" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOrigin */
    Tcl_DStringAppendElement ( &dString, " Set/Get the origin of the plane.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetOrigin(double x, double y, double z);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetOrigin */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetOrigin */
    if ( strcmp ( argv[2], "SetOrigin" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOrigin" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOrigin */
    Tcl_DStringAppendElement ( &dString, " Set/Get the origin of the plane.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetOrigin(double x\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetOrigin */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetOrigin */
    if ( strcmp ( argv[2], "GetOrigin" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOrigin" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOrigin */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double *GetOrigin();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetOrigin */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNormal */
    if ( strcmp ( argv[2], "SetNormal" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNormal" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNormal */
    Tcl_DStringAppendElement ( &dString, " Set/Get the normal to the plane.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNormal(double x, double y, double z);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetNormal */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNormal */
    if ( strcmp ( argv[2], "SetNormal" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNormal" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNormal */
    Tcl_DStringAppendElement ( &dString, " Set/Get the normal to the plane.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetNormal(double x\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetNormal */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNormal */
    if ( strcmp ( argv[2], "GetNormal" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNormal" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNormal */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double *GetNormal();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetNormal */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetV1 */
    if ( strcmp ( argv[2], "SetV1" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetV1" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetV1 */
    Tcl_DStringAppendElement ( &dString, " Set/Get the v1 vector of the plane.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetV1(double x, double y);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetV1 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetV1 */
    if ( strcmp ( argv[2], "SetV1" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetV1" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetV1 */
    Tcl_DStringAppendElement ( &dString, " Set/Get the v1 vector of the plane.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetV1(double x\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetV1 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetV1 */
    if ( strcmp ( argv[2], "GetV1" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetV1" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetV1 */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double *GetV1();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetV1 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetV2 */
    if ( strcmp ( argv[2], "SetV2" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetV2" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetV2 */
    Tcl_DStringAppendElement ( &dString, " Set/Get the v2 vector of the plane.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetV2(double x, double y);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetV2 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetV2 */
    if ( strcmp ( argv[2], "SetV2" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetV2" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetV2 */
    Tcl_DStringAppendElement ( &dString, " Set/Get the v2 vector of the plane.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetV2(double x\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetV2 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetV2 */
    if ( strcmp ( argv[2], "GetV2" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetV2" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetV2 */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double *GetV2();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetV2 */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRepresentationState */
    if ( strcmp ( argv[2], "SetRepresentationState" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRepresentationState" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRepresentationState */
    Tcl_DStringAppendElement ( &dString, " Sets the visual appearance of the representation based on the\n state it is in. This state is usually the same as InteractionState.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetRepresentationState(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for SetRepresentationState */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRepresentationState */
    if ( strcmp ( argv[2], "GetRepresentationState" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRepresentationState" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRepresentationState */
    Tcl_DStringAppendElement ( &dString, " Sets the visual appearance of the representation based on the\n state it is in. This state is usually the same as InteractionState.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetRepresentationState();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetRepresentationState */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNormalProperty */
    if ( strcmp ( argv[2], "GetNormalProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNormalProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNormalProperty */
    Tcl_DStringAppendElement ( &dString, " Get the properties on the normal (line and cone).\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetNormalProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetNormalProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSelectedNormalProperty */
    if ( strcmp ( argv[2], "GetSelectedNormalProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelectedNormalProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelectedNormalProperty */
    Tcl_DStringAppendElement ( &dString, " Get the properties on the normal (line and cone).\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetSelectedNormalProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkFinitePlaneRepresentation" );
    /* Closing for GetSelectedNormalProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkWidgetRepresentationCppCommand(static_cast<vtkWidgetRepresentation *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
