// tcl wrapper for vtkImplicitCylinderRepresentation object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImplicitCylinderRepresentation.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkImplicitCylinderRepresentationNewCommand()
{
  vtkImplicitCylinderRepresentation *temp = vtkImplicitCylinderRepresentation::New();
  return static_cast<ClientData>(temp);
}

int vtkWidgetRepresentationCppCommand(vtkWidgetRepresentation *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkImplicitCylinderRepresentationCppCommand(vtkImplicitCylinderRepresentation *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkImplicitCylinderRepresentationCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkImplicitCylinderRepresentationCppCommand(static_cast<vtkImplicitCylinderRepresentation *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkImplicitCylinderRepresentation_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkImplicitCylinderRepresentation"),vtkImplicitCylinderRepresentationNewCommand,vtkImplicitCylinderRepresentationCommand);
  return 0;
}

int VTKTCL_EXPORT vtkImplicitCylinderRepresentationCppCommand(vtkImplicitCylinderRepresentation *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkImplicitCylinderRepresentation",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkWidgetRepresentationCppCommand(static_cast<vtkWidgetRepresentation *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkWidgetRepresentation"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkImplicitCylinderRepresentation  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkImplicitCylinderRepresentation");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkImplicitCylinderRepresentation  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkImplicitCylinderRepresentation");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkImplicitCylinderRepresentation  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkImplicitCylinderRepresentation");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetCenter",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    op->SetCenter(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetCenter",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    op->SetCenter(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCenter",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetCenter();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("GetCenter",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    op->GetCenter(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetAxis",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    op->SetAxis(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetAxis",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    op->SetAxis(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAxis",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetAxis();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("GetAxis",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    op->GetAxis(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetRadius",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetRadius(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRadius",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRadius();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetMinRadius",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetMinRadius(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMinRadiusMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetMinRadiusMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetMinRadiusMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetMinRadiusMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetMinRadius",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetMinRadius();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetMaxRadius",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetMaxRadius(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMaxRadiusMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetMaxRadiusMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetMaxRadiusMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetMaxRadiusMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetMaxRadius",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetMaxRadius();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetAlongXAxis",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetAlongXAxis(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAlongXAxis",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetAlongXAxis();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("AlongXAxisOn",argv[1]))&&(argc == 2))
  {
    op->AlongXAxisOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("AlongXAxisOff",argv[1]))&&(argc == 2))
  {
    op->AlongXAxisOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetAlongYAxis",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetAlongYAxis(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAlongYAxis",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetAlongYAxis();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("AlongYAxisOn",argv[1]))&&(argc == 2))
  {
    op->AlongYAxisOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("AlongYAxisOff",argv[1]))&&(argc == 2))
  {
    op->AlongYAxisOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetAlongZAxis",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetAlongZAxis(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAlongZAxis",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetAlongZAxis();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("AlongZAxisOn",argv[1]))&&(argc == 2))
  {
    op->AlongZAxisOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("AlongZAxisOff",argv[1]))&&(argc == 2))
  {
    op->AlongZAxisOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetDrawCylinder",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetDrawCylinder(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDrawCylinder",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDrawCylinder();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("DrawCylinderOn",argv[1]))&&(argc == 2))
  {
    op->DrawCylinderOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("DrawCylinderOff",argv[1]))&&(argc == 2))
  {
    op->DrawCylinderOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetResolution",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetResolution(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetResolutionMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetResolutionMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetResolutionMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetResolutionMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetResolution",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetResolution();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetTubing",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetTubing(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTubing",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetTubing();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("TubingOn",argv[1]))&&(argc == 2))
  {
    op->TubingOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("TubingOff",argv[1]))&&(argc == 2))
  {
    op->TubingOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetOutlineTranslation",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetOutlineTranslation(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetOutlineTranslation",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetOutlineTranslation();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("OutlineTranslationOn",argv[1]))&&(argc == 2))
  {
    op->OutlineTranslationOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("OutlineTranslationOff",argv[1]))&&(argc == 2))
  {
    op->OutlineTranslationOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetOutsideBounds",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetOutsideBounds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetOutsideBounds",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetOutsideBounds();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("OutsideBoundsOn",argv[1]))&&(argc == 2))
  {
    op->OutsideBoundsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("OutsideBoundsOff",argv[1]))&&(argc == 2))
  {
    op->OutsideBoundsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetWidgetBounds",argv[1]))&&(argc == 8))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double   temp3;
    double   temp4;
    double   temp5;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp3 = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp4 = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp5 = tempd;
    if (!error)
  {
    op->SetWidgetBounds(temp0,temp1,temp2,temp3,temp4,temp5);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetWidgetBounds",argv[1]))&&(argc == 8))
  {
    double temp0[6];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (!error)
  {
    op->SetWidgetBounds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetWidgetBounds",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetWidgetBounds();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[3], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[4], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[5], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetConstrainToWidgetBounds",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetConstrainToWidgetBounds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetConstrainToWidgetBounds",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetConstrainToWidgetBounds();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("ConstrainToWidgetBoundsOn",argv[1]))&&(argc == 2))
  {
    op->ConstrainToWidgetBoundsOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ConstrainToWidgetBoundsOff",argv[1]))&&(argc == 2))
  {
    op->ConstrainToWidgetBoundsOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetScaleEnabled",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetScaleEnabled(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetScaleEnabled",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetScaleEnabled();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("ScaleEnabledOn",argv[1]))&&(argc == 2))
  {
    op->ScaleEnabledOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ScaleEnabledOff",argv[1]))&&(argc == 2))
  {
    op->ScaleEnabledOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetCylinder",argv[1]))&&(argc == 3))
  {
    vtkCylinder  *temp0;
    error = 0;

    temp0 = (vtkCylinder *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkCylinder"),interp,error));
    if (!error)
  {
    op->GetCylinder(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolyData",argv[1]))&&(argc == 3))
  {
    vtkPolyData  *temp0;
    error = 0;

    temp0 = (vtkPolyData *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPolyData"),interp,error));
    if (!error)
  {
    op->GetPolyData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("UpdatePlacement",argv[1]))&&(argc == 2))
  {
    op->UpdatePlacement();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("GetAxisProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetAxisProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetSelectedAxisProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetSelectedAxisProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetCylinderProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetCylinderProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetSelectedCylinderProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetSelectedCylinderProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetOutlineProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetOutlineProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetSelectedOutlineProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetSelectedOutlineProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("GetEdgesProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetEdgesProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetEdgeColor",argv[1]))&&(argc == 3))
  {
    vtkLookupTable  *temp0;
    error = 0;

    temp0 = (vtkLookupTable *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkLookupTable"),interp,error));
    if (!error)
  {
    op->SetEdgeColor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetEdgeColor",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    op->SetEdgeColor(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetEdgeColor",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    op->SetEdgeColor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("ComputeInteractionState",argv[1]))&&(argc == 5))
  {
    int      temp0;
    int      temp1;
    int      temp2;
    int      temp20;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetInt(interp,argv[3],&tempi) != TCL_OK) error = 1;
    temp1 = tempi;
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (!error)
  {
    temp20 = (op)->ComputeInteractionState(temp0,temp1,temp2);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("PlaceWidget",argv[1]))&&(argc == 8))
  {
    double temp0[6];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (!error)
  {
    op->PlaceWidget(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("BuildRepresentation",argv[1]))&&(argc == 2))
  {
    op->BuildRepresentation();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("StartWidgetInteraction",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->StartWidgetInteraction(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("WidgetInteraction",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->WidgetInteraction(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("EndWidgetInteraction",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->EndWidgetInteraction(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetActors",argv[1]))&&(argc == 3))
  {
    vtkPropCollection  *temp0;
    error = 0;

    temp0 = (vtkPropCollection *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPropCollection"),interp,error));
    if (!error)
  {
    op->GetActors(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("ReleaseGraphicsResources",argv[1]))&&(argc == 3))
  {
    vtkWindow  *temp0;
    error = 0;

    temp0 = (vtkWindow *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkWindow"),interp,error));
    if (!error)
  {
    op->ReleaseGraphicsResources(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("RenderOpaqueGeometry",argv[1]))&&(argc == 3))
  {
    vtkViewport  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkViewport *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkViewport"),interp,error));
    if (!error)
  {
    temp20 = (op)->RenderOpaqueGeometry(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("RenderTranslucentPolygonalGeometry",argv[1]))&&(argc == 3))
  {
    vtkViewport  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkViewport *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkViewport"),interp,error));
    if (!error)
  {
    temp20 = (op)->RenderTranslucentPolygonalGeometry(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("HasTranslucentPolygonalGeometry",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->HasTranslucentPolygonalGeometry();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetBumpDistance",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetBumpDistance(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetBumpDistanceMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetBumpDistanceMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetBumpDistanceMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetBumpDistanceMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetBumpDistance",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetBumpDistance();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("BumpCylinder",argv[1]))&&(argc == 4))
  {
    int      temp0;
    double   temp1;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    op->BumpCylinder(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("PushCylinder",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->PushCylinder(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetInteractionState",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetInteractionState(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetInteractionStateMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetInteractionStateMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetInteractionStateMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetInteractionStateMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetRepresentationState",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetRepresentationState(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRepresentationState",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetRepresentationState();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkImplicitCylinderRepresentationCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkWidgetRepresentationCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkImplicitCylinderRepresentation:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetCenter\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetCenter\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetCenter\n",NULL);
    Tcl_AppendResult(interp,"  GetCenter\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetAxis\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetAxis\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetAxis\n",NULL);
    Tcl_AppendResult(interp,"  GetAxis\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetRadius\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRadius\n",NULL);
    Tcl_AppendResult(interp,"  SetMinRadius\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMinRadiusMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetMinRadiusMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetMinRadius\n",NULL);
    Tcl_AppendResult(interp,"  SetMaxRadius\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMaxRadiusMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetMaxRadiusMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetMaxRadius\n",NULL);
    Tcl_AppendResult(interp,"  SetAlongXAxis\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAlongXAxis\n",NULL);
    Tcl_AppendResult(interp,"  AlongXAxisOn\n",NULL);
    Tcl_AppendResult(interp,"  AlongXAxisOff\n",NULL);
    Tcl_AppendResult(interp,"  SetAlongYAxis\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAlongYAxis\n",NULL);
    Tcl_AppendResult(interp,"  AlongYAxisOn\n",NULL);
    Tcl_AppendResult(interp,"  AlongYAxisOff\n",NULL);
    Tcl_AppendResult(interp,"  SetAlongZAxis\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAlongZAxis\n",NULL);
    Tcl_AppendResult(interp,"  AlongZAxisOn\n",NULL);
    Tcl_AppendResult(interp,"  AlongZAxisOff\n",NULL);
    Tcl_AppendResult(interp,"  SetDrawCylinder\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDrawCylinder\n",NULL);
    Tcl_AppendResult(interp,"  DrawCylinderOn\n",NULL);
    Tcl_AppendResult(interp,"  DrawCylinderOff\n",NULL);
    Tcl_AppendResult(interp,"  SetResolution\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetResolutionMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetResolutionMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetResolution\n",NULL);
    Tcl_AppendResult(interp,"  SetTubing\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTubing\n",NULL);
    Tcl_AppendResult(interp,"  TubingOn\n",NULL);
    Tcl_AppendResult(interp,"  TubingOff\n",NULL);
    Tcl_AppendResult(interp,"  SetOutlineTranslation\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOutlineTranslation\n",NULL);
    Tcl_AppendResult(interp,"  OutlineTranslationOn\n",NULL);
    Tcl_AppendResult(interp,"  OutlineTranslationOff\n",NULL);
    Tcl_AppendResult(interp,"  SetOutsideBounds\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOutsideBounds\n",NULL);
    Tcl_AppendResult(interp,"  OutsideBoundsOn\n",NULL);
    Tcl_AppendResult(interp,"  OutsideBoundsOff\n",NULL);
    Tcl_AppendResult(interp,"  SetWidgetBounds\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  SetWidgetBounds\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  GetWidgetBounds\n",NULL);
    Tcl_AppendResult(interp,"  SetConstrainToWidgetBounds\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetConstrainToWidgetBounds\n",NULL);
    Tcl_AppendResult(interp,"  ConstrainToWidgetBoundsOn\n",NULL);
    Tcl_AppendResult(interp,"  ConstrainToWidgetBoundsOff\n",NULL);
    Tcl_AppendResult(interp,"  SetScaleEnabled\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetScaleEnabled\n",NULL);
    Tcl_AppendResult(interp,"  ScaleEnabledOn\n",NULL);
    Tcl_AppendResult(interp,"  ScaleEnabledOff\n",NULL);
    Tcl_AppendResult(interp,"  GetCylinder\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolyData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  UpdatePlacement\n",NULL);
    Tcl_AppendResult(interp,"  GetAxisProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetSelectedAxisProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetCylinderProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetSelectedCylinderProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetOutlineProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetSelectedOutlineProperty\n",NULL);
    Tcl_AppendResult(interp,"  GetEdgesProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetEdgeColor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetEdgeColor\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetEdgeColor\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  ComputeInteractionState\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  PlaceWidget\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  BuildRepresentation\n",NULL);
    Tcl_AppendResult(interp,"  StartWidgetInteraction\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  WidgetInteraction\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  EndWidgetInteraction\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetActors\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  ReleaseGraphicsResources\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RenderOpaqueGeometry\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RenderTranslucentPolygonalGeometry\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  HasTranslucentPolygonalGeometry\n",NULL);
    Tcl_AppendResult(interp,"  SetBumpDistance\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetBumpDistanceMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetBumpDistanceMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetBumpDistance\n",NULL);
    Tcl_AppendResult(interp,"  BumpCylinder\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  PushCylinder\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetInteractionState\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetInteractionStateMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetInteractionStateMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  SetRepresentationState\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRepresentationState\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkWidgetRepresentationCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetCenter" );
    Tcl_DStringAppendElement ( &dString, "SetCenter" );
    Tcl_DStringAppendElement ( &dString, "GetCenter" );
    Tcl_DStringAppendElement ( &dString, "GetCenter" );
    Tcl_DStringAppendElement ( &dString, "SetAxis" );
    Tcl_DStringAppendElement ( &dString, "SetAxis" );
    Tcl_DStringAppendElement ( &dString, "GetAxis" );
    Tcl_DStringAppendElement ( &dString, "GetAxis" );
    Tcl_DStringAppendElement ( &dString, "SetRadius" );
    Tcl_DStringAppendElement ( &dString, "GetRadius" );
    Tcl_DStringAppendElement ( &dString, "SetMinRadius" );
    Tcl_DStringAppendElement ( &dString, "GetMinRadiusMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetMinRadiusMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetMinRadius" );
    Tcl_DStringAppendElement ( &dString, "SetMaxRadius" );
    Tcl_DStringAppendElement ( &dString, "GetMaxRadiusMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetMaxRadiusMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetMaxRadius" );
    Tcl_DStringAppendElement ( &dString, "SetAlongXAxis" );
    Tcl_DStringAppendElement ( &dString, "GetAlongXAxis" );
    Tcl_DStringAppendElement ( &dString, "AlongXAxisOn" );
    Tcl_DStringAppendElement ( &dString, "AlongXAxisOff" );
    Tcl_DStringAppendElement ( &dString, "SetAlongYAxis" );
    Tcl_DStringAppendElement ( &dString, "GetAlongYAxis" );
    Tcl_DStringAppendElement ( &dString, "AlongYAxisOn" );
    Tcl_DStringAppendElement ( &dString, "AlongYAxisOff" );
    Tcl_DStringAppendElement ( &dString, "SetAlongZAxis" );
    Tcl_DStringAppendElement ( &dString, "GetAlongZAxis" );
    Tcl_DStringAppendElement ( &dString, "AlongZAxisOn" );
    Tcl_DStringAppendElement ( &dString, "AlongZAxisOff" );
    Tcl_DStringAppendElement ( &dString, "SetDrawCylinder" );
    Tcl_DStringAppendElement ( &dString, "GetDrawCylinder" );
    Tcl_DStringAppendElement ( &dString, "DrawCylinderOn" );
    Tcl_DStringAppendElement ( &dString, "DrawCylinderOff" );
    Tcl_DStringAppendElement ( &dString, "SetResolution" );
    Tcl_DStringAppendElement ( &dString, "GetResolutionMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetResolutionMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetResolution" );
    Tcl_DStringAppendElement ( &dString, "SetTubing" );
    Tcl_DStringAppendElement ( &dString, "GetTubing" );
    Tcl_DStringAppendElement ( &dString, "TubingOn" );
    Tcl_DStringAppendElement ( &dString, "TubingOff" );
    Tcl_DStringAppendElement ( &dString, "SetOutlineTranslation" );
    Tcl_DStringAppendElement ( &dString, "GetOutlineTranslation" );
    Tcl_DStringAppendElement ( &dString, "OutlineTranslationOn" );
    Tcl_DStringAppendElement ( &dString, "OutlineTranslationOff" );
    Tcl_DStringAppendElement ( &dString, "SetOutsideBounds" );
    Tcl_DStringAppendElement ( &dString, "GetOutsideBounds" );
    Tcl_DStringAppendElement ( &dString, "OutsideBoundsOn" );
    Tcl_DStringAppendElement ( &dString, "OutsideBoundsOff" );
    Tcl_DStringAppendElement ( &dString, "SetWidgetBounds" );
    Tcl_DStringAppendElement ( &dString, "SetWidgetBounds" );
    Tcl_DStringAppendElement ( &dString, "GetWidgetBounds" );
    Tcl_DStringAppendElement ( &dString, "SetConstrainToWidgetBounds" );
    Tcl_DStringAppendElement ( &dString, "GetConstrainToWidgetBounds" );
    Tcl_DStringAppendElement ( &dString, "ConstrainToWidgetBoundsOn" );
    Tcl_DStringAppendElement ( &dString, "ConstrainToWidgetBoundsOff" );
    Tcl_DStringAppendElement ( &dString, "SetScaleEnabled" );
    Tcl_DStringAppendElement ( &dString, "GetScaleEnabled" );
    Tcl_DStringAppendElement ( &dString, "ScaleEnabledOn" );
    Tcl_DStringAppendElement ( &dString, "ScaleEnabledOff" );
    Tcl_DStringAppendElement ( &dString, "GetCylinder" );
    Tcl_DStringAppendElement ( &dString, "GetPolyData" );
    Tcl_DStringAppendElement ( &dString, "UpdatePlacement" );
    Tcl_DStringAppendElement ( &dString, "GetAxisProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSelectedAxisProperty" );
    Tcl_DStringAppendElement ( &dString, "GetCylinderProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSelectedCylinderProperty" );
    Tcl_DStringAppendElement ( &dString, "GetOutlineProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSelectedOutlineProperty" );
    Tcl_DStringAppendElement ( &dString, "GetEdgesProperty" );
    Tcl_DStringAppendElement ( &dString, "SetEdgeColor" );
    Tcl_DStringAppendElement ( &dString, "SetEdgeColor" );
    Tcl_DStringAppendElement ( &dString, "SetEdgeColor" );
    Tcl_DStringAppendElement ( &dString, "ComputeInteractionState" );
    Tcl_DStringAppendElement ( &dString, "PlaceWidget" );
    Tcl_DStringAppendElement ( &dString, "BuildRepresentation" );
    Tcl_DStringAppendElement ( &dString, "StartWidgetInteraction" );
    Tcl_DStringAppendElement ( &dString, "WidgetInteraction" );
    Tcl_DStringAppendElement ( &dString, "EndWidgetInteraction" );
    Tcl_DStringAppendElement ( &dString, "GetActors" );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    Tcl_DStringAppendElement ( &dString, "RenderOpaqueGeometry" );
    Tcl_DStringAppendElement ( &dString, "RenderTranslucentPolygonalGeometry" );
    Tcl_DStringAppendElement ( &dString, "HasTranslucentPolygonalGeometry" );
    Tcl_DStringAppendElement ( &dString, "SetBumpDistance" );
    Tcl_DStringAppendElement ( &dString, "GetBumpDistanceMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetBumpDistanceMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetBumpDistance" );
    Tcl_DStringAppendElement ( &dString, "BumpCylinder" );
    Tcl_DStringAppendElement ( &dString, "PushCylinder" );
    Tcl_DStringAppendElement ( &dString, "SetInteractionState" );
    Tcl_DStringAppendElement ( &dString, "GetInteractionStateMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetInteractionStateMaxValue" );
    Tcl_DStringAppendElement ( &dString, "SetRepresentationState" );
    Tcl_DStringAppendElement ( &dString, "GetRepresentationState" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkWidgetRepresentationCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Instantiate the class.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkImplicitCylinderRepresentation *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, " Standard methods for the class.\n" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, " Standard methods for the class.\n" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, " Standard methods for the class.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, " Standard methods for the class.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetCenter */
    if ( strcmp ( argv[2], "SetCenter" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCenter" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCenter */
    Tcl_DStringAppendElement ( &dString, " Get the center of the cylinder. The center is located along the\n cylinder axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetCenter(double x, double y, double z);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetCenter */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetCenter */
    if ( strcmp ( argv[2], "SetCenter" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCenter" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCenter */
    Tcl_DStringAppendElement ( &dString, " Get the center of the cylinder. The center is located along the\n cylinder axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetCenter(double x\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetCenter */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCenter */
    if ( strcmp ( argv[2], "GetCenter" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCenter" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCenter */
    Tcl_DStringAppendElement ( &dString, " Get the center of the cylinder. The center is located along the\n cylinder axis.\n" );
    Tcl_DStringAppendElement ( &dString, "double *GetCenter();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetCenter */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCenter */
    if ( strcmp ( argv[2], "GetCenter" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCenter" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCenter */
    Tcl_DStringAppendElement ( &dString, " Get the center of the cylinder. The center is located along the\n cylinder axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetCenter(double xyz\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetCenter */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAxis */
    if ( strcmp ( argv[2], "SetAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAxis */
    Tcl_DStringAppendElement ( &dString, " Set/Get the axis of rotation for the cylinder. If the axis is not\n specified as a unit vector, it will be normalized.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAxis(double x, double y, double z);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAxis */
    if ( strcmp ( argv[2], "SetAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAxis */
    Tcl_DStringAppendElement ( &dString, " Set/Get the axis of rotation for the cylinder. If the axis is not\n specified as a unit vector, it will be normalized.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAxis(double a\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAxis */
    if ( strcmp ( argv[2], "GetAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAxis */
    Tcl_DStringAppendElement ( &dString, " Set/Get the axis of rotation for the cylinder. If the axis is not\n specified as a unit vector, it will be normalized.\n" );
    Tcl_DStringAppendElement ( &dString, "double *GetAxis();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAxis */
    if ( strcmp ( argv[2], "GetAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAxis */
    Tcl_DStringAppendElement ( &dString, " Set/Get the axis of rotation for the cylinder. If the axis is not\n specified as a unit vector, it will be normalized.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetAxis(double a\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRadius */
    if ( strcmp ( argv[2], "SetRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRadius */
    Tcl_DStringAppendElement ( &dString, " Set/Get the radius of the cylinder. Note that if the radius is\n too big the cylinder will be outside of the bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRadius(double r);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadius */
    if ( strcmp ( argv[2], "GetRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadius */
    Tcl_DStringAppendElement ( &dString, " Set/Get the radius of the cylinder. Note that if the radius is\n too big the cylinder will be outside of the bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRadius();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMinRadius */
    if ( strcmp ( argv[2], "SetMinRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMinRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMinRadius */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum and maximum radius of the cylinder. This\n helps prevent the cylinder from \"disappearing\" during\n interaction.  Note that the minimum and maximum radius is\n specified as a fraction of the diagonal length of the widget\n bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetMinRadius(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetMinRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMinRadiusMinValue */
    if ( strcmp ( argv[2], "GetMinRadiusMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMinRadiusMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMinRadiusMinValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum and maximum radius of the cylinder. This\n helps prevent the cylinder from \"disappearing\" during\n interaction.  Note that the minimum and maximum radius is\n specified as a fraction of the diagonal length of the widget\n bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetMinRadiusMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetMinRadiusMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMinRadiusMaxValue */
    if ( strcmp ( argv[2], "GetMinRadiusMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMinRadiusMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMinRadiusMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum and maximum radius of the cylinder. This\n helps prevent the cylinder from \"disappearing\" during\n interaction.  Note that the minimum and maximum radius is\n specified as a fraction of the diagonal length of the widget\n bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetMinRadiusMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetMinRadiusMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMinRadius */
    if ( strcmp ( argv[2], "GetMinRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMinRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMinRadius */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum and maximum radius of the cylinder. This\n helps prevent the cylinder from \"disappearing\" during\n interaction.  Note that the minimum and maximum radius is\n specified as a fraction of the diagonal length of the widget\n bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetMinRadius();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetMinRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMaxRadius */
    if ( strcmp ( argv[2], "SetMaxRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMaxRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMaxRadius */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum and maximum radius of the cylinder. This\n helps prevent the cylinder from \"disappearing\" during\n interaction.  Note that the minimum and maximum radius is\n specified as a fraction of the diagonal length of the widget\n bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetMaxRadius(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetMaxRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMaxRadiusMinValue */
    if ( strcmp ( argv[2], "GetMaxRadiusMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaxRadiusMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaxRadiusMinValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum and maximum radius of the cylinder. This\n helps prevent the cylinder from \"disappearing\" during\n interaction.  Note that the minimum and maximum radius is\n specified as a fraction of the diagonal length of the widget\n bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetMaxRadiusMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetMaxRadiusMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMaxRadiusMaxValue */
    if ( strcmp ( argv[2], "GetMaxRadiusMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaxRadiusMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaxRadiusMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum and maximum radius of the cylinder. This\n helps prevent the cylinder from \"disappearing\" during\n interaction.  Note that the minimum and maximum radius is\n specified as a fraction of the diagonal length of the widget\n bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetMaxRadiusMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetMaxRadiusMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMaxRadius */
    if ( strcmp ( argv[2], "GetMaxRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaxRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaxRadius */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum and maximum radius of the cylinder. This\n helps prevent the cylinder from \"disappearing\" during\n interaction.  Note that the minimum and maximum radius is\n specified as a fraction of the diagonal length of the widget\n bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetMaxRadius();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetMaxRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAlongXAxis */
    if ( strcmp ( argv[2], "SetAlongXAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAlongXAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAlongXAxis */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAlongXAxis(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetAlongXAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAlongXAxis */
    if ( strcmp ( argv[2], "GetAlongXAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAlongXAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAlongXAxis */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetAlongXAxis();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetAlongXAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AlongXAxisOn */
    if ( strcmp ( argv[2], "AlongXAxisOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AlongXAxisOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AlongXAxisOn */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "void AlongXAxisOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for AlongXAxisOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AlongXAxisOff */
    if ( strcmp ( argv[2], "AlongXAxisOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AlongXAxisOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AlongXAxisOff */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "void AlongXAxisOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for AlongXAxisOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAlongYAxis */
    if ( strcmp ( argv[2], "SetAlongYAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAlongYAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAlongYAxis */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAlongYAxis(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetAlongYAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAlongYAxis */
    if ( strcmp ( argv[2], "GetAlongYAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAlongYAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAlongYAxis */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetAlongYAxis();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetAlongYAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AlongYAxisOn */
    if ( strcmp ( argv[2], "AlongYAxisOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AlongYAxisOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AlongYAxisOn */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "void AlongYAxisOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for AlongYAxisOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AlongYAxisOff */
    if ( strcmp ( argv[2], "AlongYAxisOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AlongYAxisOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AlongYAxisOff */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "void AlongYAxisOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for AlongYAxisOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAlongZAxis */
    if ( strcmp ( argv[2], "SetAlongZAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAlongZAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAlongZAxis */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAlongZAxis(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetAlongZAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAlongZAxis */
    if ( strcmp ( argv[2], "GetAlongZAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAlongZAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAlongZAxis */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetAlongZAxis();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetAlongZAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AlongZAxisOn */
    if ( strcmp ( argv[2], "AlongZAxisOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AlongZAxisOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AlongZAxisOn */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "void AlongZAxisOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for AlongZAxisOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AlongZAxisOff */
    if ( strcmp ( argv[2], "AlongZAxisOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AlongZAxisOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AlongZAxisOff */
    Tcl_DStringAppendElement ( &dString, " Force the cylinder widget to be aligned with one of the x-y-z axes.\n If one axis is set on, the other two will be set off.\n Remember that when the state changes, a ModifiedEvent is invoked.\n This can be used to snap the cylinder to the axes if it is originally\n not aligned.\n" );
    Tcl_DStringAppendElement ( &dString, "void AlongZAxisOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for AlongZAxisOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDrawCylinder */
    if ( strcmp ( argv[2], "SetDrawCylinder" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDrawCylinder" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDrawCylinder */
    Tcl_DStringAppendElement ( &dString, " Enable/disable the drawing of the cylinder. In some cases the cylinder\n interferes with the object that it is operating on (e.g., the\n cylinder interferes with the cut surface it produces resulting in\n z-buffer artifacts.) By default it is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDrawCylinder(int drawCyl);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetDrawCylinder */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDrawCylinder */
    if ( strcmp ( argv[2], "GetDrawCylinder" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDrawCylinder" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDrawCylinder */
    Tcl_DStringAppendElement ( &dString, " Enable/disable the drawing of the cylinder. In some cases the cylinder\n interferes with the object that it is operating on (e.g., the\n cylinder interferes with the cut surface it produces resulting in\n z-buffer artifacts.) By default it is off.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDrawCylinder();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetDrawCylinder */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DrawCylinderOn */
    if ( strcmp ( argv[2], "DrawCylinderOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DrawCylinderOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DrawCylinderOn */
    Tcl_DStringAppendElement ( &dString, " Enable/disable the drawing of the cylinder. In some cases the cylinder\n interferes with the object that it is operating on (e.g., the\n cylinder interferes with the cut surface it produces resulting in\n z-buffer artifacts.) By default it is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void DrawCylinderOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for DrawCylinderOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DrawCylinderOff */
    if ( strcmp ( argv[2], "DrawCylinderOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DrawCylinderOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DrawCylinderOff */
    Tcl_DStringAppendElement ( &dString, " Enable/disable the drawing of the cylinder. In some cases the cylinder\n interferes with the object that it is operating on (e.g., the\n cylinder interferes with the cut surface it produces resulting in\n z-buffer artifacts.) By default it is off.\n" );
    Tcl_DStringAppendElement ( &dString, "void DrawCylinderOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for DrawCylinderOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetResolution */
    if ( strcmp ( argv[2], "SetResolution" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetResolution" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetResolution */
    Tcl_DStringAppendElement ( &dString, " Set/Get the resolution of the cylinder. This is the number of\n polygonal facets used to approximate the curved cylindrical\n surface (for rendering purposes). An vtkCylinder is used under\n the hood to provide an exact surface representation.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetResolution(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetResolution */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetResolutionMinValue */
    if ( strcmp ( argv[2], "GetResolutionMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetResolutionMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetResolutionMinValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the resolution of the cylinder. This is the number of\n polygonal facets used to approximate the curved cylindrical\n surface (for rendering purposes). An vtkCylinder is used under\n the hood to provide an exact surface representation.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetResolutionMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetResolutionMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetResolutionMaxValue */
    if ( strcmp ( argv[2], "GetResolutionMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetResolutionMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetResolutionMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the resolution of the cylinder. This is the number of\n polygonal facets used to approximate the curved cylindrical\n surface (for rendering purposes). An vtkCylinder is used under\n the hood to provide an exact surface representation.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetResolutionMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetResolutionMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetResolution */
    if ( strcmp ( argv[2], "GetResolution" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetResolution" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetResolution */
    Tcl_DStringAppendElement ( &dString, " Set/Get the resolution of the cylinder. This is the number of\n polygonal facets used to approximate the curved cylindrical\n surface (for rendering purposes). An vtkCylinder is used under\n the hood to provide an exact surface representation.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetResolution();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetResolution */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTubing */
    if ( strcmp ( argv[2], "SetTubing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTubing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTubing */
    Tcl_DStringAppendElement ( &dString, " Turn on/off tubing of the wire outline of the cylinder\n intersecton (against the bounding box). The tube thickens the\n line by wrapping with a vtkTubeFilter.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTubing(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetTubing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTubing */
    if ( strcmp ( argv[2], "GetTubing" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTubing" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTubing */
    Tcl_DStringAppendElement ( &dString, " Turn on/off tubing of the wire outline of the cylinder\n intersecton (against the bounding box). The tube thickens the\n line by wrapping with a vtkTubeFilter.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetTubing();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetTubing */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: TubingOn */
    if ( strcmp ( argv[2], "TubingOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "TubingOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for TubingOn */
    Tcl_DStringAppendElement ( &dString, " Turn on/off tubing of the wire outline of the cylinder\n intersecton (against the bounding box). The tube thickens the\n line by wrapping with a vtkTubeFilter.\n" );
    Tcl_DStringAppendElement ( &dString, "void TubingOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for TubingOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: TubingOff */
    if ( strcmp ( argv[2], "TubingOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "TubingOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for TubingOff */
    Tcl_DStringAppendElement ( &dString, " Turn on/off tubing of the wire outline of the cylinder\n intersecton (against the bounding box). The tube thickens the\n line by wrapping with a vtkTubeFilter.\n" );
    Tcl_DStringAppendElement ( &dString, "void TubingOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for TubingOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetOutlineTranslation */
    if ( strcmp ( argv[2], "SetOutlineTranslation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOutlineTranslation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOutlineTranslation */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to translate the bounding box by moving it\n with the mouse.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetOutlineTranslation(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetOutlineTranslation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetOutlineTranslation */
    if ( strcmp ( argv[2], "GetOutlineTranslation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOutlineTranslation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOutlineTranslation */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to translate the bounding box by moving it\n with the mouse.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetOutlineTranslation();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetOutlineTranslation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: OutlineTranslationOn */
    if ( strcmp ( argv[2], "OutlineTranslationOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "OutlineTranslationOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for OutlineTranslationOn */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to translate the bounding box by moving it\n with the mouse.\n" );
    Tcl_DStringAppendElement ( &dString, "void OutlineTranslationOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for OutlineTranslationOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: OutlineTranslationOff */
    if ( strcmp ( argv[2], "OutlineTranslationOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "OutlineTranslationOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for OutlineTranslationOff */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to translate the bounding box by moving it\n with the mouse.\n" );
    Tcl_DStringAppendElement ( &dString, "void OutlineTranslationOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for OutlineTranslationOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetOutsideBounds */
    if ( strcmp ( argv[2], "SetOutsideBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOutsideBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOutsideBounds */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to move the widget outside of the bounds\n specified in the PlaceWidget() invocation.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetOutsideBounds(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetOutsideBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetOutsideBounds */
    if ( strcmp ( argv[2], "GetOutsideBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOutsideBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOutsideBounds */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to move the widget outside of the bounds\n specified in the PlaceWidget() invocation.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetOutsideBounds();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetOutsideBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: OutsideBoundsOn */
    if ( strcmp ( argv[2], "OutsideBoundsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "OutsideBoundsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for OutsideBoundsOn */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to move the widget outside of the bounds\n specified in the PlaceWidget() invocation.\n" );
    Tcl_DStringAppendElement ( &dString, "void OutsideBoundsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for OutsideBoundsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: OutsideBoundsOff */
    if ( strcmp ( argv[2], "OutsideBoundsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "OutsideBoundsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for OutsideBoundsOff */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to move the widget outside of the bounds\n specified in the PlaceWidget() invocation.\n" );
    Tcl_DStringAppendElement ( &dString, "void OutsideBoundsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for OutsideBoundsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetWidgetBounds */
    if ( strcmp ( argv[2], "SetWidgetBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetWidgetBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetWidgetBounds */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetWidgetBounds(double, double, double, double, double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetWidgetBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetWidgetBounds */
    if ( strcmp ( argv[2], "SetWidgetBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetWidgetBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetWidgetBounds */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetWidgetBounds(double a\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetWidgetBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetWidgetBounds */
    if ( strcmp ( argv[2], "GetWidgetBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetWidgetBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetWidgetBounds */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double *GetWidgetBounds();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetWidgetBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetConstrainToWidgetBounds */
    if ( strcmp ( argv[2], "SetConstrainToWidgetBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetConstrainToWidgetBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetConstrainToWidgetBounds */
    Tcl_DStringAppendElement ( &dString, " Turn on/off whether the cylinder should be constrained to the widget bounds.\n If on, the center will not be allowed to move outside the set widget bounds\n and the radius will be limited by MinRadius and MaxRadius. This is the\n default behaviour.\n If off, the center can be freely moved and the radius can be set to\n arbitrary values. The widget outline will change accordingly.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetConstrainToWidgetBounds(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetConstrainToWidgetBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetConstrainToWidgetBounds */
    if ( strcmp ( argv[2], "GetConstrainToWidgetBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetConstrainToWidgetBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetConstrainToWidgetBounds */
    Tcl_DStringAppendElement ( &dString, " Turn on/off whether the cylinder should be constrained to the widget bounds.\n If on, the center will not be allowed to move outside the set widget bounds\n and the radius will be limited by MinRadius and MaxRadius. This is the\n default behaviour.\n If off, the center can be freely moved and the radius can be set to\n arbitrary values. The widget outline will change accordingly.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetConstrainToWidgetBounds();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetConstrainToWidgetBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ConstrainToWidgetBoundsOn */
    if ( strcmp ( argv[2], "ConstrainToWidgetBoundsOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ConstrainToWidgetBoundsOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ConstrainToWidgetBoundsOn */
    Tcl_DStringAppendElement ( &dString, " Turn on/off whether the cylinder should be constrained to the widget bounds.\n If on, the center will not be allowed to move outside the set widget bounds\n and the radius will be limited by MinRadius and MaxRadius. This is the\n default behaviour.\n If off, the center can be freely moved and the radius can be set to\n arbitrary values. The widget outline will change accordingly.\n" );
    Tcl_DStringAppendElement ( &dString, "void ConstrainToWidgetBoundsOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for ConstrainToWidgetBoundsOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ConstrainToWidgetBoundsOff */
    if ( strcmp ( argv[2], "ConstrainToWidgetBoundsOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ConstrainToWidgetBoundsOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ConstrainToWidgetBoundsOff */
    Tcl_DStringAppendElement ( &dString, " Turn on/off whether the cylinder should be constrained to the widget bounds.\n If on, the center will not be allowed to move outside the set widget bounds\n and the radius will be limited by MinRadius and MaxRadius. This is the\n default behaviour.\n If off, the center can be freely moved and the radius can be set to\n arbitrary values. The widget outline will change accordingly.\n" );
    Tcl_DStringAppendElement ( &dString, "void ConstrainToWidgetBoundsOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for ConstrainToWidgetBoundsOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetScaleEnabled */
    if ( strcmp ( argv[2], "SetScaleEnabled" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetScaleEnabled" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetScaleEnabled */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to scale the widget with the mouse.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetScaleEnabled(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetScaleEnabled */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScaleEnabled */
    if ( strcmp ( argv[2], "GetScaleEnabled" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScaleEnabled" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScaleEnabled */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to scale the widget with the mouse.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetScaleEnabled();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetScaleEnabled */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ScaleEnabledOn */
    if ( strcmp ( argv[2], "ScaleEnabledOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ScaleEnabledOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ScaleEnabledOn */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to scale the widget with the mouse.\n" );
    Tcl_DStringAppendElement ( &dString, "void ScaleEnabledOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for ScaleEnabledOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ScaleEnabledOff */
    if ( strcmp ( argv[2], "ScaleEnabledOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ScaleEnabledOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ScaleEnabledOff */
    Tcl_DStringAppendElement ( &dString, " Turn on/off the ability to scale the widget with the mouse.\n" );
    Tcl_DStringAppendElement ( &dString, "void ScaleEnabledOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for ScaleEnabledOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCylinder */
    if ( strcmp ( argv[2], "GetCylinder" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCylinder" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkCylinder" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCylinder */
    Tcl_DStringAppendElement ( &dString, " Get the implicit function for the cylinder. The user must provide the\n instance of the class vtkCylinder. Note that vtkCylinder is a subclass of\n vtkImplicitFunction, meaning that it can be used by a variety of filters\n to perform clipping, cutting, and selection of data.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetCylinder(vtkCylinder *cyl);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetCylinder */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolyData */
    if ( strcmp ( argv[2], "GetPolyData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolyData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPolyData" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolyData */
    Tcl_DStringAppendElement ( &dString, " Grab the polydata that defines the cylinder. The polydata contains\n polygons that are clipped by the bounding box.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetPolyData(vtkPolyData *pd);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetPolyData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: UpdatePlacement */
    if ( strcmp ( argv[2], "UpdatePlacement" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "UpdatePlacement" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for UpdatePlacement */
    Tcl_DStringAppendElement ( &dString, " Satisfies the superclass API.  This will change the state of the widget\n to match changes that have been made to the underlying PolyDataSource.\n" );
    Tcl_DStringAppendElement ( &dString, "void UpdatePlacement(void);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for UpdatePlacement */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAxisProperty */
    if ( strcmp ( argv[2], "GetAxisProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAxisProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAxisProperty */
    Tcl_DStringAppendElement ( &dString, " Get the properties on the axis (line and cone).\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetAxisProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetAxisProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSelectedAxisProperty */
    if ( strcmp ( argv[2], "GetSelectedAxisProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelectedAxisProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelectedAxisProperty */
    Tcl_DStringAppendElement ( &dString, " Get the properties on the axis (line and cone).\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetSelectedAxisProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetSelectedAxisProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCylinderProperty */
    if ( strcmp ( argv[2], "GetCylinderProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCylinderProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCylinderProperty */
    Tcl_DStringAppendElement ( &dString, " Get the cylinder properties. The properties of the cylinder when selected\n and unselected can be manipulated.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetCylinderProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetCylinderProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSelectedCylinderProperty */
    if ( strcmp ( argv[2], "GetSelectedCylinderProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelectedCylinderProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelectedCylinderProperty */
    Tcl_DStringAppendElement ( &dString, " Get the cylinder properties. The properties of the cylinder when selected\n and unselected can be manipulated.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetSelectedCylinderProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetSelectedCylinderProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetOutlineProperty */
    if ( strcmp ( argv[2], "GetOutlineProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOutlineProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOutlineProperty */
    Tcl_DStringAppendElement ( &dString, " Get the property of the outline.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetOutlineProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetOutlineProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSelectedOutlineProperty */
    if ( strcmp ( argv[2], "GetSelectedOutlineProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSelectedOutlineProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSelectedOutlineProperty */
    Tcl_DStringAppendElement ( &dString, " Get the property of the outline.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetSelectedOutlineProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetSelectedOutlineProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetEdgesProperty */
    if ( strcmp ( argv[2], "GetEdgesProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetEdgesProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetEdgesProperty */
    Tcl_DStringAppendElement ( &dString, " Get the property of the intersection edges. (This property also\n applies to the edges when tubed.)\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetEdgesProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetEdgesProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetEdgeColor */
    if ( strcmp ( argv[2], "SetEdgeColor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetEdgeColor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkLookupTable" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetEdgeColor */
    Tcl_DStringAppendElement ( &dString, " Set color to the edge\n" );
    Tcl_DStringAppendElement ( &dString, "void SetEdgeColor(vtkLookupTable *);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetEdgeColor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetEdgeColor */
    if ( strcmp ( argv[2], "SetEdgeColor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetEdgeColor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetEdgeColor */
    Tcl_DStringAppendElement ( &dString, " Set color to the edge\n" );
    Tcl_DStringAppendElement ( &dString, "void SetEdgeColor(double, double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetEdgeColor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetEdgeColor */
    if ( strcmp ( argv[2], "SetEdgeColor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetEdgeColor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetEdgeColor */
    Tcl_DStringAppendElement ( &dString, " Set color to the edge\n" );
    Tcl_DStringAppendElement ( &dString, "void SetEdgeColor(double x\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetEdgeColor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ComputeInteractionState */
    if ( strcmp ( argv[2], "ComputeInteractionState" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ComputeInteractionState" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ComputeInteractionState */
    Tcl_DStringAppendElement ( &dString, " Methods to interface with the vtkImplicitCylinderWidget.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int ComputeInteractionState(int X, int Y, int modify=0);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for ComputeInteractionState */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PlaceWidget */
    if ( strcmp ( argv[2], "PlaceWidget" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PlaceWidget" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PlaceWidget */
    Tcl_DStringAppendElement ( &dString, " Methods to interface with the vtkImplicitCylinderWidget.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void PlaceWidget(double bounds\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for PlaceWidget */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: BuildRepresentation */
    if ( strcmp ( argv[2], "BuildRepresentation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "BuildRepresentation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for BuildRepresentation */
    Tcl_DStringAppendElement ( &dString, " Methods to interface with the vtkImplicitCylinderWidget.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void BuildRepresentation();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for BuildRepresentation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: StartWidgetInteraction */
    if ( strcmp ( argv[2], "StartWidgetInteraction" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "StartWidgetInteraction" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for StartWidgetInteraction */
    Tcl_DStringAppendElement ( &dString, " Methods to interface with the vtkImplicitCylinderWidget.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void StartWidgetInteraction(double eventPos\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for StartWidgetInteraction */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: WidgetInteraction */
    if ( strcmp ( argv[2], "WidgetInteraction" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "WidgetInteraction" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for WidgetInteraction */
    Tcl_DStringAppendElement ( &dString, " Methods to interface with the vtkImplicitCylinderWidget.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void WidgetInteraction(double newEventPos\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for WidgetInteraction */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: EndWidgetInteraction */
    if ( strcmp ( argv[2], "EndWidgetInteraction" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "EndWidgetInteraction" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for EndWidgetInteraction */
    Tcl_DStringAppendElement ( &dString, " Methods to interface with the vtkImplicitCylinderWidget.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void EndWidgetInteraction(double newEventPos\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for EndWidgetInteraction */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetActors */
    if ( strcmp ( argv[2], "GetActors" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetActors" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPropCollection" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetActors */
    Tcl_DStringAppendElement ( &dString, " Methods supporting the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void GetActors(vtkPropCollection *pc);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetActors */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ReleaseGraphicsResources */
    if ( strcmp ( argv[2], "ReleaseGraphicsResources" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkWindow" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReleaseGraphicsResources */
    Tcl_DStringAppendElement ( &dString, " Methods supporting the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void ReleaseGraphicsResources(vtkWindow *);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for ReleaseGraphicsResources */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RenderOpaqueGeometry */
    if ( strcmp ( argv[2], "RenderOpaqueGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RenderOpaqueGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkViewport" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RenderOpaqueGeometry */
    Tcl_DStringAppendElement ( &dString, " Methods supporting the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int RenderOpaqueGeometry(vtkViewport *);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for RenderOpaqueGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RenderTranslucentPolygonalGeometry */
    if ( strcmp ( argv[2], "RenderTranslucentPolygonalGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RenderTranslucentPolygonalGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkViewport" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RenderTranslucentPolygonalGeometry */
    Tcl_DStringAppendElement ( &dString, " Methods supporting the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int RenderTranslucentPolygonalGeometry(vtkViewport *);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for RenderTranslucentPolygonalGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: HasTranslucentPolygonalGeometry */
    if ( strcmp ( argv[2], "HasTranslucentPolygonalGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "HasTranslucentPolygonalGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for HasTranslucentPolygonalGeometry */
    Tcl_DStringAppendElement ( &dString, " Methods supporting the rendering process.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int HasTranslucentPolygonalGeometry();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for HasTranslucentPolygonalGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetBumpDistance */
    if ( strcmp ( argv[2], "SetBumpDistance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetBumpDistance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetBumpDistance */
    Tcl_DStringAppendElement ( &dString, " Specify a translation distance used by the BumpCylinder() method. Note that the\n distance is normalized; it is the fraction of the length of the bounding\n box of the wire outline.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetBumpDistance(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetBumpDistance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetBumpDistanceMinValue */
    if ( strcmp ( argv[2], "GetBumpDistanceMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBumpDistanceMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBumpDistanceMinValue */
    Tcl_DStringAppendElement ( &dString, " Specify a translation distance used by the BumpCylinder() method. Note that the\n distance is normalized; it is the fraction of the length of the bounding\n box of the wire outline.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetBumpDistanceMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetBumpDistanceMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetBumpDistanceMaxValue */
    if ( strcmp ( argv[2], "GetBumpDistanceMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBumpDistanceMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBumpDistanceMaxValue */
    Tcl_DStringAppendElement ( &dString, " Specify a translation distance used by the BumpCylinder() method. Note that the\n distance is normalized; it is the fraction of the length of the bounding\n box of the wire outline.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetBumpDistanceMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetBumpDistanceMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetBumpDistance */
    if ( strcmp ( argv[2], "GetBumpDistance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBumpDistance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBumpDistance */
    Tcl_DStringAppendElement ( &dString, " Specify a translation distance used by the BumpCylinder() method. Note that the\n distance is normalized; it is the fraction of the length of the bounding\n box of the wire outline.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetBumpDistance();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetBumpDistance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: BumpCylinder */
    if ( strcmp ( argv[2], "BumpCylinder" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "BumpCylinder" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for BumpCylinder */
    Tcl_DStringAppendElement ( &dString, " Translate the cylinder in the direction of the view vector by the\n specified BumpDistance. The dir parameter controls which\n direction the pushing occurs, either in the same direction as the\n view vector, or when negative, in the opposite direction.  The factor\n controls what percentage of the bump is used.\n" );
    Tcl_DStringAppendElement ( &dString, "void BumpCylinder(int dir, double factor);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for BumpCylinder */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PushCylinder */
    if ( strcmp ( argv[2], "PushCylinder" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PushCylinder" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PushCylinder */
    Tcl_DStringAppendElement ( &dString, " Push the cylinder the distance specified along the view\n vector. Positive values are in the direction of the view vector;\n negative values are in the opposite direction. The distance value\n is expressed in world coordinates.\n" );
    Tcl_DStringAppendElement ( &dString, "void PushCylinder(double distance);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for PushCylinder */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetInteractionState */
    if ( strcmp ( argv[2], "SetInteractionState" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetInteractionState" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetInteractionState */
    Tcl_DStringAppendElement ( &dString, " The interaction state may be set from a widget (e.g.,\n vtkImplicitCylinderWidget) or other object. This controls how the\n interaction with the widget proceeds. Normally this method is used as\n part of a handshaking process with the widget: First\n ComputeInteractionState() is invoked that returns a state based on\n geometric considerations (i.e., cursor near a widget feature), then\n based on events, the widget may modify this further.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetInteractionState(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetInteractionState */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetInteractionStateMinValue */
    if ( strcmp ( argv[2], "GetInteractionStateMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetInteractionStateMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetInteractionStateMinValue */
    Tcl_DStringAppendElement ( &dString, " The interaction state may be set from a widget (e.g.,\n vtkImplicitCylinderWidget) or other object. This controls how the\n interaction with the widget proceeds. Normally this method is used as\n part of a handshaking process with the widget: First\n ComputeInteractionState() is invoked that returns a state based on\n geometric considerations (i.e., cursor near a widget feature), then\n based on events, the widget may modify this further.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetInteractionStateMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetInteractionStateMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetInteractionStateMaxValue */
    if ( strcmp ( argv[2], "GetInteractionStateMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetInteractionStateMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetInteractionStateMaxValue */
    Tcl_DStringAppendElement ( &dString, " The interaction state may be set from a widget (e.g.,\n vtkImplicitCylinderWidget) or other object. This controls how the\n interaction with the widget proceeds. Normally this method is used as\n part of a handshaking process with the widget: First\n ComputeInteractionState() is invoked that returns a state based on\n geometric considerations (i.e., cursor near a widget feature), then\n based on events, the widget may modify this further.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetInteractionStateMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetInteractionStateMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRepresentationState */
    if ( strcmp ( argv[2], "SetRepresentationState" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRepresentationState" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRepresentationState */
    Tcl_DStringAppendElement ( &dString, " Sets the visual appearance of the representation based on the\n state it is in. This state is usually the same as InteractionState.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetRepresentationState(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for SetRepresentationState */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRepresentationState */
    if ( strcmp ( argv[2], "GetRepresentationState" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRepresentationState" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRepresentationState */
    Tcl_DStringAppendElement ( &dString, " Sets the visual appearance of the representation based on the\n state it is in. This state is usually the same as InteractionState.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetRepresentationState();" );
    Tcl_DStringAppendElement ( &dString, "vtkImplicitCylinderRepresentation" );
    /* Closing for GetRepresentationState */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkWidgetRepresentationCppCommand(static_cast<vtkWidgetRepresentation *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
