#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkAbstractContextBufferId_TclCreate(Tcl_Interp *interp);
int vtkAbstractContextItem_TclCreate(Tcl_Interp *interp);
int vtkBlockItem_TclCreate(Tcl_Interp *interp);
int vtkBrush_TclCreate(Tcl_Interp *interp);
int vtkContext2D_TclCreate(Tcl_Interp *interp);
int vtkContextActor_TclCreate(Tcl_Interp *interp);
int vtkContextClip_TclCreate(Tcl_Interp *interp);
int vtkContextItem_TclCreate(Tcl_Interp *interp);
int vtkContextMapper2D_TclCreate(Tcl_Interp *interp);
int vtkContextScene_TclCreate(Tcl_Interp *interp);
int vtkContextTransform_TclCreate(Tcl_Interp *interp);
int vtkImageItem_TclCreate(Tcl_Interp *interp);
int vtkMarkerUtilities_TclCreate(Tcl_Interp *interp);
int vtkPen_TclCreate(Tcl_Interp *interp);
int vtkPropItem_TclCreate(Tcl_Interp *interp);
int vtkTooltipItem_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkrenderingcontextiidtcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkrenderingcontextiidtcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkrenderingcontextiidtcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkrenderingcontextiidtcl_Init(interp);
}


int VTK_EXPORT Vtkrenderingcontextiidtcl_Init(Tcl_Interp *interp)
{

  vtkAbstractContextBufferId_TclCreate(interp);
  vtkAbstractContextItem_TclCreate(interp);
  vtkBlockItem_TclCreate(interp);
  vtkBrush_TclCreate(interp);
  vtkContext2D_TclCreate(interp);
  vtkContextActor_TclCreate(interp);
  vtkContextClip_TclCreate(interp);
  vtkContextItem_TclCreate(interp);
  vtkContextMapper2D_TclCreate(interp);
  vtkContextScene_TclCreate(interp);
  vtkContextTransform_TclCreate(interp);
  vtkImageItem_TclCreate(interp);
  vtkMarkerUtilities_TclCreate(interp);
  vtkPen_TclCreate(interp);
  vtkPropItem_TclCreate(interp);
  vtkTooltipItem_TclCreate(interp);
  char pkgName[]="vtkRenderingContextIIDTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
