// tcl wrapper for vtkLabeledContourMapper object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkLabeledContourMapper.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkLabeledContourMapperNewCommand()
{
  vtkLabeledContourMapper *temp = vtkLabeledContourMapper::New();
  return static_cast<ClientData>(temp);
}

int vtkMapperCppCommand(vtkMapper *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkLabeledContourMapperCppCommand(vtkLabeledContourMapper *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkLabeledContourMapperCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkLabeledContourMapperCppCommand(static_cast<vtkLabeledContourMapper *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkLabeledContourMapper_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkLabeledContourMapper"),vtkLabeledContourMapperNewCommand,vtkLabeledContourMapperCommand);
  return 0;
}

int VTKTCL_EXPORT vtkLabeledContourMapperCppCommand(vtkLabeledContourMapper *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkLabeledContourMapper",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkMapperCppCommand(static_cast<vtkMapper *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkMapper"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkLabeledContourMapper  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkLabeledContourMapper");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkLabeledContourMapper  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkLabeledContourMapper");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkLabeledContourMapper  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkLabeledContourMapper");
    return TCL_OK;
  }
  }
  if ((!strcmp("Render",argv[1]))&&(argc == 4))
  {
    vtkRenderer  *temp0;
    vtkActor  *temp1;
    error = 0;

    temp0 = (vtkRenderer *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkRenderer"),interp,error));
    temp1 = (vtkActor *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkActor"),interp,error));
    if (!error)
  {
    op->Render(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetInputData",argv[1]))&&(argc == 3))
  {
    vtkPolyData  *temp0;
    error = 0;

    temp0 = (vtkPolyData *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkPolyData"),interp,error));
    if (!error)
  {
    op->SetInputData(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetInput",argv[1]))&&(argc == 2))
  {
    vtkPolyData  *temp20;
    temp20 = (op)->GetInput();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPolyData");
    return TCL_OK;
  }
  if ((!strcmp("GetBounds",argv[1]))&&(argc == 8))
  {
    double temp0[6];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (!error)
  {
    op->GetBounds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetTextProperty",argv[1]))&&(argc == 3))
  {
    vtkTextProperty  *temp0;
    error = 0;

    temp0 = (vtkTextProperty *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTextProperty"),interp,error));
    if (!error)
  {
    op->SetTextProperty(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetTextProperties",argv[1]))&&(argc == 3))
  {
    vtkTextPropertyCollection  *temp0;
    error = 0;

    temp0 = (vtkTextPropertyCollection *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTextPropertyCollection"),interp,error));
    if (!error)
  {
    op->SetTextProperties(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTextProperties",argv[1]))&&(argc == 2))
  {
    vtkTextPropertyCollection  *temp20;
    temp20 = (op)->GetTextProperties();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTextPropertyCollection");
    return TCL_OK;
  }
  if ((!strcmp("GetTextPropertyMapping",argv[1]))&&(argc == 2))
  {
    vtkDoubleArray  *temp20;
    temp20 = (op)->GetTextPropertyMapping();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDoubleArray");
    return TCL_OK;
  }
  if ((!strcmp("SetTextPropertyMapping",argv[1]))&&(argc == 3))
  {
    vtkDoubleArray  *temp0;
    error = 0;

    temp0 = (vtkDoubleArray *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDoubleArray"),interp,error));
    if (!error)
  {
    op->SetTextPropertyMapping(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetLabelVisibility",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetLabelVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLabelVisibility",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetLabelVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("LabelVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->LabelVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("LabelVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->LabelVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetSkipDistance",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetSkipDistance(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSkipDistance",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSkipDistance();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetPolyDataMapper",argv[1]))&&(argc == 2))
  {
    vtkPolyDataMapper  *temp20;
    temp20 = (op)->GetPolyDataMapper();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPolyDataMapper");
    return TCL_OK;
  }
  if ((!strcmp("ReleaseGraphicsResources",argv[1]))&&(argc == 3))
  {
    vtkWindow  *temp0;
    error = 0;

    temp0 = (vtkWindow *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkWindow"),interp,error));
    if (!error)
  {
    op->ReleaseGraphicsResources(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkLabeledContourMapperCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkMapperCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkLabeledContourMapper:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  Render\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetInputData\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetInput\n",NULL);
    Tcl_AppendResult(interp,"  GetBounds\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  SetTextProperty\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetTextProperties\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTextProperties\n",NULL);
    Tcl_AppendResult(interp,"  GetTextPropertyMapping\n",NULL);
    Tcl_AppendResult(interp,"  SetTextPropertyMapping\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetLabelVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLabelVisibility\n",NULL);
    Tcl_AppendResult(interp,"  LabelVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  LabelVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetSkipDistance\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSkipDistance\n",NULL);
    Tcl_AppendResult(interp,"  GetPolyDataMapper\n",NULL);
    Tcl_AppendResult(interp,"  ReleaseGraphicsResources\t with 1 arg\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkMapperCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "Render" );
    Tcl_DStringAppendElement ( &dString, "SetInputData" );
    Tcl_DStringAppendElement ( &dString, "GetInput" );
    Tcl_DStringAppendElement ( &dString, "GetBounds" );
    Tcl_DStringAppendElement ( &dString, "SetTextProperty" );
    Tcl_DStringAppendElement ( &dString, "SetTextProperties" );
    Tcl_DStringAppendElement ( &dString, "GetTextProperties" );
    Tcl_DStringAppendElement ( &dString, "GetTextPropertyMapping" );
    Tcl_DStringAppendElement ( &dString, "SetTextPropertyMapping" );
    Tcl_DStringAppendElement ( &dString, "SetLabelVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetLabelVisibility" );
    Tcl_DStringAppendElement ( &dString, "LabelVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "LabelVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetSkipDistance" );
    Tcl_DStringAppendElement ( &dString, "GetSkipDistance" );
    Tcl_DStringAppendElement ( &dString, "GetPolyDataMapper" );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkMapperCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkLabeledContourMapper *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: Render */
    if ( strcmp ( argv[2], "Render" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "Render" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkRenderer" );
    Tcl_DStringAppendElement ( &dString, "vtkActor" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for Render */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "virtual void Render(vtkRenderer *ren, vtkActor *act);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for Render */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetInputData */
    if ( strcmp ( argv[2], "SetInputData" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetInputData" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkPolyData" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetInputData */
    Tcl_DStringAppendElement ( &dString, " Specify the input data to map.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetInputData(vtkPolyData *in);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for SetInputData */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetInput */
    if ( strcmp ( argv[2], "GetInput" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetInput" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetInput */
    Tcl_DStringAppendElement ( &dString, " Specify the input data to map.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkPolyData *GetInput();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for GetInput */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetBounds */
    if ( strcmp ( argv[2], "GetBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBounds */
    Tcl_DStringAppendElement ( &dString, " Return bounding box (array of six doubles) of data expressed as\n (xmin,xmax, ymin,ymax, zmin,zmax).\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void GetBounds(double bounds\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for GetBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTextProperty */
    if ( strcmp ( argv[2], "SetTextProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTextProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTextProperty */
    Tcl_DStringAppendElement ( &dString, " The text property used to label the lines. Note that both vertical and\n horizontal justifications will be reset to \"Centered\" prior to rendering.\n @note This is a convenience method that clears TextProperties and inserts\n the argument as the only property in the collection.\n @sa SetTextProperties\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetTextProperty(vtkTextProperty *tprop);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for SetTextProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTextProperties */
    if ( strcmp ( argv[2], "SetTextProperties" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTextProperties" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTextPropertyCollection" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTextProperties */
    Tcl_DStringAppendElement ( &dString, " The text properties used to label the lines. Note that both vertical and\n horizontal justifications will be reset to \"Centered\" prior to rendering.\n\n * If the TextPropertyMapping array exists, then it is used to identify which\n * text property to use for each label as follows: If the scalar value of a\n * line is found in the mapping, the index of the value in mapping is used to\n * lookup the text property in the collection. If there are more mapping\n * values than  ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetTextProperties(vtkTextPropertyCollection *coll);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for SetTextProperties */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTextProperties */
    if ( strcmp ( argv[2], "GetTextProperties" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTextProperties" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTextProperties */
    Tcl_DStringAppendElement ( &dString, " The text properties used to label the lines. Note that both vertical and\n horizontal justifications will be reset to \"Centered\" prior to rendering.\n\n * If the TextPropertyMapping array exists, then it is used to identify which\n * text property to use for each label as follows: If the scalar value of a\n * line is found in the mapping, the index of the value in mapping is used to\n * lookup the text property in the collection. If there are more mapping\n * values than  ...\n [Truncated]\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkTextPropertyCollection *GetTextProperties();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for GetTextProperties */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTextPropertyMapping */
    if ( strcmp ( argv[2], "GetTextPropertyMapping" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTextPropertyMapping" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTextPropertyMapping */
    Tcl_DStringAppendElement ( &dString, " Values in this array correspond to vtkTextProperty objects in the\n TextProperties collection. If a contour line's scalar value exists in\n this array, the corresponding text property is used for the label.\n See SetTextProperties for more information.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkDoubleArray *GetTextPropertyMapping();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for GetTextPropertyMapping */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTextPropertyMapping */
    if ( strcmp ( argv[2], "SetTextPropertyMapping" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTextPropertyMapping" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDoubleArray" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTextPropertyMapping */
    Tcl_DStringAppendElement ( &dString, " Values in this array correspond to vtkTextProperty objects in the\n TextProperties collection. If a contour line's scalar value exists in\n this array, the corresponding text property is used for the label.\n See SetTextProperties for more information.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetTextPropertyMapping(vtkDoubleArray *mapping);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for SetTextPropertyMapping */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLabelVisibility */
    if ( strcmp ( argv[2], "SetLabelVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLabelVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLabelVisibility */
    Tcl_DStringAppendElement ( &dString, " If true, labels will be placed and drawn during rendering. Otherwise,\n only the mapper returned by GetPolyDataMapper() will be rendered.\n The default is to draw labels.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLabelVisibility(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for SetLabelVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLabelVisibility */
    if ( strcmp ( argv[2], "GetLabelVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLabelVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLabelVisibility */
    Tcl_DStringAppendElement ( &dString, " If true, labels will be placed and drawn during rendering. Otherwise,\n only the mapper returned by GetPolyDataMapper() will be rendered.\n The default is to draw labels.\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetLabelVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for GetLabelVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: LabelVisibilityOn */
    if ( strcmp ( argv[2], "LabelVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "LabelVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for LabelVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " If true, labels will be placed and drawn during rendering. Otherwise,\n only the mapper returned by GetPolyDataMapper() will be rendered.\n The default is to draw labels.\n" );
    Tcl_DStringAppendElement ( &dString, "void LabelVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for LabelVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: LabelVisibilityOff */
    if ( strcmp ( argv[2], "LabelVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "LabelVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for LabelVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " If true, labels will be placed and drawn during rendering. Otherwise,\n only the mapper returned by GetPolyDataMapper() will be rendered.\n The default is to draw labels.\n" );
    Tcl_DStringAppendElement ( &dString, "void LabelVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for LabelVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSkipDistance */
    if ( strcmp ( argv[2], "SetSkipDistance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSkipDistance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSkipDistance */
    Tcl_DStringAppendElement ( &dString, " Ensure that there are at least SkipDistance pixels between labels. This\n is only enforced on labels along the the same line. The default is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSkipDistance(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for SetSkipDistance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSkipDistance */
    if ( strcmp ( argv[2], "GetSkipDistance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSkipDistance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSkipDistance */
    Tcl_DStringAppendElement ( &dString, " Ensure that there are at least SkipDistance pixels between labels. This\n is only enforced on labels along the the same line. The default is 0.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetSkipDistance();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for GetSkipDistance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolyDataMapper */
    if ( strcmp ( argv[2], "GetPolyDataMapper" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolyDataMapper" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolyDataMapper */
    Tcl_DStringAppendElement ( &dString, " The polydata mapper used to render the contours.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkPolyDataMapper *GetPolyDataMapper();" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for GetPolyDataMapper */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ReleaseGraphicsResources */
    if ( strcmp ( argv[2], "ReleaseGraphicsResources" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkWindow" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReleaseGraphicsResources */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "virtual void ReleaseGraphicsResources(vtkWindow *);" );
    Tcl_DStringAppendElement ( &dString, "vtkLabeledContourMapper" );
    /* Closing for ReleaseGraphicsResources */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkMapperCppCommand(static_cast<vtkMapper *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
