// tcl wrapper for vtkMathTextUtilities object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMathTextUtilities.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkMathTextUtilitiesNewCommand()
{
  vtkMathTextUtilities *temp = vtkMathTextUtilities::New();
  return static_cast<ClientData>(temp);
}

int vtkObjectCppCommand(vtkObject *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkMathTextUtilitiesCppCommand(vtkMathTextUtilities *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkMathTextUtilitiesCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkMathTextUtilitiesCppCommand(static_cast<vtkMathTextUtilities *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkMathTextUtilities_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkMathTextUtilities"),vtkMathTextUtilitiesNewCommand,vtkMathTextUtilitiesCommand);
  return 0;
}

int VTKTCL_EXPORT vtkMathTextUtilitiesCppCommand(vtkMathTextUtilities *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkMathTextUtilities",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkObject"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkMathTextUtilities  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMathTextUtilities");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkMathTextUtilities  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMathTextUtilities");
    return TCL_OK;
  }
  }
  if ((!strcmp("IsAvailable",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->IsAvailable();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkMathTextUtilities  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMathTextUtilities");
    return TCL_OK;
  }
  if ((!strcmp("GetInstance",argv[1]))&&(argc == 2))
  {
    vtkMathTextUtilities  *temp20;
    temp20 = (op)->GetInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkMathTextUtilities");
    return TCL_OK;
  }
  if ((!strcmp("SetInstance",argv[1]))&&(argc == 3))
  {
    vtkMathTextUtilities  *temp0;
    error = 0;

    temp0 = (vtkMathTextUtilities *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkMathTextUtilities"),interp,error));
    if (!error)
  {
    op->SetInstance(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("StringToPath",argv[1]))&&(argc == 6))
  {
    char    *temp0;
    vtkPath  *temp1;
    vtkTextProperty  *temp2;
    int      temp3;
    bool   temp20;
    error = 0;

    temp0 = argv[2];
    temp1 = (vtkPath *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkPath"),interp,error));
    temp2 = (vtkTextProperty *)(vtkTclGetPointerFromObject(argv[4],const_cast<char *>("vtkTextProperty"),interp,error));
    if (Tcl_GetInt(interp,argv[5],&tempi) != TCL_OK) error = 1;
    temp3 = tempi;
    if (!error)
  {
    temp20 = (op)->StringToPath(temp0,temp1,temp2,temp3);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetConstrainedFontSize",argv[1]))&&(argc == 7))
  {
    char    *temp0;
    vtkTextProperty  *temp1;
    int      temp2;
    int      temp3;
    int      temp4;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    temp1 = (vtkTextProperty *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkTextProperty"),interp,error));
    if (Tcl_GetInt(interp,argv[4],&tempi) != TCL_OK) error = 1;
    temp2 = tempi;
    if (Tcl_GetInt(interp,argv[5],&tempi) != TCL_OK) error = 1;
    temp3 = tempi;
    if (Tcl_GetInt(interp,argv[6],&tempi) != TCL_OK) error = 1;
    temp4 = tempi;
    if (!error)
  {
    temp20 = (op)->GetConstrainedFontSize(temp0,temp1,temp2,temp3,temp4);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetScaleToPowerOfTwo",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetScaleToPowerOfTwo();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetScaleToPowerOfTwo",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetScaleToPowerOfTwo(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkMathTextUtilitiesCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkMathTextUtilities:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  IsAvailable\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetInstance\n",NULL);
    Tcl_AppendResult(interp,"  SetInstance\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  StringToPath\t with 4 args\n",NULL);
    Tcl_AppendResult(interp,"  GetConstrainedFontSize\t with 5 args\n",NULL);
    Tcl_AppendResult(interp,"  GetScaleToPowerOfTwo\n",NULL);
    Tcl_AppendResult(interp,"  SetScaleToPowerOfTwo\t with 1 arg\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkObjectCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "IsAvailable" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetInstance" );
    Tcl_DStringAppendElement ( &dString, "SetInstance" );
    Tcl_DStringAppendElement ( &dString, "StringToPath" );
    Tcl_DStringAppendElement ( &dString, "GetConstrainedFontSize" );
    Tcl_DStringAppendElement ( &dString, "GetScaleToPowerOfTwo" );
    Tcl_DStringAppendElement ( &dString, "SetScaleToPowerOfTwo" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkObjectCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsAvailable */
    if ( strcmp ( argv[2], "IsAvailable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsAvailable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsAvailable */
    Tcl_DStringAppendElement ( &dString, " Returns true if mathtext rendering is available.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual bool IsAvailable();" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for IsAvailable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " This is a singleton pattern New. There will be only ONE reference\n to a vtkMathTextUtilities object per process.  Clients that\n call this method must use Delete() on the object so that reference\n counting will work. The single instance will be unreferenced when\n the program exits. You should just use the static GetInstance() method\n anyway to get the singleton.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkMathTextUtilities *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetInstance */
    if ( strcmp ( argv[2], "GetInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetInstance */
    Tcl_DStringAppendElement ( &dString, " Return the singleton instance with no reference counting.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkMathTextUtilities *GetInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for GetInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetInstance */
    if ( strcmp ( argv[2], "SetInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetInstance */
    Tcl_DStringAppendElement ( &dString, " Supply a user defined instance. Call Delete() on the supplied\n instance after setting it to fix the reference count.\n" );
    Tcl_DStringAppendElement ( &dString, "static void SetInstance(vtkMathTextUtilities *instance);" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for SetInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: StringToPath */
    if ( strcmp ( argv[2], "StringToPath" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "StringToPath" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringAppendElement ( &dString, "vtkPath" );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for StringToPath */
    Tcl_DStringAppendElement ( &dString, " Parse the MathText expression in str and fill path with a contour of the\n glyphs.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual bool StringToPath(const char *str, vtkPath *path, vtkTextProperty *tprop, int dpi) = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for StringToPath */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetConstrainedFontSize */
    if ( strcmp ( argv[2], "GetConstrainedFontSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetConstrainedFontSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetConstrainedFontSize */
    Tcl_DStringAppendElement ( &dString, " This function returns the font size (in points) required to fit the string\n in the target rectangle. The font size of tprop is updated to the computed\n value as well. If an error occurs (e.g. an improperly formatted MathText\n string), -1 is returned.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int GetConstrainedFontSize(const char *str, vtkTextProperty *tprop, int targetWidth, int targetHeight, int dpi);" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for GetConstrainedFontSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScaleToPowerOfTwo */
    if ( strcmp ( argv[2], "GetScaleToPowerOfTwo" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScaleToPowerOfTwo" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScaleToPowerOfTwo */
    Tcl_DStringAppendElement ( &dString, " Set to true if the graphics implmentation requires texture image dimensions\n to be a power of two. Default is true, but this member will be set\n appropriately when GL is inited.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual bool GetScaleToPowerOfTwo() = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for GetScaleToPowerOfTwo */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetScaleToPowerOfTwo */
    if ( strcmp ( argv[2], "SetScaleToPowerOfTwo" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetScaleToPowerOfTwo" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetScaleToPowerOfTwo */
    Tcl_DStringAppendElement ( &dString, " Set to true if the graphics implmentation requires texture image dimensions\n to be a power of two. Default is true, but this member will be set\n appropriately when GL is inited.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetScaleToPowerOfTwo(bool scale) = 0;" );
    Tcl_DStringAppendElement ( &dString, "vtkMathTextUtilities" );
    /* Closing for SetScaleToPowerOfTwo */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkObjectCppCommand(static_cast<vtkObject *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
