// tcl wrapper for vtkOpenGLRenderPass object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkOpenGLRenderPass.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>
int vtkRenderPassCppCommand(vtkRenderPass *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkOpenGLRenderPassCppCommand(vtkOpenGLRenderPass *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkOpenGLRenderPassCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkOpenGLRenderPassCppCommand(static_cast<vtkOpenGLRenderPass *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkOpenGLRenderPass_TclCreate(Tcl_Interp *interp)
{
  (void)interp;
  return 0;
}

int VTKTCL_EXPORT vtkOpenGLRenderPassCppCommand(vtkOpenGLRenderPass *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkOpenGLRenderPass",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkRenderPassCppCommand(static_cast<vtkRenderPass *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkRenderPass"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkOpenGLRenderPass  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkOpenGLRenderPass");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkOpenGLRenderPass  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkOpenGLRenderPass");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetShaderParameters",argv[1]))&&(argc == 5))
  {
    vtkShaderProgram  *temp0;
    vtkAbstractMapper  *temp1;
    vtkProp  *temp2;
    bool   temp20;
    error = 0;

    temp0 = (vtkShaderProgram *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkShaderProgram"),interp,error));
    temp1 = (vtkAbstractMapper *)(vtkTclGetPointerFromObject(argv[3],const_cast<char *>("vtkAbstractMapper"),interp,error));
    temp2 = (vtkProp *)(vtkTclGetPointerFromObject(argv[4],const_cast<char *>("vtkProp"),interp,error));
    if (!error)
  {
    temp20 = (op)->SetShaderParameters(temp0,temp1,temp2);
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetShaderStageMTime",argv[1]))&&(argc == 2))
  {
    unsigned long long   temp20;
    temp20 = (op)->GetShaderStageMTime();
    char tempResult[1024];
    sprintf(tempResult,"%llu",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkOpenGLRenderPassCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkRenderPassCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkOpenGLRenderPass:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetShaderParameters\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetShaderStageMTime\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkRenderPassCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetShaderParameters" );
    Tcl_DStringAppendElement ( &dString, "GetShaderStageMTime" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkRenderPassCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkOpenGLRenderPass" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkOpenGLRenderPass" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkOpenGLRenderPass *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkOpenGLRenderPass" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkOpenGLRenderPass *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkOpenGLRenderPass" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetShaderParameters */
    if ( strcmp ( argv[2], "SetShaderParameters" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetShaderParameters" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkShaderProgram" );
    Tcl_DStringAppendElement ( &dString, "vtkAbstractMapper" );
    Tcl_DStringAppendElement ( &dString, "vtkProp" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetShaderParameters */
    Tcl_DStringAppendElement ( &dString, " Update the uniforms of the shader program.\n Return false on error.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual bool SetShaderParameters(vtkShaderProgram *program, vtkAbstractMapper *mapper, vtkProp *prop);" );
    Tcl_DStringAppendElement ( &dString, "vtkOpenGLRenderPass" );
    /* Closing for SetShaderParameters */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetShaderStageMTime */
    if ( strcmp ( argv[2], "GetShaderStageMTime" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetShaderStageMTime" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetShaderStageMTime */
    Tcl_DStringAppendElement ( &dString, " For multi-stage render passes that need to change shader code during a\n single pass, use this method to notify a mapper that the shader needs to be\n rebuilt (rather than reuse the last cached shader. This method should\n return the last time that the shader stage changed, or 0 if the shader\n is single-stage.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual vtkMTimeType GetShaderStageMTime();" );
    Tcl_DStringAppendElement ( &dString, "vtkOpenGLRenderPass" );
    /* Closing for GetShaderStageMTime */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkRenderPassCppCommand(static_cast<vtkRenderPass *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
