#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkCameraPass_TclCreate(Tcl_Interp *interp);
int vtkClearRGBPass_TclCreate(Tcl_Interp *interp);
int vtkClearZPass_TclCreate(Tcl_Interp *interp);
int vtkCompositePolyDataMapper2_TclCreate(Tcl_Interp *interp);
int vtkDefaultPass_TclCreate(Tcl_Interp *interp);
int vtkDepthOfFieldPass_TclCreate(Tcl_Interp *interp);
int vtkDepthImageProcessingPass_TclCreate(Tcl_Interp *interp);
int vtkDepthPeelingPass_TclCreate(Tcl_Interp *interp);
int vtkEDLShading_TclCreate(Tcl_Interp *interp);
int vtkGaussianBlurPass_TclCreate(Tcl_Interp *interp);
int vtkGenericOpenGLRenderWindow_TclCreate(Tcl_Interp *interp);
int vtkHiddenLineRemovalPass_TclCreate(Tcl_Interp *interp);
int vtkImageProcessingPass_TclCreate(Tcl_Interp *interp);
int vtkLightingMapPass_TclCreate(Tcl_Interp *interp);
int vtkLightsPass_TclCreate(Tcl_Interp *interp);
int vtkOpaquePass_TclCreate(Tcl_Interp *interp);
int vtkOpenGLActor_TclCreate(Tcl_Interp *interp);
int vtkOpenGLBillboardTextActor3D_TclCreate(Tcl_Interp *interp);
int vtkOpenGLCamera_TclCreate(Tcl_Interp *interp);
int vtkOpenGLFXAAFilter_TclCreate(Tcl_Interp *interp);
int vtkOpenGLHardwareSelector_TclCreate(Tcl_Interp *interp);
int vtkOpenGLImageAlgorithmHelper_TclCreate(Tcl_Interp *interp);
int vtkOpenGLImageMapper_TclCreate(Tcl_Interp *interp);
int vtkOpenGLImageSliceMapper_TclCreate(Tcl_Interp *interp);
int vtkOpenGLLabeledContourMapper_TclCreate(Tcl_Interp *interp);
int vtkOpenGLLight_TclCreate(Tcl_Interp *interp);
int vtkOpenGLPointGaussianMapper_TclCreate(Tcl_Interp *interp);
int vtkOpenGLPolyDataMapper_TclCreate(Tcl_Interp *interp);
int vtkOpenGLPolyDataMapper2D_TclCreate(Tcl_Interp *interp);
int vtkOpenGLProperty_TclCreate(Tcl_Interp *interp);
int vtkOpenGLRenderPass_TclCreate(Tcl_Interp *interp);
int vtkOpenGLRenderUtilities_TclCreate(Tcl_Interp *interp);
int vtkOpenGLRenderWindow_TclCreate(Tcl_Interp *interp);
int vtkOpenGLRenderer_TclCreate(Tcl_Interp *interp);
int vtkOpenGLSphereMapper_TclCreate(Tcl_Interp *interp);
int vtkOpenGLStickMapper_TclCreate(Tcl_Interp *interp);
int vtkOpenGLTextActor_TclCreate(Tcl_Interp *interp);
int vtkOpenGLTextActor3D_TclCreate(Tcl_Interp *interp);
int vtkOpenGLTextMapper_TclCreate(Tcl_Interp *interp);
int vtkOpenGLTexture_TclCreate(Tcl_Interp *interp);
int vtkOverlayPass_TclCreate(Tcl_Interp *interp);
int vtkPointFillPass_TclCreate(Tcl_Interp *interp);
int vtkRenderPassCollection_TclCreate(Tcl_Interp *interp);
int vtkRenderStepsPass_TclCreate(Tcl_Interp *interp);
int vtkSSAAPass_TclCreate(Tcl_Interp *interp);
int vtkSequencePass_TclCreate(Tcl_Interp *interp);
int vtkShader_TclCreate(Tcl_Interp *interp);
int vtkShaderProgram_TclCreate(Tcl_Interp *interp);
int vtkShadowMapBakerPass_TclCreate(Tcl_Interp *interp);
int vtkShadowMapPass_TclCreate(Tcl_Interp *interp);
int vtkSobelGradientMagnitudePass_TclCreate(Tcl_Interp *interp);
int vtkTranslucentPass_TclCreate(Tcl_Interp *interp);
int vtkVolumetricPass_TclCreate(Tcl_Interp *interp);
int vtkDataTransferHelper_TclCreate(Tcl_Interp *interp);
int vtkDualDepthPeelingPass_TclCreate(Tcl_Interp *interp);
int vtkFrameBufferObject2_TclCreate(Tcl_Interp *interp);
int vtkValuePass_TclCreate(Tcl_Interp *interp);
int vtkDummyGPUInfoList_TclCreate(Tcl_Interp *interp);
int vtkXRenderWindowInteractor_TclCreate(Tcl_Interp *interp);
int vtkXOpenGLRenderWindow_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkrenderingopengliitcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkrenderingopengliitcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkrenderingopengliitcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkrenderingopengliitcl_Init(interp);
}


int VTK_EXPORT Vtkrenderingopengliitcl_Init(Tcl_Interp *interp)
{

  vtkCameraPass_TclCreate(interp);
  vtkClearRGBPass_TclCreate(interp);
  vtkClearZPass_TclCreate(interp);
  vtkCompositePolyDataMapper2_TclCreate(interp);
  vtkDefaultPass_TclCreate(interp);
  vtkDepthOfFieldPass_TclCreate(interp);
  vtkDepthImageProcessingPass_TclCreate(interp);
  vtkDepthPeelingPass_TclCreate(interp);
  vtkEDLShading_TclCreate(interp);
  vtkGaussianBlurPass_TclCreate(interp);
  vtkGenericOpenGLRenderWindow_TclCreate(interp);
  vtkHiddenLineRemovalPass_TclCreate(interp);
  vtkImageProcessingPass_TclCreate(interp);
  vtkLightingMapPass_TclCreate(interp);
  vtkLightsPass_TclCreate(interp);
  vtkOpaquePass_TclCreate(interp);
  vtkOpenGLActor_TclCreate(interp);
  vtkOpenGLBillboardTextActor3D_TclCreate(interp);
  vtkOpenGLCamera_TclCreate(interp);
  vtkOpenGLFXAAFilter_TclCreate(interp);
  vtkOpenGLHardwareSelector_TclCreate(interp);
  vtkOpenGLImageAlgorithmHelper_TclCreate(interp);
  vtkOpenGLImageMapper_TclCreate(interp);
  vtkOpenGLImageSliceMapper_TclCreate(interp);
  vtkOpenGLLabeledContourMapper_TclCreate(interp);
  vtkOpenGLLight_TclCreate(interp);
  vtkOpenGLPointGaussianMapper_TclCreate(interp);
  vtkOpenGLPolyDataMapper_TclCreate(interp);
  vtkOpenGLPolyDataMapper2D_TclCreate(interp);
  vtkOpenGLProperty_TclCreate(interp);
  vtkOpenGLRenderPass_TclCreate(interp);
  vtkOpenGLRenderUtilities_TclCreate(interp);
  vtkOpenGLRenderWindow_TclCreate(interp);
  vtkOpenGLRenderer_TclCreate(interp);
  vtkOpenGLSphereMapper_TclCreate(interp);
  vtkOpenGLStickMapper_TclCreate(interp);
  vtkOpenGLTextActor_TclCreate(interp);
  vtkOpenGLTextActor3D_TclCreate(interp);
  vtkOpenGLTextMapper_TclCreate(interp);
  vtkOpenGLTexture_TclCreate(interp);
  vtkOverlayPass_TclCreate(interp);
  vtkPointFillPass_TclCreate(interp);
  vtkRenderPassCollection_TclCreate(interp);
  vtkRenderStepsPass_TclCreate(interp);
  vtkSSAAPass_TclCreate(interp);
  vtkSequencePass_TclCreate(interp);
  vtkShader_TclCreate(interp);
  vtkShaderProgram_TclCreate(interp);
  vtkShadowMapBakerPass_TclCreate(interp);
  vtkShadowMapPass_TclCreate(interp);
  vtkSobelGradientMagnitudePass_TclCreate(interp);
  vtkTranslucentPass_TclCreate(interp);
  vtkVolumetricPass_TclCreate(interp);
  vtkDataTransferHelper_TclCreate(interp);
  vtkDualDepthPeelingPass_TclCreate(interp);
  vtkFrameBufferObject2_TclCreate(interp);
  vtkValuePass_TclCreate(interp);
  vtkDummyGPUInfoList_TclCreate(interp);
  vtkXRenderWindowInteractor_TclCreate(interp);
  vtkXOpenGLRenderWindow_TclCreate(interp);
  char pkgName[]="vtkRenderingOpenGLIITCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
