// tcl wrapper for vtkTreeHeatmapItem object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTreeHeatmapItem.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkTreeHeatmapItemNewCommand()
{
  vtkTreeHeatmapItem *temp = vtkTreeHeatmapItem::New();
  return static_cast<ClientData>(temp);
}

int vtkContextItemCppCommand(vtkContextItem *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkTreeHeatmapItemCppCommand(vtkTreeHeatmapItem *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkTreeHeatmapItemCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkTreeHeatmapItemCppCommand(static_cast<vtkTreeHeatmapItem *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkTreeHeatmapItem_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkTreeHeatmapItem"),vtkTreeHeatmapItemNewCommand,vtkTreeHeatmapItemCommand);
  return 0;
}

int VTKTCL_EXPORT vtkTreeHeatmapItemCppCommand(vtkTreeHeatmapItem *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkTreeHeatmapItem",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkContextItemCppCommand(static_cast<vtkContextItem *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkContextItem"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkTreeHeatmapItem  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTreeHeatmapItem");
    return TCL_OK;
  }
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkTreeHeatmapItem  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTreeHeatmapItem");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkTreeHeatmapItem  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTreeHeatmapItem");
    return TCL_OK;
  }
  }
  if ((!strcmp("SetTree",argv[1]))&&(argc == 3))
  {
    vtkTree  *temp0;
    error = 0;

    temp0 = (vtkTree *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTree"),interp,error));
    if (!error)
  {
    op->SetTree(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTree",argv[1]))&&(argc == 2))
  {
    vtkTree  *temp20;
    temp20 = (op)->GetTree();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTree");
    return TCL_OK;
  }
  if ((!strcmp("SetColumnTree",argv[1]))&&(argc == 3))
  {
    vtkTree  *temp0;
    error = 0;

    temp0 = (vtkTree *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTree"),interp,error));
    if (!error)
  {
    op->SetColumnTree(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetColumnTree",argv[1]))&&(argc == 2))
  {
    vtkTree  *temp20;
    temp20 = (op)->GetColumnTree();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTree");
    return TCL_OK;
  }
  if ((!strcmp("SetTable",argv[1]))&&(argc == 3))
  {
    vtkTable  *temp0;
    error = 0;

    temp0 = (vtkTable *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTable"),interp,error));
    if (!error)
  {
    op->SetTable(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTable",argv[1]))&&(argc == 2))
  {
    vtkTable  *temp20;
    temp20 = (op)->GetTable();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTable");
    return TCL_OK;
  }
  if ((!strcmp("GetDendrogram",argv[1]))&&(argc == 2))
  {
    vtkDendrogramItem  *temp20;
    temp20 = (op)->GetDendrogram();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkDendrogramItem");
    return TCL_OK;
  }
  if ((!strcmp("SetDendrogram",argv[1]))&&(argc == 3))
  {
    vtkDendrogramItem  *temp0;
    error = 0;

    temp0 = (vtkDendrogramItem *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkDendrogramItem"),interp,error));
    if (!error)
  {
    op->SetDendrogram(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetHeatmap",argv[1]))&&(argc == 2))
  {
    vtkHeatmapItem  *temp20;
    temp20 = (op)->GetHeatmap();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkHeatmapItem");
    return TCL_OK;
  }
  if ((!strcmp("SetHeatmap",argv[1]))&&(argc == 3))
  {
    vtkHeatmapItem  *temp0;
    error = 0;

    temp0 = (vtkHeatmapItem *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkHeatmapItem"),interp,error));
    if (!error)
  {
    op->SetHeatmap(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("ReorderTable",argv[1]))&&(argc == 2))
  {
    op->ReorderTable();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ReverseTableRows",argv[1]))&&(argc == 2))
  {
    op->ReverseTableRows();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ReverseTableColumns",argv[1]))&&(argc == 2))
  {
    op->ReverseTableColumns();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetOrientation",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetOrientation(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetOrientation",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetOrientation();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetBounds",argv[1]))&&(argc == 6))
  {
    double temp0[4];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (!error)
  {
    op->GetBounds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCenter",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->GetCenter(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSize",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->GetSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("CollapseToNumberOfLeafNodes",argv[1]))&&(argc == 3))
  {
    unsigned int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = static_cast<unsigned int>(tempi);
    if (!error)
  {
    op->CollapseToNumberOfLeafNodes(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTreeLineWidth",argv[1]))&&(argc == 2))
  {
    float    temp20;
    temp20 = (op)->GetTreeLineWidth();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetTreeLineWidth",argv[1]))&&(argc == 3))
  {
    float    temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetTreeLineWidth(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPrunedTree",argv[1]))&&(argc == 2))
  {
    vtkTree  *temp20;
    temp20 = (op)->GetPrunedTree();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTree");
    return TCL_OK;
  }
  if ((!strcmp("SetTreeColorArray",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetTreeColorArray(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkTreeHeatmapItemCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkContextItemCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkTreeHeatmapItem:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetTree\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTree\n",NULL);
    Tcl_AppendResult(interp,"  SetColumnTree\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetColumnTree\n",NULL);
    Tcl_AppendResult(interp,"  SetTable\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTable\n",NULL);
    Tcl_AppendResult(interp,"  GetDendrogram\n",NULL);
    Tcl_AppendResult(interp,"  SetDendrogram\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetHeatmap\n",NULL);
    Tcl_AppendResult(interp,"  SetHeatmap\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  ReorderTable\n",NULL);
    Tcl_AppendResult(interp,"  ReverseTableRows\n",NULL);
    Tcl_AppendResult(interp,"  ReverseTableColumns\n",NULL);
    Tcl_AppendResult(interp,"  SetOrientation\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetOrientation\n",NULL);
    Tcl_AppendResult(interp,"  GetBounds\t with 4 args\n",NULL);
    Tcl_AppendResult(interp,"  GetCenter\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetSize\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  CollapseToNumberOfLeafNodes\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTreeLineWidth\n",NULL);
    Tcl_AppendResult(interp,"  SetTreeLineWidth\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPrunedTree\n",NULL);
    Tcl_AppendResult(interp,"  SetTreeColorArray\t with 1 arg\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkContextItemCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "SetTree" );
    Tcl_DStringAppendElement ( &dString, "GetTree" );
    Tcl_DStringAppendElement ( &dString, "SetColumnTree" );
    Tcl_DStringAppendElement ( &dString, "GetColumnTree" );
    Tcl_DStringAppendElement ( &dString, "SetTable" );
    Tcl_DStringAppendElement ( &dString, "GetTable" );
    Tcl_DStringAppendElement ( &dString, "GetDendrogram" );
    Tcl_DStringAppendElement ( &dString, "SetDendrogram" );
    Tcl_DStringAppendElement ( &dString, "GetHeatmap" );
    Tcl_DStringAppendElement ( &dString, "SetHeatmap" );
    Tcl_DStringAppendElement ( &dString, "ReorderTable" );
    Tcl_DStringAppendElement ( &dString, "ReverseTableRows" );
    Tcl_DStringAppendElement ( &dString, "ReverseTableColumns" );
    Tcl_DStringAppendElement ( &dString, "SetOrientation" );
    Tcl_DStringAppendElement ( &dString, "GetOrientation" );
    Tcl_DStringAppendElement ( &dString, "GetBounds" );
    Tcl_DStringAppendElement ( &dString, "GetCenter" );
    Tcl_DStringAppendElement ( &dString, "GetSize" );
    Tcl_DStringAppendElement ( &dString, "CollapseToNumberOfLeafNodes" );
    Tcl_DStringAppendElement ( &dString, "GetTreeLineWidth" );
    Tcl_DStringAppendElement ( &dString, "SetTreeLineWidth" );
    Tcl_DStringAppendElement ( &dString, "GetPrunedTree" );
    Tcl_DStringAppendElement ( &dString, "SetTreeColorArray" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkContextItemCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "static vtkTreeHeatmapItem *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTree */
    if ( strcmp ( argv[2], "SetTree" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTree" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTree" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTree */
    Tcl_DStringAppendElement ( &dString, " Set the tree that this item draws.  Note that this tree's vertex data\n must contain a vtkStringArray called \"node name\".  Additionally, this\n array must contain the same values as the first column of the input\n table.  See SetTable for more information.  The vtkNewickTreeReader\n automatically creates this required array for you.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetTree(vtkTree *tree);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for SetTree */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTree */
    if ( strcmp ( argv[2], "GetTree" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTree" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTree */
    Tcl_DStringAppendElement ( &dString, " Get the tree that this item draws.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTree *GetTree();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetTree */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetColumnTree */
    if ( strcmp ( argv[2], "SetColumnTree" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetColumnTree" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTree" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetColumnTree */
    Tcl_DStringAppendElement ( &dString, " Set a tree to be drawn for the columns of the heatmap.  This tree's\n vertex data must contain a vtkStringArray called \"node name\" that\n corresponds to the names of the columns in the heatmap.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetColumnTree(vtkTree *tree);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for SetColumnTree */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetColumnTree */
    if ( strcmp ( argv[2], "GetColumnTree" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetColumnTree" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetColumnTree */
    Tcl_DStringAppendElement ( &dString, " Get the tree that represents the columns of the heatmap (if one has\n been set).\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTree *GetColumnTree();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetColumnTree */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTable */
    if ( strcmp ( argv[2], "SetTable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTable" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTable */
    Tcl_DStringAppendElement ( &dString, " Set the table that this item draws.  The first column of the table\n must contain the names of the rows.  These names, in turn, must correspond\n with the nodes names in the input tree.  See SetTree for more information.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetTable(vtkTable *table);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for SetTable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTable */
    if ( strcmp ( argv[2], "GetTable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTable */
    Tcl_DStringAppendElement ( &dString, " Get the table that this item draws.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTable *GetTable();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetTable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDendrogram */
    if ( strcmp ( argv[2], "GetDendrogram" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDendrogram" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDendrogram */
    Tcl_DStringAppendElement ( &dString, " Get/Set the dendrogram contained by this item.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkDendrogramItem *GetDendrogram();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetDendrogram */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDendrogram */
    if ( strcmp ( argv[2], "SetDendrogram" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDendrogram" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkDendrogramItem" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDendrogram */
    Tcl_DStringAppendElement ( &dString, " Get/Set the dendrogram contained by this item.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDendrogram(vtkDendrogramItem *dendrogram);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for SetDendrogram */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetHeatmap */
    if ( strcmp ( argv[2], "GetHeatmap" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetHeatmap" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetHeatmap */
    Tcl_DStringAppendElement ( &dString, " Get/Set the heatmap contained by this item.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkHeatmapItem *GetHeatmap();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetHeatmap */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetHeatmap */
    if ( strcmp ( argv[2], "SetHeatmap" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetHeatmap" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkHeatmapItem" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetHeatmap */
    Tcl_DStringAppendElement ( &dString, " Get/Set the heatmap contained by this item.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetHeatmap(vtkHeatmapItem *heatmap);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for SetHeatmap */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ReorderTable */
    if ( strcmp ( argv[2], "ReorderTable" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReorderTable" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReorderTable */
    Tcl_DStringAppendElement ( &dString, " Reorder the rows in the table so they match the order of the leaf\n nodes in our tree.\n" );
    Tcl_DStringAppendElement ( &dString, "void ReorderTable();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for ReorderTable */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ReverseTableRows */
    if ( strcmp ( argv[2], "ReverseTableRows" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReverseTableRows" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReverseTableRows */
    Tcl_DStringAppendElement ( &dString, " Reverse the order of the rows in our input table.  This is used\n to simplify the table layout for DOWN_TO_UP and RIGHT_TO_LEFT\n orientations.\n" );
    Tcl_DStringAppendElement ( &dString, "void ReverseTableRows();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for ReverseTableRows */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ReverseTableColumns */
    if ( strcmp ( argv[2], "ReverseTableColumns" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReverseTableColumns" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReverseTableColumns */
    Tcl_DStringAppendElement ( &dString, " Reverse the order of the rows in our input table.  This is used\n to simplify the table layout for DOWN_TO_UP and UP_TO_DOWN\n orientations.\n" );
    Tcl_DStringAppendElement ( &dString, "void ReverseTableColumns();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for ReverseTableColumns */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetOrientation */
    if ( strcmp ( argv[2], "SetOrientation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetOrientation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetOrientation */
    Tcl_DStringAppendElement ( &dString, " Set which way the tree / heatmap should face within the visualization.\n The default is for both components to be drawn left to right.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetOrientation(int orientation);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for SetOrientation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetOrientation */
    if ( strcmp ( argv[2], "GetOrientation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetOrientation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetOrientation */
    Tcl_DStringAppendElement ( &dString, " Get the current orientation.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetOrientation();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetOrientation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetBounds */
    if ( strcmp ( argv[2], "GetBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBounds */
    Tcl_DStringAppendElement ( &dString, " Get the bounds of this item (xMin, xMax, yMin, Max) in pixel coordinates.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetBounds(double bounds\\[4\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCenter */
    if ( strcmp ( argv[2], "GetCenter" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCenter" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCenter */
    Tcl_DStringAppendElement ( &dString, " Get the center point of this item in pixel coordinates.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetCenter(double center\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetCenter */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSize */
    if ( strcmp ( argv[2], "GetSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSize */
    Tcl_DStringAppendElement ( &dString, " Get the size of this item in pixel coordinates.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetSize(double size\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: CollapseToNumberOfLeafNodes */
    if ( strcmp ( argv[2], "CollapseToNumberOfLeafNodes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "CollapseToNumberOfLeafNodes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for CollapseToNumberOfLeafNodes */
    Tcl_DStringAppendElement ( &dString, " Collapse subtrees until there are only n leaf nodes left in the tree.\n The leaf nodes that remain are those that are closest to the root.\n Any subtrees that were collapsed prior to this function being called\n may be re-expanded.  Use this function instead of\n this->GetDendrogram->CollapseToNumberOfLeafNodes(), as this function\n also handles the hiding of heatmap rows that correspond to newly\n collapsed subtrees.\n" );
    Tcl_DStringAppendElement ( &dString, "void CollapseToNumberOfLeafNodes(unsigned int n);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for CollapseToNumberOfLeafNodes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTreeLineWidth */
    if ( strcmp ( argv[2], "GetTreeLineWidth" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTreeLineWidth" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTreeLineWidth */
    Tcl_DStringAppendElement ( &dString, " Get/Set how wide the edges of the trees should be.  Default is one pixel.\n" );
    Tcl_DStringAppendElement ( &dString, "float GetTreeLineWidth();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetTreeLineWidth */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTreeLineWidth */
    if ( strcmp ( argv[2], "SetTreeLineWidth" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTreeLineWidth" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTreeLineWidth */
    Tcl_DStringAppendElement ( &dString, " Get/Set how wide the edges of the trees should be.  Default is one pixel.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTreeLineWidth(float width);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for SetTreeLineWidth */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPrunedTree */
    if ( strcmp ( argv[2], "GetPrunedTree" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPrunedTree" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPrunedTree */
    Tcl_DStringAppendElement ( &dString, " Deprecated.  Use this->GetDendrogram()->GetPrunedTree() instead.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTree *GetPrunedTree();" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for GetPrunedTree */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTreeColorArray */
    if ( strcmp ( argv[2], "SetTreeColorArray" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTreeColorArray" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTreeColorArray */
    Tcl_DStringAppendElement ( &dString, " Deprecated.  Use this->GetDendrogram()->SetColorArray(const char *arrayName)\n instead.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTreeColorArray(const char *arrayName);" );
    Tcl_DStringAppendElement ( &dString, "vtkTreeHeatmapItem" );
    /* Closing for SetTreeColorArray */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkContextItemCppCommand(static_cast<vtkContextItem *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
