// python wrapper for vtkAMRDataSetCache
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkAMRDataSetCache.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAMRDataSetCache(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAMRDataSetCache_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkAMRDataSetCache_Doc();


static PyObject *
PyvtkAMRDataSetCache_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkAMRDataSetCache::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAMRDataSetCache::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkAMRDataSetCache *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAMRDataSetCache::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkAMRDataSetCache *tempr = vtkAMRDataSetCache::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_InsertAMRBlock(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InsertAMRBlock");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  int temp0;
  vtkUniformGrid *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkUniformGrid"))
  {
    if (ap.IsBound())
    {
      op->InsertAMRBlock(temp0, temp1);
    }
    else
    {
      op->vtkAMRDataSetCache::InsertAMRBlock(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_InsertAMRBlockPointData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InsertAMRBlockPointData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  int temp0;
  vtkDataArray *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkDataArray"))
  {
    if (ap.IsBound())
    {
      op->InsertAMRBlockPointData(temp0, temp1);
    }
    else
    {
      op->vtkAMRDataSetCache::InsertAMRBlockPointData(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_InsertAMRBlockCellData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InsertAMRBlockCellData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  int temp0;
  vtkDataArray *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkDataArray"))
  {
    if (ap.IsBound())
    {
      op->InsertAMRBlockCellData(temp0, temp1);
    }
    else
    {
      op->vtkAMRDataSetCache::InsertAMRBlockCellData(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_GetAMRBlockCellData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAMRBlockCellData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->GetAMRBlockCellData(temp0, temp1) :
      op->vtkAMRDataSetCache::GetAMRBlockCellData(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_GetAMRBlockPointData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAMRBlockPointData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->GetAMRBlockPointData(temp0, temp1) :
      op->vtkAMRDataSetCache::GetAMRBlockPointData(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_GetAMRBlock(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAMRBlock");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkUniformGrid *tempr = (ap.IsBound() ?
      op->GetAMRBlock(temp0) :
      op->vtkAMRDataSetCache::GetAMRBlock(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_HasAMRBlockCellData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasAMRBlockCellData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->HasAMRBlockCellData(temp0, temp1) :
      op->vtkAMRDataSetCache::HasAMRBlockCellData(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_HasAMRBlockPointData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasAMRBlockPointData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->HasAMRBlockPointData(temp0, temp1) :
      op->vtkAMRDataSetCache::HasAMRBlockPointData(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRDataSetCache_HasAMRBlock(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasAMRBlock");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRDataSetCache *op = static_cast<vtkAMRDataSetCache *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasAMRBlock(temp0) :
      op->vtkAMRDataSetCache::HasAMRBlock(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkAMRDataSetCache_Methods[] = {
  {"GetClassName", PyvtkAMRDataSetCache_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkAMRDataSetCache_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkAMRDataSetCache_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAMRDataSetCache\nC++: vtkAMRDataSetCache *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkAMRDataSetCache_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkAMRDataSetCache\nC++: vtkAMRDataSetCache *SafeDownCast(vtkObject* o)\n\n"},
  {"InsertAMRBlock", PyvtkAMRDataSetCache_InsertAMRBlock, METH_VARARGS,
   "V.InsertAMRBlock(int, vtkUniformGrid)\nC++: void InsertAMRBlock(int compositeIdx,\n    vtkUniformGrid *amrGrid)\n\nInserts an AMR block to the cache\n"},
  {"InsertAMRBlockPointData", PyvtkAMRDataSetCache_InsertAMRBlockPointData, METH_VARARGS,
   "V.InsertAMRBlockPointData(int, vtkDataArray)\nC++: void InsertAMRBlockPointData(int compositeIdx,\n    vtkDataArray *dataArray)\n\nInserts a point data array to an already cached block NOTE:\nthis->HasAMRBlock( compositeIdx ) == true\n"},
  {"InsertAMRBlockCellData", PyvtkAMRDataSetCache_InsertAMRBlockCellData, METH_VARARGS,
   "V.InsertAMRBlockCellData(int, vtkDataArray)\nC++: void InsertAMRBlockCellData(int compositeIdx,\n    vtkDataArray *dataArray)\n\nInserts a cell data array to an already cached block NOTE:\nthis->HasAMRBlock( compositeIdx ) == true\n"},
  {"GetAMRBlockCellData", PyvtkAMRDataSetCache_GetAMRBlockCellData, METH_VARARGS,
   "V.GetAMRBlockCellData(int, string) -> vtkDataArray\nC++: vtkDataArray *GetAMRBlockCellData(int compositeIdx,\n    const char *dataName)\n\nGiven the name of the cell array and AMR block composite index,\nthis method returns a pointer to the cell data array. NOTE: Null\nis returned if the cell array and/or block is not cached.\n"},
  {"GetAMRBlockPointData", PyvtkAMRDataSetCache_GetAMRBlockPointData, METH_VARARGS,
   "V.GetAMRBlockPointData(int, string) -> vtkDataArray\nC++: vtkDataArray *GetAMRBlockPointData(int compositeIdx,\n    const char *dataName)\n\nGiven the name of the point array and AMR block composite index,\nthis method returns a pointer to the point data array. NOTE: Null\nis returend if the point array and /or block is not cached.\n"},
  {"GetAMRBlock", PyvtkAMRDataSetCache_GetAMRBlock, METH_VARARGS,
   "V.GetAMRBlock(int) -> vtkUniformGrid\nC++: vtkUniformGrid *GetAMRBlock(int compositeIdx)\n\nGiven the composite index, this method returns the AMR block.\nNOTE: Null is returned if the AMR block does not exist in the\ncache.\n"},
  {"HasAMRBlockCellData", PyvtkAMRDataSetCache_HasAMRBlockCellData, METH_VARARGS,
   "V.HasAMRBlockCellData(int, string) -> bool\nC++: bool HasAMRBlockCellData(int compositeIdx, const char *name)\n\nChecks if the cell data array, associated with the provided name,\nhas been cached for the AMR block with the given composite index.\n"},
  {"HasAMRBlockPointData", PyvtkAMRDataSetCache_HasAMRBlockPointData, METH_VARARGS,
   "V.HasAMRBlockPointData(int, string) -> bool\nC++: bool HasAMRBlockPointData(int compositeIdx, const char *name)\n\nChecks if the point data array, associated with the provided\nname, has been cached for the AMR block with the given composite\nindex.\n"},
  {"HasAMRBlock", PyvtkAMRDataSetCache_HasAMRBlock, METH_VARARGS,
   "V.HasAMRBlock(int) -> bool\nC++: bool HasAMRBlock(const int compositeIdx)\n\nChecks if the AMR block associated with the given composite is\ncached.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAMRDataSetCache_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOAMRPython.vtkAMRDataSetCache", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAMRDataSetCache_StaticNew()
{
  return vtkAMRDataSetCache::New();
}

PyObject *PyvtkAMRDataSetCache_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAMRDataSetCache_Type, PyvtkAMRDataSetCache_Methods,
    "vtkAMRDataSetCache",
    PyvtkAMRDataSetCache_Doc(), &PyvtkAMRDataSetCache_StaticNew);

  PyTypeObject *pytype = &PyvtkAMRDataSetCache_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAMRDataSetCache_Doc()
{
  static const char *docstring[] = {
    "vtkAMRDataSetCache -  A concrete implementation of vtkObject that\nprovides functionality for\n caching AMR blocks.\n\n",
    "Superclass: vtkObject\n\n",
    "The primary intent of this class is to be used by the\n AMR reader infrastructure for caching blocks/data in memory to\nminimize\n out-of-core operations.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAMRDataSetCache(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAMRDataSetCache_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAMRDataSetCache", o) != 0)
  {
    Py_DECREF(o);
  }

}

