// python wrapper for vtkChacoGraphReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkChacoGraphReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkChacoGraphReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkChacoGraphReader_ClassNew(); }

#ifndef DECLARED_PyvtkUndirectedGraphAlgorithm_ClassNew
extern "C" { PyObject *PyvtkUndirectedGraphAlgorithm_ClassNew(); }
#define DECLARED_PyvtkUndirectedGraphAlgorithm_ClassNew
#endif

static const char **PyvtkChacoGraphReader_Doc();


static PyObject *
PyvtkChacoGraphReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChacoGraphReader *op = static_cast<vtkChacoGraphReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkChacoGraphReader::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChacoGraphReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChacoGraphReader *op = static_cast<vtkChacoGraphReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkChacoGraphReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChacoGraphReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChacoGraphReader *op = static_cast<vtkChacoGraphReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkChacoGraphReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkChacoGraphReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkChacoGraphReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkChacoGraphReader *tempr = vtkChacoGraphReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChacoGraphReader_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChacoGraphReader *op = static_cast<vtkChacoGraphReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkChacoGraphReader::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChacoGraphReader_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChacoGraphReader *op = static_cast<vtkChacoGraphReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkChacoGraphReader::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkChacoGraphReader_Methods[] = {
  {"GetClassName", PyvtkChacoGraphReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkChacoGraphReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkChacoGraphReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkChacoGraphReader\nC++: vtkChacoGraphReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkChacoGraphReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkChacoGraphReader\nC++: vtkChacoGraphReader *SafeDownCast(vtkObject* o)\n\n"},
  {"GetFileName", PyvtkChacoGraphReader_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: char *GetFileName()\n\nThe Chaco file name.\n"},
  {"SetFileName", PyvtkChacoGraphReader_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(char *)\n\nThe Chaco file name.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkChacoGraphReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOInfovisPython.vtkChacoGraphReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkChacoGraphReader_StaticNew()
{
  return vtkChacoGraphReader::New();
}

PyObject *PyvtkChacoGraphReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkChacoGraphReader_Type, PyvtkChacoGraphReader_Methods,
    "vtkChacoGraphReader",
    PyvtkChacoGraphReader_Doc(), &PyvtkChacoGraphReader_StaticNew);

  PyTypeObject *pytype = &PyvtkChacoGraphReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUndirectedGraphAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkChacoGraphReader_Doc()
{
  static const char *docstring[] = {
    "vtkChacoGraphReader - Reads chaco graph files.\n\n",
    "Superclass: vtkUndirectedGraphAlgorithm\n\n",
    "vtkChacoGraphReader reads in files in the Chaco format into a\nvtkGraph. An example is the following  10 13 2 6 10 1 3 2 4 8 3 5 4 6\n10 1 5 7 6 8 3 7 9 8 10 1 5 9  The first line specifies the number of\nvertices and edges in the graph. Each additional line contains the\nvertices adjacent to a particular vertex.  In this example, vertex 1\nis adjacent to 2, 6 and 10, vertex 2 is adjacent to 1 and 3, e",
    "tc. \nSince Chaco ids start at 1 and VTK ids start at 0, the vertex ids in\nthe vtkGraph will be 1 less than the Chaco ids.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkChacoGraphReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkChacoGraphReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkChacoGraphReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

