// python wrapper for vtkCirclePackToPolyData
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkCirclePackToPolyData.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCirclePackToPolyData(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCirclePackToPolyData_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkCirclePackToPolyData_Doc();


static PyObject *
PyvtkCirclePackToPolyData_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCirclePackToPolyData *op = static_cast<vtkCirclePackToPolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkCirclePackToPolyData::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCirclePackToPolyData_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCirclePackToPolyData *op = static_cast<vtkCirclePackToPolyData *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCirclePackToPolyData::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCirclePackToPolyData_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCirclePackToPolyData *op = static_cast<vtkCirclePackToPolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCirclePackToPolyData *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCirclePackToPolyData::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkCirclePackToPolyData_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkCirclePackToPolyData *tempr = vtkCirclePackToPolyData::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCirclePackToPolyData_SetCirclesArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCirclesArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCirclePackToPolyData *op = static_cast<vtkCirclePackToPolyData *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCirclesArrayName(temp0);
    }
    else
    {
      op->vtkCirclePackToPolyData::SetCirclesArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCirclePackToPolyData_SetResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCirclePackToPolyData *op = static_cast<vtkCirclePackToPolyData *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetResolution(temp0);
    }
    else
    {
      op->vtkCirclePackToPolyData::SetResolution(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCirclePackToPolyData_GetResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCirclePackToPolyData *op = static_cast<vtkCirclePackToPolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetResolution() :
      op->vtkCirclePackToPolyData::GetResolution());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCirclePackToPolyData_FillInputPortInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FillInputPortInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCirclePackToPolyData *op = static_cast<vtkCirclePackToPolyData *>(vp);

  int temp0;
  vtkInformation *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkInformation"))
  {
    int tempr = (ap.IsBound() ?
      op->FillInputPortInformation(temp0, temp1) :
      op->vtkCirclePackToPolyData::FillInputPortInformation(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkCirclePackToPolyData_Methods[] = {
  {"GetClassName", PyvtkCirclePackToPolyData_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkCirclePackToPolyData_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkCirclePackToPolyData_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCirclePackToPolyData\nC++: vtkCirclePackToPolyData *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkCirclePackToPolyData_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkCirclePackToPolyData\nC++: vtkCirclePackToPolyData *SafeDownCast(vtkObject* o)\n\n"},
  {"SetCirclesArrayName", PyvtkCirclePackToPolyData_SetCirclesArrayName, METH_VARARGS,
   "V.SetCirclesArrayName(string)\nC++: virtual void SetCirclesArrayName(const char *name)\n\nThe field containing triples of the form (Xcenter, Ycenter,\nRadius).\n\n* This field may be added to the tree using vtkCirclePackLayout.\n* This array must be set.\n"},
  {"SetResolution", PyvtkCirclePackToPolyData_SetResolution, METH_VARARGS,
   "V.SetResolution(int)\nC++: void SetResolution(unsigned int a)\n\nDefine the number of sides used in output circles. Default is\n100.\n"},
  {"GetResolution", PyvtkCirclePackToPolyData_GetResolution, METH_VARARGS,
   "V.GetResolution() -> int\nC++: unsigned int GetResolution()\n\nDefine the number of sides used in output circles. Default is\n100.\n"},
  {"FillInputPortInformation", PyvtkCirclePackToPolyData_FillInputPortInformation, METH_VARARGS,
   "V.FillInputPortInformation(int, vtkInformation) -> int\nC++: int FillInputPortInformation(int port, vtkInformation *info)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkCirclePackToPolyData_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInfovisLayoutPython.vtkCirclePackToPolyData", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCirclePackToPolyData_StaticNew()
{
  return vtkCirclePackToPolyData::New();
}

PyObject *PyvtkCirclePackToPolyData_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkCirclePackToPolyData_Type, PyvtkCirclePackToPolyData_Methods,
    "vtkCirclePackToPolyData",
    PyvtkCirclePackToPolyData_Doc(), &PyvtkCirclePackToPolyData_StaticNew);

  PyTypeObject *pytype = &PyvtkCirclePackToPolyData_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCirclePackToPolyData_Doc()
{
  static const char *docstring[] = {
    "vtkCirclePackToPolyData - converts a tree to a polygonal data\nrepresenting a circle packing of the hierarchy.\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "This algorithm requires that the vtkCirclePackLayout filter has\nalready been applied to the data in order to create the triple array\n(Xcenter, Ycenter, Radius) of circle bounds or each vertex of the\ntree.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCirclePackToPolyData(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCirclePackToPolyData_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCirclePackToPolyData", o) != 0)
  {
    Py_DECREF(o);
  }

}

