// python wrapper for vtkClipConvexPolyData
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkClipConvexPolyData.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkClipConvexPolyData(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkClipConvexPolyData_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkClipConvexPolyData_Doc();


static PyObject *
PyvtkClipConvexPolyData_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkClipConvexPolyData *op = static_cast<vtkClipConvexPolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkClipConvexPolyData::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkClipConvexPolyData_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkClipConvexPolyData *op = static_cast<vtkClipConvexPolyData *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkClipConvexPolyData::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkClipConvexPolyData_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkClipConvexPolyData *op = static_cast<vtkClipConvexPolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkClipConvexPolyData *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkClipConvexPolyData::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkClipConvexPolyData_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkClipConvexPolyData *tempr = vtkClipConvexPolyData::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkClipConvexPolyData_SetPlanes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPlanes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkClipConvexPolyData *op = static_cast<vtkClipConvexPolyData *>(vp);

  vtkPlaneCollection *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPlaneCollection"))
  {
    if (ap.IsBound())
    {
      op->SetPlanes(temp0);
    }
    else
    {
      op->vtkClipConvexPolyData::SetPlanes(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkClipConvexPolyData_GetPlanes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPlanes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkClipConvexPolyData *op = static_cast<vtkClipConvexPolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPlaneCollection *tempr = (ap.IsBound() ?
      op->GetPlanes() :
      op->vtkClipConvexPolyData::GetPlanes());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkClipConvexPolyData_GetMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkClipConvexPolyData *op = static_cast<vtkClipConvexPolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long long tempr = (ap.IsBound() ?
      op->GetMTime() :
      op->vtkClipConvexPolyData::GetMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkClipConvexPolyData_Methods[] = {
  {"GetClassName", PyvtkClipConvexPolyData_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkClipConvexPolyData_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkClipConvexPolyData_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkClipConvexPolyData\nC++: vtkClipConvexPolyData *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkClipConvexPolyData_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkClipConvexPolyData\nC++: vtkClipConvexPolyData *SafeDownCast(vtkObject* o)\n\n"},
  {"SetPlanes", PyvtkClipConvexPolyData_SetPlanes, METH_VARARGS,
   "V.SetPlanes(vtkPlaneCollection)\nC++: void SetPlanes(vtkPlaneCollection *planes)\n\nSet all the planes at once using a vtkPlanes implicit function.\nThis also sets the D value.\n"},
  {"GetPlanes", PyvtkClipConvexPolyData_GetPlanes, METH_VARARGS,
   "V.GetPlanes() -> vtkPlaneCollection\nC++: vtkPlaneCollection *GetPlanes()\n\nSet all the planes at once using a vtkPlanes implicit function.\nThis also sets the D value.\n"},
  {"GetMTime", PyvtkClipConvexPolyData_GetMTime, METH_VARARGS,
   "V.GetMTime() -> int\nC++: vtkMTimeType GetMTime()\n\nRedefines this method, as this filter depends on time of its\ncomponents (planes)\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkClipConvexPolyData_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersGeneralPython.vtkClipConvexPolyData", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkClipConvexPolyData_StaticNew()
{
  return vtkClipConvexPolyData::New();
}

PyObject *PyvtkClipConvexPolyData_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkClipConvexPolyData_Type, PyvtkClipConvexPolyData_Methods,
    "vtkClipConvexPolyData",
    PyvtkClipConvexPolyData_Doc(), &PyvtkClipConvexPolyData_StaticNew);

  PyTypeObject *pytype = &PyvtkClipConvexPolyData_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkClipConvexPolyData_Doc()
{
  static const char *docstring[] = {
    "vtkClipConvexPolyData - clip any dataset with user-specified implicit\nfunction or input scalar data\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkClipConvexPolyData is a filter that clips a convex polydata with a\nset of planes. Its main usage is for clipping a bounding volume with\nfrustum planes (used later one in volume rendering).\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkClipConvexPolyData(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkClipConvexPolyData_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkClipConvexPolyData", o) != 0)
  {
    Py_DECREF(o);
  }

}

