// python wrapper for vtkConeLayoutStrategy
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkConeLayoutStrategy.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkConeLayoutStrategy(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkConeLayoutStrategy_ClassNew(); }

#ifndef DECLARED_PyvtkGraphLayoutStrategy_ClassNew
extern "C" { PyObject *PyvtkGraphLayoutStrategy_ClassNew(); }
#define DECLARED_PyvtkGraphLayoutStrategy_ClassNew
#endif

static const char **PyvtkConeLayoutStrategy_Doc();


static PyObject *
PyvtkConeLayoutStrategy_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkConeLayoutStrategy::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkConeLayoutStrategy::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkConeLayoutStrategy *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkConeLayoutStrategy::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkConeLayoutStrategy *tempr = vtkConeLayoutStrategy::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_SetCompactness(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompactness");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCompactness(temp0);
    }
    else
    {
      op->vtkConeLayoutStrategy::SetCompactness(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_GetCompactness(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompactness");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetCompactness() :
      op->vtkConeLayoutStrategy::GetCompactness());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_SetCompression(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompression");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCompression(temp0);
    }
    else
    {
      op->vtkConeLayoutStrategy::SetCompression(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_GetCompression(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompression");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCompression() :
      op->vtkConeLayoutStrategy::GetCompression());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_CompressionOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CompressionOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CompressionOn();
    }
    else
    {
      op->vtkConeLayoutStrategy::CompressionOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_CompressionOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CompressionOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CompressionOff();
    }
    else
    {
      op->vtkConeLayoutStrategy::CompressionOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_SetSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSpacing(temp0);
    }
    else
    {
      op->vtkConeLayoutStrategy::SetSpacing(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_GetSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetSpacing() :
      op->vtkConeLayoutStrategy::GetSpacing());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkConeLayoutStrategy_Layout(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Layout");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkConeLayoutStrategy *op = static_cast<vtkConeLayoutStrategy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Layout();
    }
    else
    {
      op->vtkConeLayoutStrategy::Layout();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkConeLayoutStrategy_Methods[] = {
  {"GetClassName", PyvtkConeLayoutStrategy_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkConeLayoutStrategy_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkConeLayoutStrategy_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkConeLayoutStrategy\nC++: vtkConeLayoutStrategy *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkConeLayoutStrategy_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkConeLayoutStrategy\nC++: vtkConeLayoutStrategy *SafeDownCast(vtkObject* o)\n\n"},
  {"SetCompactness", PyvtkConeLayoutStrategy_SetCompactness, METH_VARARGS,
   "V.SetCompactness(float)\nC++: void SetCompactness(float a)\n\nDetermine the compactness, the ratio between the average width of\na cone in the tree, and the height of the cone.  The default\nsetting is 0.75 which (empirically) seems reasonable, but this\nwill need adapting depending on the data.\n"},
  {"GetCompactness", PyvtkConeLayoutStrategy_GetCompactness, METH_VARARGS,
   "V.GetCompactness() -> float\nC++: float GetCompactness()\n\nDetermine the compactness, the ratio between the average width of\na cone in the tree, and the height of the cone.  The default\nsetting is 0.75 which (empirically) seems reasonable, but this\nwill need adapting depending on the data.\n"},
  {"SetCompression", PyvtkConeLayoutStrategy_SetCompression, METH_VARARGS,
   "V.SetCompression(int)\nC++: void SetCompression(int a)\n\nDetermine if layout should be compressed, i.e. the layout puts\nchildren closer together, possibly allowing sub-trees to overlap.\n This is useful if the tree is actually the spanning tree of a\ngraph.  For \"real\" trees, non-compressed layout is best, and is\nthe default.\n"},
  {"GetCompression", PyvtkConeLayoutStrategy_GetCompression, METH_VARARGS,
   "V.GetCompression() -> int\nC++: int GetCompression()\n\nDetermine if layout should be compressed, i.e. the layout puts\nchildren closer together, possibly allowing sub-trees to overlap.\n This is useful if the tree is actually the spanning tree of a\ngraph.  For \"real\" trees, non-compressed layout is best, and is\nthe default.\n"},
  {"CompressionOn", PyvtkConeLayoutStrategy_CompressionOn, METH_VARARGS,
   "V.CompressionOn()\nC++: void CompressionOn()\n\nDetermine if layout should be compressed, i.e. the layout puts\nchildren closer together, possibly allowing sub-trees to overlap.\n This is useful if the tree is actually the spanning tree of a\ngraph.  For \"real\" trees, non-compressed layout is best, and is\nthe default.\n"},
  {"CompressionOff", PyvtkConeLayoutStrategy_CompressionOff, METH_VARARGS,
   "V.CompressionOff()\nC++: void CompressionOff()\n\nDetermine if layout should be compressed, i.e. the layout puts\nchildren closer together, possibly allowing sub-trees to overlap.\n This is useful if the tree is actually the spanning tree of a\ngraph.  For \"real\" trees, non-compressed layout is best, and is\nthe default.\n"},
  {"SetSpacing", PyvtkConeLayoutStrategy_SetSpacing, METH_VARARGS,
   "V.SetSpacing(float)\nC++: void SetSpacing(float a)\n\nSet the spacing parameter that affects space between layers of\nthe tree.  If compression is on, Spacing is the actual distance\nbetween layers.  If compression is off, actual distance also\nincludes a factor of the compactness and maximum cone radius.\n"},
  {"GetSpacing", PyvtkConeLayoutStrategy_GetSpacing, METH_VARARGS,
   "V.GetSpacing() -> float\nC++: float GetSpacing()\n\nSet the spacing parameter that affects space between layers of\nthe tree.  If compression is on, Spacing is the actual distance\nbetween layers.  If compression is off, actual distance also\nincludes a factor of the compactness and maximum cone radius.\n"},
  {"Layout", PyvtkConeLayoutStrategy_Layout, METH_VARARGS,
   "V.Layout()\nC++: void Layout()\n\nPerform the layout.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkConeLayoutStrategy_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInfovisLayoutPython.vtkConeLayoutStrategy", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkConeLayoutStrategy_StaticNew()
{
  return vtkConeLayoutStrategy::New();
}

PyObject *PyvtkConeLayoutStrategy_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkConeLayoutStrategy_Type, PyvtkConeLayoutStrategy_Methods,
    "vtkConeLayoutStrategy",
    PyvtkConeLayoutStrategy_Doc(), &PyvtkConeLayoutStrategy_StaticNew);

  PyTypeObject *pytype = &PyvtkConeLayoutStrategy_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGraphLayoutStrategy_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkConeLayoutStrategy_Doc()
{
  static const char *docstring[] = {
    "vtkConeLayoutStrategy - produce a cone-tree layout for a forest\n\n",
    "Superclass: vtkGraphLayoutStrategy\n\n",
    "vtkConeLayoutStrategy positions the nodes of a tree(forest) in 3D\nspace based on the cone-tree approach first described by Robertson,\nMackinlay and Card in Proc. CHI'91.  This implementation incorporates\nrefinements to the layout developed by Carriere and Kazman, and by\nAuber.\n\nThe input graph must be a forest (i.e. a set of trees, or a single\ntree); in the case of a forest, the input will be conv",
    "erted to a\nsingle tree by introducing a new root node, and connecting each root\nin the input forest to the meta-root. The tree is then laid out,\nafter which the meta-root is removed.\n\nThe cones are positioned so that children lie in planes parallel to\nthe X-Y plane, with the axis of cones parallel to Z, and with Z\ncoordinate increasing with distance of nodes from the root.\n\n@par Thanks: Thanks to ",
    "David Duke from the University of Leeds for\nproviding this implementation.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkConeLayoutStrategy(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkConeLayoutStrategy_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkConeLayoutStrategy", o) != 0)
  {
    Py_DECREF(o);
  }

}

