// python wrapper for vtkCriticalSection
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkCriticalSection.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCriticalSection(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCriticalSection_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkCriticalSection_Doc();


static PyObject *
PyvtkCriticalSection_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCriticalSection *op = static_cast<vtkCriticalSection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkCriticalSection::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCriticalSection_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCriticalSection *op = static_cast<vtkCriticalSection *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCriticalSection::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCriticalSection_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCriticalSection *op = static_cast<vtkCriticalSection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCriticalSection *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCriticalSection::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkCriticalSection_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkCriticalSection *tempr = vtkCriticalSection::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCriticalSection_Lock(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Lock");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCriticalSection *op = static_cast<vtkCriticalSection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Lock();
    }
    else
    {
      op->vtkCriticalSection::Lock();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCriticalSection_Unlock(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Unlock");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCriticalSection *op = static_cast<vtkCriticalSection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Unlock();
    }
    else
    {
      op->vtkCriticalSection::Unlock();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkCriticalSection_Methods[] = {
  {"GetClassName", PyvtkCriticalSection_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkCriticalSection_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkCriticalSection_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCriticalSection\nC++: vtkCriticalSection *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkCriticalSection_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkCriticalSection\nC++: vtkCriticalSection *SafeDownCast(vtkObject* o)\n\n"},
  {"Lock", PyvtkCriticalSection_Lock, METH_VARARGS,
   "V.Lock()\nC++: void Lock()\n\nLock the vtkCriticalSection\n"},
  {"Unlock", PyvtkCriticalSection_Unlock, METH_VARARGS,
   "V.Unlock()\nC++: void Unlock()\n\nUnlock the vtkCriticalSection\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkCriticalSection_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkCriticalSection", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCriticalSection_StaticNew()
{
  return vtkCriticalSection::New();
}

PyObject *PyvtkCriticalSection_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkCriticalSection_Type, PyvtkCriticalSection_Methods,
    "vtkCriticalSection",
    PyvtkCriticalSection_Doc(), &PyvtkCriticalSection_StaticNew);

  PyTypeObject *pytype = &PyvtkCriticalSection_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCriticalSection_Doc()
{
  static const char *docstring[] = {
    "vtkCriticalSection - Critical section locking class\n\n",
    "Superclass: vtkObject\n\n",
    "vtkCriticalSection allows the locking of variables which are accessed\nthrough different threads.  This header file also defines\nvtkSimpleCriticalSection which is not a subclass of vtkObject. The\nAPI is identical to that of vtkMutexLock, and the behavior is\nidentical as well, except on Windows 9x/NT platforms. The only\ndifference on these platforms is that vtkMutexLock is more flexible,\nin that it ",
    "works across processes as well as across threads, but also\ncosts more, in that it evokes a 600-cycle x86 ring transition. The\nvtkCriticalSection provides a higher-performance equivalent (on\nWindows) but won't work across processes. Since it is unclear how, in\nvtk, an object at the vtk level can be shared across processes in the\nfirst place, one should use vtkCriticalSection unless one has a very\ng",
    "ood reason to use vtkMutexLock. If higher-performance equivalents\nfor non-Windows platforms (Irix, SunOS, etc) are discovered, they\nshould replace the implementations in this class\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCriticalSection(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCriticalSection_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCriticalSection", o) != 0)
  {
    Py_DECREF(o);
  }

}

