// python wrapper for vtkDIMACSGraphWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDIMACSGraphWriter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDIMACSGraphWriter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDIMACSGraphWriter_ClassNew(); }

#ifndef DECLARED_PyvtkDataWriter_ClassNew
extern "C" { PyObject *PyvtkDataWriter_ClassNew(); }
#define DECLARED_PyvtkDataWriter_ClassNew
#endif

static const char **PyvtkDIMACSGraphWriter_Doc();


static PyObject *
PyvtkDIMACSGraphWriter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDIMACSGraphWriter *op = static_cast<vtkDIMACSGraphWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkDIMACSGraphWriter::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDIMACSGraphWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDIMACSGraphWriter *op = static_cast<vtkDIMACSGraphWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDIMACSGraphWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDIMACSGraphWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDIMACSGraphWriter *op = static_cast<vtkDIMACSGraphWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDIMACSGraphWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDIMACSGraphWriter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDIMACSGraphWriter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkDIMACSGraphWriter *tempr = vtkDIMACSGraphWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDIMACSGraphWriter_GetInput_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDIMACSGraphWriter *op = static_cast<vtkDIMACSGraphWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGraph *tempr = (ap.IsBound() ?
      op->GetInput() :
      op->vtkDIMACSGraphWriter::GetInput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDIMACSGraphWriter_GetInput_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDIMACSGraphWriter *op = static_cast<vtkDIMACSGraphWriter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkGraph *tempr = (ap.IsBound() ?
      op->GetInput(temp0) :
      op->vtkDIMACSGraphWriter::GetInput(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkDIMACSGraphWriter_GetInput(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkDIMACSGraphWriter_GetInput_s1(self, args);
    case 1:
      return PyvtkDIMACSGraphWriter_GetInput_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetInput");
  return NULL;
}


static PyMethodDef PyvtkDIMACSGraphWriter_Methods[] = {
  {"GetClassName", PyvtkDIMACSGraphWriter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkDIMACSGraphWriter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkDIMACSGraphWriter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDIMACSGraphWriter\nC++: vtkDIMACSGraphWriter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkDIMACSGraphWriter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkDIMACSGraphWriter\nC++: vtkDIMACSGraphWriter *SafeDownCast(vtkObject* o)\n\n"},
  {"GetInput", PyvtkDIMACSGraphWriter_GetInput, METH_VARARGS,
   "V.GetInput() -> vtkGraph\nC++: vtkGraph *GetInput()\nV.GetInput(int) -> vtkGraph\nC++: vtkGraph *GetInput(int port)\n\nGet the input to this writer.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDIMACSGraphWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOInfovisPython.vtkDIMACSGraphWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDIMACSGraphWriter_StaticNew()
{
  return vtkDIMACSGraphWriter::New();
}

PyObject *PyvtkDIMACSGraphWriter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDIMACSGraphWriter_Type, PyvtkDIMACSGraphWriter_Methods,
    "vtkDIMACSGraphWriter",
    PyvtkDIMACSGraphWriter_Doc(), &PyvtkDIMACSGraphWriter_StaticNew);

  PyTypeObject *pytype = &PyvtkDIMACSGraphWriter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataWriter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDIMACSGraphWriter_Doc()
{
  static const char *docstring[] = {
    "vtkDIMACSGraphWriter - write vtkGraph data to a DIMACS formatted file\n\n",
    "Superclass: vtkDataWriter\n\n",
    "vtkDIMACSGraphWriter is a sink object that writes vtkGraph data files\ninto a generic DIMACS (.gr) format.\n\nOutput files contain a problem statement line:\n\np graph <num_verts> <num_edges>\n\nFollowed by |E| edge descriptor lines that are formatted as:\n\ne <target> \n\nVertices are numbered from 1..n in DIMACS formatted files.\n\nSee webpage for format details.\nhttp://prolland.free.fr/works/research/dsat/d",
    "imacs.html\n\n@sa\nvtkDIMACSGraphReader\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDIMACSGraphWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDIMACSGraphWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDIMACSGraphWriter", o) != 0)
  {
    Py_DECREF(o);
  }

}

