// python wrapper for vtkDepthOfFieldPass
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDepthOfFieldPass.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDepthOfFieldPass(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDepthOfFieldPass_ClassNew(); }

#ifndef DECLARED_PyvtkDepthImageProcessingPass_ClassNew
extern "C" { PyObject *PyvtkDepthImageProcessingPass_ClassNew(); }
#define DECLARED_PyvtkDepthImageProcessingPass_ClassNew
#endif

static const char **PyvtkDepthOfFieldPass_Doc();


static PyObject *
PyvtkDepthOfFieldPass_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDepthOfFieldPass *op = static_cast<vtkDepthOfFieldPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkDepthOfFieldPass::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDepthOfFieldPass_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDepthOfFieldPass *op = static_cast<vtkDepthOfFieldPass *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDepthOfFieldPass::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDepthOfFieldPass_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDepthOfFieldPass *op = static_cast<vtkDepthOfFieldPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDepthOfFieldPass *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDepthOfFieldPass::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDepthOfFieldPass_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkDepthOfFieldPass *tempr = vtkDepthOfFieldPass::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDepthOfFieldPass_SetAutomaticFocalDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutomaticFocalDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDepthOfFieldPass *op = static_cast<vtkDepthOfFieldPass *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutomaticFocalDistance(temp0);
    }
    else
    {
      op->vtkDepthOfFieldPass::SetAutomaticFocalDistance(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDepthOfFieldPass_GetAutomaticFocalDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutomaticFocalDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDepthOfFieldPass *op = static_cast<vtkDepthOfFieldPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetAutomaticFocalDistance() :
      op->vtkDepthOfFieldPass::GetAutomaticFocalDistance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDepthOfFieldPass_AutomaticFocalDistanceOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AutomaticFocalDistanceOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDepthOfFieldPass *op = static_cast<vtkDepthOfFieldPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AutomaticFocalDistanceOn();
    }
    else
    {
      op->vtkDepthOfFieldPass::AutomaticFocalDistanceOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDepthOfFieldPass_AutomaticFocalDistanceOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AutomaticFocalDistanceOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDepthOfFieldPass *op = static_cast<vtkDepthOfFieldPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AutomaticFocalDistanceOff();
    }
    else
    {
      op->vtkDepthOfFieldPass::AutomaticFocalDistanceOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDepthOfFieldPass_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDepthOfFieldPass *op = static_cast<vtkDepthOfFieldPass *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkDepthOfFieldPass::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkDepthOfFieldPass_Methods[] = {
  {"GetClassName", PyvtkDepthOfFieldPass_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkDepthOfFieldPass_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkDepthOfFieldPass_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDepthOfFieldPass\nC++: vtkDepthOfFieldPass *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkDepthOfFieldPass_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkDepthOfFieldPass\nC++: vtkDepthOfFieldPass *SafeDownCast(vtkObject* o)\n\n"},
  {"SetAutomaticFocalDistance", PyvtkDepthOfFieldPass_SetAutomaticFocalDistance, METH_VARARGS,
   "V.SetAutomaticFocalDistance(bool)\nC++: void SetAutomaticFocalDistance(bool a)\n\nUse automatic focal distance calculation, this is on by default\nWhen on the center of the viewport will always be in focus\nregardless of where the focal point is.\n"},
  {"GetAutomaticFocalDistance", PyvtkDepthOfFieldPass_GetAutomaticFocalDistance, METH_VARARGS,
   "V.GetAutomaticFocalDistance() -> bool\nC++: bool GetAutomaticFocalDistance()\n\nUse automatic focal distance calculation, this is on by default\nWhen on the center of the viewport will always be in focus\nregardless of where the focal point is.\n"},
  {"AutomaticFocalDistanceOn", PyvtkDepthOfFieldPass_AutomaticFocalDistanceOn, METH_VARARGS,
   "V.AutomaticFocalDistanceOn()\nC++: void AutomaticFocalDistanceOn()\n\nUse automatic focal distance calculation, this is on by default\nWhen on the center of the viewport will always be in focus\nregardless of where the focal point is.\n"},
  {"AutomaticFocalDistanceOff", PyvtkDepthOfFieldPass_AutomaticFocalDistanceOff, METH_VARARGS,
   "V.AutomaticFocalDistanceOff()\nC++: void AutomaticFocalDistanceOff()\n\nUse automatic focal distance calculation, this is on by default\nWhen on the center of the viewport will always be in focus\nregardless of where the focal point is.\n"},
  {"ReleaseGraphicsResources", PyvtkDepthOfFieldPass_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *w)\n\nRelease graphics resources and ask components to release their\nown resources.\n\\pre w_exists: w!=0\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDepthOfFieldPass_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkDepthOfFieldPass", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDepthOfFieldPass_StaticNew()
{
  return vtkDepthOfFieldPass::New();
}

PyObject *PyvtkDepthOfFieldPass_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDepthOfFieldPass_Type, PyvtkDepthOfFieldPass_Methods,
    "vtkDepthOfFieldPass",
    PyvtkDepthOfFieldPass_Doc(), &PyvtkDepthOfFieldPass_StaticNew);

  PyTypeObject *pytype = &PyvtkDepthOfFieldPass_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDepthImageProcessingPass_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDepthOfFieldPass_Doc()
{
  static const char *docstring[] = {
    "vtkDepthOfFieldPass - Implement a post-processing DOF blur pass.\n\n",
    "Superclass: vtkDepthImageProcessingPass\n\n",
    "Currently only does behind the focal plane\n\nThis pass expects an initialized depth buffer and color buffer.\nInitialized buffers means they have been cleared with farest z-value\nand background color/gradient/transparent color.\n\nThe delegate is used once.\n\nIts delegate is usually set to a vtkCameraPass or to a\npost-processing pass.\n\n@par Implementation: As the filter is separable, it first blurs the",
    "\nimage horizontally and then vertically. This reduces the number of\ntexture samples\n\n@sa\nvtkRenderPass\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDepthOfFieldPass(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDepthOfFieldPass_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDepthOfFieldPass", o) != 0)
  {
    Py_DECREF(o);
  }

}

