// python wrapper for vtkDistancePolyDataFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDistancePolyDataFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDistancePolyDataFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDistancePolyDataFilter_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkDistancePolyDataFilter_Doc();


static PyObject *
PyvtkDistancePolyDataFilter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkDistancePolyDataFilter::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDistancePolyDataFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDistancePolyDataFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDistancePolyDataFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkDistancePolyDataFilter *tempr = vtkDistancePolyDataFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_SetSignedDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSignedDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSignedDistance(temp0);
    }
    else
    {
      op->vtkDistancePolyDataFilter::SetSignedDistance(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_GetSignedDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSignedDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSignedDistance() :
      op->vtkDistancePolyDataFilter::GetSignedDistance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_SignedDistanceOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SignedDistanceOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SignedDistanceOn();
    }
    else
    {
      op->vtkDistancePolyDataFilter::SignedDistanceOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_SignedDistanceOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SignedDistanceOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SignedDistanceOff();
    }
    else
    {
      op->vtkDistancePolyDataFilter::SignedDistanceOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_SetNegateDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNegateDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNegateDistance(temp0);
    }
    else
    {
      op->vtkDistancePolyDataFilter::SetNegateDistance(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_GetNegateDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNegateDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNegateDistance() :
      op->vtkDistancePolyDataFilter::GetNegateDistance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_NegateDistanceOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NegateDistanceOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->NegateDistanceOn();
    }
    else
    {
      op->vtkDistancePolyDataFilter::NegateDistanceOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_NegateDistanceOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NegateDistanceOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->NegateDistanceOff();
    }
    else
    {
      op->vtkDistancePolyDataFilter::NegateDistanceOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_SetComputeSecondDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetComputeSecondDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetComputeSecondDistance(temp0);
    }
    else
    {
      op->vtkDistancePolyDataFilter::SetComputeSecondDistance(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_GetComputeSecondDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetComputeSecondDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetComputeSecondDistance() :
      op->vtkDistancePolyDataFilter::GetComputeSecondDistance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_ComputeSecondDistanceOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ComputeSecondDistanceOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ComputeSecondDistanceOn();
    }
    else
    {
      op->vtkDistancePolyDataFilter::ComputeSecondDistanceOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_ComputeSecondDistanceOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ComputeSecondDistanceOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ComputeSecondDistanceOff();
    }
    else
    {
      op->vtkDistancePolyDataFilter::ComputeSecondDistanceOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDistancePolyDataFilter_GetSecondDistanceOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSecondDistanceOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDistancePolyDataFilter *op = static_cast<vtkDistancePolyDataFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPolyData *tempr = (ap.IsBound() ?
      op->GetSecondDistanceOutput() :
      op->vtkDistancePolyDataFilter::GetSecondDistanceOutput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDistancePolyDataFilter_Methods[] = {
  {"GetClassName", PyvtkDistancePolyDataFilter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkDistancePolyDataFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkDistancePolyDataFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDistancePolyDataFilter\nC++: vtkDistancePolyDataFilter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkDistancePolyDataFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkDistancePolyDataFilter\nC++: vtkDistancePolyDataFilter *SafeDownCast(vtkObject* o)\n\n"},
  {"SetSignedDistance", PyvtkDistancePolyDataFilter_SetSignedDistance, METH_VARARGS,
   "V.SetSignedDistance(int)\nC++: void SetSignedDistance(int a)\n\nEnable/disable computation of the signed distance between the\nfirst poly data and the second poly data. Defaults to on.\n"},
  {"GetSignedDistance", PyvtkDistancePolyDataFilter_GetSignedDistance, METH_VARARGS,
   "V.GetSignedDistance() -> int\nC++: int GetSignedDistance()\n\nEnable/disable computation of the signed distance between the\nfirst poly data and the second poly data. Defaults to on.\n"},
  {"SignedDistanceOn", PyvtkDistancePolyDataFilter_SignedDistanceOn, METH_VARARGS,
   "V.SignedDistanceOn()\nC++: void SignedDistanceOn()\n\nEnable/disable computation of the signed distance between the\nfirst poly data and the second poly data. Defaults to on.\n"},
  {"SignedDistanceOff", PyvtkDistancePolyDataFilter_SignedDistanceOff, METH_VARARGS,
   "V.SignedDistanceOff()\nC++: void SignedDistanceOff()\n\nEnable/disable computation of the signed distance between the\nfirst poly data and the second poly data. Defaults to on.\n"},
  {"SetNegateDistance", PyvtkDistancePolyDataFilter_SetNegateDistance, METH_VARARGS,
   "V.SetNegateDistance(int)\nC++: void SetNegateDistance(int a)\n\nEnable/disable negation of the distance values. Defaults to off.\nHas no effect if SignedDistance is off.\n"},
  {"GetNegateDistance", PyvtkDistancePolyDataFilter_GetNegateDistance, METH_VARARGS,
   "V.GetNegateDistance() -> int\nC++: int GetNegateDistance()\n\nEnable/disable negation of the distance values. Defaults to off.\nHas no effect if SignedDistance is off.\n"},
  {"NegateDistanceOn", PyvtkDistancePolyDataFilter_NegateDistanceOn, METH_VARARGS,
   "V.NegateDistanceOn()\nC++: void NegateDistanceOn()\n\nEnable/disable negation of the distance values. Defaults to off.\nHas no effect if SignedDistance is off.\n"},
  {"NegateDistanceOff", PyvtkDistancePolyDataFilter_NegateDistanceOff, METH_VARARGS,
   "V.NegateDistanceOff()\nC++: void NegateDistanceOff()\n\nEnable/disable negation of the distance values. Defaults to off.\nHas no effect if SignedDistance is off.\n"},
  {"SetComputeSecondDistance", PyvtkDistancePolyDataFilter_SetComputeSecondDistance, METH_VARARGS,
   "V.SetComputeSecondDistance(int)\nC++: void SetComputeSecondDistance(int a)\n\nEnable/disable computation of a second output poly data with the\ndistance from the first poly data at each point. Defaults to on.\n"},
  {"GetComputeSecondDistance", PyvtkDistancePolyDataFilter_GetComputeSecondDistance, METH_VARARGS,
   "V.GetComputeSecondDistance() -> int\nC++: int GetComputeSecondDistance()\n\nEnable/disable computation of a second output poly data with the\ndistance from the first poly data at each point. Defaults to on.\n"},
  {"ComputeSecondDistanceOn", PyvtkDistancePolyDataFilter_ComputeSecondDistanceOn, METH_VARARGS,
   "V.ComputeSecondDistanceOn()\nC++: void ComputeSecondDistanceOn()\n\nEnable/disable computation of a second output poly data with the\ndistance from the first poly data at each point. Defaults to on.\n"},
  {"ComputeSecondDistanceOff", PyvtkDistancePolyDataFilter_ComputeSecondDistanceOff, METH_VARARGS,
   "V.ComputeSecondDistanceOff()\nC++: void ComputeSecondDistanceOff()\n\nEnable/disable computation of a second output poly data with the\ndistance from the first poly data at each point. Defaults to on.\n"},
  {"GetSecondDistanceOutput", PyvtkDistancePolyDataFilter_GetSecondDistanceOutput, METH_VARARGS,
   "V.GetSecondDistanceOutput() -> vtkPolyData\nC++: vtkPolyData *GetSecondDistanceOutput()\n\nGet the second output, which is a copy of the second input with\nan additional distance scalar field. Note this will return a\nvalid data object only after this->Update() is called.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDistancePolyDataFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersGeneralPython.vtkDistancePolyDataFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDistancePolyDataFilter_StaticNew()
{
  return vtkDistancePolyDataFilter::New();
}

PyObject *PyvtkDistancePolyDataFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDistancePolyDataFilter_Type, PyvtkDistancePolyDataFilter_Methods,
    "vtkDistancePolyDataFilter",
    PyvtkDistancePolyDataFilter_Doc(), &PyvtkDistancePolyDataFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkDistancePolyDataFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDistancePolyDataFilter_Doc()
{
  static const char *docstring[] = {
    "vtkDistancePolyDataFilter - Computes the signed distance from one\nvtkPolyData to another.\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "The signed distance to the second input is computed at every point in\nthe first input using vtkImplicitPolyDataDistance. Optionally, the\nsigned distance to the first input at every point in the second input\ncan be computed. This may be enabled by calling\nComputeSecondDistanceOn().\n\nIf the signed distance is not desired, the unsigned distance can be\ncomputed by calling SignedDistanceOff(). The sign",
    "ed distance field\nmay be negated by calling NegateDistanceOn();\n\nThis code was contributed in the VTK Journal paper: \"Boolean Operations on Surfaces in VTK Without External\nLibraries\" by Cory Quammen, Chris Weigle C., Russ Taylor\nhttp://hdl.handle.net/10380/3262\nhttp://www.midasjournal.org/browse/publication/797\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDistancePolyDataFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDistancePolyDataFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDistancePolyDataFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

