// python wrapper for vtkDualDepthPeelingPass
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkDualDepthPeelingPass.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDualDepthPeelingPass(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDualDepthPeelingPass_ClassNew(); }

#ifndef DECLARED_PyvtkDepthPeelingPass_ClassNew
extern "C" { PyObject *PyvtkDepthPeelingPass_ClassNew(); }
#define DECLARED_PyvtkDepthPeelingPass_ClassNew
#endif

static const char **PyvtkDualDepthPeelingPass_Doc();


static PyObject *
PyvtkDualDepthPeelingPass_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDualDepthPeelingPass *op = static_cast<vtkDualDepthPeelingPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkDualDepthPeelingPass::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDualDepthPeelingPass_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDualDepthPeelingPass *op = static_cast<vtkDualDepthPeelingPass *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDualDepthPeelingPass::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDualDepthPeelingPass_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDualDepthPeelingPass *op = static_cast<vtkDualDepthPeelingPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDualDepthPeelingPass *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDualDepthPeelingPass::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDualDepthPeelingPass_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkDualDepthPeelingPass *tempr = vtkDualDepthPeelingPass::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDualDepthPeelingPass_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDualDepthPeelingPass *op = static_cast<vtkDualDepthPeelingPass *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkDualDepthPeelingPass::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDualDepthPeelingPass_ReplaceShaderValues(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReplaceShaderValues");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDualDepthPeelingPass *op = static_cast<vtkDualDepthPeelingPass *>(vp);

  std::string temp0;
  std::string temp1;
  std::string temp2;
  vtkAbstractMapper *temp3 = NULL;
  vtkProp *temp4 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetVTKObject(temp3, "vtkAbstractMapper") &&
      ap.GetVTKObject(temp4, "vtkProp"))
  {
    bool tempr = (ap.IsBound() ?
      op->ReplaceShaderValues(temp0, temp1, temp2, temp3, temp4) :
      op->vtkDualDepthPeelingPass::ReplaceShaderValues(temp0, temp1, temp2, temp3, temp4));

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(0, temp0);
    }
    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(1, temp1);
    }
    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(2, temp2);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDualDepthPeelingPass_SetShaderParameters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetShaderParameters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDualDepthPeelingPass *op = static_cast<vtkDualDepthPeelingPass *>(vp);

  vtkShaderProgram *temp0 = NULL;
  vtkAbstractMapper *temp1 = NULL;
  vtkProp *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkShaderProgram") &&
      ap.GetVTKObject(temp1, "vtkAbstractMapper") &&
      ap.GetVTKObject(temp2, "vtkProp"))
  {
    bool tempr = (ap.IsBound() ?
      op->SetShaderParameters(temp0, temp1, temp2) :
      op->vtkDualDepthPeelingPass::SetShaderParameters(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDualDepthPeelingPass_GetShaderStageMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShaderStageMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDualDepthPeelingPass *op = static_cast<vtkDualDepthPeelingPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long long tempr = (ap.IsBound() ?
      op->GetShaderStageMTime() :
      op->vtkDualDepthPeelingPass::GetShaderStageMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDualDepthPeelingPass_Methods[] = {
  {"GetClassName", PyvtkDualDepthPeelingPass_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkDualDepthPeelingPass_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkDualDepthPeelingPass_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDualDepthPeelingPass\nC++: vtkDualDepthPeelingPass *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkDualDepthPeelingPass_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkDualDepthPeelingPass\nC++: vtkDualDepthPeelingPass *SafeDownCast(vtkObject* o)\n\n"},
  {"ReleaseGraphicsResources", PyvtkDualDepthPeelingPass_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: virtual void ReleaseGraphicsResources(vtkWindow *w)\n\n"},
  {"ReplaceShaderValues", PyvtkDualDepthPeelingPass_ReplaceShaderValues, METH_VARARGS,
   "V.ReplaceShaderValues(string, string, string, vtkAbstractMapper,\n    vtkProp) -> bool\nC++: virtual bool ReplaceShaderValues(std::string &vertexShader,\n    std::string &geometryShader, std::string &fragmentShader,\n    vtkAbstractMapper *mapper, vtkProp *prop)\n\n"},
  {"SetShaderParameters", PyvtkDualDepthPeelingPass_SetShaderParameters, METH_VARARGS,
   "V.SetShaderParameters(vtkShaderProgram, vtkAbstractMapper,\n    vtkProp) -> bool\nC++: virtual bool SetShaderParameters(vtkShaderProgram *program,\n    vtkAbstractMapper *mapper, vtkProp *prop)\n\n"},
  {"GetShaderStageMTime", PyvtkDualDepthPeelingPass_GetShaderStageMTime, METH_VARARGS,
   "V.GetShaderStageMTime() -> int\nC++: virtual vtkMTimeType GetShaderStageMTime()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDualDepthPeelingPass_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkDualDepthPeelingPass", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDualDepthPeelingPass_StaticNew()
{
  return vtkDualDepthPeelingPass::New();
}

PyObject *PyvtkDualDepthPeelingPass_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDualDepthPeelingPass_Type, PyvtkDualDepthPeelingPass_Methods,
    "vtkDualDepthPeelingPass",
    PyvtkDualDepthPeelingPass_Doc(), &PyvtkDualDepthPeelingPass_StaticNew);

  PyTypeObject *pytype = &PyvtkDualDepthPeelingPass_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDepthPeelingPass_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDualDepthPeelingPass_Doc()
{
  static const char *docstring[] = {
    "vtkDualDepthPeelingPass - Implements the dual depth peeling algorithm.\n\n",
    "Superclass: vtkDepthPeelingPass\n\n",
    "Dual depth peeling is an augmentatation of the standard depth peeling\nalgorithm that peels two layers (front and back) for each render\npass. The technique is described in \"Order independent transparency\nwith dual depth peeling\" (February 2008) by L. Bavoil, K. Myers.\n\nThe pass occurs in several stages:\n\n1. Copy the current (opaque geometry) depth buffer into a texture.\n2. Initialize the min-max de",
    "pth buffer from the opaque depth texture\n   and the translucent geometry.\n3. Peel the nearest and farthest fragments: 3a. Blend fragments that\n   match the nearest depth of the min-max depth buffer into the front\nbuffer. 3b. Write the far depth fragments into a temporary buffer.\n   3c. Extract the next set of min/max depth values for the next\n   peel. 3d. Blend the temporary far fragment texture (",
    "3b) into an\n   accumulation texture. 3e. Go back to 3a and repeat until the\n   maximum number of peels is met, or the desired occlusion ratio is\n   satisfied.\n4. If the occlusion ratio != 0 (i.e. we hit the maximum number of\n   peels before finishing), alpha blend the remaining fragments\n   in-between the near and far accumulation textures.\n5. Blend all accumulation buffers over the opaque color b",
    "uffer to\n   produce the final image.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDualDepthPeelingPass(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDualDepthPeelingPass_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDualDepthPeelingPass", o) != 0)
  {
    Py_DECREF(o);
  }

}

