// python wrapper for vtkDummyGPUInfoList
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDummyGPUInfoList.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDummyGPUInfoList(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDummyGPUInfoList_ClassNew(); }

#ifndef DECLARED_PyvtkGPUInfoList_ClassNew
extern "C" { PyObject *PyvtkGPUInfoList_ClassNew(); }
#define DECLARED_PyvtkGPUInfoList_ClassNew
#endif

static const char **PyvtkDummyGPUInfoList_Doc();


static PyObject *
PyvtkDummyGPUInfoList_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDummyGPUInfoList *op = static_cast<vtkDummyGPUInfoList *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkDummyGPUInfoList::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDummyGPUInfoList_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDummyGPUInfoList *op = static_cast<vtkDummyGPUInfoList *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDummyGPUInfoList::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDummyGPUInfoList_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDummyGPUInfoList *op = static_cast<vtkDummyGPUInfoList *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDummyGPUInfoList *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDummyGPUInfoList::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDummyGPUInfoList_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkDummyGPUInfoList *tempr = vtkDummyGPUInfoList::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDummyGPUInfoList_Probe(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Probe");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDummyGPUInfoList *op = static_cast<vtkDummyGPUInfoList *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Probe();
    }
    else
    {
      op->vtkDummyGPUInfoList::Probe();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkDummyGPUInfoList_Methods[] = {
  {"GetClassName", PyvtkDummyGPUInfoList_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkDummyGPUInfoList_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkDummyGPUInfoList_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDummyGPUInfoList\nC++: vtkDummyGPUInfoList *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkDummyGPUInfoList_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkDummyGPUInfoList\nC++: vtkDummyGPUInfoList *SafeDownCast(vtkObject* o)\n\n"},
  {"Probe", PyvtkDummyGPUInfoList_Probe, METH_VARARGS,
   "V.Probe()\nC++: virtual void Probe()\n\nBuild the list of vtkInfoGPU if not done yet.\n\\post probed: IsProbed()\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDummyGPUInfoList_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkDummyGPUInfoList", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDummyGPUInfoList_StaticNew()
{
  return vtkDummyGPUInfoList::New();
}

PyObject *PyvtkDummyGPUInfoList_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDummyGPUInfoList_Type, PyvtkDummyGPUInfoList_Methods,
    "vtkDummyGPUInfoList",
    PyvtkDummyGPUInfoList_Doc(), &PyvtkDummyGPUInfoList_StaticNew);

  PyTypeObject *pytype = &PyvtkDummyGPUInfoList_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGPUInfoList_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDummyGPUInfoList_Doc()
{
  static const char *docstring[] = {
    "vtkDummyGPUInfoList - Do thing during Probe()\n\n",
    "Superclass: vtkGPUInfoList\n\n",
    "vtkDummyGPUInfoList implements Probe() by just setting the count of\nGPUs to be zero. Useful when an OS specific implementation is not\navailable.\n@sa\nvtkGPUInfo vtkGPUInfoList\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDummyGPUInfoList(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDummyGPUInfoList_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDummyGPUInfoList", o) != 0)
  {
    Py_DECREF(o);
  }

}

