// python wrapper for vtkDynamic2DLabelMapper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDynamic2DLabelMapper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDynamic2DLabelMapper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDynamic2DLabelMapper_ClassNew(); }

#ifndef DECLARED_PyvtkLabeledDataMapper_ClassNew
extern "C" { PyObject *PyvtkLabeledDataMapper_ClassNew(); }
#define DECLARED_PyvtkLabeledDataMapper_ClassNew
#endif

static const char **PyvtkDynamic2DLabelMapper_Doc();


static PyObject *
PyvtkDynamic2DLabelMapper_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkDynamic2DLabelMapper::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDynamic2DLabelMapper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDynamic2DLabelMapper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDynamic2DLabelMapper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkDynamic2DLabelMapper *tempr = vtkDynamic2DLabelMapper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_SetPriorityArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPriorityArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPriorityArrayName(temp0);
    }
    else
    {
      op->vtkDynamic2DLabelMapper::SetPriorityArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_SetReversePriority(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReversePriority");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetReversePriority(temp0);
    }
    else
    {
      op->vtkDynamic2DLabelMapper::SetReversePriority(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_GetReversePriority(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReversePriority");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetReversePriority() :
      op->vtkDynamic2DLabelMapper::GetReversePriority());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_ReversePriorityOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReversePriorityOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReversePriorityOn();
    }
    else
    {
      op->vtkDynamic2DLabelMapper::ReversePriorityOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_ReversePriorityOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReversePriorityOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReversePriorityOff();
    }
    else
    {
      op->vtkDynamic2DLabelMapper::ReversePriorityOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_SetLabelHeightPadding(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabelHeightPadding");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLabelHeightPadding(temp0);
    }
    else
    {
      op->vtkDynamic2DLabelMapper::SetLabelHeightPadding(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_GetLabelHeightPadding(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLabelHeightPadding");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetLabelHeightPadding() :
      op->vtkDynamic2DLabelMapper::GetLabelHeightPadding());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_SetLabelWidthPadding(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabelWidthPadding");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLabelWidthPadding(temp0);
    }
    else
    {
      op->vtkDynamic2DLabelMapper::SetLabelWidthPadding(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_GetLabelWidthPadding(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLabelWidthPadding");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetLabelWidthPadding() :
      op->vtkDynamic2DLabelMapper::GetLabelWidthPadding());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_RenderOpaqueGeometry(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RenderOpaqueGeometry");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  vtkViewport *temp0 = NULL;
  vtkActor2D *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkViewport") &&
      ap.GetVTKObject(temp1, "vtkActor2D"))
  {
    if (ap.IsBound())
    {
      op->RenderOpaqueGeometry(temp0, temp1);
    }
    else
    {
      op->vtkDynamic2DLabelMapper::RenderOpaqueGeometry(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDynamic2DLabelMapper_RenderOverlay(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RenderOverlay");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDynamic2DLabelMapper *op = static_cast<vtkDynamic2DLabelMapper *>(vp);

  vtkViewport *temp0 = NULL;
  vtkActor2D *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkViewport") &&
      ap.GetVTKObject(temp1, "vtkActor2D"))
  {
    if (ap.IsBound())
    {
      op->RenderOverlay(temp0, temp1);
    }
    else
    {
      op->vtkDynamic2DLabelMapper::RenderOverlay(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkDynamic2DLabelMapper_Methods[] = {
  {"GetClassName", PyvtkDynamic2DLabelMapper_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nInstantiate object with %%-#6.3g label format. By default, point\nids are labeled.\n"},
  {"IsA", PyvtkDynamic2DLabelMapper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nInstantiate object with %%-#6.3g label format. By default, point\nids are labeled.\n"},
  {"NewInstance", PyvtkDynamic2DLabelMapper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDynamic2DLabelMapper\nC++: vtkDynamic2DLabelMapper *NewInstance()\n\nInstantiate object with %%-#6.3g label format. By default, point\nids are labeled.\n"},
  {"SafeDownCast", PyvtkDynamic2DLabelMapper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkDynamic2DLabelMapper\nC++: vtkDynamic2DLabelMapper *SafeDownCast(vtkObject* o)\n\nInstantiate object with %%-#6.3g label format. By default, point\nids are labeled.\n"},
  {"SetPriorityArrayName", PyvtkDynamic2DLabelMapper_SetPriorityArrayName, METH_VARARGS,
   "V.SetPriorityArrayName(string)\nC++: void SetPriorityArrayName(const char *name)\n\nSet the points array name to use to give priority to labels.\nDefaults to \"priority\".\n"},
  {"SetReversePriority", PyvtkDynamic2DLabelMapper_SetReversePriority, METH_VARARGS,
   "V.SetReversePriority(bool)\nC++: void SetReversePriority(bool a)\n\nWhether to reverse the priority order (i.e. low values have high\npriority). Default is off.\n"},
  {"GetReversePriority", PyvtkDynamic2DLabelMapper_GetReversePriority, METH_VARARGS,
   "V.GetReversePriority() -> bool\nC++: bool GetReversePriority()\n\nWhether to reverse the priority order (i.e. low values have high\npriority). Default is off.\n"},
  {"ReversePriorityOn", PyvtkDynamic2DLabelMapper_ReversePriorityOn, METH_VARARGS,
   "V.ReversePriorityOn()\nC++: void ReversePriorityOn()\n\nWhether to reverse the priority order (i.e. low values have high\npriority). Default is off.\n"},
  {"ReversePriorityOff", PyvtkDynamic2DLabelMapper_ReversePriorityOff, METH_VARARGS,
   "V.ReversePriorityOff()\nC++: void ReversePriorityOff()\n\nWhether to reverse the priority order (i.e. low values have high\npriority). Default is off.\n"},
  {"SetLabelHeightPadding", PyvtkDynamic2DLabelMapper_SetLabelHeightPadding, METH_VARARGS,
   "V.SetLabelHeightPadding(float)\nC++: void SetLabelHeightPadding(float a)\n\nSet the label height padding as a percentage. The percentage is a\npercentage of your label height. Default is 50%.\n"},
  {"GetLabelHeightPadding", PyvtkDynamic2DLabelMapper_GetLabelHeightPadding, METH_VARARGS,
   "V.GetLabelHeightPadding() -> float\nC++: float GetLabelHeightPadding()\n\nSet the label height padding as a percentage. The percentage is a\npercentage of your label height. Default is 50%.\n"},
  {"SetLabelWidthPadding", PyvtkDynamic2DLabelMapper_SetLabelWidthPadding, METH_VARARGS,
   "V.SetLabelWidthPadding(float)\nC++: void SetLabelWidthPadding(float a)\n\nSet the label width padding as a percentage. The percentage is a\npercentage of your label ^height^ (yes, not a typo). Default is\n50%.\n"},
  {"GetLabelWidthPadding", PyvtkDynamic2DLabelMapper_GetLabelWidthPadding, METH_VARARGS,
   "V.GetLabelWidthPadding() -> float\nC++: float GetLabelWidthPadding()\n\nSet the label width padding as a percentage. The percentage is a\npercentage of your label ^height^ (yes, not a typo). Default is\n50%.\n"},
  {"RenderOpaqueGeometry", PyvtkDynamic2DLabelMapper_RenderOpaqueGeometry, METH_VARARGS,
   "V.RenderOpaqueGeometry(vtkViewport, vtkActor2D)\nC++: void RenderOpaqueGeometry(vtkViewport *viewport,\n    vtkActor2D *actor)\n\nDraw non-overlapping labels to the screen.\n"},
  {"RenderOverlay", PyvtkDynamic2DLabelMapper_RenderOverlay, METH_VARARGS,
   "V.RenderOverlay(vtkViewport, vtkActor2D)\nC++: void RenderOverlay(vtkViewport *viewport, vtkActor2D *actor)\n\nDraw non-overlapping labels to the screen.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDynamic2DLabelMapper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingLabelPython.vtkDynamic2DLabelMapper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDynamic2DLabelMapper_StaticNew()
{
  return vtkDynamic2DLabelMapper::New();
}

PyObject *PyvtkDynamic2DLabelMapper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDynamic2DLabelMapper_Type, PyvtkDynamic2DLabelMapper_Methods,
    "vtkDynamic2DLabelMapper",
    PyvtkDynamic2DLabelMapper_Doc(), &PyvtkDynamic2DLabelMapper_StaticNew);

  PyTypeObject *pytype = &PyvtkDynamic2DLabelMapper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkLabeledDataMapper_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDynamic2DLabelMapper_Doc()
{
  static const char *docstring[] = {
    "vtkDynamic2DLabelMapper - draw text labels at 2D dataset points\n\n",
    "Superclass: vtkLabeledDataMapper\n\n",
    "vtkDynamic2DLabelMapper is a mapper that renders text at dataset\npoints such that the labels do not overlap. Various items can be\nlabeled including point ids, scalars, vectors, normals, texture\ncoordinates, tensors, and field data components. This mapper assumes\nthat the points are located on the x-y plane and that the camera\nremains perpendicular to that plane with a y-up axis (this can be\nconstr",
    "ained using vtkImageInteractor). On the first render, the\nmapper computes the visiblility of all labels at all scales, and\nqueries this information on successive renders. This causes the first\nrender to be much slower. The visibility algorithm is a greedy\napproach based on the point id, so the label for a point will be\ndrawn unless the label for a point with lower id overlaps it.\n\n@warning\nUse thi",
    "s filter in combination with vtkSelectVisiblePoints if you\nwant to label only points that are visible. If you want to label\ncells rather than points, use the filter vtkCellCenters to generate\npoints at the center of the cells. Also, you can use the class\nvtkIdFilter to generate ids as scalars or field data, which can then\nbe labeled.\n\n@sa\nvtkLabeledDataMapper\n\n@par Thanks: This algorithm was devel",
    "oped in the paper Ken Been and\nChee Yap. Dynamic Map Labeling. IEEE Transactions on Visualization\nand Computer Graphics, Vol. 12, No. 5, 2006. pp. 773-780.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDynamic2DLabelMapper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDynamic2DLabelMapper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDynamic2DLabelMapper", o) != 0)
  {
    Py_DECREF(o);
  }

}

