// python wrapper for vtkEllipsoidalGaussianKernel
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkEllipsoidalGaussianKernel.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkEllipsoidalGaussianKernel(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkEllipsoidalGaussianKernel_ClassNew(); }

#ifndef DECLARED_PyvtkGeneralizedKernel_ClassNew
extern "C" { PyObject *PyvtkGeneralizedKernel_ClassNew(); }
#define DECLARED_PyvtkGeneralizedKernel_ClassNew
#endif

static const char **PyvtkEllipsoidalGaussianKernel_Doc();


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkEllipsoidalGaussianKernel::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkEllipsoidalGaussianKernel::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkEllipsoidalGaussianKernel *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkEllipsoidalGaussianKernel::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkEllipsoidalGaussianKernel *tempr = vtkEllipsoidalGaussianKernel::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  vtkAbstractPointLocator *temp0 = NULL;
  vtkDataSet *temp1 = NULL;
  vtkPointData *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkAbstractPointLocator") &&
      ap.GetVTKObject(temp1, "vtkDataSet") &&
      ap.GetVTKObject(temp2, "vtkPointData"))
  {
    if (ap.IsBound())
    {
      op->Initialize(temp0, temp1, temp2);
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::Initialize(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_ComputeWeights_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ComputeWeights");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  const int size0 = 3;
  double temp0[3];
  double save0[3];
  vtkIdList *temp1 = NULL;
  vtkDoubleArray *temp2 = NULL;
  vtkDoubleArray *temp3 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetArray(temp0, size0) &&
      ap.GetVTKObject(temp1, "vtkIdList") &&
      ap.GetVTKObject(temp2, "vtkDoubleArray") &&
      ap.GetVTKObject(temp3, "vtkDoubleArray"))
  {
    ap.SaveArray(temp0, save0, size0);

    vtkIdType tempr = (ap.IsBound() ?
      op->ComputeWeights(temp0, temp1, temp2, temp3) :
      op->vtkEllipsoidalGaussianKernel::ComputeWeights(temp0, temp1, temp2, temp3));

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkEllipsoidalGaussianKernel_ComputeWeights_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ComputeWeights");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  const int size0 = 3;
  double temp0[3];
  double save0[3];
  vtkIdList *temp1 = NULL;
  vtkDoubleArray *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetVTKObject(temp1, "vtkIdList") &&
      ap.GetVTKObject(temp2, "vtkDoubleArray"))
  {
    ap.SaveArray(temp0, save0, size0);

    vtkIdType tempr = (ap.IsBound() ?
      op->ComputeWeights(temp0, temp1, temp2) :
      op->vtkEllipsoidalGaussianKernel::ComputeWeights(temp0, temp1, temp2));

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkEllipsoidalGaussianKernel_ComputeWeights(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 4:
      return PyvtkEllipsoidalGaussianKernel_ComputeWeights_s1(self, args);
    case 3:
      return PyvtkEllipsoidalGaussianKernel_ComputeWeights_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "ComputeWeights");
  return NULL;
}



static PyObject *
PyvtkEllipsoidalGaussianKernel_SetUseNormals(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseNormals");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseNormals(temp0);
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::SetUseNormals(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetUseNormals(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseNormals");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseNormals() :
      op->vtkEllipsoidalGaussianKernel::GetUseNormals());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_UseNormalsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseNormalsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseNormalsOn();
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::UseNormalsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_UseNormalsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseNormalsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseNormalsOff();
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::UseNormalsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_SetNormalsArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNormalsArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  vtkStdString temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNormalsArrayName(temp0);
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::SetNormalsArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetNormalsArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNormalsArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetNormalsArrayName() :
      op->vtkEllipsoidalGaussianKernel::GetNormalsArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_SetUseScalars(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseScalars");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseScalars(temp0);
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::SetUseScalars(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetUseScalars(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseScalars");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseScalars() :
      op->vtkEllipsoidalGaussianKernel::GetUseScalars());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_UseScalarsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseScalarsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseScalarsOn();
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::UseScalarsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_UseScalarsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseScalarsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseScalarsOff();
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::UseScalarsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_SetScalarsArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarsArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  vtkStdString temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScalarsArrayName(temp0);
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::SetScalarsArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetScalarsArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScalarsArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetScalarsArrayName() :
      op->vtkEllipsoidalGaussianKernel::GetScalarsArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_SetScaleFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScaleFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScaleFactor(temp0);
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::SetScaleFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetScaleFactorMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScaleFactorMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetScaleFactorMinValue() :
      op->vtkEllipsoidalGaussianKernel::GetScaleFactorMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetScaleFactorMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScaleFactorMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetScaleFactorMaxValue() :
      op->vtkEllipsoidalGaussianKernel::GetScaleFactorMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetScaleFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScaleFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetScaleFactor() :
      op->vtkEllipsoidalGaussianKernel::GetScaleFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_SetSharpness(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSharpness");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSharpness(temp0);
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::SetSharpness(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetSharpnessMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSharpnessMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSharpnessMinValue() :
      op->vtkEllipsoidalGaussianKernel::GetSharpnessMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetSharpnessMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSharpnessMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSharpnessMaxValue() :
      op->vtkEllipsoidalGaussianKernel::GetSharpnessMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetSharpness(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSharpness");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSharpness() :
      op->vtkEllipsoidalGaussianKernel::GetSharpness());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_SetEccentricity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEccentricity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEccentricity(temp0);
    }
    else
    {
      op->vtkEllipsoidalGaussianKernel::SetEccentricity(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetEccentricityMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEccentricityMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetEccentricityMinValue() :
      op->vtkEllipsoidalGaussianKernel::GetEccentricityMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetEccentricityMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEccentricityMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetEccentricityMaxValue() :
      op->vtkEllipsoidalGaussianKernel::GetEccentricityMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkEllipsoidalGaussianKernel_GetEccentricity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEccentricity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkEllipsoidalGaussianKernel *op = static_cast<vtkEllipsoidalGaussianKernel *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetEccentricity() :
      op->vtkEllipsoidalGaussianKernel::GetEccentricity());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkEllipsoidalGaussianKernel_Methods[] = {
  {"GetClassName", PyvtkEllipsoidalGaussianKernel_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nStandard methods for instantiation, obtaining type information,\nand printing.\n"},
  {"IsA", PyvtkEllipsoidalGaussianKernel_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nStandard methods for instantiation, obtaining type information,\nand printing.\n"},
  {"NewInstance", PyvtkEllipsoidalGaussianKernel_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkEllipsoidalGaussianKernel\nC++: vtkEllipsoidalGaussianKernel *NewInstance()\n\nStandard methods for instantiation, obtaining type information,\nand printing.\n"},
  {"SafeDownCast", PyvtkEllipsoidalGaussianKernel_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkEllipsoidalGaussianKernel\nC++: vtkEllipsoidalGaussianKernel *SafeDownCast(vtkObject* o)\n\nStandard methods for instantiation, obtaining type information,\nand printing.\n"},
  {"Initialize", PyvtkEllipsoidalGaussianKernel_Initialize, METH_VARARGS,
   "V.Initialize(vtkAbstractPointLocator, vtkDataSet, vtkPointData)\nC++: virtual void Initialize(vtkAbstractPointLocator *loc,\n    vtkDataSet *ds, vtkPointData *pd)\n\nInitialize the kernel. Overload the superclass to set up scalars\nand vectors.\n"},
  {"ComputeWeights", PyvtkEllipsoidalGaussianKernel_ComputeWeights, METH_VARARGS,
   "V.ComputeWeights([float, float, float], vtkIdList, vtkDoubleArray,\n     vtkDoubleArray) -> int\nC++: virtual vtkIdType ComputeWeights(double x[3],\n    vtkIdList *pIds, vtkDoubleArray *prob,\n    vtkDoubleArray *weights)\nV.ComputeWeights([float, float, float], vtkIdList, vtkDoubleArray)\n     -> int\nC++: virtual vtkIdType ComputeWeights(double x[3],\n    vtkIdList *pIds, vtkDoubleArray *weights)\n\nGiven a point x, a list of basis points pIds, and a probability\nweighting function prob, compute interpolation weights associated\nwith these basis points.  Note that basis points list pIds, the\nprobability weighting prob, and the weights array are provided by\nthe caller of the method, and may be dynamically resized as\nnecessary. The method returns the number of weights (pIds may be\nresized in some cases). Typically this method is called after\nComputeBasis(), although advanced users can invoke\nComputeWeights() and provide the interpolation basis points pIds\ndirectly. The probably weighting prob are numbers 0<=prob<=1\nwhich are multiplied against the interpolation weights before\nnormalization. They are estimates of local confidence of weights.\nThe prob may be NULL in which all probabilities are considered\n=1.\n"},
  {"SetUseNormals", PyvtkEllipsoidalGaussianKernel_SetUseNormals, METH_VARARGS,
   "V.SetUseNormals(bool)\nC++: void SetUseNormals(bool a)\n\nSpecify whether vector values should be used to affect the shape\nof the Gaussian distribution. By default this is on.\n"},
  {"GetUseNormals", PyvtkEllipsoidalGaussianKernel_GetUseNormals, METH_VARARGS,
   "V.GetUseNormals() -> bool\nC++: bool GetUseNormals()\n\nSpecify whether vector values should be used to affect the shape\nof the Gaussian distribution. By default this is on.\n"},
  {"UseNormalsOn", PyvtkEllipsoidalGaussianKernel_UseNormalsOn, METH_VARARGS,
   "V.UseNormalsOn()\nC++: void UseNormalsOn()\n\nSpecify whether vector values should be used to affect the shape\nof the Gaussian distribution. By default this is on.\n"},
  {"UseNormalsOff", PyvtkEllipsoidalGaussianKernel_UseNormalsOff, METH_VARARGS,
   "V.UseNormalsOff()\nC++: void UseNormalsOff()\n\nSpecify whether vector values should be used to affect the shape\nof the Gaussian distribution. By default this is on.\n"},
  {"SetNormalsArrayName", PyvtkEllipsoidalGaussianKernel_SetNormalsArrayName, METH_VARARGS,
   "V.SetNormalsArrayName(string)\nC++: void SetNormalsArrayName(vtkStdString a)\n\nSpecify the normals array name. Used to orient the ellipsoid.\nNote that by default the input normals are used (i.e. the input\nto vtkPointInterpolator). If no input normals are available, then\nthe named NormalsArrayName is used.\n"},
  {"GetNormalsArrayName", PyvtkEllipsoidalGaussianKernel_GetNormalsArrayName, METH_VARARGS,
   "V.GetNormalsArrayName() -> string\nC++: vtkStdString GetNormalsArrayName()\n\nSpecify the normals array name. Used to orient the ellipsoid.\nNote that by default the input normals are used (i.e. the input\nto vtkPointInterpolator). If no input normals are available, then\nthe named NormalsArrayName is used.\n"},
  {"SetUseScalars", PyvtkEllipsoidalGaussianKernel_SetUseScalars, METH_VARARGS,
   "V.SetUseScalars(bool)\nC++: void SetUseScalars(bool a)\n\nSpecify whether scalar values should be used to scale the\nweights. By default this is off.\n"},
  {"GetUseScalars", PyvtkEllipsoidalGaussianKernel_GetUseScalars, METH_VARARGS,
   "V.GetUseScalars() -> bool\nC++: bool GetUseScalars()\n\nSpecify whether scalar values should be used to scale the\nweights. By default this is off.\n"},
  {"UseScalarsOn", PyvtkEllipsoidalGaussianKernel_UseScalarsOn, METH_VARARGS,
   "V.UseScalarsOn()\nC++: void UseScalarsOn()\n\nSpecify whether scalar values should be used to scale the\nweights. By default this is off.\n"},
  {"UseScalarsOff", PyvtkEllipsoidalGaussianKernel_UseScalarsOff, METH_VARARGS,
   "V.UseScalarsOff()\nC++: void UseScalarsOff()\n\nSpecify whether scalar values should be used to scale the\nweights. By default this is off.\n"},
  {"SetScalarsArrayName", PyvtkEllipsoidalGaussianKernel_SetScalarsArrayName, METH_VARARGS,
   "V.SetScalarsArrayName(string)\nC++: void SetScalarsArrayName(vtkStdString a)\n\nSpecify the scalars array name. Used to scale the ellipsoid. Note\nthat by default the input scalars are used (i.e. the input to\nvtkPointInterpolator). If no input scalars are available, then\nthe named ScalarsArrayName is used.\n"},
  {"GetScalarsArrayName", PyvtkEllipsoidalGaussianKernel_GetScalarsArrayName, METH_VARARGS,
   "V.GetScalarsArrayName() -> string\nC++: vtkStdString GetScalarsArrayName()\n\nSpecify the scalars array name. Used to scale the ellipsoid. Note\nthat by default the input scalars are used (i.e. the input to\nvtkPointInterpolator). If no input scalars are available, then\nthe named ScalarsArrayName is used.\n"},
  {"SetScaleFactor", PyvtkEllipsoidalGaussianKernel_SetScaleFactor, METH_VARARGS,
   "V.SetScaleFactor(float)\nC++: void SetScaleFactor(double)\n\nMultiply the Gaussian splat distribution by this value. If\nUseScalars is on and a scalar aray is provided, then the scalar\nvalue will be multiplied by the ScaleFactor times the Gaussian\nfunction.\n"},
  {"GetScaleFactorMinValue", PyvtkEllipsoidalGaussianKernel_GetScaleFactorMinValue, METH_VARARGS,
   "V.GetScaleFactorMinValue() -> float\nC++: double GetScaleFactorMinValue()\n\nMultiply the Gaussian splat distribution by this value. If\nUseScalars is on and a scalar aray is provided, then the scalar\nvalue will be multiplied by the ScaleFactor times the Gaussian\nfunction.\n"},
  {"GetScaleFactorMaxValue", PyvtkEllipsoidalGaussianKernel_GetScaleFactorMaxValue, METH_VARARGS,
   "V.GetScaleFactorMaxValue() -> float\nC++: double GetScaleFactorMaxValue()\n\nMultiply the Gaussian splat distribution by this value. If\nUseScalars is on and a scalar aray is provided, then the scalar\nvalue will be multiplied by the ScaleFactor times the Gaussian\nfunction.\n"},
  {"GetScaleFactor", PyvtkEllipsoidalGaussianKernel_GetScaleFactor, METH_VARARGS,
   "V.GetScaleFactor() -> float\nC++: double GetScaleFactor()\n\nMultiply the Gaussian splat distribution by this value. If\nUseScalars is on and a scalar aray is provided, then the scalar\nvalue will be multiplied by the ScaleFactor times the Gaussian\nfunction.\n"},
  {"SetSharpness", PyvtkEllipsoidalGaussianKernel_SetSharpness, METH_VARARGS,
   "V.SetSharpness(float)\nC++: void SetSharpness(double)\n\nSet / Get the sharpness (i.e., falloff) of the Gaussian. By\ndefault Sharpness=2. As the sharpness increases the effects of\ndistant points are reduced.\n"},
  {"GetSharpnessMinValue", PyvtkEllipsoidalGaussianKernel_GetSharpnessMinValue, METH_VARARGS,
   "V.GetSharpnessMinValue() -> float\nC++: double GetSharpnessMinValue()\n\nSet / Get the sharpness (i.e., falloff) of the Gaussian. By\ndefault Sharpness=2. As the sharpness increases the effects of\ndistant points are reduced.\n"},
  {"GetSharpnessMaxValue", PyvtkEllipsoidalGaussianKernel_GetSharpnessMaxValue, METH_VARARGS,
   "V.GetSharpnessMaxValue() -> float\nC++: double GetSharpnessMaxValue()\n\nSet / Get the sharpness (i.e., falloff) of the Gaussian. By\ndefault Sharpness=2. As the sharpness increases the effects of\ndistant points are reduced.\n"},
  {"GetSharpness", PyvtkEllipsoidalGaussianKernel_GetSharpness, METH_VARARGS,
   "V.GetSharpness() -> float\nC++: double GetSharpness()\n\nSet / Get the sharpness (i.e., falloff) of the Gaussian. By\ndefault Sharpness=2. As the sharpness increases the effects of\ndistant points are reduced.\n"},
  {"SetEccentricity", PyvtkEllipsoidalGaussianKernel_SetEccentricity, METH_VARARGS,
   "V.SetEccentricity(float)\nC++: void SetEccentricity(double)\n\nSet / Get the eccentricity of the ellipsoidal Gaussian. A\nvalue=1.0 produces a spherical distribution. Values < 1 produce a\nneedle like distribution (in the direction of the normal); values\n> 1 produce a pancake like distribution (orthogonal to the\nnormal).\n"},
  {"GetEccentricityMinValue", PyvtkEllipsoidalGaussianKernel_GetEccentricityMinValue, METH_VARARGS,
   "V.GetEccentricityMinValue() -> float\nC++: double GetEccentricityMinValue()\n\nSet / Get the eccentricity of the ellipsoidal Gaussian. A\nvalue=1.0 produces a spherical distribution. Values < 1 produce a\nneedle like distribution (in the direction of the normal); values\n> 1 produce a pancake like distribution (orthogonal to the\nnormal).\n"},
  {"GetEccentricityMaxValue", PyvtkEllipsoidalGaussianKernel_GetEccentricityMaxValue, METH_VARARGS,
   "V.GetEccentricityMaxValue() -> float\nC++: double GetEccentricityMaxValue()\n\nSet / Get the eccentricity of the ellipsoidal Gaussian. A\nvalue=1.0 produces a spherical distribution. Values < 1 produce a\nneedle like distribution (in the direction of the normal); values\n> 1 produce a pancake like distribution (orthogonal to the\nnormal).\n"},
  {"GetEccentricity", PyvtkEllipsoidalGaussianKernel_GetEccentricity, METH_VARARGS,
   "V.GetEccentricity() -> float\nC++: double GetEccentricity()\n\nSet / Get the eccentricity of the ellipsoidal Gaussian. A\nvalue=1.0 produces a spherical distribution. Values < 1 produce a\nneedle like distribution (in the direction of the normal); values\n> 1 produce a pancake like distribution (orthogonal to the\nnormal).\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkEllipsoidalGaussianKernel_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersPointsPython.vtkEllipsoidalGaussianKernel", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkEllipsoidalGaussianKernel_StaticNew()
{
  return vtkEllipsoidalGaussianKernel::New();
}

PyObject *PyvtkEllipsoidalGaussianKernel_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkEllipsoidalGaussianKernel_Type, PyvtkEllipsoidalGaussianKernel_Methods,
    "vtkEllipsoidalGaussianKernel",
    PyvtkEllipsoidalGaussianKernel_Doc(), &PyvtkEllipsoidalGaussianKernel_StaticNew);

  PyTypeObject *pytype = &PyvtkEllipsoidalGaussianKernel_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGeneralizedKernel_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkEllipsoidalGaussianKernel_Doc()
{
  static const char *docstring[] = {
    "vtkEllipsoidalGaussianKernel - an ellipsoidal Gaussian interpolation\nkernel\n\n",
    "Superclass: vtkGeneralizedKernel\n\n",
    "vtkEllipsoidalGaussianKernel is an interpolation kernel that returns\nthe weights for all points found in the ellipsoid defined by radius R\nin combination with local data (normals and/or scalars). For example,\n\"pancake\" weightings (the local normal parallel to the minimum\nellisoidal axis); or \"needle\" weightings (the local normal parallel\nto the maximum ellipsoidal axis) are possible. (Note that sp",
    "herical\nGaussian weightings are more efficiently computed using\nvtkGaussianKernel.)\n\nThe ellipsoidal Gaussian can be described by:\n\n\n    W(x) = S * exp( -( Sharpness^2 * ((rxy/E)**2 + z**2)/R**2) )\n\nwhere S is the local scalar value; E is a user-defined eccentricity\nfactor that controls the elliptical shape of the splat; z is the\ndistance of the current voxel sample point along the local normal N;",
    "\nand rxy is the distance to neigbor point x in the direction\nprependicular to N.\n\n@warning\nThe weights are normalized so that SUM(Wi) = 1. If a neighbor point p\nprecisely lies on the point to be interpolated, then the interpolated\npoint takes on the values associated with p.\n\n@sa\nvtkPointInterpolator vtkInterpolationKernel vtkGeneralizedKernel\nvtkGaussianKernel vtkVoronoiKernel vtkSPHKernel vtkShe",
    "pardKernel\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkEllipsoidalGaussianKernel(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkEllipsoidalGaussianKernel_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkEllipsoidalGaussianKernel", o) != 0)
  {
    Py_DECREF(o);
  }

}

