// python wrapper for vtkFieldDataSerializer
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMultiProcessStream.h"
#include "vtkFieldDataSerializer.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkFieldDataSerializer(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkFieldDataSerializer_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkFieldDataSerializer_Doc();


static PyObject *
PyvtkFieldDataSerializer_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFieldDataSerializer *op = static_cast<vtkFieldDataSerializer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkFieldDataSerializer::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFieldDataSerializer_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFieldDataSerializer *op = static_cast<vtkFieldDataSerializer *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkFieldDataSerializer::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFieldDataSerializer_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFieldDataSerializer *op = static_cast<vtkFieldDataSerializer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkFieldDataSerializer *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkFieldDataSerializer::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkFieldDataSerializer_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkFieldDataSerializer *tempr = vtkFieldDataSerializer::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFieldDataSerializer_SerializeMetaData(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SerializeMetaData");

  vtkFieldData *temp0 = NULL;
  vtkMultiProcessStream *temp1 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkFieldData") &&
      ap.GetSpecialObject(temp1, "vtkMultiProcessStream"))
  {
    vtkFieldDataSerializer::SerializeMetaData(temp0, *temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkFieldDataSerializer_DeserializeMetaData(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "DeserializeMetaData");

  vtkMultiProcessStream *temp0 = NULL;
  vtkStringArray *temp1 = NULL;
  vtkIntArray *temp2 = NULL;
  vtkIntArray *temp3 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetSpecialObject(temp0, "vtkMultiProcessStream") &&
      ap.GetVTKObject(temp1, "vtkStringArray") &&
      ap.GetVTKObject(temp2, "vtkIntArray") &&
      ap.GetVTKObject(temp3, "vtkIntArray"))
  {
    vtkFieldDataSerializer::DeserializeMetaData(*temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkFieldDataSerializer_Serialize(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Serialize");

  vtkFieldData *temp0 = NULL;
  vtkMultiProcessStream *temp1 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkFieldData") &&
      ap.GetSpecialObject(temp1, "vtkMultiProcessStream"))
  {
    vtkFieldDataSerializer::Serialize(temp0, *temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkFieldDataSerializer_SerializeTuples(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SerializeTuples");

  vtkIdList *temp0 = NULL;
  vtkFieldData *temp1 = NULL;
  vtkMultiProcessStream *temp2 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkIdList") &&
      ap.GetVTKObject(temp1, "vtkFieldData") &&
      ap.GetSpecialObject(temp2, "vtkMultiProcessStream"))
  {
    vtkFieldDataSerializer::SerializeTuples(temp0, temp1, *temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkFieldDataSerializer_SerializeSubExtent(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SerializeSubExtent");

  const int size0 = 6;
  int temp0[6];
  int save0[6];
  const int size1 = 6;
  int temp1[6];
  int save1[6];
  vtkFieldData *temp2 = NULL;
  vtkMultiProcessStream *temp3 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetVTKObject(temp2, "vtkFieldData") &&
      ap.GetSpecialObject(temp3, "vtkMultiProcessStream"))
  {
    ap.SaveArray(temp0, save0, size0);
    ap.SaveArray(temp1, save1, size1);

    vtkFieldDataSerializer::SerializeSubExtent(temp0, temp1, temp2, *temp3);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkFieldDataSerializer_DeSerializeToSubExtent(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "DeSerializeToSubExtent");

  const int size0 = 6;
  int temp0[6];
  int save0[6];
  const int size1 = 6;
  int temp1[6];
  int save1[6];
  vtkFieldData *temp2 = NULL;
  vtkMultiProcessStream *temp3 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetVTKObject(temp2, "vtkFieldData") &&
      ap.GetSpecialObject(temp3, "vtkMultiProcessStream"))
  {
    ap.SaveArray(temp0, save0, size0);
    ap.SaveArray(temp1, save1, size1);

    vtkFieldDataSerializer::DeSerializeToSubExtent(temp0, temp1, temp2, *temp3);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkFieldDataSerializer_Deserialize(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Deserialize");

  vtkMultiProcessStream *temp0 = NULL;
  vtkFieldData *temp1 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, "vtkMultiProcessStream") &&
      ap.GetVTKObject(temp1, "vtkFieldData"))
  {
    vtkFieldDataSerializer::Deserialize(*temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkFieldDataSerializer_Methods[] = {
  {"GetClassName", PyvtkFieldDataSerializer_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkFieldDataSerializer_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkFieldDataSerializer_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkFieldDataSerializer\nC++: vtkFieldDataSerializer *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkFieldDataSerializer_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkFieldDataSerializer\nC++: vtkFieldDataSerializer *SafeDownCast(vtkObject* o)\n\n"},
  {"SerializeMetaData", PyvtkFieldDataSerializer_SerializeMetaData, METH_VARARGS,
   "V.SerializeMetaData(vtkFieldData, vtkMultiProcessStream)\nC++: static void SerializeMetaData(vtkFieldData *fieldData,\n    vtkMultiProcessStream &bytestream)\n\nSerializes the metadata of the given field data instance, i.e.,\nthe number of arrays, the name of each array and their\ndimensions.\n"},
  {"DeserializeMetaData", PyvtkFieldDataSerializer_DeserializeMetaData, METH_VARARGS,
   "V.DeserializeMetaData(vtkMultiProcessStream, vtkStringArray,\n    vtkIntArray, vtkIntArray)\nC++: static void DeserializeMetaData(\n    vtkMultiProcessStream &bytestream, vtkStringArray *names,\n    vtkIntArray *datatypes, vtkIntArray *dimensions)\n\nGiven the serialized field metadata in a bytestream, this method\nextracts the name, datatype and dimensions of each array. The\nmetadata is deserialized on user-supplied, pre-allocated data\nstructures. (1) names -- an array of strings wherein, each\nelement, names[i], corresponds to the name of array i. (2)\ndatatypes -- an array of ints where each element corresponds to\nthe actual primitive type of each array, e.g.,VTK_DOUBLE,VTK_INT,\netc. (3) dimensions -- a 2-component array of  integers where the\nfirst component corresponds to the number of tuples of and the\nsecond component corresponds to the number components of array i.\n"},
  {"Serialize", PyvtkFieldDataSerializer_Serialize, METH_VARARGS,
   "V.Serialize(vtkFieldData, vtkMultiProcessStream)\nC++: static void Serialize(vtkFieldData *fieldData,\n    vtkMultiProcessStream &bytestream)\n\nSerializes the given field data (all the field data) into a\nbytestream.\n"},
  {"SerializeTuples", PyvtkFieldDataSerializer_SerializeTuples, METH_VARARGS,
   "V.SerializeTuples(vtkIdList, vtkFieldData, vtkMultiProcessStream)\nC++: static void SerializeTuples(vtkIdList *tupleIds,\n    vtkFieldData *fieldData, vtkMultiProcessStream &bytestream)\n\nSerializes the selected tuples from the the field data in a\nbyte-stream.\n"},
  {"SerializeSubExtent", PyvtkFieldDataSerializer_SerializeSubExtent, METH_VARARGS,
   "V.SerializeSubExtent([int, int, int, int, int, int], [int, int,\n    int, int, int, int], vtkFieldData, vtkMultiProcessStream)\nC++: static void SerializeSubExtent(int subext[6],\n    int gridExtent[6], vtkFieldData *fieldData,\n    vtkMultiProcessStream &bytestream)\n\nSerializes the given sub-extent of field data of a structured\ngrid in a byte-stream. The field data can be either cell-centered\nor node-centered depending on what subext and gridExtent actually\nrepresents.\n"},
  {"DeSerializeToSubExtent", PyvtkFieldDataSerializer_DeSerializeToSubExtent, METH_VARARGS,
   "V.DeSerializeToSubExtent([int, int, int, int, int, int], [int,\n    int, int, int, int, int], vtkFieldData, vtkMultiProcessStream)\nC++: static void DeSerializeToSubExtent(int subext[6],\n    int gridExtent[6], vtkFieldData *fieldData,\n    vtkMultiProcessStream &bytestream)\n\nDeserializes the field data from a bytestream to a the given\nsub-extent. The field data can be either cell-centered or\nnode-centered depending on what subext and gridExtent actually\nrepresent.\n"},
  {"Deserialize", PyvtkFieldDataSerializer_Deserialize, METH_VARARGS,
   "V.Deserialize(vtkMultiProcessStream, vtkFieldData)\nC++: static void Deserialize(vtkMultiProcessStream &bytestream,\n    vtkFieldData *fieldData)\n\nDeserializes the field data from a bytestream.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkFieldDataSerializer_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkParallelCorePython.vtkFieldDataSerializer", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkFieldDataSerializer_StaticNew()
{
  return vtkFieldDataSerializer::New();
}

PyObject *PyvtkFieldDataSerializer_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkFieldDataSerializer_Type, PyvtkFieldDataSerializer_Methods,
    "vtkFieldDataSerializer",
    PyvtkFieldDataSerializer_Doc(), &PyvtkFieldDataSerializer_StaticNew);

  PyTypeObject *pytype = &PyvtkFieldDataSerializer_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkFieldDataSerializer_Doc()
{
  static const char *docstring[] = {
    "vtkFieldDataSerializer -  A concrete instance of vtkObject which\nprovides functionality for\n serializing and de-serializing field data, primarily used for the\npurpose\n of preparing the data for transfer over MPI or other communication\n mechanism.\n\n",
    "Superclass: vtkObject\n\n",
    "@sa\nvtkFieldData vtkPointData vtkCellData vtkMultiProcessStream\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkFieldDataSerializer(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkFieldDataSerializer_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkFieldDataSerializer", o) != 0)
  {
    Py_DECREF(o);
  }

}

