// python wrapper for vtkFrameBufferObjectBase
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkFrameBufferObjectBase.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkFrameBufferObjectBase(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkFrameBufferObjectBase_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkFrameBufferObjectBase_Doc();


static PyObject *
PyvtkFrameBufferObjectBase_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFrameBufferObjectBase *op = static_cast<vtkFrameBufferObjectBase *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkFrameBufferObjectBase::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFrameBufferObjectBase_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFrameBufferObjectBase *op = static_cast<vtkFrameBufferObjectBase *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkFrameBufferObjectBase::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFrameBufferObjectBase_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFrameBufferObjectBase *op = static_cast<vtkFrameBufferObjectBase *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkFrameBufferObjectBase *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkFrameBufferObjectBase::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkFrameBufferObjectBase_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkFrameBufferObjectBase *tempr = vtkFrameBufferObjectBase::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFrameBufferObjectBase_GetLastSize_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFrameBufferObjectBase *op = static_cast<vtkFrameBufferObjectBase *>(vp);

  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(0))
  {
    int *tempr = op->GetLastSize();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkFrameBufferObjectBase_GetLastSize_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFrameBufferObjectBase *op = static_cast<vtkFrameBufferObjectBase *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    op->GetLastSize(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(0, temp0);
    }
    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(1, temp1);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkFrameBufferObjectBase_GetLastSize_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFrameBufferObjectBase *op = static_cast<vtkFrameBufferObjectBase *>(vp);

  const int size0 = 2;
  int temp0[2];
  int save0[2];
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    op->GetLastSize(temp0);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkFrameBufferObjectBase_GetLastSize(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkFrameBufferObjectBase_GetLastSize_s1(self, args);
    case 2:
      return PyvtkFrameBufferObjectBase_GetLastSize_s2(self, args);
    case 1:
      return PyvtkFrameBufferObjectBase_GetLastSize_s3(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetLastSize");
  return NULL;
}


static PyMethodDef PyvtkFrameBufferObjectBase_Methods[] = {
  {"GetClassName", PyvtkFrameBufferObjectBase_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkFrameBufferObjectBase_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkFrameBufferObjectBase_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkFrameBufferObjectBase\nC++: vtkFrameBufferObjectBase *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkFrameBufferObjectBase_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkFrameBufferObjectBase\nC++: vtkFrameBufferObjectBase *SafeDownCast(vtkObject* o)\n\n"},
  {"GetLastSize", PyvtkFrameBufferObjectBase_GetLastSize, METH_VARARGS,
   "V.GetLastSize() -> (int, ...)\nC++: virtual int *GetLastSize()\nV.GetLastSize(int, int)\nC++: virtual void GetLastSize(int &_arg1, int &_arg2)\nV.GetLastSize([int, int])\nC++: virtual void GetLastSize(int _arg[2])\n\nDimensions in pixels of the framebuffer.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkFrameBufferObjectBase_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingCorePython.vtkFrameBufferObjectBase", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkFrameBufferObjectBase_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkFrameBufferObjectBase_Type, PyvtkFrameBufferObjectBase_Methods,
    "vtkFrameBufferObjectBase",
    PyvtkFrameBufferObjectBase_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkFrameBufferObjectBase_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkFrameBufferObjectBase_Doc()
{
  static const char *docstring[] = {
    "vtkFrameBufferObjectBase - abstract interface to OpenGL FBOs\n\n",
    "Superclass: vtkObject\n\n",
    "API for classes that encapsulate an OpenGL Frame Buffer Object.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkFrameBufferObjectBase(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkFrameBufferObjectBase_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkFrameBufferObjectBase", o) != 0)
  {
    Py_DECREF(o);
  }

}

