// python wrapper for vtkGarbageCollector
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGarbageCollector.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGarbageCollector(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGarbageCollector_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkGarbageCollector_Doc();


static PyObject *
PyvtkGarbageCollector_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGarbageCollector *op = static_cast<vtkGarbageCollector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGarbageCollector::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGarbageCollector_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGarbageCollector *op = static_cast<vtkGarbageCollector *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGarbageCollector::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGarbageCollector_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGarbageCollector *op = static_cast<vtkGarbageCollector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGarbageCollector *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGarbageCollector::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGarbageCollector_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkGarbageCollector *tempr = vtkGarbageCollector::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGarbageCollector_Collect_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Collect");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkGarbageCollector::Collect();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkGarbageCollector_Collect_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Collect");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGarbageCollector::Collect(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkGarbageCollector_Collect(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkGarbageCollector_Collect_s1(self, args);
    case 1:
      return PyvtkGarbageCollector_Collect_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Collect");
  return NULL;
}



static PyObject *
PyvtkGarbageCollector_DeferredCollectionPush(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "DeferredCollectionPush");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkGarbageCollector::DeferredCollectionPush();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGarbageCollector_DeferredCollectionPop(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "DeferredCollectionPop");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkGarbageCollector::DeferredCollectionPop();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGarbageCollector_SetGlobalDebugFlag(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SetGlobalDebugFlag");

  bool temp0 = false;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkGarbageCollector::SetGlobalDebugFlag(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGarbageCollector_GetGlobalDebugFlag(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetGlobalDebugFlag");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    bool tempr = vtkGarbageCollector::GetGlobalDebugFlag();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkGarbageCollector_Methods[] = {
  {"GetClassName", PyvtkGarbageCollector_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGarbageCollector_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGarbageCollector_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGarbageCollector\nC++: vtkGarbageCollector *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGarbageCollector_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGarbageCollector\nC++: vtkGarbageCollector *SafeDownCast(vtkObject* o)\n\n"},
  {"Collect", PyvtkGarbageCollector_Collect, METH_VARARGS,
   "V.Collect()\nC++: static void Collect()\nV.Collect(vtkObjectBase)\nC++: static void Collect(vtkObjectBase *root)\n\nCollect immediately using any objects whose collection was\npreviously deferred as a root for the reference graph walk.\nStrongly connected components in the reference graph are\nidentified.  Those with a net reference count of zero are\ndeleted.  When a component is deleted it may remove references to\nother components that are not part of the same reference loop but\nare held by objects in the original component.  These removed\nreferences are handled as any other and their corresponding\nchecks may be deferred.  This method keeps collecting until no\ndeferred collection checks remain.\n"},
  {"DeferredCollectionPush", PyvtkGarbageCollector_DeferredCollectionPush, METH_VARARGS,
   "V.DeferredCollectionPush()\nC++: static void DeferredCollectionPush()\n\nPush/Pop whether to do deferred collection.  Whenever the total\nnumber of pushes exceeds the total number of pops collection will\nbe deferred.  Code can call the Collect method directly to force\ncollection.\n"},
  {"DeferredCollectionPop", PyvtkGarbageCollector_DeferredCollectionPop, METH_VARARGS,
   "V.DeferredCollectionPop()\nC++: static void DeferredCollectionPop()\n\nPush/Pop whether to do deferred collection.  Whenever the total\nnumber of pushes exceeds the total number of pops collection will\nbe deferred.  Code can call the Collect method directly to force\ncollection.\n"},
  {"SetGlobalDebugFlag", PyvtkGarbageCollector_SetGlobalDebugFlag, METH_VARARGS,
   "V.SetGlobalDebugFlag(bool)\nC++: static void SetGlobalDebugFlag(bool flag)\n\nSet/Get global garbage collection debugging flag.  When set to\ntrue, all garbage collection checks will produce debugging\ninformation.\n"},
  {"GetGlobalDebugFlag", PyvtkGarbageCollector_GetGlobalDebugFlag, METH_VARARGS,
   "V.GetGlobalDebugFlag() -> bool\nC++: static bool GetGlobalDebugFlag()\n\nSet/Get global garbage collection debugging flag.  When set to\ntrue, all garbage collection checks will produce debugging\ninformation.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGarbageCollector_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkGarbageCollector", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGarbageCollector_StaticNew()
{
  return vtkGarbageCollector::New();
}

PyObject *PyvtkGarbageCollector_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGarbageCollector_Type, PyvtkGarbageCollector_Methods,
    "vtkGarbageCollector",
    PyvtkGarbageCollector_Doc(), &PyvtkGarbageCollector_StaticNew);

  PyTypeObject *pytype = &PyvtkGarbageCollector_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGarbageCollector_Doc()
{
  static const char *docstring[] = {
    "vtkGarbageCollector - Detect and break reference loops\n\n",
    "Superclass: vtkObject\n\n",
    "vtkGarbageCollector is used by VTK classes that may be involved in\nreference counting loops (such as Algorithm <-> Executive).  It\ndetects strongly connected components of the reference graph that\nhave been leaked deletes them.  The garbage collector uses the\nReportReferences method to search the reference graph and construct a\nnet reference count for each connected component.  If the net\nreferenc",
    "e count is zero the entire set of objects is deleted.\nDeleting each component may leak other components, which are then\ncollected recursively.\n\nTo enable garbage collection for a class, add these members:\n\npublic:\n  void Register(vtkObjectBase* o) VTK_OVERRIDE\n    {\n    this->RegisterInternal(o, true);\n    }\n  void UnRegister(vtkObjectBase* o) VTK_OVERRIDE\n    {\n    this->UnRegisterInternal(o, tru",
    "e);\n    }\n\n\n protected:\n\n\n  void ReportReferences(vtkGarbageCollector* collector) VTK_OVERRIDE\n    {\n    // Report references held by this object that may be in a loop.\n    this->Superclass::ReportReferences(collector);\n    vtkGarbageCollectorReport(collector, this->OtherObject, \"Other\nObject\");\n    }\n\nThe implementations should be in the .cxx file in practice. It is\nimportant that the reference b",
    "e reported using the real pointer or\nsmart pointer instance that holds the reference.  When collecting the\ngarbage collector will actually set this pointer to NULL.  The\ndestructor of the class should be written to deal with this.  It is\nalso expected that an invariant is maintained for any reference that\nis reported.  The variable holding the reference must always either\nbe NULL or refer to a ful",
    "ly constructed valid object.  Therefore code\nlike \"this->Object->UnRegister(this)\" must be avoided if\n\"this->Object\" is a reported reference because it is possible that\nthe object is deleted before UnRegister returns but then\n\"this->Object\" will be left as a dangling pointer.  Instead use code\nlike\n\nvtkObjectBase* obj = this->Object;\n  this->Object = 0;\n  obj->UnRegister(this);\n\nso that the report",
    "ed reference maintains the invariant.\n\nIf subclassing from a class that already supports garbage collection,\none need only provide the ReportReferences method.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGarbageCollector(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGarbageCollector_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGarbageCollector", o) != 0)
  {
    Py_DECREF(o);
  }

}

