// python wrapper for vtkGaussianBlurPass
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGaussianBlurPass.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGaussianBlurPass(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGaussianBlurPass_ClassNew(); }

#ifndef DECLARED_PyvtkImageProcessingPass_ClassNew
extern "C" { PyObject *PyvtkImageProcessingPass_ClassNew(); }
#define DECLARED_PyvtkImageProcessingPass_ClassNew
#endif

static const char **PyvtkGaussianBlurPass_Doc();


static PyObject *
PyvtkGaussianBlurPass_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGaussianBlurPass *op = static_cast<vtkGaussianBlurPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGaussianBlurPass::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGaussianBlurPass_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGaussianBlurPass *op = static_cast<vtkGaussianBlurPass *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGaussianBlurPass::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGaussianBlurPass_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGaussianBlurPass *op = static_cast<vtkGaussianBlurPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGaussianBlurPass *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGaussianBlurPass::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGaussianBlurPass_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkGaussianBlurPass *tempr = vtkGaussianBlurPass::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGaussianBlurPass_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGaussianBlurPass *op = static_cast<vtkGaussianBlurPass *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkGaussianBlurPass::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGaussianBlurPass_Methods[] = {
  {"GetClassName", PyvtkGaussianBlurPass_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGaussianBlurPass_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGaussianBlurPass_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGaussianBlurPass\nC++: vtkGaussianBlurPass *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGaussianBlurPass_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGaussianBlurPass\nC++: vtkGaussianBlurPass *SafeDownCast(vtkObject* o)\n\n"},
  {"ReleaseGraphicsResources", PyvtkGaussianBlurPass_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *w)\n\nRelease graphics resources and ask components to release their\nown resources.\n\\pre w_exists: w!=0\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGaussianBlurPass_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkGaussianBlurPass", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGaussianBlurPass_StaticNew()
{
  return vtkGaussianBlurPass::New();
}

PyObject *PyvtkGaussianBlurPass_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGaussianBlurPass_Type, PyvtkGaussianBlurPass_Methods,
    "vtkGaussianBlurPass",
    PyvtkGaussianBlurPass_Doc(), &PyvtkGaussianBlurPass_StaticNew);

  PyTypeObject *pytype = &PyvtkGaussianBlurPass_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageProcessingPass_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGaussianBlurPass_Doc()
{
  static const char *docstring[] = {
    "vtkGaussianBlurPass - Implement a post-processing Gaussian blur\nrender pass.\n\n",
    "Superclass: vtkImageProcessingPass\n\n",
    "Blur the image renderered by its delegate. Blurring uses a Gaussian\nlow-pass filter with a 5x5 kernel.\n\nThis pass expects an initialized depth buffer and color buffer.\nInitialized buffers means they have been cleared with farest z-value\nand background color/gradient/transparent color. An opaque pass may\nhave been performed right after the initialization.\n\nThe delegate is used once.\n\nIts delegate i",
    "s usually set to a vtkCameraPass or to a\npost-processing pass.\n\nThis pass requires a OpenGL context that supports texture objects\n(TO), framebuffer objects (FBO) and GLSL. If not, it will emit an\nerror message and will render its delegate and return.\n\n@par Implementation: As the filter is separable, it first blurs the\nimage horizontally and then vertically. This reduces the number of\ntexture sampl",
    "ing to 5 per pass. In addition, as texture sampling can\nalready blend texel values in linear mode, by adjusting the texture\ncoordinate accordingly, only 3 texture sampling are actually\nnecessary. Reference: OpenGL Bloom Toturial by Philip Rideout,\nsection Exploit Hardware Filtering \nhttp://prideout.net/bloom/index.php#Sneaky\n\n@sa\nvtkRenderPass\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGaussianBlurPass(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGaussianBlurPass_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGaussianBlurPass", o) != 0)
  {
    Py_DECREF(o);
  }

}

