// python wrapper for vtkGeoRandomGraphSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGeoRandomGraphSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoRandomGraphSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoRandomGraphSource_ClassNew(); }

#ifndef DECLARED_PyvtkRandomGraphSource_ClassNew
extern "C" { PyObject *PyvtkRandomGraphSource_ClassNew(); }
#define DECLARED_PyvtkRandomGraphSource_ClassNew
#endif

static const char **PyvtkGeoRandomGraphSource_Doc();


static PyObject *
PyvtkGeoRandomGraphSource_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoRandomGraphSource *op = static_cast<vtkGeoRandomGraphSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGeoRandomGraphSource::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoRandomGraphSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoRandomGraphSource *op = static_cast<vtkGeoRandomGraphSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoRandomGraphSource::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoRandomGraphSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoRandomGraphSource *op = static_cast<vtkGeoRandomGraphSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoRandomGraphSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoRandomGraphSource::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGeoRandomGraphSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkGeoRandomGraphSource *tempr = vtkGeoRandomGraphSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkGeoRandomGraphSource_Methods[] = {
  {"GetClassName", PyvtkGeoRandomGraphSource_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGeoRandomGraphSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGeoRandomGraphSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoRandomGraphSource\nC++: vtkGeoRandomGraphSource *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGeoRandomGraphSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGeoRandomGraphSource\nC++: vtkGeoRandomGraphSource *SafeDownCast(vtkObject* o)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGeoRandomGraphSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoRandomGraphSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoRandomGraphSource_StaticNew()
{
  return vtkGeoRandomGraphSource::New();
}

PyObject *PyvtkGeoRandomGraphSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoRandomGraphSource_Type, PyvtkGeoRandomGraphSource_Methods,
    "vtkGeoRandomGraphSource",
    PyvtkGeoRandomGraphSource_Doc(), &PyvtkGeoRandomGraphSource_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoRandomGraphSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkRandomGraphSource_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGeoRandomGraphSource_Doc()
{
  static const char *docstring[] = {
    "vtkGeoRandomGraphSource - A geospatial graph with random edges\n\n",
    "Superclass: vtkRandomGraphSource\n\n",
    "Generates a graph with a specified number of vertices, with the\ndensity of edges specified by either an exact number of edges or the\nprobability of an edge.  You may additionally specify whether to\nbegin with a random tree (which enforces graph connectivity).\n\nThe filter also adds random vertex attributes called latitude and\nlongitude. The latitude is distributed uniformly from -90 to 90,\nwhile lo",
    "ngitude is distributed uniformly from -180 to 180.\n\n@sa\nvtkRandomGraphSource\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGeoRandomGraphSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoRandomGraphSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoRandomGraphSource", o) != 0)
  {
    Py_DECREF(o);
  }

}

