// python wrapper for vtkGeoTerrain2D
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGeoTerrain2D.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoTerrain2D(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoTerrain2D_ClassNew(); }

#ifndef DECLARED_PyvtkGeoTerrain_ClassNew
extern "C" { PyObject *PyvtkGeoTerrain_ClassNew(); }
#define DECLARED_PyvtkGeoTerrain_ClassNew
#endif

static const char **PyvtkGeoTerrain2D_Doc();


static PyObject *
PyvtkGeoTerrain2D_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTerrain2D *op = static_cast<vtkGeoTerrain2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGeoTerrain2D::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTerrain2D_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTerrain2D *op = static_cast<vtkGeoTerrain2D *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoTerrain2D::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTerrain2D_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTerrain2D *op = static_cast<vtkGeoTerrain2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoTerrain2D *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoTerrain2D::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTerrain2D_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkGeoTerrain2D *tempr = vtkGeoTerrain2D::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTerrain2D_SetTextureTolerance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTextureTolerance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTerrain2D *op = static_cast<vtkGeoTerrain2D *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTextureTolerance(temp0);
    }
    else
    {
      op->vtkGeoTerrain2D::SetTextureTolerance(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTerrain2D_GetTextureTolerance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTextureTolerance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTerrain2D *op = static_cast<vtkGeoTerrain2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTextureTolerance() :
      op->vtkGeoTerrain2D::GetTextureTolerance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTerrain2D_SetLocationTolerance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLocationTolerance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTerrain2D *op = static_cast<vtkGeoTerrain2D *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLocationTolerance(temp0);
    }
    else
    {
      op->vtkGeoTerrain2D::SetLocationTolerance(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTerrain2D_GetLocationTolerance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLocationTolerance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTerrain2D *op = static_cast<vtkGeoTerrain2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetLocationTolerance() :
      op->vtkGeoTerrain2D::GetLocationTolerance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTerrain2D_GetTransform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTransform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTerrain2D *op = static_cast<vtkGeoTerrain2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkAbstractTransform *tempr = (ap.IsBound() ?
      op->GetTransform() :
      op->vtkGeoTerrain2D::GetTransform());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkGeoTerrain2D_Methods[] = {
  {"GetClassName", PyvtkGeoTerrain2D_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGeoTerrain2D_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGeoTerrain2D_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoTerrain2D\nC++: vtkGeoTerrain2D *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGeoTerrain2D_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGeoTerrain2D\nC++: vtkGeoTerrain2D *SafeDownCast(vtkObject* o)\n\n"},
  {"SetTextureTolerance", PyvtkGeoTerrain2D_SetTextureTolerance, METH_VARARGS,
   "V.SetTextureTolerance(float)\nC++: void SetTextureTolerance(double a)\n\nThe maximum size of a single texel in pixels. Images will be\nrefined if a texel becomes larger than the tolerance.\n"},
  {"GetTextureTolerance", PyvtkGeoTerrain2D_GetTextureTolerance, METH_VARARGS,
   "V.GetTextureTolerance() -> float\nC++: double GetTextureTolerance()\n\nThe maximum size of a single texel in pixels. Images will be\nrefined if a texel becomes larger than the tolerance.\n"},
  {"SetLocationTolerance", PyvtkGeoTerrain2D_SetLocationTolerance, METH_VARARGS,
   "V.SetLocationTolerance(float)\nC++: void SetLocationTolerance(double a)\n\nThe maximum allowed deviation of geometry in pixels. Geometry\nwill be refined if the deviation is larger than the tolerance.\n"},
  {"GetLocationTolerance", PyvtkGeoTerrain2D_GetLocationTolerance, METH_VARARGS,
   "V.GetLocationTolerance() -> float\nC++: double GetLocationTolerance()\n\nThe maximum allowed deviation of geometry in pixels. Geometry\nwill be refined if the deviation is larger than the tolerance.\n"},
  {"GetTransform", PyvtkGeoTerrain2D_GetTransform, METH_VARARGS,
   "V.GetTransform() -> vtkAbstractTransform\nC++: virtual vtkAbstractTransform *GetTransform()\n\nReturn the projection transformation used by this 2D terrain.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGeoTerrain2D_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoTerrain2D", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoTerrain2D_StaticNew()
{
  return vtkGeoTerrain2D::New();
}

PyObject *PyvtkGeoTerrain2D_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoTerrain2D_Type, PyvtkGeoTerrain2D_Methods,
    "vtkGeoTerrain2D",
    PyvtkGeoTerrain2D_Doc(), &PyvtkGeoTerrain2D_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoTerrain2D_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGeoTerrain_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGeoTerrain2D_Doc()
{
  static const char *docstring[] = {
    "vtkGeoTerrain2D - A 2D terrain model for the globe.\n\n",
    "Superclass: vtkGeoTerrain\n\n",
    "vtkGeoTerrain2D contains a multi-resolution tree of geometry\nrepresenting the globe. It uses a vtkGeoSource subclass to generate\nthe terrain, such as vtkGeoProjectionSource. This source must be set\nbefore using the terrain in a vtkGeoView2D. The terrain also contains\nan AddActors() method which updates the set of actors representing\nthe globe given the current camera position.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGeoTerrain2D(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoTerrain2D_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoTerrain2D", o) != 0)
  {
    Py_DECREF(o);
  }

}

