// python wrapper for vtkGeoTreeNodeCache
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGeoTreeNodeCache.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoTreeNodeCache(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoTreeNodeCache_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkGeoTreeNodeCache_Doc();


static PyObject *
PyvtkGeoTreeNodeCache_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNodeCache *op = static_cast<vtkGeoTreeNodeCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGeoTreeNodeCache::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNodeCache_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNodeCache *op = static_cast<vtkGeoTreeNodeCache *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoTreeNodeCache::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNodeCache_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNodeCache *op = static_cast<vtkGeoTreeNodeCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoTreeNodeCache *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoTreeNodeCache::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNodeCache_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkGeoTreeNodeCache *tempr = vtkGeoTreeNodeCache::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNodeCache_SetCacheMaximumLimit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCacheMaximumLimit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNodeCache *op = static_cast<vtkGeoTreeNodeCache *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCacheMaximumLimit(temp0);
    }
    else
    {
      op->vtkGeoTreeNodeCache::SetCacheMaximumLimit(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNodeCache_GetCacheMaximumLimit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCacheMaximumLimit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNodeCache *op = static_cast<vtkGeoTreeNodeCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCacheMaximumLimit() :
      op->vtkGeoTreeNodeCache::GetCacheMaximumLimit());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNodeCache_SetCacheMinimumLimit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCacheMinimumLimit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNodeCache *op = static_cast<vtkGeoTreeNodeCache *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCacheMinimumLimit(temp0);
    }
    else
    {
      op->vtkGeoTreeNodeCache::SetCacheMinimumLimit(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNodeCache_GetCacheMinimumLimit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCacheMinimumLimit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNodeCache *op = static_cast<vtkGeoTreeNodeCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCacheMinimumLimit() :
      op->vtkGeoTreeNodeCache::GetCacheMinimumLimit());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNodeCache_SendToFront(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SendToFront");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNodeCache *op = static_cast<vtkGeoTreeNodeCache *>(vp);

  vtkGeoTreeNode *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
  {
    if (ap.IsBound())
    {
      op->SendToFront(temp0);
    }
    else
    {
      op->vtkGeoTreeNodeCache::SendToFront(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNodeCache_RemoveNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNodeCache *op = static_cast<vtkGeoTreeNodeCache *>(vp);

  vtkGeoTreeNode *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
  {
    if (ap.IsBound())
    {
      op->RemoveNode(temp0);
    }
    else
    {
      op->vtkGeoTreeNodeCache::RemoveNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNodeCache_GetSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNodeCache *op = static_cast<vtkGeoTreeNodeCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSize() :
      op->vtkGeoTreeNodeCache::GetSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkGeoTreeNodeCache_Methods[] = {
  {"GetClassName", PyvtkGeoTreeNodeCache_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGeoTreeNodeCache_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGeoTreeNodeCache_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoTreeNodeCache\nC++: vtkGeoTreeNodeCache *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGeoTreeNodeCache_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGeoTreeNodeCache\nC++: vtkGeoTreeNodeCache *SafeDownCast(vtkObject* o)\n\n"},
  {"SetCacheMaximumLimit", PyvtkGeoTreeNodeCache_SetCacheMaximumLimit, METH_VARARGS,
   "V.SetCacheMaximumLimit(int)\nC++: void SetCacheMaximumLimit(int a)\n\nThe size of the cache of geospatial nodes. When the size reaches\nthis limit, the list of non-empty nodes will be shortened to\nCacheMinimumLimit.\n"},
  {"GetCacheMaximumLimit", PyvtkGeoTreeNodeCache_GetCacheMaximumLimit, METH_VARARGS,
   "V.GetCacheMaximumLimit() -> int\nC++: int GetCacheMaximumLimit()\n\nThe size of the cache of geospatial nodes. When the size reaches\nthis limit, the list of non-empty nodes will be shortened to\nCacheMinimumLimit.\n"},
  {"SetCacheMinimumLimit", PyvtkGeoTreeNodeCache_SetCacheMinimumLimit, METH_VARARGS,
   "V.SetCacheMinimumLimit(int)\nC++: void SetCacheMinimumLimit(int a)\n\nThe cache is reduced to this size when the maximum limit is\nreached.\n"},
  {"GetCacheMinimumLimit", PyvtkGeoTreeNodeCache_GetCacheMinimumLimit, METH_VARARGS,
   "V.GetCacheMinimumLimit() -> int\nC++: int GetCacheMinimumLimit()\n\nThe cache is reduced to this size when the maximum limit is\nreached.\n"},
  {"SendToFront", PyvtkGeoTreeNodeCache_SendToFront, METH_VARARGS,
   "V.SendToFront(vtkGeoTreeNode)\nC++: void SendToFront(vtkGeoTreeNode *node)\n\nSend a node to the front of the list. Perform this whenever a\nnode is accessed, so that the most recently accessed nodes' data\nare not deleted.\n"},
  {"RemoveNode", PyvtkGeoTreeNodeCache_RemoveNode, METH_VARARGS,
   "V.RemoveNode(vtkGeoTreeNode)\nC++: void RemoveNode(vtkGeoTreeNode *node)\n\nRemove the node from the list.\n"},
  {"GetSize", PyvtkGeoTreeNodeCache_GetSize, METH_VARARGS,
   "V.GetSize() -> int\nC++: int GetSize()\n\nThe current size of the list.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGeoTreeNodeCache_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoTreeNodeCache", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoTreeNodeCache_StaticNew()
{
  return vtkGeoTreeNodeCache::New();
}

PyObject *PyvtkGeoTreeNodeCache_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoTreeNodeCache_Type, PyvtkGeoTreeNodeCache_Methods,
    "vtkGeoTreeNodeCache",
    PyvtkGeoTreeNodeCache_Doc(), &PyvtkGeoTreeNodeCache_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoTreeNodeCache_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGeoTreeNodeCache_Doc()
{
  static const char *docstring[] = {
    "vtkGeoTreeNodeCache - Manages a list of vtkGeoTreeNodes.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkGeoTreeNodeCache keeps track of a linked list of vtkGeoTreeNodes,\nand has operations to move nodes to the front of the list and to\ndelete data from the least used nodes. This is used to recover memory\nfrom nodes that store data that hasn't been used in a while.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGeoTreeNodeCache(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoTreeNodeCache_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoTreeNodeCache", o) != 0)
  {
    Py_DECREF(o);
  }

}

