// python wrapper for vtkGeoView
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGeoView.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoView(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoView_ClassNew(); }

#ifndef DECLARED_PyvtkRenderView_ClassNew
extern "C" { PyObject *PyvtkRenderView_ClassNew(); }
#define DECLARED_PyvtkRenderView_ClassNew
#endif

static const char **PyvtkGeoView_Doc();


static PyObject *
PyvtkGeoView_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGeoView::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoView::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoView *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoView::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkGeoView *tempr = vtkGeoView::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_AddDefaultImageRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddDefaultImageRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  vtkImageData *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    vtkGeoAlignedImageRepresentation *tempr = (ap.IsBound() ?
      op->AddDefaultImageRepresentation(temp0) :
      op->vtkGeoView::AddDefaultImageRepresentation(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_PrepareForRendering(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PrepareForRendering");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PrepareForRendering();
    }
    else
    {
      op->vtkGeoView::PrepareForRendering();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_BuildLowResEarth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BuildLowResEarth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  const int size0 = 3;
  double temp0[3];
  double save0[3];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->BuildLowResEarth(temp0);
    }
    else
    {
      op->vtkGeoView::BuildLowResEarth(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_SetLockHeading(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLockHeading");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLockHeading(temp0);
    }
    else
    {
      op->vtkGeoView::SetLockHeading(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_GetLockHeading(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLockHeading");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetLockHeading() :
      op->vtkGeoView::GetLockHeading());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_LockHeadingOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LockHeadingOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LockHeadingOn();
    }
    else
    {
      op->vtkGeoView::LockHeadingOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_LockHeadingOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LockHeadingOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LockHeadingOff();
    }
    else
    {
      op->vtkGeoView::LockHeadingOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_GetGeoInteractorStyle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGeoInteractorStyle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoInteractorStyle *tempr = (ap.IsBound() ?
      op->GetGeoInteractorStyle() :
      op->vtkGeoView::GetGeoInteractorStyle());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_SetGeoInteractorStyle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGeoInteractorStyle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  vtkGeoInteractorStyle *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoInteractorStyle"))
  {
    if (ap.IsBound())
    {
      op->SetGeoInteractorStyle(temp0);
    }
    else
    {
      op->vtkGeoView::SetGeoInteractorStyle(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_SetTerrain(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTerrain");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  vtkGeoTerrain *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTerrain"))
  {
    if (ap.IsBound())
    {
      op->SetTerrain(temp0);
    }
    else
    {
      op->vtkGeoView::SetTerrain(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_GetTerrain(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTerrain");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoTerrain *tempr = (ap.IsBound() ?
      op->GetTerrain() :
      op->vtkGeoView::GetTerrain());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoView_Render(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Render");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoView *op = static_cast<vtkGeoView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Render();
    }
    else
    {
      op->vtkGeoView::Render();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGeoView_Methods[] = {
  {"GetClassName", PyvtkGeoView_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGeoView_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGeoView_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoView\nC++: vtkGeoView *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGeoView_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGeoView\nC++: vtkGeoView *SafeDownCast(vtkObject* o)\n\n"},
  {"AddDefaultImageRepresentation", PyvtkGeoView_AddDefaultImageRepresentation, METH_VARARGS,
   "V.AddDefaultImageRepresentation(vtkImageData)\n    -> vtkGeoAlignedImageRepresentation\nC++: vtkGeoAlignedImageRepresentation *AddDefaultImageRepresentation(\n    vtkImageData *image)\n\nAdds an image representation with a simple terrain model using\nthe image in the specified file as the globe terrain.\n"},
  {"PrepareForRendering", PyvtkGeoView_PrepareForRendering, METH_VARARGS,
   "V.PrepareForRendering()\nC++: virtual void PrepareForRendering()\n\nPrepares the view for rendering.\n"},
  {"BuildLowResEarth", PyvtkGeoView_BuildLowResEarth, METH_VARARGS,
   "V.BuildLowResEarth([float, float, float])\nC++: void BuildLowResEarth(double origin[3])\n\nRebuild low-res earth source; call after (re)setting origin.\n"},
  {"SetLockHeading", PyvtkGeoView_SetLockHeading, METH_VARARGS,
   "V.SetLockHeading(bool)\nC++: virtual void SetLockHeading(bool lock)\n\nWhether the view locks the heading when panning. Default is off.\n"},
  {"GetLockHeading", PyvtkGeoView_GetLockHeading, METH_VARARGS,
   "V.GetLockHeading() -> bool\nC++: virtual bool GetLockHeading()\n\nWhether the view locks the heading when panning. Default is off.\n"},
  {"LockHeadingOn", PyvtkGeoView_LockHeadingOn, METH_VARARGS,
   "V.LockHeadingOn()\nC++: void LockHeadingOn()\n\nWhether the view locks the heading when panning. Default is off.\n"},
  {"LockHeadingOff", PyvtkGeoView_LockHeadingOff, METH_VARARGS,
   "V.LockHeadingOff()\nC++: void LockHeadingOff()\n\nWhether the view locks the heading when panning. Default is off.\n"},
  {"GetGeoInteractorStyle", PyvtkGeoView_GetGeoInteractorStyle, METH_VARARGS,
   "V.GetGeoInteractorStyle() -> vtkGeoInteractorStyle\nC++: vtkGeoInteractorStyle *GetGeoInteractorStyle()\n\nConvenience method for obtaining the internal interactor style.\n"},
  {"SetGeoInteractorStyle", PyvtkGeoView_SetGeoInteractorStyle, METH_VARARGS,
   "V.SetGeoInteractorStyle(vtkGeoInteractorStyle)\nC++: virtual void SetGeoInteractorStyle(\n    vtkGeoInteractorStyle *style)\n\nMethod to change the interactor style.\n"},
  {"SetTerrain", PyvtkGeoView_SetTerrain, METH_VARARGS,
   "V.SetTerrain(vtkGeoTerrain)\nC++: virtual void SetTerrain(vtkGeoTerrain *terrain)\n\nThe terrain (geometry) model for this earth view.\n"},
  {"GetTerrain", PyvtkGeoView_GetTerrain, METH_VARARGS,
   "V.GetTerrain() -> vtkGeoTerrain\nC++: vtkGeoTerrain *GetTerrain()\n\nThe terrain (geometry) model for this earth view.\n"},
  {"Render", PyvtkGeoView_Render, METH_VARARGS,
   "V.Render()\nC++: virtual void Render()\n\nUpdate and render the view.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGeoView_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsGeovisPython.vtkGeoView", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoView_StaticNew()
{
  return vtkGeoView::New();
}

PyObject *PyvtkGeoView_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoView_Type, PyvtkGeoView_Methods,
    "vtkGeoView",
    PyvtkGeoView_Doc(), &PyvtkGeoView_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoView_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkRenderView_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGeoView_Doc()
{
  static const char *docstring[] = {
    "vtkGeoView - A 3D geospatial view.\n\n",
    "Superclass: vtkRenderView\n\n",
    "vtkGeoView is a 3D globe view. The globe may contain a\nmulti-resolution geometry source (vtkGeoTerrain), multiple\nmulti-resolution image sources (vtkGeoAlignedImageRepresentation), as\nwell as other representations such as vtkRenderedGraphRepresentation.\nAt a minimum, the view must have a terrain and one image\nrepresentation. The view uses vtkGeoInteractorStyle to orbit, zoom,\nand tilt the view, an",
    "d contains a vtkCompassWidget for manipulating\nthe camera.\n\nEach terrain or image representation contains a vtkGeoSource subclass\nwhich generates geometry or imagery at multiple resolutions. As the\ncamera position changes, the terrain and/or image representations may\nask its vtkGeoSource to refine the geometry. This refinement is\nperformed on a separate thread, and the data is added to the view\nwh",
    "en it becomes available.\n\n@sa\nvtkGeoTerrain vtkGeoAlignedImageRepresentation vtkGeoSource\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGeoView(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoView_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoView", o) != 0)
  {
    Py_DECREF(o);
  }

}

