// python wrapper for vtkGraphItem
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGraphItem.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGraphItem(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGraphItem_ClassNew(); }

#ifndef DECLARED_PyvtkContextItem_ClassNew
extern "C" { PyObject *PyvtkContextItem_ClassNew(); }
#define DECLARED_PyvtkContextItem_ClassNew
#endif

static const char **PyvtkGraphItem_Doc();


static PyObject *
PyvtkGraphItem_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphItem *op = static_cast<vtkGraphItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGraphItem::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphItem_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphItem *op = static_cast<vtkGraphItem *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGraphItem::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphItem_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphItem *op = static_cast<vtkGraphItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGraphItem *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGraphItem::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGraphItem_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkGraphItem *tempr = vtkGraphItem::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphItem_SetGraph(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGraph");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphItem *op = static_cast<vtkGraphItem *>(vp);

  vtkGraph *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGraph"))
  {
    if (ap.IsBound())
    {
      op->SetGraph(temp0);
    }
    else
    {
      op->vtkGraphItem::SetGraph(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphItem_GetGraph(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGraph");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphItem *op = static_cast<vtkGraphItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGraph *tempr = (ap.IsBound() ?
      op->GetGraph() :
      op->vtkGraphItem::GetGraph());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphItem_GetLayout(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLayout");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphItem *op = static_cast<vtkGraphItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIncrementalForceLayout *tempr = (ap.IsBound() ?
      op->GetLayout() :
      op->vtkGraphItem::GetLayout());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphItem_StartLayoutAnimation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StartLayoutAnimation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphItem *op = static_cast<vtkGraphItem *>(vp);

  vtkRenderWindowInteractor *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindowInteractor"))
  {
    if (ap.IsBound())
    {
      op->StartLayoutAnimation(temp0);
    }
    else
    {
      op->vtkGraphItem::StartLayoutAnimation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphItem_StopLayoutAnimation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StopLayoutAnimation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphItem *op = static_cast<vtkGraphItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->StopLayoutAnimation();
    }
    else
    {
      op->vtkGraphItem::StopLayoutAnimation();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphItem_UpdateLayout(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateLayout");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphItem *op = static_cast<vtkGraphItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateLayout();
    }
    else
    {
      op->vtkGraphItem::UpdateLayout();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGraphItem_Methods[] = {
  {"GetClassName", PyvtkGraphItem_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGraphItem_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGraphItem_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGraphItem\nC++: vtkGraphItem *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGraphItem_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGraphItem\nC++: vtkGraphItem *SafeDownCast(vtkObject* o)\n\n"},
  {"SetGraph", PyvtkGraphItem_SetGraph, METH_VARARGS,
   "V.SetGraph(vtkGraph)\nC++: virtual void SetGraph(vtkGraph *graph)\n\nThe graph that this item draws.\n"},
  {"GetGraph", PyvtkGraphItem_GetGraph, METH_VARARGS,
   "V.GetGraph() -> vtkGraph\nC++: vtkGraph *GetGraph()\n\nThe graph that this item draws.\n"},
  {"GetLayout", PyvtkGraphItem_GetLayout, METH_VARARGS,
   "V.GetLayout() -> vtkIncrementalForceLayout\nC++: virtual vtkIncrementalForceLayout *GetLayout()\n\nExposes the incremental graph layout for updating parameters.\n"},
  {"StartLayoutAnimation", PyvtkGraphItem_StartLayoutAnimation, METH_VARARGS,
   "V.StartLayoutAnimation(vtkRenderWindowInteractor)\nC++: virtual void StartLayoutAnimation(\n    vtkRenderWindowInteractor *interactor)\n\nBegins or ends the layout animation.\n"},
  {"StopLayoutAnimation", PyvtkGraphItem_StopLayoutAnimation, METH_VARARGS,
   "V.StopLayoutAnimation()\nC++: virtual void StopLayoutAnimation()\n\nBegins or ends the layout animation.\n"},
  {"UpdateLayout", PyvtkGraphItem_UpdateLayout, METH_VARARGS,
   "V.UpdateLayout()\nC++: virtual void UpdateLayout()\n\nIncrementally updates the graph layout.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGraphItem_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkGraphItem", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGraphItem_StaticNew()
{
  return vtkGraphItem::New();
}

PyObject *PyvtkGraphItem_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGraphItem_Type, PyvtkGraphItem_Methods,
    "vtkGraphItem",
    PyvtkGraphItem_Doc(), &PyvtkGraphItem_StaticNew);

  PyTypeObject *pytype = &PyvtkGraphItem_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkContextItem_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGraphItem_Doc()
{
  static const char *docstring[] = {
    "vtkGraphItem - A 2D graphics item for rendering a graph.\n\n",
    "Superclass: vtkContextItem\n\n",
    "This item draws a graph as a part of a vtkContextScene. This simple\nclass has minimal state and delegates the determination of visual\nvertex and edge properties like color, size, width, etc. to a set of\nvirtual functions. To influence the rendering of the graph, subclass\nthis item and override the property functions you wish to customize.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGraphItem(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGraphItem_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGraphItem", o) != 0)
  {
    Py_DECREF(o);
  }

}

