// python wrapper for vtkGraphLayoutView
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGraphLayoutView.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGraphLayoutView(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGraphLayoutView_ClassNew(); }

#ifndef DECLARED_PyvtkRenderView_ClassNew
extern "C" { PyObject *PyvtkRenderView_ClassNew(); }
#define DECLARED_PyvtkRenderView_ClassNew
#endif

static const char **PyvtkGraphLayoutView_Doc();


static PyObject *
PyvtkGraphLayoutView_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkGraphLayoutView::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGraphLayoutView::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGraphLayoutView *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGraphLayoutView::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkGraphLayoutView *tempr = vtkGraphLayoutView::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetVertexLabelArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVertexLabelArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetVertexLabelArrayName(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetVertexLabelArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetVertexLabelArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVertexLabelArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetVertexLabelArrayName() :
      op->vtkGraphLayoutView::GetVertexLabelArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEdgeLabelArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeLabelArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeLabelArrayName(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeLabelArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEdgeLabelArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEdgeLabelArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetEdgeLabelArrayName() :
      op->vtkGraphLayoutView::GetEdgeLabelArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetVertexLabelVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVertexLabelVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetVertexLabelVisibility(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetVertexLabelVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetVertexLabelVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVertexLabelVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetVertexLabelVisibility() :
      op->vtkGraphLayoutView::GetVertexLabelVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_VertexLabelVisibilityOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "VertexLabelVisibilityOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->VertexLabelVisibilityOn();
    }
    else
    {
      op->vtkGraphLayoutView::VertexLabelVisibilityOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_VertexLabelVisibilityOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "VertexLabelVisibilityOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->VertexLabelVisibilityOff();
    }
    else
    {
      op->vtkGraphLayoutView::VertexLabelVisibilityOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetHideVertexLabelsOnInteraction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHideVertexLabelsOnInteraction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetHideVertexLabelsOnInteraction(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetHideVertexLabelsOnInteraction(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetHideVertexLabelsOnInteraction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHideVertexLabelsOnInteraction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetHideVertexLabelsOnInteraction() :
      op->vtkGraphLayoutView::GetHideVertexLabelsOnInteraction());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_HideVertexLabelsOnInteractionOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HideVertexLabelsOnInteractionOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->HideVertexLabelsOnInteractionOn();
    }
    else
    {
      op->vtkGraphLayoutView::HideVertexLabelsOnInteractionOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_HideVertexLabelsOnInteractionOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HideVertexLabelsOnInteractionOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->HideVertexLabelsOnInteractionOff();
    }
    else
    {
      op->vtkGraphLayoutView::HideVertexLabelsOnInteractionOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEdgeVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeVisibility(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEdgeVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEdgeVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetEdgeVisibility() :
      op->vtkGraphLayoutView::GetEdgeVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_EdgeVisibilityOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EdgeVisibilityOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EdgeVisibilityOn();
    }
    else
    {
      op->vtkGraphLayoutView::EdgeVisibilityOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_EdgeVisibilityOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EdgeVisibilityOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EdgeVisibilityOff();
    }
    else
    {
      op->vtkGraphLayoutView::EdgeVisibilityOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEdgeLabelVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeLabelVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeLabelVisibility(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeLabelVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEdgeLabelVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEdgeLabelVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetEdgeLabelVisibility() :
      op->vtkGraphLayoutView::GetEdgeLabelVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_EdgeLabelVisibilityOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EdgeLabelVisibilityOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EdgeLabelVisibilityOn();
    }
    else
    {
      op->vtkGraphLayoutView::EdgeLabelVisibilityOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_EdgeLabelVisibilityOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EdgeLabelVisibilityOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EdgeLabelVisibilityOff();
    }
    else
    {
      op->vtkGraphLayoutView::EdgeLabelVisibilityOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetHideEdgeLabelsOnInteraction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHideEdgeLabelsOnInteraction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetHideEdgeLabelsOnInteraction(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetHideEdgeLabelsOnInteraction(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetHideEdgeLabelsOnInteraction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHideEdgeLabelsOnInteraction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetHideEdgeLabelsOnInteraction() :
      op->vtkGraphLayoutView::GetHideEdgeLabelsOnInteraction());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_HideEdgeLabelsOnInteractionOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HideEdgeLabelsOnInteractionOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->HideEdgeLabelsOnInteractionOn();
    }
    else
    {
      op->vtkGraphLayoutView::HideEdgeLabelsOnInteractionOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_HideEdgeLabelsOnInteractionOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HideEdgeLabelsOnInteractionOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->HideEdgeLabelsOnInteractionOff();
    }
    else
    {
      op->vtkGraphLayoutView::HideEdgeLabelsOnInteractionOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetVertexColorArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVertexColorArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetVertexColorArrayName(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetVertexColorArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetVertexColorArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVertexColorArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetVertexColorArrayName() :
      op->vtkGraphLayoutView::GetVertexColorArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetColorVertices(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetColorVertices");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetColorVertices(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetColorVertices(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetColorVertices(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColorVertices");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetColorVertices() :
      op->vtkGraphLayoutView::GetColorVertices());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_ColorVerticesOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ColorVerticesOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ColorVerticesOn();
    }
    else
    {
      op->vtkGraphLayoutView::ColorVerticesOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_ColorVerticesOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ColorVerticesOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ColorVerticesOff();
    }
    else
    {
      op->vtkGraphLayoutView::ColorVerticesOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEdgeColorArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeColorArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeColorArrayName(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeColorArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEdgeColorArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEdgeColorArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetEdgeColorArrayName() :
      op->vtkGraphLayoutView::GetEdgeColorArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetColorEdges(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetColorEdges");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetColorEdges(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetColorEdges(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetColorEdges(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColorEdges");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetColorEdges() :
      op->vtkGraphLayoutView::GetColorEdges());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_ColorEdgesOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ColorEdgesOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ColorEdgesOn();
    }
    else
    {
      op->vtkGraphLayoutView::ColorEdgesOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_ColorEdgesOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ColorEdgesOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ColorEdgesOff();
    }
    else
    {
      op->vtkGraphLayoutView::ColorEdgesOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEdgeSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeSelection(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeSelection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEdgeSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEdgeSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetEdgeSelection() :
      op->vtkGraphLayoutView::GetEdgeSelection());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_EdgeSelectionOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EdgeSelectionOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EdgeSelectionOn();
    }
    else
    {
      op->vtkGraphLayoutView::EdgeSelectionOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_EdgeSelectionOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EdgeSelectionOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EdgeSelectionOff();
    }
    else
    {
      op->vtkGraphLayoutView::EdgeSelectionOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEnabledEdgesArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnabledEdgesArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEnabledEdgesArrayName(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEnabledEdgesArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEnabledEdgesArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEnabledEdgesArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetEnabledEdgesArrayName() :
      op->vtkGraphLayoutView::GetEnabledEdgesArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEnableEdgesByArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnableEdgesByArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEnableEdgesByArray(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEnableEdgesByArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEnableEdgesByArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEnableEdgesByArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetEnableEdgesByArray() :
      op->vtkGraphLayoutView::GetEnableEdgesByArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEnabledVerticesArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnabledVerticesArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEnabledVerticesArrayName(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEnabledVerticesArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEnabledVerticesArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEnabledVerticesArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetEnabledVerticesArrayName() :
      op->vtkGraphLayoutView::GetEnabledVerticesArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEnableVerticesByArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnableVerticesByArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEnableVerticesByArray(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEnableVerticesByArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEnableVerticesByArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEnableVerticesByArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetEnableVerticesByArray() :
      op->vtkGraphLayoutView::GetEnableVerticesByArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetScalingArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalingArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScalingArrayName(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetScalingArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetScalingArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScalingArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetScalingArrayName() :
      op->vtkGraphLayoutView::GetScalingArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetScaledGlyphs(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScaledGlyphs");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScaledGlyphs(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetScaledGlyphs(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetScaledGlyphs(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScaledGlyphs");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetScaledGlyphs() :
      op->vtkGraphLayoutView::GetScaledGlyphs());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_ScaledGlyphsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ScaledGlyphsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ScaledGlyphsOn();
    }
    else
    {
      op->vtkGraphLayoutView::ScaledGlyphsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_ScaledGlyphsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ScaledGlyphsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ScaledGlyphsOff();
    }
    else
    {
      op->vtkGraphLayoutView::ScaledGlyphsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategy_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategy(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategy_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  vtkGraphLayoutStrategy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGraphLayoutStrategy"))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategy(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGraphLayoutView_SetLayoutStrategy_Methods[] = {
  {NULL, PyvtkGraphLayoutView_SetLayoutStrategy_s1, METH_VARARGS,
   "@z"},
  {NULL, PyvtkGraphLayoutView_SetLayoutStrategy_s2, METH_VARARGS,
   "@V *vtkGraphLayoutStrategy"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategy(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkGraphLayoutView_SetLayoutStrategy_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetLayoutStrategy");
  return NULL;
}



static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToRandom(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToRandom");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToRandom();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToRandom();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToForceDirected(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToForceDirected");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToForceDirected();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToForceDirected();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToSimple2D(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToSimple2D");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToSimple2D();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToSimple2D();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToClustering2D(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToClustering2D");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToClustering2D();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToClustering2D();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToCommunity2D(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToCommunity2D");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToCommunity2D();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToCommunity2D();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToFast2D(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToFast2D");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToFast2D();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToFast2D();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToPassThrough(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToPassThrough");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToPassThrough();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToPassThrough();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToCircular(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToCircular");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToCircular();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToCircular();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToTree(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToTree");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToTree();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToTree();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToCosmicTree(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToCosmicTree");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToCosmicTree();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToCosmicTree();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToCone(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToCone");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToCone();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToCone();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetLayoutStrategyToSpanTree(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategyToSpanTree");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategyToSpanTree();
    }
    else
    {
      op->vtkGraphLayoutView::SetLayoutStrategyToSpanTree();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetLayoutStrategyName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLayoutStrategyName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetLayoutStrategyName() :
      op->vtkGraphLayoutView::GetLayoutStrategyName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetLayoutStrategy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLayoutStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGraphLayoutStrategy *tempr = (ap.IsBound() ?
      op->GetLayoutStrategy() :
      op->vtkGraphLayoutView::GetLayoutStrategy());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEdgeLayoutStrategy_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeLayoutStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeLayoutStrategy(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeLayoutStrategy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkGraphLayoutView_SetEdgeLayoutStrategy_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeLayoutStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  vtkEdgeLayoutStrategy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkEdgeLayoutStrategy"))
  {
    if (ap.IsBound())
    {
      op->SetEdgeLayoutStrategy(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeLayoutStrategy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGraphLayoutView_SetEdgeLayoutStrategy_Methods[] = {
  {NULL, PyvtkGraphLayoutView_SetEdgeLayoutStrategy_s1, METH_VARARGS,
   "@z"},
  {NULL, PyvtkGraphLayoutView_SetEdgeLayoutStrategy_s2, METH_VARARGS,
   "@V *vtkEdgeLayoutStrategy"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkGraphLayoutView_SetEdgeLayoutStrategy(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkGraphLayoutView_SetEdgeLayoutStrategy_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetEdgeLayoutStrategy");
  return NULL;
}



static PyObject *
PyvtkGraphLayoutView_SetEdgeLayoutStrategyToArcParallel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeLayoutStrategyToArcParallel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeLayoutStrategyToArcParallel();
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeLayoutStrategyToArcParallel();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEdgeLayoutStrategyToPassThrough(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeLayoutStrategyToPassThrough");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeLayoutStrategyToPassThrough();
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeLayoutStrategyToPassThrough();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEdgeLayoutStrategyName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEdgeLayoutStrategyName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetEdgeLayoutStrategyName() :
      op->vtkGraphLayoutView::GetEdgeLayoutStrategyName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEdgeLayoutStrategy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEdgeLayoutStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkEdgeLayoutStrategy *tempr = (ap.IsBound() ?
      op->GetEdgeLayoutStrategy() :
      op->vtkGraphLayoutView::GetEdgeLayoutStrategy());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_AddIconType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddIconType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->AddIconType(temp0, temp1);
    }
    else
    {
      op->vtkGraphLayoutView::AddIconType(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_ClearIconTypes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearIconTypes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ClearIconTypes();
    }
    else
    {
      op->vtkGraphLayoutView::ClearIconTypes();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetIconAlignment(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIconAlignment");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIconAlignment(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetIconAlignment(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetIconVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIconVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIconVisibility(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetIconVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetIconVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIconVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetIconVisibility() :
      op->vtkGraphLayoutView::GetIconVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_IconVisibilityOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IconVisibilityOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->IconVisibilityOn();
    }
    else
    {
      op->vtkGraphLayoutView::IconVisibilityOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_IconVisibilityOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IconVisibilityOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->IconVisibilityOff();
    }
    else
    {
      op->vtkGraphLayoutView::IconVisibilityOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetIconArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIconArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIconArrayName(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetIconArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetIconArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIconArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetIconArrayName() :
      op->vtkGraphLayoutView::GetIconArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetGlyphType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlyphType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlyphType(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetGlyphType(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetGlyphType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGlyphType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetGlyphType() :
      op->vtkGraphLayoutView::GetGlyphType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetVertexLabelFontSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVertexLabelFontSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetVertexLabelFontSize(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetVertexLabelFontSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetVertexLabelFontSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVertexLabelFontSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetVertexLabelFontSize() :
      op->vtkGraphLayoutView::GetVertexLabelFontSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEdgeLabelFontSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeLabelFontSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeLabelFontSize(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeLabelFontSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEdgeLabelFontSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEdgeLabelFontSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetEdgeLabelFontSize() :
      op->vtkGraphLayoutView::GetEdgeLabelFontSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetEdgeScalarBarVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeScalarBarVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeScalarBarVisibility(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetEdgeScalarBarVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetEdgeScalarBarVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEdgeScalarBarVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetEdgeScalarBarVisibility() :
      op->vtkGraphLayoutView::GetEdgeScalarBarVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_SetVertexScalarBarVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVertexScalarBarVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetVertexScalarBarVisibility(temp0);
    }
    else
    {
      op->vtkGraphLayoutView::SetVertexScalarBarVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_GetVertexScalarBarVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVertexScalarBarVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetVertexScalarBarVisibility() :
      op->vtkGraphLayoutView::GetVertexScalarBarVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_ZoomToSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ZoomToSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ZoomToSelection();
    }
    else
    {
      op->vtkGraphLayoutView::ZoomToSelection();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_IsLayoutComplete(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsLayoutComplete");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->IsLayoutComplete() :
      op->vtkGraphLayoutView::IsLayoutComplete());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGraphLayoutView_UpdateLayout(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateLayout");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGraphLayoutView *op = static_cast<vtkGraphLayoutView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateLayout();
    }
    else
    {
      op->vtkGraphLayoutView::UpdateLayout();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGraphLayoutView_Methods[] = {
  {"GetClassName", PyvtkGraphLayoutView_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkGraphLayoutView_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkGraphLayoutView_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGraphLayoutView\nC++: vtkGraphLayoutView *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkGraphLayoutView_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkGraphLayoutView\nC++: vtkGraphLayoutView *SafeDownCast(vtkObject* o)\n\n"},
  {"SetVertexLabelArrayName", PyvtkGraphLayoutView_SetVertexLabelArrayName, METH_VARARGS,
   "V.SetVertexLabelArrayName(string)\nC++: void SetVertexLabelArrayName(const char *name)\n\nThe array to use for vertex labeling.  Default is \"VertexDegree\".\n"},
  {"GetVertexLabelArrayName", PyvtkGraphLayoutView_GetVertexLabelArrayName, METH_VARARGS,
   "V.GetVertexLabelArrayName() -> string\nC++: const char *GetVertexLabelArrayName()\n\nThe array to use for vertex labeling.  Default is \"VertexDegree\".\n"},
  {"SetEdgeLabelArrayName", PyvtkGraphLayoutView_SetEdgeLabelArrayName, METH_VARARGS,
   "V.SetEdgeLabelArrayName(string)\nC++: void SetEdgeLabelArrayName(const char *name)\n\nThe array to use for edge labeling.  Default is \"LabelText\".\n"},
  {"GetEdgeLabelArrayName", PyvtkGraphLayoutView_GetEdgeLabelArrayName, METH_VARARGS,
   "V.GetEdgeLabelArrayName() -> string\nC++: const char *GetEdgeLabelArrayName()\n\nThe array to use for edge labeling.  Default is \"LabelText\".\n"},
  {"SetVertexLabelVisibility", PyvtkGraphLayoutView_SetVertexLabelVisibility, METH_VARARGS,
   "V.SetVertexLabelVisibility(bool)\nC++: void SetVertexLabelVisibility(bool vis)\n\nWhether to show vertex labels.  Default is off.\n"},
  {"GetVertexLabelVisibility", PyvtkGraphLayoutView_GetVertexLabelVisibility, METH_VARARGS,
   "V.GetVertexLabelVisibility() -> bool\nC++: bool GetVertexLabelVisibility()\n\nWhether to show vertex labels.  Default is off.\n"},
  {"VertexLabelVisibilityOn", PyvtkGraphLayoutView_VertexLabelVisibilityOn, METH_VARARGS,
   "V.VertexLabelVisibilityOn()\nC++: void VertexLabelVisibilityOn()\n\nWhether to show vertex labels.  Default is off.\n"},
  {"VertexLabelVisibilityOff", PyvtkGraphLayoutView_VertexLabelVisibilityOff, METH_VARARGS,
   "V.VertexLabelVisibilityOff()\nC++: void VertexLabelVisibilityOff()\n\nWhether to show vertex labels.  Default is off.\n"},
  {"SetHideVertexLabelsOnInteraction", PyvtkGraphLayoutView_SetHideVertexLabelsOnInteraction, METH_VARARGS,
   "V.SetHideVertexLabelsOnInteraction(bool)\nC++: void SetHideVertexLabelsOnInteraction(bool vis)\n\nWhether to hide vertex labels during mouse interactions.  Default\nis off.\n"},
  {"GetHideVertexLabelsOnInteraction", PyvtkGraphLayoutView_GetHideVertexLabelsOnInteraction, METH_VARARGS,
   "V.GetHideVertexLabelsOnInteraction() -> bool\nC++: bool GetHideVertexLabelsOnInteraction()\n\nWhether to hide vertex labels during mouse interactions.  Default\nis off.\n"},
  {"HideVertexLabelsOnInteractionOn", PyvtkGraphLayoutView_HideVertexLabelsOnInteractionOn, METH_VARARGS,
   "V.HideVertexLabelsOnInteractionOn()\nC++: void HideVertexLabelsOnInteractionOn()\n\nWhether to hide vertex labels during mouse interactions.  Default\nis off.\n"},
  {"HideVertexLabelsOnInteractionOff", PyvtkGraphLayoutView_HideVertexLabelsOnInteractionOff, METH_VARARGS,
   "V.HideVertexLabelsOnInteractionOff()\nC++: void HideVertexLabelsOnInteractionOff()\n\nWhether to hide vertex labels during mouse interactions.  Default\nis off.\n"},
  {"SetEdgeVisibility", PyvtkGraphLayoutView_SetEdgeVisibility, METH_VARARGS,
   "V.SetEdgeVisibility(bool)\nC++: void SetEdgeVisibility(bool vis)\n\nWhether to show the edges at all. Default is on\n"},
  {"GetEdgeVisibility", PyvtkGraphLayoutView_GetEdgeVisibility, METH_VARARGS,
   "V.GetEdgeVisibility() -> bool\nC++: bool GetEdgeVisibility()\n\nWhether to show the edges at all. Default is on\n"},
  {"EdgeVisibilityOn", PyvtkGraphLayoutView_EdgeVisibilityOn, METH_VARARGS,
   "V.EdgeVisibilityOn()\nC++: void EdgeVisibilityOn()\n\nWhether to show the edges at all. Default is on\n"},
  {"EdgeVisibilityOff", PyvtkGraphLayoutView_EdgeVisibilityOff, METH_VARARGS,
   "V.EdgeVisibilityOff()\nC++: void EdgeVisibilityOff()\n\nWhether to show the edges at all. Default is on\n"},
  {"SetEdgeLabelVisibility", PyvtkGraphLayoutView_SetEdgeLabelVisibility, METH_VARARGS,
   "V.SetEdgeLabelVisibility(bool)\nC++: void SetEdgeLabelVisibility(bool vis)\n\nWhether to show edge labels.  Default is off.\n"},
  {"GetEdgeLabelVisibility", PyvtkGraphLayoutView_GetEdgeLabelVisibility, METH_VARARGS,
   "V.GetEdgeLabelVisibility() -> bool\nC++: bool GetEdgeLabelVisibility()\n\nWhether to show edge labels.  Default is off.\n"},
  {"EdgeLabelVisibilityOn", PyvtkGraphLayoutView_EdgeLabelVisibilityOn, METH_VARARGS,
   "V.EdgeLabelVisibilityOn()\nC++: void EdgeLabelVisibilityOn()\n\nWhether to show edge labels.  Default is off.\n"},
  {"EdgeLabelVisibilityOff", PyvtkGraphLayoutView_EdgeLabelVisibilityOff, METH_VARARGS,
   "V.EdgeLabelVisibilityOff()\nC++: void EdgeLabelVisibilityOff()\n\nWhether to show edge labels.  Default is off.\n"},
  {"SetHideEdgeLabelsOnInteraction", PyvtkGraphLayoutView_SetHideEdgeLabelsOnInteraction, METH_VARARGS,
   "V.SetHideEdgeLabelsOnInteraction(bool)\nC++: void SetHideEdgeLabelsOnInteraction(bool vis)\n\nWhether to hide edge labels during mouse interactions.  Default\nis off.\n"},
  {"GetHideEdgeLabelsOnInteraction", PyvtkGraphLayoutView_GetHideEdgeLabelsOnInteraction, METH_VARARGS,
   "V.GetHideEdgeLabelsOnInteraction() -> bool\nC++: bool GetHideEdgeLabelsOnInteraction()\n\nWhether to hide edge labels during mouse interactions.  Default\nis off.\n"},
  {"HideEdgeLabelsOnInteractionOn", PyvtkGraphLayoutView_HideEdgeLabelsOnInteractionOn, METH_VARARGS,
   "V.HideEdgeLabelsOnInteractionOn()\nC++: void HideEdgeLabelsOnInteractionOn()\n\nWhether to hide edge labels during mouse interactions.  Default\nis off.\n"},
  {"HideEdgeLabelsOnInteractionOff", PyvtkGraphLayoutView_HideEdgeLabelsOnInteractionOff, METH_VARARGS,
   "V.HideEdgeLabelsOnInteractionOff()\nC++: void HideEdgeLabelsOnInteractionOff()\n\nWhether to hide edge labels during mouse interactions.  Default\nis off.\n"},
  {"SetVertexColorArrayName", PyvtkGraphLayoutView_SetVertexColorArrayName, METH_VARARGS,
   "V.SetVertexColorArrayName(string)\nC++: void SetVertexColorArrayName(const char *name)\n\nThe array to use for coloring vertices.  The default behavior is\nto color by vertex degree.\n"},
  {"GetVertexColorArrayName", PyvtkGraphLayoutView_GetVertexColorArrayName, METH_VARARGS,
   "V.GetVertexColorArrayName() -> string\nC++: const char *GetVertexColorArrayName()\n\nThe array to use for coloring vertices.  The default behavior is\nto color by vertex degree.\n"},
  {"SetColorVertices", PyvtkGraphLayoutView_SetColorVertices, METH_VARARGS,
   "V.SetColorVertices(bool)\nC++: void SetColorVertices(bool vis)\n\nWhether to color vertices.  Default is off.\n"},
  {"GetColorVertices", PyvtkGraphLayoutView_GetColorVertices, METH_VARARGS,
   "V.GetColorVertices() -> bool\nC++: bool GetColorVertices()\n\nWhether to color vertices.  Default is off.\n"},
  {"ColorVerticesOn", PyvtkGraphLayoutView_ColorVerticesOn, METH_VARARGS,
   "V.ColorVerticesOn()\nC++: void ColorVerticesOn()\n\nWhether to color vertices.  Default is off.\n"},
  {"ColorVerticesOff", PyvtkGraphLayoutView_ColorVerticesOff, METH_VARARGS,
   "V.ColorVerticesOff()\nC++: void ColorVerticesOff()\n\nWhether to color vertices.  Default is off.\n"},
  {"SetEdgeColorArrayName", PyvtkGraphLayoutView_SetEdgeColorArrayName, METH_VARARGS,
   "V.SetEdgeColorArrayName(string)\nC++: void SetEdgeColorArrayName(const char *name)\n\nThe array to use for coloring edges.  Default is \"color\".\n"},
  {"GetEdgeColorArrayName", PyvtkGraphLayoutView_GetEdgeColorArrayName, METH_VARARGS,
   "V.GetEdgeColorArrayName() -> string\nC++: const char *GetEdgeColorArrayName()\n\nThe array to use for coloring edges.  Default is \"color\".\n"},
  {"SetColorEdges", PyvtkGraphLayoutView_SetColorEdges, METH_VARARGS,
   "V.SetColorEdges(bool)\nC++: void SetColorEdges(bool vis)\n\nWhether to color edges.  Default is off.\n"},
  {"GetColorEdges", PyvtkGraphLayoutView_GetColorEdges, METH_VARARGS,
   "V.GetColorEdges() -> bool\nC++: bool GetColorEdges()\n\nWhether to color edges.  Default is off.\n"},
  {"ColorEdgesOn", PyvtkGraphLayoutView_ColorEdgesOn, METH_VARARGS,
   "V.ColorEdgesOn()\nC++: void ColorEdgesOn()\n\nWhether to color edges.  Default is off.\n"},
  {"ColorEdgesOff", PyvtkGraphLayoutView_ColorEdgesOff, METH_VARARGS,
   "V.ColorEdgesOff()\nC++: void ColorEdgesOff()\n\nWhether to color edges.  Default is off.\n"},
  {"SetEdgeSelection", PyvtkGraphLayoutView_SetEdgeSelection, METH_VARARGS,
   "V.SetEdgeSelection(bool)\nC++: void SetEdgeSelection(bool vis)\n\nWhether edges are selectable. Default is on.\n"},
  {"GetEdgeSelection", PyvtkGraphLayoutView_GetEdgeSelection, METH_VARARGS,
   "V.GetEdgeSelection() -> bool\nC++: bool GetEdgeSelection()\n\nWhether edges are selectable. Default is on.\n"},
  {"EdgeSelectionOn", PyvtkGraphLayoutView_EdgeSelectionOn, METH_VARARGS,
   "V.EdgeSelectionOn()\nC++: void EdgeSelectionOn()\n\nWhether edges are selectable. Default is on.\n"},
  {"EdgeSelectionOff", PyvtkGraphLayoutView_EdgeSelectionOff, METH_VARARGS,
   "V.EdgeSelectionOff()\nC++: void EdgeSelectionOff()\n\nWhether edges are selectable. Default is on.\n"},
  {"SetEnabledEdgesArrayName", PyvtkGraphLayoutView_SetEnabledEdgesArrayName, METH_VARARGS,
   "V.SetEnabledEdgesArrayName(string)\nC++: void SetEnabledEdgesArrayName(const char *name)\n\nThe array to use for coloring edges.\n"},
  {"GetEnabledEdgesArrayName", PyvtkGraphLayoutView_GetEnabledEdgesArrayName, METH_VARARGS,
   "V.GetEnabledEdgesArrayName() -> string\nC++: const char *GetEnabledEdgesArrayName()\n\nThe array to use for coloring edges.\n"},
  {"SetEnableEdgesByArray", PyvtkGraphLayoutView_SetEnableEdgesByArray, METH_VARARGS,
   "V.SetEnableEdgesByArray(bool)\nC++: void SetEnableEdgesByArray(bool vis)\n\nWhether to color edges.  Default is off.\n"},
  {"GetEnableEdgesByArray", PyvtkGraphLayoutView_GetEnableEdgesByArray, METH_VARARGS,
   "V.GetEnableEdgesByArray() -> int\nC++: int GetEnableEdgesByArray()\n\nWhether to color edges.  Default is off.\n"},
  {"SetEnabledVerticesArrayName", PyvtkGraphLayoutView_SetEnabledVerticesArrayName, METH_VARARGS,
   "V.SetEnabledVerticesArrayName(string)\nC++: void SetEnabledVerticesArrayName(const char *name)\n\nThe array to use for coloring vertices.\n"},
  {"GetEnabledVerticesArrayName", PyvtkGraphLayoutView_GetEnabledVerticesArrayName, METH_VARARGS,
   "V.GetEnabledVerticesArrayName() -> string\nC++: const char *GetEnabledVerticesArrayName()\n\nThe array to use for coloring vertices.\n"},
  {"SetEnableVerticesByArray", PyvtkGraphLayoutView_SetEnableVerticesByArray, METH_VARARGS,
   "V.SetEnableVerticesByArray(bool)\nC++: void SetEnableVerticesByArray(bool vis)\n\nWhether to color vertices.  Default is off.\n"},
  {"GetEnableVerticesByArray", PyvtkGraphLayoutView_GetEnableVerticesByArray, METH_VARARGS,
   "V.GetEnableVerticesByArray() -> int\nC++: int GetEnableVerticesByArray()\n\nWhether to color vertices.  Default is off.\n"},
  {"SetScalingArrayName", PyvtkGraphLayoutView_SetScalingArrayName, METH_VARARGS,
   "V.SetScalingArrayName(string)\nC++: void SetScalingArrayName(const char *name)\n\nThe array used for scaling (if ScaledGlyphs is ON)\n"},
  {"GetScalingArrayName", PyvtkGraphLayoutView_GetScalingArrayName, METH_VARARGS,
   "V.GetScalingArrayName() -> string\nC++: const char *GetScalingArrayName()\n\nThe array used for scaling (if ScaledGlyphs is ON)\n"},
  {"SetScaledGlyphs", PyvtkGraphLayoutView_SetScaledGlyphs, METH_VARARGS,
   "V.SetScaledGlyphs(bool)\nC++: void SetScaledGlyphs(bool arg)\n\nWhether to use scaled glyphs or not.  Default is off.\n"},
  {"GetScaledGlyphs", PyvtkGraphLayoutView_GetScaledGlyphs, METH_VARARGS,
   "V.GetScaledGlyphs() -> bool\nC++: bool GetScaledGlyphs()\n\nWhether to use scaled glyphs or not.  Default is off.\n"},
  {"ScaledGlyphsOn", PyvtkGraphLayoutView_ScaledGlyphsOn, METH_VARARGS,
   "V.ScaledGlyphsOn()\nC++: void ScaledGlyphsOn()\n\nWhether to use scaled glyphs or not.  Default is off.\n"},
  {"ScaledGlyphsOff", PyvtkGraphLayoutView_ScaledGlyphsOff, METH_VARARGS,
   "V.ScaledGlyphsOff()\nC++: void ScaledGlyphsOff()\n\nWhether to use scaled glyphs or not.  Default is off.\n"},
  {"SetLayoutStrategy", PyvtkGraphLayoutView_SetLayoutStrategy, METH_VARARGS,
   "V.SetLayoutStrategy(string)\nC++: void SetLayoutStrategy(const char *name)\nV.SetLayoutStrategy(vtkGraphLayoutStrategy)\nC++: void SetLayoutStrategy(vtkGraphLayoutStrategy *s)\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToRandom", PyvtkGraphLayoutView_SetLayoutStrategyToRandom, METH_VARARGS,
   "V.SetLayoutStrategyToRandom()\nC++: void SetLayoutStrategyToRandom()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToForceDirected", PyvtkGraphLayoutView_SetLayoutStrategyToForceDirected, METH_VARARGS,
   "V.SetLayoutStrategyToForceDirected()\nC++: void SetLayoutStrategyToForceDirected()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToSimple2D", PyvtkGraphLayoutView_SetLayoutStrategyToSimple2D, METH_VARARGS,
   "V.SetLayoutStrategyToSimple2D()\nC++: void SetLayoutStrategyToSimple2D()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToClustering2D", PyvtkGraphLayoutView_SetLayoutStrategyToClustering2D, METH_VARARGS,
   "V.SetLayoutStrategyToClustering2D()\nC++: void SetLayoutStrategyToClustering2D()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToCommunity2D", PyvtkGraphLayoutView_SetLayoutStrategyToCommunity2D, METH_VARARGS,
   "V.SetLayoutStrategyToCommunity2D()\nC++: void SetLayoutStrategyToCommunity2D()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToFast2D", PyvtkGraphLayoutView_SetLayoutStrategyToFast2D, METH_VARARGS,
   "V.SetLayoutStrategyToFast2D()\nC++: void SetLayoutStrategyToFast2D()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToPassThrough", PyvtkGraphLayoutView_SetLayoutStrategyToPassThrough, METH_VARARGS,
   "V.SetLayoutStrategyToPassThrough()\nC++: void SetLayoutStrategyToPassThrough()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToCircular", PyvtkGraphLayoutView_SetLayoutStrategyToCircular, METH_VARARGS,
   "V.SetLayoutStrategyToCircular()\nC++: void SetLayoutStrategyToCircular()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToTree", PyvtkGraphLayoutView_SetLayoutStrategyToTree, METH_VARARGS,
   "V.SetLayoutStrategyToTree()\nC++: void SetLayoutStrategyToTree()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToCosmicTree", PyvtkGraphLayoutView_SetLayoutStrategyToCosmicTree, METH_VARARGS,
   "V.SetLayoutStrategyToCosmicTree()\nC++: void SetLayoutStrategyToCosmicTree()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToCone", PyvtkGraphLayoutView_SetLayoutStrategyToCone, METH_VARARGS,
   "V.SetLayoutStrategyToCone()\nC++: void SetLayoutStrategyToCone()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"SetLayoutStrategyToSpanTree", PyvtkGraphLayoutView_SetLayoutStrategyToSpanTree, METH_VARARGS,
   "V.SetLayoutStrategyToSpanTree()\nC++: void SetLayoutStrategyToSpanTree()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"GetLayoutStrategyName", PyvtkGraphLayoutView_GetLayoutStrategyName, METH_VARARGS,
   "V.GetLayoutStrategyName() -> string\nC++: const char *GetLayoutStrategyName()\n\nThe layout strategy to use when performing the graph layout. The\npossible strings are:\n- \"Random\"         Randomly places vertices in a box.\n- \"Force Directed\" A layout in 3D or 2D simulating forces on\n  edges.\n- \"Simple 2D\"      A simple 2D force directed layout.\n- \"Clustering 2D\"  A 2D force directed layout that's just like\n  simple 2D but uses some techniques to cluster better.\n- \"Community 2D\"   A linear-time 2D layout that's just like Fast\n  2D but looks for and uses a community array to 'accentuate'\n  clusters.\n- \"Fast 2D\"       A linear-time 2D layout.\n- \"Pass Through\"  Use locations assigned to the input.\n- \"Circular\"      Places vertices uniformly on a circle.\n- \"Cone\"          Cone tree layout.\n- \"Span Tree\"     Span Tree Layout. Default is \"Simple 2D\".\n"},
  {"GetLayoutStrategy", PyvtkGraphLayoutView_GetLayoutStrategy, METH_VARARGS,
   "V.GetLayoutStrategy() -> vtkGraphLayoutStrategy\nC++: vtkGraphLayoutStrategy *GetLayoutStrategy()\n\nThe layout strategy to use when performing the graph layout. This\nsignature allows an application to create a layout object\ndirectly and simply set the pointer through this method.\n"},
  {"SetEdgeLayoutStrategy", PyvtkGraphLayoutView_SetEdgeLayoutStrategy, METH_VARARGS,
   "V.SetEdgeLayoutStrategy(string)\nC++: void SetEdgeLayoutStrategy(const char *name)\nV.SetEdgeLayoutStrategy(vtkEdgeLayoutStrategy)\nC++: void SetEdgeLayoutStrategy(vtkEdgeLayoutStrategy *s)\n\nThe layout strategy to use when performing the edge layout. The\npossible strings are: \"Arc Parallel\"   - Arc parallel edges and\nself loops. \"Pass Through\"   - Use edge routes assigned to the\ninput. Default is \"Arc Parallel\".\n"},
  {"SetEdgeLayoutStrategyToArcParallel", PyvtkGraphLayoutView_SetEdgeLayoutStrategyToArcParallel, METH_VARARGS,
   "V.SetEdgeLayoutStrategyToArcParallel()\nC++: void SetEdgeLayoutStrategyToArcParallel()\n\nThe layout strategy to use when performing the edge layout. The\npossible strings are: \"Arc Parallel\"   - Arc parallel edges and\nself loops. \"Pass Through\"   - Use edge routes assigned to the\ninput. Default is \"Arc Parallel\".\n"},
  {"SetEdgeLayoutStrategyToPassThrough", PyvtkGraphLayoutView_SetEdgeLayoutStrategyToPassThrough, METH_VARARGS,
   "V.SetEdgeLayoutStrategyToPassThrough()\nC++: void SetEdgeLayoutStrategyToPassThrough()\n\nThe layout strategy to use when performing the edge layout. The\npossible strings are: \"Arc Parallel\"   - Arc parallel edges and\nself loops. \"Pass Through\"   - Use edge routes assigned to the\ninput. Default is \"Arc Parallel\".\n"},
  {"GetEdgeLayoutStrategyName", PyvtkGraphLayoutView_GetEdgeLayoutStrategyName, METH_VARARGS,
   "V.GetEdgeLayoutStrategyName() -> string\nC++: const char *GetEdgeLayoutStrategyName()\n\nThe layout strategy to use when performing the edge layout. The\npossible strings are: \"Arc Parallel\"   - Arc parallel edges and\nself loops. \"Pass Through\"   - Use edge routes assigned to the\ninput. Default is \"Arc Parallel\".\n"},
  {"GetEdgeLayoutStrategy", PyvtkGraphLayoutView_GetEdgeLayoutStrategy, METH_VARARGS,
   "V.GetEdgeLayoutStrategy() -> vtkEdgeLayoutStrategy\nC++: vtkEdgeLayoutStrategy *GetEdgeLayoutStrategy()\n\nThe layout strategy to use when performing the edge layout. This\nsignature allows an application to create a layout object\ndirectly and simply set the pointer through this method.\n"},
  {"AddIconType", PyvtkGraphLayoutView_AddIconType, METH_VARARGS,
   "V.AddIconType(string, int)\nC++: void AddIconType(char *type, int index)\n\nAssociate the icon at index \"index\" in the vtkTexture to all\nvertices containing \"type\" as a value in the vertex attribute\narray specified by IconArrayName.\n"},
  {"ClearIconTypes", PyvtkGraphLayoutView_ClearIconTypes, METH_VARARGS,
   "V.ClearIconTypes()\nC++: void ClearIconTypes()\n\nClear all icon mappings.\n"},
  {"SetIconAlignment", PyvtkGraphLayoutView_SetIconAlignment, METH_VARARGS,
   "V.SetIconAlignment(int)\nC++: void SetIconAlignment(int alignment)\n\nSpecify where the icons should be placed in relation to the\nvertex. See vtkIconGlyphFilter.h for possible values.\n"},
  {"SetIconVisibility", PyvtkGraphLayoutView_SetIconVisibility, METH_VARARGS,
   "V.SetIconVisibility(bool)\nC++: void SetIconVisibility(bool b)\n\nWhether icons are visible (default off).\n"},
  {"GetIconVisibility", PyvtkGraphLayoutView_GetIconVisibility, METH_VARARGS,
   "V.GetIconVisibility() -> bool\nC++: bool GetIconVisibility()\n\nWhether icons are visible (default off).\n"},
  {"IconVisibilityOn", PyvtkGraphLayoutView_IconVisibilityOn, METH_VARARGS,
   "V.IconVisibilityOn()\nC++: void IconVisibilityOn()\n\nWhether icons are visible (default off).\n"},
  {"IconVisibilityOff", PyvtkGraphLayoutView_IconVisibilityOff, METH_VARARGS,
   "V.IconVisibilityOff()\nC++: void IconVisibilityOff()\n\nWhether icons are visible (default off).\n"},
  {"SetIconArrayName", PyvtkGraphLayoutView_SetIconArrayName, METH_VARARGS,
   "V.SetIconArrayName(string)\nC++: void SetIconArrayName(const char *name)\n\nThe array used for assigning icons\n"},
  {"GetIconArrayName", PyvtkGraphLayoutView_GetIconArrayName, METH_VARARGS,
   "V.GetIconArrayName() -> string\nC++: const char *GetIconArrayName()\n\nThe array used for assigning icons\n"},
  {"SetGlyphType", PyvtkGraphLayoutView_SetGlyphType, METH_VARARGS,
   "V.SetGlyphType(int)\nC++: void SetGlyphType(int type)\n\nThe type of glyph to use for the vertices\n"},
  {"GetGlyphType", PyvtkGraphLayoutView_GetGlyphType, METH_VARARGS,
   "V.GetGlyphType() -> int\nC++: int GetGlyphType()\n\nThe type of glyph to use for the vertices\n"},
  {"SetVertexLabelFontSize", PyvtkGraphLayoutView_SetVertexLabelFontSize, METH_VARARGS,
   "V.SetVertexLabelFontSize(int)\nC++: virtual void SetVertexLabelFontSize(const int size)\n\nThe size of the font used for vertex labeling\n"},
  {"GetVertexLabelFontSize", PyvtkGraphLayoutView_GetVertexLabelFontSize, METH_VARARGS,
   "V.GetVertexLabelFontSize() -> int\nC++: virtual int GetVertexLabelFontSize()\n\nThe size of the font used for vertex labeling\n"},
  {"SetEdgeLabelFontSize", PyvtkGraphLayoutView_SetEdgeLabelFontSize, METH_VARARGS,
   "V.SetEdgeLabelFontSize(int)\nC++: virtual void SetEdgeLabelFontSize(const int size)\n\nThe size of the font used for edge labeling\n"},
  {"GetEdgeLabelFontSize", PyvtkGraphLayoutView_GetEdgeLabelFontSize, METH_VARARGS,
   "V.GetEdgeLabelFontSize() -> int\nC++: virtual int GetEdgeLabelFontSize()\n\nThe size of the font used for edge labeling\n"},
  {"SetEdgeScalarBarVisibility", PyvtkGraphLayoutView_SetEdgeScalarBarVisibility, METH_VARARGS,
   "V.SetEdgeScalarBarVisibility(bool)\nC++: void SetEdgeScalarBarVisibility(bool vis)\n\nWhether the scalar bar for edges is visible.  Default is off.\n"},
  {"GetEdgeScalarBarVisibility", PyvtkGraphLayoutView_GetEdgeScalarBarVisibility, METH_VARARGS,
   "V.GetEdgeScalarBarVisibility() -> bool\nC++: bool GetEdgeScalarBarVisibility()\n\nWhether the scalar bar for edges is visible.  Default is off.\n"},
  {"SetVertexScalarBarVisibility", PyvtkGraphLayoutView_SetVertexScalarBarVisibility, METH_VARARGS,
   "V.SetVertexScalarBarVisibility(bool)\nC++: void SetVertexScalarBarVisibility(bool vis)\n\nWhether the scalar bar for vertices is visible.  Default is off.\n"},
  {"GetVertexScalarBarVisibility", PyvtkGraphLayoutView_GetVertexScalarBarVisibility, METH_VARARGS,
   "V.GetVertexScalarBarVisibility() -> bool\nC++: bool GetVertexScalarBarVisibility()\n\nWhether the scalar bar for vertices is visible.  Default is off.\n"},
  {"ZoomToSelection", PyvtkGraphLayoutView_ZoomToSelection, METH_VARARGS,
   "V.ZoomToSelection()\nC++: void ZoomToSelection()\n\nReset the camera based on the bounds of the selected region.\n"},
  {"IsLayoutComplete", PyvtkGraphLayoutView_IsLayoutComplete, METH_VARARGS,
   "V.IsLayoutComplete() -> int\nC++: virtual int IsLayoutComplete()\n\nIs the graph layout complete? This method is useful for when the\nstrategy is iterative and the application wants to show the\niterative progress of the graph layout See Also: UpdateLayout();\n"},
  {"UpdateLayout", PyvtkGraphLayoutView_UpdateLayout, METH_VARARGS,
   "V.UpdateLayout()\nC++: virtual void UpdateLayout()\n\nThis method is useful for when the strategy is iterative and the\napplication wants to show the iterative progress of the graph\nlayout. The application would have something like\nwhile(!IsLayoutComplete()) { UpdateLayout(); } See Also:\nIsLayoutComplete();\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGraphLayoutView_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkGraphLayoutView", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGraphLayoutView_StaticNew()
{
  return vtkGraphLayoutView::New();
}

PyObject *PyvtkGraphLayoutView_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGraphLayoutView_Type, PyvtkGraphLayoutView_Methods,
    "vtkGraphLayoutView",
    PyvtkGraphLayoutView_Doc(), &PyvtkGraphLayoutView_StaticNew);

  PyTypeObject *pytype = &PyvtkGraphLayoutView_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkRenderView_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGraphLayoutView_Doc()
{
  static const char *docstring[] = {
    "vtkGraphLayoutView - Lays out and displays a graph\n\n",
    "Superclass: vtkRenderView\n\n",
    "vtkGraphLayoutView performs graph layout and displays a vtkGraph. You\nmay color and label the vertices and edges using fields in the graph.\nIf coordinates are already assigned to the graph vertices in your\ngraph, set the layout strategy to PassThrough in this view. The\ndefault layout is Fast2D which is fast but not that good, for better\nlayout set the layout to Simple2D or ForceDirected. There are",
    " also\ntree and circle layout strategies. :)\n\n.SEE ALSO vtkFast2DLayoutStrategy vtkSimple2DLayoutStrategy\nvtkForceDirectedLayoutStrategy\n\n@par Thanks: Thanks a bunch to the holographic unfolding pattern.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGraphLayoutView(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGraphLayoutView_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGraphLayoutView", o) != 0)
  {
    Py_DECREF(o);
  }

}

