// python wrapper for vtkImageRFFT
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkImageRFFT.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageRFFT(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageRFFT_ClassNew(); }

#ifndef DECLARED_PyvtkImageFourierFilter_ClassNew
extern "C" { PyObject *PyvtkImageFourierFilter_ClassNew(); }
#define DECLARED_PyvtkImageFourierFilter_ClassNew
#endif

static const char **PyvtkImageRFFT_Doc();


static PyObject *
PyvtkImageRFFT_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageRFFT *op = static_cast<vtkImageRFFT *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageRFFT::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageRFFT_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageRFFT *op = static_cast<vtkImageRFFT *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageRFFT::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageRFFT_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageRFFT *op = static_cast<vtkImageRFFT *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageRFFT *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageRFFT::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkImageRFFT_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkImageRFFT *tempr = vtkImageRFFT::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkImageRFFT_Methods[] = {
  {"GetClassName", PyvtkImageRFFT_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImageRFFT_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImageRFFT_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageRFFT\nC++: vtkImageRFFT *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImageRFFT_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageRFFT\nC++: vtkImageRFFT *SafeDownCast(vtkObject* o)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageRFFT_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingFourierPython.vtkImageRFFT", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageRFFT_StaticNew()
{
  return vtkImageRFFT::New();
}

PyObject *PyvtkImageRFFT_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageRFFT_Type, PyvtkImageRFFT_Methods,
    "vtkImageRFFT",
    PyvtkImageRFFT_Doc(), &PyvtkImageRFFT_StaticNew);

  PyTypeObject *pytype = &PyvtkImageRFFT_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageFourierFilter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageRFFT_Doc()
{
  static const char *docstring[] = {
    "vtkImageRFFT - Reverse Fast Fourier Transform.\n\n",
    "Superclass: vtkImageFourierFilter\n\n",
    "vtkImageRFFT implements the reverse fast Fourier transform.  The\ninput can have real or complex data in any components and data types,\nbut the output is always complex doubles with real values in\ncomponent0, and imaginary values in component1.  The filter is\nfastest for images that have power of two sizes.  The filter uses a\nbutterfly fitlers for each prime factor of the dimension.  This makes\nima",
    "ges with prime number dimensions (i.e. 17x17) much slower to\ncompute.  Multi dimensional (i.e volumes) FFT's are decomposed so\nthat each axis executes in series. In most cases the RFFT will\nproduce an image whose imaginary values are all zero's. In this case\nvtkImageExtractComponents can be used to remove this imaginary\ncomponents leaving only the real image.\n\n@sa\nvtkImageExtractComponenents\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageRFFT(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageRFFT_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageRFFT", o) != 0)
  {
    Py_DECREF(o);
  }

}

