// python wrapper for vtkImageToStructuredPoints
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkImageToStructuredPoints.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageToStructuredPoints(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageToStructuredPoints_ClassNew(); }

#ifndef DECLARED_PyvtkImageAlgorithm_ClassNew
extern "C" { PyObject *PyvtkImageAlgorithm_ClassNew(); }
#define DECLARED_PyvtkImageAlgorithm_ClassNew
#endif

static const char **PyvtkImageToStructuredPoints_Doc();


static PyObject *
PyvtkImageToStructuredPoints_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageToStructuredPoints *op = static_cast<vtkImageToStructuredPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageToStructuredPoints::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageToStructuredPoints_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageToStructuredPoints *op = static_cast<vtkImageToStructuredPoints *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageToStructuredPoints::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageToStructuredPoints_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageToStructuredPoints *op = static_cast<vtkImageToStructuredPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageToStructuredPoints *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageToStructuredPoints::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkImageToStructuredPoints_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkImageToStructuredPoints *tempr = vtkImageToStructuredPoints::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageToStructuredPoints_SetVectorInputData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVectorInputData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageToStructuredPoints *op = static_cast<vtkImageToStructuredPoints *>(vp);

  vtkImageData *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SetVectorInputData(temp0);
    }
    else
    {
      op->vtkImageToStructuredPoints::SetVectorInputData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImageToStructuredPoints_GetVectorInput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVectorInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageToStructuredPoints *op = static_cast<vtkImageToStructuredPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetVectorInput() :
      op->vtkImageToStructuredPoints::GetVectorInput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageToStructuredPoints_GetStructuredPointsOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStructuredPointsOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageToStructuredPoints *op = static_cast<vtkImageToStructuredPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkStructuredPoints *tempr = (ap.IsBound() ?
      op->GetStructuredPointsOutput() :
      op->vtkImageToStructuredPoints::GetStructuredPointsOutput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkImageToStructuredPoints_Methods[] = {
  {"GetClassName", PyvtkImageToStructuredPoints_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImageToStructuredPoints_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImageToStructuredPoints_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageToStructuredPoints\nC++: vtkImageToStructuredPoints *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImageToStructuredPoints_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageToStructuredPoints\nC++: vtkImageToStructuredPoints *SafeDownCast(vtkObject* o)\n\n"},
  {"SetVectorInputData", PyvtkImageToStructuredPoints_SetVectorInputData, METH_VARARGS,
   "V.SetVectorInputData(vtkImageData)\nC++: void SetVectorInputData(vtkImageData *input)\n\nSet/Get the input object from the image pipeline.\n"},
  {"GetVectorInput", PyvtkImageToStructuredPoints_GetVectorInput, METH_VARARGS,
   "V.GetVectorInput() -> vtkImageData\nC++: vtkImageData *GetVectorInput()\n\nSet/Get the input object from the image pipeline.\n"},
  {"GetStructuredPointsOutput", PyvtkImageToStructuredPoints_GetStructuredPointsOutput, METH_VARARGS,
   "V.GetStructuredPointsOutput() -> vtkStructuredPoints\nC++: vtkStructuredPoints *GetStructuredPointsOutput()\n\nGet the output of the filter.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageToStructuredPoints_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonExecutionModelPython.vtkImageToStructuredPoints", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageToStructuredPoints_StaticNew()
{
  return vtkImageToStructuredPoints::New();
}

PyObject *PyvtkImageToStructuredPoints_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageToStructuredPoints_Type, PyvtkImageToStructuredPoints_Methods,
    "vtkImageToStructuredPoints",
    PyvtkImageToStructuredPoints_Doc(), &PyvtkImageToStructuredPoints_StaticNew);

  PyTypeObject *pytype = &PyvtkImageToStructuredPoints_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageToStructuredPoints_Doc()
{
  static const char *docstring[] = {
    "vtkImageToStructuredPoints - Attaches image pipeline to VTK.\n\n",
    "Superclass: vtkImageAlgorithm\n\n",
    "vtkImageToStructuredPoints changes an image cache format to a\nstructured points dataset.  It takes an Input plus an optional\nVectorInput. The VectorInput converts the RGB scalar components of\nthe VectorInput to vector pointdata attributes. This filter will try\nto reference count the data but in some cases it must make a copy.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageToStructuredPoints(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageToStructuredPoints_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageToStructuredPoints", o) != 0)
  {
    Py_DECREF(o);
  }

}

