// python wrapper for vtkImageTranslateExtent
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkImageTranslateExtent.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageTranslateExtent(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageTranslateExtent_ClassNew(); }

#ifndef DECLARED_PyvtkImageAlgorithm_ClassNew
extern "C" { PyObject *PyvtkImageAlgorithm_ClassNew(); }
#define DECLARED_PyvtkImageAlgorithm_ClassNew
#endif

static const char **PyvtkImageTranslateExtent_Doc();


static PyObject *
PyvtkImageTranslateExtent_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageTranslateExtent *op = static_cast<vtkImageTranslateExtent *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImageTranslateExtent::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageTranslateExtent_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageTranslateExtent *op = static_cast<vtkImageTranslateExtent *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageTranslateExtent::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageTranslateExtent_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageTranslateExtent *op = static_cast<vtkImageTranslateExtent *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageTranslateExtent *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageTranslateExtent::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkImageTranslateExtent_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkImageTranslateExtent *tempr = vtkImageTranslateExtent::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageTranslateExtent_SetTranslation_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTranslation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageTranslateExtent *op = static_cast<vtkImageTranslateExtent *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetTranslation(temp0, temp1, temp2);
    }
    else
    {
      op->vtkImageTranslateExtent::SetTranslation(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageTranslateExtent_SetTranslation_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTranslation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageTranslateExtent *op = static_cast<vtkImageTranslateExtent *>(vp);

  const int size0 = 3;
  int temp0[3];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetTranslation(temp0);
    }
    else
    {
      op->vtkImageTranslateExtent::SetTranslation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImageTranslateExtent_SetTranslation(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkImageTranslateExtent_SetTranslation_s1(self, args);
    case 1:
      return PyvtkImageTranslateExtent_SetTranslation_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetTranslation");
  return NULL;
}



static PyObject *
PyvtkImageTranslateExtent_GetTranslation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTranslation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageTranslateExtent *op = static_cast<vtkImageTranslateExtent *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetTranslation() :
      op->vtkImageTranslateExtent::GetTranslation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}

static PyMethodDef PyvtkImageTranslateExtent_Methods[] = {
  {"GetClassName", PyvtkImageTranslateExtent_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImageTranslateExtent_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImageTranslateExtent_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageTranslateExtent\nC++: vtkImageTranslateExtent *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImageTranslateExtent_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImageTranslateExtent\nC++: vtkImageTranslateExtent *SafeDownCast(vtkObject* o)\n\n"},
  {"SetTranslation", PyvtkImageTranslateExtent_SetTranslation, METH_VARARGS,
   "V.SetTranslation(int, int, int)\nC++: void SetTranslation(int, int, int)\nV.SetTranslation((int, int, int))\nC++: void SetTranslation(int a[3])\n\n"},
  {"GetTranslation", PyvtkImageTranslateExtent_GetTranslation, METH_VARARGS,
   "V.GetTranslation() -> (int, int, int)\nC++: int *GetTranslation()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageTranslateExtent_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingCorePython.vtkImageTranslateExtent", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageTranslateExtent_StaticNew()
{
  return vtkImageTranslateExtent::New();
}

PyObject *PyvtkImageTranslateExtent_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageTranslateExtent_Type, PyvtkImageTranslateExtent_Methods,
    "vtkImageTranslateExtent",
    PyvtkImageTranslateExtent_Doc(), &PyvtkImageTranslateExtent_StaticNew);

  PyTypeObject *pytype = &PyvtkImageTranslateExtent_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageTranslateExtent_Doc()
{
  static const char *docstring[] = {
    "vtkImageTranslateExtent - Changes extent, nothing else.\n\n",
    "Superclass: vtkImageAlgorithm\n\n",
    "vtkImageTranslateExtent  shift the whole extent, but does not change\nthe data.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageTranslateExtent(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageTranslateExtent_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageTranslateExtent", o) != 0)
  {
    Py_DECREF(o);
  }

}

