// python wrapper for vtkImplicitCylinderWidget
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkImplicitCylinderWidget.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImplicitCylinderWidget(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImplicitCylinderWidget_ClassNew(); }

#ifndef DECLARED_PyvtkAbstractWidget_ClassNew
extern "C" { PyObject *PyvtkAbstractWidget_ClassNew(); }
#define DECLARED_PyvtkAbstractWidget_ClassNew
#endif

static const char **PyvtkImplicitCylinderWidget_Doc();


static PyObject *
PyvtkImplicitCylinderWidget_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitCylinderWidget *op = static_cast<vtkImplicitCylinderWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImplicitCylinderWidget::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitCylinderWidget_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitCylinderWidget *op = static_cast<vtkImplicitCylinderWidget *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImplicitCylinderWidget::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitCylinderWidget_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitCylinderWidget *op = static_cast<vtkImplicitCylinderWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImplicitCylinderWidget *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImplicitCylinderWidget::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitCylinderWidget_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkImplicitCylinderWidget *tempr = vtkImplicitCylinderWidget::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitCylinderWidget_SetRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitCylinderWidget *op = static_cast<vtkImplicitCylinderWidget *>(vp);

  vtkImplicitCylinderRepresentation *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImplicitCylinderRepresentation"))
  {
    if (ap.IsBound())
    {
      op->SetRepresentation(temp0);
    }
    else
    {
      op->vtkImplicitCylinderWidget::SetRepresentation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitCylinderWidget_SetEnabled(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnabled");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitCylinderWidget *op = static_cast<vtkImplicitCylinderWidget *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEnabled(temp0);
    }
    else
    {
      op->vtkImplicitCylinderWidget::SetEnabled(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitCylinderWidget_GetCylinderRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCylinderRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitCylinderWidget *op = static_cast<vtkImplicitCylinderWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImplicitCylinderRepresentation *tempr = (ap.IsBound() ?
      op->GetCylinderRepresentation() :
      op->vtkImplicitCylinderWidget::GetCylinderRepresentation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitCylinderWidget_CreateDefaultRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitCylinderWidget *op = static_cast<vtkImplicitCylinderWidget *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CreateDefaultRepresentation();
    }
    else
    {
      op->vtkImplicitCylinderWidget::CreateDefaultRepresentation();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkImplicitCylinderWidget_Methods[] = {
  {"GetClassName", PyvtkImplicitCylinderWidget_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nStandard vtkObject methods\n"},
  {"IsA", PyvtkImplicitCylinderWidget_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nStandard vtkObject methods\n"},
  {"NewInstance", PyvtkImplicitCylinderWidget_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImplicitCylinderWidget\nC++: vtkImplicitCylinderWidget *NewInstance()\n\nStandard vtkObject methods\n"},
  {"SafeDownCast", PyvtkImplicitCylinderWidget_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImplicitCylinderWidget\nC++: vtkImplicitCylinderWidget *SafeDownCast(vtkObject* o)\n\nStandard vtkObject methods\n"},
  {"SetRepresentation", PyvtkImplicitCylinderWidget_SetRepresentation, METH_VARARGS,
   "V.SetRepresentation(vtkImplicitCylinderRepresentation)\nC++: void SetRepresentation(\n    vtkImplicitCylinderRepresentation *rep)\n\nSpecify an instance of vtkWidgetRepresentation used to represent\nthis widget in the scene. Note that the representation is a\nsubclass of vtkProp so it can be added to the renderer\nindependent of the widget.\n"},
  {"SetEnabled", PyvtkImplicitCylinderWidget_SetEnabled, METH_VARARGS,
   "V.SetEnabled(int)\nC++: void SetEnabled(int enabling)\n\n"},
  {"GetCylinderRepresentation", PyvtkImplicitCylinderWidget_GetCylinderRepresentation, METH_VARARGS,
   "V.GetCylinderRepresentation() -> vtkImplicitCylinderRepresentation\nC++: vtkImplicitCylinderRepresentation *GetCylinderRepresentation(\n    )\n\nReturn the representation as a vtkImplicitCylinderRepresentation.\n"},
  {"CreateDefaultRepresentation", PyvtkImplicitCylinderWidget_CreateDefaultRepresentation, METH_VARARGS,
   "V.CreateDefaultRepresentation()\nC++: void CreateDefaultRepresentation()\n\nCreate the default widget representation if one is not set.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImplicitCylinderWidget_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInteractionWidgetsPython.vtkImplicitCylinderWidget", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImplicitCylinderWidget_StaticNew()
{
  return vtkImplicitCylinderWidget::New();
}

PyObject *PyvtkImplicitCylinderWidget_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImplicitCylinderWidget_Type, PyvtkImplicitCylinderWidget_Methods,
    "vtkImplicitCylinderWidget",
    PyvtkImplicitCylinderWidget_Doc(), &PyvtkImplicitCylinderWidget_StaticNew);

  PyTypeObject *pytype = &PyvtkImplicitCylinderWidget_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAbstractWidget_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImplicitCylinderWidget_Doc()
{
  static const char *docstring[] = {
    "vtkImplicitCylinderWidget - 3D widget for manipulating an infinite\ncylnder\n\n",
    "Superclass: vtkAbstractWidget\n\n",
    "This 3D widget defines an infinite cylinder that can be interactively\nplaced in a scene. The widget is assumed to consist of four parts: 1)\na cylinder contained in a 2) bounding box, with a\n3) cylinder axis, which is rooted at a 4) center point in the\n   bounding box. (The representation paired with this widget\n   determines the actual geometry of the widget.)\n\nTo use this widget, you generally pa",
    "ir it with a\nvtkImplicitCylinderRepresentation (or a subclass). Variuos options\nare available for controlling how the representation appears, and how\nthe widget functions.\n\n@par Event Bindings: By default, the widget responds to the following\nVTK events (i.e., it watches the vtkRenderWindowInteractor for these\nevents):\n\nIf the cylinder axis is selected:\n  LeftButtonPressEvent - select normal\n  Lef",
    "tButtonReleaseEvent - release (end select) normal\n  MouseMoveEvent - orient the normal vector If the center point\n(handle) is selected:\n  LeftButtonPressEvent - select handle (if on slider)\n  LeftButtonReleaseEvent - release handle (if selected)\n  MouseMoveEvent - move the center point (constrained to plane or on\nthe\n                   axis if CTRL key is pressed) If the cylinder is\nselected:\n  Le",
    "ftButtonPressEvent - select cylinder\n  LeftButtonReleaseEvent - release cylinder\n  MouseMoveEvent - increase/decrease cylinder radius If the outline\nis selected:\n  LeftButtonPressEvent - select outline\n  LeftButtonReleaseEvent - release outline\n  MouseMoveEvent - move the outline If the keypress characters are\nused\n  'Down/Left' Move cylinder away from viewer\n  'Up/Right' Move cylinder towards vie",
    "wer In all the cases,\nindependent of what is picked, the widget responds to the following\nVTK events:\n  MiddleButtonPressEvent - move the cylinder\n  MiddleButtonReleaseEvent - release the cylinder\n  RightButtonPressEvent - scale the widget's representation\n  RightButtonReleaseEvent - stop scaling the widget\n  MouseMoveEvent - scale (if right button) or move (if middle button)\nthe widget \n\n@par Eve",
    "nt Bindings: Note that the event bindings described above can\nbe changed using this class's vtkWidgetEventTranslator. This class\ntranslates VTK events into the vtkImplicitCylinderWidget's widget\nevents:\n\n\n  vtkWidgetEvent::Select -- some part of the widget has been selected\n  vtkWidgetEvent::EndSelect -- the selection process has completed\n  vtkWidgetEvent::Move -- a request for widget motion has ",
    "been\ninvoked\n  vtkWidgetEvent::Up and vtkWidgetEvent::Down -- MoveCylinderAction \n\n@par Event Bindings: In turn, when these widget events are processed,\nthe vtkImplicitCylinderWidget invokes the following VTK events on\nitself (which observers can listen for):\n\n\n  vtkCommand::StartInteractionEvent (on vtkWidgetEvent::Select)\n  vtkCommand::EndInteractionEvent (on vtkWidgetEvent::EndSelect)\n  vtkComm",
    "and::InteractionEvent (on vtkWidgetEvent::Move) \n\n@sa\nvtk3DWidget vtkImplicitPlaneWidget\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImplicitCylinderWidget(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImplicitCylinderWidget_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImplicitCylinderWidget", o) != 0)
  {
    Py_DECREF(o);
  }

}

