// python wrapper for vtkImplicitFunctionCollection
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkImplicitFunctionCollection.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImplicitFunctionCollection(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImplicitFunctionCollection_ClassNew(); }

#ifndef DECLARED_PyvtkCollection_ClassNew
extern "C" { PyObject *PyvtkCollection_ClassNew(); }
#define DECLARED_PyvtkCollection_ClassNew
#endif

static const char **PyvtkImplicitFunctionCollection_Doc();


static PyObject *
PyvtkImplicitFunctionCollection_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionCollection *op = static_cast<vtkImplicitFunctionCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkImplicitFunctionCollection::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionCollection_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionCollection *op = static_cast<vtkImplicitFunctionCollection *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImplicitFunctionCollection::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionCollection_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionCollection *op = static_cast<vtkImplicitFunctionCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImplicitFunctionCollection *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImplicitFunctionCollection::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionCollection_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkImplicitFunctionCollection *tempr = vtkImplicitFunctionCollection::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionCollection_AddItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionCollection *op = static_cast<vtkImplicitFunctionCollection *>(vp);

  vtkImplicitFunction *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImplicitFunction"))
  {
    if (ap.IsBound())
    {
      op->AddItem(temp0);
    }
    else
    {
      op->vtkImplicitFunctionCollection::AddItem(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionCollection_GetNextItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionCollection *op = static_cast<vtkImplicitFunctionCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImplicitFunction *tempr = (ap.IsBound() ?
      op->GetNextItem() :
      op->vtkImplicitFunctionCollection::GetNextItem());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkImplicitFunctionCollection_Methods[] = {
  {"GetClassName", PyvtkImplicitFunctionCollection_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkImplicitFunctionCollection_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkImplicitFunctionCollection_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImplicitFunctionCollection\nC++: vtkImplicitFunctionCollection *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkImplicitFunctionCollection_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkImplicitFunctionCollection\nC++: vtkImplicitFunctionCollection *SafeDownCast(vtkObject* o)\n\n"},
  {"AddItem", PyvtkImplicitFunctionCollection_AddItem, METH_VARARGS,
   "V.AddItem(vtkImplicitFunction)\nC++: void AddItem(vtkImplicitFunction *)\n\nAdd an implicit function to the list.\n"},
  {"GetNextItem", PyvtkImplicitFunctionCollection_GetNextItem, METH_VARARGS,
   "V.GetNextItem() -> vtkImplicitFunction\nC++: vtkImplicitFunction *GetNextItem()\n\nGet the next implicit function in the list.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImplicitFunctionCollection_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonDataModelPython.vtkImplicitFunctionCollection", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImplicitFunctionCollection_StaticNew()
{
  return vtkImplicitFunctionCollection::New();
}

PyObject *PyvtkImplicitFunctionCollection_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImplicitFunctionCollection_Type, PyvtkImplicitFunctionCollection_Methods,
    "vtkImplicitFunctionCollection",
    PyvtkImplicitFunctionCollection_Doc(), &PyvtkImplicitFunctionCollection_StaticNew);

  PyTypeObject *pytype = &PyvtkImplicitFunctionCollection_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCollection_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImplicitFunctionCollection_Doc()
{
  static const char *docstring[] = {
    "vtkImplicitFunctionCollection - maintain a list of implicit functions\n\n",
    "Superclass: vtkCollection\n\n",
    "vtkImplicitFunctionCollection is an object that creates and\nmanipulates lists of objects of type vtkImplicitFunction.\n@sa\nvtkCollection vtkPlaneCollection\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImplicitFunctionCollection(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImplicitFunctionCollection_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImplicitFunctionCollection", o) != 0)
  {
    Py_DECREF(o);
  }

}

