// python wrapper for vtkInteractorStyleMultiTouchCamera
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkInteractorStyleMultiTouchCamera.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkInteractorStyleMultiTouchCamera(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkInteractorStyleMultiTouchCamera_ClassNew(); }

#ifndef DECLARED_PyvtkInteractorStyleTrackballCamera_ClassNew
extern "C" { PyObject *PyvtkInteractorStyleTrackballCamera_ClassNew(); }
#define DECLARED_PyvtkInteractorStyleTrackballCamera_ClassNew
#endif

static const char **PyvtkInteractorStyleMultiTouchCamera_Doc();


static PyObject *
PyvtkInteractorStyleMultiTouchCamera_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleMultiTouchCamera *op = static_cast<vtkInteractorStyleMultiTouchCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkInteractorStyleMultiTouchCamera::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleMultiTouchCamera_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleMultiTouchCamera *op = static_cast<vtkInteractorStyleMultiTouchCamera *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkInteractorStyleMultiTouchCamera::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleMultiTouchCamera_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleMultiTouchCamera *op = static_cast<vtkInteractorStyleMultiTouchCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkInteractorStyleMultiTouchCamera *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkInteractorStyleMultiTouchCamera::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleMultiTouchCamera_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkInteractorStyleMultiTouchCamera *tempr = vtkInteractorStyleMultiTouchCamera::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleMultiTouchCamera_OnRotate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnRotate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleMultiTouchCamera *op = static_cast<vtkInteractorStyleMultiTouchCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnRotate();
    }
    else
    {
      op->vtkInteractorStyleMultiTouchCamera::OnRotate();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleMultiTouchCamera_OnPinch(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnPinch");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleMultiTouchCamera *op = static_cast<vtkInteractorStyleMultiTouchCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnPinch();
    }
    else
    {
      op->vtkInteractorStyleMultiTouchCamera::OnPinch();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleMultiTouchCamera_OnPan(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnPan");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleMultiTouchCamera *op = static_cast<vtkInteractorStyleMultiTouchCamera *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnPan();
    }
    else
    {
      op->vtkInteractorStyleMultiTouchCamera::OnPan();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkInteractorStyleMultiTouchCamera_Methods[] = {
  {"GetClassName", PyvtkInteractorStyleMultiTouchCamera_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkInteractorStyleMultiTouchCamera_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkInteractorStyleMultiTouchCamera_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkInteractorStyleMultiTouchCamera\nC++: vtkInteractorStyleMultiTouchCamera *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkInteractorStyleMultiTouchCamera_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkInteractorStyleMultiTouchCamera\nC++: vtkInteractorStyleMultiTouchCamera *SafeDownCast(\n    vtkObject* o)\n\n"},
  {"OnRotate", PyvtkInteractorStyleMultiTouchCamera_OnRotate, METH_VARARGS,
   "V.OnRotate()\nC++: virtual void OnRotate()\n\nEvent bindings for gestures\n"},
  {"OnPinch", PyvtkInteractorStyleMultiTouchCamera_OnPinch, METH_VARARGS,
   "V.OnPinch()\nC++: virtual void OnPinch()\n\nEvent bindings for gestures\n"},
  {"OnPan", PyvtkInteractorStyleMultiTouchCamera_OnPan, METH_VARARGS,
   "V.OnPan()\nC++: virtual void OnPan()\n\nEvent bindings for gestures\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkInteractorStyleMultiTouchCamera_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInteractionStylePython.vtkInteractorStyleMultiTouchCamera", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkInteractorStyleMultiTouchCamera_StaticNew()
{
  return vtkInteractorStyleMultiTouchCamera::New();
}

PyObject *PyvtkInteractorStyleMultiTouchCamera_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkInteractorStyleMultiTouchCamera_Type, PyvtkInteractorStyleMultiTouchCamera_Methods,
    "vtkInteractorStyleMultiTouchCamera",
    PyvtkInteractorStyleMultiTouchCamera_Doc(), &PyvtkInteractorStyleMultiTouchCamera_StaticNew);

  PyTypeObject *pytype = &PyvtkInteractorStyleMultiTouchCamera_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkInteractorStyleTrackballCamera_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkInteractorStyleMultiTouchCamera_Doc()
{
  static const char *docstring[] = {
    "vtkInteractorStyleMultiTouchCamera - multitouch manipulation of the\ncamera\n\n",
    "Superclass: vtkInteractorStyleTrackballCamera\n\n",
    "vtkInteractorStyleMultiTouchCamera allows the user to interactively\nmanipulate (rotate, pan, etc.) the camera, the viewpoint of the scene\nusing multitouch gestures in addition to regular gestures\n\n@sa\nvtkInteractorStyleTrackballActor vtkInteractorStyleJoystickCamera\nvtkInteractorStyleJoystickActor\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkInteractorStyleMultiTouchCamera(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkInteractorStyleMultiTouchCamera_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkInteractorStyleMultiTouchCamera", o) != 0)
  {
    Py_DECREF(o);
  }

}

