// python wrapper for vtkMPIImageReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMPIImageReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMPIImageReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMPIImageReader_ClassNew(); }

#ifndef DECLARED_PyvtkImageReader_ClassNew
extern "C" { PyObject *PyvtkImageReader_ClassNew(); }
#define DECLARED_PyvtkImageReader_ClassNew
#endif

static const char **PyvtkMPIImageReader_Doc();


static PyObject *
PyvtkMPIImageReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIImageReader *op = static_cast<vtkMPIImageReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkMPIImageReader::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPIImageReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIImageReader *op = static_cast<vtkMPIImageReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMPIImageReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPIImageReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIImageReader *op = static_cast<vtkMPIImageReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMPIImageReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMPIImageReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMPIImageReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkMPIImageReader *tempr = vtkMPIImageReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPIImageReader_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIImageReader *op = static_cast<vtkMPIImageReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiProcessController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkMPIImageReader::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPIImageReader_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIImageReader *op = static_cast<vtkMPIImageReader *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkMPIImageReader::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMPIImageReader_Methods[] = {
  {"GetClassName", PyvtkMPIImageReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkMPIImageReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkMPIImageReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMPIImageReader\nC++: vtkMPIImageReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkMPIImageReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkMPIImageReader\nC++: vtkMPIImageReader *SafeDownCast(vtkObject* o)\n\n"},
  {"GetController", PyvtkMPIImageReader_GetController, METH_VARARGS,
   "V.GetController() -> vtkMultiProcessController\nC++: vtkMultiProcessController *GetController()\n\nGet/set the multi process controller to use for coordinated\nreads.  By default, set to the global controller.\n"},
  {"SetController", PyvtkMPIImageReader_SetController, METH_VARARGS,
   "V.SetController(vtkMultiProcessController)\nC++: virtual void SetController(vtkMultiProcessController *)\n\nGet/set the multi process controller to use for coordinated\nreads.  By default, set to the global controller.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkMPIImageReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOMPIImagePython.vtkMPIImageReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMPIImageReader_StaticNew()
{
  return vtkMPIImageReader::New();
}

PyObject *PyvtkMPIImageReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkMPIImageReader_Type, PyvtkMPIImageReader_Methods,
    "vtkMPIImageReader",
    PyvtkMPIImageReader_Doc(), &PyvtkMPIImageReader_StaticNew);

  PyTypeObject *pytype = &PyvtkMPIImageReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageReader_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMPIImageReader_Doc()
{
  static const char *docstring[] = {
    "vtkMPIImageReader - vtkMPIImageReader provides the mechanism to read\na brick of bytes (or shorts, or ints, or floats, or doubles, ...)\nfrom a file or series of files.\n\n",
    "Superclass: vtkImageReader\n\n",
    "You can use it to read raw image data from files.  You may also be\nable to subclass this to read simple file formats.\n\nWhat distinguishes this class from vtkImageReader and vtkImageReader2\nis that it performs synchronized parallel I/O using the MPIIO layer. \nThis can make a huge difference in file read times, especially when\nreading in parallel from a parallel file system.\n\nDespite the name of thi",
    "s class, vtkMPIImageReader will work even if\nMPI is not available.  If MPI is not available or MPIIO is not\navailable or the given Controller is not a vtkMPIController (or\nNULL), then this class will silently work exactly like its\nsuperclass.  The point is that you can safely use this class in\napplications that may or may not be compiled with MPI (or may or may\nnot actually be run with MPI).\n\n@sa\n",
    "vtkMultiProcessController, vtkImageReader, vtkImageReader2\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMPIImageReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMPIImageReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMPIImageReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

