// python wrapper for vtkMathTextFreeTypeTextRenderer
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMathTextFreeTypeTextRenderer.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMathTextFreeTypeTextRenderer(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMathTextFreeTypeTextRenderer_ClassNew(); }

#ifndef DECLARED_PyvtkTextRenderer_ClassNew
extern "C" { PyObject *PyvtkTextRenderer_ClassNew(); }
#define DECLARED_PyvtkTextRenderer_ClassNew
#endif

static const char **PyvtkMathTextFreeTypeTextRenderer_Doc();


static PyObject *
PyvtkMathTextFreeTypeTextRenderer_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMathTextFreeTypeTextRenderer *op = static_cast<vtkMathTextFreeTypeTextRenderer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkMathTextFreeTypeTextRenderer::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMathTextFreeTypeTextRenderer_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMathTextFreeTypeTextRenderer *op = static_cast<vtkMathTextFreeTypeTextRenderer *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMathTextFreeTypeTextRenderer::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMathTextFreeTypeTextRenderer_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMathTextFreeTypeTextRenderer *op = static_cast<vtkMathTextFreeTypeTextRenderer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMathTextFreeTypeTextRenderer *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMathTextFreeTypeTextRenderer::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMathTextFreeTypeTextRenderer_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkMathTextFreeTypeTextRenderer *tempr = vtkMathTextFreeTypeTextRenderer::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMathTextFreeTypeTextRenderer_FreeTypeIsSupported(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FreeTypeIsSupported");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMathTextFreeTypeTextRenderer *op = static_cast<vtkMathTextFreeTypeTextRenderer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->FreeTypeIsSupported() :
      op->vtkMathTextFreeTypeTextRenderer::FreeTypeIsSupported());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMathTextFreeTypeTextRenderer_MathTextIsSupported(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MathTextIsSupported");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMathTextFreeTypeTextRenderer *op = static_cast<vtkMathTextFreeTypeTextRenderer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->MathTextIsSupported() :
      op->vtkMathTextFreeTypeTextRenderer::MathTextIsSupported());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMathTextFreeTypeTextRenderer_Methods[] = {
  {"GetClassName", PyvtkMathTextFreeTypeTextRenderer_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkMathTextFreeTypeTextRenderer_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkMathTextFreeTypeTextRenderer_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMathTextFreeTypeTextRenderer\nC++: vtkMathTextFreeTypeTextRenderer *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkMathTextFreeTypeTextRenderer_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkMathTextFreeTypeTextRenderer\nC++: vtkMathTextFreeTypeTextRenderer *SafeDownCast(vtkObject* o)\n\n"},
  {"FreeTypeIsSupported", PyvtkMathTextFreeTypeTextRenderer_FreeTypeIsSupported, METH_VARARGS,
   "V.FreeTypeIsSupported() -> bool\nC++: virtual bool FreeTypeIsSupported()\n\nTest for availability of various backends\n"},
  {"MathTextIsSupported", PyvtkMathTextFreeTypeTextRenderer_MathTextIsSupported, METH_VARARGS,
   "V.MathTextIsSupported() -> bool\nC++: virtual bool MathTextIsSupported()\n\nTest for availability of various backends\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkMathTextFreeTypeTextRenderer_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingFreeTypePython.vtkMathTextFreeTypeTextRenderer", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMathTextFreeTypeTextRenderer_StaticNew()
{
  return vtkMathTextFreeTypeTextRenderer::New();
}

PyObject *PyvtkMathTextFreeTypeTextRenderer_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkMathTextFreeTypeTextRenderer_Type, PyvtkMathTextFreeTypeTextRenderer_Methods,
    "vtkMathTextFreeTypeTextRenderer",
    PyvtkMathTextFreeTypeTextRenderer_Doc(), &PyvtkMathTextFreeTypeTextRenderer_StaticNew);

  PyTypeObject *pytype = &PyvtkMathTextFreeTypeTextRenderer_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTextRenderer_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMathTextFreeTypeTextRenderer_Doc()
{
  static const char *docstring[] = {
    "vtkMathTextFreeTypeTextRenderer - Default implementation of\nvtkTextRenderer.\n\n",
    "Superclass: vtkTextRenderer\n\n",
    "Default implementation of vtkTextRenderer using vtkFreeTypeTools and\nvtkMathTextUtilities.\n\n@warning\nThe MathText backend does not currently support UTF16 strings, thus\nUTF16 strings passed to the MathText renderer will be converted to\nUTF8.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMathTextFreeTypeTextRenderer(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMathTextFreeTypeTextRenderer_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMathTextFreeTypeTextRenderer", o) != 0)
  {
    Py_DECREF(o);
  }

}

