// python wrapper for vtkMergeDataObjectFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMergeDataObjectFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMergeDataObjectFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMergeDataObjectFilter_ClassNew(); }

#ifndef DECLARED_PyvtkDataSetAlgorithm_ClassNew
extern "C" { PyObject *PyvtkDataSetAlgorithm_ClassNew(); }
#define DECLARED_PyvtkDataSetAlgorithm_ClassNew
#endif

static const char **PyvtkMergeDataObjectFilter_Doc();


static PyObject *
PyvtkMergeDataObjectFilter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMergeDataObjectFilter *op = static_cast<vtkMergeDataObjectFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkMergeDataObjectFilter::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMergeDataObjectFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMergeDataObjectFilter *op = static_cast<vtkMergeDataObjectFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMergeDataObjectFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMergeDataObjectFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMergeDataObjectFilter *op = static_cast<vtkMergeDataObjectFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMergeDataObjectFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMergeDataObjectFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMergeDataObjectFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkMergeDataObjectFilter *tempr = vtkMergeDataObjectFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMergeDataObjectFilter_SetDataObjectInputData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDataObjectInputData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMergeDataObjectFilter *op = static_cast<vtkMergeDataObjectFilter *>(vp);

  vtkDataObject *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->SetDataObjectInputData(temp0);
    }
    else
    {
      op->vtkMergeDataObjectFilter::SetDataObjectInputData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMergeDataObjectFilter_GetDataObject(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataObject");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMergeDataObjectFilter *op = static_cast<vtkMergeDataObjectFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDataObject *tempr = (ap.IsBound() ?
      op->GetDataObject() :
      op->vtkMergeDataObjectFilter::GetDataObject());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMergeDataObjectFilter_SetOutputField(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputField");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMergeDataObjectFilter *op = static_cast<vtkMergeDataObjectFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOutputField(temp0);
    }
    else
    {
      op->vtkMergeDataObjectFilter::SetOutputField(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMergeDataObjectFilter_GetOutputField(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputField");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMergeDataObjectFilter *op = static_cast<vtkMergeDataObjectFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOutputField() :
      op->vtkMergeDataObjectFilter::GetOutputField());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMergeDataObjectFilter_SetOutputFieldToDataObjectField(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputFieldToDataObjectField");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMergeDataObjectFilter *op = static_cast<vtkMergeDataObjectFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetOutputFieldToDataObjectField();
    }
    else
    {
      op->vtkMergeDataObjectFilter::SetOutputFieldToDataObjectField();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMergeDataObjectFilter_SetOutputFieldToPointDataField(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputFieldToPointDataField");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMergeDataObjectFilter *op = static_cast<vtkMergeDataObjectFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetOutputFieldToPointDataField();
    }
    else
    {
      op->vtkMergeDataObjectFilter::SetOutputFieldToPointDataField();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMergeDataObjectFilter_SetOutputFieldToCellDataField(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputFieldToCellDataField");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMergeDataObjectFilter *op = static_cast<vtkMergeDataObjectFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetOutputFieldToCellDataField();
    }
    else
    {
      op->vtkMergeDataObjectFilter::SetOutputFieldToCellDataField();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMergeDataObjectFilter_Methods[] = {
  {"GetClassName", PyvtkMergeDataObjectFilter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkMergeDataObjectFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkMergeDataObjectFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMergeDataObjectFilter\nC++: vtkMergeDataObjectFilter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkMergeDataObjectFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkMergeDataObjectFilter\nC++: vtkMergeDataObjectFilter *SafeDownCast(vtkObject* o)\n\n"},
  {"SetDataObjectInputData", PyvtkMergeDataObjectFilter_SetDataObjectInputData, METH_VARARGS,
   "V.SetDataObjectInputData(vtkDataObject)\nC++: void SetDataObjectInputData(vtkDataObject *object)\n\nSpecify the data object to merge with the input dataset.\n"},
  {"GetDataObject", PyvtkMergeDataObjectFilter_GetDataObject, METH_VARARGS,
   "V.GetDataObject() -> vtkDataObject\nC++: vtkDataObject *GetDataObject()\n\nSpecify the data object to merge with the input dataset.\n"},
  {"SetOutputField", PyvtkMergeDataObjectFilter_SetOutputField, METH_VARARGS,
   "V.SetOutputField(int)\nC++: void SetOutputField(int a)\n\nSpecify where to place the field data during the merge process. \nThere are three choices: the field data associated with the\nvtkDataObject superclass; the point field attribute data; and the\ncell field attribute data.\n"},
  {"GetOutputField", PyvtkMergeDataObjectFilter_GetOutputField, METH_VARARGS,
   "V.GetOutputField() -> int\nC++: int GetOutputField()\n\nSpecify where to place the field data during the merge process. \nThere are three choices: the field data associated with the\nvtkDataObject superclass; the point field attribute data; and the\ncell field attribute data.\n"},
  {"SetOutputFieldToDataObjectField", PyvtkMergeDataObjectFilter_SetOutputFieldToDataObjectField, METH_VARARGS,
   "V.SetOutputFieldToDataObjectField()\nC++: void SetOutputFieldToDataObjectField()\n\nSpecify where to place the field data during the merge process. \nThere are three choices: the field data associated with the\nvtkDataObject superclass; the point field attribute data; and the\ncell field attribute data.\n"},
  {"SetOutputFieldToPointDataField", PyvtkMergeDataObjectFilter_SetOutputFieldToPointDataField, METH_VARARGS,
   "V.SetOutputFieldToPointDataField()\nC++: void SetOutputFieldToPointDataField()\n\nSpecify where to place the field data during the merge process. \nThere are three choices: the field data associated with the\nvtkDataObject superclass; the point field attribute data; and the\ncell field attribute data.\n"},
  {"SetOutputFieldToCellDataField", PyvtkMergeDataObjectFilter_SetOutputFieldToCellDataField, METH_VARARGS,
   "V.SetOutputFieldToCellDataField()\nC++: void SetOutputFieldToCellDataField()\n\nSpecify where to place the field data during the merge process. \nThere are three choices: the field data associated with the\nvtkDataObject superclass; the point field attribute data; and the\ncell field attribute data.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkMergeDataObjectFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersCorePython.vtkMergeDataObjectFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMergeDataObjectFilter_StaticNew()
{
  return vtkMergeDataObjectFilter::New();
}

PyObject *PyvtkMergeDataObjectFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkMergeDataObjectFilter_Type, PyvtkMergeDataObjectFilter_Methods,
    "vtkMergeDataObjectFilter",
    PyvtkMergeDataObjectFilter_Doc(), &PyvtkMergeDataObjectFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkMergeDataObjectFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataSetAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMergeDataObjectFilter_Doc()
{
  static const char *docstring[] = {
    "vtkMergeDataObjectFilter - merge dataset and data object field to\ncreate dataset with attribute data\n\n",
    "Superclass: vtkDataSetAlgorithm\n\n",
    "vtkMergeDataObjectFilter is a filter that merges the field from a\nvtkDataObject with a vtkDataSet. The resulting combined dataset can\nthen be processed by other filters (e.g.,\nvtkFieldDataToAttributeDataFilter) to create attribute data like\nscalars, vectors, etc.\n\nThe filter operates as follows. The field data from the vtkDataObject\nis merged with the input's vtkDataSet and then placed in the outp",
    "ut.\nYou can choose to place the field data into the cell data field, the\npoint data field, or the datasets field (i.e., the one inherited from\nvtkDataSet's superclass vtkDataObject). All this data shuffling\noccurs via reference counting, therefore memory is not copied.\n\nOne of the uses of this filter is to allow you to read/generate the\nstructure of a dataset independent of the attributes. So, for",
    "\nexample, you could store the dataset geometry/topology in one file,\nand field data in another. Then use this filter in combination with\nvtkFieldDataToAttributeData to create a dataset ready for processing\nin the visualization pipeline.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMergeDataObjectFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMergeDataObjectFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMergeDataObjectFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

