// python wrapper for vtkNonOverlappingAMRAlgorithm
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkNonOverlappingAMRAlgorithm.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkNonOverlappingAMRAlgorithm(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkNonOverlappingAMRAlgorithm_ClassNew(); }

#ifndef DECLARED_PyvtkUniformGridAMRAlgorithm_ClassNew
extern "C" { PyObject *PyvtkUniformGridAMRAlgorithm_ClassNew(); }
#define DECLARED_PyvtkUniformGridAMRAlgorithm_ClassNew
#endif

static const char **PyvtkNonOverlappingAMRAlgorithm_Doc();


static PyObject *
PyvtkNonOverlappingAMRAlgorithm_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNonOverlappingAMRAlgorithm *op = static_cast<vtkNonOverlappingAMRAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkNonOverlappingAMRAlgorithm::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNonOverlappingAMRAlgorithm_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNonOverlappingAMRAlgorithm *op = static_cast<vtkNonOverlappingAMRAlgorithm *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkNonOverlappingAMRAlgorithm::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNonOverlappingAMRAlgorithm_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNonOverlappingAMRAlgorithm *op = static_cast<vtkNonOverlappingAMRAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkNonOverlappingAMRAlgorithm *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkNonOverlappingAMRAlgorithm::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkNonOverlappingAMRAlgorithm_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkNonOverlappingAMRAlgorithm *tempr = vtkNonOverlappingAMRAlgorithm::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNonOverlappingAMRAlgorithm_GetOutput_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNonOverlappingAMRAlgorithm *op = static_cast<vtkNonOverlappingAMRAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkNonOverlappingAMR *tempr = (ap.IsBound() ?
      op->GetOutput() :
      op->vtkNonOverlappingAMRAlgorithm::GetOutput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkNonOverlappingAMRAlgorithm_GetOutput_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNonOverlappingAMRAlgorithm *op = static_cast<vtkNonOverlappingAMRAlgorithm *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkNonOverlappingAMR *tempr = (ap.IsBound() ?
      op->GetOutput(temp0) :
      op->vtkNonOverlappingAMRAlgorithm::GetOutput(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkNonOverlappingAMRAlgorithm_GetOutput(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkNonOverlappingAMRAlgorithm_GetOutput_s1(self, args);
    case 1:
      return PyvtkNonOverlappingAMRAlgorithm_GetOutput_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetOutput");
  return NULL;
}


static PyMethodDef PyvtkNonOverlappingAMRAlgorithm_Methods[] = {
  {"GetClassName", PyvtkNonOverlappingAMRAlgorithm_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkNonOverlappingAMRAlgorithm_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkNonOverlappingAMRAlgorithm_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkNonOverlappingAMRAlgorithm\nC++: vtkNonOverlappingAMRAlgorithm *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkNonOverlappingAMRAlgorithm_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkNonOverlappingAMRAlgorithm\nC++: vtkNonOverlappingAMRAlgorithm *SafeDownCast(vtkObject* o)\n\n"},
  {"GetOutput", PyvtkNonOverlappingAMRAlgorithm_GetOutput, METH_VARARGS,
   "V.GetOutput() -> vtkNonOverlappingAMR\nC++: vtkNonOverlappingAMR *GetOutput()\nV.GetOutput(int) -> vtkNonOverlappingAMR\nC++: vtkNonOverlappingAMR *GetOutput(int)\n\nGet the output data object for a port on this algorithm\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkNonOverlappingAMRAlgorithm_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonExecutionModelPython.vtkNonOverlappingAMRAlgorithm", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkNonOverlappingAMRAlgorithm_StaticNew()
{
  return vtkNonOverlappingAMRAlgorithm::New();
}

PyObject *PyvtkNonOverlappingAMRAlgorithm_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkNonOverlappingAMRAlgorithm_Type, PyvtkNonOverlappingAMRAlgorithm_Methods,
    "vtkNonOverlappingAMRAlgorithm",
    PyvtkNonOverlappingAMRAlgorithm_Doc(), &PyvtkNonOverlappingAMRAlgorithm_StaticNew);

  PyTypeObject *pytype = &PyvtkNonOverlappingAMRAlgorithm_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUniformGridAMRAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkNonOverlappingAMRAlgorithm_Doc()
{
  static const char *docstring[] = {
    "vtkNonOverlappingAMRAlgorithm -  produce vtkNonOverlappingAMR as\noutput.\n\n",
    "Superclass: vtkUniformGridAMRAlgorithm\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkNonOverlappingAMRAlgorithm(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkNonOverlappingAMRAlgorithm_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkNonOverlappingAMRAlgorithm", o) != 0)
  {
    Py_DECREF(o);
  }

}

