// python wrapper for vtkOBJImporter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkOBJImporter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOBJImporter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOBJImporter_ClassNew(); }

#ifndef DECLARED_PyvtkImporter_ClassNew
extern "C" { PyObject *PyvtkImporter_ClassNew(); }
#define DECLARED_PyvtkImporter_ClassNew
#endif

static const char **PyvtkOBJImporter_Doc();


static PyObject *
PyvtkOBJImporter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOBJImporter *op = static_cast<vtkOBJImporter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkOBJImporter::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOBJImporter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOBJImporter *op = static_cast<vtkOBJImporter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOBJImporter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOBJImporter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOBJImporter *op = static_cast<vtkOBJImporter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkOBJImporter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOBJImporter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOBJImporter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkOBJImporter *tempr = vtkOBJImporter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOBJImporter_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOBJImporter *op = static_cast<vtkOBJImporter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkOBJImporter::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOBJImporter_SetFileNameMTL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileNameMTL");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOBJImporter *op = static_cast<vtkOBJImporter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileNameMTL(temp0);
    }
    else
    {
      op->vtkOBJImporter::SetFileNameMTL(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOBJImporter_SetTexturePath(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTexturePath");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOBJImporter *op = static_cast<vtkOBJImporter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTexturePath(temp0);
    }
    else
    {
      op->vtkOBJImporter::SetTexturePath(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOBJImporter_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOBJImporter *op = static_cast<vtkOBJImporter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkOBJImporter::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOBJImporter_GetFileNameMTL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileNameMTL");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOBJImporter *op = static_cast<vtkOBJImporter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFileNameMTL() :
      op->vtkOBJImporter::GetFileNameMTL());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOBJImporter_GetTexturePath(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTexturePath");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOBJImporter *op = static_cast<vtkOBJImporter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetTexturePath() :
      op->vtkOBJImporter::GetTexturePath());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkOBJImporter_Methods[] = {
  {"GetClassName", PyvtkOBJImporter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkOBJImporter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkOBJImporter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOBJImporter\nC++: vtkOBJImporter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkOBJImporter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkOBJImporter\nC++: vtkOBJImporter *SafeDownCast(vtkObject* o)\n\n"},
  {"SetFileName", PyvtkOBJImporter_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(const char *arg)\n\nSpecify the name of the file to read.\n"},
  {"SetFileNameMTL", PyvtkOBJImporter_SetFileNameMTL, METH_VARARGS,
   "V.SetFileNameMTL(string)\nC++: void SetFileNameMTL(const char *arg)\n\nSpecify the name of the file to read.\n"},
  {"SetTexturePath", PyvtkOBJImporter_SetTexturePath, METH_VARARGS,
   "V.SetTexturePath(string)\nC++: void SetTexturePath(const char *path)\n\nSpecify the name of the file to read.\n"},
  {"GetFileName", PyvtkOBJImporter_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: const char *GetFileName()\n\nSpecify the name of the file to read.\n"},
  {"GetFileNameMTL", PyvtkOBJImporter_GetFileNameMTL, METH_VARARGS,
   "V.GetFileNameMTL() -> string\nC++: const char *GetFileNameMTL()\n\nSpecify the name of the file to read.\n"},
  {"GetTexturePath", PyvtkOBJImporter_GetTexturePath, METH_VARARGS,
   "V.GetTexturePath() -> string\nC++: const char *GetTexturePath()\n\nSpecify the name of the file to read.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOBJImporter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOImportPython.vtkOBJImporter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOBJImporter_StaticNew()
{
  return vtkOBJImporter::New();
}

PyObject *PyvtkOBJImporter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOBJImporter_Type, PyvtkOBJImporter_Methods,
    "vtkOBJImporter",
    PyvtkOBJImporter_Doc(), &PyvtkOBJImporter_StaticNew);

  PyTypeObject *pytype = &PyvtkOBJImporter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImporter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOBJImporter_Doc()
{
  static const char *docstring[] = {
    "vtkOBJImporter - import from .obj wavefront files\n\n",
    "Superclass: vtkImporter\n\n",
    "from Wavefront .obj & associated .mtl files.@par Thanks - Peter\nKarasev (Georgia Tech / Keysight Technologies Inc),:\n                  Allen Tannenbaum (SUNY Stonybrook), Patricio Vela\n(Georgia Tech)\n@sa\n vtkImporter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOBJImporter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOBJImporter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOBJImporter", o) != 0)
  {
    Py_DECREF(o);
  }

}

