// python wrapper for vtkOpenGLHardwareSelector
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkOpenGLHardwareSelector.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLHardwareSelector(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLHardwareSelector_ClassNew(); }

#ifndef DECLARED_PyvtkHardwareSelector_ClassNew
extern "C" { PyObject *PyvtkHardwareSelector_ClassNew(); }
#define DECLARED_PyvtkHardwareSelector_ClassNew
#endif

static const char **PyvtkOpenGLHardwareSelector_Doc();


static PyObject *
PyvtkOpenGLHardwareSelector_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHardwareSelector *op = static_cast<vtkOpenGLHardwareSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkOpenGLHardwareSelector::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHardwareSelector_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHardwareSelector *op = static_cast<vtkOpenGLHardwareSelector *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLHardwareSelector::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHardwareSelector_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHardwareSelector *op = static_cast<vtkOpenGLHardwareSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkOpenGLHardwareSelector *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLHardwareSelector::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHardwareSelector_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkOpenGLHardwareSelector *tempr = vtkOpenGLHardwareSelector::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHardwareSelector_BeginRenderProp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BeginRenderProp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHardwareSelector *op = static_cast<vtkOpenGLHardwareSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->BeginRenderProp();
    }
    else
    {
      op->vtkOpenGLHardwareSelector::BeginRenderProp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHardwareSelector_EndRenderProp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EndRenderProp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHardwareSelector *op = static_cast<vtkOpenGLHardwareSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EndRenderProp();
    }
    else
    {
      op->vtkOpenGLHardwareSelector::EndRenderProp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHardwareSelector_RenderCompositeIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RenderCompositeIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHardwareSelector *op = static_cast<vtkOpenGLHardwareSelector *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RenderCompositeIndex(temp0);
    }
    else
    {
      op->vtkOpenGLHardwareSelector::RenderCompositeIndex(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHardwareSelector_RenderAttributeId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RenderAttributeId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHardwareSelector *op = static_cast<vtkOpenGLHardwareSelector *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RenderAttributeId(temp0);
    }
    else
    {
      op->vtkOpenGLHardwareSelector::RenderAttributeId(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHardwareSelector_RenderProcessId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RenderProcessId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHardwareSelector *op = static_cast<vtkOpenGLHardwareSelector *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RenderProcessId(temp0);
    }
    else
    {
      op->vtkOpenGLHardwareSelector::RenderProcessId(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLHardwareSelector_BeginSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BeginSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLHardwareSelector *op = static_cast<vtkOpenGLHardwareSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->BeginSelection();
    }
    else
    {
      op->vtkOpenGLHardwareSelector::BeginSelection();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLHardwareSelector_Methods[] = {
  {"GetClassName", PyvtkOpenGLHardwareSelector_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkOpenGLHardwareSelector_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkOpenGLHardwareSelector_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLHardwareSelector\nC++: vtkOpenGLHardwareSelector *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkOpenGLHardwareSelector_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkOpenGLHardwareSelector\nC++: vtkOpenGLHardwareSelector *SafeDownCast(vtkObject* o)\n\n"},
  {"BeginRenderProp", PyvtkOpenGLHardwareSelector_BeginRenderProp, METH_VARARGS,
   "V.BeginRenderProp()\nC++: virtual void BeginRenderProp()\n\nCalled by the mapper before and after rendering each prop.\n"},
  {"EndRenderProp", PyvtkOpenGLHardwareSelector_EndRenderProp, METH_VARARGS,
   "V.EndRenderProp()\nC++: virtual void EndRenderProp()\n\n"},
  {"RenderCompositeIndex", PyvtkOpenGLHardwareSelector_RenderCompositeIndex, METH_VARARGS,
   "V.RenderCompositeIndex(int)\nC++: virtual void RenderCompositeIndex(unsigned int index)\n\nCalled by any vtkMapper or vtkProp subclass to render a\ncomposite-index. Currently indices >= 0xffffff are not supported.\n"},
  {"RenderAttributeId", PyvtkOpenGLHardwareSelector_RenderAttributeId, METH_VARARGS,
   "V.RenderAttributeId(int)\nC++: virtual void RenderAttributeId(vtkIdType attribid)\n\nCalled by any vtkMapper or vtkProp subclass to render an\nattribute's id.\n"},
  {"RenderProcessId", PyvtkOpenGLHardwareSelector_RenderProcessId, METH_VARARGS,
   "V.RenderProcessId(int)\nC++: virtual void RenderProcessId(unsigned int processid)\n\nCalled by any vtkMapper or subclass to render process id. This\nhas any effect when this->UseProcessIdFromData is true.\n"},
  {"BeginSelection", PyvtkOpenGLHardwareSelector_BeginSelection, METH_VARARGS,
   "V.BeginSelection()\nC++: virtual void BeginSelection()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLHardwareSelector_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkOpenGLHardwareSelector", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLHardwareSelector_StaticNew()
{
  return vtkOpenGLHardwareSelector::New();
}

PyObject *PyvtkOpenGLHardwareSelector_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLHardwareSelector_Type, PyvtkOpenGLHardwareSelector_Methods,
    "vtkOpenGLHardwareSelector",
    PyvtkOpenGLHardwareSelector_Doc(), &PyvtkOpenGLHardwareSelector_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLHardwareSelector_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkHardwareSelector_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLHardwareSelector_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLHardwareSelector - implements the device specific code of\n vtkOpenGLHardwareSelector.\n\n",
    "Superclass: vtkHardwareSelector\n\n",
    "Implements the device specific code of vtkOpenGLHardwareSelector.\n\n@sa\nvtkHardwareSelector\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLHardwareSelector(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLHardwareSelector_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLHardwareSelector", o) != 0)
  {
    Py_DECREF(o);
  }

}

