// python wrapper for vtkPYoungsMaterialInterface
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPYoungsMaterialInterface.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPYoungsMaterialInterface(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPYoungsMaterialInterface_ClassNew(); }

#ifndef DECLARED_PyvtkYoungsMaterialInterface_ClassNew
extern "C" { PyObject *PyvtkYoungsMaterialInterface_ClassNew(); }
#define DECLARED_PyvtkYoungsMaterialInterface_ClassNew
#endif

static const char **PyvtkPYoungsMaterialInterface_Doc();


static PyObject *
PyvtkPYoungsMaterialInterface_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPYoungsMaterialInterface *op = static_cast<vtkPYoungsMaterialInterface *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPYoungsMaterialInterface::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPYoungsMaterialInterface_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPYoungsMaterialInterface *op = static_cast<vtkPYoungsMaterialInterface *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPYoungsMaterialInterface::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPYoungsMaterialInterface_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPYoungsMaterialInterface *op = static_cast<vtkPYoungsMaterialInterface *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPYoungsMaterialInterface *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPYoungsMaterialInterface::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPYoungsMaterialInterface_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPYoungsMaterialInterface *tempr = vtkPYoungsMaterialInterface::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPYoungsMaterialInterface_Aggregate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Aggregate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPYoungsMaterialInterface *op = static_cast<vtkPYoungsMaterialInterface *>(vp);

  int temp0;
  int size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<int> store1(2*size1);
  int *temp1 = store1.Data();
  int *save1 = (size1 == 0 ? NULL : temp1 + size1);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    ap.SaveArray(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->Aggregate(temp0, temp1);
    }
    else
    {
      op->vtkPYoungsMaterialInterface::Aggregate(temp0, temp1);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPYoungsMaterialInterface_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPYoungsMaterialInterface *op = static_cast<vtkPYoungsMaterialInterface *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkPYoungsMaterialInterface::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPYoungsMaterialInterface_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPYoungsMaterialInterface *op = static_cast<vtkPYoungsMaterialInterface *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiProcessController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkPYoungsMaterialInterface::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPYoungsMaterialInterface_Methods[] = {
  {"GetClassName", PyvtkPYoungsMaterialInterface_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPYoungsMaterialInterface_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPYoungsMaterialInterface_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPYoungsMaterialInterface\nC++: vtkPYoungsMaterialInterface *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPYoungsMaterialInterface_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPYoungsMaterialInterface\nC++: vtkPYoungsMaterialInterface *SafeDownCast(vtkObject* o)\n\n"},
  {"Aggregate", PyvtkPYoungsMaterialInterface_Aggregate, METH_VARARGS,
   "V.Aggregate(int, [int, ...])\nC++: virtual void Aggregate(int, int *)\n\nParallel implementation of the material aggregation.\n"},
  {"SetController", PyvtkPYoungsMaterialInterface_SetController, METH_VARARGS,
   "V.SetController(vtkMultiProcessController)\nC++: virtual void SetController(vtkMultiProcessController *)\n\nGet/Set the multiprocess controller. If no controller is set,\nsingle process is assumed.\n"},
  {"GetController", PyvtkPYoungsMaterialInterface_GetController, METH_VARARGS,
   "V.GetController() -> vtkMultiProcessController\nC++: vtkMultiProcessController *GetController()\n\nGet/Set the multiprocess controller. If no controller is set,\nsingle process is assumed.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPYoungsMaterialInterface_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersParallelPython.vtkPYoungsMaterialInterface", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPYoungsMaterialInterface_StaticNew()
{
  return vtkPYoungsMaterialInterface::New();
}

PyObject *PyvtkPYoungsMaterialInterface_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPYoungsMaterialInterface_Type, PyvtkPYoungsMaterialInterface_Methods,
    "vtkPYoungsMaterialInterface",
    PyvtkPYoungsMaterialInterface_Doc(), &PyvtkPYoungsMaterialInterface_StaticNew);

  PyTypeObject *pytype = &PyvtkPYoungsMaterialInterface_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkYoungsMaterialInterface_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPYoungsMaterialInterface_Doc()
{
  static const char *docstring[] = {
    "vtkPYoungsMaterialInterface - parallel reconstruction of material\ninterfaces\n\n",
    "Superclass: vtkYoungsMaterialInterface\n\n",
    "This is a subclass of vtkYoungsMaterialInterface, implementing the\nreconstruction of material interfaces, for parallel data sets\n\n@par Thanks: This file is part of the generalized Youngs material\ninterface reconstruction algorithm contributed by\n\nCEA/DIF - Commissariat a l'Energie Atomique, Centre DAM Ile-De-France\n\nBP12, F-91297 Arpajon, France.\n\nImplementation by Thierry Carrard and Philippe Peb",
    "ay\n\n@sa\nvtkYoungsMaterialInterface\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPYoungsMaterialInterface(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPYoungsMaterialInterface_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPYoungsMaterialInterface", o) != 0)
  {
    Py_DECREF(o);
  }

}

