// python wrapper for vtkPeriodicTable
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkColor.h"
#include "vtkPeriodicTable.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPeriodicTable(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPeriodicTable_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkPeriodicTable_Doc();


static PyObject *
PyvtkPeriodicTable_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPeriodicTable::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPeriodicTable::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPeriodicTable *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPeriodicTable::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPeriodicTable *tempr = vtkPeriodicTable::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_GetBlueObeliskData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBlueObeliskData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkBlueObeliskData *tempr = (ap.IsBound() ?
      op->GetBlueObeliskData() :
      op->vtkPeriodicTable::GetBlueObeliskData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_GetNumberOfElements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfElements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned short tempr = (ap.IsBound() ?
      op->GetNumberOfElements() :
      op->vtkPeriodicTable::GetNumberOfElements());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_GetSymbol(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSymbol");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  unsigned short temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetSymbol(temp0) :
      op->vtkPeriodicTable::GetSymbol(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_GetElementName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetElementName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  unsigned short temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetElementName(temp0) :
      op->vtkPeriodicTable::GetElementName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_GetAtomicNumber(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAtomicNumber");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  vtkStdString temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    unsigned short tempr = (ap.IsBound() ?
      op->GetAtomicNumber(temp0) :
      op->vtkPeriodicTable::GetAtomicNumber(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_GetCovalentRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCovalentRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  unsigned short temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    float tempr = (ap.IsBound() ?
      op->GetCovalentRadius(temp0) :
      op->vtkPeriodicTable::GetCovalentRadius(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_GetVDWRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVDWRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  unsigned short temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    float tempr = (ap.IsBound() ?
      op->GetVDWRadius(temp0) :
      op->vtkPeriodicTable::GetVDWRadius(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_GetDefaultLUT(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultLUT");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  vtkLookupTable *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkLookupTable"))
  {
    if (ap.IsBound())
    {
      op->GetDefaultLUT(temp0);
    }
    else
    {
      op->vtkPeriodicTable::GetDefaultLUT(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPeriodicTable_GetDefaultRGBTuple_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultRGBTuple");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  unsigned short temp0;
  const int size1 = 3;
  float temp1[3];
  float save1[3];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    ap.SaveArray(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->GetDefaultRGBTuple(temp0, temp1);
    }
    else
    {
      op->vtkPeriodicTable::GetDefaultRGBTuple(temp0, temp1);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkPeriodicTable_GetDefaultRGBTuple_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultRGBTuple");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPeriodicTable *op = static_cast<vtkPeriodicTable *>(vp);

  unsigned short temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkColor3f tempr = (ap.IsBound() ?
      op->GetDefaultRGBTuple(temp0) :
      op->vtkPeriodicTable::GetDefaultRGBTuple(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkColor3f");
    }
  }

  return result;
}

static PyObject *
PyvtkPeriodicTable_GetDefaultRGBTuple(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkPeriodicTable_GetDefaultRGBTuple_s1(self, args);
    case 1:
      return PyvtkPeriodicTable_GetDefaultRGBTuple_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetDefaultRGBTuple");
  return NULL;
}


static PyMethodDef PyvtkPeriodicTable_Methods[] = {
  {"GetClassName", PyvtkPeriodicTable_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPeriodicTable_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPeriodicTable_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPeriodicTable\nC++: vtkPeriodicTable *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPeriodicTable_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPeriodicTable\nC++: vtkPeriodicTable *SafeDownCast(vtkObject* o)\n\n"},
  {"GetBlueObeliskData", PyvtkPeriodicTable_GetBlueObeliskData, METH_VARARGS,
   "V.GetBlueObeliskData() -> vtkBlueObeliskData\nC++: virtual vtkBlueObeliskData *GetBlueObeliskData()\n\nAccess the static vtkBlueObeliskData object for raw access to\nBODR data.\n"},
  {"GetNumberOfElements", PyvtkPeriodicTable_GetNumberOfElements, METH_VARARGS,
   "V.GetNumberOfElements() -> int\nC++: unsigned short GetNumberOfElements()\n\nReturns the number of elements in the periodic table.\n"},
  {"GetSymbol", PyvtkPeriodicTable_GetSymbol, METH_VARARGS,
   "V.GetSymbol(int) -> string\nC++: const char *GetSymbol(const unsigned short atomicNum)\n\nGiven an atomic number, returns the symbol associated with the\nelement\n"},
  {"GetElementName", PyvtkPeriodicTable_GetElementName, METH_VARARGS,
   "V.GetElementName(int) -> string\nC++: const char *GetElementName(const unsigned short atomicNum)\n\nGiven an atomic number, returns the name of the element\n"},
  {"GetAtomicNumber", PyvtkPeriodicTable_GetAtomicNumber, METH_VARARGS,
   "V.GetAtomicNumber(string) -> int\nC++: unsigned short GetAtomicNumber(const vtkStdString &str)\n\nGiven a case-insensitive string that contains the symbol or name\nof an element, return the corresponding atomic number.\n"},
  {"GetCovalentRadius", PyvtkPeriodicTable_GetCovalentRadius, METH_VARARGS,
   "V.GetCovalentRadius(int) -> float\nC++: float GetCovalentRadius(const unsigned short atomicNum)\n\nGiven an atomic number, return the covalent radius of the atom\n"},
  {"GetVDWRadius", PyvtkPeriodicTable_GetVDWRadius, METH_VARARGS,
   "V.GetVDWRadius(int) -> float\nC++: float GetVDWRadius(const unsigned short atomicNum)\n\nGiven an atomic number, returns the van der Waals radius of the\natom\n"},
  {"GetDefaultLUT", PyvtkPeriodicTable_GetDefaultLUT, METH_VARARGS,
   "V.GetDefaultLUT(vtkLookupTable)\nC++: void GetDefaultLUT(vtkLookupTable *)\n\nFill the given vtkLookupTable to map atomic numbers to the\nfamiliar RGB tuples provided by the Blue Obelisk Data Repository\n"},
  {"GetDefaultRGBTuple", PyvtkPeriodicTable_GetDefaultRGBTuple, METH_VARARGS,
   "V.GetDefaultRGBTuple(int, [float, float, float])\nC++: void GetDefaultRGBTuple(unsigned short atomicNum,\n    float rgb[3])\nV.GetDefaultRGBTuple(int) -> vtkColor3f\nC++: vtkColor3f GetDefaultRGBTuple(unsigned short atomicNum)\n\nGiven an atomic number, return the familiar RGB tuple provided by\nthe Blue Obelisk Data Repository\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPeriodicTable_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkDomainsChemistryPython.vtkPeriodicTable", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPeriodicTable_StaticNew()
{
  return vtkPeriodicTable::New();
}

PyObject *PyvtkPeriodicTable_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPeriodicTable_Type, PyvtkPeriodicTable_Methods,
    "vtkPeriodicTable",
    PyvtkPeriodicTable_Doc(), &PyvtkPeriodicTable_StaticNew);

  PyTypeObject *pytype = &PyvtkPeriodicTable_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPeriodicTable_Doc()
{
  static const char *docstring[] = {
    "vtkPeriodicTable - Access to information about the elements.\n\n",
    "Superclass: vtkObject\n\n",
    "Sourced from the Blue Obelisk Data Repository\n\n@sa\nvtkBlueObeliskData vtkBlueObeliskDataParser\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPeriodicTable(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPeriodicTable_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPeriodicTable", o) != 0)
  {
    Py_DECREF(o);
  }

}

