// python wrapper for vtkPiecewisePointHandleItem
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkContextMouseEvent.h"
#include "vtkPiecewisePointHandleItem.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPiecewisePointHandleItem(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPiecewisePointHandleItem_ClassNew(); }

#ifndef DECLARED_PyvtkContextItem_ClassNew
extern "C" { PyObject *PyvtkContextItem_ClassNew(); }
#define DECLARED_PyvtkContextItem_ClassNew
#endif

static const char **PyvtkPiecewisePointHandleItem_Doc();


static PyObject *
PyvtkPiecewisePointHandleItem_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPiecewisePointHandleItem::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPiecewisePointHandleItem::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPiecewisePointHandleItem *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPiecewisePointHandleItem::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPiecewisePointHandleItem *tempr = vtkPiecewisePointHandleItem::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_CallRedraw(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "CallRedraw");

  vtkObject *temp0 = NULL;
  unsigned long temp1;
  void  *temp2 = NULL;
  Py_buffer pbuf2 = VTK_PYBUFFER_INITIALIZER;
  void  *temp3 = NULL;
  Py_buffer pbuf3 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkObject") &&
      ap.GetValue(temp1) &&
      ap.GetBuffer(temp2, &pbuf2) &&
      ap.GetBuffer(temp3, &pbuf3))
  {
    vtkPiecewisePointHandleItem::CallRedraw(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf2.obj != 0)
  {
    PyBuffer_Release(&pbuf2);
  }
#endif
#if PY_VERSION_HEX >= 0x02060000
  if (pbuf3.obj != 0)
  {
    PyBuffer_Release(&pbuf3);
  }
#endif
  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_SetParent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  vtkAbstractContextItem *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAbstractContextItem"))
  {
    if (ap.IsBound())
    {
      op->SetParent(temp0);
    }
    else
    {
      op->vtkPiecewisePointHandleItem::SetParent(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_Paint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Paint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  vtkContext2D *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkContext2D"))
  {
    bool tempr = (ap.IsBound() ?
      op->Paint(temp0) :
      op->vtkPiecewisePointHandleItem::Paint(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_SetCurrentPointIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCurrentPointIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCurrentPointIndex(temp0);
    }
    else
    {
      op->vtkPiecewisePointHandleItem::SetCurrentPointIndex(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_GetCurrentPointIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurrentPointIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetCurrentPointIndex() :
      op->vtkPiecewisePointHandleItem::GetCurrentPointIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_SetPiecewiseFunction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPiecewiseFunction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  vtkPiecewiseFunction *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPiecewiseFunction"))
  {
    if (ap.IsBound())
    {
      op->SetPiecewiseFunction(temp0);
    }
    else
    {
      op->vtkPiecewisePointHandleItem::SetPiecewiseFunction(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_IsOverHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsOverHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<float> store0(2*size0);
  float *temp0 = store0.Data();
  float *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    int tempr = (ap.IsBound() ?
      op->IsOverHandle(temp0) :
      op->vtkPiecewisePointHandleItem::IsOverHandle(temp0));

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_Hit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Hit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
  {
    bool tempr = (ap.IsBound() ?
      op->Hit(*temp0) :
      op->vtkPiecewisePointHandleItem::Hit(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_MouseMoveEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MouseMoveEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
  {
    bool tempr = (ap.IsBound() ?
      op->MouseMoveEvent(*temp0) :
      op->vtkPiecewisePointHandleItem::MouseMoveEvent(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_MouseButtonPressEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MouseButtonPressEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
  {
    bool tempr = (ap.IsBound() ?
      op->MouseButtonPressEvent(*temp0) :
      op->vtkPiecewisePointHandleItem::MouseButtonPressEvent(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkPiecewisePointHandleItem_MouseButtonReleaseEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MouseButtonReleaseEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPiecewisePointHandleItem *op = static_cast<vtkPiecewisePointHandleItem *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
  {
    bool tempr = (ap.IsBound() ?
      op->MouseButtonReleaseEvent(*temp0) :
      op->vtkPiecewisePointHandleItem::MouseButtonReleaseEvent(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkPiecewisePointHandleItem_Methods[] = {
  {"GetClassName", PyvtkPiecewisePointHandleItem_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPiecewisePointHandleItem_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPiecewisePointHandleItem_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPiecewisePointHandleItem\nC++: vtkPiecewisePointHandleItem *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPiecewisePointHandleItem_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPiecewisePointHandleItem\nC++: vtkPiecewisePointHandleItem *SafeDownCast(vtkObject* o)\n\n"},
  {"CallRedraw", PyvtkPiecewisePointHandleItem_CallRedraw, METH_VARARGS,
   "V.CallRedraw(vtkObject, int, void, void)\nC++: static void CallRedraw(vtkObject *sender,\n    unsigned long event, void *receiver, void *params)\n\n"},
  {"SetParent", PyvtkPiecewisePointHandleItem_SetParent, METH_VARARGS,
   "V.SetParent(vtkAbstractContextItem)\nC++: virtual void SetParent(vtkAbstractContextItem *parent)\n\nSet the parent item, which should be a vtkControlPointItem\n"},
  {"Paint", PyvtkPiecewisePointHandleItem_Paint, METH_VARARGS,
   "V.Paint(vtkContext2D) -> bool\nC++: virtual bool Paint(vtkContext2D *painter)\n\nPaint event for the item.\n"},
  {"SetCurrentPointIndex", PyvtkPiecewisePointHandleItem_SetCurrentPointIndex, METH_VARARGS,
   "V.SetCurrentPointIndex(int)\nC++: void SetCurrentPointIndex(vtkIdType a)\n\nThe current point id in the piecewise function being handled.\n"},
  {"GetCurrentPointIndex", PyvtkPiecewisePointHandleItem_GetCurrentPointIndex, METH_VARARGS,
   "V.GetCurrentPointIndex() -> int\nC++: vtkIdType GetCurrentPointIndex()\n\nThe current point id in the piecewise function being handled.\n"},
  {"SetPiecewiseFunction", PyvtkPiecewisePointHandleItem_SetPiecewiseFunction, METH_VARARGS,
   "V.SetPiecewiseFunction(vtkPiecewiseFunction)\nC++: virtual void SetPiecewiseFunction(\n    vtkPiecewiseFunction *piecewiseFunc)\n\nSet the PieceWiseFunction the handles will manipulate\n"},
  {"IsOverHandle", PyvtkPiecewisePointHandleItem_IsOverHandle, METH_VARARGS,
   "V.IsOverHandle([float, ...]) -> int\nC++: int IsOverHandle(float *pos)\n\nReturns the index of the handle if pos is over any of the\nhandles, otherwise return -1;\n"},
  {"Hit", PyvtkPiecewisePointHandleItem_Hit, METH_VARARGS,
   "V.Hit(vtkContextMouseEvent) -> bool\nC++: virtual bool Hit(const vtkContextMouseEvent &mouse)\n\nReturns true if the supplied x, y coordinate is inside the item.\n"},
  {"MouseMoveEvent", PyvtkPiecewisePointHandleItem_MouseMoveEvent, METH_VARARGS,
   "V.MouseMoveEvent(vtkContextMouseEvent) -> bool\nC++: virtual bool MouseMoveEvent(\n    const vtkContextMouseEvent &mouse)\n\nMouse move event.\n"},
  {"MouseButtonPressEvent", PyvtkPiecewisePointHandleItem_MouseButtonPressEvent, METH_VARARGS,
   "V.MouseButtonPressEvent(vtkContextMouseEvent) -> bool\nC++: virtual bool MouseButtonPressEvent(\n    const vtkContextMouseEvent &mouse)\n\nMouse button down event.\n"},
  {"MouseButtonReleaseEvent", PyvtkPiecewisePointHandleItem_MouseButtonReleaseEvent, METH_VARARGS,
   "V.MouseButtonReleaseEvent(vtkContextMouseEvent) -> bool\nC++: virtual bool MouseButtonReleaseEvent(\n    const vtkContextMouseEvent &mouse)\n\nMouse button release event.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPiecewisePointHandleItem_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkChartsCorePython.vtkPiecewisePointHandleItem", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPiecewisePointHandleItem_StaticNew()
{
  return vtkPiecewisePointHandleItem::New();
}

PyObject *PyvtkPiecewisePointHandleItem_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPiecewisePointHandleItem_Type, PyvtkPiecewisePointHandleItem_Methods,
    "vtkPiecewisePointHandleItem",
    PyvtkPiecewisePointHandleItem_Doc(), &PyvtkPiecewisePointHandleItem_StaticNew);

  PyTypeObject *pytype = &PyvtkPiecewisePointHandleItem_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkContextItem_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPiecewisePointHandleItem_Doc()
{
  static const char *docstring[] = {
    "vtkPiecewisePointHandleItem - a vtkContextItem that draws handles\n      around a point of a piecewise function\n\n",
    "Superclass: vtkContextItem\n\n",
    "This is a vtkContextItem that can be placed into a vtkContextScene.\nIt draws handles around a given point of a piecewise function so that\nthe curve can be adjusted using these handles.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPiecewisePointHandleItem(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPiecewisePointHandleItem_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPiecewisePointHandleItem", o) != 0)
  {
    Py_DECREF(o);
  }

}

