// python wrapper for vtkPointCloudFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPointCloudFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPointCloudFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPointCloudFilter_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkPointCloudFilter_Doc();


static PyObject *
PyvtkPointCloudFilter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPointCloudFilter::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPointCloudFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPointCloudFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPointCloudFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPointCloudFilter *tempr = vtkPointCloudFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_GetPointMap(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPointMap");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const vtkIdType *tempr = (ap.IsBound() ?
      op->GetPointMap() :
      op->vtkPointCloudFilter::GetPointMap());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_GetNumberOfPointsRemoved(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfPointsRemoved");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetNumberOfPointsRemoved() :
      op->vtkPointCloudFilter::GetNumberOfPointsRemoved());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_SetGenerateOutliers(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGenerateOutliers");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGenerateOutliers(temp0);
    }
    else
    {
      op->vtkPointCloudFilter::SetGenerateOutliers(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_GetGenerateOutliers(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGenerateOutliers");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetGenerateOutliers() :
      op->vtkPointCloudFilter::GetGenerateOutliers());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_GenerateOutliersOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GenerateOutliersOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->GenerateOutliersOn();
    }
    else
    {
      op->vtkPointCloudFilter::GenerateOutliersOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_GenerateOutliersOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GenerateOutliersOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->GenerateOutliersOff();
    }
    else
    {
      op->vtkPointCloudFilter::GenerateOutliersOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_SetGenerateVertices(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGenerateVertices");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGenerateVertices(temp0);
    }
    else
    {
      op->vtkPointCloudFilter::SetGenerateVertices(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_GetGenerateVertices(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGenerateVertices");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetGenerateVertices() :
      op->vtkPointCloudFilter::GetGenerateVertices());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_GenerateVerticesOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GenerateVerticesOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->GenerateVerticesOn();
    }
    else
    {
      op->vtkPointCloudFilter::GenerateVerticesOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPointCloudFilter_GenerateVerticesOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GenerateVerticesOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointCloudFilter *op = static_cast<vtkPointCloudFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->GenerateVerticesOff();
    }
    else
    {
      op->vtkPointCloudFilter::GenerateVerticesOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPointCloudFilter_Methods[] = {
  {"GetClassName", PyvtkPointCloudFilter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nStandard methods to obtain type information, and print\ninformation.\n"},
  {"IsA", PyvtkPointCloudFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nStandard methods to obtain type information, and print\ninformation.\n"},
  {"NewInstance", PyvtkPointCloudFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPointCloudFilter\nC++: vtkPointCloudFilter *NewInstance()\n\nStandard methods to obtain type information, and print\ninformation.\n"},
  {"SafeDownCast", PyvtkPointCloudFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPointCloudFilter\nC++: vtkPointCloudFilter *SafeDownCast(vtkObject* o)\n\nStandard methods to obtain type information, and print\ninformation.\n"},
  {"GetPointMap", PyvtkPointCloudFilter_GetPointMap, METH_VARARGS,
   "V.GetPointMap() -> (int, ...)\nC++: const vtkIdType *GetPointMap()\n\nRetrieve a map which indicates, on a point-by-point basis, where\neach input point was placed into the output. In other words,\nmap[i] indicates where the ith input point is located in the\noutput array of points. If map[i] < 0, then the ith input point\nwas removed during filter execution.  This method returns valid\ninformation only after the filter executes.\n"},
  {"GetNumberOfPointsRemoved", PyvtkPointCloudFilter_GetNumberOfPointsRemoved, METH_VARARGS,
   "V.GetNumberOfPointsRemoved() -> int\nC++: vtkIdType GetNumberOfPointsRemoved()\n\nReturn the number of points removed after filter execution. The\ninformation retuned is valid only after the filter executes.\n"},
  {"SetGenerateOutliers", PyvtkPointCloudFilter_SetGenerateOutliers, METH_VARARGS,
   "V.SetGenerateOutliers(bool)\nC++: void SetGenerateOutliers(bool a)\n\nIf this method is enabled (true), then a second output will be\ncreated that contains the outlier points. By default this is off\n(false).  Note that if enabled, the PointMap is modified as well:\nthe outlier points are listed as well, with similar meaning,\nexcept their value is negated and shifted by -1.\n"},
  {"GetGenerateOutliers", PyvtkPointCloudFilter_GetGenerateOutliers, METH_VARARGS,
   "V.GetGenerateOutliers() -> bool\nC++: bool GetGenerateOutliers()\n\nIf this method is enabled (true), then a second output will be\ncreated that contains the outlier points. By default this is off\n(false).  Note that if enabled, the PointMap is modified as well:\nthe outlier points are listed as well, with similar meaning,\nexcept their value is negated and shifted by -1.\n"},
  {"GenerateOutliersOn", PyvtkPointCloudFilter_GenerateOutliersOn, METH_VARARGS,
   "V.GenerateOutliersOn()\nC++: void GenerateOutliersOn()\n\nIf this method is enabled (true), then a second output will be\ncreated that contains the outlier points. By default this is off\n(false).  Note that if enabled, the PointMap is modified as well:\nthe outlier points are listed as well, with similar meaning,\nexcept their value is negated and shifted by -1.\n"},
  {"GenerateOutliersOff", PyvtkPointCloudFilter_GenerateOutliersOff, METH_VARARGS,
   "V.GenerateOutliersOff()\nC++: void GenerateOutliersOff()\n\nIf this method is enabled (true), then a second output will be\ncreated that contains the outlier points. By default this is off\n(false).  Note that if enabled, the PointMap is modified as well:\nthe outlier points are listed as well, with similar meaning,\nexcept their value is negated and shifted by -1.\n"},
  {"SetGenerateVertices", PyvtkPointCloudFilter_SetGenerateVertices, METH_VARARGS,
   "V.SetGenerateVertices(bool)\nC++: void SetGenerateVertices(bool a)\n\nIf this method is enabled (true), then the outputs will contain a\nvertex cells (i.e., a vtkPolyVertex for each output). This takes\na lot more memory but some VTK filters need cells to function\nproperly. By default this is off (false).\n"},
  {"GetGenerateVertices", PyvtkPointCloudFilter_GetGenerateVertices, METH_VARARGS,
   "V.GetGenerateVertices() -> bool\nC++: bool GetGenerateVertices()\n\nIf this method is enabled (true), then the outputs will contain a\nvertex cells (i.e., a vtkPolyVertex for each output). This takes\na lot more memory but some VTK filters need cells to function\nproperly. By default this is off (false).\n"},
  {"GenerateVerticesOn", PyvtkPointCloudFilter_GenerateVerticesOn, METH_VARARGS,
   "V.GenerateVerticesOn()\nC++: void GenerateVerticesOn()\n\nIf this method is enabled (true), then the outputs will contain a\nvertex cells (i.e., a vtkPolyVertex for each output). This takes\na lot more memory but some VTK filters need cells to function\nproperly. By default this is off (false).\n"},
  {"GenerateVerticesOff", PyvtkPointCloudFilter_GenerateVerticesOff, METH_VARARGS,
   "V.GenerateVerticesOff()\nC++: void GenerateVerticesOff()\n\nIf this method is enabled (true), then the outputs will contain a\nvertex cells (i.e., a vtkPolyVertex for each output). This takes\na lot more memory but some VTK filters need cells to function\nproperly. By default this is off (false).\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPointCloudFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersPointsPython.vtkPointCloudFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkPointCloudFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPointCloudFilter_Type, PyvtkPointCloudFilter_Methods,
    "vtkPointCloudFilter",
    PyvtkPointCloudFilter_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkPointCloudFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPointCloudFilter_Doc()
{
  static const char *docstring[] = {
    "vtkPointCloudFilter - abstract class for filtering a point cloud\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkPointCloudFilter serves as a base for classes that filter point\nclouds. It takes as input any vtkPointSet (which represents points\nexplicitly using vtkPoints) and produces as output an explicit\nrepresentation of filtered points via a vtkPolyData. This output\nvtkPolyData will populate its instance of vtkPoints, and typically no\ncells will be defined (i.e., no vtkVertex or vtkPolyVertex are\nconta",
    "ined in the output unless explicitly requested). Also, after\nfilter execution, the user can request a vtkIdType* point map which\nindicates how the input points were mapped to the output. A value of\nPointMap[i] < 0 (where i is the ith input point) means that the ith\ninput point was removed. Otherwise PointMap[i] indicates the position\nin the output vtkPoints array (point cloud).\n\nOptionally the fil",
    "ter may produce a second output. This second output\nis another vtkPolyData with a vtkPoints that contains the points that\nwere removed during processing. To produce this second output, you\nmust enable GenerateOutliers. If this optional, second output is\ncreated, then the contents of the PointMap are modified as well. In\nthis case, a PointMap[i] < 0 means that the ith input point has been\nmapped to",
    " the (-PointMap[i])-1 position in the second output's\nvtkPoints.\n\n@warning\nThis class has been threaded with vtkSMPTools. Using TBB or other\nnon-sequential type (set in the CMake variable\nVTK_SMP_IMPLEMENTATION_TYPE) may improve performance significantly.\n\n@warning\nThe filter copies point attributes from input to output consistent\nwith the filtering operation.\n\n@warning\nIt is convenient to use vtk",
    "PointGaussianMapper to render the points\n(since this mapper does not require cells to be defined, and it is\nquite fast).\n\n@sa\nvtkRadiusOutlierRemoval vtkPointGaussianMapper vtkThresholdPoints\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPointCloudFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPointCloudFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPointCloudFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

