// python wrapper for vtkPointData
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPointData.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPointData(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPointData_ClassNew(); }

#ifndef DECLARED_PyvtkDataSetAttributes_ClassNew
extern "C" { PyObject *PyvtkDataSetAttributes_ClassNew(); }
#define DECLARED_PyvtkDataSetAttributes_ClassNew
#endif

static const char **PyvtkPointData_Doc();


static PyObject *
PyvtkPointData_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointData *op = static_cast<vtkPointData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPointData::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointData_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointData *op = static_cast<vtkPointData *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPointData::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointData_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointData *op = static_cast<vtkPointData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPointData *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPointData::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPointData_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPointData *tempr = vtkPointData::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointData_NullPoint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NullPoint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointData *op = static_cast<vtkPointData *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->NullPoint(temp0);
    }
    else
    {
      op->vtkPointData::NullPoint(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPointData_Methods[] = {
  {"GetClassName", PyvtkPointData_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPointData_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPointData_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPointData\nC++: vtkPointData *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPointData_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPointData\nC++: vtkPointData *SafeDownCast(vtkObject* o)\n\n"},
  {"NullPoint", PyvtkPointData_NullPoint, METH_VARARGS,
   "V.NullPoint(int)\nC++: void NullPoint(vtkIdType ptId)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPointData_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonDataModelPython.vtkPointData", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPointData_StaticNew()
{
  return vtkPointData::New();
}

PyObject *PyvtkPointData_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPointData_Type, PyvtkPointData_Methods,
    "vtkPointData",
    PyvtkPointData_Doc(), &PyvtkPointData_StaticNew);

  PyTypeObject *pytype = &PyvtkPointData_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataSetAttributes_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPointData_Doc()
{
  static const char *docstring[] = {
    "vtkPointData - represent and manipulate point attribute data\n\n",
    "Superclass: vtkDataSetAttributes\n\n",
    "vtkPointData is a class that is used to represent and manipulate\npoint attribute data (e.g., scalars, vectors, normals, texture\ncoordinates, etc.) Most of the functionality is handled by\nvtkDataSetAttributes\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPointData(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPointData_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPointData", o) != 0)
  {
    Py_DECREF(o);
  }

}

