// python wrapper for vtkPointFillPass
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPointFillPass.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPointFillPass(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPointFillPass_ClassNew(); }

#ifndef DECLARED_PyvtkDepthImageProcessingPass_ClassNew
extern "C" { PyObject *PyvtkDepthImageProcessingPass_ClassNew(); }
#define DECLARED_PyvtkDepthImageProcessingPass_ClassNew
#endif

static const char **PyvtkPointFillPass_Doc();


static PyObject *
PyvtkPointFillPass_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointFillPass *op = static_cast<vtkPointFillPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPointFillPass::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointFillPass_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointFillPass *op = static_cast<vtkPointFillPass *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPointFillPass::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointFillPass_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointFillPass *op = static_cast<vtkPointFillPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPointFillPass *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPointFillPass::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPointFillPass_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPointFillPass *tempr = vtkPointFillPass::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointFillPass_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointFillPass *op = static_cast<vtkPointFillPass *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkPointFillPass::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPointFillPass_SetCandidatePointRatio(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCandidatePointRatio");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointFillPass *op = static_cast<vtkPointFillPass *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCandidatePointRatio(temp0);
    }
    else
    {
      op->vtkPointFillPass::SetCandidatePointRatio(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPointFillPass_GetCandidatePointRatio(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCandidatePointRatio");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointFillPass *op = static_cast<vtkPointFillPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetCandidatePointRatio() :
      op->vtkPointFillPass::GetCandidatePointRatio());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPointFillPass_SetMinimumCandidateAngle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMinimumCandidateAngle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointFillPass *op = static_cast<vtkPointFillPass *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMinimumCandidateAngle(temp0);
    }
    else
    {
      op->vtkPointFillPass::SetMinimumCandidateAngle(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPointFillPass_GetMinimumCandidateAngle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMinimumCandidateAngle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPointFillPass *op = static_cast<vtkPointFillPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetMinimumCandidateAngle() :
      op->vtkPointFillPass::GetMinimumCandidateAngle());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPointFillPass_Methods[] = {
  {"GetClassName", PyvtkPointFillPass_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPointFillPass_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPointFillPass_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPointFillPass\nC++: vtkPointFillPass *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPointFillPass_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPointFillPass\nC++: vtkPointFillPass *SafeDownCast(vtkObject* o)\n\n"},
  {"ReleaseGraphicsResources", PyvtkPointFillPass_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *w)\n\nRelease graphics resources and ask components to release their\nown resources.\n\\pre w_exists: w!=0\n"},
  {"SetCandidatePointRatio", PyvtkPointFillPass_SetCandidatePointRatio, METH_VARARGS,
   "V.SetCandidatePointRatio(float)\nC++: void SetCandidatePointRatio(float a)\n\nHow far in front of a point must a neighboring point be to be\nused as a filler candidate.  Expressed as a multiple of the\npoints distance from the camera. Defaults to 0.95\n"},
  {"GetCandidatePointRatio", PyvtkPointFillPass_GetCandidatePointRatio, METH_VARARGS,
   "V.GetCandidatePointRatio() -> float\nC++: float GetCandidatePointRatio()\n\nHow far in front of a point must a neighboring point be to be\nused as a filler candidate.  Expressed as a multiple of the\npoints distance from the camera. Defaults to 0.95\n"},
  {"SetMinimumCandidateAngle", PyvtkPointFillPass_SetMinimumCandidateAngle, METH_VARARGS,
   "V.SetMinimumCandidateAngle(float)\nC++: void SetMinimumCandidateAngle(float a)\n\nHow large of an angle must the filler candidates span before a\npoint will be filled. Expressed in radians. A value of pi will\nkeep edges from growing out. Large values require more support,\nlower values less.\n"},
  {"GetMinimumCandidateAngle", PyvtkPointFillPass_GetMinimumCandidateAngle, METH_VARARGS,
   "V.GetMinimumCandidateAngle() -> float\nC++: float GetMinimumCandidateAngle()\n\nHow large of an angle must the filler candidates span before a\npoint will be filled. Expressed in radians. A value of pi will\nkeep edges from growing out. Large values require more support,\nlower values less.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPointFillPass_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkPointFillPass", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPointFillPass_StaticNew()
{
  return vtkPointFillPass::New();
}

PyObject *PyvtkPointFillPass_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPointFillPass_Type, PyvtkPointFillPass_Methods,
    "vtkPointFillPass",
    PyvtkPointFillPass_Doc(), &PyvtkPointFillPass_StaticNew);

  PyTypeObject *pytype = &PyvtkPointFillPass_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDepthImageProcessingPass_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPointFillPass_Doc()
{
  static const char *docstring[] = {
    "vtkPointFillPass - Implement a post-processing fillpass\n\n",
    "Superclass: vtkDepthImageProcessingPass\n\n",
    "This pass is designed to fill in rendering of sparse point\nsets/coulds The delegate is used once and is usually set to a\nvtkCameraPass or to a post-processing pass.\n\n@sa\nvtkRenderPass\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPointFillPass(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPointFillPass_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPointFillPass", o) != 0)
  {
    Py_DECREF(o);
  }

}

