// python wrapper for vtkPolyDataToImageStencil
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPolyDataToImageStencil.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPolyDataToImageStencil(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPolyDataToImageStencil_ClassNew(); }

#ifndef DECLARED_PyvtkImageStencilSource_ClassNew
extern "C" { PyObject *PyvtkImageStencilSource_ClassNew(); }
#define DECLARED_PyvtkImageStencilSource_ClassNew
#endif

static const char **PyvtkPolyDataToImageStencil_Doc();


static PyObject *
PyvtkPolyDataToImageStencil_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataToImageStencil *op = static_cast<vtkPolyDataToImageStencil *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPolyDataToImageStencil::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataToImageStencil_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataToImageStencil *op = static_cast<vtkPolyDataToImageStencil *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPolyDataToImageStencil::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataToImageStencil_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataToImageStencil *op = static_cast<vtkPolyDataToImageStencil *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPolyDataToImageStencil *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPolyDataToImageStencil::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataToImageStencil_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPolyDataToImageStencil *tempr = vtkPolyDataToImageStencil::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataToImageStencil_SetInputData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataToImageStencil *op = static_cast<vtkPolyDataToImageStencil *>(vp);

  vtkPolyData *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPolyData"))
  {
    if (ap.IsBound())
    {
      op->SetInputData(temp0);
    }
    else
    {
      op->vtkPolyDataToImageStencil::SetInputData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataToImageStencil_GetInput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataToImageStencil *op = static_cast<vtkPolyDataToImageStencil *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPolyData *tempr = (ap.IsBound() ?
      op->GetInput() :
      op->vtkPolyDataToImageStencil::GetInput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataToImageStencil_SetTolerance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTolerance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataToImageStencil *op = static_cast<vtkPolyDataToImageStencil *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTolerance(temp0);
    }
    else
    {
      op->vtkPolyDataToImageStencil::SetTolerance(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataToImageStencil_GetToleranceMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetToleranceMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataToImageStencil *op = static_cast<vtkPolyDataToImageStencil *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetToleranceMinValue() :
      op->vtkPolyDataToImageStencil::GetToleranceMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataToImageStencil_GetToleranceMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetToleranceMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataToImageStencil *op = static_cast<vtkPolyDataToImageStencil *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetToleranceMaxValue() :
      op->vtkPolyDataToImageStencil::GetToleranceMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataToImageStencil_GetTolerance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTolerance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataToImageStencil *op = static_cast<vtkPolyDataToImageStencil *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTolerance() :
      op->vtkPolyDataToImageStencil::GetTolerance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPolyDataToImageStencil_Methods[] = {
  {"GetClassName", PyvtkPolyDataToImageStencil_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPolyDataToImageStencil_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPolyDataToImageStencil_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPolyDataToImageStencil\nC++: vtkPolyDataToImageStencil *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPolyDataToImageStencil_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPolyDataToImageStencil\nC++: vtkPolyDataToImageStencil *SafeDownCast(vtkObject* o)\n\n"},
  {"SetInputData", PyvtkPolyDataToImageStencil_SetInputData, METH_VARARGS,
   "V.SetInputData(vtkPolyData)\nC++: virtual void SetInputData(vtkPolyData *)\n\nSpecify the implicit function to convert into a stencil.\n"},
  {"GetInput", PyvtkPolyDataToImageStencil_GetInput, METH_VARARGS,
   "V.GetInput() -> vtkPolyData\nC++: vtkPolyData *GetInput()\n\nSpecify the implicit function to convert into a stencil.\n"},
  {"SetTolerance", PyvtkPolyDataToImageStencil_SetTolerance, METH_VARARGS,
   "V.SetTolerance(float)\nC++: void SetTolerance(double)\n\nThe tolerance for including a voxel inside the stencil. This is\nin fractions of a voxel, and must be between 0 and 1. Tolerance\nis only applied in the x and y directions, not in z. Setting the\ntolerance to zero disables all tolerance checks and might result\nin faster performance.\n"},
  {"GetToleranceMinValue", PyvtkPolyDataToImageStencil_GetToleranceMinValue, METH_VARARGS,
   "V.GetToleranceMinValue() -> float\nC++: double GetToleranceMinValue()\n\nThe tolerance for including a voxel inside the stencil. This is\nin fractions of a voxel, and must be between 0 and 1. Tolerance\nis only applied in the x and y directions, not in z. Setting the\ntolerance to zero disables all tolerance checks and might result\nin faster performance.\n"},
  {"GetToleranceMaxValue", PyvtkPolyDataToImageStencil_GetToleranceMaxValue, METH_VARARGS,
   "V.GetToleranceMaxValue() -> float\nC++: double GetToleranceMaxValue()\n\nThe tolerance for including a voxel inside the stencil. This is\nin fractions of a voxel, and must be between 0 and 1. Tolerance\nis only applied in the x and y directions, not in z. Setting the\ntolerance to zero disables all tolerance checks and might result\nin faster performance.\n"},
  {"GetTolerance", PyvtkPolyDataToImageStencil_GetTolerance, METH_VARARGS,
   "V.GetTolerance() -> float\nC++: double GetTolerance()\n\nThe tolerance for including a voxel inside the stencil. This is\nin fractions of a voxel, and must be between 0 and 1. Tolerance\nis only applied in the x and y directions, not in z. Setting the\ntolerance to zero disables all tolerance checks and might result\nin faster performance.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPolyDataToImageStencil_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingStencilPython.vtkPolyDataToImageStencil", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPolyDataToImageStencil_StaticNew()
{
  return vtkPolyDataToImageStencil::New();
}

PyObject *PyvtkPolyDataToImageStencil_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPolyDataToImageStencil_Type, PyvtkPolyDataToImageStencil_Methods,
    "vtkPolyDataToImageStencil",
    PyvtkPolyDataToImageStencil_Doc(), &PyvtkPolyDataToImageStencil_StaticNew);

  PyTypeObject *pytype = &PyvtkPolyDataToImageStencil_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageStencilSource_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPolyDataToImageStencil_Doc()
{
  static const char *docstring[] = {
    "vtkPolyDataToImageStencil - use polydata to mask an image\n\n",
    "Superclass: vtkImageStencilSource\n\n",
    "The vtkPolyDataToImageStencil class will convert polydata into an\nimage stencil.  The polydata can either be a closed surface mesh or a\nseries of polyline contours (one contour per slice).\n@warning\nIf contours are provided, the contours must be aligned with the Z\nplanes.  Other contour orientations are not supported.\n@sa\nvtkImageStencil vtkImageAccumulate vtkImageBlend vtkImageReslice\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPolyDataToImageStencil(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPolyDataToImageStencil_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPolyDataToImageStencil", o) != 0)
  {
    Py_DECREF(o);
  }

}

