// python wrapper for vtkQImageToImageSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkQImageToImageSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkQImageToImageSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkQImageToImageSource_ClassNew(); }

#ifndef DECLARED_PyvtkImageAlgorithm_ClassNew
extern "C" { PyObject *PyvtkImageAlgorithm_ClassNew(); }
#define DECLARED_PyvtkImageAlgorithm_ClassNew
#endif

static const char **PyvtkQImageToImageSource_Doc();


static PyObject *
PyvtkQImageToImageSource_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQImageToImageSource *op = static_cast<vtkQImageToImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkQImageToImageSource::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQImageToImageSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQImageToImageSource *op = static_cast<vtkQImageToImageSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkQImageToImageSource::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQImageToImageSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQImageToImageSource *op = static_cast<vtkQImageToImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkQImageToImageSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkQImageToImageSource::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkQImageToImageSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkQImageToImageSource *tempr = vtkQImageToImageSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQImageToImageSource_SetQImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQImageToImageSource *op = static_cast<vtkQImageToImageSource *>(vp);

  QImage *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSIPObject(temp0, "QImage"))
  {
    if (ap.IsBound())
    {
      op->SetQImage(temp0);
    }
    else
    {
      op->vtkQImageToImageSource::SetQImage(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkQImageToImageSource_GetQImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQImageToImageSource *op = static_cast<vtkQImageToImageSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const QImage *tempr = (ap.IsBound() ?
      op->GetQImage() :
      op->vtkQImageToImageSource::GetQImage());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSIPObject(tempr, "QImage", false);
    }
  }

  return result;
}

static PyMethodDef PyvtkQImageToImageSource_Methods[] = {
  {"GetClassName", PyvtkQImageToImageSource_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkQImageToImageSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkQImageToImageSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkQImageToImageSource\nC++: vtkQImageToImageSource *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkQImageToImageSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkQImageToImageSource\nC++: vtkQImageToImageSource *SafeDownCast(vtkObject* o)\n\n"},
  {"SetQImage", PyvtkQImageToImageSource_SetQImage, METH_VARARGS,
   "V.SetQImage(QImage)\nC++: void SetQImage(QImage *image)\n\nSet/Get QImage surface to be used.\n"},
  {"GetQImage", PyvtkQImageToImageSource_GetQImage, METH_VARARGS,
   "V.GetQImage() -> QImage\nC++: const QImage *GetQImage()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkQImageToImageSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingQtPython.vtkQImageToImageSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkQImageToImageSource_StaticNew()
{
  return vtkQImageToImageSource::New();
}

PyObject *PyvtkQImageToImageSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkQImageToImageSource_Type, PyvtkQImageToImageSource_Methods,
    "vtkQImageToImageSource",
    PyvtkQImageToImageSource_Doc(), &PyvtkQImageToImageSource_StaticNew);

  PyTypeObject *pytype = &PyvtkQImageToImageSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkQImageToImageSource_Doc()
{
  static const char *docstring[] = {
    "vtkQImageToImageSource - Create image data from a QImage.\n\n",
    "Superclass: vtkImageAlgorithm\n\n",
    "vtkQImageToImageSource produces image data from a QImage.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkQImageToImageSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkQImageToImageSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkQImageToImageSource", o) != 0)
  {
    Py_DECREF(o);
  }

}

