// python wrapper for vtkRIBProperty
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkRIBProperty.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkRIBProperty(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkRIBProperty_ClassNew(); }

#ifndef DECLARED_PyvtkProperty_ClassNew
extern "C" { PyObject *PyvtkProperty_ClassNew(); }
#define DECLARED_PyvtkProperty_ClassNew
#endif

static const char **PyvtkRIBProperty_Doc();


static PyObject *
PyvtkRIBProperty_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkRIBProperty::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkRIBProperty::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRIBProperty *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkRIBProperty::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkRIBProperty *tempr = vtkRIBProperty::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_SetSurfaceShaderUsesDefaultParameters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSurfaceShaderUsesDefaultParameters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSurfaceShaderUsesDefaultParameters(temp0);
    }
    else
    {
      op->vtkRIBProperty::SetSurfaceShaderUsesDefaultParameters(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_GetSurfaceShaderUsesDefaultParameters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSurfaceShaderUsesDefaultParameters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetSurfaceShaderUsesDefaultParameters() :
      op->vtkRIBProperty::GetSurfaceShaderUsesDefaultParameters());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_SurfaceShaderUsesDefaultParametersOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SurfaceShaderUsesDefaultParametersOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SurfaceShaderUsesDefaultParametersOn();
    }
    else
    {
      op->vtkRIBProperty::SurfaceShaderUsesDefaultParametersOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_SurfaceShaderUsesDefaultParametersOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SurfaceShaderUsesDefaultParametersOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SurfaceShaderUsesDefaultParametersOff();
    }
    else
    {
      op->vtkRIBProperty::SurfaceShaderUsesDefaultParametersOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_SetSurfaceShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSurfaceShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSurfaceShader(temp0);
    }
    else
    {
      op->vtkRIBProperty::SetSurfaceShader(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_GetSurfaceShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSurfaceShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetSurfaceShader() :
      op->vtkRIBProperty::GetSurfaceShader());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_SetDisplacementShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplacementShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDisplacementShader(temp0);
    }
    else
    {
      op->vtkRIBProperty::SetDisplacementShader(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_GetDisplacementShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplacementShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetDisplacementShader() :
      op->vtkRIBProperty::GetDisplacementShader());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_SetVariable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVariable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetVariable(temp0, temp1);
    }
    else
    {
      op->vtkRIBProperty::SetVariable(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_AddVariable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddVariable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->AddVariable(temp0, temp1);
    }
    else
    {
      op->vtkRIBProperty::AddVariable(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_GetDeclarations(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDeclarations");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetDeclarations() :
      op->vtkRIBProperty::GetDeclarations());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_SetParameter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParameter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetParameter(temp0, temp1);
    }
    else
    {
      op->vtkRIBProperty::SetParameter(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_AddParameter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddParameter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->AddParameter(temp0, temp1);
    }
    else
    {
      op->vtkRIBProperty::AddParameter(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_SetSurfaceShaderParameter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSurfaceShaderParameter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetSurfaceShaderParameter(temp0, temp1);
    }
    else
    {
      op->vtkRIBProperty::SetSurfaceShaderParameter(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_AddSurfaceShaderParameter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddSurfaceShaderParameter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->AddSurfaceShaderParameter(temp0, temp1);
    }
    else
    {
      op->vtkRIBProperty::AddSurfaceShaderParameter(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_SetDisplacementShaderParameter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplacementShaderParameter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetDisplacementShaderParameter(temp0, temp1);
    }
    else
    {
      op->vtkRIBProperty::SetDisplacementShaderParameter(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_AddDisplacementShaderParameter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddDisplacementShaderParameter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->AddDisplacementShaderParameter(temp0, temp1);
    }
    else
    {
      op->vtkRIBProperty::AddDisplacementShaderParameter(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_GetParameters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParameters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetParameters() :
      op->vtkRIBProperty::GetParameters());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_GetSurfaceShaderParameters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSurfaceShaderParameters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetSurfaceShaderParameters() :
      op->vtkRIBProperty::GetSurfaceShaderParameters());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRIBProperty_GetDisplacementShaderParameters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplacementShaderParameters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRIBProperty *op = static_cast<vtkRIBProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetDisplacementShaderParameters() :
      op->vtkRIBProperty::GetDisplacementShaderParameters());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkRIBProperty_Methods[] = {
  {"GetClassName", PyvtkRIBProperty_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkRIBProperty_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkRIBProperty_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkRIBProperty\nC++: vtkRIBProperty *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkRIBProperty_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkRIBProperty\nC++: vtkRIBProperty *SafeDownCast(vtkObject* o)\n\n"},
  {"SetSurfaceShaderUsesDefaultParameters", PyvtkRIBProperty_SetSurfaceShaderUsesDefaultParameters, METH_VARARGS,
   "V.SetSurfaceShaderUsesDefaultParameters(bool)\nC++: void SetSurfaceShaderUsesDefaultParameters(bool a)\n\nIf true (default) the surface shader uses the usual shader\nparameters: Ka - Ambient amount Kd - Diffuse amount Ks - Specular\namount Roughness SpecularColor Additional surface shader\nparameters can be added with the Set/AddSurfaceShaderParameter\nmethods. If false, all surface shader parameters must be\nspecified\n"},
  {"GetSurfaceShaderUsesDefaultParameters", PyvtkRIBProperty_GetSurfaceShaderUsesDefaultParameters, METH_VARARGS,
   "V.GetSurfaceShaderUsesDefaultParameters() -> bool\nC++: bool GetSurfaceShaderUsesDefaultParameters()\n\nIf true (default) the surface shader uses the usual shader\nparameters: Ka - Ambient amount Kd - Diffuse amount Ks - Specular\namount Roughness SpecularColor Additional surface shader\nparameters can be added with the Set/AddSurfaceShaderParameter\nmethods. If false, all surface shader parameters must be\nspecified\n"},
  {"SurfaceShaderUsesDefaultParametersOn", PyvtkRIBProperty_SurfaceShaderUsesDefaultParametersOn, METH_VARARGS,
   "V.SurfaceShaderUsesDefaultParametersOn()\nC++: void SurfaceShaderUsesDefaultParametersOn()\n\nIf true (default) the surface shader uses the usual shader\nparameters: Ka - Ambient amount Kd - Diffuse amount Ks - Specular\namount Roughness SpecularColor Additional surface shader\nparameters can be added with the Set/AddSurfaceShaderParameter\nmethods. If false, all surface shader parameters must be\nspecified\n"},
  {"SurfaceShaderUsesDefaultParametersOff", PyvtkRIBProperty_SurfaceShaderUsesDefaultParametersOff, METH_VARARGS,
   "V.SurfaceShaderUsesDefaultParametersOff()\nC++: void SurfaceShaderUsesDefaultParametersOff()\n\nIf true (default) the surface shader uses the usual shader\nparameters: Ka - Ambient amount Kd - Diffuse amount Ks - Specular\namount Roughness SpecularColor Additional surface shader\nparameters can be added with the Set/AddSurfaceShaderParameter\nmethods. If false, all surface shader parameters must be\nspecified\n"},
  {"SetSurfaceShader", PyvtkRIBProperty_SetSurfaceShader, METH_VARARGS,
   "V.SetSurfaceShader(string)\nC++: void SetSurfaceShader(char *)\n\nSpecify the name of a surface shader.\n"},
  {"GetSurfaceShader", PyvtkRIBProperty_GetSurfaceShader, METH_VARARGS,
   "V.GetSurfaceShader() -> string\nC++: char *GetSurfaceShader()\n\nSpecify the name of a surface shader.\n"},
  {"SetDisplacementShader", PyvtkRIBProperty_SetDisplacementShader, METH_VARARGS,
   "V.SetDisplacementShader(string)\nC++: void SetDisplacementShader(char *)\n\nSpecify the name of a displacement shader.\n"},
  {"GetDisplacementShader", PyvtkRIBProperty_GetDisplacementShader, METH_VARARGS,
   "V.GetDisplacementShader() -> string\nC++: char *GetDisplacementShader()\n\nSpecify the name of a displacement shader.\n"},
  {"SetVariable", PyvtkRIBProperty_SetVariable, METH_VARARGS,
   "V.SetVariable(string, string)\nC++: void SetVariable(const char *variable,\n    const char *declaration)\n\nSpecify declarations for variables..\n"},
  {"AddVariable", PyvtkRIBProperty_AddVariable, METH_VARARGS,
   "V.AddVariable(string, string)\nC++: void AddVariable(const char *variable,\n    const char *declaration)\n\nSpecify declarations for variables..\n"},
  {"GetDeclarations", PyvtkRIBProperty_GetDeclarations, METH_VARARGS,
   "V.GetDeclarations() -> string\nC++: char *GetDeclarations()\n\nGet variable declarations\n"},
  {"SetParameter", PyvtkRIBProperty_SetParameter, METH_VARARGS,
   "V.SetParameter(string, string)\nC++: void SetParameter(const char *parameter, const char *value)\n\nSpecify parameter values for variables. DEPRECATED: use\n(Set/Add)SurfaceShaderParameter instead.\n"},
  {"AddParameter", PyvtkRIBProperty_AddParameter, METH_VARARGS,
   "V.AddParameter(string, string)\nC++: void AddParameter(const char *parameter, const char *value)\n\nSpecify parameter values for variables. DEPRECATED: use\n(Set/Add)SurfaceShaderParameter instead.\n"},
  {"SetSurfaceShaderParameter", PyvtkRIBProperty_SetSurfaceShaderParameter, METH_VARARGS,
   "V.SetSurfaceShaderParameter(string, string)\nC++: void SetSurfaceShaderParameter(const char *parameter,\n    const char *value)\n\nSpecify parameter values for surface shader parameters\n"},
  {"AddSurfaceShaderParameter", PyvtkRIBProperty_AddSurfaceShaderParameter, METH_VARARGS,
   "V.AddSurfaceShaderParameter(string, string)\nC++: void AddSurfaceShaderParameter(const char *parameter,\n    const char *value)\n\nSpecify parameter values for surface shader parameters\n"},
  {"SetDisplacementShaderParameter", PyvtkRIBProperty_SetDisplacementShaderParameter, METH_VARARGS,
   "V.SetDisplacementShaderParameter(string, string)\nC++: void SetDisplacementShaderParameter(const char *parameter,\n    const char *value)\n\nSpecify parameter values for displacement shader parameters\n"},
  {"AddDisplacementShaderParameter", PyvtkRIBProperty_AddDisplacementShaderParameter, METH_VARARGS,
   "V.AddDisplacementShaderParameter(string, string)\nC++: void AddDisplacementShaderParameter(const char *parameter,\n    const char *value)\n\nSpecify parameter values for displacement shader parameters\n"},
  {"GetParameters", PyvtkRIBProperty_GetParameters, METH_VARARGS,
   "V.GetParameters() -> string\nC++: char *GetParameters()\n\nGet parameters.\n"},
  {"GetSurfaceShaderParameters", PyvtkRIBProperty_GetSurfaceShaderParameters, METH_VARARGS,
   "V.GetSurfaceShaderParameters() -> string\nC++: char *GetSurfaceShaderParameters()\n\nGet parameters.\n"},
  {"GetDisplacementShaderParameters", PyvtkRIBProperty_GetDisplacementShaderParameters, METH_VARARGS,
   "V.GetDisplacementShaderParameters() -> string\nC++: char *GetDisplacementShaderParameters()\n\nGet parameters.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkRIBProperty_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOExportPython.vtkRIBProperty", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkRIBProperty_StaticNew()
{
  return vtkRIBProperty::New();
}

PyObject *PyvtkRIBProperty_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkRIBProperty_Type, PyvtkRIBProperty_Methods,
    "vtkRIBProperty",
    PyvtkRIBProperty_Doc(), &PyvtkRIBProperty_StaticNew);

  PyTypeObject *pytype = &PyvtkRIBProperty_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkProperty_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkRIBProperty_Doc()
{
  static const char *docstring[] = {
    "vtkRIBProperty - RIP Property\n\n",
    "Superclass: vtkProperty\n\n",
    "vtkRIBProperty is a subclass of vtkProperty that allows the user to\nspecify named shaders for use with RenderMan. Both surface and\ndisplacement shaders can be specified. Parameters for the shaders can\nbe declared and set.\n\n@sa\nvtkRIBExporter vtkRIBLight\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkRIBProperty(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkRIBProperty_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkRIBProperty", o) != 0)
  {
    Py_DECREF(o);
  }

}

