// python wrapper for vtkRenderStepsPass
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkRenderStepsPass.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkRenderStepsPass(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkRenderStepsPass_ClassNew(); }

#ifndef DECLARED_PyvtkRenderPass_ClassNew
extern "C" { PyObject *PyvtkRenderPass_ClassNew(); }
#define DECLARED_PyvtkRenderPass_ClassNew
#endif

static const char **PyvtkRenderStepsPass_Doc();


static PyObject *
PyvtkRenderStepsPass_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkRenderStepsPass::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkRenderStepsPass::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderStepsPass *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkRenderStepsPass::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkRenderStepsPass *tempr = vtkRenderStepsPass::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkRenderStepsPass::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_GetCameraPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCameraPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCameraPass *tempr = (ap.IsBound() ?
      op->GetCameraPass() :
      op->vtkRenderStepsPass::GetCameraPass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_SetCameraPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCameraPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  vtkCameraPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCameraPass"))
  {
    if (ap.IsBound())
    {
      op->SetCameraPass(temp0);
    }
    else
    {
      op->vtkRenderStepsPass::SetCameraPass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_GetLightsPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLightsPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderPass *tempr = (ap.IsBound() ?
      op->GetLightsPass() :
      op->vtkRenderStepsPass::GetLightsPass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_SetLightsPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLightsPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  vtkRenderPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderPass"))
  {
    if (ap.IsBound())
    {
      op->SetLightsPass(temp0);
    }
    else
    {
      op->vtkRenderStepsPass::SetLightsPass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_GetOpaquePass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOpaquePass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderPass *tempr = (ap.IsBound() ?
      op->GetOpaquePass() :
      op->vtkRenderStepsPass::GetOpaquePass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_SetOpaquePass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOpaquePass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  vtkRenderPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderPass"))
  {
    if (ap.IsBound())
    {
      op->SetOpaquePass(temp0);
    }
    else
    {
      op->vtkRenderStepsPass::SetOpaquePass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_GetTranslucentPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTranslucentPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderPass *tempr = (ap.IsBound() ?
      op->GetTranslucentPass() :
      op->vtkRenderStepsPass::GetTranslucentPass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_SetTranslucentPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTranslucentPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  vtkRenderPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderPass"))
  {
    if (ap.IsBound())
    {
      op->SetTranslucentPass(temp0);
    }
    else
    {
      op->vtkRenderStepsPass::SetTranslucentPass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_GetVolumetricPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVolumetricPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderPass *tempr = (ap.IsBound() ?
      op->GetVolumetricPass() :
      op->vtkRenderStepsPass::GetVolumetricPass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_SetVolumetricPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVolumetricPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  vtkRenderPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderPass"))
  {
    if (ap.IsBound())
    {
      op->SetVolumetricPass(temp0);
    }
    else
    {
      op->vtkRenderStepsPass::SetVolumetricPass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_GetOverlayPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOverlayPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderPass *tempr = (ap.IsBound() ?
      op->GetOverlayPass() :
      op->vtkRenderStepsPass::GetOverlayPass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_SetOverlayPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOverlayPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  vtkRenderPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderPass"))
  {
    if (ap.IsBound())
    {
      op->SetOverlayPass(temp0);
    }
    else
    {
      op->vtkRenderStepsPass::SetOverlayPass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_GetPostProcessPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPostProcessPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderPass *tempr = (ap.IsBound() ?
      op->GetPostProcessPass() :
      op->vtkRenderStepsPass::GetPostProcessPass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderStepsPass_SetPostProcessPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPostProcessPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderStepsPass *op = static_cast<vtkRenderStepsPass *>(vp);

  vtkRenderPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderPass"))
  {
    if (ap.IsBound())
    {
      op->SetPostProcessPass(temp0);
    }
    else
    {
      op->vtkRenderStepsPass::SetPostProcessPass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkRenderStepsPass_Methods[] = {
  {"GetClassName", PyvtkRenderStepsPass_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkRenderStepsPass_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkRenderStepsPass_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkRenderStepsPass\nC++: vtkRenderStepsPass *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkRenderStepsPass_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkRenderStepsPass\nC++: vtkRenderStepsPass *SafeDownCast(vtkObject* o)\n\n"},
  {"ReleaseGraphicsResources", PyvtkRenderStepsPass_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: virtual void ReleaseGraphicsResources(vtkWindow *w)\n\nRelease graphics resources and ask components to release their\nown resources.\n\\pre w_exists: w!=0\n"},
  {"GetCameraPass", PyvtkRenderStepsPass_GetCameraPass, METH_VARARGS,
   "V.GetCameraPass() -> vtkCameraPass\nC++: vtkCameraPass *GetCameraPass()\n\nGet the RenderPass used for the Camera Step\n"},
  {"SetCameraPass", PyvtkRenderStepsPass_SetCameraPass, METH_VARARGS,
   "V.SetCameraPass(vtkCameraPass)\nC++: void SetCameraPass(vtkCameraPass *)\n\nGet the RenderPass used for the Camera Step\n"},
  {"GetLightsPass", PyvtkRenderStepsPass_GetLightsPass, METH_VARARGS,
   "V.GetLightsPass() -> vtkRenderPass\nC++: vtkRenderPass *GetLightsPass()\n\nGet the RenderPass used for the Lights Step\n"},
  {"SetLightsPass", PyvtkRenderStepsPass_SetLightsPass, METH_VARARGS,
   "V.SetLightsPass(vtkRenderPass)\nC++: void SetLightsPass(vtkRenderPass *)\n\nGet the RenderPass used for the Lights Step\n"},
  {"GetOpaquePass", PyvtkRenderStepsPass_GetOpaquePass, METH_VARARGS,
   "V.GetOpaquePass() -> vtkRenderPass\nC++: vtkRenderPass *GetOpaquePass()\n\nGet the RenderPass used for the Opaque Step\n"},
  {"SetOpaquePass", PyvtkRenderStepsPass_SetOpaquePass, METH_VARARGS,
   "V.SetOpaquePass(vtkRenderPass)\nC++: void SetOpaquePass(vtkRenderPass *)\n\nGet the RenderPass used for the Opaque Step\n"},
  {"GetTranslucentPass", PyvtkRenderStepsPass_GetTranslucentPass, METH_VARARGS,
   "V.GetTranslucentPass() -> vtkRenderPass\nC++: vtkRenderPass *GetTranslucentPass()\n\nGet the RenderPass used for the translucent Step\n"},
  {"SetTranslucentPass", PyvtkRenderStepsPass_SetTranslucentPass, METH_VARARGS,
   "V.SetTranslucentPass(vtkRenderPass)\nC++: void SetTranslucentPass(vtkRenderPass *)\n\nGet the RenderPass used for the translucent Step\n"},
  {"GetVolumetricPass", PyvtkRenderStepsPass_GetVolumetricPass, METH_VARARGS,
   "V.GetVolumetricPass() -> vtkRenderPass\nC++: vtkRenderPass *GetVolumetricPass()\n\nGet the RenderPass used for the Volume Step\n"},
  {"SetVolumetricPass", PyvtkRenderStepsPass_SetVolumetricPass, METH_VARARGS,
   "V.SetVolumetricPass(vtkRenderPass)\nC++: void SetVolumetricPass(vtkRenderPass *)\n\nGet the RenderPass used for the Volume Step\n"},
  {"GetOverlayPass", PyvtkRenderStepsPass_GetOverlayPass, METH_VARARGS,
   "V.GetOverlayPass() -> vtkRenderPass\nC++: vtkRenderPass *GetOverlayPass()\n\nGet the RenderPass used for the Overlay Step\n"},
  {"SetOverlayPass", PyvtkRenderStepsPass_SetOverlayPass, METH_VARARGS,
   "V.SetOverlayPass(vtkRenderPass)\nC++: void SetOverlayPass(vtkRenderPass *)\n\nGet the RenderPass used for the Overlay Step\n"},
  {"GetPostProcessPass", PyvtkRenderStepsPass_GetPostProcessPass, METH_VARARGS,
   "V.GetPostProcessPass() -> vtkRenderPass\nC++: vtkRenderPass *GetPostProcessPass()\n\nGet the RenderPass used for the PostProcess Step\n"},
  {"SetPostProcessPass", PyvtkRenderStepsPass_SetPostProcessPass, METH_VARARGS,
   "V.SetPostProcessPass(vtkRenderPass)\nC++: void SetPostProcessPass(vtkRenderPass *)\n\nGet the RenderPass used for the PostProcess Step\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkRenderStepsPass_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkRenderStepsPass", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkRenderStepsPass_StaticNew()
{
  return vtkRenderStepsPass::New();
}

PyObject *PyvtkRenderStepsPass_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkRenderStepsPass_Type, PyvtkRenderStepsPass_Methods,
    "vtkRenderStepsPass",
    PyvtkRenderStepsPass_Doc(), &PyvtkRenderStepsPass_StaticNew);

  PyTypeObject *pytype = &PyvtkRenderStepsPass_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkRenderPass_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkRenderStepsPass_Doc()
{
  static const char *docstring[] = {
    "vtkRenderStepsPass - Execute render passes sequentially.\n\n",
    "Superclass: vtkRenderPass\n\n",
    "vtkRenderStepsPass executes a standard list of render passes\nsequentially. This class allows to define a sequence of render passes\nat run time. You can set a step to NULL in order to skip that step.\nLikewise you can replace any of the default steps with your own step.\nTypically in such a case you would get the current step, replace it\nwith your own and likely have your step call the current step a",
    "s a\ndelegate. For example to replace the translucent step with a\ndepthpeeling step you would get the current tranlucent step and set\nit as a delegate on the depthpeeling step. Then set this classes\ntranslparent step to the depthpeelnig step.\n\n@sa\nvtkRenderPass\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkRenderStepsPass(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkRenderStepsPass_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkRenderStepsPass", o) != 0)
  {
    Py_DECREF(o);
  }

}

