// python wrapper for vtkRenderedRepresentation
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkRenderedRepresentation.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkRenderedRepresentation(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkRenderedRepresentation_ClassNew(); }

#ifndef DECLARED_PyvtkDataRepresentation_ClassNew
extern "C" { PyObject *PyvtkDataRepresentation_ClassNew(); }
#define DECLARED_PyvtkDataRepresentation_ClassNew
#endif

static const char **PyvtkRenderedRepresentation_Doc();


static PyObject *
PyvtkRenderedRepresentation_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedRepresentation *op = static_cast<vtkRenderedRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkRenderedRepresentation::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderedRepresentation_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedRepresentation *op = static_cast<vtkRenderedRepresentation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkRenderedRepresentation::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderedRepresentation_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedRepresentation *op = static_cast<vtkRenderedRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderedRepresentation *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkRenderedRepresentation::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkRenderedRepresentation_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkRenderedRepresentation *tempr = vtkRenderedRepresentation::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRenderedRepresentation_SetLabelRenderMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabelRenderMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedRepresentation *op = static_cast<vtkRenderedRepresentation *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLabelRenderMode(temp0);
    }
    else
    {
      op->vtkRenderedRepresentation::SetLabelRenderMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRenderedRepresentation_GetLabelRenderMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLabelRenderMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRenderedRepresentation *op = static_cast<vtkRenderedRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLabelRenderMode() :
      op->vtkRenderedRepresentation::GetLabelRenderMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkRenderedRepresentation_Methods[] = {
  {"GetClassName", PyvtkRenderedRepresentation_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkRenderedRepresentation_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkRenderedRepresentation_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkRenderedRepresentation\nC++: vtkRenderedRepresentation *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkRenderedRepresentation_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkRenderedRepresentation\nC++: vtkRenderedRepresentation *SafeDownCast(vtkObject* o)\n\n"},
  {"SetLabelRenderMode", PyvtkRenderedRepresentation_SetLabelRenderMode, METH_VARARGS,
   "V.SetLabelRenderMode(int)\nC++: void SetLabelRenderMode(int a)\n\nSet the label render mode. vtkRenderView::QT - Use Qt-based\nlabeler with fitted labeling and unicode support. Requires\nVTK_USE_QT to be on. vtkRenderView::FREETYPE - Use standard\nfreetype text rendering.\n"},
  {"GetLabelRenderMode", PyvtkRenderedRepresentation_GetLabelRenderMode, METH_VARARGS,
   "V.GetLabelRenderMode() -> int\nC++: int GetLabelRenderMode()\n\nSet the label render mode. vtkRenderView::QT - Use Qt-based\nlabeler with fitted labeling and unicode support. Requires\nVTK_USE_QT to be on. vtkRenderView::FREETYPE - Use standard\nfreetype text rendering.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkRenderedRepresentation_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkRenderedRepresentation", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkRenderedRepresentation_StaticNew()
{
  return vtkRenderedRepresentation::New();
}

PyObject *PyvtkRenderedRepresentation_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkRenderedRepresentation_Type, PyvtkRenderedRepresentation_Methods,
    "vtkRenderedRepresentation",
    PyvtkRenderedRepresentation_Doc(), &PyvtkRenderedRepresentation_StaticNew);

  PyTypeObject *pytype = &PyvtkRenderedRepresentation_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataRepresentation_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkRenderedRepresentation_Doc()
{
  static const char *docstring[] = {
    "vtkRenderedRepresentation - \n\n",
    "Superclass: vtkDataRepresentation\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkRenderedRepresentation(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkRenderedRepresentation_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkRenderedRepresentation", o) != 0)
  {
    Py_DECREF(o);
  }

}

