// python wrapper for vtkReverseSense
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkReverseSense.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkReverseSense(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkReverseSense_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkReverseSense_Doc();


static PyObject *
PyvtkReverseSense_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkReverseSense::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkReverseSense::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkReverseSense *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkReverseSense::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkReverseSense *tempr = vtkReverseSense::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_SetReverseCells(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReverseCells");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetReverseCells(temp0);
    }
    else
    {
      op->vtkReverseSense::SetReverseCells(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_GetReverseCells(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReverseCells");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetReverseCells() :
      op->vtkReverseSense::GetReverseCells());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_ReverseCellsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReverseCellsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReverseCellsOn();
    }
    else
    {
      op->vtkReverseSense::ReverseCellsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_ReverseCellsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReverseCellsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReverseCellsOff();
    }
    else
    {
      op->vtkReverseSense::ReverseCellsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_SetReverseNormals(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReverseNormals");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetReverseNormals(temp0);
    }
    else
    {
      op->vtkReverseSense::SetReverseNormals(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_GetReverseNormals(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReverseNormals");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetReverseNormals() :
      op->vtkReverseSense::GetReverseNormals());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_ReverseNormalsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReverseNormalsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReverseNormalsOn();
    }
    else
    {
      op->vtkReverseSense::ReverseNormalsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkReverseSense_ReverseNormalsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReverseNormalsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReverseSense *op = static_cast<vtkReverseSense *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReverseNormalsOff();
    }
    else
    {
      op->vtkReverseSense::ReverseNormalsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkReverseSense_Methods[] = {
  {"GetClassName", PyvtkReverseSense_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkReverseSense_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkReverseSense_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkReverseSense\nC++: vtkReverseSense *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkReverseSense_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkReverseSense\nC++: vtkReverseSense *SafeDownCast(vtkObject* o)\n\n"},
  {"SetReverseCells", PyvtkReverseSense_SetReverseCells, METH_VARARGS,
   "V.SetReverseCells(int)\nC++: void SetReverseCells(int a)\n\nFlag controls whether to reverse cell ordering.\n"},
  {"GetReverseCells", PyvtkReverseSense_GetReverseCells, METH_VARARGS,
   "V.GetReverseCells() -> int\nC++: int GetReverseCells()\n\nFlag controls whether to reverse cell ordering.\n"},
  {"ReverseCellsOn", PyvtkReverseSense_ReverseCellsOn, METH_VARARGS,
   "V.ReverseCellsOn()\nC++: void ReverseCellsOn()\n\nFlag controls whether to reverse cell ordering.\n"},
  {"ReverseCellsOff", PyvtkReverseSense_ReverseCellsOff, METH_VARARGS,
   "V.ReverseCellsOff()\nC++: void ReverseCellsOff()\n\nFlag controls whether to reverse cell ordering.\n"},
  {"SetReverseNormals", PyvtkReverseSense_SetReverseNormals, METH_VARARGS,
   "V.SetReverseNormals(int)\nC++: void SetReverseNormals(int a)\n\nFlag controls whether to reverse normal orientation.\n"},
  {"GetReverseNormals", PyvtkReverseSense_GetReverseNormals, METH_VARARGS,
   "V.GetReverseNormals() -> int\nC++: int GetReverseNormals()\n\nFlag controls whether to reverse normal orientation.\n"},
  {"ReverseNormalsOn", PyvtkReverseSense_ReverseNormalsOn, METH_VARARGS,
   "V.ReverseNormalsOn()\nC++: void ReverseNormalsOn()\n\nFlag controls whether to reverse normal orientation.\n"},
  {"ReverseNormalsOff", PyvtkReverseSense_ReverseNormalsOff, METH_VARARGS,
   "V.ReverseNormalsOff()\nC++: void ReverseNormalsOff()\n\nFlag controls whether to reverse normal orientation.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkReverseSense_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersCorePython.vtkReverseSense", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkReverseSense_StaticNew()
{
  return vtkReverseSense::New();
}

PyObject *PyvtkReverseSense_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkReverseSense_Type, PyvtkReverseSense_Methods,
    "vtkReverseSense",
    PyvtkReverseSense_Doc(), &PyvtkReverseSense_StaticNew);

  PyTypeObject *pytype = &PyvtkReverseSense_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkReverseSense_Doc()
{
  static const char *docstring[] = {
    "vtkReverseSense - reverse the ordering of polygonal cells and/or\nvertex normals\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkReverseSense is a filter that reverses the order of polygonal\ncells and/or reverses the direction of point and cell normals. Two\nflags are used to control these operations. Cell reversal means\nreversing the order of indices in the cell connectivity list. Normal\nreversal means multiplying the normal vector by -1 (both point and\ncell normals, if present).\n\n@warning\nNormals can be operated on only",
    " if they are present in the data.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkReverseSense(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkReverseSense_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkReverseSense", o) != 0)
  {
    Py_DECREF(o);
  }

}

