// python wrapper for vtkSCurveSpline
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSCurveSpline.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSCurveSpline(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSCurveSpline_ClassNew(); }

#ifndef DECLARED_PyvtkSpline_ClassNew
extern "C" { PyObject *PyvtkSpline_ClassNew(); }
#define DECLARED_PyvtkSpline_ClassNew
#endif

static const char **PyvtkSCurveSpline_Doc();


static PyObject *
PyvtkSCurveSpline_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSCurveSpline *op = static_cast<vtkSCurveSpline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSCurveSpline::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSCurveSpline_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSCurveSpline *op = static_cast<vtkSCurveSpline *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSCurveSpline::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSCurveSpline_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSCurveSpline *op = static_cast<vtkSCurveSpline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSCurveSpline *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSCurveSpline::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSCurveSpline_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkSCurveSpline *tempr = vtkSCurveSpline::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSCurveSpline_Compute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Compute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSCurveSpline *op = static_cast<vtkSCurveSpline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Compute();
    }
    else
    {
      op->vtkSCurveSpline::Compute();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSCurveSpline_Evaluate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Evaluate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSCurveSpline *op = static_cast<vtkSCurveSpline *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double tempr = (ap.IsBound() ?
      op->Evaluate(temp0) :
      op->vtkSCurveSpline::Evaluate(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSCurveSpline_DeepCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeepCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSCurveSpline *op = static_cast<vtkSCurveSpline *>(vp);

  vtkSpline *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSpline"))
  {
    if (ap.IsBound())
    {
      op->DeepCopy(temp0);
    }
    else
    {
      op->vtkSCurveSpline::DeepCopy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSCurveSpline_SetNodeWeight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNodeWeight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSCurveSpline *op = static_cast<vtkSCurveSpline *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNodeWeight(temp0);
    }
    else
    {
      op->vtkSCurveSpline::SetNodeWeight(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSCurveSpline_GetNodeWeight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNodeWeight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSCurveSpline *op = static_cast<vtkSCurveSpline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetNodeWeight() :
      op->vtkSCurveSpline::GetNodeWeight());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSCurveSpline_Methods[] = {
  {"GetClassName", PyvtkSCurveSpline_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSCurveSpline_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSCurveSpline_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSCurveSpline\nC++: vtkSCurveSpline *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSCurveSpline_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSCurveSpline\nC++: vtkSCurveSpline *SafeDownCast(vtkObject* o)\n\n"},
  {"Compute", PyvtkSCurveSpline_Compute, METH_VARARGS,
   "V.Compute()\nC++: void Compute()\n\nCompute SCurve Splines for each dependent variable\n"},
  {"Evaluate", PyvtkSCurveSpline_Evaluate, METH_VARARGS,
   "V.Evaluate(float) -> float\nC++: virtual double Evaluate(double t)\n\nEvaluate a 1D SCurve spline.\n"},
  {"DeepCopy", PyvtkSCurveSpline_DeepCopy, METH_VARARGS,
   "V.DeepCopy(vtkSpline)\nC++: virtual void DeepCopy(vtkSpline *s)\n\nDeep copy of SCurve spline data.\n"},
  {"SetNodeWeight", PyvtkSCurveSpline_SetNodeWeight, METH_VARARGS,
   "V.SetNodeWeight(float)\nC++: void SetNodeWeight(double a)\n\n"},
  {"GetNodeWeight", PyvtkSCurveSpline_GetNodeWeight, METH_VARARGS,
   "V.GetNodeWeight() -> float\nC++: double GetNodeWeight()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSCurveSpline_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkSCurveSpline", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSCurveSpline_StaticNew()
{
  return vtkSCurveSpline::New();
}

PyObject *PyvtkSCurveSpline_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSCurveSpline_Type, PyvtkSCurveSpline_Methods,
    "vtkSCurveSpline",
    PyvtkSCurveSpline_Doc(), &PyvtkSCurveSpline_StaticNew);

  PyTypeObject *pytype = &PyvtkSCurveSpline_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSpline_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSCurveSpline_Doc()
{
  static const char *docstring[] = {
    "vtkSCurveSpline - computes an interpolating spline using a a SCurve\nbasis.\n\n",
    "Superclass: vtkSpline\n\n",
    "vtkSCurveSpline is a concrete implementation of vtkSpline using a\nSCurve basis.\n\n@sa\nvtkSpline vtkKochanekSpline\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSCurveSpline(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSCurveSpline_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSCurveSpline", o) != 0)
  {
    Py_DECREF(o);
  }

}

