// python wrapper for vtkSMPContourGrid
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkInformationVector.h"
#include "vtkSMPContourGrid.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMPContourGrid(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMPContourGrid_ClassNew(); }

#ifndef DECLARED_PyvtkContourGrid_ClassNew
extern "C" { PyObject *PyvtkContourGrid_ClassNew(); }
#define DECLARED_PyvtkContourGrid_ClassNew
#endif

static const char **PyvtkSMPContourGrid_Doc();


static PyObject *
PyvtkSMPContourGrid_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPContourGrid *op = static_cast<vtkSMPContourGrid *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSMPContourGrid::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPContourGrid_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPContourGrid *op = static_cast<vtkSMPContourGrid *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMPContourGrid::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPContourGrid_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPContourGrid *op = static_cast<vtkSMPContourGrid *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMPContourGrid *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMPContourGrid::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMPContourGrid_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkSMPContourGrid *tempr = vtkSMPContourGrid::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPContourGrid_SetMergePieces(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMergePieces");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPContourGrid *op = static_cast<vtkSMPContourGrid *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMergePieces(temp0);
    }
    else
    {
      op->vtkSMPContourGrid::SetMergePieces(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMPContourGrid_GetMergePieces(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMergePieces");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPContourGrid *op = static_cast<vtkSMPContourGrid *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetMergePieces() :
      op->vtkSMPContourGrid::GetMergePieces());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPContourGrid_MergePiecesOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MergePiecesOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPContourGrid *op = static_cast<vtkSMPContourGrid *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MergePiecesOn();
    }
    else
    {
      op->vtkSMPContourGrid::MergePiecesOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMPContourGrid_MergePiecesOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MergePiecesOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPContourGrid *op = static_cast<vtkSMPContourGrid *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MergePiecesOff();
    }
    else
    {
      op->vtkSMPContourGrid::MergePiecesOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSMPContourGrid_Methods[] = {
  {"GetClassName", PyvtkSMPContourGrid_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSMPContourGrid_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSMPContourGrid_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMPContourGrid\nC++: vtkSMPContourGrid *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSMPContourGrid_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSMPContourGrid\nC++: vtkSMPContourGrid *SafeDownCast(vtkObject* o)\n\n"},
  {"SetMergePieces", PyvtkSMPContourGrid_SetMergePieces, METH_VARARGS,
   "V.SetMergePieces(bool)\nC++: void SetMergePieces(bool a)\n\nIf MergePieces is true (default), this filter will merge all\npieces generated by processing the input with multiple threads.\nThe output will be a vtkPolyData. Note that this has a slight\noverhead which becomes more significant as the number of threads\nused grows. If MergePieces is false, this filter will generate a\nvtkMultiBlock of vtkPolyData where the number of pieces will be\nequal to the number of threads used.\n"},
  {"GetMergePieces", PyvtkSMPContourGrid_GetMergePieces, METH_VARARGS,
   "V.GetMergePieces() -> bool\nC++: bool GetMergePieces()\n\nIf MergePieces is true (default), this filter will merge all\npieces generated by processing the input with multiple threads.\nThe output will be a vtkPolyData. Note that this has a slight\noverhead which becomes more significant as the number of threads\nused grows. If MergePieces is false, this filter will generate a\nvtkMultiBlock of vtkPolyData where the number of pieces will be\nequal to the number of threads used.\n"},
  {"MergePiecesOn", PyvtkSMPContourGrid_MergePiecesOn, METH_VARARGS,
   "V.MergePiecesOn()\nC++: void MergePiecesOn()\n\nIf MergePieces is true (default), this filter will merge all\npieces generated by processing the input with multiple threads.\nThe output will be a vtkPolyData. Note that this has a slight\noverhead which becomes more significant as the number of threads\nused grows. If MergePieces is false, this filter will generate a\nvtkMultiBlock of vtkPolyData where the number of pieces will be\nequal to the number of threads used.\n"},
  {"MergePiecesOff", PyvtkSMPContourGrid_MergePiecesOff, METH_VARARGS,
   "V.MergePiecesOff()\nC++: void MergePiecesOff()\n\nIf MergePieces is true (default), this filter will merge all\npieces generated by processing the input with multiple threads.\nThe output will be a vtkPolyData. Note that this has a slight\noverhead which becomes more significant as the number of threads\nused grows. If MergePieces is false, this filter will generate a\nvtkMultiBlock of vtkPolyData where the number of pieces will be\nequal to the number of threads used.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMPContourGrid_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersSMPPython.vtkSMPContourGrid", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMPContourGrid_StaticNew()
{
  return vtkSMPContourGrid::New();
}

PyObject *PyvtkSMPContourGrid_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMPContourGrid_Type, PyvtkSMPContourGrid_Methods,
    "vtkSMPContourGrid",
    PyvtkSMPContourGrid_Doc(), &PyvtkSMPContourGrid_StaticNew);

  PyTypeObject *pytype = &PyvtkSMPContourGrid_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkContourGrid_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMPContourGrid_Doc()
{
  static const char *docstring[] = {
    "vtkSMPContourGrid - a subclass of vtkContourGrid that works in\nparallel vtkSMPContourGrid performs the same functionaliy as\nvtkContourGrid but does it using multiple threads.\n\n",
    "Superclass: vtkContourGrid\n\n",
    "This will probably be merged with vtkContourGrid in the future.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMPContourGrid(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMPContourGrid_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMPContourGrid", o) != 0)
  {
    Py_DECREF(o);
  }

}

