// python wrapper for vtkSMPMergePoints
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMPMergePoints.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMPMergePoints(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMPMergePoints_ClassNew(); }

#ifndef DECLARED_PyvtkMergePoints_ClassNew
extern "C" { PyObject *PyvtkMergePoints_ClassNew(); }
#define DECLARED_PyvtkMergePoints_ClassNew
#endif

static const char **PyvtkSMPMergePoints_Doc();


static PyObject *
PyvtkSMPMergePoints_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPMergePoints *op = static_cast<vtkSMPMergePoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSMPMergePoints::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPMergePoints_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPMergePoints *op = static_cast<vtkSMPMergePoints *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMPMergePoints::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPMergePoints_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPMergePoints *op = static_cast<vtkSMPMergePoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMPMergePoints *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMPMergePoints::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMPMergePoints_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkSMPMergePoints *tempr = vtkSMPMergePoints::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPMergePoints_InitializeMerge(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InitializeMerge");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPMergePoints *op = static_cast<vtkSMPMergePoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->InitializeMerge();
    }
    else
    {
      op->vtkSMPMergePoints::InitializeMerge();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMPMergePoints_Merge(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Merge");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPMergePoints *op = static_cast<vtkSMPMergePoints *>(vp);

  vtkSMPMergePoints *temp0 = NULL;
  vtkIdType temp1;
  vtkPointData *temp2 = NULL;
  vtkPointData *temp3 = NULL;
  vtkIdList *temp4 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(5) &&
      ap.GetVTKObject(temp0, "vtkSMPMergePoints") &&
      ap.GetValue(temp1) &&
      ap.GetVTKObject(temp2, "vtkPointData") &&
      ap.GetVTKObject(temp3, "vtkPointData") &&
      ap.GetVTKObject(temp4, "vtkIdList"))
  {
    if (ap.IsBound())
    {
      op->Merge(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkSMPMergePoints::Merge(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMPMergePoints_FixSizeOfPointArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FixSizeOfPointArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPMergePoints *op = static_cast<vtkSMPMergePoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->FixSizeOfPointArray();
    }
    else
    {
      op->vtkSMPMergePoints::FixSizeOfPointArray();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMPMergePoints_GetMaxId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaxId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPMergePoints *op = static_cast<vtkSMPMergePoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetMaxId() :
      op->vtkSMPMergePoints::GetMaxId());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPMergePoints_GetNumberOfIdsInBucket(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfIdsInBucket");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPMergePoints *op = static_cast<vtkSMPMergePoints *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetNumberOfIdsInBucket(temp0) :
      op->vtkSMPMergePoints::GetNumberOfIdsInBucket(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPMergePoints_GetNumberOfBuckets(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfBuckets");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPMergePoints *op = static_cast<vtkSMPMergePoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetNumberOfBuckets() :
      op->vtkSMPMergePoints::GetNumberOfBuckets());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMPMergePoints_Methods[] = {
  {"GetClassName", PyvtkSMPMergePoints_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSMPMergePoints_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSMPMergePoints_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMPMergePoints\nC++: vtkSMPMergePoints *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSMPMergePoints_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSMPMergePoints\nC++: vtkSMPMergePoints *SafeDownCast(vtkObject* o)\n\n"},
  {"InitializeMerge", PyvtkSMPMergePoints_InitializeMerge, METH_VARARGS,
   "V.InitializeMerge()\nC++: void InitializeMerge()\n\nThis should be called from 1 thread before any call to Merge.\n"},
  {"Merge", PyvtkSMPMergePoints_Merge, METH_VARARGS,
   "V.Merge(vtkSMPMergePoints, int, vtkPointData, vtkPointData,\n    vtkIdList)\nC++: void Merge(vtkSMPMergePoints *locator, vtkIdType idx,\n    vtkPointData *outPd, vtkPointData *inPd, vtkIdList *idList)\n\nMerge the points of one of the bins from the given locator to the\nsame bin of the current locator. Note that this requires that the\ntwo locators have identical binning structures. This also merges\npoint data given in the inPD argument to the outPd. Furthermore,\nit generates a map of the old ids of the input locator to the new\nids. This is stored in the idList argument. The map is\nidList[oldId] = newId.\n"},
  {"FixSizeOfPointArray", PyvtkSMPMergePoints_FixSizeOfPointArray, METH_VARARGS,
   "V.FixSizeOfPointArray()\nC++: void FixSizeOfPointArray()\n\nAt the of the merge, this can be called to set the MaxId of the\npoints array to the maximum id in the locator. The current design\nusage is as follows:\n- Allocate points with points->Resize(numPts). NumPts should be\n  >= total number of points\n- Do bunch of merging with outLocator->Merge(inLocator[i], ...)\n- Fix the size of points with outLocator->FixSizeOfPointArray()\n"},
  {"GetMaxId", PyvtkSMPMergePoints_GetMaxId, METH_VARARGS,
   "V.GetMaxId() -> int\nC++: vtkIdType GetMaxId()\n\nReturns the biggest id in the locator.\n"},
  {"GetNumberOfIdsInBucket", PyvtkSMPMergePoints_GetNumberOfIdsInBucket, METH_VARARGS,
   "V.GetNumberOfIdsInBucket(int) -> int\nC++: vtkIdType GetNumberOfIdsInBucket(vtkIdType idx)\n\nRetuns the number of points in a bin.\n"},
  {"GetNumberOfBuckets", PyvtkSMPMergePoints_GetNumberOfBuckets, METH_VARARGS,
   "V.GetNumberOfBuckets() -> int\nC++: vtkIdType GetNumberOfBuckets()\n\nRetuns the number of bins.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMPMergePoints_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersSMPPython.vtkSMPMergePoints", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMPMergePoints_StaticNew()
{
  return vtkSMPMergePoints::New();
}

PyObject *PyvtkSMPMergePoints_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMPMergePoints_Type, PyvtkSMPMergePoints_Methods,
    "vtkSMPMergePoints",
    PyvtkSMPMergePoints_Doc(), &PyvtkSMPMergePoints_StaticNew);

  PyTypeObject *pytype = &PyvtkSMPMergePoints_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMergePoints_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMPMergePoints_Doc()
{
  static const char *docstring[] = {
    "vtkSMPMergePoints - Class designed to help with merging of points in\nparallel\n\n",
    "Superclass: vtkMergePoints\n\n",
    "vtkSMPMergePoints is a subclass of vtkMergePoints designed to help\nwith merging of points generated by using multiple locators in\nparallel. Its main functionality is provided by the Merge function.\nIt also has a few additional convenience functions. Merge is thread\nsafe as long as no two threads are merging the same bin. The common\nway of using vtkSMPMergePoints is:\n- Initialize with outLocator->I",
    "nitializeMerge()\n- Allocate points with outLocator->GetPoints()->Resize(numPts)\n  (numPts should be >= total number of points)\n- Do bunch of merging with outLocator->Merge(inLocator[i], ...) (this\ncan be done in parallel as long as no two bins are done at the same\n  time)\n- Fix the size of points with outLocator->FixSizeOfPointArray()\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMPMergePoints(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMPMergePoints_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMPMergePoints", o) != 0)
  {
    Py_DECREF(o);
  }

}

