// python wrapper for vtkSQLDatabaseTableSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkSQLDatabaseTableSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSQLDatabaseTableSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSQLDatabaseTableSource_ClassNew(); }

#ifndef DECLARED_PyvtkTableAlgorithm_ClassNew
extern "C" { PyObject *PyvtkTableAlgorithm_ClassNew(); }
#define DECLARED_PyvtkTableAlgorithm_ClassNew
#endif

static const char **PyvtkSQLDatabaseTableSource_Doc();


static PyObject *
PyvtkSQLDatabaseTableSource_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSQLDatabaseTableSource::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSQLDatabaseTableSource::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSQLDatabaseTableSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSQLDatabaseTableSource::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkSQLDatabaseTableSource *tempr = vtkSQLDatabaseTableSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_GetURL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetURL");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetURL() :
      op->vtkSQLDatabaseTableSource::GetURL());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_SetURL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetURL");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  vtkStdString temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetURL(temp0);
    }
    else
    {
      op->vtkSQLDatabaseTableSource::SetURL(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_SetPassword(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPassword");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  vtkStdString temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPassword(temp0);
    }
    else
    {
      op->vtkSQLDatabaseTableSource::SetPassword(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_GetQuery(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQuery");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetQuery() :
      op->vtkSQLDatabaseTableSource::GetQuery());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_SetQuery(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQuery");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  vtkStdString temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetQuery(temp0);
    }
    else
    {
      op->vtkSQLDatabaseTableSource::SetQuery(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_SetPedigreeIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPedigreeIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPedigreeIdArrayName(temp0);
    }
    else
    {
      op->vtkSQLDatabaseTableSource::SetPedigreeIdArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_GetPedigreeIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPedigreeIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetPedigreeIdArrayName() :
      op->vtkSQLDatabaseTableSource::GetPedigreeIdArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_SetGeneratePedigreeIds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGeneratePedigreeIds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGeneratePedigreeIds(temp0);
    }
    else
    {
      op->vtkSQLDatabaseTableSource::SetGeneratePedigreeIds(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_GetGeneratePedigreeIds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGeneratePedigreeIds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetGeneratePedigreeIds() :
      op->vtkSQLDatabaseTableSource::GetGeneratePedigreeIds());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_GeneratePedigreeIdsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GeneratePedigreeIdsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->GeneratePedigreeIdsOn();
    }
    else
    {
      op->vtkSQLDatabaseTableSource::GeneratePedigreeIdsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseTableSource_GeneratePedigreeIdsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GeneratePedigreeIdsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseTableSource *op = static_cast<vtkSQLDatabaseTableSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->GeneratePedigreeIdsOff();
    }
    else
    {
      op->vtkSQLDatabaseTableSource::GeneratePedigreeIdsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSQLDatabaseTableSource_Methods[] = {
  {"GetClassName", PyvtkSQLDatabaseTableSource_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSQLDatabaseTableSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSQLDatabaseTableSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSQLDatabaseTableSource\nC++: vtkSQLDatabaseTableSource *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSQLDatabaseTableSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSQLDatabaseTableSource\nC++: vtkSQLDatabaseTableSource *SafeDownCast(vtkObject* o)\n\n"},
  {"GetURL", PyvtkSQLDatabaseTableSource_GetURL, METH_VARARGS,
   "V.GetURL() -> string\nC++: vtkStdString GetURL()\n\n"},
  {"SetURL", PyvtkSQLDatabaseTableSource_SetURL, METH_VARARGS,
   "V.SetURL(string)\nC++: void SetURL(const vtkStdString &url)\n\n"},
  {"SetPassword", PyvtkSQLDatabaseTableSource_SetPassword, METH_VARARGS,
   "V.SetPassword(string)\nC++: void SetPassword(const vtkStdString &password)\n\n"},
  {"GetQuery", PyvtkSQLDatabaseTableSource_GetQuery, METH_VARARGS,
   "V.GetQuery() -> string\nC++: vtkStdString GetQuery()\n\n"},
  {"SetQuery", PyvtkSQLDatabaseTableSource_SetQuery, METH_VARARGS,
   "V.SetQuery(string)\nC++: void SetQuery(const vtkStdString &query)\n\n"},
  {"SetPedigreeIdArrayName", PyvtkSQLDatabaseTableSource_SetPedigreeIdArrayName, METH_VARARGS,
   "V.SetPedigreeIdArrayName(string)\nC++: void SetPedigreeIdArrayName(char *)\n\nThe name of the array for generating or assigning pedigree ids\n(default \"id\").\n"},
  {"GetPedigreeIdArrayName", PyvtkSQLDatabaseTableSource_GetPedigreeIdArrayName, METH_VARARGS,
   "V.GetPedigreeIdArrayName() -> string\nC++: char *GetPedigreeIdArrayName()\n\nThe name of the array for generating or assigning pedigree ids\n(default \"id\").\n"},
  {"SetGeneratePedigreeIds", PyvtkSQLDatabaseTableSource_SetGeneratePedigreeIds, METH_VARARGS,
   "V.SetGeneratePedigreeIds(bool)\nC++: void SetGeneratePedigreeIds(bool a)\n\nIf on (default), generates pedigree ids automatically. If off,\nassign one of the arrays to be the pedigree id.\n"},
  {"GetGeneratePedigreeIds", PyvtkSQLDatabaseTableSource_GetGeneratePedigreeIds, METH_VARARGS,
   "V.GetGeneratePedigreeIds() -> bool\nC++: bool GetGeneratePedigreeIds()\n\nIf on (default), generates pedigree ids automatically. If off,\nassign one of the arrays to be the pedigree id.\n"},
  {"GeneratePedigreeIdsOn", PyvtkSQLDatabaseTableSource_GeneratePedigreeIdsOn, METH_VARARGS,
   "V.GeneratePedigreeIdsOn()\nC++: void GeneratePedigreeIdsOn()\n\nIf on (default), generates pedigree ids automatically. If off,\nassign one of the arrays to be the pedigree id.\n"},
  {"GeneratePedigreeIdsOff", PyvtkSQLDatabaseTableSource_GeneratePedigreeIdsOff, METH_VARARGS,
   "V.GeneratePedigreeIdsOff()\nC++: void GeneratePedigreeIdsOff()\n\nIf on (default), generates pedigree ids automatically. If off,\nassign one of the arrays to be the pedigree id.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSQLDatabaseTableSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOSQLPython.vtkSQLDatabaseTableSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSQLDatabaseTableSource_StaticNew()
{
  return vtkSQLDatabaseTableSource::New();
}

PyObject *PyvtkSQLDatabaseTableSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSQLDatabaseTableSource_Type, PyvtkSQLDatabaseTableSource_Methods,
    "vtkSQLDatabaseTableSource",
    PyvtkSQLDatabaseTableSource_Doc(), &PyvtkSQLDatabaseTableSource_StaticNew);

  PyTypeObject *pytype = &PyvtkSQLDatabaseTableSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTableAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSQLDatabaseTableSource_Doc()
{
  static const char *docstring[] = {
    "vtkSQLDatabaseTableSource - Generates a vtkTable based on an SQL\nquery.\n\n",
    "Superclass: vtkTableAlgorithm\n\n",
    "This class combines vtkSQLDatabase, vtkSQLQuery, and vtkQueryToTable\nto provide a convenience class for generating tables from databases.\nAlso this class can be easily wrapped and used within ParaView /\nOverView.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSQLDatabaseTableSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSQLDatabaseTableSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSQLDatabaseTableSource", o) != 0)
  {
    Py_DECREF(o);
  }

}

