// python wrapper for vtkSliceCubes
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSliceCubes.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSliceCubes(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSliceCubes_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkSliceCubes_Doc();


static PyObject *
PyvtkSliceCubes_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSliceCubes::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSliceCubes::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSliceCubes *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSliceCubes::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkSliceCubes *tempr = vtkSliceCubes::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_Write(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Write");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Write();
    }
    else
    {
      op->vtkSliceCubes::Write();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Update();
    }
    else
    {
      op->vtkSliceCubes::Update();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_SetReader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetReader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  vtkVolumeReader *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkVolumeReader"))
  {
    if (ap.IsBound())
    {
      op->SetReader(temp0);
    }
    else
    {
      op->vtkSliceCubes::SetReader(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_GetReader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetReader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVolumeReader *tempr = (ap.IsBound() ?
      op->GetReader() :
      op->vtkSliceCubes::GetReader());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkSliceCubes::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkSliceCubes::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_SetValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetValue(temp0);
    }
    else
    {
      op->vtkSliceCubes::SetValue(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_GetValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetValue() :
      op->vtkSliceCubes::GetValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_SetLimitsFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLimitsFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLimitsFileName(temp0);
    }
    else
    {
      op->vtkSliceCubes::SetLimitsFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSliceCubes_GetLimitsFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLimitsFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceCubes *op = static_cast<vtkSliceCubes *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetLimitsFileName() :
      op->vtkSliceCubes::GetLimitsFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSliceCubes_Methods[] = {
  {"GetClassName", PyvtkSliceCubes_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSliceCubes_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSliceCubes_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSliceCubes\nC++: vtkSliceCubes *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSliceCubes_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSliceCubes\nC++: vtkSliceCubes *SafeDownCast(vtkObject* o)\n\n"},
  {"Write", PyvtkSliceCubes_Write, METH_VARARGS,
   "V.Write()\nC++: void Write()\n\n"},
  {"Update", PyvtkSliceCubes_Update, METH_VARARGS,
   "V.Update()\nC++: void Update()\n\n"},
  {"SetReader", PyvtkSliceCubes_SetReader, METH_VARARGS,
   "V.SetReader(vtkVolumeReader)\nC++: virtual void SetReader(vtkVolumeReader *)\n\nSet/get object to read slices.\n"},
  {"GetReader", PyvtkSliceCubes_GetReader, METH_VARARGS,
   "V.GetReader() -> vtkVolumeReader\nC++: vtkVolumeReader *GetReader()\n\nSet/get object to read slices.\n"},
  {"SetFileName", PyvtkSliceCubes_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(char *)\n\nSpecify file name of marching cubes output file.\n"},
  {"GetFileName", PyvtkSliceCubes_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: char *GetFileName()\n\nSpecify file name of marching cubes output file.\n"},
  {"SetValue", PyvtkSliceCubes_SetValue, METH_VARARGS,
   "V.SetValue(float)\nC++: void SetValue(double a)\n\nSet/get isosurface contour value.\n"},
  {"GetValue", PyvtkSliceCubes_GetValue, METH_VARARGS,
   "V.GetValue() -> float\nC++: double GetValue()\n\nSet/get isosurface contour value.\n"},
  {"SetLimitsFileName", PyvtkSliceCubes_SetLimitsFileName, METH_VARARGS,
   "V.SetLimitsFileName(string)\nC++: void SetLimitsFileName(char *)\n\nSpecify file name of marching cubes limits file. The limits file\nspeeds up subsequent reading of output triangle file.\n"},
  {"GetLimitsFileName", PyvtkSliceCubes_GetLimitsFileName, METH_VARARGS,
   "V.GetLimitsFileName() -> string\nC++: char *GetLimitsFileName()\n\nSpecify file name of marching cubes limits file. The limits file\nspeeds up subsequent reading of output triangle file.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSliceCubes_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingHybridPython.vtkSliceCubes", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSliceCubes_StaticNew()
{
  return vtkSliceCubes::New();
}

PyObject *PyvtkSliceCubes_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSliceCubes_Type, PyvtkSliceCubes_Methods,
    "vtkSliceCubes",
    PyvtkSliceCubes_Doc(), &PyvtkSliceCubes_StaticNew);

  PyTypeObject *pytype = &PyvtkSliceCubes_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSliceCubes_Doc()
{
  static const char *docstring[] = {
    "vtkSliceCubes - generate isosurface(s) from volume four slices at a\ntime\n\n",
    "Superclass: vtkObject\n\n",
    "vtkSliceCubes is a special version of the marching cubes filter.\nInstead of ingesting an entire volume at once it processes only four\nslices at a time. This way, it can generate isosurfaces from huge\nvolumes. Also, the output of this object is written to a marching\ncubes triangle file. That way, output triangles do not need to be\nheld in memory.\n\nTo use vtkSliceCubes you must specify an instance o",
    "f vtkVolumeReader\nto read the data. Set this object up with the proper file prefix,\nimage range, data origin, data dimensions, header size, data mask,\nand swap bytes flag. The vtkSliceCubes object will then take over and\nread slices as necessary. You also will need to specify the name of\nan output marching cubes triangle file.\n\n@warning\nThis process object is both a source and mapper (i.e., it rea",
    "ds and\nwrites data to a file). This is different than the other marching\ncubes objects (and most process objects in the system). It's\nspecialized to handle very large data.\n\n@warning\nThis object only extracts a single isosurface. This compares with the\nother contouring objects in vtk that generate multiple surfaces.\n\n@warning\nTo read the output file use vtkMCubesReader.\n\n@sa\nvtkMarchingCubes vtkCo",
    "ntourFilter vtkMCubesReader vtkDividingCubes\nvtkVolumeReader\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSliceCubes(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSliceCubes_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSliceCubes", o) != 0)
  {
    Py_DECREF(o);
  }

}

