// python wrapper for vtkSobelGradientMagnitudePass
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSobelGradientMagnitudePass.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSobelGradientMagnitudePass(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSobelGradientMagnitudePass_ClassNew(); }

#ifndef DECLARED_PyvtkImageProcessingPass_ClassNew
extern "C" { PyObject *PyvtkImageProcessingPass_ClassNew(); }
#define DECLARED_PyvtkImageProcessingPass_ClassNew
#endif

static const char **PyvtkSobelGradientMagnitudePass_Doc();


static PyObject *
PyvtkSobelGradientMagnitudePass_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSobelGradientMagnitudePass *op = static_cast<vtkSobelGradientMagnitudePass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSobelGradientMagnitudePass::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSobelGradientMagnitudePass_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSobelGradientMagnitudePass *op = static_cast<vtkSobelGradientMagnitudePass *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSobelGradientMagnitudePass::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSobelGradientMagnitudePass_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSobelGradientMagnitudePass *op = static_cast<vtkSobelGradientMagnitudePass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSobelGradientMagnitudePass *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSobelGradientMagnitudePass::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSobelGradientMagnitudePass_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkSobelGradientMagnitudePass *tempr = vtkSobelGradientMagnitudePass::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSobelGradientMagnitudePass_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSobelGradientMagnitudePass *op = static_cast<vtkSobelGradientMagnitudePass *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkSobelGradientMagnitudePass::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSobelGradientMagnitudePass_Methods[] = {
  {"GetClassName", PyvtkSobelGradientMagnitudePass_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSobelGradientMagnitudePass_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSobelGradientMagnitudePass_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSobelGradientMagnitudePass\nC++: vtkSobelGradientMagnitudePass *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSobelGradientMagnitudePass_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSobelGradientMagnitudePass\nC++: vtkSobelGradientMagnitudePass *SafeDownCast(vtkObject* o)\n\n"},
  {"ReleaseGraphicsResources", PyvtkSobelGradientMagnitudePass_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *w)\n\nRelease graphics resources and ask components to release their\nown resources.\n\\pre w_exists: w!=0\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSobelGradientMagnitudePass_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkSobelGradientMagnitudePass", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSobelGradientMagnitudePass_StaticNew()
{
  return vtkSobelGradientMagnitudePass::New();
}

PyObject *PyvtkSobelGradientMagnitudePass_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSobelGradientMagnitudePass_Type, PyvtkSobelGradientMagnitudePass_Methods,
    "vtkSobelGradientMagnitudePass",
    PyvtkSobelGradientMagnitudePass_Doc(), &PyvtkSobelGradientMagnitudePass_StaticNew);

  PyTypeObject *pytype = &PyvtkSobelGradientMagnitudePass_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageProcessingPass_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSobelGradientMagnitudePass_Doc()
{
  static const char *docstring[] = {
    "vtkSobelGradientMagnitudePass - Implement a post-processing edge\ndetection with a Sobel gradient magnitude render pass.\n\n",
    "Superclass: vtkImageProcessingPass\n\n",
    "Detect the edges of the image renderered by its delegate.\nEdge-detection uses a Sobel high-pass filter (3x3 kernel).\n\nThis pass expects an initialized depth buffer and color buffer.\nInitialized buffers means they have been cleared with farest z-value\nand background color/gradient/transparent color. An opaque pass may\nhave been performed right after the initialization.\n\nThe delegate is used once.\n\n",
    "Its delegate is usually set to a vtkCameraPass or to a\npost-processing pass.\n\nThis pass requires a OpenGL context that supports texture objects\n(TO), framebuffer objects (FBO) and GLSL. If not, it will emit an\nerror message and will render its delegate and return.\n\n@par Implementation: To compute the gradient magnitude, the x and y\ncomponents of the gradient (Gx and Gy) have to be computed first.\n",
    "Each computation of Gx and Gy uses a separable filter. The first pass\ntakes the image from the delegate as the single input texture. The\nfirst pass has two outputs, one for the first part of Gx, Gx1, result\nof a convolution with (-1 0 1), one for the first part of Gy, Gy1,\nresult of a convolution with (1 2 1). The second pass has two inputs,\nGx1 and Gy1. Kernel (1 2 1)^T is applied to Gx1 and kern",
    "el (-1 0 1)^T\nis applied to Gx2. It gives the values for Gx and Gy. Thoses values\nare then used to compute the magnitude of the gradient which is\nstored in the render target. The gradient computation happens per\ncomponent (R,G,B). A is arbitrarly set to 1 (full opacity).\n\n@par Implementation:\\image html\nvtkSobelGradientMagnitudePassFigure.png\\image latex\nvtkSobelGradientMagnitudePassFigure.eps\n\n@s",
    "a\nvtkRenderPass\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSobelGradientMagnitudePass(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSobelGradientMagnitudePass_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSobelGradientMagnitudePass", o) != 0)
  {
    Py_DECREF(o);
  }

}

