// python wrapper for vtkStreamPoints
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStreamPoints.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkStreamPoints(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkStreamPoints_ClassNew(); }

#ifndef DECLARED_PyvtkStreamer_ClassNew
extern "C" { PyObject *PyvtkStreamer_ClassNew(); }
#define DECLARED_PyvtkStreamer_ClassNew
#endif

static const char **PyvtkStreamPoints_Doc();


static PyObject *
PyvtkStreamPoints_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamPoints *op = static_cast<vtkStreamPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkStreamPoints::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStreamPoints_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamPoints *op = static_cast<vtkStreamPoints *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkStreamPoints::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStreamPoints_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamPoints *op = static_cast<vtkStreamPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkStreamPoints *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkStreamPoints::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkStreamPoints_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkStreamPoints *tempr = vtkStreamPoints::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStreamPoints_SetTimeIncrement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeIncrement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamPoints *op = static_cast<vtkStreamPoints *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTimeIncrement(temp0);
    }
    else
    {
      op->vtkStreamPoints::SetTimeIncrement(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStreamPoints_GetTimeIncrementMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeIncrementMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamPoints *op = static_cast<vtkStreamPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTimeIncrementMinValue() :
      op->vtkStreamPoints::GetTimeIncrementMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStreamPoints_GetTimeIncrementMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeIncrementMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamPoints *op = static_cast<vtkStreamPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTimeIncrementMaxValue() :
      op->vtkStreamPoints::GetTimeIncrementMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStreamPoints_GetTimeIncrement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeIncrement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStreamPoints *op = static_cast<vtkStreamPoints *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTimeIncrement() :
      op->vtkStreamPoints::GetTimeIncrement());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkStreamPoints_Methods[] = {
  {"GetClassName", PyvtkStreamPoints_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkStreamPoints_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkStreamPoints_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkStreamPoints\nC++: vtkStreamPoints *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkStreamPoints_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkStreamPoints\nC++: vtkStreamPoints *SafeDownCast(vtkObject* o)\n\n"},
  {"SetTimeIncrement", PyvtkStreamPoints_SetTimeIncrement, METH_VARARGS,
   "V.SetTimeIncrement(float)\nC++: void SetTimeIncrement(double)\n\nSpecify the separation of points in terms of absolute time.\n"},
  {"GetTimeIncrementMinValue", PyvtkStreamPoints_GetTimeIncrementMinValue, METH_VARARGS,
   "V.GetTimeIncrementMinValue() -> float\nC++: double GetTimeIncrementMinValue()\n\nSpecify the separation of points in terms of absolute time.\n"},
  {"GetTimeIncrementMaxValue", PyvtkStreamPoints_GetTimeIncrementMaxValue, METH_VARARGS,
   "V.GetTimeIncrementMaxValue() -> float\nC++: double GetTimeIncrementMaxValue()\n\nSpecify the separation of points in terms of absolute time.\n"},
  {"GetTimeIncrement", PyvtkStreamPoints_GetTimeIncrement, METH_VARARGS,
   "V.GetTimeIncrement() -> float\nC++: double GetTimeIncrement()\n\nSpecify the separation of points in terms of absolute time.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkStreamPoints_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersFlowPathsPython.vtkStreamPoints", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkStreamPoints_StaticNew()
{
  return vtkStreamPoints::New();
}

PyObject *PyvtkStreamPoints_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkStreamPoints_Type, PyvtkStreamPoints_Methods,
    "vtkStreamPoints",
    PyvtkStreamPoints_Doc(), &PyvtkStreamPoints_StaticNew);

  PyTypeObject *pytype = &PyvtkStreamPoints_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkStreamer_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkStreamPoints_Doc()
{
  static const char *docstring[] = {
    "vtkStreamPoints - generate points along streamer separated by\nconstant time increment\n\n",
    "Superclass: vtkStreamer\n\n",
    "vtkStreamPoints is a filter that generates points along a streamer.\nThe points are separated by a constant time increment. The resulting\nvisual effect (especially when coupled with vtkGlyph3D) is an\nindication of particle speed.\n\n@sa\nvtkStreamer vtkStreamLine vtkDashedStreamLine\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkStreamPoints(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkStreamPoints_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkStreamPoints", o) != 0)
  {
    Py_DECREF(o);
  }

}

