// python wrapper for vtkStructuredImplicitConnectivity
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStructuredImplicitConnectivity.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkStructuredImplicitConnectivity(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkStructuredImplicitConnectivity_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkStructuredImplicitConnectivity_Doc();


static PyObject *
PyvtkStructuredImplicitConnectivity_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkStructuredImplicitConnectivity::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkStructuredImplicitConnectivity::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkStructuredImplicitConnectivity *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkStructuredImplicitConnectivity::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkStructuredImplicitConnectivity *tempr = vtkStructuredImplicitConnectivity::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_SetWholeExtent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWholeExtent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  const int size0 = 6;
  int temp0[6];
  int save0[6];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetWholeExtent(temp0);
    }
    else
    {
      op->vtkStructuredImplicitConnectivity::SetWholeExtent(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_RegisterGrid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RegisterGrid");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  int temp0;
  const int size1 = 6;
  int temp1[6];
  int save1[6];
  vtkPoints *temp2 = NULL;
  vtkPointData *temp3 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetVTKObject(temp2, "vtkPoints") &&
      ap.GetVTKObject(temp3, "vtkPointData"))
  {
    ap.SaveArray(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->RegisterGrid(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkStructuredImplicitConnectivity::RegisterGrid(temp0, temp1, temp2, temp3);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_RegisterRectilinearGrid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RegisterRectilinearGrid");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  int temp0;
  const int size1 = 6;
  int temp1[6];
  int save1[6];
  vtkDataArray *temp2 = NULL;
  vtkDataArray *temp3 = NULL;
  vtkDataArray *temp4 = NULL;
  vtkPointData *temp5 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetVTKObject(temp2, "vtkDataArray") &&
      ap.GetVTKObject(temp3, "vtkDataArray") &&
      ap.GetVTKObject(temp4, "vtkDataArray") &&
      ap.GetVTKObject(temp5, "vtkPointData"))
  {
    ap.SaveArray(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->RegisterRectilinearGrid(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkStructuredImplicitConnectivity::RegisterRectilinearGrid(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_EstablishConnectivity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EstablishConnectivity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EstablishConnectivity();
    }
    else
    {
      op->vtkStructuredImplicitConnectivity::EstablishConnectivity();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_HasImplicitConnectivity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasImplicitConnectivity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasImplicitConnectivity() :
      op->vtkStructuredImplicitConnectivity::HasImplicitConnectivity());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_ExchangeData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ExchangeData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ExchangeData();
    }
    else
    {
      op->vtkStructuredImplicitConnectivity::ExchangeData();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_GetOutputStructuredGrid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputStructuredGrid");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  int temp0;
  vtkStructuredGrid *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkStructuredGrid"))
  {
    if (ap.IsBound())
    {
      op->GetOutputStructuredGrid(temp0, temp1);
    }
    else
    {
      op->vtkStructuredImplicitConnectivity::GetOutputStructuredGrid(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_GetOutputImageData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputImageData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  int temp0;
  vtkImageData *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->GetOutputImageData(temp0, temp1);
    }
    else
    {
      op->vtkStructuredImplicitConnectivity::GetOutputImageData(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStructuredImplicitConnectivity_GetOutputRectilinearGrid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputRectilinearGrid");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStructuredImplicitConnectivity *op = static_cast<vtkStructuredImplicitConnectivity *>(vp);

  int temp0;
  vtkRectilinearGrid *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkRectilinearGrid"))
  {
    if (ap.IsBound())
    {
      op->GetOutputRectilinearGrid(temp0, temp1);
    }
    else
    {
      op->vtkStructuredImplicitConnectivity::GetOutputRectilinearGrid(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkStructuredImplicitConnectivity_Methods[] = {
  {"GetClassName", PyvtkStructuredImplicitConnectivity_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkStructuredImplicitConnectivity_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkStructuredImplicitConnectivity_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkStructuredImplicitConnectivity\nC++: vtkStructuredImplicitConnectivity *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkStructuredImplicitConnectivity_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkStructuredImplicitConnectivity\nC++: vtkStructuredImplicitConnectivity *SafeDownCast(vtkObject* o)\n\n"},
  {"SetWholeExtent", PyvtkStructuredImplicitConnectivity_SetWholeExtent, METH_VARARGS,
   "V.SetWholeExtent([int, int, int, int, int, int])\nC++: void SetWholeExtent(int wholeExt[6])\n\nSets the whole extent for the distributed structured domain.\n\\param wholeExt the extent of the entire domain (in).\n\note All ranks must call this method with the same whole extent.\n\\post this->DomainInfo != NULL\n"},
  {"RegisterGrid", PyvtkStructuredImplicitConnectivity_RegisterGrid, METH_VARARGS,
   "V.RegisterGrid(int, [int, int, int, int, int, int], vtkPoints,\n    vtkPointData)\nC++: void RegisterGrid(const int gridID, int extent[6],\n    vtkPoints *gridPnts, vtkPointData *pointData)\n\n"},
  {"RegisterRectilinearGrid", PyvtkStructuredImplicitConnectivity_RegisterRectilinearGrid, METH_VARARGS,
   "V.RegisterRectilinearGrid(int, [int, int, int, int, int, int],\n    vtkDataArray, vtkDataArray, vtkDataArray, vtkPointData)\nC++: void RegisterRectilinearGrid(const int gridID, int extent[6],\n     vtkDataArray *xcoords, vtkDataArray *ycoords,\n    vtkDataArray *zcoords, vtkPointData *pointData)\n\n"},
  {"EstablishConnectivity", PyvtkStructuredImplicitConnectivity_EstablishConnectivity, METH_VARARGS,
   "V.EstablishConnectivity()\nC++: void EstablishConnectivity()\n\nFinds implicit connectivity for a distributed structured dataset.\n\note This is a collective operation, all ranks must call this\nmethod.\n\\pre this->Controller != NULL\n\\pre this->DomainInfo != NULL\n"},
  {"HasImplicitConnectivity", PyvtkStructuredImplicitConnectivity_HasImplicitConnectivity, METH_VARARGS,
   "V.HasImplicitConnectivity() -> bool\nC++: bool HasImplicitConnectivity()\n\nChecks if there is implicit connectivity.\n\\return status true if implicit connectivity in one or more\n    dimensions.\n"},
  {"ExchangeData", PyvtkStructuredImplicitConnectivity_ExchangeData, METH_VARARGS,
   "V.ExchangeData()\nC++: void ExchangeData()\n\nExchanges one layer (row or column) of data between neighboring\ngrids to fix the implicit connectivity.\n\note This is a collective operation, all ranks must call this\nmethod.\n\\pre this->Controller != NULL\n\\pre this->DomainInfo != NULL\n"},
  {"GetOutputStructuredGrid", PyvtkStructuredImplicitConnectivity_GetOutputStructuredGrid, METH_VARARGS,
   "V.GetOutputStructuredGrid(int, vtkStructuredGrid)\nC++: void GetOutputStructuredGrid(const int gridID,\n    vtkStructuredGrid *grid)\n\nGets the output structured grid instance on this process.\n\\param gridID the ID of the grid\n\\param grid pointer to data-structure where to store the output.\n"},
  {"GetOutputImageData", PyvtkStructuredImplicitConnectivity_GetOutputImageData, METH_VARARGS,
   "V.GetOutputImageData(int, vtkImageData)\nC++: void GetOutputImageData(const int gridID, vtkImageData *grid)\n\nGets the output uniform grid instance on this process.\n\\param gridID the ID of the grid.\n\\param grid pointer to data-structure where to store the output.\n"},
  {"GetOutputRectilinearGrid", PyvtkStructuredImplicitConnectivity_GetOutputRectilinearGrid, METH_VARARGS,
   "V.GetOutputRectilinearGrid(int, vtkRectilinearGrid)\nC++: void GetOutputRectilinearGrid(const int gridID,\n    vtkRectilinearGrid *grid)\n\nGets the output rectilinear grid instance on this process.\n\\param gridID the ID of the grid.\n\\param grid pointer to data-structure where to store the output.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkStructuredImplicitConnectivity_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersParallelMPIPython.vtkStructuredImplicitConnectivity", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkStructuredImplicitConnectivity_StaticNew()
{
  return vtkStructuredImplicitConnectivity::New();
}

PyObject *PyvtkStructuredImplicitConnectivity_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkStructuredImplicitConnectivity_Type, PyvtkStructuredImplicitConnectivity_Methods,
    "vtkStructuredImplicitConnectivity",
    PyvtkStructuredImplicitConnectivity_Doc(), &PyvtkStructuredImplicitConnectivity_StaticNew);

  PyTypeObject *pytype = &PyvtkStructuredImplicitConnectivity_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkStructuredImplicitConnectivity_Doc()
{
  static const char *docstring[] = {
    "vtkStructuredImplicitConnectivity - a distributed structured dataset\nthat is implicitly connected among partitions without abutting.\n\n",
    "Superclass: vtkObject\n\n",
    "This creates a gap between partitions and introduces a cell that\nspans multiple zones. This typically arises with finite difference\ngrids, which are partitioned with respect to the nodes of the grid,\nor, when a filter samples the grid, e.g., to get a lower resolution\nrepresentation.\n\nThis class is intended as a lower-level helper for higher level VTK\nfilters that provides functionality for resolvi",
    "ng the implicit\nconnectivity (gap) between two or more partitions of a distributed\nstructured dataset.\n\n@warning\nThe present implementation requires: \n one block/grid per rank. \n 2-D (XY,YZ or XZ planes) or 3-D datasets. \n node-center fields must match across processes.  \n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkStructuredImplicitConnectivity(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkStructuredImplicitConnectivity_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkStructuredImplicitConnectivity", o) != 0)
  {
    Py_DECREF(o);
  }

}

