// python wrapper for vtkTemporalDataSetCache
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkTemporalDataSetCache.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTemporalDataSetCache(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTemporalDataSetCache_ClassNew(); }

#ifndef DECLARED_PyvtkAlgorithm_ClassNew
extern "C" { PyObject *PyvtkAlgorithm_ClassNew(); }
#define DECLARED_PyvtkAlgorithm_ClassNew
#endif

static const char **PyvtkTemporalDataSetCache_Doc();


static PyObject *
PyvtkTemporalDataSetCache_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTemporalDataSetCache *op = static_cast<vtkTemporalDataSetCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTemporalDataSetCache::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTemporalDataSetCache_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTemporalDataSetCache *op = static_cast<vtkTemporalDataSetCache *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTemporalDataSetCache::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTemporalDataSetCache_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTemporalDataSetCache *op = static_cast<vtkTemporalDataSetCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTemporalDataSetCache *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTemporalDataSetCache::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkTemporalDataSetCache_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkTemporalDataSetCache *tempr = vtkTemporalDataSetCache::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTemporalDataSetCache_SetCacheSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCacheSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTemporalDataSetCache *op = static_cast<vtkTemporalDataSetCache *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCacheSize(temp0);
    }
    else
    {
      op->vtkTemporalDataSetCache::SetCacheSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTemporalDataSetCache_GetCacheSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCacheSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTemporalDataSetCache *op = static_cast<vtkTemporalDataSetCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCacheSize() :
      op->vtkTemporalDataSetCache::GetCacheSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkTemporalDataSetCache_Methods[] = {
  {"GetClassName", PyvtkTemporalDataSetCache_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTemporalDataSetCache_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTemporalDataSetCache_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTemporalDataSetCache\nC++: vtkTemporalDataSetCache *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTemporalDataSetCache_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTemporalDataSetCache\nC++: vtkTemporalDataSetCache *SafeDownCast(vtkObject* o)\n\n"},
  {"SetCacheSize", PyvtkTemporalDataSetCache_SetCacheSize, METH_VARARGS,
   "V.SetCacheSize(int)\nC++: void SetCacheSize(int size)\n\nThis is the maximum number of time steps that can be retained in\nmemory. it defaults to 10.\n"},
  {"GetCacheSize", PyvtkTemporalDataSetCache_GetCacheSize, METH_VARARGS,
   "V.GetCacheSize() -> int\nC++: int GetCacheSize()\n\nThis is the maximum number of time steps that can be retained in\nmemory. it defaults to 10.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTemporalDataSetCache_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersHybridPython.vtkTemporalDataSetCache", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTemporalDataSetCache_StaticNew()
{
  return vtkTemporalDataSetCache::New();
}

PyObject *PyvtkTemporalDataSetCache_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTemporalDataSetCache_Type, PyvtkTemporalDataSetCache_Methods,
    "vtkTemporalDataSetCache",
    PyvtkTemporalDataSetCache_Doc(), &PyvtkTemporalDataSetCache_StaticNew);

  PyTypeObject *pytype = &PyvtkTemporalDataSetCache_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTemporalDataSetCache_Doc()
{
  static const char *docstring[] = {
    "vtkTemporalDataSetCache - cache time steps\n\n",
    "Superclass: vtkAlgorithm\n\n",
    "vtkTemporalDataSetCache cache time step requests of a temporal\ndataset, when cached data is requested it is returned using a shallow\ncopy.@par Thanks: Ken Martin (Kitware) and John Bidiscombe of CSCS -\nSwiss National Supercomputing Centre for creating and contributing\nthis class. For related material, please refer to : John Biddiscombe,\nBerk Geveci, Ken Martin, Kenneth Moreland, David Thompson, \"T",
    "ime Dependent Processing in a Parallel Pipeline\nArchitecture\", IEEE Visualization 2007.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTemporalDataSetCache(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTemporalDataSetCache_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTemporalDataSetCache", o) != 0)
  {
    Py_DECREF(o);
  }

}

