// python wrapper for vtkTreeMapLayout
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkTreeMapLayout.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTreeMapLayout(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTreeMapLayout_ClassNew(); }

#ifndef DECLARED_PyvtkTreeAlgorithm_ClassNew
extern "C" { PyObject *PyvtkTreeAlgorithm_ClassNew(); }
#define DECLARED_PyvtkTreeAlgorithm_ClassNew
#endif

static const char **PyvtkTreeMapLayout_Doc();


static PyObject *
PyvtkTreeMapLayout_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTreeMapLayout::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTreeMapLayout::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTreeMapLayout *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTreeMapLayout::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkTreeMapLayout *tempr = vtkTreeMapLayout::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_GetRectanglesFieldName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRectanglesFieldName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetRectanglesFieldName() :
      op->vtkTreeMapLayout::GetRectanglesFieldName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_SetRectanglesFieldName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRectanglesFieldName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRectanglesFieldName(temp0);
    }
    else
    {
      op->vtkTreeMapLayout::SetRectanglesFieldName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_SetSizeArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSizeArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSizeArrayName(temp0);
    }
    else
    {
      op->vtkTreeMapLayout::SetSizeArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_GetLayoutStrategy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLayoutStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTreeMapLayoutStrategy *tempr = (ap.IsBound() ?
      op->GetLayoutStrategy() :
      op->vtkTreeMapLayout::GetLayoutStrategy());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_SetLayoutStrategy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLayoutStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  vtkTreeMapLayoutStrategy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTreeMapLayoutStrategy"))
  {
    if (ap.IsBound())
    {
      op->SetLayoutStrategy(temp0);
    }
    else
    {
      op->vtkTreeMapLayout::SetLayoutStrategy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_FindVertex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FindVertex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  const int size0 = 2;
  float temp0[2];
  float save0[2];
  int size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<float> store1(2*size1);
  float *temp1 = store1.Data();
  float *save1 = (size1 == 0 ? NULL : temp1 + size1);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetArray(temp0, size0) &&
      (ap.NoArgsLeft() || ap.GetArray(temp1, size1)))
  {
    ap.SaveArray(temp0, save0, size0);
    ap.SaveArray(temp1, save1, size1);

    vtkIdType tempr = (ap.IsBound() ?
      op->FindVertex(temp0, temp1) :
      op->vtkTreeMapLayout::FindVertex(temp0, temp1));

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_GetBoundingBox(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBoundingBox");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  vtkIdType temp0;
  int size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<float> store1(2*size1);
  float *temp1 = store1.Data();
  float *save1 = (size1 == 0 ? NULL : temp1 + size1);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    ap.SaveArray(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->GetBoundingBox(temp0, temp1);
    }
    else
    {
      op->vtkTreeMapLayout::GetBoundingBox(temp0, temp1);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTreeMapLayout_GetMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTreeMapLayout *op = static_cast<vtkTreeMapLayout *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long long tempr = (ap.IsBound() ?
      op->GetMTime() :
      op->vtkTreeMapLayout::GetMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkTreeMapLayout_Methods[] = {
  {"GetClassName", PyvtkTreeMapLayout_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTreeMapLayout_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTreeMapLayout_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTreeMapLayout\nC++: vtkTreeMapLayout *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTreeMapLayout_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTreeMapLayout\nC++: vtkTreeMapLayout *SafeDownCast(vtkObject* o)\n\n"},
  {"GetRectanglesFieldName", PyvtkTreeMapLayout_GetRectanglesFieldName, METH_VARARGS,
   "V.GetRectanglesFieldName() -> string\nC++: char *GetRectanglesFieldName()\n\nThe field name to use for storing the rectangles for each vertex.\nThe rectangles are stored in a quadruple float array (minX, maxX,\nminY, maxY).\n"},
  {"SetRectanglesFieldName", PyvtkTreeMapLayout_SetRectanglesFieldName, METH_VARARGS,
   "V.SetRectanglesFieldName(string)\nC++: void SetRectanglesFieldName(char *)\n\nThe field name to use for storing the rectangles for each vertex.\nThe rectangles are stored in a quadruple float array (minX, maxX,\nminY, maxY).\n"},
  {"SetSizeArrayName", PyvtkTreeMapLayout_SetSizeArrayName, METH_VARARGS,
   "V.SetSizeArrayName(string)\nC++: virtual void SetSizeArrayName(const char *name)\n\nThe array to use for the size of each vertex.\n"},
  {"GetLayoutStrategy", PyvtkTreeMapLayout_GetLayoutStrategy, METH_VARARGS,
   "V.GetLayoutStrategy() -> vtkTreeMapLayoutStrategy\nC++: vtkTreeMapLayoutStrategy *GetLayoutStrategy()\n\nThe strategy to use when laying out the tree map.\n"},
  {"SetLayoutStrategy", PyvtkTreeMapLayout_SetLayoutStrategy, METH_VARARGS,
   "V.SetLayoutStrategy(vtkTreeMapLayoutStrategy)\nC++: void SetLayoutStrategy(vtkTreeMapLayoutStrategy *strategy)\n\nThe strategy to use when laying out the tree map.\n"},
  {"FindVertex", PyvtkTreeMapLayout_FindVertex, METH_VARARGS,
   "V.FindVertex([float, float], [float, ...]) -> int\nC++: vtkIdType FindVertex(float pnt[2], float *binfo=0)\n\nReturns the vertex id that contains pnt (or -1 if no one contains\nit)\n"},
  {"GetBoundingBox", PyvtkTreeMapLayout_GetBoundingBox, METH_VARARGS,
   "V.GetBoundingBox(int, [float, ...])\nC++: void GetBoundingBox(vtkIdType id, float *binfo)\n\nReturn the min and max 2D points of the vertex's bounding box\n"},
  {"GetMTime", PyvtkTreeMapLayout_GetMTime, METH_VARARGS,
   "V.GetMTime() -> int\nC++: virtual vtkMTimeType GetMTime()\n\nGet the modification time of the layout algorithm.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTreeMapLayout_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInfovisLayoutPython.vtkTreeMapLayout", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTreeMapLayout_StaticNew()
{
  return vtkTreeMapLayout::New();
}

PyObject *PyvtkTreeMapLayout_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTreeMapLayout_Type, PyvtkTreeMapLayout_Methods,
    "vtkTreeMapLayout",
    PyvtkTreeMapLayout_Doc(), &PyvtkTreeMapLayout_StaticNew);

  PyTypeObject *pytype = &PyvtkTreeMapLayout_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTreeAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTreeMapLayout_Doc()
{
  static const char *docstring[] = {
    "vtkTreeMapLayout - layout a vtkTree into a tree map\n\n",
    "Superclass: vtkTreeAlgorithm\n\n",
    "vtkTreeMapLayout assigns rectangular regions to each vertex in the\ntree, creating a tree map.  The data is added as a data array with\nfour components per tuple representing the location and size of the\nrectangle using the format (Xmin, Xmax, Ymin, Ymax).\n\nThis algorithm relies on a helper class to perform the actual layout.\nThis helper class is a subclass of vtkTreeMapLayoutStrategy.\n\n@par Thanks:",
    " Thanks to Brian Wylie and Ken Moreland from Sandia\nNational Laboratories for help developing this class.\n\n@par Thanks: Tree map concept comes from: Shneiderman, B. 1992. Tree\nvisualization with tree-maps: 2-d space-filling approach. ACM Trans.\nGraph. 11, 1 (Jan. 1992), 92-99.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTreeMapLayout(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTreeMapLayout_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTreeMapLayout", o) != 0)
  {
    Py_DECREF(o);
  }

}

