// python wrapper for vtkTriangleFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkTriangleFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTriangleFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTriangleFilter_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkTriangleFilter_Doc();


static PyObject *
PyvtkTriangleFilter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTriangleFilter::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTriangleFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTriangleFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTriangleFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkTriangleFilter *tempr = vtkTriangleFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_PassVertsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PassVertsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PassVertsOn();
    }
    else
    {
      op->vtkTriangleFilter::PassVertsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_PassVertsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PassVertsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PassVertsOff();
    }
    else
    {
      op->vtkTriangleFilter::PassVertsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_SetPassVerts(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPassVerts");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPassVerts(temp0);
    }
    else
    {
      op->vtkTriangleFilter::SetPassVerts(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_GetPassVerts(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPassVerts");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPassVerts() :
      op->vtkTriangleFilter::GetPassVerts());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_PassLinesOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PassLinesOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PassLinesOn();
    }
    else
    {
      op->vtkTriangleFilter::PassLinesOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_PassLinesOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PassLinesOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PassLinesOff();
    }
    else
    {
      op->vtkTriangleFilter::PassLinesOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_SetPassLines(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPassLines");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPassLines(temp0);
    }
    else
    {
      op->vtkTriangleFilter::SetPassLines(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTriangleFilter_GetPassLines(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPassLines");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangleFilter *op = static_cast<vtkTriangleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPassLines() :
      op->vtkTriangleFilter::GetPassLines());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkTriangleFilter_Methods[] = {
  {"GetClassName", PyvtkTriangleFilter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTriangleFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTriangleFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTriangleFilter\nC++: vtkTriangleFilter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTriangleFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTriangleFilter\nC++: vtkTriangleFilter *SafeDownCast(vtkObject* o)\n\n"},
  {"PassVertsOn", PyvtkTriangleFilter_PassVertsOn, METH_VARARGS,
   "V.PassVertsOn()\nC++: void PassVertsOn()\n\nTurn on/off passing vertices through filter (default: on). If\nthis is on, then the input vertex cells will be broken into\nindividual vertex cells (one point per cell).  If it is off, the\ninput vertex cells will be ignored.\n"},
  {"PassVertsOff", PyvtkTriangleFilter_PassVertsOff, METH_VARARGS,
   "V.PassVertsOff()\nC++: void PassVertsOff()\n\nTurn on/off passing vertices through filter (default: on). If\nthis is on, then the input vertex cells will be broken into\nindividual vertex cells (one point per cell).  If it is off, the\ninput vertex cells will be ignored.\n"},
  {"SetPassVerts", PyvtkTriangleFilter_SetPassVerts, METH_VARARGS,
   "V.SetPassVerts(int)\nC++: void SetPassVerts(int a)\n\nTurn on/off passing vertices through filter (default: on). If\nthis is on, then the input vertex cells will be broken into\nindividual vertex cells (one point per cell).  If it is off, the\ninput vertex cells will be ignored.\n"},
  {"GetPassVerts", PyvtkTriangleFilter_GetPassVerts, METH_VARARGS,
   "V.GetPassVerts() -> int\nC++: int GetPassVerts()\n\nTurn on/off passing vertices through filter (default: on). If\nthis is on, then the input vertex cells will be broken into\nindividual vertex cells (one point per cell).  If it is off, the\ninput vertex cells will be ignored.\n"},
  {"PassLinesOn", PyvtkTriangleFilter_PassLinesOn, METH_VARARGS,
   "V.PassLinesOn()\nC++: void PassLinesOn()\n\nTurn on/off passing lines through filter (default: on). If this\nis on, then the input polylines will be broken into line\nsegments.  If it is off, then the input lines will be ignored and\nthe output will have no lines.\n"},
  {"PassLinesOff", PyvtkTriangleFilter_PassLinesOff, METH_VARARGS,
   "V.PassLinesOff()\nC++: void PassLinesOff()\n\nTurn on/off passing lines through filter (default: on). If this\nis on, then the input polylines will be broken into line\nsegments.  If it is off, then the input lines will be ignored and\nthe output will have no lines.\n"},
  {"SetPassLines", PyvtkTriangleFilter_SetPassLines, METH_VARARGS,
   "V.SetPassLines(int)\nC++: void SetPassLines(int a)\n\nTurn on/off passing lines through filter (default: on). If this\nis on, then the input polylines will be broken into line\nsegments.  If it is off, then the input lines will be ignored and\nthe output will have no lines.\n"},
  {"GetPassLines", PyvtkTriangleFilter_GetPassLines, METH_VARARGS,
   "V.GetPassLines() -> int\nC++: int GetPassLines()\n\nTurn on/off passing lines through filter (default: on). If this\nis on, then the input polylines will be broken into line\nsegments.  If it is off, then the input lines will be ignored and\nthe output will have no lines.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTriangleFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersCorePython.vtkTriangleFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTriangleFilter_StaticNew()
{
  return vtkTriangleFilter::New();
}

PyObject *PyvtkTriangleFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTriangleFilter_Type, PyvtkTriangleFilter_Methods,
    "vtkTriangleFilter",
    PyvtkTriangleFilter_Doc(), &PyvtkTriangleFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkTriangleFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTriangleFilter_Doc()
{
  static const char *docstring[] = {
    "vtkTriangleFilter - convert input polygons and strips to triangles\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkTriangleFilter generates triangles from input polygons and\ntriangle strips.  It also generates line segments from polylines\nunless PassLines is off, and generates individual vertex cells from\nvtkVertex point lists unless PassVerts is off.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTriangleFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTriangleFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTriangleFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

