// python wrapper for vtkTrivialProducer
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkInformationVector.h"
#include "vtkTrivialProducer.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTrivialProducer(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTrivialProducer_ClassNew(); }

#ifndef DECLARED_PyvtkAlgorithm_ClassNew
extern "C" { PyObject *PyvtkAlgorithm_ClassNew(); }
#define DECLARED_PyvtkAlgorithm_ClassNew
#endif

static const char **PyvtkTrivialProducer_Doc();


static PyObject *
PyvtkTrivialProducer_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTrivialProducer *op = static_cast<vtkTrivialProducer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTrivialProducer::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTrivialProducer_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTrivialProducer *op = static_cast<vtkTrivialProducer *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTrivialProducer::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTrivialProducer_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTrivialProducer *op = static_cast<vtkTrivialProducer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTrivialProducer *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTrivialProducer::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkTrivialProducer_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkTrivialProducer *tempr = vtkTrivialProducer::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTrivialProducer_SetOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTrivialProducer *op = static_cast<vtkTrivialProducer *>(vp);

  vtkDataObject *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->SetOutput(temp0);
    }
    else
    {
      op->vtkTrivialProducer::SetOutput(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTrivialProducer_GetMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTrivialProducer *op = static_cast<vtkTrivialProducer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long long tempr = (ap.IsBound() ?
      op->GetMTime() :
      op->vtkTrivialProducer::GetMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTrivialProducer_SetWholeExtent_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWholeExtent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTrivialProducer *op = static_cast<vtkTrivialProducer *>(vp);

  int temp0;
  int temp1;
  int temp2;
  int temp3;
  int temp4;
  int temp5;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5))
  {
    if (ap.IsBound())
    {
      op->SetWholeExtent(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkTrivialProducer::SetWholeExtent(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkTrivialProducer_SetWholeExtent_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWholeExtent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTrivialProducer *op = static_cast<vtkTrivialProducer *>(vp);

  const int size0 = 6;
  int temp0[6];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetWholeExtent(temp0);
    }
    else
    {
      op->vtkTrivialProducer::SetWholeExtent(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkTrivialProducer_SetWholeExtent(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 6:
      return PyvtkTrivialProducer_SetWholeExtent_s1(self, args);
    case 1:
      return PyvtkTrivialProducer_SetWholeExtent_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetWholeExtent");
  return NULL;
}



static PyObject *
PyvtkTrivialProducer_GetWholeExtent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWholeExtent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTrivialProducer *op = static_cast<vtkTrivialProducer *>(vp);

  int sizer = 6;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetWholeExtent() :
      op->vtkTrivialProducer::GetWholeExtent());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkTrivialProducer_FillOutputDataInformation(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "FillOutputDataInformation");

  vtkDataObject *temp0 = NULL;
  vtkInformation *temp1 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkDataObject") &&
      ap.GetVTKObject(temp1, "vtkInformation"))
  {
    vtkTrivialProducer::FillOutputDataInformation(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkTrivialProducer_Methods[] = {
  {"GetClassName", PyvtkTrivialProducer_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTrivialProducer_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTrivialProducer_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTrivialProducer\nC++: vtkTrivialProducer *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTrivialProducer_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTrivialProducer\nC++: vtkTrivialProducer *SafeDownCast(vtkObject* o)\n\n"},
  {"SetOutput", PyvtkTrivialProducer_SetOutput, METH_VARARGS,
   "V.SetOutput(vtkDataObject)\nC++: virtual void SetOutput(vtkDataObject *output)\n\nSet the data object that is \"produced\" by this producer.  It is\nnever really modified.\n"},
  {"GetMTime", PyvtkTrivialProducer_GetMTime, METH_VARARGS,
   "V.GetMTime() -> int\nC++: vtkMTimeType GetMTime()\n\nThe modified time of this producer is the newer of this object or\nthe assigned output.\n"},
  {"SetWholeExtent", PyvtkTrivialProducer_SetWholeExtent, METH_VARARGS,
   "V.SetWholeExtent(int, int, int, int, int, int)\nC++: void SetWholeExtent(int, int, int, int, int, int)\nV.SetWholeExtent((int, int, int, int, int, int))\nC++: void SetWholeExtent(int a[6])\n\n"},
  {"GetWholeExtent", PyvtkTrivialProducer_GetWholeExtent, METH_VARARGS,
   "V.GetWholeExtent() -> (int, int, int, int, int, int)\nC++: int *GetWholeExtent()\n\n"},
  {"FillOutputDataInformation", PyvtkTrivialProducer_FillOutputDataInformation, METH_VARARGS,
   "V.FillOutputDataInformation(vtkDataObject, vtkInformation)\nC++: static void FillOutputDataInformation(vtkDataObject *output,\n    vtkInformation *outInfo)\n\nThis method can be used to copy meta-data from an existing data\nobject to an information object. For example, whole extent, image\ndata spacing, origin etc.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTrivialProducer_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonExecutionModelPython.vtkTrivialProducer", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTrivialProducer_StaticNew()
{
  return vtkTrivialProducer::New();
}

PyObject *PyvtkTrivialProducer_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTrivialProducer_Type, PyvtkTrivialProducer_Methods,
    "vtkTrivialProducer",
    PyvtkTrivialProducer_Doc(), &PyvtkTrivialProducer_StaticNew);

  PyTypeObject *pytype = &PyvtkTrivialProducer_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTrivialProducer_Doc()
{
  static const char *docstring[] = {
    "vtkTrivialProducer - Producer for stand-alone data objects.\n\n",
    "Superclass: vtkAlgorithm\n\n",
    "vtkTrivialProducer allows stand-alone data objects to be connected as\ninputs in a pipeline.  All data objects that are connected to a\npipeline involving vtkAlgorithm must have a producer.  This trivial\nproducer allows data objects that are hand-constructed in a program\nwithout another vtk producer to be connected.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTrivialProducer(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTrivialProducer_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTrivialProducer", o) != 0)
  {
    Py_DECREF(o);
  }

}

