// python wrapper for vtkTulipReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkTulipReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTulipReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTulipReader_ClassNew(); }

#ifndef DECLARED_PyvtkUndirectedGraphAlgorithm_ClassNew
extern "C" { PyObject *PyvtkUndirectedGraphAlgorithm_ClassNew(); }
#define DECLARED_PyvtkUndirectedGraphAlgorithm_ClassNew
#endif

static const char **PyvtkTulipReader_Doc();


static PyObject *
PyvtkTulipReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTulipReader *op = static_cast<vtkTulipReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTulipReader::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTulipReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTulipReader *op = static_cast<vtkTulipReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTulipReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTulipReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTulipReader *op = static_cast<vtkTulipReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTulipReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTulipReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkTulipReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkTulipReader *tempr = vtkTulipReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTulipReader_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTulipReader *op = static_cast<vtkTulipReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkTulipReader::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTulipReader_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTulipReader *op = static_cast<vtkTulipReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkTulipReader::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkTulipReader_Methods[] = {
  {"GetClassName", PyvtkTulipReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTulipReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTulipReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTulipReader\nC++: vtkTulipReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTulipReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTulipReader\nC++: vtkTulipReader *SafeDownCast(vtkObject* o)\n\n"},
  {"GetFileName", PyvtkTulipReader_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: char *GetFileName()\n\nThe Tulip file name.\n"},
  {"SetFileName", PyvtkTulipReader_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(char *)\n\nThe Tulip file name.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTulipReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOInfovisPython.vtkTulipReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTulipReader_StaticNew()
{
  return vtkTulipReader::New();
}

PyObject *PyvtkTulipReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTulipReader_Type, PyvtkTulipReader_Methods,
    "vtkTulipReader",
    PyvtkTulipReader_Doc(), &PyvtkTulipReader_StaticNew);

  PyTypeObject *pytype = &PyvtkTulipReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUndirectedGraphAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTulipReader_Doc()
{
  static const char *docstring[] = {
    "vtkTulipReader - Reads tulip graph files.\n\n",
    "Superclass: vtkUndirectedGraphAlgorithm\n\n",
    "vtkTulipReader reads in files in the Tulip format. Definition of the\nTulip file format can be found online at:\nhttp://tulip.labri.fr/tlpformat.php An example is the following \n(nodes 0 1 2 3 4 5 6 7 8 9) (edge 0 0 1) (edge 1 1 2) (edge 2 2 3)\n(edge 3 3 4) (edge 4 4 5) (edge 5 5 6) (edge 6 6 7) (edge 7 7 8)\n(edge 8 8 9) (edge 9 9 0) (edge 10 0 5) (edge 11 2 7) (edge 12 4 9) \nwhere \"nodes\" defines a",
    "ll the nodes ids in the graph, and \"edge\" is a\ntriple of edge id, source vertex id, and target vertex id. The graph\nis read in as undirected graph. Pedigree ids are set on the output\ngraph's vertices and edges that match the node and edge ids defined\nin the Tulip file.\n\nClusters are output as a vtkAnnotationLayers on output port 1. Each\ncluster name is used to create an annotation layer, and each ",
    "cluster\nwith that name is added to the layer as a vtkSelectionNode. Nesting\nhierarchies are treated as if they were flat. See\nvtkGraphAnnotationLayersFilter for an example of how the clusters can\nbe represented visually.\n\n@attention Only string, int, and double properties are supported.\nDisplay information is discarded.\n\n@par Thanks: Thanks to Colin Myers, University of Leeds for extending\nthis im",
    "plementation.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTulipReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTulipReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTulipReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

