// python wrapper for vtkTypeInt8Array
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkTypeInt8Array.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTypeInt8Array(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTypeInt8Array_ClassNew(); }

#ifndef DECLARED_PyvtkCharArray_ClassNew
extern "C" { PyObject *PyvtkCharArray_ClassNew(); }
#define DECLARED_PyvtkCharArray_ClassNew
#endif

static const char **PyvtkTypeInt8Array_Doc();


static PyObject *
PyvtkTypeInt8Array_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTypeInt8Array *op = static_cast<vtkTypeInt8Array *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTypeInt8Array::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTypeInt8Array_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTypeInt8Array *op = static_cast<vtkTypeInt8Array *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTypeInt8Array::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTypeInt8Array_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTypeInt8Array *op = static_cast<vtkTypeInt8Array *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTypeInt8Array *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTypeInt8Array::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkTypeInt8Array_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkTypeInt8Array *tempr = vtkTypeInt8Array::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTypeInt8Array_FastDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "FastDownCast");

  vtkAbstractArray *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAbstractArray"))
  {
    vtkTypeInt8Array *tempr = vtkTypeInt8Array::FastDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkTypeInt8Array_Methods[] = {
  {"GetClassName", PyvtkTypeInt8Array_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTypeInt8Array_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTypeInt8Array_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTypeInt8Array\nC++: vtkTypeInt8Array *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTypeInt8Array_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTypeInt8Array\nC++: vtkTypeInt8Array *SafeDownCast(vtkObject* o)\n\n"},
  {"FastDownCast", PyvtkTypeInt8Array_FastDownCast, METH_VARARGS,
   "V.FastDownCast(vtkAbstractArray) -> vtkTypeInt8Array\nC++: static vtkTypeInt8Array *FastDownCast(\n    vtkAbstractArray *source)\n\nA faster alternative to SafeDownCast for downcasting\nvtkAbstractArrays.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTypeInt8Array_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkTypeInt8Array", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTypeInt8Array_StaticNew()
{
  return vtkTypeInt8Array::New();
}

PyObject *PyvtkTypeInt8Array_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTypeInt8Array_Type, PyvtkTypeInt8Array_Methods,
    "vtkTypeInt8Array",
    PyvtkTypeInt8Array_Doc(), &PyvtkTypeInt8Array_StaticNew);

  PyTypeObject *pytype = &PyvtkTypeInt8Array_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCharArray_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTypeInt8Array_Doc()
{
  static const char *docstring[] = {
    "vtkTypeInt8Array - dynamic, self-adjusting array of vtkTypeInt8\n\n",
    "Superclass: vtkCharArray\n\n",
    "vtkTypeInt8Array is an array of values of type vtkTypeInt8.  It\nprovides methods for insertion and retrieval of values and will\nautomatically resize itself to hold new data.\n\nThis array should be preferred for data of type Int8 as this array\nwill use the correct underlying datatype based on the desired number\nof bits and the current platform.  The superclass of this type will\nchange depending on t",
    "he machine and compiler in use so that the data\ncontained always uses the proper type.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTypeInt8Array(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTypeInt8Array_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTypeInt8Array", o) != 0)
  {
    Py_DECREF(o);
  }

}

