// python wrapper for vtkUnstructuredGridQuadricDecimation
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkUnstructuredGridQuadricDecimation.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkUnstructuredGridQuadricDecimation(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkUnstructuredGridQuadricDecimation_ClassNew(); }

#ifndef DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
extern "C" { PyObject *PyvtkUnstructuredGridAlgorithm_ClassNew(); }
#define DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
#endif

static const char **PyvtkUnstructuredGridQuadricDecimation_Doc();


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkUnstructuredGridQuadricDecimation::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkUnstructuredGridQuadricDecimation::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkUnstructuredGridQuadricDecimation *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkUnstructuredGridQuadricDecimation::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkUnstructuredGridQuadricDecimation *tempr = vtkUnstructuredGridQuadricDecimation::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_SetTargetReduction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTargetReduction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTargetReduction(temp0);
    }
    else
    {
      op->vtkUnstructuredGridQuadricDecimation::SetTargetReduction(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_GetTargetReduction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTargetReduction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTargetReduction() :
      op->vtkUnstructuredGridQuadricDecimation::GetTargetReduction());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_SetNumberOfTetsOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfTetsOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfTetsOutput(temp0);
    }
    else
    {
      op->vtkUnstructuredGridQuadricDecimation::SetNumberOfTetsOutput(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_GetNumberOfTetsOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfTetsOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfTetsOutput() :
      op->vtkUnstructuredGridQuadricDecimation::GetNumberOfTetsOutput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_SetNumberOfEdgesToDecimate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfEdgesToDecimate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfEdgesToDecimate(temp0);
    }
    else
    {
      op->vtkUnstructuredGridQuadricDecimation::SetNumberOfEdgesToDecimate(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_GetNumberOfEdgesToDecimate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfEdgesToDecimate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfEdgesToDecimate() :
      op->vtkUnstructuredGridQuadricDecimation::GetNumberOfEdgesToDecimate());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_SetNumberOfCandidates(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfCandidates");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfCandidates(temp0);
    }
    else
    {
      op->vtkUnstructuredGridQuadricDecimation::SetNumberOfCandidates(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_GetNumberOfCandidates(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfCandidates");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfCandidates() :
      op->vtkUnstructuredGridQuadricDecimation::GetNumberOfCandidates());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_SetAutoAddCandidates(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoAddCandidates");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutoAddCandidates(temp0);
    }
    else
    {
      op->vtkUnstructuredGridQuadricDecimation::SetAutoAddCandidates(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_GetAutoAddCandidates(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoAddCandidates");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAutoAddCandidates() :
      op->vtkUnstructuredGridQuadricDecimation::GetAutoAddCandidates());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_SetAutoAddCandidatesThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoAddCandidatesThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutoAddCandidatesThreshold(temp0);
    }
    else
    {
      op->vtkUnstructuredGridQuadricDecimation::SetAutoAddCandidatesThreshold(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_GetAutoAddCandidatesThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutoAddCandidatesThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetAutoAddCandidatesThreshold() :
      op->vtkUnstructuredGridQuadricDecimation::GetAutoAddCandidatesThreshold());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_SetBoundaryWeight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBoundaryWeight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetBoundaryWeight(temp0);
    }
    else
    {
      op->vtkUnstructuredGridQuadricDecimation::SetBoundaryWeight(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_GetBoundaryWeight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBoundaryWeight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetBoundaryWeight() :
      op->vtkUnstructuredGridQuadricDecimation::GetBoundaryWeight());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_SetScalarsName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarsName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScalarsName(temp0);
    }
    else
    {
      op->vtkUnstructuredGridQuadricDecimation::SetScalarsName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUnstructuredGridQuadricDecimation_GetScalarsName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScalarsName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUnstructuredGridQuadricDecimation *op = static_cast<vtkUnstructuredGridQuadricDecimation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetScalarsName() :
      op->vtkUnstructuredGridQuadricDecimation::GetScalarsName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkUnstructuredGridQuadricDecimation_Methods[] = {
  {"GetClassName", PyvtkUnstructuredGridQuadricDecimation_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkUnstructuredGridQuadricDecimation_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkUnstructuredGridQuadricDecimation_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkUnstructuredGridQuadricDecimation\nC++: vtkUnstructuredGridQuadricDecimation *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkUnstructuredGridQuadricDecimation_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkUnstructuredGridQuadricDecimation\nC++: vtkUnstructuredGridQuadricDecimation *SafeDownCast(\n    vtkObject* o)\n\n"},
  {"SetTargetReduction", PyvtkUnstructuredGridQuadricDecimation_SetTargetReduction, METH_VARARGS,
   "V.SetTargetReduction(float)\nC++: void SetTargetReduction(double a)\n\nSet/Get the desired reduction (expressed as a fraction of the\noriginal number of tetrehedra)\n"},
  {"GetTargetReduction", PyvtkUnstructuredGridQuadricDecimation_GetTargetReduction, METH_VARARGS,
   "V.GetTargetReduction() -> float\nC++: double GetTargetReduction()\n\nSet/Get the desired reduction (expressed as a fraction of the\noriginal number of tetrehedra)\n"},
  {"SetNumberOfTetsOutput", PyvtkUnstructuredGridQuadricDecimation_SetNumberOfTetsOutput, METH_VARARGS,
   "V.SetNumberOfTetsOutput(int)\nC++: void SetNumberOfTetsOutput(int a)\n\nSet/Get the desired number of tetrahedra to be outputed\n"},
  {"GetNumberOfTetsOutput", PyvtkUnstructuredGridQuadricDecimation_GetNumberOfTetsOutput, METH_VARARGS,
   "V.GetNumberOfTetsOutput() -> int\nC++: int GetNumberOfTetsOutput()\n\nSet/Get the desired number of tetrahedra to be outputed\n"},
  {"SetNumberOfEdgesToDecimate", PyvtkUnstructuredGridQuadricDecimation_SetNumberOfEdgesToDecimate, METH_VARARGS,
   "V.SetNumberOfEdgesToDecimate(int)\nC++: void SetNumberOfEdgesToDecimate(int a)\n\nSet/Get the desired number of edge to collapse\n"},
  {"GetNumberOfEdgesToDecimate", PyvtkUnstructuredGridQuadricDecimation_GetNumberOfEdgesToDecimate, METH_VARARGS,
   "V.GetNumberOfEdgesToDecimate() -> int\nC++: int GetNumberOfEdgesToDecimate()\n\nSet/Get the desired number of edge to collapse\n"},
  {"SetNumberOfCandidates", PyvtkUnstructuredGridQuadricDecimation_SetNumberOfCandidates, METH_VARARGS,
   "V.SetNumberOfCandidates(int)\nC++: void SetNumberOfCandidates(int a)\n\nSet/Get the number of candidates selected for each randomized set\nbefore performing an edge collapse. Increasing this number can\nhelp producing higher quality output but it will be slower.\nDefault is 8.\n"},
  {"GetNumberOfCandidates", PyvtkUnstructuredGridQuadricDecimation_GetNumberOfCandidates, METH_VARARGS,
   "V.GetNumberOfCandidates() -> int\nC++: int GetNumberOfCandidates()\n\nSet/Get the number of candidates selected for each randomized set\nbefore performing an edge collapse. Increasing this number can\nhelp producing higher quality output but it will be slower.\nDefault is 8.\n"},
  {"SetAutoAddCandidates", PyvtkUnstructuredGridQuadricDecimation_SetAutoAddCandidates, METH_VARARGS,
   "V.SetAutoAddCandidates(int)\nC++: void SetAutoAddCandidates(int a)\n\nEnable(1)/Disable(0) the feature of temporarily doubling the\nnumber of candidates for each randomized set if the quadric error\nwas significantly increased over the last edge collapse, i.e. if\nthe ratio between the error difference and the last error is over\nsome threshold. Basically, we are trying to make up for cases\nwhen random selection returns so many 'bad' edges. By doing this\nwe can achieve a higher quality output with much less time than\njust double the NumberOfCandidates. Default is Enabled(1)\n"},
  {"GetAutoAddCandidates", PyvtkUnstructuredGridQuadricDecimation_GetAutoAddCandidates, METH_VARARGS,
   "V.GetAutoAddCandidates() -> int\nC++: int GetAutoAddCandidates()\n\nEnable(1)/Disable(0) the feature of temporarily doubling the\nnumber of candidates for each randomized set if the quadric error\nwas significantly increased over the last edge collapse, i.e. if\nthe ratio between the error difference and the last error is over\nsome threshold. Basically, we are trying to make up for cases\nwhen random selection returns so many 'bad' edges. By doing this\nwe can achieve a higher quality output with much less time than\njust double the NumberOfCandidates. Default is Enabled(1)\n"},
  {"SetAutoAddCandidatesThreshold", PyvtkUnstructuredGridQuadricDecimation_SetAutoAddCandidatesThreshold, METH_VARARGS,
   "V.SetAutoAddCandidatesThreshold(float)\nC++: void SetAutoAddCandidatesThreshold(double a)\n\nSet/Get the threshold that decides when to double the set size.\nDefault is 0.4.\n"},
  {"GetAutoAddCandidatesThreshold", PyvtkUnstructuredGridQuadricDecimation_GetAutoAddCandidatesThreshold, METH_VARARGS,
   "V.GetAutoAddCandidatesThreshold() -> float\nC++: double GetAutoAddCandidatesThreshold()\n\nSet/Get the threshold that decides when to double the set size.\nDefault is 0.4.\n"},
  {"SetBoundaryWeight", PyvtkUnstructuredGridQuadricDecimation_SetBoundaryWeight, METH_VARARGS,
   "V.SetBoundaryWeight(float)\nC++: void SetBoundaryWeight(double a)\n\nSet/Get the weight of the boundary on the quadric metrics. The\nlarger the number, the better the boundary is preserved.\n"},
  {"GetBoundaryWeight", PyvtkUnstructuredGridQuadricDecimation_GetBoundaryWeight, METH_VARARGS,
   "V.GetBoundaryWeight() -> float\nC++: double GetBoundaryWeight()\n\nSet/Get the weight of the boundary on the quadric metrics. The\nlarger the number, the better the boundary is preserved.\n"},
  {"SetScalarsName", PyvtkUnstructuredGridQuadricDecimation_SetScalarsName, METH_VARARGS,
   "V.SetScalarsName(string)\nC++: void SetScalarsName(char *)\n\nSet/Get the scalar field name used for simplification\n"},
  {"GetScalarsName", PyvtkUnstructuredGridQuadricDecimation_GetScalarsName, METH_VARARGS,
   "V.GetScalarsName() -> string\nC++: char *GetScalarsName()\n\nSet/Get the scalar field name used for simplification\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkUnstructuredGridQuadricDecimation_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersCorePython.vtkUnstructuredGridQuadricDecimation", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkUnstructuredGridQuadricDecimation_StaticNew()
{
  return vtkUnstructuredGridQuadricDecimation::New();
}

PyObject *PyvtkUnstructuredGridQuadricDecimation_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkUnstructuredGridQuadricDecimation_Type, PyvtkUnstructuredGridQuadricDecimation_Methods,
    "vtkUnstructuredGridQuadricDecimation",
    PyvtkUnstructuredGridQuadricDecimation_Doc(), &PyvtkUnstructuredGridQuadricDecimation_StaticNew);

  PyTypeObject *pytype = &PyvtkUnstructuredGridQuadricDecimation_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUnstructuredGridAlgorithm_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 4; c++)
  {
    static const struct { const char *name; int value; }
      constants[4] = {
        { "NO_ERROR", vtkUnstructuredGridQuadricDecimation::NO_ERROR },
        { "NON_TETRAHEDRA", vtkUnstructuredGridQuadricDecimation::NON_TETRAHEDRA },
        { "NO_SCALARS", vtkUnstructuredGridQuadricDecimation::NO_SCALARS },
        { "NO_CELLS", vtkUnstructuredGridQuadricDecimation::NO_CELLS },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkUnstructuredGridQuadricDecimation_Doc()
{
  static const char *docstring[] = {
    "vtkUnstructuredGridQuadricDecimation - reduce the number of\ntetrahedra in a mesh\n\n",
    "Superclass: vtkUnstructuredGridAlgorithm\n\n",
    "vtkUnstructuredGridQuadricDecimation is a class that simplifies\ntetrahedral meshes using randomized multiple choice edge collapses.\nThe input to this filter is a vtkUnstructuredGrid object with a\nsingle scalar field (specifying in the ScalarsName attribute). Users\ncan determine the size of the output mesh by either setting the value\nof TargetReduction or NumberOfTetsOutput. The BoundaryWeight can ",
    "be\nset to control how well the mesh boundary should be preserved. The\nimplementation uses Michael Garland's generalized Quadric Error\nMetrics, the Corner Table representation and the Standard Conjugate\nGradient Method to order the edge collapse sequence.\n\nInstead of using the traditional priority queue, the algorithm uses a\nrandomized approach to yield faster performance with comparable\nquality. A",
    "t each step, a set of 8 random candidate edges are examined\nto select the best edge to collapse. This number can also be changed\nby users through NumberOfCandidates.\n\nFor more information as well as the streaming version of this\nalgorithm see:\n\n\"Streaming Simplification of Tetrahedral Meshes\" by H. T. Vo, S. P.\nCallahan, P. Lindstrom, V. Pascucci and C. T. Silva, IEEE\nTransactions on Visualization",
    " and Computer Graphics, 13(1):145-155,\n2007.\n\n@par Acknowledgments: This code was developed by Huy T. Vo under the\nsupervision of Prof. Claudio T. Silva. The code also contains\ncontributions from Peter Lindstrom and Steven P. Callahan.\n\n@par Acknowledgments: The work was supported by grants, contracts,\nand gifts from the National Science Foundation, the Department of\nEnergy and IBM.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkUnstructuredGridQuadricDecimation(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkUnstructuredGridQuadricDecimation_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkUnstructuredGridQuadricDecimation", o) != 0)
  {
    Py_DECREF(o);
  }

}

