// python wrapper for vtkValuePass
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkValuePass.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkValuePass(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkValuePass_ClassNew(); }

#ifndef DECLARED_PyvtkDefaultPass_ClassNew
extern "C" { PyObject *PyvtkDefaultPass_ClassNew(); }
#define DECLARED_PyvtkDefaultPass_ClassNew
#endif

static const char **PyvtkValuePass_Doc();

static PyTypeObject PyvtkValuePass_Mode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkValuePass.Mode", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkValuePass_Mode_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkValuePass_Mode_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkValuePass_Mode_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}


static PyObject *
PyvtkValuePass_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkValuePass::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkValuePass::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkValuePass *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkValuePass::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkValuePass *tempr = vtkValuePass::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_RENDER_VALUES(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "RENDER_VALUES");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkValuePass::RENDER_VALUES();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_SetRenderingMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRenderingMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRenderingMode(temp0);
    }
    else
    {
      op->vtkValuePass::SetRenderingMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_GetRenderingMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRenderingMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetRenderingMode() :
      op->vtkValuePass::GetRenderingMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_SetInputArrayToProcess_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputArrayToProcess");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetInputArrayToProcess(temp0, temp1);
    }
    else
    {
      op->vtkValuePass::SetInputArrayToProcess(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkValuePass_SetInputArrayToProcess_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputArrayToProcess");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetInputArrayToProcess(temp0, temp1);
    }
    else
    {
      op->vtkValuePass::SetInputArrayToProcess(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkValuePass_SetInputArrayToProcess_Methods[] = {
  {NULL, PyvtkValuePass_SetInputArrayToProcess_s1, METH_VARARGS,
   "@iz"},
  {NULL, PyvtkValuePass_SetInputArrayToProcess_s2, METH_VARARGS,
   "@ii"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkValuePass_SetInputArrayToProcess(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkValuePass_SetInputArrayToProcess_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetInputArrayToProcess");
  return NULL;
}



static PyObject *
PyvtkValuePass_SetInputComponentToProcess(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputComponentToProcess");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetInputComponentToProcess(temp0);
    }
    else
    {
      op->vtkValuePass::SetInputComponentToProcess(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_SetScalarRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  double temp0;
  double temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetScalarRange(temp0, temp1);
    }
    else
    {
      op->vtkValuePass::SetScalarRange(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_SCALAR_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkValuePass::SCALAR_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_ARRAY_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkValuePass::ARRAY_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_ARRAY_ID(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_ID");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkValuePass::ARRAY_ID();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_ARRAY_NAME(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_NAME");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationStringKey *tempr = vtkValuePass::ARRAY_NAME();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_ARRAY_COMPONENT(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_COMPONENT");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkValuePass::ARRAY_COMPONENT();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_SCALAR_RANGE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_RANGE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationDoubleVectorKey *tempr = vtkValuePass::SCALAR_RANGE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_RELOAD_DATA(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "RELOAD_DATA");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkValuePass::RELOAD_DATA();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_GetFloatImageDataArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFloatImageDataArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  vtkRenderer *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderer"))
  {
    vtkFloatArray *tempr = (ap.IsBound() ?
      op->GetFloatImageDataArray(temp0) :
      op->vtkValuePass::GetFloatImageDataArray(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_GetFloatImageData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFloatImageData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  int temp0;
  int temp1;
  int temp2;
  void  *temp3 = NULL;
  Py_buffer pbuf3 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetBuffer(temp3, &pbuf3))
  {
    if (ap.IsBound())
    {
      op->GetFloatImageData(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkValuePass::GetFloatImageData(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf3.obj != 0)
  {
    PyBuffer_Release(&pbuf3);
  }
#endif
  return result;
}


static PyObject *
PyvtkValuePass_GetFloatImageExtents(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFloatImageExtents");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetFloatImageExtents() :
      op->vtkValuePass::GetFloatImageExtents());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePass_IsFloatingPointModeSupported(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsFloatingPointModeSupported");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePass *op = static_cast<vtkValuePass *>(vp);

  vtkRenderWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindow"))
  {
    bool tempr = (ap.IsBound() ?
      op->IsFloatingPointModeSupported(temp0) :
      op->vtkValuePass::IsFloatingPointModeSupported(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkValuePass_Methods[] = {
  {"GetClassName", PyvtkValuePass_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkValuePass_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkValuePass_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkValuePass\nC++: vtkValuePass *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkValuePass_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkValuePass\nC++: vtkValuePass *SafeDownCast(vtkObject* o)\n\n"},
  {"RENDER_VALUES", PyvtkValuePass_RENDER_VALUES, METH_VARARGS,
   "V.RENDER_VALUES() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *RENDER_VALUES()\n\n"},
  {"SetRenderingMode", PyvtkValuePass_SetRenderingMode, METH_VARARGS,
   "V.SetRenderingMode(int)\nC++: void SetRenderingMode(int a)\n\n"},
  {"GetRenderingMode", PyvtkValuePass_GetRenderingMode, METH_VARARGS,
   "V.GetRenderingMode() -> int\nC++: int GetRenderingMode()\n\n"},
  {"SetInputArrayToProcess", PyvtkValuePass_SetInputArrayToProcess, METH_VARARGS,
   "V.SetInputArrayToProcess(int, string)\nC++: void SetInputArrayToProcess(int fieldAssociation,\n    const char *name)\nV.SetInputArrayToProcess(int, int)\nC++: void SetInputArrayToProcess(int fieldAssociation,\n    int fieldAttributeType)\n\n"},
  {"SetInputComponentToProcess", PyvtkValuePass_SetInputComponentToProcess, METH_VARARGS,
   "V.SetInputComponentToProcess(int)\nC++: void SetInputComponentToProcess(int component)\n\n"},
  {"SetScalarRange", PyvtkValuePass_SetScalarRange, METH_VARARGS,
   "V.SetScalarRange(float, float)\nC++: void SetScalarRange(double min, double max)\n\n"},
  {"SCALAR_MODE", PyvtkValuePass_SCALAR_MODE, METH_VARARGS,
   "V.SCALAR_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SCALAR_MODE()\n\nPassed down the rendering pipeline to control what data array to\ndraw.\n"},
  {"ARRAY_MODE", PyvtkValuePass_ARRAY_MODE, METH_VARARGS,
   "V.ARRAY_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *ARRAY_MODE()\n\nPassed down the rendering pipeline to control what data array to\ndraw.\n"},
  {"ARRAY_ID", PyvtkValuePass_ARRAY_ID, METH_VARARGS,
   "V.ARRAY_ID() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *ARRAY_ID()\n\nPassed down the rendering pipeline to control what data array to\ndraw.\n"},
  {"ARRAY_NAME", PyvtkValuePass_ARRAY_NAME, METH_VARARGS,
   "V.ARRAY_NAME() -> vtkInformationStringKey\nC++: static vtkInformationStringKey *ARRAY_NAME()\n\nPassed down the rendering pipeline to control what data array to\ndraw.\n"},
  {"ARRAY_COMPONENT", PyvtkValuePass_ARRAY_COMPONENT, METH_VARARGS,
   "V.ARRAY_COMPONENT() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *ARRAY_COMPONENT()\n\nPassed down the rendering pipeline to control what data array to\ndraw.\n"},
  {"SCALAR_RANGE", PyvtkValuePass_SCALAR_RANGE, METH_VARARGS,
   "V.SCALAR_RANGE() -> vtkInformationDoubleVectorKey\nC++: static vtkInformationDoubleVectorKey *SCALAR_RANGE()\n\nPassed down the rendering pipeline to control what data array to\ndraw.\n"},
  {"RELOAD_DATA", PyvtkValuePass_RELOAD_DATA, METH_VARARGS,
   "V.RELOAD_DATA() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *RELOAD_DATA()\n\nPassed down the rendering pipeline to control what data array to\ndraw.\n"},
  {"GetFloatImageDataArray", PyvtkValuePass_GetFloatImageDataArray, METH_VARARGS,
   "V.GetFloatImageDataArray(vtkRenderer) -> vtkFloatArray\nC++: vtkFloatArray *GetFloatImageDataArray(vtkRenderer *ren)\n\nInterface to get the rendered image in FLOATING_POINT mode. \nReturns a single component array containing the rendered values. \nThe returned array is owned by vtkValuePass so it is intended to\nbe deep copied.\n"},
  {"GetFloatImageData", PyvtkValuePass_GetFloatImageData, METH_VARARGS,
   "V.GetFloatImageData(int, int, int, void)\nC++: void GetFloatImageData(int const format, int const width,\n    int const height, void *data)\n\nInterface to get the rendered image in FLOATING_POINT mode.  Low\nlevel API, a format for the internal glReadPixels call can be\nspecified. 'data' is expected to be allocated and cleaned-up by\nthe caller.\n"},
  {"GetFloatImageExtents", PyvtkValuePass_GetFloatImageExtents, METH_VARARGS,
   "V.GetFloatImageExtents() -> (int, ...)\nC++: int *GetFloatImageExtents()\n\nInterface to get the rendered image in FLOATING_POINT mode. \nImage extents of the value array.\n"},
  {"IsFloatingPointModeSupported", PyvtkValuePass_IsFloatingPointModeSupported, METH_VARARGS,
   "V.IsFloatingPointModeSupported(vtkRenderWindow) -> bool\nC++: bool IsFloatingPointModeSupported(vtkRenderWindow *renWin)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkValuePass_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGL2Python.vtkValuePass", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkValuePass_StaticNew()
{
  return vtkValuePass::New();
}

PyObject *PyvtkValuePass_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkValuePass_Type, PyvtkValuePass_Methods,
    "vtkValuePass",
    PyvtkValuePass_Doc(), &PyvtkValuePass_StaticNew);

  PyTypeObject *pytype = &PyvtkValuePass_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDefaultPass_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkValuePass_Mode_Type);
  PyvtkValuePass_Mode_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkValuePass_Mode_Type);

  o = (PyObject *)&PyvtkValuePass_Mode_Type;
  if (PyDict_SetItemString(d, "Mode", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 2; c++)
  {
    typedef vtkValuePass::Mode cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "INVERTIBLE_LUT", vtkValuePass::INVERTIBLE_LUT },
        { "FLOATING_POINT", vtkValuePass::FLOATING_POINT },
      };

    o = PyvtkValuePass_Mode_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkValuePass_Doc()
{
  static const char *docstring[] = {
    "vtkValuePass - Renders geometry using the values of a field array as\nfragment colors.\n\n",
    "Superclass: vtkDefaultPass\n\n",
    "The output can be used for deferred color mapping. It supports using\narrays of either point or cell data. The target array can be selected\nby setting an array name/id and a component number. Only opaque\ngeometry is supported.\n\nThere are two rendering modes available:\n\n* INVERTIBLE_LUT  Encodes array values as RGB data and renders the\n  result to the default framebuffer.\n\n* FLOATING_POINT  Renders ",
    "actual array values as floating point data\n  to an internal RGBA32F framebuffer.  This class binds and unbinds\n  the framebuffer on each render pass.\n\n@sa\nvtkRenderPass vtkDefaultPass vtkValuePassHelper vtkMapper\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkValuePass(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkValuePass_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkValuePass", o) != 0)
  {
    Py_DECREF(o);
  }

}

