// python wrapper for vtkVersion
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkVersion.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkVersion(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkVersion_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkVersion_Doc();


static PyObject *
PyvtkVersion_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVersion *op = static_cast<vtkVersion *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkVersion::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVersion_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVersion *op = static_cast<vtkVersion *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkVersion::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVersion_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVersion *op = static_cast<vtkVersion *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVersion *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkVersion::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkVersion_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkVersion *tempr = vtkVersion::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVersion_GetVTKVersion(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetVTKVersion");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    const char *tempr = vtkVersion::GetVTKVersion();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVersion_GetVTKMajorVersion(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetVTKMajorVersion");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    int tempr = vtkVersion::GetVTKMajorVersion();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVersion_GetVTKMinorVersion(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetVTKMinorVersion");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    int tempr = vtkVersion::GetVTKMinorVersion();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVersion_GetVTKBuildVersion(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetVTKBuildVersion");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    int tempr = vtkVersion::GetVTKBuildVersion();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVersion_GetVTKSourceVersion(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetVTKSourceVersion");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    const char *tempr = vtkVersion::GetVTKSourceVersion();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkVersion_Methods[] = {
  {"GetClassName", PyvtkVersion_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkVersion_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkVersion_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkVersion\nC++: vtkVersion *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkVersion_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkVersion\nC++: vtkVersion *SafeDownCast(vtkObject* o)\n\n"},
  {"GetVTKVersion", PyvtkVersion_GetVTKVersion, METH_VARARGS,
   "V.GetVTKVersion() -> string\nC++: static const char *GetVTKVersion()\n\nReturn the version of vtk this object is a part of. A variety of\nmethods are included. GetVTKSourceVersion returns a string with\nan identifier which timestamps a particular source tree.\n"},
  {"GetVTKMajorVersion", PyvtkVersion_GetVTKMajorVersion, METH_VARARGS,
   "V.GetVTKMajorVersion() -> int\nC++: static int GetVTKMajorVersion()\n\n"},
  {"GetVTKMinorVersion", PyvtkVersion_GetVTKMinorVersion, METH_VARARGS,
   "V.GetVTKMinorVersion() -> int\nC++: static int GetVTKMinorVersion()\n\n"},
  {"GetVTKBuildVersion", PyvtkVersion_GetVTKBuildVersion, METH_VARARGS,
   "V.GetVTKBuildVersion() -> int\nC++: static int GetVTKBuildVersion()\n\n"},
  {"GetVTKSourceVersion", PyvtkVersion_GetVTKSourceVersion, METH_VARARGS,
   "V.GetVTKSourceVersion() -> string\nC++: static const char *GetVTKSourceVersion()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkVersion_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkVersion", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkVersion_StaticNew()
{
  return vtkVersion::New();
}

PyObject *PyvtkVersion_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkVersion_Type, PyvtkVersion_Methods,
    "vtkVersion",
    PyvtkVersion_Doc(), &PyvtkVersion_StaticNew);

  PyTypeObject *pytype = &PyvtkVersion_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkVersion_Doc()
{
  static const char *docstring[] = {
    "vtkVersion - Versioning class for vtk\n\n",
    "Superclass: vtkObject\n\n",
    "Holds methods for defining/determining the current vtk version\n(major, minor, build).\n\n@warning\nThis file will change frequently to update the VTKSourceVersion which\ntimestamps a particular source release.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkVersion(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkVersion_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkVersion", o) != 0)
  {
    Py_DECREF(o);
  }

  o = PyString_FromString((char *)("vtk version " VTK_VERSION));
  if (o)
  {
    PyDict_SetItemString(dict, "VTK_SOURCE_VERSION", o);
    Py_DECREF(o);
  }
}

