// python wrapper for vtkViewUpdater
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkViewUpdater.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkViewUpdater(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkViewUpdater_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkViewUpdater_Doc();


static PyObject *
PyvtkViewUpdater_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkViewUpdater *op = static_cast<vtkViewUpdater *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkViewUpdater::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkViewUpdater_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkViewUpdater *op = static_cast<vtkViewUpdater *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkViewUpdater::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkViewUpdater_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkViewUpdater *op = static_cast<vtkViewUpdater *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkViewUpdater *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkViewUpdater::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkViewUpdater_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkViewUpdater *tempr = vtkViewUpdater::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkViewUpdater_AddView(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddView");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkViewUpdater *op = static_cast<vtkViewUpdater *>(vp);

  vtkView *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkView"))
  {
    if (ap.IsBound())
    {
      op->AddView(temp0);
    }
    else
    {
      op->vtkViewUpdater::AddView(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkViewUpdater_RemoveView(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveView");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkViewUpdater *op = static_cast<vtkViewUpdater *>(vp);

  vtkView *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkView"))
  {
    if (ap.IsBound())
    {
      op->RemoveView(temp0);
    }
    else
    {
      op->vtkViewUpdater::RemoveView(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkViewUpdater_AddAnnotationLink(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddAnnotationLink");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkViewUpdater *op = static_cast<vtkViewUpdater *>(vp);

  vtkAnnotationLink *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAnnotationLink"))
  {
    if (ap.IsBound())
    {
      op->AddAnnotationLink(temp0);
    }
    else
    {
      op->vtkViewUpdater::AddAnnotationLink(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkViewUpdater_Methods[] = {
  {"GetClassName", PyvtkViewUpdater_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkViewUpdater_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkViewUpdater_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkViewUpdater\nC++: vtkViewUpdater *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkViewUpdater_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkViewUpdater\nC++: vtkViewUpdater *SafeDownCast(vtkObject* o)\n\n"},
  {"AddView", PyvtkViewUpdater_AddView, METH_VARARGS,
   "V.AddView(vtkView)\nC++: void AddView(vtkView *view)\n\n"},
  {"RemoveView", PyvtkViewUpdater_RemoveView, METH_VARARGS,
   "V.RemoveView(vtkView)\nC++: void RemoveView(vtkView *view)\n\n"},
  {"AddAnnotationLink", PyvtkViewUpdater_AddAnnotationLink, METH_VARARGS,
   "V.AddAnnotationLink(vtkAnnotationLink)\nC++: void AddAnnotationLink(vtkAnnotationLink *link)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkViewUpdater_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkViewUpdater", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkViewUpdater_StaticNew()
{
  return vtkViewUpdater::New();
}

PyObject *PyvtkViewUpdater_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkViewUpdater_Type, PyvtkViewUpdater_Methods,
    "vtkViewUpdater",
    PyvtkViewUpdater_Doc(), &PyvtkViewUpdater_StaticNew);

  PyTypeObject *pytype = &PyvtkViewUpdater_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkViewUpdater_Doc()
{
  static const char *docstring[] = {
    "vtkViewUpdater - Updates views automatically\n\n",
    "Superclass: vtkObject\n\n",
    "vtkViewUpdater registers with annotation change events for a set of\nannotation links, and updates all views when an annotation link fires\nan annotation changed event. This is often needed when multiple views\nshare a selection with vtkAnnotationLink.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkViewUpdater(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkViewUpdater_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkViewUpdater", o) != 0)
  {
    Py_DECREF(o);
  }

}

