// python wrapper for vtkVolumeCollection
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkVolumeCollection.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkVolumeCollection(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkVolumeCollection_ClassNew(); }

#ifndef DECLARED_PyvtkPropCollection_ClassNew
extern "C" { PyObject *PyvtkPropCollection_ClassNew(); }
#define DECLARED_PyvtkPropCollection_ClassNew
#endif

static const char **PyvtkVolumeCollection_Doc();


static PyObject *
PyvtkVolumeCollection_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeCollection *op = static_cast<vtkVolumeCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkVolumeCollection::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeCollection_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeCollection *op = static_cast<vtkVolumeCollection *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkVolumeCollection::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeCollection_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeCollection *op = static_cast<vtkVolumeCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVolumeCollection *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkVolumeCollection::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeCollection_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkVolumeCollection *tempr = vtkVolumeCollection::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeCollection_AddItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeCollection *op = static_cast<vtkVolumeCollection *>(vp);

  vtkVolume *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkVolume"))
  {
    if (ap.IsBound())
    {
      op->AddItem(temp0);
    }
    else
    {
      op->vtkVolumeCollection::AddItem(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeCollection_GetNextVolume(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextVolume");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeCollection *op = static_cast<vtkVolumeCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVolume *tempr = (ap.IsBound() ?
      op->GetNextVolume() :
      op->vtkVolumeCollection::GetNextVolume());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeCollection_GetNextItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeCollection *op = static_cast<vtkVolumeCollection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVolume *tempr = (ap.IsBound() ?
      op->GetNextItem() :
      op->vtkVolumeCollection::GetNextItem());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkVolumeCollection_Methods[] = {
  {"GetClassName", PyvtkVolumeCollection_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkVolumeCollection_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkVolumeCollection_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkVolumeCollection\nC++: vtkVolumeCollection *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkVolumeCollection_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkVolumeCollection\nC++: vtkVolumeCollection *SafeDownCast(vtkObject* o)\n\n"},
  {"AddItem", PyvtkVolumeCollection_AddItem, METH_VARARGS,
   "V.AddItem(vtkVolume)\nC++: void AddItem(vtkVolume *a)\n\nAdd a Volume to the list.\n"},
  {"GetNextVolume", PyvtkVolumeCollection_GetNextVolume, METH_VARARGS,
   "V.GetNextVolume() -> vtkVolume\nC++: vtkVolume *GetNextVolume()\n\nGet the next Volume in the list. Return NULL when at the end of\nthe list.\n"},
  {"GetNextItem", PyvtkVolumeCollection_GetNextItem, METH_VARARGS,
   "V.GetNextItem() -> vtkVolume\nC++: vtkVolume *GetNextItem()\n\nAccess routine provided for compatibility with previous versions\nof VTK.  Please use the GetNextVolume() variant where possible.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkVolumeCollection_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingCorePython.vtkVolumeCollection", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkVolumeCollection_StaticNew()
{
  return vtkVolumeCollection::New();
}

PyObject *PyvtkVolumeCollection_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkVolumeCollection_Type, PyvtkVolumeCollection_Methods,
    "vtkVolumeCollection",
    PyvtkVolumeCollection_Doc(), &PyvtkVolumeCollection_StaticNew);

  PyTypeObject *pytype = &PyvtkVolumeCollection_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPropCollection_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkVolumeCollection_Doc()
{
  static const char *docstring[] = {
    "vtkVolumeCollection - a list of volumes\n\n",
    "Superclass: vtkPropCollection\n\n",
    "vtkVolumeCollection represents and provides methods to manipulate a\nlist of volumes (i.e., vtkVolume and subclasses). The list is\nunsorted and duplicate entries are not prevented.\n\n@sa\nvtkCollection vtkVolume\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkVolumeCollection(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkVolumeCollection_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkVolumeCollection", o) != 0)
  {
    Py_DECREF(o);
  }

}

