// python wrapper for vtkVolumeRayCastFunction
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkVolumeRayCastFunction.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkVolumeRayCastFunction(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkVolumeRayCastFunction_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkVolumeRayCastFunction_Doc();


static PyObject *
PyvtkVolumeRayCastFunction_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastFunction *op = static_cast<vtkVolumeRayCastFunction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkVolumeRayCastFunction::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastFunction_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastFunction *op = static_cast<vtkVolumeRayCastFunction *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkVolumeRayCastFunction::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastFunction_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastFunction *op = static_cast<vtkVolumeRayCastFunction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVolumeRayCastFunction *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkVolumeRayCastFunction::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastFunction_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkVolumeRayCastFunction *tempr = vtkVolumeRayCastFunction::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastFunction_FunctionInitialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FunctionInitialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastFunction *op = static_cast<vtkVolumeRayCastFunction *>(vp);

  vtkRenderer *temp0 = NULL;
  vtkVolume *temp1 = NULL;
  vtkVolumeRayCastStaticInfo *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkRenderer") &&
      ap.GetVTKObject(temp1, "vtkVolume") &&
      ap.GetVTKObject(temp2, "vtkVolumeRayCastStaticInfo"))
  {
    if (ap.IsBound())
    {
      op->FunctionInitialize(temp0, temp1, temp2);
    }
    else
    {
      op->vtkVolumeRayCastFunction::FunctionInitialize(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastFunction_CastRay(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CastRay");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastFunction *op = static_cast<vtkVolumeRayCastFunction *>(vp);

  vtkVolumeRayCastDynamicInfo *temp0 = NULL;
  vtkVolumeRayCastStaticInfo *temp1 = NULL;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkVolumeRayCastDynamicInfo") &&
      ap.GetVTKObject(temp1, "vtkVolumeRayCastStaticInfo"))
  {
    op->CastRay(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastFunction_GetZeroOpacityThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetZeroOpacityThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastFunction *op = static_cast<vtkVolumeRayCastFunction *>(vp);

  vtkVolume *temp0 = NULL;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkVolume"))
  {
    float tempr = op->GetZeroOpacityThreshold(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkVolumeRayCastFunction_Methods[] = {
  {"GetClassName", PyvtkVolumeRayCastFunction_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkVolumeRayCastFunction_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkVolumeRayCastFunction_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkVolumeRayCastFunction\nC++: vtkVolumeRayCastFunction *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkVolumeRayCastFunction_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkVolumeRayCastFunction\nC++: vtkVolumeRayCastFunction *SafeDownCast(vtkObject* o)\n\n"},
  {"FunctionInitialize", PyvtkVolumeRayCastFunction_FunctionInitialize, METH_VARARGS,
   "V.FunctionInitialize(vtkRenderer, vtkVolume,\n    vtkVolumeRayCastStaticInfo)\nC++: void FunctionInitialize(vtkRenderer *ren, vtkVolume *vol,\n    vtkVolumeRayCastStaticInfo *staticInfo)\n\nDo the basic initialization. This includes saving the parameters\npassed in into local variables, as well as grabbing some useful\ninfo from the volume property and normal encoder. This initialize\nroutine is called once per render. It also calls the\nSpecificFunctionInitialize of the subclass function.\n"},
  {"CastRay", PyvtkVolumeRayCastFunction_CastRay, METH_VARARGS,
   "V.CastRay(vtkVolumeRayCastDynamicInfo, vtkVolumeRayCastStaticInfo)\nC++: virtual void CastRay(\n    vtkVolumeRayCastDynamicInfo *dynamicInfo,\n    vtkVolumeRayCastStaticInfo *staticInfo)\n\n"},
  {"GetZeroOpacityThreshold", PyvtkVolumeRayCastFunction_GetZeroOpacityThreshold, METH_VARARGS,
   "V.GetZeroOpacityThreshold(vtkVolume) -> float\nC++: virtual float GetZeroOpacityThreshold(vtkVolume *vol)\n\nGet the value below which all scalar values are considered to\nhave 0 opacity.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkVolumeRayCastFunction_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingVolumePython.vtkVolumeRayCastFunction", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkVolumeRayCastFunction_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkVolumeRayCastFunction_Type, PyvtkVolumeRayCastFunction_Methods,
    "vtkVolumeRayCastFunction",
    PyvtkVolumeRayCastFunction_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkVolumeRayCastFunction_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkVolumeRayCastFunction_Doc()
{
  static const char *docstring[] = {
    "vtkVolumeRayCastFunction - a superclass for ray casting functions\n\n",
    "Superclass: vtkObject\n\n",
    "vtkVolumeRayCastFunction is a superclass for ray casting functions\nthat can be used within a vtkVolumeRayCastMapper. This includes for\nexample, vtkVolumeRayCastCompositeFunction,\nvtkVolumeRayCastMIPFunction, and vtkVolumeRayCastIsosurfaceFunction.\n\n@sa\nvtkVolumeRayCastCompositeFunction vtkVolumeRayCastMIPFunction\nvtkVolumeRayCastIsosurfaceFunction vtkVolumeRayCastMapper@deprecated\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkVolumeRayCastFunction(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkVolumeRayCastFunction_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkVolumeRayCastFunction", o) != 0)
  {
    Py_DECREF(o);
  }

}

