// tcl wrapper for vtkPolarAxesActor object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPolarAxesActor.h"

#include "vtkTclUtil.h"
#include "vtkStdString.h"
#include <stdexcept>
#include <sstream>

ClientData vtkPolarAxesActorNewCommand()
{
  vtkPolarAxesActor *temp = vtkPolarAxesActor::New();
  return static_cast<ClientData>(temp);
}

int vtkActorCppCommand(vtkActor *op, Tcl_Interp *interp,
             int argc, char *argv[]);
int VTKTCL_EXPORT vtkPolarAxesActorCppCommand(vtkPolarAxesActor *op, Tcl_Interp *interp,
             int argc, char *argv[]);

int vtkPolarAxesActorCommand(ClientData cd, Tcl_Interp *interp,
             int argc, char *argv[])
{
  if ((argc == 2)&&(!strcmp("Delete",argv[1]))&& !vtkTclInDelete(interp))
  {
    Tcl_DeleteCommand(interp,argv[0]);
    return TCL_OK;
  }
   return vtkPolarAxesActorCppCommand(static_cast<vtkPolarAxesActor *>(static_cast<vtkTclCommandArgStruct *>(cd)->Pointer),interp, argc, argv);
}

int VTKTCL_EXPORT vtkPolarAxesActor_TclCreate(Tcl_Interp *interp)
{
  vtkTclCreateNew(interp,const_cast<char *>("vtkPolarAxesActor"),vtkPolarAxesActorNewCommand,vtkPolarAxesActorCommand);
  return 0;
}

int VTKTCL_EXPORT vtkPolarAxesActorCppCommand(vtkPolarAxesActor *op, Tcl_Interp *interp,
             int argc, char *argv[])
{
  int    tempi = 0;      (void)tempi;
  double tempd = 0.0;    (void)tempd;
  static char temps[80]; (void)temps;
  int    error = 0;      (void)error;
  temps[0] = 0;

  if (argc < 2)
  {
    Tcl_SetResult(interp,const_cast<char *>("Could not find requested method."), TCL_VOLATILE);
    return TCL_ERROR;
  }
  if (!interp)
  {
    if (!strcmp("DoTypecasting",argv[0]))
    {
      if (!strcmp("vtkPolarAxesActor",argv[1]))
      {
        argv[2] = static_cast<char *>(static_cast<void *>(op));
        return TCL_OK;
      }
      if (vtkActorCppCommand(static_cast<vtkActor *>(op),interp,argc,argv) == TCL_OK)
      {
        return TCL_OK;
      }
    }
    return TCL_ERROR;
  }

  if (!strcmp("GetSuperClassName",argv[1]))
  {
    Tcl_SetResult(interp,const_cast<char *>("vtkActor"), TCL_VOLATILE);
    return TCL_OK;
  }

  try
  {
  if ((!strcmp("GetClassName",argv[1]))&&(argc == 2))
  {
    const char    *temp20;
    temp20 = (op)->GetClassName();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("IsA",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    int      temp20;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    temp20 = (op)->IsA(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("NewInstance",argv[1]))&&(argc == 2))
  {
    vtkPolarAxesActor  *temp20;
    temp20 = (op)->NewInstance();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPolarAxesActor");
    return TCL_OK;
  }
  if ((!strcmp("SafeDownCast",argv[1]))&&(argc == 3))
  {
    vtkObject  *temp0;
    vtkPolarAxesActor  *temp20;
    error = 0;

    temp0 = (vtkObject *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkObject"),interp,error));
    if (!error)
  {
    temp20 = (op)->SafeDownCast(temp0);
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPolarAxesActor");
    return TCL_OK;
  }
  }
  if ((!strcmp("New",argv[1]))&&(argc == 2))
  {
    vtkPolarAxesActor  *temp20;
    temp20 = (op)->New();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkPolarAxesActor");
    return TCL_OK;
  }
  if ((!strcmp("RenderOpaqueGeometry",argv[1]))&&(argc == 3))
  {
    vtkViewport  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkViewport *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkViewport"),interp,error));
    if (!error)
  {
    temp20 = (op)->RenderOpaqueGeometry(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("RenderOverlay",argv[1]))&&(argc == 3))
  {
    vtkViewport  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkViewport *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkViewport"),interp,error));
    if (!error)
  {
    temp20 = (op)->RenderOverlay(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("RenderTranslucentPolygonalGeometry",argv[1]))&&(argc == 3))
  {
    vtkViewport  *temp0;
    int      temp20;
    error = 0;

    temp0 = (vtkViewport *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkViewport"),interp,error));
    if (!error)
  {
    temp20 = (op)->RenderTranslucentPolygonalGeometry(temp0);
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetPole",argv[1]))&&(argc == 5))
  {
    double temp0[3];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (!error)
  {
    op->SetPole(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetPole",argv[1]))&&(argc == 5))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (!error)
  {
    op->SetPole(temp0,temp1,temp2);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPole",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetPole();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[2], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetLog",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetLog(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLog",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetLog();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("LogOn",argv[1]))&&(argc == 2))
  {
    op->LogOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("LogOff",argv[1]))&&(argc == 2))
  {
    op->LogOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetNumberOfRadialAxes",argv[1]))&&(argc == 3))
  {
    vtkIdType   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNumberOfRadialAxes(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfRadialAxes",argv[1]))&&(argc == 2))
  {
    vtkIdType   temp20;
    temp20 = (op)->GetNumberOfRadialAxes();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetNumberOfPolarAxisTicks",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetNumberOfPolarAxisTicks(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetNumberOfPolarAxisTicks",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetNumberOfPolarAxisTicks();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetAutoSubdividePolarAxis",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetAutoSubdividePolarAxis(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAutoSubdividePolarAxis",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetAutoSubdividePolarAxis();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("AutoSubdividePolarAxisOn",argv[1]))&&(argc == 2))
  {
    op->AutoSubdividePolarAxisOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("AutoSubdividePolarAxisOff",argv[1]))&&(argc == 2))
  {
    op->AutoSubdividePolarAxisOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetRange",argv[1]))&&(argc == 4))
  {
    double   temp0;
    double   temp1;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (!error)
  {
    op->SetRange(temp0,temp1);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetRange",argv[1]))&&(argc == 4))
  {
    double temp0[2];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (!error)
  {
    op->SetRange(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRange",argv[1]))&&(argc == 2))
  {
    double  *temp20;
    temp20 = (op)->GetRange();
    if(temp20)
    {
      char tempResult[1024];
      *tempResult = '\0';
      char converted[1024];
      *converted = '\0';
      Tcl_PrintDouble(interp,temp20[0], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_PrintDouble(interp,temp20[1], converted);
      strcat(tempResult, " ");
      strcat(tempResult, converted);
      Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    }
    else
    {
      Tcl_SetResult(interp, const_cast<char *>(""), TCL_VOLATILE);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetMinimumRadius",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetMinimumRadius(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMinimumRadius",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetMinimumRadius();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetMaximumRadius",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetMaximumRadius(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMaximumRadius",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetMaximumRadius();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetAutoScaleRadius",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetAutoScaleRadius(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAutoScaleRadius",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetAutoScaleRadius();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetMinimumAngle",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetMinimumAngle(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMinimumAngle",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetMinimumAngle();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetMaximumAngle",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetMaximumAngle(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetMaximumAngle",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetMaximumAngle();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetSmallestVisiblePolarAngle",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetSmallestVisiblePolarAngle(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSmallestVisiblePolarAngleMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSmallestVisiblePolarAngleMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSmallestVisiblePolarAngleMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSmallestVisiblePolarAngleMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetSmallestVisiblePolarAngle",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetSmallestVisiblePolarAngle();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetTickLocation",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetTickLocation(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetTickLocationMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetTickLocationMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetTickLocationMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetTickLocationMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetTickLocation",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetTickLocation();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetRadialUnits",argv[1]))&&(argc == 3))
  {
    bool   temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi ? true : false;
    if (!error)
  {
    op->SetRadialUnits(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRadialUnits",argv[1]))&&(argc == 2))
  {
    bool   temp20;
    temp20 = (op)->GetRadialUnits();
    char tempResult[1024];
    sprintf(tempResult,"%i",(int)temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetScreenSize",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetScreenSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetScreenSize",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetScreenSize();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetCamera",argv[1]))&&(argc == 3))
  {
    vtkCamera  *temp0;
    error = 0;

    temp0 = (vtkCamera *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkCamera"),interp,error));
    if (!error)
  {
    op->SetCamera(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetCamera",argv[1]))&&(argc == 2))
  {
    vtkCamera  *temp20;
    temp20 = (op)->GetCamera();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkCamera");
    return TCL_OK;
  }
  if ((!strcmp("SetPolarAxisTitle",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetPolarAxisTitle(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarAxisTitle",argv[1]))&&(argc == 2))
  {
    char    *temp20;
    temp20 = (op)->GetPolarAxisTitle();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetPolarLabelFormat",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetPolarLabelFormat(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarLabelFormat",argv[1]))&&(argc == 2))
  {
    char    *temp20;
    temp20 = (op)->GetPolarLabelFormat();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("SetExponentLocation",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetExponentLocation(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetExponentLocationMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetExponentLocationMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetExponentLocationMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetExponentLocationMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetExponentLocation",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetExponentLocation();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetRadialAngleFormat",argv[1]))&&(argc == 3))
  {
    char    *temp0;
    error = 0;

    temp0 = argv[2];
    if (!error)
  {
    op->SetRadialAngleFormat(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRadialAngleFormat",argv[1]))&&(argc == 2))
  {
    char    *temp20;
    temp20 = (op)->GetRadialAngleFormat();
    if (temp20)
    {
      Tcl_SetResult(interp, const_cast<char *>(temp20), TCL_VOLATILE);
    }
    else
    {
      Tcl_ResetResult(interp);
    }
    return TCL_OK;
  }
  if ((!strcmp("ReleaseGraphicsResources",argv[1]))&&(argc == 3))
  {
    vtkWindow  *temp0;
    error = 0;

    temp0 = (vtkWindow *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkWindow"),interp,error));
    if (!error)
  {
    op->ReleaseGraphicsResources(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetEnableDistanceLOD",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetEnableDistanceLOD(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetEnableDistanceLOD",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetEnableDistanceLOD();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDistanceLODThreshold",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetDistanceLODThreshold(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDistanceLODThresholdMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetDistanceLODThresholdMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetDistanceLODThresholdMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetDistanceLODThresholdMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetDistanceLODThreshold",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetDistanceLODThreshold();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetEnableViewAngleLOD",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetEnableViewAngleLOD(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetEnableViewAngleLOD",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetEnableViewAngleLOD();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetViewAngleLODThreshold",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetViewAngleLODThreshold(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetViewAngleLODThresholdMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetViewAngleLODThresholdMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetViewAngleLODThresholdMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetViewAngleLODThresholdMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetViewAngleLODThreshold",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetViewAngleLODThreshold();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarAxisVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetPolarAxisVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarAxisVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetPolarAxisVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("PolarAxisVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->PolarAxisVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PolarAxisVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->PolarAxisVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetDrawRadialGridlines",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetDrawRadialGridlines(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDrawRadialGridlines",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDrawRadialGridlines();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("DrawRadialGridlinesOn",argv[1]))&&(argc == 2))
  {
    op->DrawRadialGridlinesOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("DrawRadialGridlinesOff",argv[1]))&&(argc == 2))
  {
    op->DrawRadialGridlinesOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetDrawPolarArcsGridlines",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetDrawPolarArcsGridlines(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDrawPolarArcsGridlines",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetDrawPolarArcsGridlines();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("DrawPolarArcsGridlinesOn",argv[1]))&&(argc == 2))
  {
    op->DrawPolarArcsGridlinesOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("DrawPolarArcsGridlinesOff",argv[1]))&&(argc == 2))
  {
    op->DrawPolarArcsGridlinesOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarTitleVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetPolarTitleVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarTitleVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetPolarTitleVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("PolarTitleVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->PolarTitleVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PolarTitleVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->PolarTitleVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetRadialAxisTitleLocation",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetRadialAxisTitleLocation(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRadialAxisTitleLocationMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetRadialAxisTitleLocationMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetRadialAxisTitleLocationMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetRadialAxisTitleLocationMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetRadialAxisTitleLocation",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetRadialAxisTitleLocation();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarAxisTitleLocation",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetPolarAxisTitleLocation(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarAxisTitleLocationMinValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetPolarAxisTitleLocationMinValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetPolarAxisTitleLocationMaxValue",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetPolarAxisTitleLocationMaxValue();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetPolarAxisTitleLocation",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetPolarAxisTitleLocation();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarLabelVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetPolarLabelVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarLabelVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetPolarLabelVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("PolarLabelVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->PolarLabelVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PolarLabelVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->PolarLabelVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetArcTicksOriginToPolarAxis",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetArcTicksOriginToPolarAxis(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetArcTicksOriginToPolarAxis",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetArcTicksOriginToPolarAxis();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("ArcTicksOriginToPolarAxisOn",argv[1]))&&(argc == 2))
  {
    op->ArcTicksOriginToPolarAxisOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ArcTicksOriginToPolarAxisOff",argv[1]))&&(argc == 2))
  {
    op->ArcTicksOriginToPolarAxisOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetRadialAxesOriginToPolarAxis",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetRadialAxesOriginToPolarAxis(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRadialAxesOriginToPolarAxis",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetRadialAxesOriginToPolarAxis();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("RadialAxesOriginToPolarAxisOn",argv[1]))&&(argc == 2))
  {
    op->RadialAxesOriginToPolarAxisOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("RadialAxesOriginToPolarAxisOff",argv[1]))&&(argc == 2))
  {
    op->RadialAxesOriginToPolarAxisOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarTickVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetPolarTickVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarTickVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetPolarTickVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("PolarTickVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->PolarTickVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PolarTickVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->PolarTickVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetAxisTickVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetAxisTickVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAxisTickVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetAxisTickVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("AxisTickVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->AxisTickVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("AxisTickVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->AxisTickVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetAxisMinorTickVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetAxisMinorTickVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetAxisMinorTickVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetAxisMinorTickVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("AxisMinorTickVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->AxisMinorTickVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("AxisMinorTickVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->AxisMinorTickVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetArcTickVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetArcTickVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetArcTickVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetArcTickVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("ArcTickVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->ArcTickVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ArcTickVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->ArcTickVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetArcMinorTickVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetArcMinorTickVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetArcMinorTickVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetArcMinorTickVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("ArcMinorTickVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->ArcMinorTickVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("ArcMinorTickVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->ArcMinorTickVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetArcMajorTickSize",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetArcMajorTickSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetArcMajorTickSize",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetArcMajorTickSize();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarAxisMajorTickSize",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetPolarAxisMajorTickSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarAxisMajorTickSize",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetPolarAxisMajorTickSize();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetLastRadialAxisMajorTickSize",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetLastRadialAxisMajorTickSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLastRadialAxisMajorTickSize",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetLastRadialAxisMajorTickSize();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarAxisTickRatioSize",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetPolarAxisTickRatioSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarAxisTickRatioSize",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetPolarAxisTickRatioSize();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetLastAxisTickRatioSize",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetLastAxisTickRatioSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLastAxisTickRatioSize",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetLastAxisTickRatioSize();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetArcTickRatioSize",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetArcTickRatioSize(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetArcTickRatioSize",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetArcTickRatioSize();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarAxisMajorTickThickness",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetPolarAxisMajorTickThickness(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarAxisMajorTickThickness",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetPolarAxisMajorTickThickness();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetLastRadialAxisMajorTickThickness",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetLastRadialAxisMajorTickThickness(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLastRadialAxisMajorTickThickness",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetLastRadialAxisMajorTickThickness();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetArcMajorTickThickness",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetArcMajorTickThickness(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetArcMajorTickThickness",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetArcMajorTickThickness();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarAxisTickRatioThickness",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetPolarAxisTickRatioThickness(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarAxisTickRatioThickness",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetPolarAxisTickRatioThickness();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetLastAxisTickRatioThickness",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetLastAxisTickRatioThickness(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLastAxisTickRatioThickness",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetLastAxisTickRatioThickness();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetArcTickRatioThickness",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetArcTickRatioThickness(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetArcTickRatioThickness",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetArcTickRatioThickness();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDeltaRangeMajor",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetDeltaRangeMajor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDeltaRangeMajor",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetDeltaRangeMajor();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDeltaRangeMinor",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetDeltaRangeMinor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDeltaRangeMinor",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetDeltaRangeMinor();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDeltaAngleMajor",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetDeltaAngleMajor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDeltaAngleMajor",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetDeltaAngleMajor();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDeltaAngleMinor",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetDeltaAngleMinor(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDeltaAngleMinor",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetDeltaAngleMinor();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetDeltaAngleRadialAxes",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetDeltaAngleRadialAxes(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetDeltaAngleRadialAxes",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetDeltaAngleRadialAxes();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetRadialAxesVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetRadialAxesVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRadialAxesVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetRadialAxesVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("RadialAxesVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->RadialAxesVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("RadialAxesVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->RadialAxesVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetRadialTitleVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetRadialTitleVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRadialTitleVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetRadialTitleVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("RadialTitleVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->RadialTitleVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("RadialTitleVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->RadialTitleVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarArcsVisibility",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetPolarArcsVisibility(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarArcsVisibility",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetPolarArcsVisibility();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("PolarArcsVisibilityOn",argv[1]))&&(argc == 2))
  {
    op->PolarArcsVisibilityOn();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("PolarArcsVisibilityOff",argv[1]))&&(argc == 2))
  {
    op->PolarArcsVisibilityOff();
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  if ((!strcmp("SetUse2DMode",argv[1]))&&(argc == 3))
  {
    int      temp0;
    error = 0;

    if (Tcl_GetInt(interp,argv[2],&tempi) != TCL_OK) error = 1;
    temp0 = tempi;
    if (!error)
  {
    op->SetUse2DMode(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetUse2DMode",argv[1]))&&(argc == 2))
  {
    int      temp20;
    temp20 = (op)->GetUse2DMode();
    char tempResult[1024];
    sprintf(tempResult,"%i",temp20);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("SetPolarAxisTitleTextProperty",argv[1]))&&(argc == 3))
  {
    vtkTextProperty  *temp0;
    error = 0;

    temp0 = (vtkTextProperty *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTextProperty"),interp,error));
    if (!error)
  {
    op->SetPolarAxisTitleTextProperty(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarAxisTitleTextProperty",argv[1]))&&(argc == 2))
  {
    vtkTextProperty  *temp20;
    temp20 = (op)->GetPolarAxisTitleTextProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTextProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetPolarAxisLabelTextProperty",argv[1]))&&(argc == 3))
  {
    vtkTextProperty  *temp0;
    error = 0;

    temp0 = (vtkTextProperty *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTextProperty"),interp,error));
    if (!error)
  {
    op->SetPolarAxisLabelTextProperty(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarAxisLabelTextProperty",argv[1]))&&(argc == 2))
  {
    vtkTextProperty  *temp20;
    temp20 = (op)->GetPolarAxisLabelTextProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTextProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetLastRadialAxisTextProperty",argv[1]))&&(argc == 3))
  {
    vtkTextProperty  *temp0;
    error = 0;

    temp0 = (vtkTextProperty *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTextProperty"),interp,error));
    if (!error)
  {
    op->SetLastRadialAxisTextProperty(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLastRadialAxisTextProperty",argv[1]))&&(argc == 2))
  {
    vtkTextProperty  *temp20;
    temp20 = (op)->GetLastRadialAxisTextProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTextProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetSecondaryRadialAxesTextProperty",argv[1]))&&(argc == 3))
  {
    vtkTextProperty  *temp0;
    error = 0;

    temp0 = (vtkTextProperty *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkTextProperty"),interp,error));
    if (!error)
  {
    op->SetSecondaryRadialAxesTextProperty(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSecondaryRadialAxesTextProperty",argv[1]))&&(argc == 2))
  {
    vtkTextProperty  *temp20;
    temp20 = (op)->GetSecondaryRadialAxesTextProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkTextProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetPolarAxisProperty",argv[1]))&&(argc == 3))
  {
    vtkProperty  *temp0;
    error = 0;

    temp0 = (vtkProperty *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkProperty"),interp,error));
    if (!error)
  {
    op->SetPolarAxisProperty(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarAxisProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetPolarAxisProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetLastRadialAxisProperty",argv[1]))&&(argc == 3))
  {
    vtkProperty  *temp0;
    error = 0;

    temp0 = (vtkProperty *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkProperty"),interp,error));
    if (!error)
  {
    op->SetLastRadialAxisProperty(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetLastRadialAxisProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetLastRadialAxisProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetSecondaryRadialAxesProperty",argv[1]))&&(argc == 3))
  {
    vtkProperty  *temp0;
    error = 0;

    temp0 = (vtkProperty *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkProperty"),interp,error));
    if (!error)
  {
    op->SetSecondaryRadialAxesProperty(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSecondaryRadialAxesProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetSecondaryRadialAxesProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetPolarArcsProperty",argv[1]))&&(argc == 3))
  {
    vtkProperty  *temp0;
    error = 0;

    temp0 = (vtkProperty *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkProperty"),interp,error));
    if (!error)
  {
    op->SetPolarArcsProperty(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetPolarArcsProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetPolarArcsProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetSecondaryPolarArcsProperty",argv[1]))&&(argc == 3))
  {
    vtkProperty  *temp0;
    error = 0;

    temp0 = (vtkProperty *)(vtkTclGetPointerFromObject(argv[2],const_cast<char *>("vtkProperty"),interp,error));
    if (!error)
  {
    op->SetSecondaryPolarArcsProperty(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetSecondaryPolarArcsProperty",argv[1]))&&(argc == 2))
  {
    vtkProperty  *temp20;
    temp20 = (op)->GetSecondaryPolarArcsProperty();
      vtkTclGetObjectFromPointer(interp,(void *)(temp20),"vtkProperty");
    return TCL_OK;
  }
  if ((!strcmp("SetBounds",argv[1]))&&(argc == 8))
  {
    double   temp0;
    double   temp1;
    double   temp2;
    double   temp3;
    double   temp4;
    double   temp5;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp1 = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp2 = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp3 = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp4 = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp5 = tempd;
    if (!error)
  {
    op->SetBounds(temp0,temp1,temp2,temp3,temp4,temp5);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetBounds",argv[1]))&&(argc == 8))
  {
    double temp0[6];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (!error)
  {
    op->SetBounds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetBounds",argv[1]))&&(argc == 8))
  {
    double temp0[6];
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0[0] = tempd;
    if (Tcl_GetDouble(interp,argv[3],&tempd) != TCL_OK) error = 1;
    temp0[1] = tempd;
    if (Tcl_GetDouble(interp,argv[4],&tempd) != TCL_OK) error = 1;
    temp0[2] = tempd;
    if (Tcl_GetDouble(interp,argv[5],&tempd) != TCL_OK) error = 1;
    temp0[3] = tempd;
    if (Tcl_GetDouble(interp,argv[6],&tempd) != TCL_OK) error = 1;
    temp0[4] = tempd;
    if (Tcl_GetDouble(interp,argv[7],&tempd) != TCL_OK) error = 1;
    temp0[5] = tempd;
    if (!error)
  {
    op->GetBounds(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("SetRatio",argv[1]))&&(argc == 3))
  {
    double   temp0;
    error = 0;

    if (Tcl_GetDouble(interp,argv[2],&tempd) != TCL_OK) error = 1;
    temp0 = tempd;
    if (!error)
  {
    op->SetRatio(temp0);
    Tcl_ResetResult(interp);
    return TCL_OK;
  }
  }
  if ((!strcmp("GetRatioMinValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRatioMinValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetRatioMaxValue",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRatioMaxValue();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }
  if ((!strcmp("GetRatio",argv[1]))&&(argc == 2))
  {
    double   temp20;
    temp20 = (op)->GetRatio();
    char tempResult[1024];
    Tcl_PrintDouble(interp,temp20,tempResult);
    Tcl_SetResult(interp, tempResult, TCL_VOLATILE);
    return TCL_OK;
  }

  if (!strcmp("ListInstances",argv[1]))
  {
    vtkTclListInstances(interp,(ClientData)(vtkPolarAxesActorCommand));
    return TCL_OK;
  }

  if (!strcmp("ListMethods",argv[1]))
  {
    vtkActorCppCommand(op,interp,argc,argv);
    Tcl_AppendResult(interp,"Methods from vtkPolarAxesActor:\n",NULL);
    Tcl_AppendResult(interp,"  GetSuperClassName\n",NULL);
    Tcl_AppendResult(interp,"  GetClassName\n",NULL);
    Tcl_AppendResult(interp,"  IsA\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  NewInstance\n",NULL);
    Tcl_AppendResult(interp,"  SafeDownCast\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  New\n",NULL);
    Tcl_AppendResult(interp,"  RenderOpaqueGeometry\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RenderOverlay\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  RenderTranslucentPolygonalGeometry\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetPole\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  SetPole\t with 3 args\n",NULL);
    Tcl_AppendResult(interp,"  GetPole\n",NULL);
    Tcl_AppendResult(interp,"  SetLog\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLog\n",NULL);
    Tcl_AppendResult(interp,"  LogOn\n",NULL);
    Tcl_AppendResult(interp,"  LogOff\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfRadialAxes\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfRadialAxes\n",NULL);
    Tcl_AppendResult(interp,"  SetNumberOfPolarAxisTicks\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetNumberOfPolarAxisTicks\n",NULL);
    Tcl_AppendResult(interp,"  SetAutoSubdividePolarAxis\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAutoSubdividePolarAxis\n",NULL);
    Tcl_AppendResult(interp,"  AutoSubdividePolarAxisOn\n",NULL);
    Tcl_AppendResult(interp,"  AutoSubdividePolarAxisOff\n",NULL);
    Tcl_AppendResult(interp,"  SetRange\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  SetRange\t with 2 args\n",NULL);
    Tcl_AppendResult(interp,"  GetRange\n",NULL);
    Tcl_AppendResult(interp,"  SetMinimumRadius\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMinimumRadius\n",NULL);
    Tcl_AppendResult(interp,"  SetMaximumRadius\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMaximumRadius\n",NULL);
    Tcl_AppendResult(interp,"  SetAutoScaleRadius\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAutoScaleRadius\n",NULL);
    Tcl_AppendResult(interp,"  SetMinimumAngle\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMinimumAngle\n",NULL);
    Tcl_AppendResult(interp,"  SetMaximumAngle\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetMaximumAngle\n",NULL);
    Tcl_AppendResult(interp,"  SetSmallestVisiblePolarAngle\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSmallestVisiblePolarAngleMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSmallestVisiblePolarAngleMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetSmallestVisiblePolarAngle\n",NULL);
    Tcl_AppendResult(interp,"  SetTickLocation\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetTickLocationMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetTickLocationMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetTickLocation\n",NULL);
    Tcl_AppendResult(interp,"  SetRadialUnits\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRadialUnits\n",NULL);
    Tcl_AppendResult(interp,"  SetScreenSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetScreenSize\n",NULL);
    Tcl_AppendResult(interp,"  SetCamera\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetCamera\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarAxisTitle\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisTitle\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarLabelFormat\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarLabelFormat\n",NULL);
    Tcl_AppendResult(interp,"  SetExponentLocation\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetExponentLocationMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetExponentLocationMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetExponentLocation\n",NULL);
    Tcl_AppendResult(interp,"  SetRadialAngleFormat\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRadialAngleFormat\n",NULL);
    Tcl_AppendResult(interp,"  ReleaseGraphicsResources\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  SetEnableDistanceLOD\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetEnableDistanceLOD\n",NULL);
    Tcl_AppendResult(interp,"  SetDistanceLODThreshold\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDistanceLODThresholdMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetDistanceLODThresholdMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetDistanceLODThreshold\n",NULL);
    Tcl_AppendResult(interp,"  SetEnableViewAngleLOD\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetEnableViewAngleLOD\n",NULL);
    Tcl_AppendResult(interp,"  SetViewAngleLODThreshold\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetViewAngleLODThresholdMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetViewAngleLODThresholdMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetViewAngleLODThreshold\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarAxisVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisVisibility\n",NULL);
    Tcl_AppendResult(interp,"  PolarAxisVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  PolarAxisVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetDrawRadialGridlines\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDrawRadialGridlines\n",NULL);
    Tcl_AppendResult(interp,"  DrawRadialGridlinesOn\n",NULL);
    Tcl_AppendResult(interp,"  DrawRadialGridlinesOff\n",NULL);
    Tcl_AppendResult(interp,"  SetDrawPolarArcsGridlines\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDrawPolarArcsGridlines\n",NULL);
    Tcl_AppendResult(interp,"  DrawPolarArcsGridlinesOn\n",NULL);
    Tcl_AppendResult(interp,"  DrawPolarArcsGridlinesOff\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarTitleVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarTitleVisibility\n",NULL);
    Tcl_AppendResult(interp,"  PolarTitleVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  PolarTitleVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetRadialAxisTitleLocation\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRadialAxisTitleLocationMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetRadialAxisTitleLocationMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetRadialAxisTitleLocation\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarAxisTitleLocation\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisTitleLocationMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisTitleLocationMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisTitleLocation\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarLabelVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarLabelVisibility\n",NULL);
    Tcl_AppendResult(interp,"  PolarLabelVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  PolarLabelVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetArcTicksOriginToPolarAxis\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetArcTicksOriginToPolarAxis\n",NULL);
    Tcl_AppendResult(interp,"  ArcTicksOriginToPolarAxisOn\n",NULL);
    Tcl_AppendResult(interp,"  ArcTicksOriginToPolarAxisOff\n",NULL);
    Tcl_AppendResult(interp,"  SetRadialAxesOriginToPolarAxis\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRadialAxesOriginToPolarAxis\n",NULL);
    Tcl_AppendResult(interp,"  RadialAxesOriginToPolarAxisOn\n",NULL);
    Tcl_AppendResult(interp,"  RadialAxesOriginToPolarAxisOff\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarTickVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarTickVisibility\n",NULL);
    Tcl_AppendResult(interp,"  PolarTickVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  PolarTickVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetAxisTickVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAxisTickVisibility\n",NULL);
    Tcl_AppendResult(interp,"  AxisTickVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  AxisTickVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetAxisMinorTickVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetAxisMinorTickVisibility\n",NULL);
    Tcl_AppendResult(interp,"  AxisMinorTickVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  AxisMinorTickVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetArcTickVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetArcTickVisibility\n",NULL);
    Tcl_AppendResult(interp,"  ArcTickVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  ArcTickVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetArcMinorTickVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetArcMinorTickVisibility\n",NULL);
    Tcl_AppendResult(interp,"  ArcMinorTickVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  ArcMinorTickVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetArcMajorTickSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetArcMajorTickSize\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarAxisMajorTickSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisMajorTickSize\n",NULL);
    Tcl_AppendResult(interp,"  SetLastRadialAxisMajorTickSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLastRadialAxisMajorTickSize\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarAxisTickRatioSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisTickRatioSize\n",NULL);
    Tcl_AppendResult(interp,"  SetLastAxisTickRatioSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLastAxisTickRatioSize\n",NULL);
    Tcl_AppendResult(interp,"  SetArcTickRatioSize\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetArcTickRatioSize\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarAxisMajorTickThickness\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisMajorTickThickness\n",NULL);
    Tcl_AppendResult(interp,"  SetLastRadialAxisMajorTickThickness\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLastRadialAxisMajorTickThickness\n",NULL);
    Tcl_AppendResult(interp,"  SetArcMajorTickThickness\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetArcMajorTickThickness\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarAxisTickRatioThickness\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisTickRatioThickness\n",NULL);
    Tcl_AppendResult(interp,"  SetLastAxisTickRatioThickness\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLastAxisTickRatioThickness\n",NULL);
    Tcl_AppendResult(interp,"  SetArcTickRatioThickness\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetArcTickRatioThickness\n",NULL);
    Tcl_AppendResult(interp,"  SetDeltaRangeMajor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDeltaRangeMajor\n",NULL);
    Tcl_AppendResult(interp,"  SetDeltaRangeMinor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDeltaRangeMinor\n",NULL);
    Tcl_AppendResult(interp,"  SetDeltaAngleMajor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDeltaAngleMajor\n",NULL);
    Tcl_AppendResult(interp,"  SetDeltaAngleMinor\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDeltaAngleMinor\n",NULL);
    Tcl_AppendResult(interp,"  SetDeltaAngleRadialAxes\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetDeltaAngleRadialAxes\n",NULL);
    Tcl_AppendResult(interp,"  SetRadialAxesVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRadialAxesVisibility\n",NULL);
    Tcl_AppendResult(interp,"  RadialAxesVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  RadialAxesVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetRadialTitleVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRadialTitleVisibility\n",NULL);
    Tcl_AppendResult(interp,"  RadialTitleVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  RadialTitleVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarArcsVisibility\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarArcsVisibility\n",NULL);
    Tcl_AppendResult(interp,"  PolarArcsVisibilityOn\n",NULL);
    Tcl_AppendResult(interp,"  PolarArcsVisibilityOff\n",NULL);
    Tcl_AppendResult(interp,"  SetUse2DMode\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetUse2DMode\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarAxisTitleTextProperty\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisTitleTextProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarAxisLabelTextProperty\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisLabelTextProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetLastRadialAxisTextProperty\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLastRadialAxisTextProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetSecondaryRadialAxesTextProperty\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSecondaryRadialAxesTextProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarAxisProperty\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarAxisProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetLastRadialAxisProperty\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetLastRadialAxisProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetSecondaryRadialAxesProperty\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSecondaryRadialAxesProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetPolarArcsProperty\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetPolarArcsProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetSecondaryPolarArcsProperty\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetSecondaryPolarArcsProperty\n",NULL);
    Tcl_AppendResult(interp,"  SetBounds\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  SetBounds\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  GetBounds\t with 6 args\n",NULL);
    Tcl_AppendResult(interp,"  SetRatio\t with 1 arg\n",NULL);
    Tcl_AppendResult(interp,"  GetRatioMinValue\n",NULL);
    Tcl_AppendResult(interp,"  GetRatioMaxValue\n",NULL);
    Tcl_AppendResult(interp,"  GetRatio\n",NULL);
    return TCL_OK;
  }

  if (!strcmp("DescribeMethods",argv[1]))
  {
    if(argc>3) {
      Tcl_SetResult ( interp, const_cast<char*>("Wrong number of arguments: object DescribeMethods <MethodName>"), TCL_VOLATILE ); 
      return TCL_ERROR;
 }
    if(argc==2) {

  Tcl_DString dString, dStringParent;

  Tcl_DStringInit ( &dString );

  Tcl_DStringInit ( &dStringParent );
    vtkActorCppCommand(op,interp,argc,argv);
    Tcl_DStringGetResult ( interp, &dStringParent );
    Tcl_DStringAppend ( &dString, Tcl_DStringValue ( &dStringParent ), -1 );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    Tcl_DStringAppendElement ( &dString, "New" );
    Tcl_DStringAppendElement ( &dString, "RenderOpaqueGeometry" );
    Tcl_DStringAppendElement ( &dString, "RenderOverlay" );
    Tcl_DStringAppendElement ( &dString, "RenderTranslucentPolygonalGeometry" );
    Tcl_DStringAppendElement ( &dString, "SetPole" );
    Tcl_DStringAppendElement ( &dString, "SetPole" );
    Tcl_DStringAppendElement ( &dString, "GetPole" );
    Tcl_DStringAppendElement ( &dString, "SetLog" );
    Tcl_DStringAppendElement ( &dString, "GetLog" );
    Tcl_DStringAppendElement ( &dString, "LogOn" );
    Tcl_DStringAppendElement ( &dString, "LogOff" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfRadialAxes" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfRadialAxes" );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfPolarAxisTicks" );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPolarAxisTicks" );
    Tcl_DStringAppendElement ( &dString, "SetAutoSubdividePolarAxis" );
    Tcl_DStringAppendElement ( &dString, "GetAutoSubdividePolarAxis" );
    Tcl_DStringAppendElement ( &dString, "AutoSubdividePolarAxisOn" );
    Tcl_DStringAppendElement ( &dString, "AutoSubdividePolarAxisOff" );
    Tcl_DStringAppendElement ( &dString, "SetRange" );
    Tcl_DStringAppendElement ( &dString, "SetRange" );
    Tcl_DStringAppendElement ( &dString, "GetRange" );
    Tcl_DStringAppendElement ( &dString, "SetMinimumRadius" );
    Tcl_DStringAppendElement ( &dString, "GetMinimumRadius" );
    Tcl_DStringAppendElement ( &dString, "SetMaximumRadius" );
    Tcl_DStringAppendElement ( &dString, "GetMaximumRadius" );
    Tcl_DStringAppendElement ( &dString, "SetAutoScaleRadius" );
    Tcl_DStringAppendElement ( &dString, "GetAutoScaleRadius" );
    Tcl_DStringAppendElement ( &dString, "SetMinimumAngle" );
    Tcl_DStringAppendElement ( &dString, "GetMinimumAngle" );
    Tcl_DStringAppendElement ( &dString, "SetMaximumAngle" );
    Tcl_DStringAppendElement ( &dString, "GetMaximumAngle" );
    Tcl_DStringAppendElement ( &dString, "SetSmallestVisiblePolarAngle" );
    Tcl_DStringAppendElement ( &dString, "GetSmallestVisiblePolarAngleMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetSmallestVisiblePolarAngleMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetSmallestVisiblePolarAngle" );
    Tcl_DStringAppendElement ( &dString, "SetTickLocation" );
    Tcl_DStringAppendElement ( &dString, "GetTickLocationMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetTickLocationMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetTickLocation" );
    Tcl_DStringAppendElement ( &dString, "SetRadialUnits" );
    Tcl_DStringAppendElement ( &dString, "GetRadialUnits" );
    Tcl_DStringAppendElement ( &dString, "SetScreenSize" );
    Tcl_DStringAppendElement ( &dString, "GetScreenSize" );
    Tcl_DStringAppendElement ( &dString, "SetCamera" );
    Tcl_DStringAppendElement ( &dString, "GetCamera" );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisTitle" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTitle" );
    Tcl_DStringAppendElement ( &dString, "SetPolarLabelFormat" );
    Tcl_DStringAppendElement ( &dString, "GetPolarLabelFormat" );
    Tcl_DStringAppendElement ( &dString, "SetExponentLocation" );
    Tcl_DStringAppendElement ( &dString, "GetExponentLocationMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetExponentLocationMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetExponentLocation" );
    Tcl_DStringAppendElement ( &dString, "SetRadialAngleFormat" );
    Tcl_DStringAppendElement ( &dString, "GetRadialAngleFormat" );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    Tcl_DStringAppendElement ( &dString, "SetEnableDistanceLOD" );
    Tcl_DStringAppendElement ( &dString, "GetEnableDistanceLOD" );
    Tcl_DStringAppendElement ( &dString, "SetDistanceLODThreshold" );
    Tcl_DStringAppendElement ( &dString, "GetDistanceLODThresholdMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetDistanceLODThresholdMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetDistanceLODThreshold" );
    Tcl_DStringAppendElement ( &dString, "SetEnableViewAngleLOD" );
    Tcl_DStringAppendElement ( &dString, "GetEnableViewAngleLOD" );
    Tcl_DStringAppendElement ( &dString, "SetViewAngleLODThreshold" );
    Tcl_DStringAppendElement ( &dString, "GetViewAngleLODThresholdMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetViewAngleLODThresholdMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetViewAngleLODThreshold" );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisVisibility" );
    Tcl_DStringAppendElement ( &dString, "PolarAxisVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "PolarAxisVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetDrawRadialGridlines" );
    Tcl_DStringAppendElement ( &dString, "GetDrawRadialGridlines" );
    Tcl_DStringAppendElement ( &dString, "DrawRadialGridlinesOn" );
    Tcl_DStringAppendElement ( &dString, "DrawRadialGridlinesOff" );
    Tcl_DStringAppendElement ( &dString, "SetDrawPolarArcsGridlines" );
    Tcl_DStringAppendElement ( &dString, "GetDrawPolarArcsGridlines" );
    Tcl_DStringAppendElement ( &dString, "DrawPolarArcsGridlinesOn" );
    Tcl_DStringAppendElement ( &dString, "DrawPolarArcsGridlinesOff" );
    Tcl_DStringAppendElement ( &dString, "SetPolarTitleVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetPolarTitleVisibility" );
    Tcl_DStringAppendElement ( &dString, "PolarTitleVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "PolarTitleVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetRadialAxisTitleLocation" );
    Tcl_DStringAppendElement ( &dString, "GetRadialAxisTitleLocationMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetRadialAxisTitleLocationMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetRadialAxisTitleLocation" );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisTitleLocation" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTitleLocationMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTitleLocationMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTitleLocation" );
    Tcl_DStringAppendElement ( &dString, "SetPolarLabelVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetPolarLabelVisibility" );
    Tcl_DStringAppendElement ( &dString, "PolarLabelVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "PolarLabelVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetArcTicksOriginToPolarAxis" );
    Tcl_DStringAppendElement ( &dString, "GetArcTicksOriginToPolarAxis" );
    Tcl_DStringAppendElement ( &dString, "ArcTicksOriginToPolarAxisOn" );
    Tcl_DStringAppendElement ( &dString, "ArcTicksOriginToPolarAxisOff" );
    Tcl_DStringAppendElement ( &dString, "SetRadialAxesOriginToPolarAxis" );
    Tcl_DStringAppendElement ( &dString, "GetRadialAxesOriginToPolarAxis" );
    Tcl_DStringAppendElement ( &dString, "RadialAxesOriginToPolarAxisOn" );
    Tcl_DStringAppendElement ( &dString, "RadialAxesOriginToPolarAxisOff" );
    Tcl_DStringAppendElement ( &dString, "SetPolarTickVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetPolarTickVisibility" );
    Tcl_DStringAppendElement ( &dString, "PolarTickVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "PolarTickVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetAxisTickVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetAxisTickVisibility" );
    Tcl_DStringAppendElement ( &dString, "AxisTickVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "AxisTickVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetAxisMinorTickVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetAxisMinorTickVisibility" );
    Tcl_DStringAppendElement ( &dString, "AxisMinorTickVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "AxisMinorTickVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetArcTickVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetArcTickVisibility" );
    Tcl_DStringAppendElement ( &dString, "ArcTickVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "ArcTickVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetArcMinorTickVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetArcMinorTickVisibility" );
    Tcl_DStringAppendElement ( &dString, "ArcMinorTickVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "ArcMinorTickVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetArcMajorTickSize" );
    Tcl_DStringAppendElement ( &dString, "GetArcMajorTickSize" );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisMajorTickSize" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisMajorTickSize" );
    Tcl_DStringAppendElement ( &dString, "SetLastRadialAxisMajorTickSize" );
    Tcl_DStringAppendElement ( &dString, "GetLastRadialAxisMajorTickSize" );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisTickRatioSize" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTickRatioSize" );
    Tcl_DStringAppendElement ( &dString, "SetLastAxisTickRatioSize" );
    Tcl_DStringAppendElement ( &dString, "GetLastAxisTickRatioSize" );
    Tcl_DStringAppendElement ( &dString, "SetArcTickRatioSize" );
    Tcl_DStringAppendElement ( &dString, "GetArcTickRatioSize" );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisMajorTickThickness" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisMajorTickThickness" );
    Tcl_DStringAppendElement ( &dString, "SetLastRadialAxisMajorTickThickness" );
    Tcl_DStringAppendElement ( &dString, "GetLastRadialAxisMajorTickThickness" );
    Tcl_DStringAppendElement ( &dString, "SetArcMajorTickThickness" );
    Tcl_DStringAppendElement ( &dString, "GetArcMajorTickThickness" );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisTickRatioThickness" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTickRatioThickness" );
    Tcl_DStringAppendElement ( &dString, "SetLastAxisTickRatioThickness" );
    Tcl_DStringAppendElement ( &dString, "GetLastAxisTickRatioThickness" );
    Tcl_DStringAppendElement ( &dString, "SetArcTickRatioThickness" );
    Tcl_DStringAppendElement ( &dString, "GetArcTickRatioThickness" );
    Tcl_DStringAppendElement ( &dString, "SetDeltaRangeMajor" );
    Tcl_DStringAppendElement ( &dString, "GetDeltaRangeMajor" );
    Tcl_DStringAppendElement ( &dString, "SetDeltaRangeMinor" );
    Tcl_DStringAppendElement ( &dString, "GetDeltaRangeMinor" );
    Tcl_DStringAppendElement ( &dString, "SetDeltaAngleMajor" );
    Tcl_DStringAppendElement ( &dString, "GetDeltaAngleMajor" );
    Tcl_DStringAppendElement ( &dString, "SetDeltaAngleMinor" );
    Tcl_DStringAppendElement ( &dString, "GetDeltaAngleMinor" );
    Tcl_DStringAppendElement ( &dString, "SetDeltaAngleRadialAxes" );
    Tcl_DStringAppendElement ( &dString, "GetDeltaAngleRadialAxes" );
    Tcl_DStringAppendElement ( &dString, "SetRadialAxesVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetRadialAxesVisibility" );
    Tcl_DStringAppendElement ( &dString, "RadialAxesVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "RadialAxesVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetRadialTitleVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetRadialTitleVisibility" );
    Tcl_DStringAppendElement ( &dString, "RadialTitleVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "RadialTitleVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetPolarArcsVisibility" );
    Tcl_DStringAppendElement ( &dString, "GetPolarArcsVisibility" );
    Tcl_DStringAppendElement ( &dString, "PolarArcsVisibilityOn" );
    Tcl_DStringAppendElement ( &dString, "PolarArcsVisibilityOff" );
    Tcl_DStringAppendElement ( &dString, "SetUse2DMode" );
    Tcl_DStringAppendElement ( &dString, "GetUse2DMode" );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisTitleTextProperty" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTitleTextProperty" );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisLabelTextProperty" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisLabelTextProperty" );
    Tcl_DStringAppendElement ( &dString, "SetLastRadialAxisTextProperty" );
    Tcl_DStringAppendElement ( &dString, "GetLastRadialAxisTextProperty" );
    Tcl_DStringAppendElement ( &dString, "SetSecondaryRadialAxesTextProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSecondaryRadialAxesTextProperty" );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisProperty" );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisProperty" );
    Tcl_DStringAppendElement ( &dString, "SetLastRadialAxisProperty" );
    Tcl_DStringAppendElement ( &dString, "GetLastRadialAxisProperty" );
    Tcl_DStringAppendElement ( &dString, "SetSecondaryRadialAxesProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSecondaryRadialAxesProperty" );
    Tcl_DStringAppendElement ( &dString, "SetPolarArcsProperty" );
    Tcl_DStringAppendElement ( &dString, "GetPolarArcsProperty" );
    Tcl_DStringAppendElement ( &dString, "SetSecondaryPolarArcsProperty" );
    Tcl_DStringAppendElement ( &dString, "GetSecondaryPolarArcsProperty" );
    Tcl_DStringAppendElement ( &dString, "SetBounds" );
    Tcl_DStringAppendElement ( &dString, "SetBounds" );
    Tcl_DStringAppendElement ( &dString, "GetBounds" );
    Tcl_DStringAppendElement ( &dString, "SetRatio" );
    Tcl_DStringAppendElement ( &dString, "GetRatioMinValue" );
    Tcl_DStringAppendElement ( &dString, "GetRatioMaxValue" );
    Tcl_DStringAppendElement ( &dString, "GetRatio" );
  Tcl_DStringResult ( interp, &dString );
  Tcl_DStringFree ( &dString );
  Tcl_DStringFree ( &dStringParent );
    return TCL_OK;
  }
    if(argc==3) {
      Tcl_DString dString;
      int SuperClassStatus;
    SuperClassStatus = vtkActorCppCommand(op,interp,argc,argv);
    if ( SuperClassStatus == TCL_OK ) { return TCL_OK; }
    /* Starting function: GetClassName */
    if ( strcmp ( argv[2], "GetClassName" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetClassName" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetClassName */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "const char *GetClassName();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetClassName */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: IsA */
    if ( strcmp ( argv[2], "IsA" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "IsA" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for IsA */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "int IsA(const char *name);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for IsA */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: NewInstance */
    if ( strcmp ( argv[2], "NewInstance" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "NewInstance" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for NewInstance */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor *NewInstance();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for NewInstance */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SafeDownCast */
    if ( strcmp ( argv[2], "SafeDownCast" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SafeDownCast" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkObject" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SafeDownCast */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor *SafeDownCast(vtkObject* o);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SafeDownCast */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: New */
    if ( strcmp ( argv[2], "New" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "New" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for New */
    Tcl_DStringAppendElement ( &dString, " Instantiate object with label format \"6.3g\" and the number of labels\n per axis set to 3.\n" );
    Tcl_DStringAppendElement ( &dString, "static vtkPolarAxesActor *New();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for New */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RenderOpaqueGeometry */
    if ( strcmp ( argv[2], "RenderOpaqueGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RenderOpaqueGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkViewport" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RenderOpaqueGeometry */
    Tcl_DStringAppendElement ( &dString, " Draw the polar axes\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int RenderOpaqueGeometry(vtkViewport *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for RenderOpaqueGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RenderOverlay */
    if ( strcmp ( argv[2], "RenderOverlay" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RenderOverlay" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkViewport" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RenderOverlay */
    Tcl_DStringAppendElement ( &dString, " Draw the polar axes\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int RenderOverlay(vtkViewport *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for RenderOverlay */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RenderTranslucentPolygonalGeometry */
    if ( strcmp ( argv[2], "RenderTranslucentPolygonalGeometry" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RenderTranslucentPolygonalGeometry" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkViewport" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RenderTranslucentPolygonalGeometry */
    Tcl_DStringAppendElement ( &dString, " Draw the polar axes\n" );
    Tcl_DStringAppendElement ( &dString, "virtual int RenderTranslucentPolygonalGeometry(vtkViewport *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for RenderTranslucentPolygonalGeometry */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPole */
    if ( strcmp ( argv[2], "SetPole" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPole" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPole */
    Tcl_DStringAppendElement ( &dString, " Explicitly specify the coordinate of the pole.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetPole(double\\[3\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPole */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPole */
    if ( strcmp ( argv[2], "SetPole" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPole" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPole */
    Tcl_DStringAppendElement ( &dString, " Explicitly specify the coordinate of the pole.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetPole(double, double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPole */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPole */
    if ( strcmp ( argv[2], "GetPole" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPole" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPole */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "double *GetPole();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPole */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLog */
    if ( strcmp ( argv[2], "SetLog" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLog" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLog */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable log scale\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLog(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetLog */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLog */
    if ( strcmp ( argv[2], "GetLog" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLog" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLog */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable log scale\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetLog();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetLog */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: LogOn */
    if ( strcmp ( argv[2], "LogOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "LogOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for LogOn */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable log scale\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "void LogOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for LogOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: LogOff */
    if ( strcmp ( argv[2], "LogOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "LogOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for LogOff */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable log scale\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "void LogOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for LogOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfRadialAxes */
    if ( strcmp ( argv[2], "SetNumberOfRadialAxes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfRadialAxes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfRadialAxes */
    Tcl_DStringAppendElement ( &dString, " Gets/Sets the number of radial axes\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetNumberOfRadialAxes(vtkIdType);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetNumberOfRadialAxes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfRadialAxes */
    if ( strcmp ( argv[2], "GetNumberOfRadialAxes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfRadialAxes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfRadialAxes */
    Tcl_DStringAppendElement ( &dString, " Gets/Sets the number of radial axes\n" );
    Tcl_DStringAppendElement ( &dString, "vtkIdType GetNumberOfRadialAxes();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetNumberOfRadialAxes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetNumberOfPolarAxisTicks */
    if ( strcmp ( argv[2], "SetNumberOfPolarAxisTicks" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetNumberOfPolarAxisTicks" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetNumberOfPolarAxisTicks */
    Tcl_DStringAppendElement ( &dString, " Set/Get a number of ticks that one would like to display along polar axis\n NB: it modifies DeltaRangeMajor to correspond to this number\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetNumberOfPolarAxisTicks(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetNumberOfPolarAxisTicks */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetNumberOfPolarAxisTicks */
    if ( strcmp ( argv[2], "GetNumberOfPolarAxisTicks" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetNumberOfPolarAxisTicks" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetNumberOfPolarAxisTicks */
    Tcl_DStringAppendElement ( &dString, " Set/Get a number of ticks that one would like to display along polar axis\n NB: it modifies DeltaRangeMajor to correspond to this number\n" );
    Tcl_DStringAppendElement ( &dString, "int GetNumberOfPolarAxisTicks();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetNumberOfPolarAxisTicks */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAutoSubdividePolarAxis */
    if ( strcmp ( argv[2], "SetAutoSubdividePolarAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAutoSubdividePolarAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAutoSubdividePolarAxis */
    Tcl_DStringAppendElement ( &dString, " Set/Get whether the number of polar axis ticks and arcs should be automatically calculated\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAutoSubdividePolarAxis(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetAutoSubdividePolarAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAutoSubdividePolarAxis */
    if ( strcmp ( argv[2], "GetAutoSubdividePolarAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAutoSubdividePolarAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAutoSubdividePolarAxis */
    Tcl_DStringAppendElement ( &dString, " Set/Get whether the number of polar axis ticks and arcs should be automatically calculated\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetAutoSubdividePolarAxis();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetAutoSubdividePolarAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AutoSubdividePolarAxisOn */
    if ( strcmp ( argv[2], "AutoSubdividePolarAxisOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AutoSubdividePolarAxisOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AutoSubdividePolarAxisOn */
    Tcl_DStringAppendElement ( &dString, " Set/Get whether the number of polar axis ticks and arcs should be automatically calculated\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "void AutoSubdividePolarAxisOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for AutoSubdividePolarAxisOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AutoSubdividePolarAxisOff */
    if ( strcmp ( argv[2], "AutoSubdividePolarAxisOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AutoSubdividePolarAxisOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AutoSubdividePolarAxisOff */
    Tcl_DStringAppendElement ( &dString, " Set/Get whether the number of polar axis ticks and arcs should be automatically calculated\n Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "void AutoSubdividePolarAxisOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for AutoSubdividePolarAxisOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRange */
    if ( strcmp ( argv[2], "SetRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRange */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetRange(double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRange */
    if ( strcmp ( argv[2], "SetRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRange */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetRange(double a\\[2\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRange */
    if ( strcmp ( argv[2], "GetRange" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRange" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRange */
    Tcl_DStringAppendElement ( &dString, " Define the range values displayed on the polar Axis.\n" );
    Tcl_DStringAppendElement ( &dString, "double *GetRange();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRange */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMinimumRadius */
    if ( strcmp ( argv[2], "SetMinimumRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMinimumRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMinimumRadius */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimal radius of the polar coordinates.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetMinimumRadius(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetMinimumRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMinimumRadius */
    if ( strcmp ( argv[2], "GetMinimumRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMinimumRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMinimumRadius */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimal radius of the polar coordinates.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetMinimumRadius();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetMinimumRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMaximumRadius */
    if ( strcmp ( argv[2], "SetMaximumRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMaximumRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMaximumRadius */
    Tcl_DStringAppendElement ( &dString, " Set/Get the maximum radius of the polar coordinates.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetMaximumRadius(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetMaximumRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMaximumRadius */
    if ( strcmp ( argv[2], "GetMaximumRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaximumRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaximumRadius */
    Tcl_DStringAppendElement ( &dString, " Set/Get the maximum radius of the polar coordinates.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetMaximumRadius();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetMaximumRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAutoScaleRadius */
    if ( strcmp ( argv[2], "SetAutoScaleRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAutoScaleRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAutoScaleRadius */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the auto-scaling of the maximum radius.\n Default: false\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAutoScaleRadius(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetAutoScaleRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAutoScaleRadius */
    if ( strcmp ( argv[2], "GetAutoScaleRadius" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAutoScaleRadius" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAutoScaleRadius */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the auto-scaling of the maximum radius.\n Default: false\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetAutoScaleRadius();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetAutoScaleRadius */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMinimumAngle */
    if ( strcmp ( argv[2], "SetMinimumAngle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMinimumAngle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMinimumAngle */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum radius of the polar coordinates (in degrees).\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetMinimumAngle(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetMinimumAngle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMinimumAngle */
    if ( strcmp ( argv[2], "GetMinimumAngle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMinimumAngle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMinimumAngle */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum radius of the polar coordinates (in degrees).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetMinimumAngle();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetMinimumAngle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetMaximumAngle */
    if ( strcmp ( argv[2], "SetMaximumAngle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetMaximumAngle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetMaximumAngle */
    Tcl_DStringAppendElement ( &dString, " Set/Get the maximum radius of the polar coordinates (in degrees).\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetMaximumAngle(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetMaximumAngle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetMaximumAngle */
    if ( strcmp ( argv[2], "GetMaximumAngle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetMaximumAngle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetMaximumAngle */
    Tcl_DStringAppendElement ( &dString, " Set/Get the maximum radius of the polar coordinates (in degrees).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetMaximumAngle();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetMaximumAngle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSmallestVisiblePolarAngle */
    if ( strcmp ( argv[2], "SetSmallestVisiblePolarAngle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSmallestVisiblePolarAngle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSmallestVisiblePolarAngle */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum radial angle distinguishable from polar axis\n NB: This is used only when polar axis is visible\n Default: 0.5\n" );
    Tcl_DStringAppendElement ( &dString, "void SetSmallestVisiblePolarAngle(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetSmallestVisiblePolarAngle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSmallestVisiblePolarAngleMinValue */
    if ( strcmp ( argv[2], "GetSmallestVisiblePolarAngleMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSmallestVisiblePolarAngleMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSmallestVisiblePolarAngleMinValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum radial angle distinguishable from polar axis\n NB: This is used only when polar axis is visible\n Default: 0.5\n" );
    Tcl_DStringAppendElement ( &dString, "double GetSmallestVisiblePolarAngleMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetSmallestVisiblePolarAngleMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSmallestVisiblePolarAngleMaxValue */
    if ( strcmp ( argv[2], "GetSmallestVisiblePolarAngleMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSmallestVisiblePolarAngleMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSmallestVisiblePolarAngleMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum radial angle distinguishable from polar axis\n NB: This is used only when polar axis is visible\n Default: 0.5\n" );
    Tcl_DStringAppendElement ( &dString, "double GetSmallestVisiblePolarAngleMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetSmallestVisiblePolarAngleMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSmallestVisiblePolarAngle */
    if ( strcmp ( argv[2], "GetSmallestVisiblePolarAngle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSmallestVisiblePolarAngle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSmallestVisiblePolarAngle */
    Tcl_DStringAppendElement ( &dString, " Set/Get the minimum radial angle distinguishable from polar axis\n NB: This is used only when polar axis is visible\n Default: 0.5\n" );
    Tcl_DStringAppendElement ( &dString, "double GetSmallestVisiblePolarAngle();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetSmallestVisiblePolarAngle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetTickLocation */
    if ( strcmp ( argv[2], "SetTickLocation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetTickLocation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetTickLocation */
    Tcl_DStringAppendElement ( &dString, " Set/Get the location of the ticks.\n Inside: tick end toward positive direction of perpendicular axes.\n Outside: tick end toward negative direction of perpendicular axes.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetTickLocation(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetTickLocation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTickLocationMinValue */
    if ( strcmp ( argv[2], "GetTickLocationMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTickLocationMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTickLocationMinValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the location of the ticks.\n Inside: tick end toward positive direction of perpendicular axes.\n Outside: tick end toward negative direction of perpendicular axes.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetTickLocationMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetTickLocationMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTickLocationMaxValue */
    if ( strcmp ( argv[2], "GetTickLocationMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTickLocationMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTickLocationMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set/Get the location of the ticks.\n Inside: tick end toward positive direction of perpendicular axes.\n Outside: tick end toward negative direction of perpendicular axes.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetTickLocationMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetTickLocationMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetTickLocation */
    if ( strcmp ( argv[2], "GetTickLocation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetTickLocation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetTickLocation */
    Tcl_DStringAppendElement ( &dString, " Set/Get the location of the ticks.\n Inside: tick end toward positive direction of perpendicular axes.\n Outside: tick end toward negative direction of perpendicular axes.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetTickLocation();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetTickLocation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRadialUnits */
    if ( strcmp ( argv[2], "SetRadialUnits" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRadialUnits" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "bool" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRadialUnits */
    Tcl_DStringAppendElement ( &dString, " Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRadialUnits(bool a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetRadialUnits */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadialUnits */
    if ( strcmp ( argv[2], "GetRadialUnits" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadialUnits" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadialUnits */
    Tcl_DStringAppendElement ( &dString, " Default: true\n" );
    Tcl_DStringAppendElement ( &dString, "bool GetRadialUnits();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRadialUnits */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetScreenSize */
    if ( strcmp ( argv[2], "SetScreenSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetScreenSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetScreenSize */
    Tcl_DStringAppendElement ( &dString, " Explicitly specify the screen size of title and label text.\n ScreenSize detemines the size of the text in terms of screen\n pixels.\n Default: 10.0.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetScreenSize(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetScreenSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetScreenSize */
    if ( strcmp ( argv[2], "GetScreenSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetScreenSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetScreenSize */
    Tcl_DStringAppendElement ( &dString, " Explicitly specify the screen size of title and label text.\n ScreenSize detemines the size of the text in terms of screen\n pixels.\n Default: 10.0.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetScreenSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetScreenSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetCamera */
    if ( strcmp ( argv[2], "SetCamera" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetCamera" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkCamera" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetCamera */
    Tcl_DStringAppendElement ( &dString, " Set/Get the camera to perform scaling and translation of the\n vtkPolarAxesActor.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetCamera(vtkCamera *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetCamera */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetCamera */
    if ( strcmp ( argv[2], "GetCamera" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetCamera" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetCamera */
    Tcl_DStringAppendElement ( &dString, " Set/Get the camera to perform scaling and translation of the\n vtkPolarAxesActor.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkCamera *GetCamera();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetCamera */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarAxisTitle */
    if ( strcmp ( argv[2], "SetPolarAxisTitle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisTitle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarAxisTitle */
    Tcl_DStringAppendElement ( &dString, " Set/Get the labels for the polar axis.\n Default: \"Radial Distance\".\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarAxisTitle(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarAxisTitle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisTitle */
    if ( strcmp ( argv[2], "GetPolarAxisTitle" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTitle" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisTitle */
    Tcl_DStringAppendElement ( &dString, " Set/Get the labels for the polar axis.\n Default: \"Radial Distance\".\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetPolarAxisTitle();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisTitle */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarLabelFormat */
    if ( strcmp ( argv[2], "SetPolarLabelFormat" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarLabelFormat" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarLabelFormat */
    Tcl_DStringAppendElement ( &dString, " Set/Get the format with which to print the polar axis labels.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarLabelFormat(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarLabelFormat */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarLabelFormat */
    if ( strcmp ( argv[2], "GetPolarLabelFormat" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarLabelFormat" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarLabelFormat */
    Tcl_DStringAppendElement ( &dString, " Set/Get the format with which to print the polar axis labels.\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetPolarLabelFormat();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarLabelFormat */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetExponentLocation */
    if ( strcmp ( argv[2], "SetExponentLocation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetExponentLocation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetExponentLocation */
    Tcl_DStringAppendElement ( &dString, " Get/Set the location of the exponent (if any) of the polar axis values.\n Possible location: VTK_EXPONENT_BOTTOM, VTK_EXPONENT_EXTERN,\n VTK_EXPONENT_LABELS\n" );
    Tcl_DStringAppendElement ( &dString, "void SetExponentLocation(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetExponentLocation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExponentLocationMinValue */
    if ( strcmp ( argv[2], "GetExponentLocationMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExponentLocationMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExponentLocationMinValue */
    Tcl_DStringAppendElement ( &dString, " Get/Set the location of the exponent (if any) of the polar axis values.\n Possible location: VTK_EXPONENT_BOTTOM, VTK_EXPONENT_EXTERN,\n VTK_EXPONENT_LABELS\n" );
    Tcl_DStringAppendElement ( &dString, "int GetExponentLocationMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetExponentLocationMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExponentLocationMaxValue */
    if ( strcmp ( argv[2], "GetExponentLocationMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExponentLocationMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExponentLocationMaxValue */
    Tcl_DStringAppendElement ( &dString, " Get/Set the location of the exponent (if any) of the polar axis values.\n Possible location: VTK_EXPONENT_BOTTOM, VTK_EXPONENT_EXTERN,\n VTK_EXPONENT_LABELS\n" );
    Tcl_DStringAppendElement ( &dString, "int GetExponentLocationMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetExponentLocationMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetExponentLocation */
    if ( strcmp ( argv[2], "GetExponentLocation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetExponentLocation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetExponentLocation */
    Tcl_DStringAppendElement ( &dString, " Get/Set the location of the exponent (if any) of the polar axis values.\n Possible location: VTK_EXPONENT_BOTTOM, VTK_EXPONENT_EXTERN,\n VTK_EXPONENT_LABELS\n" );
    Tcl_DStringAppendElement ( &dString, "int GetExponentLocation();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetExponentLocation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRadialAngleFormat */
    if ( strcmp ( argv[2], "SetRadialAngleFormat" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRadialAngleFormat" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "string" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRadialAngleFormat */
    Tcl_DStringAppendElement ( &dString, " String to format angle values displayed on the radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRadialAngleFormat(char *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetRadialAngleFormat */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadialAngleFormat */
    if ( strcmp ( argv[2], "GetRadialAngleFormat" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadialAngleFormat" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadialAngleFormat */
    Tcl_DStringAppendElement ( &dString, " String to format angle values displayed on the radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "char *GetRadialAngleFormat();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRadialAngleFormat */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ReleaseGraphicsResources */
    if ( strcmp ( argv[2], "ReleaseGraphicsResources" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ReleaseGraphicsResources" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkWindow" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ReleaseGraphicsResources */
    Tcl_DStringAppendElement ( &dString, " Release any graphics resources that are being consumed by this actor.\n The parameter window could be used to determine which graphic\n resources to release.\n" );
    Tcl_DStringAppendElement ( &dString, "void ReleaseGraphicsResources(vtkWindow *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for ReleaseGraphicsResources */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetEnableDistanceLOD */
    if ( strcmp ( argv[2], "SetEnableDistanceLOD" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetEnableDistanceLOD" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetEnableDistanceLOD */
    Tcl_DStringAppendElement ( &dString, " Enable and disable the use of distance based LOD for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetEnableDistanceLOD(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetEnableDistanceLOD */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetEnableDistanceLOD */
    if ( strcmp ( argv[2], "GetEnableDistanceLOD" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetEnableDistanceLOD" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetEnableDistanceLOD */
    Tcl_DStringAppendElement ( &dString, " Enable and disable the use of distance based LOD for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetEnableDistanceLOD();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetEnableDistanceLOD */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDistanceLODThreshold */
    if ( strcmp ( argv[2], "SetDistanceLODThreshold" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDistanceLODThreshold" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDistanceLODThreshold */
    Tcl_DStringAppendElement ( &dString, " Set distance LOD threshold \\[0.0 - 1.0\\] for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDistanceLODThreshold(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetDistanceLODThreshold */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDistanceLODThresholdMinValue */
    if ( strcmp ( argv[2], "GetDistanceLODThresholdMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDistanceLODThresholdMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDistanceLODThresholdMinValue */
    Tcl_DStringAppendElement ( &dString, " Set distance LOD threshold \\[0.0 - 1.0\\] for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetDistanceLODThresholdMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetDistanceLODThresholdMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDistanceLODThresholdMaxValue */
    if ( strcmp ( argv[2], "GetDistanceLODThresholdMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDistanceLODThresholdMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDistanceLODThresholdMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set distance LOD threshold \\[0.0 - 1.0\\] for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetDistanceLODThresholdMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetDistanceLODThresholdMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDistanceLODThreshold */
    if ( strcmp ( argv[2], "GetDistanceLODThreshold" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDistanceLODThreshold" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDistanceLODThreshold */
    Tcl_DStringAppendElement ( &dString, " Set distance LOD threshold \\[0.0 - 1.0\\] for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetDistanceLODThreshold();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetDistanceLODThreshold */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetEnableViewAngleLOD */
    if ( strcmp ( argv[2], "SetEnableViewAngleLOD" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetEnableViewAngleLOD" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetEnableViewAngleLOD */
    Tcl_DStringAppendElement ( &dString, " Enable and disable the use of view angle based LOD for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetEnableViewAngleLOD(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetEnableViewAngleLOD */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetEnableViewAngleLOD */
    if ( strcmp ( argv[2], "GetEnableViewAngleLOD" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetEnableViewAngleLOD" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetEnableViewAngleLOD */
    Tcl_DStringAppendElement ( &dString, " Enable and disable the use of view angle based LOD for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetEnableViewAngleLOD();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetEnableViewAngleLOD */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetViewAngleLODThreshold */
    if ( strcmp ( argv[2], "SetViewAngleLODThreshold" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetViewAngleLODThreshold" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetViewAngleLODThreshold */
    Tcl_DStringAppendElement ( &dString, " Set view angle LOD threshold \\[0.0 - 1.0\\] for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetViewAngleLODThreshold(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetViewAngleLODThreshold */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetViewAngleLODThresholdMinValue */
    if ( strcmp ( argv[2], "GetViewAngleLODThresholdMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetViewAngleLODThresholdMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetViewAngleLODThresholdMinValue */
    Tcl_DStringAppendElement ( &dString, " Set view angle LOD threshold \\[0.0 - 1.0\\] for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetViewAngleLODThresholdMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetViewAngleLODThresholdMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetViewAngleLODThresholdMaxValue */
    if ( strcmp ( argv[2], "GetViewAngleLODThresholdMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetViewAngleLODThresholdMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetViewAngleLODThresholdMaxValue */
    Tcl_DStringAppendElement ( &dString, " Set view angle LOD threshold \\[0.0 - 1.0\\] for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetViewAngleLODThresholdMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetViewAngleLODThresholdMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetViewAngleLODThreshold */
    if ( strcmp ( argv[2], "GetViewAngleLODThreshold" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetViewAngleLODThreshold" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetViewAngleLODThreshold */
    Tcl_DStringAppendElement ( &dString, " Set view angle LOD threshold \\[0.0 - 1.0\\] for titles and labels.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetViewAngleLODThreshold();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetViewAngleLODThreshold */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarAxisVisibility */
    if ( strcmp ( argv[2], "SetPolarAxisVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarAxisVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of the polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarAxisVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarAxisVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisVisibility */
    if ( strcmp ( argv[2], "GetPolarAxisVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of the polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPolarAxisVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PolarAxisVisibilityOn */
    if ( strcmp ( argv[2], "PolarAxisVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PolarAxisVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PolarAxisVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of the polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void PolarAxisVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for PolarAxisVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PolarAxisVisibilityOff */
    if ( strcmp ( argv[2], "PolarAxisVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PolarAxisVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PolarAxisVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of the polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void PolarAxisVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for PolarAxisVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDrawRadialGridlines */
    if ( strcmp ( argv[2], "SetDrawRadialGridlines" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDrawRadialGridlines" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDrawRadialGridlines */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of inner radial grid lines\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDrawRadialGridlines(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetDrawRadialGridlines */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDrawRadialGridlines */
    if ( strcmp ( argv[2], "GetDrawRadialGridlines" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDrawRadialGridlines" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDrawRadialGridlines */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of inner radial grid lines\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDrawRadialGridlines();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetDrawRadialGridlines */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DrawRadialGridlinesOn */
    if ( strcmp ( argv[2], "DrawRadialGridlinesOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DrawRadialGridlinesOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DrawRadialGridlinesOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of inner radial grid lines\n" );
    Tcl_DStringAppendElement ( &dString, "void DrawRadialGridlinesOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for DrawRadialGridlinesOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DrawRadialGridlinesOff */
    if ( strcmp ( argv[2], "DrawRadialGridlinesOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DrawRadialGridlinesOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DrawRadialGridlinesOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of inner radial grid lines\n" );
    Tcl_DStringAppendElement ( &dString, "void DrawRadialGridlinesOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for DrawRadialGridlinesOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDrawPolarArcsGridlines */
    if ( strcmp ( argv[2], "SetDrawPolarArcsGridlines" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDrawPolarArcsGridlines" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDrawPolarArcsGridlines */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of inner polar arcs grid lines\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDrawPolarArcsGridlines(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetDrawPolarArcsGridlines */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDrawPolarArcsGridlines */
    if ( strcmp ( argv[2], "GetDrawPolarArcsGridlines" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDrawPolarArcsGridlines" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDrawPolarArcsGridlines */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of inner polar arcs grid lines\n" );
    Tcl_DStringAppendElement ( &dString, "int GetDrawPolarArcsGridlines();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetDrawPolarArcsGridlines */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DrawPolarArcsGridlinesOn */
    if ( strcmp ( argv[2], "DrawPolarArcsGridlinesOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DrawPolarArcsGridlinesOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DrawPolarArcsGridlinesOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of inner polar arcs grid lines\n" );
    Tcl_DStringAppendElement ( &dString, "void DrawPolarArcsGridlinesOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for DrawPolarArcsGridlinesOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: DrawPolarArcsGridlinesOff */
    if ( strcmp ( argv[2], "DrawPolarArcsGridlinesOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "DrawPolarArcsGridlinesOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for DrawPolarArcsGridlinesOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of inner polar arcs grid lines\n" );
    Tcl_DStringAppendElement ( &dString, "void DrawPolarArcsGridlinesOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for DrawPolarArcsGridlinesOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarTitleVisibility */
    if ( strcmp ( argv[2], "SetPolarTitleVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarTitleVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarTitleVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of titles for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarTitleVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarTitleVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarTitleVisibility */
    if ( strcmp ( argv[2], "GetPolarTitleVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarTitleVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarTitleVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of titles for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPolarTitleVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarTitleVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PolarTitleVisibilityOn */
    if ( strcmp ( argv[2], "PolarTitleVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PolarTitleVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PolarTitleVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of titles for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void PolarTitleVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for PolarTitleVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PolarTitleVisibilityOff */
    if ( strcmp ( argv[2], "PolarTitleVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PolarTitleVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PolarTitleVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of titles for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void PolarTitleVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for PolarTitleVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRadialAxisTitleLocation */
    if ( strcmp ( argv[2], "SetRadialAxisTitleLocation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRadialAxisTitleLocation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRadialAxisTitleLocation */
    Tcl_DStringAppendElement ( &dString, " Get/Set the alignement of the radial axes title related to the axis.\n Possible Alignment: VTK_TITLE_BOTTOM, VTK_TITLE_EXTERN\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRadialAxisTitleLocation(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetRadialAxisTitleLocation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadialAxisTitleLocationMinValue */
    if ( strcmp ( argv[2], "GetRadialAxisTitleLocationMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadialAxisTitleLocationMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadialAxisTitleLocationMinValue */
    Tcl_DStringAppendElement ( &dString, " Get/Set the alignement of the radial axes title related to the axis.\n Possible Alignment: VTK_TITLE_BOTTOM, VTK_TITLE_EXTERN\n" );
    Tcl_DStringAppendElement ( &dString, "int GetRadialAxisTitleLocationMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRadialAxisTitleLocationMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadialAxisTitleLocationMaxValue */
    if ( strcmp ( argv[2], "GetRadialAxisTitleLocationMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadialAxisTitleLocationMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadialAxisTitleLocationMaxValue */
    Tcl_DStringAppendElement ( &dString, " Get/Set the alignement of the radial axes title related to the axis.\n Possible Alignment: VTK_TITLE_BOTTOM, VTK_TITLE_EXTERN\n" );
    Tcl_DStringAppendElement ( &dString, "int GetRadialAxisTitleLocationMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRadialAxisTitleLocationMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadialAxisTitleLocation */
    if ( strcmp ( argv[2], "GetRadialAxisTitleLocation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadialAxisTitleLocation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadialAxisTitleLocation */
    Tcl_DStringAppendElement ( &dString, " Get/Set the alignement of the radial axes title related to the axis.\n Possible Alignment: VTK_TITLE_BOTTOM, VTK_TITLE_EXTERN\n" );
    Tcl_DStringAppendElement ( &dString, "int GetRadialAxisTitleLocation();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRadialAxisTitleLocation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarAxisTitleLocation */
    if ( strcmp ( argv[2], "SetPolarAxisTitleLocation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisTitleLocation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarAxisTitleLocation */
    Tcl_DStringAppendElement ( &dString, " Get/Set the alignement of the polar axes title related to the axis.\n Possible Alignment: VTKTITLE_BOTTOM, VTK_TITLE_EXTERN\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarAxisTitleLocation(int);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarAxisTitleLocation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisTitleLocationMinValue */
    if ( strcmp ( argv[2], "GetPolarAxisTitleLocationMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTitleLocationMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisTitleLocationMinValue */
    Tcl_DStringAppendElement ( &dString, " Get/Set the alignement of the polar axes title related to the axis.\n Possible Alignment: VTKTITLE_BOTTOM, VTK_TITLE_EXTERN\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPolarAxisTitleLocationMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisTitleLocationMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisTitleLocationMaxValue */
    if ( strcmp ( argv[2], "GetPolarAxisTitleLocationMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTitleLocationMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisTitleLocationMaxValue */
    Tcl_DStringAppendElement ( &dString, " Get/Set the alignement of the polar axes title related to the axis.\n Possible Alignment: VTKTITLE_BOTTOM, VTK_TITLE_EXTERN\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPolarAxisTitleLocationMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisTitleLocationMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisTitleLocation */
    if ( strcmp ( argv[2], "GetPolarAxisTitleLocation" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTitleLocation" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisTitleLocation */
    Tcl_DStringAppendElement ( &dString, " Get/Set the alignement of the polar axes title related to the axis.\n Possible Alignment: VTKTITLE_BOTTOM, VTK_TITLE_EXTERN\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPolarAxisTitleLocation();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisTitleLocation */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarLabelVisibility */
    if ( strcmp ( argv[2], "SetPolarLabelVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarLabelVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarLabelVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of labels for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarLabelVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarLabelVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarLabelVisibility */
    if ( strcmp ( argv[2], "GetPolarLabelVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarLabelVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarLabelVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of labels for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPolarLabelVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarLabelVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PolarLabelVisibilityOn */
    if ( strcmp ( argv[2], "PolarLabelVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PolarLabelVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PolarLabelVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of labels for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void PolarLabelVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for PolarLabelVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PolarLabelVisibilityOff */
    if ( strcmp ( argv[2], "PolarLabelVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PolarLabelVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PolarLabelVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of labels for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void PolarLabelVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for PolarLabelVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetArcTicksOriginToPolarAxis */
    if ( strcmp ( argv[2], "SetArcTicksOriginToPolarAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetArcTicksOriginToPolarAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetArcTicksOriginToPolarAxis */
    Tcl_DStringAppendElement ( &dString, " If On, the ticks are drawn from the angle of the polarAxis (i.e. this->MinimalRadius)\n and continue counterclockwise with the step DeltaAngle Major/Minor. if Off, the start angle is 0.0, i.e.\n the angle on the major radius of the ellipse.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetArcTicksOriginToPolarAxis(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetArcTicksOriginToPolarAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetArcTicksOriginToPolarAxis */
    if ( strcmp ( argv[2], "GetArcTicksOriginToPolarAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetArcTicksOriginToPolarAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetArcTicksOriginToPolarAxis */
    Tcl_DStringAppendElement ( &dString, " If On, the ticks are drawn from the angle of the polarAxis (i.e. this->MinimalRadius)\n and continue counterclockwise with the step DeltaAngle Major/Minor. if Off, the start angle is 0.0, i.e.\n the angle on the major radius of the ellipse.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetArcTicksOriginToPolarAxis();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetArcTicksOriginToPolarAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ArcTicksOriginToPolarAxisOn */
    if ( strcmp ( argv[2], "ArcTicksOriginToPolarAxisOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ArcTicksOriginToPolarAxisOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ArcTicksOriginToPolarAxisOn */
    Tcl_DStringAppendElement ( &dString, " If On, the ticks are drawn from the angle of the polarAxis (i.e. this->MinimalRadius)\n and continue counterclockwise with the step DeltaAngle Major/Minor. if Off, the start angle is 0.0, i.e.\n the angle on the major radius of the ellipse.\n" );
    Tcl_DStringAppendElement ( &dString, "void ArcTicksOriginToPolarAxisOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for ArcTicksOriginToPolarAxisOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ArcTicksOriginToPolarAxisOff */
    if ( strcmp ( argv[2], "ArcTicksOriginToPolarAxisOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ArcTicksOriginToPolarAxisOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ArcTicksOriginToPolarAxisOff */
    Tcl_DStringAppendElement ( &dString, " If On, the ticks are drawn from the angle of the polarAxis (i.e. this->MinimalRadius)\n and continue counterclockwise with the step DeltaAngle Major/Minor. if Off, the start angle is 0.0, i.e.\n the angle on the major radius of the ellipse.\n" );
    Tcl_DStringAppendElement ( &dString, "void ArcTicksOriginToPolarAxisOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for ArcTicksOriginToPolarAxisOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRadialAxesOriginToPolarAxis */
    if ( strcmp ( argv[2], "SetRadialAxesOriginToPolarAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRadialAxesOriginToPolarAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRadialAxesOriginToPolarAxis */
    Tcl_DStringAppendElement ( &dString, " If On, the radial axes are drawn from the angle of the polarAxis (i.e. this->MinimalRadius)\n and continue counterclockwise with the step DeltaAngleRadialAxes. if Off, the start angle is 0.0, i.e.\n the angle on the major radius of the ellipse.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRadialAxesOriginToPolarAxis(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetRadialAxesOriginToPolarAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadialAxesOriginToPolarAxis */
    if ( strcmp ( argv[2], "GetRadialAxesOriginToPolarAxis" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadialAxesOriginToPolarAxis" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadialAxesOriginToPolarAxis */
    Tcl_DStringAppendElement ( &dString, " If On, the radial axes are drawn from the angle of the polarAxis (i.e. this->MinimalRadius)\n and continue counterclockwise with the step DeltaAngleRadialAxes. if Off, the start angle is 0.0, i.e.\n the angle on the major radius of the ellipse.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetRadialAxesOriginToPolarAxis();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRadialAxesOriginToPolarAxis */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RadialAxesOriginToPolarAxisOn */
    if ( strcmp ( argv[2], "RadialAxesOriginToPolarAxisOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RadialAxesOriginToPolarAxisOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RadialAxesOriginToPolarAxisOn */
    Tcl_DStringAppendElement ( &dString, " If On, the radial axes are drawn from the angle of the polarAxis (i.e. this->MinimalRadius)\n and continue counterclockwise with the step DeltaAngleRadialAxes. if Off, the start angle is 0.0, i.e.\n the angle on the major radius of the ellipse.\n" );
    Tcl_DStringAppendElement ( &dString, "void RadialAxesOriginToPolarAxisOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for RadialAxesOriginToPolarAxisOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RadialAxesOriginToPolarAxisOff */
    if ( strcmp ( argv[2], "RadialAxesOriginToPolarAxisOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RadialAxesOriginToPolarAxisOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RadialAxesOriginToPolarAxisOff */
    Tcl_DStringAppendElement ( &dString, " If On, the radial axes are drawn from the angle of the polarAxis (i.e. this->MinimalRadius)\n and continue counterclockwise with the step DeltaAngleRadialAxes. if Off, the start angle is 0.0, i.e.\n the angle on the major radius of the ellipse.\n" );
    Tcl_DStringAppendElement ( &dString, "void RadialAxesOriginToPolarAxisOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for RadialAxesOriginToPolarAxisOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarTickVisibility */
    if ( strcmp ( argv[2], "SetPolarTickVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarTickVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarTickVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the overall visibility of ticks.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarTickVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarTickVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarTickVisibility */
    if ( strcmp ( argv[2], "GetPolarTickVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarTickVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarTickVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the overall visibility of ticks.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPolarTickVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarTickVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PolarTickVisibilityOn */
    if ( strcmp ( argv[2], "PolarTickVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PolarTickVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PolarTickVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the overall visibility of ticks.\n" );
    Tcl_DStringAppendElement ( &dString, "void PolarTickVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for PolarTickVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PolarTickVisibilityOff */
    if ( strcmp ( argv[2], "PolarTickVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PolarTickVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PolarTickVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the overall visibility of ticks.\n" );
    Tcl_DStringAppendElement ( &dString, "void PolarTickVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for PolarTickVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAxisTickVisibility */
    if ( strcmp ( argv[2], "SetAxisTickVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAxisTickVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAxisTickVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of major ticks on polar axis and last radial axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAxisTickVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetAxisTickVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAxisTickVisibility */
    if ( strcmp ( argv[2], "GetAxisTickVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAxisTickVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAxisTickVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of major ticks on polar axis and last radial axis.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetAxisTickVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetAxisTickVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AxisTickVisibilityOn */
    if ( strcmp ( argv[2], "AxisTickVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AxisTickVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AxisTickVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of major ticks on polar axis and last radial axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void AxisTickVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for AxisTickVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AxisTickVisibilityOff */
    if ( strcmp ( argv[2], "AxisTickVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AxisTickVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AxisTickVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of major ticks on polar axis and last radial axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void AxisTickVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for AxisTickVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetAxisMinorTickVisibility */
    if ( strcmp ( argv[2], "SetAxisMinorTickVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetAxisMinorTickVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetAxisMinorTickVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of minor ticks on polar axis and last radial axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetAxisMinorTickVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetAxisMinorTickVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetAxisMinorTickVisibility */
    if ( strcmp ( argv[2], "GetAxisMinorTickVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetAxisMinorTickVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetAxisMinorTickVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of minor ticks on polar axis and last radial axis.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetAxisMinorTickVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetAxisMinorTickVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AxisMinorTickVisibilityOn */
    if ( strcmp ( argv[2], "AxisMinorTickVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AxisMinorTickVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AxisMinorTickVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of minor ticks on polar axis and last radial axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void AxisMinorTickVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for AxisMinorTickVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: AxisMinorTickVisibilityOff */
    if ( strcmp ( argv[2], "AxisMinorTickVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "AxisMinorTickVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for AxisMinorTickVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of minor ticks on polar axis and last radial axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void AxisMinorTickVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for AxisMinorTickVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetArcTickVisibility */
    if ( strcmp ( argv[2], "SetArcTickVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetArcTickVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetArcTickVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of major ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetArcTickVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetArcTickVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetArcTickVisibility */
    if ( strcmp ( argv[2], "GetArcTickVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetArcTickVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetArcTickVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of major ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetArcTickVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetArcTickVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ArcTickVisibilityOn */
    if ( strcmp ( argv[2], "ArcTickVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ArcTickVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ArcTickVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of major ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "void ArcTickVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for ArcTickVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ArcTickVisibilityOff */
    if ( strcmp ( argv[2], "ArcTickVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ArcTickVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ArcTickVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of major ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "void ArcTickVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for ArcTickVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetArcMinorTickVisibility */
    if ( strcmp ( argv[2], "SetArcMinorTickVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetArcMinorTickVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetArcMinorTickVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of minor ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetArcMinorTickVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetArcMinorTickVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetArcMinorTickVisibility */
    if ( strcmp ( argv[2], "GetArcMinorTickVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetArcMinorTickVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetArcMinorTickVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of minor ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetArcMinorTickVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetArcMinorTickVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ArcMinorTickVisibilityOn */
    if ( strcmp ( argv[2], "ArcMinorTickVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ArcMinorTickVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ArcMinorTickVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of minor ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "void ArcMinorTickVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for ArcMinorTickVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: ArcMinorTickVisibilityOff */
    if ( strcmp ( argv[2], "ArcMinorTickVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "ArcMinorTickVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for ArcMinorTickVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of minor ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "void ArcMinorTickVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for ArcMinorTickVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetArcMajorTickSize */
    if ( strcmp ( argv[2], "SetArcMajorTickSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetArcMajorTickSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetArcMajorTickSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the major ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetArcMajorTickSize(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetArcMajorTickSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetArcMajorTickSize */
    if ( strcmp ( argv[2], "GetArcMajorTickSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetArcMajorTickSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetArcMajorTickSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the major ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetArcMajorTickSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetArcMajorTickSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarAxisMajorTickSize */
    if ( strcmp ( argv[2], "SetPolarAxisMajorTickSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisMajorTickSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarAxisMajorTickSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the major ticks on the polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarAxisMajorTickSize(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarAxisMajorTickSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisMajorTickSize */
    if ( strcmp ( argv[2], "GetPolarAxisMajorTickSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisMajorTickSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisMajorTickSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the major ticks on the polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetPolarAxisMajorTickSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisMajorTickSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLastRadialAxisMajorTickSize */
    if ( strcmp ( argv[2], "SetLastRadialAxisMajorTickSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLastRadialAxisMajorTickSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLastRadialAxisMajorTickSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the major ticks on the last radial axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLastRadialAxisMajorTickSize(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetLastRadialAxisMajorTickSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLastRadialAxisMajorTickSize */
    if ( strcmp ( argv[2], "GetLastRadialAxisMajorTickSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLastRadialAxisMajorTickSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLastRadialAxisMajorTickSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the major ticks on the last radial axis.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetLastRadialAxisMajorTickSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetLastRadialAxisMajorTickSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarAxisTickRatioSize */
    if ( strcmp ( argv[2], "SetPolarAxisTickRatioSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisTickRatioSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarAxisTickRatioSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Polar Axis ticks size\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarAxisTickRatioSize(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarAxisTickRatioSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisTickRatioSize */
    if ( strcmp ( argv[2], "GetPolarAxisTickRatioSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTickRatioSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisTickRatioSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Polar Axis ticks size\n" );
    Tcl_DStringAppendElement ( &dString, "double GetPolarAxisTickRatioSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisTickRatioSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLastAxisTickRatioSize */
    if ( strcmp ( argv[2], "SetLastAxisTickRatioSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLastAxisTickRatioSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLastAxisTickRatioSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Last Radial axis ticks size\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLastAxisTickRatioSize(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetLastAxisTickRatioSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLastAxisTickRatioSize */
    if ( strcmp ( argv[2], "GetLastAxisTickRatioSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLastAxisTickRatioSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLastAxisTickRatioSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Last Radial axis ticks size\n" );
    Tcl_DStringAppendElement ( &dString, "double GetLastAxisTickRatioSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetLastAxisTickRatioSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetArcTickRatioSize */
    if ( strcmp ( argv[2], "SetArcTickRatioSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetArcTickRatioSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetArcTickRatioSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Arc ticks size\n" );
    Tcl_DStringAppendElement ( &dString, "void SetArcTickRatioSize(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetArcTickRatioSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetArcTickRatioSize */
    if ( strcmp ( argv[2], "GetArcTickRatioSize" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetArcTickRatioSize" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetArcTickRatioSize */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Arc ticks size\n" );
    Tcl_DStringAppendElement ( &dString, "double GetArcTickRatioSize();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetArcTickRatioSize */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarAxisMajorTickThickness */
    if ( strcmp ( argv[2], "SetPolarAxisMajorTickThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisMajorTickThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarAxisMajorTickThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the thickness of polar axis ticks\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarAxisMajorTickThickness(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarAxisMajorTickThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisMajorTickThickness */
    if ( strcmp ( argv[2], "GetPolarAxisMajorTickThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisMajorTickThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisMajorTickThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the thickness of polar axis ticks\n" );
    Tcl_DStringAppendElement ( &dString, "double GetPolarAxisMajorTickThickness();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisMajorTickThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLastRadialAxisMajorTickThickness */
    if ( strcmp ( argv[2], "SetLastRadialAxisMajorTickThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLastRadialAxisMajorTickThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLastRadialAxisMajorTickThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the thickness of last radial axis ticks\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLastRadialAxisMajorTickThickness(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetLastRadialAxisMajorTickThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLastRadialAxisMajorTickThickness */
    if ( strcmp ( argv[2], "GetLastRadialAxisMajorTickThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLastRadialAxisMajorTickThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLastRadialAxisMajorTickThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the thickness of last radial axis ticks\n" );
    Tcl_DStringAppendElement ( &dString, "double GetLastRadialAxisMajorTickThickness();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetLastRadialAxisMajorTickThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetArcMajorTickThickness */
    if ( strcmp ( argv[2], "SetArcMajorTickThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetArcMajorTickThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetArcMajorTickThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the thickness of the last arc ticks\n" );
    Tcl_DStringAppendElement ( &dString, "void SetArcMajorTickThickness(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetArcMajorTickThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetArcMajorTickThickness */
    if ( strcmp ( argv[2], "GetArcMajorTickThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetArcMajorTickThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetArcMajorTickThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the size of the thickness of the last arc ticks\n" );
    Tcl_DStringAppendElement ( &dString, "double GetArcMajorTickThickness();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetArcMajorTickThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarAxisTickRatioThickness */
    if ( strcmp ( argv[2], "SetPolarAxisTickRatioThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisTickRatioThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarAxisTickRatioThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Polar Axis ticks thickness\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarAxisTickRatioThickness(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarAxisTickRatioThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisTickRatioThickness */
    if ( strcmp ( argv[2], "GetPolarAxisTickRatioThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTickRatioThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisTickRatioThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Polar Axis ticks thickness\n" );
    Tcl_DStringAppendElement ( &dString, "double GetPolarAxisTickRatioThickness();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisTickRatioThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLastAxisTickRatioThickness */
    if ( strcmp ( argv[2], "SetLastAxisTickRatioThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLastAxisTickRatioThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLastAxisTickRatioThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Last Radial axis ticks thickness\n" );
    Tcl_DStringAppendElement ( &dString, "void SetLastAxisTickRatioThickness(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetLastAxisTickRatioThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLastAxisTickRatioThickness */
    if ( strcmp ( argv[2], "GetLastAxisTickRatioThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLastAxisTickRatioThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLastAxisTickRatioThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Last Radial axis ticks thickness\n" );
    Tcl_DStringAppendElement ( &dString, "double GetLastAxisTickRatioThickness();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetLastAxisTickRatioThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetArcTickRatioThickness */
    if ( strcmp ( argv[2], "SetArcTickRatioThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetArcTickRatioThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetArcTickRatioThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Arc ticks thickness\n" );
    Tcl_DStringAppendElement ( &dString, "void SetArcTickRatioThickness(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetArcTickRatioThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetArcTickRatioThickness */
    if ( strcmp ( argv[2], "GetArcTickRatioThickness" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetArcTickRatioThickness" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetArcTickRatioThickness */
    Tcl_DStringAppendElement ( &dString, " Set/Get the ratio between major and minor Arc ticks thickness\n" );
    Tcl_DStringAppendElement ( &dString, "double GetArcTickRatioThickness();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetArcTickRatioThickness */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDeltaRangeMajor */
    if ( strcmp ( argv[2], "SetDeltaRangeMajor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDeltaRangeMajor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDeltaRangeMajor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the step between 2 major ticks, in range value (values displayed on the axis).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDeltaRangeMajor(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetDeltaRangeMajor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDeltaRangeMajor */
    if ( strcmp ( argv[2], "GetDeltaRangeMajor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDeltaRangeMajor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDeltaRangeMajor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the step between 2 major ticks, in range value (values displayed on the axis).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetDeltaRangeMajor();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetDeltaRangeMajor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDeltaRangeMinor */
    if ( strcmp ( argv[2], "SetDeltaRangeMinor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDeltaRangeMinor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDeltaRangeMinor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the step between 2 minor ticks, in range value (values displayed on the axis).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDeltaRangeMinor(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetDeltaRangeMinor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDeltaRangeMinor */
    if ( strcmp ( argv[2], "GetDeltaRangeMinor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDeltaRangeMinor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDeltaRangeMinor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the step between 2 minor ticks, in range value (values displayed on the axis).\n" );
    Tcl_DStringAppendElement ( &dString, "double GetDeltaRangeMinor();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetDeltaRangeMinor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDeltaAngleMajor */
    if ( strcmp ( argv[2], "SetDeltaAngleMajor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDeltaAngleMajor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDeltaAngleMajor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the angle between 2 major ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDeltaAngleMajor(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetDeltaAngleMajor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDeltaAngleMajor */
    if ( strcmp ( argv[2], "GetDeltaAngleMajor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDeltaAngleMajor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDeltaAngleMajor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the angle between 2 major ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetDeltaAngleMajor();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetDeltaAngleMajor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDeltaAngleMinor */
    if ( strcmp ( argv[2], "SetDeltaAngleMinor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDeltaAngleMinor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDeltaAngleMinor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the angle between 2 minor ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDeltaAngleMinor(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetDeltaAngleMinor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDeltaAngleMinor */
    if ( strcmp ( argv[2], "GetDeltaAngleMinor" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDeltaAngleMinor" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDeltaAngleMinor */
    Tcl_DStringAppendElement ( &dString, " Set/Get the angle between 2 minor ticks on the last arc.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetDeltaAngleMinor();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetDeltaAngleMinor */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetDeltaAngleRadialAxes */
    if ( strcmp ( argv[2], "SetDeltaAngleRadialAxes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetDeltaAngleRadialAxes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetDeltaAngleRadialAxes */
    Tcl_DStringAppendElement ( &dString, " Set/Get the angle between 2 radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetDeltaAngleRadialAxes(double a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetDeltaAngleRadialAxes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetDeltaAngleRadialAxes */
    if ( strcmp ( argv[2], "GetDeltaAngleRadialAxes" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetDeltaAngleRadialAxes" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetDeltaAngleRadialAxes */
    Tcl_DStringAppendElement ( &dString, " Set/Get the angle between 2 radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "double GetDeltaAngleRadialAxes();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetDeltaAngleRadialAxes */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRadialAxesVisibility */
    if ( strcmp ( argv[2], "SetRadialAxesVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRadialAxesVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRadialAxesVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of non-polar radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRadialAxesVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetRadialAxesVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadialAxesVisibility */
    if ( strcmp ( argv[2], "GetRadialAxesVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadialAxesVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadialAxesVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of non-polar radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetRadialAxesVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRadialAxesVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RadialAxesVisibilityOn */
    if ( strcmp ( argv[2], "RadialAxesVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RadialAxesVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RadialAxesVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of non-polar radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "void RadialAxesVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for RadialAxesVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RadialAxesVisibilityOff */
    if ( strcmp ( argv[2], "RadialAxesVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RadialAxesVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RadialAxesVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of non-polar radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "void RadialAxesVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for RadialAxesVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRadialTitleVisibility */
    if ( strcmp ( argv[2], "SetRadialTitleVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRadialTitleVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRadialTitleVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of titles for non-polar radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRadialTitleVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetRadialTitleVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRadialTitleVisibility */
    if ( strcmp ( argv[2], "GetRadialTitleVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRadialTitleVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRadialTitleVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of titles for non-polar radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetRadialTitleVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRadialTitleVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RadialTitleVisibilityOn */
    if ( strcmp ( argv[2], "RadialTitleVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RadialTitleVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RadialTitleVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of titles for non-polar radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "void RadialTitleVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for RadialTitleVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: RadialTitleVisibilityOff */
    if ( strcmp ( argv[2], "RadialTitleVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "RadialTitleVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for RadialTitleVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of titles for non-polar radial axes.\n" );
    Tcl_DStringAppendElement ( &dString, "void RadialTitleVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for RadialTitleVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarArcsVisibility */
    if ( strcmp ( argv[2], "SetPolarArcsVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarArcsVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarArcsVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of arcs for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void SetPolarArcsVisibility(int a);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarArcsVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarArcsVisibility */
    if ( strcmp ( argv[2], "GetPolarArcsVisibility" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarArcsVisibility" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarArcsVisibility */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of arcs for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "int GetPolarArcsVisibility();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarArcsVisibility */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PolarArcsVisibilityOn */
    if ( strcmp ( argv[2], "PolarArcsVisibilityOn" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PolarArcsVisibilityOn" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PolarArcsVisibilityOn */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of arcs for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void PolarArcsVisibilityOn();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for PolarArcsVisibilityOn */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: PolarArcsVisibilityOff */
    if ( strcmp ( argv[2], "PolarArcsVisibilityOff" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "PolarArcsVisibilityOff" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for PolarArcsVisibilityOff */
    Tcl_DStringAppendElement ( &dString, " Turn on and off the visibility of arcs for polar axis.\n" );
    Tcl_DStringAppendElement ( &dString, "void PolarArcsVisibilityOff();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for PolarArcsVisibilityOff */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetUse2DMode */
    if ( strcmp ( argv[2], "SetUse2DMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetUse2DMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "int" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetUse2DMode */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable labels 2D mode (always facing the camera).\n" );
    Tcl_DStringAppendElement ( &dString, "void SetUse2DMode(int val);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetUse2DMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetUse2DMode */
    if ( strcmp ( argv[2], "GetUse2DMode" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetUse2DMode" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetUse2DMode */
    Tcl_DStringAppendElement ( &dString, " Enable/Disable labels 2D mode (always facing the camera).\n" );
    Tcl_DStringAppendElement ( &dString, "int GetUse2DMode();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetUse2DMode */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarAxisTitleTextProperty */
    if ( strcmp ( argv[2], "SetPolarAxisTitleTextProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisTitleTextProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarAxisTitleTextProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the polar axis title text property.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetPolarAxisTitleTextProperty(vtkTextProperty *p);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarAxisTitleTextProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisTitleTextProperty */
    if ( strcmp ( argv[2], "GetPolarAxisTitleTextProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisTitleTextProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisTitleTextProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the polar axis title text property.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty *GetPolarAxisTitleTextProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisTitleTextProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarAxisLabelTextProperty */
    if ( strcmp ( argv[2], "SetPolarAxisLabelTextProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisLabelTextProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarAxisLabelTextProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the polar axis labels text property.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetPolarAxisLabelTextProperty(vtkTextProperty *p);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarAxisLabelTextProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisLabelTextProperty */
    if ( strcmp ( argv[2], "GetPolarAxisLabelTextProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisLabelTextProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisLabelTextProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the polar axis labels text property.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty *GetPolarAxisLabelTextProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisLabelTextProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLastRadialAxisTextProperty */
    if ( strcmp ( argv[2], "SetLastRadialAxisTextProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLastRadialAxisTextProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLastRadialAxisTextProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the last radial axis text property.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetLastRadialAxisTextProperty(vtkTextProperty *p);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetLastRadialAxisTextProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLastRadialAxisTextProperty */
    if ( strcmp ( argv[2], "GetLastRadialAxisTextProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLastRadialAxisTextProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLastRadialAxisTextProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the last radial axis text property.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty *GetLastRadialAxisTextProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetLastRadialAxisTextProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSecondaryRadialAxesTextProperty */
    if ( strcmp ( argv[2], "SetSecondaryRadialAxesTextProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSecondaryRadialAxesTextProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSecondaryRadialAxesTextProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the secondary radial axes text property.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetSecondaryRadialAxesTextProperty(vtkTextProperty *p);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetSecondaryRadialAxesTextProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSecondaryRadialAxesTextProperty */
    if ( strcmp ( argv[2], "GetSecondaryRadialAxesTextProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSecondaryRadialAxesTextProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSecondaryRadialAxesTextProperty */
    Tcl_DStringAppendElement ( &dString, " Set/Get the secondary radial axes text property.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkTextProperty *GetSecondaryRadialAxesTextProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetSecondaryRadialAxesTextProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarAxisProperty */
    if ( strcmp ( argv[2], "SetPolarAxisProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarAxisProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkProperty" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarAxisProperty */
    Tcl_DStringAppendElement ( &dString, " Get/Set polar axis actor properties.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetPolarAxisProperty(vtkProperty *);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarAxisProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarAxisProperty */
    if ( strcmp ( argv[2], "GetPolarAxisProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarAxisProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarAxisProperty */
    Tcl_DStringAppendElement ( &dString, " Get/Set polar axis actor properties.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetPolarAxisProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarAxisProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetLastRadialAxisProperty */
    if ( strcmp ( argv[2], "SetLastRadialAxisProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetLastRadialAxisProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkProperty" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetLastRadialAxisProperty */
    Tcl_DStringAppendElement ( &dString, " Get/Set last radial axis actor properties.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetLastRadialAxisProperty(vtkProperty *p);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetLastRadialAxisProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetLastRadialAxisProperty */
    if ( strcmp ( argv[2], "GetLastRadialAxisProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetLastRadialAxisProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetLastRadialAxisProperty */
    Tcl_DStringAppendElement ( &dString, " Get/Set last radial axis actor properties.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetLastRadialAxisProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetLastRadialAxisProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSecondaryRadialAxesProperty */
    if ( strcmp ( argv[2], "SetSecondaryRadialAxesProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSecondaryRadialAxesProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkProperty" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSecondaryRadialAxesProperty */
    Tcl_DStringAppendElement ( &dString, " Get/Set secondary radial axes actors properties.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetSecondaryRadialAxesProperty(vtkProperty *p);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetSecondaryRadialAxesProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSecondaryRadialAxesProperty */
    if ( strcmp ( argv[2], "GetSecondaryRadialAxesProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSecondaryRadialAxesProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSecondaryRadialAxesProperty */
    Tcl_DStringAppendElement ( &dString, " Get/Set secondary radial axes actors properties.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetSecondaryRadialAxesProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetSecondaryRadialAxesProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetPolarArcsProperty */
    if ( strcmp ( argv[2], "SetPolarArcsProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetPolarArcsProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkProperty" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetPolarArcsProperty */
    Tcl_DStringAppendElement ( &dString, " Get/Set principal polar arc actor property.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetPolarArcsProperty(vtkProperty *p);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetPolarArcsProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetPolarArcsProperty */
    if ( strcmp ( argv[2], "GetPolarArcsProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetPolarArcsProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetPolarArcsProperty */
    Tcl_DStringAppendElement ( &dString, " Get/Set principal polar arc actor property.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetPolarArcsProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetPolarArcsProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetSecondaryPolarArcsProperty */
    if ( strcmp ( argv[2], "SetSecondaryPolarArcsProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetSecondaryPolarArcsProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "vtkProperty" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetSecondaryPolarArcsProperty */
    Tcl_DStringAppendElement ( &dString, " Get/Set secondary polar arcs actors property.\n" );
    Tcl_DStringAppendElement ( &dString, "virtual void SetSecondaryPolarArcsProperty(vtkProperty *p);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetSecondaryPolarArcsProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetSecondaryPolarArcsProperty */
    if ( strcmp ( argv[2], "GetSecondaryPolarArcsProperty" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetSecondaryPolarArcsProperty" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetSecondaryPolarArcsProperty */
    Tcl_DStringAppendElement ( &dString, " Get/Set secondary polar arcs actors property.\n" );
    Tcl_DStringAppendElement ( &dString, "vtkProperty *GetSecondaryPolarArcsProperty();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetSecondaryPolarArcsProperty */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetBounds */
    if ( strcmp ( argv[2], "SetBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetBounds */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetBounds(double, double, double, double, double, double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetBounds */
    if ( strcmp ( argv[2], "SetBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetBounds */
    Tcl_DStringAppendElement ( &dString, "" );
    Tcl_DStringAppendElement ( &dString, "void SetBounds(double a\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetBounds */
    if ( strcmp ( argv[2], "GetBounds" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetBounds" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetBounds */
    Tcl_DStringAppendElement ( &dString, " Explicitly specify the region in space around which to draw the bounds.\n The bounds are used only when no Input or Prop is specified. The bounds\n are specified according to (xmin,xmax, ymin,ymax, zmin,zmax), making\n sure that the min's are less than the max's.\n" );
    Tcl_DStringAppendElement ( &dString, "void GetBounds(double bounds\\[6\\]);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetBounds */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: SetRatio */
    if ( strcmp ( argv[2], "SetRatio" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "SetRatio" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringAppendElement ( &dString, "float" );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for SetRatio */
    Tcl_DStringAppendElement ( &dString, " Ratio\n" );
    Tcl_DStringAppendElement ( &dString, "void SetRatio(double);" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for SetRatio */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRatioMinValue */
    if ( strcmp ( argv[2], "GetRatioMinValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRatioMinValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRatioMinValue */
    Tcl_DStringAppendElement ( &dString, " Ratio\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRatioMinValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRatioMinValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRatioMaxValue */
    if ( strcmp ( argv[2], "GetRatioMaxValue" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRatioMaxValue" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRatioMaxValue */
    Tcl_DStringAppendElement ( &dString, " Ratio\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRatioMaxValue();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRatioMaxValue */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
    /* Starting function: GetRatio */
    if ( strcmp ( argv[2], "GetRatio" ) == 0 ) {
    Tcl_DStringInit ( &dString );
    Tcl_DStringAppendElement ( &dString, "GetRatio" );
    /* Arguments */
    Tcl_DStringStartSublist ( &dString );
    Tcl_DStringEndSublist ( &dString );
    /* Documentation for GetRatio */
    Tcl_DStringAppendElement ( &dString, " Ratio\n" );
    Tcl_DStringAppendElement ( &dString, "double GetRatio();" );
    Tcl_DStringAppendElement ( &dString, "vtkPolarAxesActor" );
    /* Closing for GetRatio */

    Tcl_DStringResult ( interp, &dString );
    Tcl_DStringFree ( &dString );
    return TCL_OK;
  }
   Tcl_SetResult ( interp, const_cast<char*>("Could not find method"), TCL_VOLATILE ); 
   return TCL_ERROR;
 }
 }

  if (vtkActorCppCommand(static_cast<vtkActor *>(op),interp,argc,argv) == TCL_OK)
  {
    return TCL_OK;
  }
  }
  catch (std::exception &e)
  {
    Tcl_AppendResult(interp, "Uncaught exception: ",  e.what(), "\n", NULL);
    return TCL_ERROR;
  }
  return TCL_ERROR;
}
